<?php

require_once('initialize.php');
require_once 'lib/core/FilesystemPeer.php';
require_once 'lib/core/Filesystem.php';
require_once 'plugins/wiki/lib/WikiPlugin.php';

function print_usage($argv){
	echo "Usage {$argv[0]} --dry-run | --commit \n";
}

if ($argc != 2) {
	print_usage($argv);
	exit(1);
}

if ($argv[1] != trim('--dry-run') && $argv[1] != trim('--commit')) {
	print_usage($argv);
	exit(1);
}

$commit = $argv[1] == '--commit' ? true : false;

//Grab all filesystem records
$c = new Criteria();
/** @var Filesystem[] $files */
$files = FilesystemPeer::doSelect($c);

foreach ($files as $file) {
	if ($file->getSection() == WikiPlugin::SECTION || $file->getSection() == 'project') {
		continue;
	}
	$sanitizedName = StringUtils::removeInvalidChars($file->getFileName(), false);
	if ( $sanitizedName != $file->getFileNameSafe()) {
		echo "File: " . dirname($file->getFilePath()) . "/". $file->getFileNameSafe() . " will be renamed to " . $sanitizedName ."\n";
		if ($commit) {
			try {
				$oldName = $file->getFileNameSafe();
				$file->setFileNameSafe($oldName);
				//rename(dirname($file->getFilePath()).'/'.$oldName,dirname($file->getFilePath()).'/'.escapeshellarg($file->getFileNameSafe()));
				$file->save();
			} catch (Exception $e) {
				echo "Operation failed for file " .$file->getFilePath() . ", skipping \n";
				continue;
			}

		}
	} else {
		echo "Skipping file: " . $file->getFileName() . "\n";
	}
}

exit(0);