<?php
require_once('initialize.php');
require_once('core/Filesystem.php');
require_once('core/FilesystemPeer.php');

$con = Propel::getConnection();
$stmt = $con->createStatement();

//Get tracker extra fields of type status or select, that have more than one data element
$sql = "SELECT max(tracker_extra_field_data_id) AS tracker_extra_field_data_id, tefed.tracker_extra_field_id, tracker_item_id, tef.field_name
				FROM tracker_extra_field_data tefed, tracker_extra_field tef
				WHERE 
					tefed.tracker_extra_field_id = tef.tracker_extra_field_id
					AND
					(tef.field_type = 1 OR tef.field_type = 7)
				GROUP BY tracker_item_id, tefed.tracker_extra_field_id, tef.field_name
				HAVING COUNT(*) > 1";

$rs = $stmt->executeQuery($sql, ResultSet::FETCHMODE_ASSOC);

while($rs->next()) {
	$tracker_extra_field_data_id = $rs->getInt('tracker_extra_field_data_id');
	$tracker_extra_field_id = $rs->getInt('tracker_extra_field_id');
	$field_name = $rs->getString('field_name');
	$tracker_item_id = $rs->getInt('tracker_item_id');
	
	//Deletes for the extra field in the TI, all data elements except for the newest
	$sql = "DELETE FROM tracker_extra_field_data 
					WHERE 
						tracker_item_id = $tracker_item_id
						AND 
						tracker_extra_field_id = $tracker_extra_field_id 
						AND 
						tracker_extra_field_data_id < $tracker_extra_field_data_id";

	$stmt->executeQuery($sql);
	
	//Adds a follow up to the TI
	try {
		$tracker_item = TrackerItemPeer::retrieveByPk($tracker_item_id);
		
		$tracker_item_message = new TrackerItemMessage();
		
		$str_body = "There were duplicate values on extra field: $field_name.<br /><br />.Duplicates have been eliminated.<br /><br />.The newest value has been preserved.";
		
		$tracker_item_message->setTrackerItem($tracker_item);
		$tracker_item_message->setSubmittedBy(100);
		$tracker_item_message->setBody($str_body);
		$tracker_item_message->save();
	} catch(Exception $e) {
		
	}
}
				
