#!/usr/bin/php -f
<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id$
 * @author Ruben Gutierrez ruben@gforgegroup.com
 * @date 2006-09-07
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */


define ('GREEN', "\033[01;32m" );
define ('NORMAL', "\033[00m" );
define ('RED', "\033[01;31m" );

function changeHostname() {
	// Where the PHP code will live
	$gforge_lib_dir = GFConf::get('system.libDir', '/opt/gforge');
	if (!is_dir($gforge_lib_dir)) {
		show(RED."Error: GForge folder doesn't exist.");
		die();
	}

	$gforge_etc_dir = GFConf::get('system.etcDir', '/etc/gforge');
	if (!is_dir($gforge_etc_dir)) {
		show(RED."Error: GForge config folder doesn't exist.");
		die();
	}
	
	show(' * Enter the new hostname (example: gforge.company.com): ');
	$hostname = trim(fgets(STDIN));
	if (strlen($hostname) == 0) {
		show(RED."Error: you have to enter a hostname.");
		die();
	}

	# gforge core
	GFConf::set('system.hostName', $hostname);

	# mailman 
	GFConf::set('mailman.listsHost', $hostname);

	# httpd.conf
	$httpd_conf = array('ServerName'=>"ServerName	$hostname");
	foreach($httpd_conf as $key => $val) {
		$key = str_replace("/", "\\/", $key);
		$key = str_replace('"', '\\"', $key);
		$val = str_replace("/", "\\/", $val);
		$val = str_replace('"', '\\"', $val);
		run("perl -pi -e \"s/$key.*/$val/gi\" $gforge_etc_dir/httpd.conf");
	}

	show(' * Updating GForge DB');
	$conn = Propel::getConnection(SettingPeer::DATABASE_NAME);
	$stmt = $conn->createStatement();
	$sql = "UPDATE scm_server SET hostname='$hostname' WHERE lower(scm_type) IN ('cvs', 'svn')";
	$stmt->executeQuery($sql, ResultSet::FETCHMODE_ASSOC);

	show(' * Restarting Apache...');
	if (is_file('/etc/init.d/httpd')) {
		run('/etc/init.d/httpd restart',true);
	} elseif (is_file('/etc/init.d/apache2')) {
		run('/etc/init.d/apache2 restart',true);
	} elseif (is_file('/etc/init.d/cswapache2')) {
		run('/etc/init.d/cswapache2 restart',true);
	}

	finish();
}

function finish() {
	show("Done.\n");
}

function show($text, $newLine = true) {
	if ($newLine) {
		$text = GREEN.$text .NORMAL."\n";
	}
	fwrite(STDOUT, $text);
}

function run($command, $ignore = false) {
	system($command, $ret);
	if ($ret != 0 && $ignore == false) {
		echo RED.'An error ocurred running the last command... aborting.'.NORMAL."\n";
		die();
	}
}

function checkInit() {
	require_once('initialize.php');
	require_once('GFConf.php');
}

checkInit();
changeHostname();
