<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version
 * @author Federico Tarantini federicot@gmail.com
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

/**
 * Stats
 */

require_once("system/Cronjob.php");
require_once('core/ActivityLog.php');

class DbStats extends Cronjob {
	public function __construct() {
		$this->jobname = basename(__FILE__);
		parent::__construct();
	}

	public function run() {
		$this->site_page_view();
		$this->project_page_view();
		for ($i=1; $i<=15; $i++) {
			$time=(time()-($i*86400));
			$this->project_activity(date('Y-m-d',$time));
		}
	}

	//Count total page views per day
	//then insert them on a table
	public function site_page_view() {
		//get timestamp for yesterday
		$yesterday = (mktime()-86400);

		//first delete the entry in case this script is run more than once
		$sql = 'DELETE FROM stats_site_page_view WHERE count_date = \''.date('Y-m-d', $yesterday).'\';';
		$con = Propel::getConnection();
		$stmt = $con->createStatement();
		$rs = $stmt->executeQuery($sql);

		//insert the count
		$sql = 'INSERT INTO stats_site_page_view (count_date, count_views) SELECT \''.date('Y-m-d', $yesterday).'\', count(*) FROM activity_log WHERE activity_date <= \''.date('Y-m-d 23:59:59', $yesterday).'\' AND activity_date >= \''.date('Y-m-d 00:00:00', $yesterday).'\'';
		$con = Propel::getConnection();
		$stmt = $con->createStatement();
		$rs = $stmt->executeQuery($sql);
		
	}

	//Count total page views per project per day
	//then insert them on a table
	public function project_page_view() {
		//get timestamp for yesterday
		$yesterday = (mktime()-86400);	

		//first delete the entry in case this script is run more than once
		$sql = 'DELETE FROM stats_project_page_view WHERE count_date = \''.date('Y-m-d', $yesterday).'\';';
		$con = Propel::getConnection();
		$stmt = $con->createStatement();
		$rs = $stmt->executeQuery($sql);

		//insert the count
		$con = Propel::getConnection();
		$sql = 'INSERT INTO stats_project_page_view (project_id, count_date, count_views) SELECT project_id, \''.date('Y-m-d', $yesterday).'\', count(*) FROM activity_log WHERE activity_date <= \''.date('Y-m-d 23:59:59', $yesterday).'\' AND activity_date >= \''.date('Y-m-d 00:00:00', $yesterday).'\' AND project_id != 0 GROUP BY project_id ;';
		$stmt = $con->createStatement();
		$rs = $stmt->executeQuery($sql);

	}

	public function project_activity($date) {
$sql="DELETE FROM project_activity WHERE activity_date='$date'";
		$con = Propel::getConnection();
		$stmt = $con->createStatement();
		$rs = $stmt->executeQuery($sql);
$sql="INSERT INTO project_activity (activity_date,project_id,measure) 
	SELECT '$date'::date,foo.project_id,sum(foo.count) FROM (
	SELECT project_id,count(*) AS count FROM activity_log WHERE activity_date BETWEEN '$date 00:00:00' AND '$date 23:59:59' GROUP BY project_id
	UNION 
	SELECT frsp.project_id,count(*) AS count FROM frs_package frsp 
		NATURAL JOIN frs_release frsr, filesystem fs NATURAL JOIN filesystem_download fsd
		WHERE fs.ref_id=frsr.frs_release_id AND fs.section='frsrelease'
		AND download_date BETWEEN '$date 00:00:00' AND '$date 23:59:59'
		GROUP BY project_id ) foo
	WHERE foo.project_id IN (SELECT project_id FROM project)
	GROUP BY foo.project_id";
		$con = Propel::getConnection();
		$stmt = $con->createStatement();
		$rs = $stmt->executeQuery($sql);

	}
}

$cronjob = new DbStats();
$cronjob->run();
?>
