CREATE OR REPLACE FUNCTION forummessage_insertupdatedelete_agg() RETURNS trigger AS
$BODY$
BEGIN
	IF TG_OP != 'DELETE' THEN
		UPDATE forum_thread SET message_count=(SELECT count(*) FROM forum_message 
		WHERE is_approved=true AND forum_thread_id=NEW.forum_thread_id)
		WHERE forum_thread_id=NEW.forum_thread_id;
	ELSE
		UPDATE forum_thread SET message_count=(SELECT count(*) FROM forum_message 
		WHERE is_approved=true AND forum_thread_id=OLD.forum_thread_id) 
		WHERE forum_thread_id=OLD.forum_thread_id;
	END IF;
	RETURN NEW;
END;
$BODY$
LANGUAGE plpgsql;


CREATE OR REPLACE FUNCTION forumthread_insertupdatedelete_agg() RETURNS trigger AS
$BODY$
BEGIN
	IF TG_OP != 'DELETE' THEN
		UPDATE forum SET message_count=coalesce((SELECT sum(message_count) FROM forum_thread
		WHERE forum_id=NEW.forum_id),0),
		thread_count=coalesce((SELECT count(*) FROM forum_thread
	 	WHERE forum_id=NEW.forum_id AND message_count > 0),0)
		WHERE forum_id=NEW.forum_id;
	ELSE
		UPDATE forum SET message_count=coalesce((SELECT sum(message_count) FROM forum_thread
		WHERE forum_id=OLD.forum_id),0),
		thread_count=coalesce((SELECT count(*) FROM forum_thread
		WHERE forum_id=OLD.forum_id AND message_count > 0),0)
		WHERE forum_id=OLD.forum_id;
	END IF;
RETURN NEW;
END;
$BODY$
LANGUAGE plpgsql; 


CREATE OR REPLACE RULE forum_message_most_recent_date AS ON INSERT TO forum_message DO  UPDATE forum_thread SET most_recent_date = now()
WHERE forum_thread.forum_thread_id = new.forum_thread_id;

CREATE OR REPLACE RULE forum_most_recent_date AS
ON UPDATE TO forum_thread
WHERE new.page_views = old.page_views DO  UPDATE forum SET most_recent_date = now()
WHERE forum.forum_id = new.forum_id;
