<?php

require_once('initialize.php');
//require_once('plugins/tracker/lib/TrackerQuery.php');
require_once('plugins/tracker/lib/TrackerItemQuery.php');

$con = Propel::getConnection();
$sql = "select tracker_query_id, query_field_type, query_field_id, query_field_values from tracker_query_field where query_field_type in ('3', '7', '8')";
$stmt = $con->createStatement();
$rs = $stmt->executeQuery($sql, ResultSet::FETCHMODE_NUM);

$con2 = Propel::getConnection();

try {
    //$con2->begin();
    $sql = 'UPDATE tracker_query_field SET query_field_values = ? WHERE tracker_query_id = ? AND query_field_type = ? and query_field_id = ?';
    $stmt = $con2->prepareStatement($sql);

    while ($rs->next()) {
        $tracker_query_id = $rs->getInt(1);
        $query_field_type = $rs->getString(2);
        $query_field_id = $rs->getInt(3);
        $currentValue = $rs->getString(4);

        if (stripos($currentValue, ' ') !== FALSE) {
            $elements = explode(' ', $currentValue);
            if (count($elements) == 2) {
                $newValue = $elements[0].TrackerItemQuery::DATE_RANGE_DELIMITER.$elements[1];
            } elseif (count($elements) == 6) {
                $newValue = implode(' ', array_slice($elements, 0, 3)).TrackerItemQuery::DATE_RANGE_DELIMITER.implode(' ', array_slice($elements, 3, 3));
            } else {
                echo "Cannot migrate this query parameter (tracker_query_id, query_field_type, query_field_id, query_field_values) ($tracker_query_id, $query_field_type, $query_field_id, $currentValue).  The record will be left unchanged in the database.";
                continue;
            }
            $params = array(
                $newValue,
                $tracker_query_id,
                $query_field_type,
                $query_field_id
            );
            $stmt->executeUpdate($params);
        }
    }
    //$con2->commit();
    exit(0);
} catch (Exception $ex) {
    $con2->rollback();
    exit(1);
}
