CREATE OR REPLACE FUNCTION add_project_id_column()
RETURNS BOOLEAN AS $$
BEGIN
        IF (SELECT EXISTS(SELECT column_name FROM information_schema.columns
        WHERE table_name='setting' AND column_name='project_id')) THEN

                RETURN false;
        ELSE
                ALTER TABLE setting ADD COLUMN project_id INTEGER DEFAULT null;
                ALTER TABLE setting ADD FOREIGN KEY (project_id) REFERENCES project ON DELETE CASCADE;
                RETURN true;
        END IF;

END;
$$ LANGUAGE plpgsql;


SELECT * FROM add_project_id_column();

DROP FUNCTION add_project_id_column();

--Update current settings
UPDATE setting SET project_id=(SELECT project_id FROM tracker WHERE tracker_id=ref_id) WHERE section IN ('tracker_field','tracker');
UPDATE setting SET project_id=ref_id WHERE section='project';

--Fix references to 'tracker_field'
UPDATE setting SET section='tracker' WHERE section='tracker_field';
