<?php
/**
 * Insert ServerTokens directive into httpd.conf 
 */

require_once('initialize.php');
require_once('GFConf.php');
require_once('lib/StringUtils.php');
require_once('lib/SystemUtils.php');

define ('GREEN', "\033[01;32m" );
define ('NORMAL', "\033[00m" );
define ('RED', "\033[01;31m" );

function run($command, $ignore = false) {
	system($command, $ret);
	if ($ret != 0 && $ignore == false) {
		echo RED.'An error ocurred running the last command... aborting.'.NORMAL."\n";
		die();
	}
}

$apacheConf= GFConf::get('system.etcDir').DIRECTORY_SEPARATOR.'httpd.conf';

if(!is_file($apacheConf) || !is_readable($apacheConf)) {
	throw new Exception ('Couldn\'t read apache configuration file');
}

//Backup current apache config file
$apacheBackup = GFConf::get('system.etcDir').DIRECTORY_SEPARATOR.'httpd_'.date('Ymd-hms', time()).'.conf';
$cmd = 'cp ' . $apacheConf . ' ' . $apacheBackup;
SystemUtils::execute($cmd, $output);

echo "Adding ServerTokens directive\n";

$s = "\n#Silence Server header in Apache\nServerTokens Prod\n";

file_put_contents($apacheConf, $s, FILE_APPEND);
