ALTER TABLE plugin_dependency
ADD plugin_dependency_id serial NOT NULL,
ADD CONSTRAINT plugin_dependency_pkey PRIMARY KEY (plugin_dependency_id);

ALTER TABLE project_plugin
DROP CONSTRAINT project_plugin_pkey,
ADD project_plugin_id serial NOT NULL,
ADD CONSTRAINT project_plugin_pkey PRIMARY KEY (project_plugin_id);

ALTER TABLE association
DROP CONSTRAINT associations_pkey,
ADD association_id serial NOT NULL,
ADD CONSTRAINT association_pkey PRIMARY KEY (association_id),
ADD CONSTRAINT association_unique UNIQUE (section, ref_id, to_section, to_ref_id);

ALTER TABLE cruisecontrol_publisher
DROP CONSTRAINT cruisecontrol_publisher_pkey,
ADD cruisecontrol_publisher_id serial NOT NULL,
ADD CONSTRAINT cruisecontrol_publisher_pkey PRIMARY KEY (cruisecontrol_publisher_id),
ADD CONSTRAINT cruisecontrol_publisher_unique UNIQUE (cruisecontrol_id, tracker_id);

ALTER TABLE cruisecontrol_assignee
DROP CONSTRAINT cruisecontrol_assignee_pkey,
ADD cruisecontrol_assignee_id serial NOT NULL,
ADD CONSTRAINT cruisecontrol_assignee_pkey PRIMARY KEY (cruisecontrol_assignee_id),
ADD CONSTRAINT cruisecontrol_assignee_unique UNIQUE (cruisecontrol_id, assignee);

ALTER TABLE cruisecontrol_build_change_user
DROP CONSTRAINT cruisecontrol_build_change_user_pkey,
ADD cruisecontrol_build_change_user_id serial NOT NULL,
ADD CONSTRAINT cruisecontrol_build_change_user_pkey PRIMARY KEY (cruisecontrol_build_change_user_id),
ADD CONSTRAINT cruisecontrol_build_change_user_unique UNIQUE (cruisecontrol_build_id, user_id);

ALTER TABLE project_join_request
DROP CONSTRAINT project_join_request_pkey,
ADD project_join_request_id serial NOT NULL,
ADD CONSTRAINT project_join_request_pkey PRIMARY KEY (project_join_request_id),
ADD CONSTRAINT project_join_request_unique UNIQUE (project_id, user_id);

ALTER TABLE scm_module_user
DROP CONSTRAINT scm_module_user_pkey,
ADD scm_module_user_id serial NOT NULL,
ADD CONSTRAINT scm_module_user_pkey PRIMARY KEY (scm_module_user_id),
ADD CONSTRAINT scm_module_user_unique UNIQUE (scm_module_id, user_id);

ALTER TABLE site_admin
DROP CONSTRAINT site_admin_pkey,
ADD site_admin_id serial NOT NULL,
ADD CONSTRAINT site_admin_pkey PRIMARY KEY (site_admin_id),
ADD CONSTRAINT site_admin_unique UNIQUE (user_id);

ALTER TABLE tracker_my_queue
DROP CONSTRAINT tracker_my_queue_pkey,
ADD tracker_my_queue_id serial NOT NULL,
ADD CONSTRAINT tracker_my_queue_pkey PRIMARY KEY (tracker_my_queue_id),
ADD CONSTRAINT tracker_my_queue_unique UNIQUE (user_id, tracker_item_id);

ALTER TABLE scm_commit_filter_project
DROP CONSTRAINT scm_commit_filter_project_pkey,
ADD scm_commit_filter_project_id serial NOT NULL,
ADD CONSTRAINT scm_commit_filter_project_pkey PRIMARY KEY (scm_commit_filter_project_id),
ADD CONSTRAINT scm_commit_filter_project_unique UNIQUE (scm_commit_filter_id, project_id);

ALTER TABLE code_search_index
ADD code_search_index_id serial NOT NULL,
ADD CONSTRAINT code_search_index_pkey PRIMARY KEY (code_search_index_id);

ALTER TABLE tracker_item_scm_commit
ADD tracker_item_scm_commit_id serial NOT NULL,
ADD CONSTRAINT tracker_item_scm_commit_pkey PRIMARY KEY (tracker_item_scm_commit_id);

ALTER TABLE filesystem_download
ADD filesystem_download_id serial NOT NULL,
ADD CONSTRAINT filesystem_download_pkey PRIMARY KEY (filesystem_download_id);


DELETE FROM user_plugin WHERE user_id NOT IN (select distinct user_id FROM "user");

ALTER TABLE user_plugin
DROP CONSTRAINT user_plugin_pkey,
ADD user_plugin_id serial NOT NULL,
ADD CONSTRAINT user_plugin_pkey PRIMARY KEY (user_plugin_id);

ALTER TABLE deleted_project
DROP CONSTRAINT deleted_project_pkey,
ADD deleted_project_id serial NOT NULL,
ADD CONSTRAINT deleted_project_pkey PRIMARY KEY (deleted_project_id),
ADD CONSTRAINT deleted_project_unique UNIQUE (unix_group_name);

ALTER TABLE disk_usage
DROP CONSTRAINT disk_usage_pkey,
ADD disk_usage_id serial NOT NULL,
ADD CONSTRAINT disk_usage_pkey PRIMARY KEY (disk_usage_id),
ADD CONSTRAINT disk_usage_unique UNIQUE (project_id, check_date);

ALTER TABLE scm_project_stats
DROP CONSTRAINT scm_project_stats_pkey,
ADD scm_project_stats_id serial NOT NULL,
ADD CONSTRAINT scm_project_stats_pkey PRIMARY KEY (scm_project_stats_id),
ADD CONSTRAINT scm_project_stats_unique UNIQUE (project_id, stat_date);

ALTER TABLE scm_user_stats
DROP CONSTRAINT scm_user_stats_pkey,
ADD scm_user_stats_id serial NOT NULL,
ADD CONSTRAINT scm_user_stats_pkey PRIMARY KEY (scm_user_stats_id),
ADD CONSTRAINT scm_user_stats_unique UNIQUE (user_id, project_id, stat_date);

ALTER TABLE cron_history
ADD cron_history_id serial NOT NULL,
ADD CONSTRAINT cron_history_pkey PRIMARY KEY (cron_history_id),
ADD CONSTRAINT cron_history_unique UNIQUE (rundate);
