<?php
require_once('initialize.php');
require_once('GFConf.php');
require_once('SystemUtils.php');
require_once('Validator.php');

$msg = "New configuration setting: system.csrfTokenLifetime.
This setting determines the lifetime of the hidden token that is sent in form submissions to protect them against CSRF attacks.
Default value is 60 minutes. if you want to customize this setting, enter the time (in minutes) that you want to set, if you want to keep the default, just enter 0.";

$lifetime = Validator::sanitizeInt(SystemUtils::input_string($msg, 60));
if ($lifetime == 0) {
	$lifetime = 60;
}
GFConf::set('system.csrfTokenLifetime', $lifetime);

exit(0);
