CREATE OR REPLACE FUNCTION trove_merge(category_id bigint, to_id bigint)
  RETURNS integer AS
$BODY$
DECLARE
    trove_cat RECORD; -- trove category record for inmediate children of source category
    children_count integer; -- count of source category inmediate children
BEGIN
    children_count := 0;
    -- Move source category inmediate children to destination category
    FOR trove_cat IN SELECT trove_category_id FROM trove_category WHERE parent_trove_category_id = category_id LOOP
        children_count := children_count + 1;
        PERFORM trove_move(trove_cat.trove_category_id, to_id);
    END LOOP;
    -- If any children moved
    IF (children_count > 0) 
    THEN
        -- Delete source category
        DELETE FROM trove_category WHERE trove_category_id = category_id;
    END IF;
    -- Return count of children moved
    RETURN children_count;
END;
$BODY$
  LANGUAGE plpgsql VOLATILE
  COST 100;