<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id$
 * @author Julian Yerfino <jyerfino@gforgegroup.com>
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

require_once('lib/GFConf.php');
require_once('lib/plugin/GFPlugin.php');

class GFExportImportUtils {
	public static function getSpecData(GFPlugin $plugin, $specDataPath='specData.xml') {
		
		if($specDataPath[0]!= '/') {
			// Add plugin_name/conf/ in front of $specDataPath if this variable does not start with a /
			$specDataPath = $plugin->getName() . '/conf/' . $specDataPath;
		}
		
		$data = file_get_contents(SystemUtils::buildFilePath(GFConf::get('system.pluginsPath'), $specDataPath));
		$result = new PluginResult($plugin);
		$result->setResult($data);
		return $result;
	}

}


?>