<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id$
 * @author Tim Perdue tim@gforge.org
 * @date 2005-11-11
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
// The parent class
require_once 'core/om/BaseActivityLogPeer.php';

// The object class
include_once 'core/ActivityLog.php';

/** 
 * The skeleton for this class was autogenerated by Propel on:
 *
 * [Sun Nov 13 22:49:46 2005]
 *
 *  You should add additional methods to this class to meet the
 *  application requirements.  This class will only be generated as
 *  long as it does not already exist in the output directory.
 *
 * @package core 
 */
class ActivityLogPeer extends BaseActivityLogPeer {
	private static $_pkCache = array();

	/**
	 * Create and save an ActivityLog record, given the associative array of values as input
	 * @param array $params name/value pairs for the required fields.
	 * @return ActivityLog The entity created in the database
	 */
	public static function SaveEvent($params) {

		if (! array_key_exists('user_id', $params) || $params['user_id'] == 0) {
			$params['user_id'] = 100;  // special "nobody" ID to satisfy FK
		}

		$newObject = new ActivityLog();
		foreach ($params as $key => $value) {
			$fieldName = self::TABLE_NAME.'.'.strtoupper($key);
			// The extended_data field often receives a copy of the full object as it was saved
			// by the action that caused the event.  This causes an 'array to string conversion' 
			// error that is apparently swallowed by current code.
			// It doesn't cause any trouble, but it did get in the way of my testing, so I thought
			// it should get fixed. 
			if (is_array($value) || is_object($value)) {
				$value = json_encode($value);
			}
			$newObject->setByName($fieldName, $value);
		}
		$newObject->save();

		return $newObject;
	}

	public static function getProjectActivitySince($project_id, $since_id = 0, $max_records = 25) {

		$c = new Criteria();
		$c->add(self::PROJECT_ID,$project_id);

		if ($since_id < 1) {
            $c->add(self::ACTIVITY_DATE, time() - 5, Criteria::GREATER_THAN);
		} else {
            $c->add(self::ACTIVITY_LOG_ID, $since_id, Criteria::GREATER_THAN);
		}
		$c->addAscendingOrderByColumn(self::ACTIVITY_LOG_ID)
		  ->setLimit($max_records);

		return self::doSelect($c);
	}

	public static function getProjectActivitySinceTime($project_id, $since_timestamp, $max_records = 25) {

		$c = new Criteria();
		$c->add(self::PROJECT_ID,$project_id);
        $c->add(self::ACTIVITY_DATE, $since_timestamp, Criteria::GREATER_THAN);
		$c->addAscendingOrderByColumn(self::ACTIVITY_LOG_ID)
		  ->setLimit($max_records);

		return self::doSelect($c);
	}

	/**
	 * Retrieve a single object by pkey or NULL if not found.
	 * This method was added by propel_customizer.php.
	 *
	 * @param	mixed $pk	The primary key
	 * @param	bool $useCache	Whether to use caching. This will increase performance if the same object
	 *							is accessed several times
	 * @param	Connection $con	The connection to use
	 * @return	ActivityLog
	 */
	public static function retrieveByPk($pk, $useCache = true, $con = null) {
		if ($useCache && array_key_exists($pk, ActivityLogPeer::$_pkCache)) {
			return ActivityLogPeer::$_pkCache[$pk];
		}
		
		$object = parent::retrieveByPk($pk, $con);
		if ($useCache) {
			ActivityLogPeer::$_pkCache[$pk] = $object;
		}
		return $object;
	}
	
	/**
	 * Removes an object from the cache. This is usually done after saving.
	 * This method was added by propel_customizer.php.
	 *
	 * @param	mixed $pk	The primary key of the object to remove
	 */
	public static function invalidate($pk) {
		if (array_key_exists($pk, ActivityLogPeer::$_pkCache)) {
			unset(ActivityLogPeer::$_pkCache[$pk]);
		}
	}

}
?>