<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id$
 * @author Tim Perdue tim@gforge.org
 * @date 2005-11-11
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
require_once 'core/om/BaseProjectJoinRequest.php';
require_once("plugin/ActionManager.php");

/** 
 * The skeleton for this class was autogenerated by Propel  on:
 *
 * [Sun Nov 13 22:49:46 2005]
 *
 * You should add additional methods to this class to meet the
 * application requirements.  This class will only be generated as
 * long as it does not already exist in the output directory.
 *
 * @package core 
 */
class ProjectJoinRequest extends BaseProjectJoinRequest {
	/**
	 * Removes this object from datastore and sets delete attribute. Informs the plugin manager.
	 * This method was added by propel_customizer.php.
	 * 
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 * @see ProjectJoinRequest::setDeleted()
	 * @see ProjectJoinRequest::isDeleted()
	 */
	function delete($con = null) {
		ActionManager::notify("PROJECT_JOIN_REQUEST_DELETE", $this);
		parent::delete($con);
	}

	/**
	 * Stores the object in the database using the Propel methods. Informs the plugin manager.
	 * This method was added by propel_customizer.php.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
	function save($con = null) {
		/*
		$errors=array();
		if (count($this->role_id) < 1) {
			$errors['role_id'] = Language::getSessText('ProjectJoinRequestException.NoRoleSelected');
		}
		if (count($errors) > 0) {
			throw new InvalidDataException($errors);
		}
		*/
		parent::save($con);
		ActionManager::notify("PROJECT_JOIN_REQUEST_SAVE", $this);
		$this->sendEmailRequest();
	}

	public function sendEmailRequest() {
		$project = $this->getProject();
		$projectAdministrators = $project->getProjectAdministrators();
		$oProject = $this->getProject();
 
		foreach ($projectAdministrators as $projectAdministrator) {
			$language = LanguagePeer::retrieveByPk($projectAdministrator->getLanguageId());
			$subject = $language->getText('ProjectJoinRequest.PendingProjectRequestSubject', array($this->getUser()->getUnixName(),$oProject->getUnixName()));
			$body = $language->getText('ProjectJoinRequest.PendingProjectRequestTextAdmin', array($oProject->getUnixName(), $this->getUser()->getUnixName(), GFUrl::getUrl()->getFullURL(GFUrl::getUrl()->ProjectURL($oProject->getUnixName(), 'ProjectJoinRequestBrowse', '','admin'), true)));
			$oTo = UserPeer::retrieveByPk($projectAdministrator->getUserId());

			SystemUtils::sendMail($subject, $body, $oTo);
		}

	}

	public function sendAcceptMessage() {
		$project_id = $this->getProjectId();
		$oProject = $this->getProject();
		
		$user_id = $this->getUserId();
		$oUser = $this->getUser();

		$language = LanguagePeer::retrieveByPk($oUser->getLanguageId());
		$subject = $language->getText('ProjectJoinRequestAccept.ProjectJoinAcceptanceSubject', array($oProject->getUnixName()));
		$body = $language->getText('ProjectJoinRequestAccept.ProjectJoinAcceptanceText', array($oProject->getUnixName()));

		SystemUtils::sendMail($subject, $body, $oUser);
	}

	public function sendRejectMessage() {
		$user_id = $this->getUserId();
		$oUser = $this->getUser();

		$project_id = $this->getProjectId();
		$oProject = $this->getProject();

		$language = LanguagePeer::retrieveByPk($oUser->getLanguageId());
		$subject = $language->getText('ProjectJoinRequestReject.ProjectJoinRejectionSubject', array($oProject->getUnixName()));
		$body = $language->getText('ProjectJoinRequestReject.ProjectJoinRejectionText', array($oProject->getUnixName()));

		SystemUtils::sendMail($subject, $body, $oUser);
	}
	
	public function isMember() {
		$project_id = $this->getProjectId();
		$user_id = $this->getUserId();
		$crit = new Criteria();
		$crit->add(UserProjectPeer::PROJECT_ID, $project_id);
		$crit->add(UserProjectPeer::USER_ID, $user_id);
		$res = UserProjectPeer::doSelectOne($crit);

		return (is_object($res) ? true : false);
	}

}
?>
