<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id$
 * @author Tim Perdue tim@gforge.org
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
// The parent class
require_once 'core/om/BaseProjectPeer.php';

// The object class
include_once 'core/Project.php';

/** 
 * The skeleton for this class was autogenerated by Propel on:
 *
 * [Sun Nov 13 22:49:46 2005]
 *
 *  You should add additional methods to this class to meet the
 *  application requirements.  This class will only be generated as
 *  long as it does not already exist in the output directory.
 *
 * @package core 
 */
class ProjectPeer extends BaseProjectPeer {
	private static $_pkCache = array();
	private static $_unixNameCache = array();

	/**
	 * Retrieve a single object by pkey or NULL if not found.
	 * This method was added by propel_customizer.php.
	 *
	 * @param	mixed $pk	The primary key
	 * @param	bool $useCache	Whether to use caching. This will increase performance if the same object
	 *							is accessed several times
	 * @param	Connection $con	The connection to use
	 * @return	Project
	 */
	public static function retrieveByPk($pk, $useCache = true, $con = null) {
		if ($useCache && array_key_exists($pk, ProjectPeer::$_pkCache)) {
			return ProjectPeer::$_pkCache[$pk];
		}
		
		$object = parent::retrieveByPk($pk, $con);
		if (is_null($object)) {
			return null;
		}

		if ($useCache) {
			ProjectPeer::$_pkCache[$pk] = $object;
			ProjectPeer::$_unixNameCache[$object->getUnixName()] = $object;
		}
		return $object;
	}
	
	/**
	 * Retrieve a single object by UnixName or NULL if not found.
	 * This method was added by propel_customizer.php.
	 *
	 * @param	mixed $unixName	Unix name of the project
	 * @param	bool $useCache	Whether to use caching. This will increase performance if the same object
	 *							is accessed several times
	 * @param	Connection $con	The connection to use
	 * @return	Project
	 */
	public static function retrieveByUnixName($unixName, $useCache=true, $con=null) {
		if ($useCache && array_key_exists($unixName, ProjectPeer::$_unixNameCache)) {
			return ProjectPeer::$_unixNameCache[$unixName];
		}					
		$c = new Criteria();
		$c->add(ProjectPeer::UNIX_NAME,$unixName);
		$object = ProjectPeer::DoSelectOne($c);
		
		if (is_null($object)) {
			return null;
		}

		if ($useCache) {
		 	ProjectPeer::$_unixNameCache[$unixName] = $object;
			ProjectPeer::$_pkCache[$object->getProjectID()] = $object;
		}
		return $object;
	}
	/**
	 * Removes an object from the cache. This is usually done after saving.
	 * This method was added by propel_customizer.php.
	 *
	 * @param	mixed $pk	The primary key of the object to remove
	 */
	public static function invalidate($pk) {
		if (array_key_exists($pk, ProjectPeer::$_pkCache)) {
			unset(ProjectPeer::$_pkCache[$pk]);
		}
	}
	
	/**
	 * Get the list of "template" projects
	 */
	public static function getTemplateProjects() {
		// get only the active projects
		$c = new Criteria();
		$c->add(ProjectPeer::STATUS,project::STATUS_ACTIVE);
		$c->add(ProjectPeer::IS_TEMPLATE,true);
		$c->addAscendingOrderByColumn(ProjectPeer::PROJECT_NAME);
		return self::doSelect($c);
	}

	public static function getProjectMembersFor($project_id) {
		$sql = "SELECT * FROM \"user\" WHERE user_id IN
					(
						SELECT DISTINCT user_project.user_id
						FROM user_project, user_project_role, role_setting
						WHERE user_project.user_project_id=user_project_role.user_project_id
						AND user_project_role.role_id=role_setting.role_id
						AND user_project.project_id = $project_id
						AND value > -1
						UNION SELECT member_user_id AS user_id FROM usergroup_user WHERE usergroup_id IN
						(
							SELECT DISTINCT user_project.user_id AS usergroup_id
							FROM user_project, user_project_role, role_setting
							WHERE user_project.user_project_id=user_project_role.user_project_id
							AND user_project_role.role_id=role_setting.role_id
							AND user_project.project_id = $project_id
							AND value > -1
						)
					)
					AND is_group = 'f'
					ORDER BY firstname ASC, lastname ASC;
					";

		$con = Propel::getConnection(UserPeer::DATABASE_NAME);
		$stmt = $con->createStatement();
		$rs = $stmt->executeQuery($sql, ResultSet::FETCHMODE_NUM);

		return UserPeer::populateObjects($rs);
	}

	public static function getPublicProjects() {
		$c = new Criteria();
		$c->add(ProjectPeer::IS_PUBLIC, true);
		$c->add(ProjectPeer::IS_TEMPLATE, false);
		return ProjectPeer::doSelect($c);
	}
}
?>