<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id$
 * @author Tim Perdue tim@gforge.org
 * @date 2010-02-23
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
require_once 'core/om/BaseTagEntry.php';
require_once("plugin/ActionManager.php");

/** 
 * The skeleton for this class was autogenerated by Propel  * You should add additional methods to this class to meet the
 * application requirements.  This class will only be generated as
 * long as it does not already exist in the output directory.
 *
 * @package core 
 */
class TagEntry extends BaseTagEntry {
	/**
	 * Removes this object from datastore and sets delete attribute. Informs the plugin manager.
	 * This method was added by propel_customizer.php.
	 * 
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 * @see TagEntry::setDeleted()
	 * @see TagEntry::isDeleted()
	 */
	function delete($con = null) {
		if (!$this->userCanUpdate()) {
			throw new PermissionDeniedException();
		}

		ActionManager::notify("TAG_ENTRY_DELETE", $this);
		parent::delete($con);		
	}

	/**
	 * Stores the object in the database using the Propel methods. Informs the plugin manager.
	 * This method was added by propel_customizer.php.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
	function save($con = null) {
		if (!$this->userCanUpdate()) {
			throw new PermissionDeniedException();
		}
		
		parent::save($con);
		ActionManager::notify("TAG_ENTRY_SAVE", $this);
	}
	
	function userCanUpdate() {
		return TagEntryPeer::userCanUpdate($this->getSection(), $this->getRefId());
	}
}
?>
