<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id$
 * @author Tim Perdue tim@gforge.org
 * @date 2005-11-11
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
// The parent class
require_once 'core/om/BaseUserUnixPeer.php';

// The object class
include_once 'core/UserUnix.php';

/** 
 * The skeleton for this class was autogenerated by Propel on:
 *
 * [Sun Nov 13 22:49:46 2005]
 *
 *  You should add additional methods to this class to meet the
 *  application requirements.  This class will only be generated as
 *  long as it does not already exist in the output directory.
 *
 * @package core 
 */
class UserUnixPeer extends BaseUserUnixPeer {
	private static $_pkCache = array();
	
	const UNIX_UID_ADD = 1000000;
	const UNIX_GID_ADD = 1000000;

	/**
	 * Retrieve a single object by pkey or NULL if not found.
	 * This method was added by propel_customizer.php.
	 *
	 * @param	mixed $pk	The primary key
	 * @param	bool $useCache	Whether to use caching. This will increase performance if the same object
	 *							is accessed several times
	 * @param	Connection $con	The connection to use
	 * @return	UserUnix
	 */
	public static function retrieveByPk($pk, $useCache = true, $con = null) {
		if ($useCache && array_key_exists($pk, UserUnixPeer::$_pkCache)) {
			return UserUnixPeer::$_pkCache[$pk];
		}
		
		$object = parent::retrieveByPk($pk, $con);
		if ($useCache) {
			UserUnixPeer::$_pkCache[$pk] = $object;
		}
		return $object;
	}
	
	/**
	 * Removes an object from the cache. This is usually done after saving.
	 * This method was added by propel_customizer.php.
	 *
	 * @param	mixed $pk	The primary key of the object to remove
	 */
	public static function invalidate($pk) {
		if (array_key_exists($pk, UserUnixPeer::$_pkCache)) {
			unset(UserUnixPeer::$_pkCache[$pk]);
		}
	}
	
	/**
	 * Retrieves a user_unix object for the user. If it can't find
	 * the entry, it will create one with the default values. Note that
	 * the session user must have enough permissions to create the object
	 */
	public static function retrieveByPkOrCreate($user_id) {
		$user_unix = self::retrieveByPk($user_id);
		if (!$user_unix) {
			$user = UserPeer::retrieveByPk($user_id);
			if (!$user) return null;
			//if it's not configured, create a new configuration with default values
			$user_unix = new UserUnix();
			$user_unix->setUserId($user->getUserId());
			$user_unix->setUnixShellId(UnixShell::RESTRICTED_CVS_SHELL);		// "cvssh.pl"
			$user_unix->setUnixUid(self::UNIX_UID_ADD + $user->getUserId());
			$user_unix->setUnixGid(self::UNIX_GID_ADD + $user->getUserId());
			$user_unix->save();
		}
		
		return $user_unix;
	}

}
?>
