<?php
require_once 'propel/map/MapBuilder.php';
include_once 'creole/CreoleTypes.php';

/**
 * This class adds structure of 'activity_log' table to 'gf5' DatabaseMap object.
 *
 * These statically-built map classes are used by Propel to do runtime db structure discovery.
 * For example, the createSelectSql() method checks the type of a given column used in an 
 * ORDER BY clause to know whether it needs to apply SQL to make the ORDER BY case-insensitive 
 * (i.e. if it's a text column type).
 *
 * @see BasePeer
 * @see DatabaseMap
 * @package core.map
 */
class ActivityLogMapBuilder implements MapBuilder {

    /**
     * The name of this class
     */
    const CLASS_NAME = "core.map.ActivityLogMapBuilder";
	
    /**
     * The database map.
     */
    private $dbMap = null;

    /**
     * Tells us if this DatabaseMapBuilder is built so that we
     * don't have to re-build it every time.
     *
     * @return true if this DatabaseMapBuilder is built
     */
    public function isBuilt()
    {
        return ($this->dbMap !== null);
    }

    /**
     * Gets the databasemap this map builder built.
     *
     * @return the databasemap
     */
    public function getDatabaseMap()
    {
        return $this->dbMap;
    }

    /**
     * The doBuild() method builds the DatabaseMap
     *
	 * @return void
     * @throws PropelException
     */
    public function doBuild()
    {
		$this->dbMap = Propel::getDatabaseMap("gf5");
		
		$tMap = $this->dbMap->addTable("activity_log");
		$tMap->setPhpName("ActivityLog");
		
         
		$tMap->setUseIdGenerator(true);
		 
						
		 
		$tMap->setPrimaryKeyMethodInfo("activity_log_activity_log_id_seq");
		 
		
		// Add columns to map
		$tMap->addPrimaryKey("ACTIVITY_LOG_ID", "ActivityLogId", "int", CreoleTypes::INTEGER, true);
		$tMap->addColumn("ACTIVITY_DATE", "ActivityDate", "int", CreoleTypes::TIMESTAMP, true, null);
		$tMap->addColumn("PROJECT_ID", "ProjectId", "int", CreoleTypes::INTEGER, false, null);
		$tMap->addColumn("USER_ID", "UserId", "int", CreoleTypes::INTEGER, false, null);
		$tMap->addColumn("SECTION", "Section", "string", CreoleTypes::VARCHAR, false, 20);
		$tMap->addColumn("REF_ID", "RefId", "int", CreoleTypes::INTEGER, false, null);
		$tMap->addColumn("DESCRIPTION", "Description", "string", CreoleTypes::VARCHAR, true, null);
		$tMap->addColumn("URL", "Url", "string", CreoleTypes::VARCHAR, false, null);
		$tMap->addColumn("ACTIVITY_TYPE", "ActivityType", "string", CreoleTypes::VARCHAR, false, 20);
		$tMap->addColumn("EXTENDED_DATA", "ExtendedData", "string", CreoleTypes::VARCHAR, false, null);
				
    }
}
