<?php
require_once 'propel/map/MapBuilder.php';
include_once 'creole/CreoleTypes.php';

/**
 * This class adds structure of 'filesystem_download' table to 'gf5' DatabaseMap object.
 *
 * These statically-built map classes are used by Propel to do runtime db structure discovery.
 * For example, the createSelectSql() method checks the type of a given column used in an 
 * ORDER BY clause to know whether it needs to apply SQL to make the ORDER BY case-insensitive 
 * (i.e. if it's a text column type).
 *
 * @see BasePeer
 * @see DatabaseMap
 * @package core.map
 */
class FilesystemDownloadMapBuilder implements MapBuilder {

    /**
     * The name of this class
     */
    const CLASS_NAME = "core.map.FilesystemDownloadMapBuilder";
	
    /**
     * The database map.
     */
    private $dbMap = null;

    /**
     * Tells us if this DatabaseMapBuilder is built so that we
     * don't have to re-build it every time.
     *
     * @return true if this DatabaseMapBuilder is built
     */
    public function isBuilt()
    {
        return ($this->dbMap !== null);
    }

    /**
     * Gets the databasemap this map builder built.
     *
     * @return the databasemap
     */
    public function getDatabaseMap()
    {
        return $this->dbMap;
    }

    /**
     * The doBuild() method builds the DatabaseMap
     *
	 * @return void
     * @throws PropelException
     */
    public function doBuild()
    {
		$this->dbMap = Propel::getDatabaseMap("gf5");
		
		$tMap = $this->dbMap->addTable("filesystem_download");
		$tMap->setPhpName("FilesystemDownload");
		
         
		$tMap->setUseIdGenerator(true);
		 
						
		 
		$tMap->setPrimaryKeyMethodInfo("filesystem_download_filesystem_download_id_seq");
		 
		
		// Add columns to map
		$tMap->addPrimaryKey("FILESYSTEM_DOWNLOAD_ID", "FilesystemDownloadId", "int", CreoleTypes::INTEGER, true);
		$tMap->addColumn("IP_ADDRESS", "IpAddress", "string", CreoleTypes::VARCHAR, false, null);
		$tMap->addForeignKey("FILESYSTEM_ID", "FilesystemId", "int", CreoleTypes::INTEGER, "filesystem" , "FILESYSTEM_ID", false);
		$tMap->addColumn("DOWNLOAD_DATE", "DownloadDate", "int", CreoleTypes::TIMESTAMP, false, null);
		$tMap->addColumn("USER_ID", "UserId", "int", CreoleTypes::INTEGER, false, null);
				
    }
}
