<?php
require_once 'propel/map/MapBuilder.php';
include_once 'creole/CreoleTypes.php';

/**
 * This class adds structure of 'project' table to 'gf5' DatabaseMap object.
 *
 * These statically-built map classes are used by Propel to do runtime db structure discovery.
 * For example, the createSelectSql() method checks the type of a given column used in an 
 * ORDER BY clause to know whether it needs to apply SQL to make the ORDER BY case-insensitive 
 * (i.e. if it's a text column type).
 *
 * @see BasePeer
 * @see DatabaseMap
 * @package core.map
 */
class ProjectMapBuilder implements MapBuilder {

    /**
     * The name of this class
     */
    const CLASS_NAME = "core.map.ProjectMapBuilder";
	
    /**
     * The database map.
     */
    private $dbMap = null;

    /**
     * Tells us if this DatabaseMapBuilder is built so that we
     * don't have to re-build it every time.
     *
     * @return true if this DatabaseMapBuilder is built
     */
    public function isBuilt()
    {
        return ($this->dbMap !== null);
    }

    /**
     * Gets the databasemap this map builder built.
     *
     * @return the databasemap
     */
    public function getDatabaseMap()
    {
        return $this->dbMap;
    }

    /**
     * The doBuild() method builds the DatabaseMap
     *
	 * @return void
     * @throws PropelException
     */
    public function doBuild()
    {
		$this->dbMap = Propel::getDatabaseMap("gf5");
		
		$tMap = $this->dbMap->addTable("project");
		$tMap->setPhpName("Project");
		
         
		$tMap->setUseIdGenerator(true);
		 
						
		 
		$tMap->setPrimaryKeyMethodInfo("project_project_id_seq");
		 
		
		// Add columns to map
		$tMap->addPrimaryKey("PROJECT_ID", "ProjectId", "int", CreoleTypes::INTEGER, true);
		$tMap->addColumn("PROJECT_NAME", "ProjectName", "string", CreoleTypes::VARCHAR, false, 40);
		$tMap->addColumn("UNIX_NAME", "UnixName", "string", CreoleTypes::VARCHAR, true, 30);
		$tMap->addColumn("HOMEPAGE_URL", "HomepageUrl", "string", CreoleTypes::VARCHAR, false, null);
		$tMap->addColumn("IS_PUBLIC", "IsPublic", "boolean", CreoleTypes::BOOLEAN, false, null);
		$tMap->addColumn("STATUS", "Status", "int", CreoleTypes::INTEGER, false, null);
		$tMap->addColumn("DESCRIPTION", "Description", "string", CreoleTypes::VARCHAR, false, null);
		$tMap->addColumn("REGISTER_PURPOSE", "RegisterPurpose", "string", CreoleTypes::VARCHAR, false, null);
		$tMap->addColumn("REGISTER_LICENSE_OTHER", "RegisterLicenseOther", "string", CreoleTypes::VARCHAR, false, null);
		$tMap->addColumn("CREATE_DATE", "CreateDate", "int", CreoleTypes::TIMESTAMP, false, null);
		$tMap->addColumn("TEMPLATE_PROJECT_ID", "TemplateProjectId", "int", CreoleTypes::INTEGER, false, null);
		$tMap->addColumn("IS_TEMPLATE", "IsTemplate", "boolean", CreoleTypes::BOOLEAN, false, null);
		$tMap->addColumn("PARENT_PROJECT_ID", "ParentProjectId", "int", CreoleTypes::INTEGER, false, null);
		$tMap->addColumn("ROOT_PARENT_PROJECT_ID", "RootParentProjectId", "int", CreoleTypes::INTEGER, false, null);
		$tMap->addColumn("ROOT_PATH", "RootPath", "string", CreoleTypes::VARCHAR, false, null);
		$tMap->addColumn("PROJECT_TEXT1", "ProjectText1", "string", CreoleTypes::VARCHAR, false, null);
		$tMap->addColumn("PROJECT_TEXT2", "ProjectText2", "string", CreoleTypes::VARCHAR, false, null);
		$tMap->addColumn("PROJECT_TEXT3", "ProjectText3", "string", CreoleTypes::VARCHAR, false, null);
		$tMap->addColumn("PROJECT_TEXT4", "ProjectText4", "string", CreoleTypes::VARCHAR, false, null);
		$tMap->addColumn("PROJECT_TEXT5", "ProjectText5", "string", CreoleTypes::VARCHAR, false, null);
		$tMap->addColumn("PROJECT_TEXT6", "ProjectText6", "string", CreoleTypes::VARCHAR, false, null);
		$tMap->addColumn("IS_LISTED", "IsListed", "boolean", CreoleTypes::BOOLEAN, false, null);
		$tMap->addColumn("ENABLE_WORKFLOW_SCRIPTS", "EnableWorkflowScripts", "boolean", CreoleTypes::BOOLEAN, false, null);
		$tMap->addColumn("AVERAGE_RATING", "AverageRating", "int", CreoleTypes::INTEGER, false, null);
				
    }
}
