<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id$
 * @author Tim Perdue tim@gforge.org
 * @date 2006-02-27
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

require_once 'propel/map/MapBuilder.php';
include_once 'creole/CreoleTypes.php';

/**
 * This class adds structure of 'project_scm' table to 'gf5' DatabaseMap object.
 *
 * These statically-built map classes are used by Propel to do runtime db structure discovery.
 * For example, the createSelectSql() method checks the type of a given column used in an 
 * ORDER BY clause to know whether it needs to apply SQL to make the ORDER BY case-insensitive 
 * (i.e. if it's a text column type).
 *
 *  This class was autogenerated by Propel on:
 *
 * [Mon Dec 26 18:20:24 2005]
 *
 * @see BasePeer
 * @see DatabaseMap
 * @package core.map
 */
class ProjectScmMapBuilder implements MapBuilder {

    /**
     * The name of this class
     */
    const CLASS_NAME = "core.map.ProjectScmMapBuilder";
	
    /**
     * The database map.
     */
    private $dbMap = null;

    /**
     * Tells us if this DatabaseMapBuilder is built so that we
     * don't have to re-build it every time.
     *
     * @return true if this DatabaseMapBuilder is built
     */
    public function isBuilt()
    {
        return ($this->dbMap !== null);
    }

    /**
     * Gets the databasemap this map builder built.
     *
     * @return the databasemap
     */
    public function getDatabaseMap()
    {
        return $this->dbMap;
    }

    /**
     * The doBuild() method builds the DatabaseMap
     *
	 * @return void
     * @throws PropelException
     */
    public function doBuild()
    {
		$this->dbMap = Propel::getDatabaseMap("gf5");
		
		$tMap = $this->dbMap->addTable("project_scm");
		$tMap->setPhpName("ProjectScm");
		
         
		$tMap->setUseIdGenerator(false);
		 
						
		 
		
		// Add columns to map
		$tMap->addForeignPrimaryKey("PROJECT_ID", "ProjectId", "int" , CreoleTypes::INTEGER, "project", "PROJECT_ID", true);
		$tMap->addColumn("ENABLE_ANONREAD", "EnableAnonread", "boolean", CreoleTypes::BOOLEAN, true, null);
		$tMap->addForeignKey("SCM_SERVER_ID", "ScmServerId", "int", CreoleTypes::INTEGER, "scm_server" , "SCM_SERVER_ID", true);
		$tMap->addColumn("CONTROLLED", "Controlled", "boolean", CreoleTypes::BOOLEAN, true, null);
		$tMap->addColumn("HOSTNAME", "Hostname", "string", CreoleTypes::VARCHAR, false, null);
		$tMap->addColumn("ROOT_DIRECTORY", "RootDirectory", "string", CreoleTypes::VARCHAR, false, null);
				
    }
}