<?php
require_once 'propel/map/MapBuilder.php';
include_once 'creole/CreoleTypes.php';

/**
 * This class adds structure of 'trove_category' table to 'gf5' DatabaseMap object.
 *
 * These statically-built map classes are used by Propel to do runtime db structure discovery.
 * For example, the createSelectSql() method checks the type of a given column used in an 
 * ORDER BY clause to know whether it needs to apply SQL to make the ORDER BY case-insensitive 
 * (i.e. if it's a text column type).
 *
 * @see BasePeer
 * @see DatabaseMap
 * @package core.map
 */
class TroveCategoryMapBuilder implements MapBuilder {

    /**
     * The name of this class
     */
    const CLASS_NAME = "core.map.TroveCategoryMapBuilder";
	
    /**
     * The database map.
     */
    private $dbMap = null;

    /**
     * Tells us if this DatabaseMapBuilder is built so that we
     * don't have to re-build it every time.
     *
     * @return true if this DatabaseMapBuilder is built
     */
    public function isBuilt()
    {
        return ($this->dbMap !== null);
    }

    /**
     * Gets the databasemap this map builder built.
     *
     * @return the databasemap
     */
    public function getDatabaseMap()
    {
        return $this->dbMap;
    }

    /**
     * The doBuild() method builds the DatabaseMap
     *
	 * @return void
     * @throws PropelException
     */
    public function doBuild()
    {
		$this->dbMap = Propel::getDatabaseMap("gf5");
		
		$tMap = $this->dbMap->addTable("trove_category");
		$tMap->setPhpName("TroveCategory");
		
         
		$tMap->setUseIdGenerator(true);
		 
						
		 
		$tMap->setPrimaryKeyMethodInfo("trove_category_trove_category_id_seq");
		 
		
		// Add columns to map
		$tMap->addPrimaryKey("TROVE_CATEGORY_ID", "TroveCategoryId", "int", CreoleTypes::INTEGER, true);
		$tMap->addColumn("ROOT_TROVE_CATEGORY_ID", "RootTroveCategoryId", "int", CreoleTypes::INTEGER, true, null);
		$tMap->addForeignKey("PARENT_TROVE_CATEGORY_ID", "ParentTroveCategoryId", "int", CreoleTypes::INTEGER, "trove_category" , "TROVE_CATEGORY_ID", true);
		$tMap->addColumn("ALIAS", "Alias", "string", CreoleTypes::VARCHAR, true, null);
		$tMap->addColumn("CATEGORY_NAME", "CategoryName", "string", CreoleTypes::VARCHAR, true, null);
		$tMap->addColumn("DESCRIPTION", "Description", "string", CreoleTypes::VARCHAR, true, null);
		$tMap->addColumn("SHOW_IN_SEARCH", "ShowInSearch", "boolean", CreoleTypes::BOOLEAN, false, null);
		$tMap->addColumn("ACCESS_LEVEL", "AccessLevel", "int", CreoleTypes::INTEGER, false, null);
		$tMap->addColumn("PROJECT_LINKS_COUNT", "ProjectLinksCount", "int", CreoleTypes::INTEGER, false, null);
				
    }
}
