<?php
require_once 'propel/map/MapBuilder.php';
include_once 'creole/CreoleTypes.php';

/**
 * This class adds structure of 'user' table to 'gf5' DatabaseMap object.
 *
 * These statically-built map classes are used by Propel to do runtime db structure discovery.
 * For example, the createSelectSql() method checks the type of a given column used in an 
 * ORDER BY clause to know whether it needs to apply SQL to make the ORDER BY case-insensitive 
 * (i.e. if it's a text column type).
 *
 * @see BasePeer
 * @see DatabaseMap
 * @package core.map
 */
class UserMapBuilder implements MapBuilder {

    /**
     * The name of this class
     */
    const CLASS_NAME = "core.map.UserMapBuilder";
	
    /**
     * The database map.
     */
    private $dbMap = null;

    /**
     * Tells us if this DatabaseMapBuilder is built so that we
     * don't have to re-build it every time.
     *
     * @return true if this DatabaseMapBuilder is built
     */
    public function isBuilt()
    {
        return ($this->dbMap !== null);
    }

    /**
     * Gets the databasemap this map builder built.
     *
     * @return the databasemap
     */
    public function getDatabaseMap()
    {
        return $this->dbMap;
    }

    /**
     * The doBuild() method builds the DatabaseMap
     *
	 * @return void
     * @throws PropelException
     */
    public function doBuild()
    {
		$this->dbMap = Propel::getDatabaseMap("gf5");
		
		$tMap = $this->dbMap->addTable('"user"');
		$tMap->setPhpName("User");
		
         
		$tMap->setUseIdGenerator(true);
		 
						
		 
		$tMap->setPrimaryKeyMethodInfo("user_user_id_seq");
		 
		
		// Add columns to map
		$tMap->addPrimaryKey("USER_ID", "UserId", "int", CreoleTypes::INTEGER, true);
		$tMap->addColumn("UNIX_NAME", "UnixName", "string", CreoleTypes::VARCHAR, true, null);
		$tMap->addColumn("EMAIL", "Email", "string", CreoleTypes::VARCHAR, true, null);
		$tMap->addColumn("STATUS", "Status", "int", CreoleTypes::INTEGER, false, null);
		$tMap->addColumn("PASSWORD_MD5", "PasswordMd5", "string", CreoleTypes::VARCHAR, true, 32);
		$tMap->addColumn("PASSWORD_CRYPT", "PasswordCrypt", "string", CreoleTypes::VARCHAR, true, 40);
		$tMap->addColumn("CREATE_DATE", "CreateDate", "int", CreoleTypes::TIMESTAMP, false, null);
		$tMap->addColumn("CONFIRM_HASH", "ConfirmHash", "string", CreoleTypes::VARCHAR, false, 32);
		$tMap->addColumn("EMAIL_NEW", "EmailNew", "string", CreoleTypes::VARCHAR, false, null);
		$tMap->addColumn("TIMEZONE", "Timezone", "string", CreoleTypes::VARCHAR, false, null);
		$tMap->addColumn("DATE_FORMAT", "DateFormat", "string", CreoleTypes::VARCHAR, false, null);
		$tMap->addColumn("ADDRESS", "Address", "string", CreoleTypes::VARCHAR, false, null);
		$tMap->addColumn("ADDRESS2", "Address2", "string", CreoleTypes::VARCHAR, false, null);
		$tMap->addColumn("PHONE", "Phone", "string", CreoleTypes::VARCHAR, false, null);
		$tMap->addColumn("FAX", "Fax", "string", CreoleTypes::VARCHAR, false, null);
		$tMap->addColumn("TITLE", "Title", "string", CreoleTypes::VARCHAR, false, null);
		$tMap->addColumn("FIRSTNAME", "Firstname", "string", CreoleTypes::VARCHAR, false, null);
		$tMap->addColumn("LASTNAME", "Lastname", "string", CreoleTypes::VARCHAR, false, null);
		$tMap->addForeignKey("CCODE", "Ccode", "string", CreoleTypes::CHAR, "country_code" , "CCODE", true);
		$tMap->addForeignKey("LANGUAGE_ID", "LanguageId", "int", CreoleTypes::INTEGER, "language" , "LANGUAGE_ID", true);
		$tMap->addForeignKey("THEME_ID", "ThemeId", "int", CreoleTypes::INTEGER, "theme" , "THEME_ID", true);
		$tMap->addColumn("EXTERNAL_ID", "ExternalId", "string", CreoleTypes::VARCHAR, false, null);
		$tMap->addColumn("LAST_LOGIN", "LastLogin", "int", CreoleTypes::TIMESTAMP, false, null);
		$tMap->addColumn("USER_TEXT1", "UserText1", "string", CreoleTypes::VARCHAR, false, null);
		$tMap->addColumn("USER_TEXT2", "UserText2", "string", CreoleTypes::VARCHAR, false, null);
		$tMap->addColumn("USER_TEXT3", "UserText3", "string", CreoleTypes::VARCHAR, false, null);
		$tMap->addColumn("USER_TEXT4", "UserText4", "string", CreoleTypes::VARCHAR, false, null);
		$tMap->addColumn("USER_TEXT5", "UserText5", "string", CreoleTypes::VARCHAR, false, null);
		$tMap->addColumn("USER_TEXT6", "UserText6", "string", CreoleTypes::VARCHAR, false, null);
		$tMap->addColumn("IS_GROUP", "IsGroup", "boolean", CreoleTypes::BOOLEAN, false, null);
		$tMap->addColumn("PASSWORD_CHANGE_DATE", "PasswordChangeDate", "int", CreoleTypes::TIMESTAMP, false, null);
		$tMap->addColumn("IS_RESTRICTED", "IsRestricted", "boolean", CreoleTypes::BOOLEAN, false, null);
		$tMap->addColumn("USE_CUSTOM_AVATAR", "UseCustomAvatar", "boolean", CreoleTypes::BOOLEAN, false, null);
		$tMap->addColumn("AVATAR_ID", "AvatarId", "int", CreoleTypes::INTEGER, false, null);
		$tMap->addColumn("CELL", "Cell", "string", CreoleTypes::VARCHAR, false, null);
				
    }
}
