<?php
require_once 'propel/map/MapBuilder.php';
include_once 'creole/CreoleTypes.php';

/**
 * This class adds structure of 'user_session' table to 'gf5' DatabaseMap object.
 *
 * These statically-built map classes are used by Propel to do runtime db structure discovery.
 * For example, the createSelectSql() method checks the type of a given column used in an 
 * ORDER BY clause to know whether it needs to apply SQL to make the ORDER BY case-insensitive 
 * (i.e. if it's a text column type).
 *
 * @see BasePeer
 * @see DatabaseMap
 * @package core.map
 */
class UserSessionMapBuilder implements MapBuilder {

    /**
     * The name of this class
     */
    const CLASS_NAME = "core.map.UserSessionMapBuilder";
	
    /**
     * The database map.
     */
    private $dbMap = null;

    /**
     * Tells us if this DatabaseMapBuilder is built so that we
     * don't have to re-build it every time.
     *
     * @return true if this DatabaseMapBuilder is built
     */
    public function isBuilt()
    {
        return ($this->dbMap !== null);
    }

    /**
     * Gets the databasemap this map builder built.
     *
     * @return the databasemap
     */
    public function getDatabaseMap()
    {
        return $this->dbMap;
    }

    /**
     * The doBuild() method builds the DatabaseMap
     *
	 * @return void
     * @throws PropelException
     */
    public function doBuild()
    {
		$this->dbMap = Propel::getDatabaseMap("gf5");
		
		$tMap = $this->dbMap->addTable("user_session");
		$tMap->setPhpName("UserSession");
		
         
		$tMap->setUseIdGenerator(false);
		 
						
		 
		
		// Add columns to map
		$tMap->addForeignKey("USER_ID", "UserId", "int", CreoleTypes::INTEGER, "user" , "USER_ID", true);
		$tMap->addPrimaryKey("SESSION_HASH", "SessionHash", "string", CreoleTypes::VARCHAR, true);
		$tMap->addColumn("IP_ADDR", "IpAddr", "string", CreoleTypes::CHAR, true, 15);
		$tMap->addColumn("LOGIN_TIME", "LoginTime", "int", CreoleTypes::TIMESTAMP, false, null);
		$tMap->addColumn("MODIFIED", "Modified", "int", CreoleTypes::TIMESTAMP, false, null);
		$tMap->addColumn("DATA", "Data", "string", CreoleTypes::VARCHAR, false, null);
				
    }
}
