<?php 

require_once 'propel/om/BaseObject.php';

 
require_once 'propel/om/Persistent.php';

 

include_once 'propel/util/Criteria.php';
 

// (on-demand) include_once 'core/User.php';
// (on-demand) include_once 'core/UserPeer.php';
 

// (on-demand) include_once 'core/Notification.php';
// (on-demand) include_once 'core/NotificationPeer.php';

include_once 'core/NotificationQueuePeer.php';

/**
 * Base class that represents a row from the 'notification_queue' table.
 *
 *  
 *
 * You should not use this class directly.  It should not even be
 * extended; all references should be to NotificationQueue class. 
 * 
 * @package core 
 */
abstract class BaseNotificationQueue extends BaseObject implements Persistent {
	
	/** 
	 * The Peer class.
	 * Instance provides a convenient way of calling static methods on a class
	 * that calling code may not be able to identify.
	 * @var NotificationQueuePeer
	 */
	protected static $peer;

	/**
	 * The value for the notification_queue_id field.
	 * @var int	  
	 */
	protected $notification_queue_id;	

	/**
	 * The value for the section field.
	 * @var string	  
	 */
	protected $section;	

	/**
	 * The value for the ref_id field.
	 * @var int	  
	 */
	protected $ref_id;	

	/**
	 * The value for the user_id field.
	 * @var int	  
	 */
	protected $user_id;	

	/**
	 * The value for the subject field.
	 * @var string	  
	 */
	protected $subject;	

	/**
	 * The value for the body field.
	 * @var string	  
	 */
	protected $body;	

	/**
	 * The value for the queue_date field.
	 * @var int	  
	 */
	protected $queue_date = -1;	

	/**
	 * The value for the send_date field.
	 * @var int	  
	 */
	protected $send_date = -1;	

	/**
	 * The value for the message_id field.
	 * @var string	  
	 */
	protected $message_id;	

	/**
	 * The value for the in_reply_to field.
	 * @var string	  
	 */
	protected $in_reply_to;	

	/**
	 * The value for the ref_message field.
	 * @var string	  
	 */
	protected $ref_message;	

	/**
	 * The value for the notification_id field.
	 * @var int	  
	 */
	protected $notification_id = 0;	
  
	/**
	 * Get the NotificationQueueId column value.
	 *  
	 * @return int	  
	 */
	public function getNotificationQueueId()
	{
		return $this->notification_queue_id;
	}


	/**
	 * Set the value of `notification_queue_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 *  
	 */
	public function setNotificationQueueId($v)
	{
		if ($this->notification_queue_id !== $v) {
			$this->notification_queue_id = $v;
			$this->modifiedColumns[] = NotificationQueuePeer::NOTIFICATION_QUEUE_ID;
		}
				
	}

  
	/**
	 * Get the Section column value.
	 *  
	 * @return string	  
	 */
	public function getSection()
	{
		return $this->section;
	}


	/**
	 * Set the value of `section` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setSection($v)
	{
		if ($this->section !== $v) {
			$this->section = $v;
			$this->modifiedColumns[] = NotificationQueuePeer::SECTION;
		}
				
	}

  
	/**
	 * Get the RefId column value.
	 *  
	 * @return int	  
	 */
	public function getRefId()
	{
		return $this->ref_id;
	}


	/**
	 * Set the value of `ref_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 *  
	 */
	public function setRefId($v)
	{
		if ($this->ref_id !== $v) {
			$this->ref_id = $v;
			$this->modifiedColumns[] = NotificationQueuePeer::REF_ID;
		}
				
	}

  
	/**
	 * Get the UserId column value.
	 *  
	 * @return int	  
	 */
	public function getUserId()
	{
		return $this->user_id;
	}


	/**
	 * Set the value of `user_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setUserId($v)
	{
		if ($this->user_id !== $v) {
			$this->user_id = $v;
			$this->modifiedColumns[] = NotificationQueuePeer::USER_ID;
		}
			
		if ($this->aUser !== null && $this->aUser->getUserId() !== $v) {
			$this->aUser = null;
		}
			
	}

  
	/**
	 * Get the Subject column value.
	 *  
	 * @return string	  
	 */
	public function getSubject()
	{
		return $this->subject;
	}


	/**
	 * Set the value of `subject` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setSubject($v)
	{
		if ($this->subject !== $v) {
			$this->subject = $v;
			$this->modifiedColumns[] = NotificationQueuePeer::SUBJECT;
		}
				
	}

  
	/**
	 * Get the Body column value.
	 *  
	 * @return string	  
	 */
	public function getBody()
	{
		return $this->body;
	}


	/**
	 * Set the value of `body` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setBody($v)
	{
		if ($this->body !== $v) {
			$this->body = $v;
			$this->modifiedColumns[] = NotificationQueuePeer::BODY;
		}
				
	}


	/**
	 * Get the [optionally formatted] `queue_date` column value.
	 *  
	 * @param string $format The date/time format string (either date()-style or strftime()-style).
	 *							If format is NULL, then the integer unix timestamp will be returned.
	 * @return mixed Formatted date/time value as string or integer unix timestamp (if format is NULL).
	 * @throws PropelException - if unable to convert the date/time to timestamp.
	 */
	public function getQueueDate($format = 'Y-m-d H:i:s')
	{
		if ($this->queue_date === null || $this->queue_date === '') {
			return null;
		} elseif (!is_int($this->queue_date)) {
			// a non-timestamp value was set externally, so we convert it
			$ts = strtotime($this->queue_date);
			if ($ts === -1) {
				throw new PropelException("Unable to parse value of queue_date as date/time value: " . var_export($this->queue_date, true));
			}
		} else {
			$ts = $this->queue_date;
		}
		if ($format === null) {
			return $ts;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $ts);
		} else {
			return date($format, $ts);
		}
	}


	/**
	 * Set the value of `queue_date` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException - If passed [not-null] date/time is in an invalid format. 
	 */
	public function setQueueDate($v)
	{
		if ($v !== null && !is_int($v)) {
			$ts = strtotime($v);
			if ($ts === -1) {
				throw new PropelException("Unable to parse date/time value for queue_date from input: " . var_export($v, true));
			}
		} else {
			$ts = $v;
		}
		if ($this->queue_date !== $ts || $ts === -1) {
			$this->queue_date = $ts;
			$this->modifiedColumns[] = NotificationQueuePeer::QUEUE_DATE;
		}
		
	}


	/**
	 * Get the [optionally formatted] `send_date` column value.
	 *  
	 * @param string $format The date/time format string (either date()-style or strftime()-style).
	 *							If format is NULL, then the integer unix timestamp will be returned.
	 * @return mixed Formatted date/time value as string or integer unix timestamp (if format is NULL).
	 * @throws PropelException - if unable to convert the date/time to timestamp.
	 */
	public function getSendDate($format = 'Y-m-d H:i:s')
	{
		if ($this->send_date === null || $this->send_date === '') {
			return null;
		} elseif (!is_int($this->send_date)) {
			// a non-timestamp value was set externally, so we convert it
			$ts = strtotime($this->send_date);
			if ($ts === -1) {
				throw new PropelException("Unable to parse value of send_date as date/time value: " . var_export($this->send_date, true));
			}
		} else {
			$ts = $this->send_date;
		}
		if ($format === null) {
			return $ts;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $ts);
		} else {
			return date($format, $ts);
		}
	}


	/**
	 * Set the value of `send_date` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException - If passed [not-null] date/time is in an invalid format. 
	 */
	public function setSendDate($v)
	{
		if ($v !== null && !is_int($v)) {
			$ts = strtotime($v);
			if ($ts === -1) {
				throw new PropelException("Unable to parse date/time value for send_date from input: " . var_export($v, true));
			}
		} else {
			$ts = $v;
		}
		if ($this->send_date !== $ts || $ts === -1) {
			$this->send_date = $ts;
			$this->modifiedColumns[] = NotificationQueuePeer::SEND_DATE;
		}
		
	}

  
	/**
	 * Get the MessageId column value.
	 *  
	 * @return string	  
	 */
	public function getMessageId()
	{
		return $this->message_id;
	}


	/**
	 * Set the value of `message_id` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setMessageId($v)
	{
		if ($this->message_id !== $v) {
			$this->message_id = $v;
			$this->modifiedColumns[] = NotificationQueuePeer::MESSAGE_ID;
		}
				
	}

  
	/**
	 * Get the InReplyTo column value.
	 *  
	 * @return string	  
	 */
	public function getInReplyTo()
	{
		return $this->in_reply_to;
	}


	/**
	 * Set the value of `in_reply_to` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setInReplyTo($v)
	{
		if ($this->in_reply_to !== $v) {
			$this->in_reply_to = $v;
			$this->modifiedColumns[] = NotificationQueuePeer::IN_REPLY_TO;
		}
				
	}

  
	/**
	 * Get the RefMessage column value.
	 *  
	 * @return string	  
	 */
	public function getRefMessage()
	{
		return $this->ref_message;
	}


	/**
	 * Set the value of `ref_message` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setRefMessage($v)
	{
		if ($this->ref_message !== $v) {
			$this->ref_message = $v;
			$this->modifiedColumns[] = NotificationQueuePeer::REF_MESSAGE;
		}
				
	}

  
	/**
	 * Get the NotificationId column value.
	 *  
	 * @return int	  
	 */
	public function getNotificationId()
	{
		return $this->notification_id;
	}


	/**
	 * Set the value of `notification_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setNotificationId($v)
	{
		if ($this->notification_id !== $v || $v === 0) {
			$this->notification_id = $v;
			$this->modifiedColumns[] = NotificationQueuePeer::NOTIFICATION_ID;
		}
			
		if ($this->aNotification !== null && $this->aNotification->getNotificationId() !== $v) {
			$this->aNotification = null;
		}
			
	}


	
	/**
	 * Hydrates (populates) the object variables with values from the database resultset.
	 *
	 * An offset (1-based "start column") is specified so that objects can be hydrated
	 * with a subset of the columns in the resultset rows.  This is needed, for example,
	 * for results of JOIN queries where the resultset row includes columns from two or
	 * more tables.
	 *
	 * @param ResultSet $rs The ResultSet class with cursor advanced to desired record pos.
	 * @param int $startcol 1-based offset column which indicates which restultset column to start with.
	 * @return void
	 * @throws PropelException  - Any caught Exception will be rewrapped as a PropelException.
	 */
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {
			$this->notification_queue_id = $rs->getInt($startcol + 0);					
			$this->section = $rs->getString($startcol + 1);					
			$this->ref_id = $rs->getInt($startcol + 2);					
			$this->user_id = $rs->getInt($startcol + 3);					
			$this->subject = $rs->getString($startcol + 4);					
			$this->body = $rs->getString($startcol + 5);					
			$this->queue_date = $rs->getTimestamp($startcol + 6, null);
			$this->send_date = $rs->getTimestamp($startcol + 7, null);
			$this->message_id = $rs->getString($startcol + 8);					
			$this->in_reply_to = $rs->getString($startcol + 9);					
			$this->ref_message = $rs->getString($startcol + 10);					
			$this->notification_id = $rs->getInt($startcol + 11);					
			 
			$this->resetModified();
			$this->setNew(false);
		
		} catch (Exception $e) {
			throw new PropelException("Error populating NotificationQueue object", $e);
		}		
	
	}
	
	/**
	 * Builds a Criteria object containing the primary key for this object.
	 *
	 * Unlike buildCriteria() this method includes the primary key values regardless
	 * of whether or not they have been modified.
	 * 
	 * @return Criteria The Criteria object containing value(s) for primary key(s).
	 */
	public function buildPkeyCriteria()
	{		
		$criteria = new Criteria(NotificationQueuePeer::DATABASE_NAME);
		$criteria->add(NotificationQueuePeer::NOTIFICATION_QUEUE_ID, $this->notification_queue_id);
		return $criteria;			
	}
	
	/**
	 * Build a Criteria object containing the values of all modified columns in this object.
	 *
	 * @return Criteria The Criteria object containing all modified values.
	 */
	public function buildCriteria()
	{		
		$criteria = new Criteria(NotificationQueuePeer::DATABASE_NAME);
		if ($this->isColumnModified(NotificationQueuePeer::NOTIFICATION_QUEUE_ID)) $criteria->add(NotificationQueuePeer::NOTIFICATION_QUEUE_ID, $this->notification_queue_id);
		if ($this->isColumnModified(NotificationQueuePeer::SECTION)) $criteria->add(NotificationQueuePeer::SECTION, $this->section);
		if ($this->isColumnModified(NotificationQueuePeer::REF_ID)) $criteria->add(NotificationQueuePeer::REF_ID, $this->ref_id);
		if ($this->isColumnModified(NotificationQueuePeer::USER_ID)) $criteria->add(NotificationQueuePeer::USER_ID, $this->user_id);
		if ($this->isColumnModified(NotificationQueuePeer::SUBJECT)) $criteria->add(NotificationQueuePeer::SUBJECT, $this->subject);
		if ($this->isColumnModified(NotificationQueuePeer::BODY)) $criteria->add(NotificationQueuePeer::BODY, $this->body);
		if ($this->isColumnModified(NotificationQueuePeer::QUEUE_DATE)) $criteria->add(NotificationQueuePeer::QUEUE_DATE, $this->queue_date);
		if ($this->isColumnModified(NotificationQueuePeer::SEND_DATE)) $criteria->add(NotificationQueuePeer::SEND_DATE, $this->send_date);
		if ($this->isColumnModified(NotificationQueuePeer::MESSAGE_ID)) $criteria->add(NotificationQueuePeer::MESSAGE_ID, $this->message_id);
		if ($this->isColumnModified(NotificationQueuePeer::IN_REPLY_TO)) $criteria->add(NotificationQueuePeer::IN_REPLY_TO, $this->in_reply_to);
		if ($this->isColumnModified(NotificationQueuePeer::REF_MESSAGE)) $criteria->add(NotificationQueuePeer::REF_MESSAGE, $this->ref_message);
		if ($this->isColumnModified(NotificationQueuePeer::NOTIFICATION_ID)) $criteria->add(NotificationQueuePeer::NOTIFICATION_ID, $this->notification_id);
		return $criteria;			
	}
	
	

	/**
	 * @var User	  
	 */
	protected $aUser;

	/**
	 * Declares an association between this object and a User object
	 *
	 * @param User $v
	 * @return void
	 * @throws PropelException
	 */
	public function setUser($v)
	{
			
		if ($v === null) {
			$this->setUserId(NULL);
		} else {
			$this->setUserId($v->getUserId());
		}
   
		$this->aUser = $v;
	}


	/**
	 * Get the associated User object
	 *
	 * @param Connection Optional Connection object.
	 * @return User The associated User object.
	 * @throws PropelException
	 */
	public function getUser($con = null)
	{
		// include the Peer class
		include_once 'core/UserPeer.php';

		if ($this->aUser === null && ($this->user_id !== null)) {
	
			$this->aUser = UserPeer::retrieveByPK($this->user_id, $con);
	
			/* The following can be used instead of the line above to
			   guarantee the related object contains a reference
			   to this object, but this level of coupling
			   may be undesirable in many circumstances.
			   As it can lead to a db query with many results that may
			   never be used.
			   $obj = UserPeer::retrieveByPK($this->user_id, $con);
			   $obj->addNotificationQueues($this);
			 */
		}
		return $this->aUser;
	}

	/**
	 * Provides convenient way to set a relationship based on a
	 * key.  e.g.
	 * <code>$bar->setFooKey($foo->getPrimaryKey())</code>
	 *
 
	 * @return void
	 * @throws PropelException
	 */
	public function setUserKey($key)
	{

		$this->setUserId( (int) $key);			
		
	}

	/**
	 * @var Notification	  
	 */
	protected $aNotification;

	/**
	 * Declares an association between this object and a Notification object
	 *
	 * @param Notification $v
	 * @return void
	 * @throws PropelException
	 */
	public function setNotification($v)
	{
			
		if ($v === null) {
			$this->setNotificationId('null');
		} else {
			$this->setNotificationId($v->getNotificationId());
		}
   
		$this->aNotification = $v;
	}


	/**
	 * Get the associated Notification object
	 *
	 * @param Connection Optional Connection object.
	 * @return Notification The associated Notification object.
	 * @throws PropelException
	 */
	public function getNotification($con = null)
	{
		// include the Peer class
		include_once 'core/NotificationPeer.php';

		if ($this->aNotification === null && ($this->notification_id !== null)) {
	
			$this->aNotification = NotificationPeer::retrieveByPK($this->notification_id, $con);
	
			/* The following can be used instead of the line above to
			   guarantee the related object contains a reference
			   to this object, but this level of coupling
			   may be undesirable in many circumstances.
			   As it can lead to a db query with many results that may
			   never be used.
			   $obj = NotificationPeer::retrieveByPK($this->notification_id, $con);
			   $obj->addNotificationQueues($this);
			 */
		}
		return $this->aNotification;
	}

	/**
	 * Provides convenient way to set a relationship based on a
	 * key.  e.g.
	 * <code>$bar->setFooKey($foo->getPrimaryKey())</code>
	 *
 
	 * @return void
	 * @throws PropelException
	 */
	public function setNotificationKey($key)
	{

		$this->setNotificationId( (int) $key);			
		
	}

	private $fieldNames;

	/**
	 * Generate a list of field names.
	 *
	 * @return array A list of field names
	 */
	public function getFieldNames()
	{
		if ($this->fieldNames === null) {
			$this->fieldNames = array("notification_queue_id", "section", "ref_id", "user_id", "subject", "body", "queue_date", "send_date", "message_id", "in_reply_to", "ref_message", "notification_id", );
		}
		return $this->fieldNames;
	}
	
	/**
	 * Retrieves a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @return mixed Value of field.
	 */
	public function getByName($name)
	{
		switch($name) {
	  
			case NotificationQueuePeer::NOTIFICATION_QUEUE_ID:
				return $this->getNotificationQueueId();
				break;
		  
			case NotificationQueuePeer::SECTION:
				return $this->getSection();
				break;
		  
			case NotificationQueuePeer::REF_ID:
				return $this->getRefId();
				break;
		  
			case NotificationQueuePeer::USER_ID:
				return $this->getUserId();
				break;
		  
			case NotificationQueuePeer::SUBJECT:
				return $this->getSubject();
				break;
		  
			case NotificationQueuePeer::BODY:
				return $this->getBody();
				break;
		  
			case NotificationQueuePeer::QUEUE_DATE:
				return $this->getQueueDate();
				break;
		  
			case NotificationQueuePeer::SEND_DATE:
				return $this->getSendDate();
				break;
		  
			case NotificationQueuePeer::MESSAGE_ID:
				return $this->getMessageId();
				break;
		  
			case NotificationQueuePeer::IN_REPLY_TO:
				return $this->getInReplyTo();
				break;
		  
			case NotificationQueuePeer::REF_MESSAGE:
				return $this->getRefMessage();
				break;
		  
			case NotificationQueuePeer::NOTIFICATION_ID:
				return $this->getNotificationId();
				break;
	  
			default:
				return null;
				
		} // switch()
	}

	/**
	 * Retrieves a field from the object by Position as specified in the xml schema. 
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @return mixed Value of field at $pos
	 */
	public function getByPosition($pos)
	{
		switch($pos) {
  
			case 0:
				return $this->getNotificationQueueId();
				break;
  
			case 1:
				return $this->getSection();
				break;
  
			case 2:
				return $this->getRefId();
				break;
  
			case 3:
				return $this->getUserId();
				break;
  
			case 4:
				return $this->getSubject();
				break;
  
			case 5:
				return $this->getBody();
				break;
  
			case 6:
				return $this->getQueueDate();
				break;
  
			case 7:
				return $this->getSendDate();
				break;
  
			case 8:
				return $this->getMessageId();
				break;
  
			case 9:
				return $this->getInReplyTo();
				break;
  
			case 10:
				return $this->getRefMessage();
				break;
  
			case 11:
				return $this->getNotificationId();
				break;
			default:
				return null;
		} // switch()
	}



	
	/**
	 * Convenience method to populate the object using an array.
	 * This is particularly useful when populating an object from one of the request arrays (e.g. $_POST).  This method
	 * goest through the column (peer) names, checking to see whether a matching key exists in populated array. If
	 * so the setByName() method is called for that column.
	 * @param array $arr An array where keys are column names.
	 * @return void
	 */
	public function populateFromArray($arr)
	{
  
		if (array_key_exists(NotificationQueuePeer::NOTIFICATION_QUEUE_ID, $arr)) $this->setNotificationQueueId($arr[NotificationQueuePeer::NOTIFICATION_QUEUE_ID]);
  
		if (array_key_exists(NotificationQueuePeer::SECTION, $arr)) $this->setSection($arr[NotificationQueuePeer::SECTION]);
  
		if (array_key_exists(NotificationQueuePeer::REF_ID, $arr)) $this->setRefId($arr[NotificationQueuePeer::REF_ID]);
  
		if (array_key_exists(NotificationQueuePeer::USER_ID, $arr)) $this->setUserId($arr[NotificationQueuePeer::USER_ID]);
  
		if (array_key_exists(NotificationQueuePeer::SUBJECT, $arr)) $this->setSubject($arr[NotificationQueuePeer::SUBJECT]);
  
		if (array_key_exists(NotificationQueuePeer::BODY, $arr)) $this->setBody($arr[NotificationQueuePeer::BODY]);
  
		if (array_key_exists(NotificationQueuePeer::QUEUE_DATE, $arr)) $this->setQueueDate($arr[NotificationQueuePeer::QUEUE_DATE]);
  
		if (array_key_exists(NotificationQueuePeer::SEND_DATE, $arr)) $this->setSendDate($arr[NotificationQueuePeer::SEND_DATE]);
  
		if (array_key_exists(NotificationQueuePeer::MESSAGE_ID, $arr)) $this->setMessageId($arr[NotificationQueuePeer::MESSAGE_ID]);
  
		if (array_key_exists(NotificationQueuePeer::IN_REPLY_TO, $arr)) $this->setInReplyTo($arr[NotificationQueuePeer::IN_REPLY_TO]);
  
		if (array_key_exists(NotificationQueuePeer::REF_MESSAGE, $arr)) $this->setRefMessage($arr[NotificationQueuePeer::REF_MESSAGE]);
  
		if (array_key_exists(NotificationQueuePeer::NOTIFICATION_ID, $arr)) $this->setNotificationId($arr[NotificationQueuePeer::NOTIFICATION_ID]);
 
	}
	
	/**
	 * Sets a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByName($name, $value)
	{
		switch($name) {
	  
			case NotificationQueuePeer::NOTIFICATION_QUEUE_ID:
				$this->setNotificationQueueId($value);
				break;
	  
			case NotificationQueuePeer::SECTION:
				$this->setSection($value);
				break;
	  
			case NotificationQueuePeer::REF_ID:
				$this->setRefId($value);
				break;
	  
			case NotificationQueuePeer::USER_ID:
				$this->setUserId($value);
				break;
	  
			case NotificationQueuePeer::SUBJECT:
				$this->setSubject($value);
				break;
	  
			case NotificationQueuePeer::BODY:
				$this->setBody($value);
				break;
	  
			case NotificationQueuePeer::QUEUE_DATE:
				$this->setQueueDate($value);
				break;
	  
			case NotificationQueuePeer::SEND_DATE:
				$this->setSendDate($value);
				break;
	  
			case NotificationQueuePeer::MESSAGE_ID:
				$this->setMessageId($value);
				break;
	  
			case NotificationQueuePeer::IN_REPLY_TO:
				$this->setInReplyTo($value);
				break;
	  
			case NotificationQueuePeer::REF_MESSAGE:
				$this->setRefMessage($value);
				break;
	  
			case NotificationQueuePeer::NOTIFICATION_ID:
				$this->setNotificationId($value);
				break;
				  
		} // switch()
	}

	/**
	 * Sets a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByPosition($pos, $value)
	{
		switch($pos) {
  
			case 0:
				$this->setNotificationQueueId($value);
				break;
  
			case 1:
				$this->setSection($value);
				break;
  
			case 2:
				$this->setRefId($value);
				break;
  
			case 3:
				$this->setUserId($value);
				break;
  
			case 4:
				$this->setSubject($value);
				break;
  
			case 5:
				$this->setBody($value);
				break;
  
			case 6:
				$this->setQueueDate($value);
				break;
  
			case 7:
				$this->setSendDate($value);
				break;
  
			case 8:
				$this->setMessageId($value);
				break;
  
			case 9:
				$this->setInReplyTo($value);
				break;
  
			case 10:
				$this->setRefMessage($value);
				break;
  
			case 11:
				$this->setNotificationId($value);
				break;
		} // switch()
	}


 
	/**
	 * Removes this object from datastore and sets delete attribute.
	 * 
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 * @see BaseObject::setDeleted()
	 * @see BaseObject::isDeleted()
	 */
	public function delete($con = null)
	{	
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}
		
		if ($con === null)
			$con = Propel::getConnection(NotificationQueuePeer::DATABASE_NAME);

		try {
			$con->begin();
			NotificationQueuePeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
	

	/**
	 * flag to prevent endless save loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	private $alreadyInSave = false;

	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.  This method
	 * wraps the doSave() worker method in a transaction.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
	public function save($con = null)
	{
		if ($this->isDeleted()) {
		//	throw new PropelException("You cannot save an object that has been deleted.");
			return;
		}
		
		if ($con === null)
			$con = Propel::getConnection(NotificationQueuePeer::DATABASE_NAME);

		try {
			$con->begin();
			$this->doSave($con);			
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
  
	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
		protected function doSave($con)	{ 
		
	 
		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;

			// We call the save method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.
 
			if ($this->aUser !== null) {
				if ($this->aUser->isModified()) $this->aUser->save($con);
				$this->setUser($this->aUser);
			}
 
			if ($this->aNotification !== null) {
				if ($this->aNotification->isModified()) $this->aNotification->save($con);
				$this->setNotification($this->aNotification);
			}

			// If this object has been modified, then save it to the database.
			if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = NotificationQueuePeer::doInsert($this, $con);
					$this->setNotificationQueueId( $pk );  //[IMV] update autoincrement primary key
					$this->setNew(false);
				} else {
					NotificationQueuePeer::doUpdate($this, $con);
				}			
				$this->resetModified(); // [HL] After being saved an object is no longer 'modified'
			}

			$this->alreadyInSave = false;
		}
	}

	/**
	 * Validates the objects modified field values.
	 * This includes all objects related to this table.
	 *
	 * If $columns is either a column name or an array of column names
	 * only those columns are validated.
	 *
	 * @param mixed $columns Column name or an array of column names.
	 *
	 * @return mixed <code>true</code> if all columns pass validation
	 *			  or an array of <code>ValidationFailed</code> objects for columns that fail.
	 */
	public function validate($columns = null)
	{
	  if ($columns)
	  {
		return NotificationQueuePeer::doValidate($this, $columns);
	  }

		return $this->doValidate();
	}

	/**
	 * flag to prevent endless validation loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	protected $alreadyInValidation = false;
  
	/**
	 * This function performs the validation work for complex object models.
	 * 
	 * In addition to checking the current object, all related objects will
	 * also be validated.  If all pass then <code>true</code> is returned; otherwise
	 * an aggreagated array of ValidationFailed objects will be returned.
	 *
	 * @return mixed <code>true</code> if all validations pass; array of <code>ValidationFailed</code> objets otherwise.
	 */
	protected function doValidate()
	{
		if (! $this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;
	  
			$failureMap = array();	  
	  
			// We call the validate method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.
			if ($this->aUser !== null) {
				if (($retval = $this->aUser->validate()) !== true) {
					$failureMap = array_merge($failureMap, $retval);
				}
			}
			if ($this->aNotification !== null) {
				if (($retval = $this->aNotification->validate()) !== true) {
					$failureMap = array_merge($failureMap, $retval);
				}
			}

			if (($retval = NotificationQueuePeer::doValidate($this)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}
	  
	  
			$this->alreadyInValidation = false;
		}
	
		return (!empty($failureMap) ? $failureMap : true);
	}
  

	/**
	 * Set the PrimaryKey.
	 *
	 * @param mixed notification_queue_id Primary key.
	 * @return void
	 * @throws PropelException	 */
	public function setPrimaryKey($key) 
	{		
		$this->setNotificationQueueId($key);
	}
	

	/**
	 * Returns an id that differentiates this object from others
	 * of its class.
	 * @return int 
	 */
	public function getPrimaryKey()
	{

		return $this->getNotificationQueueId();

	}

	
	/**
	 * Makes a copy of this object that will be inserted as a new row in table when saved.
	 * It creates a new object filling in the simple attributes, but skipping any primary
	 * keys that are defined for the table.
	 *  
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 *  
	 * @return NotificationQueue Clone of current object.
	 * @throws PropelException
	 */
	public function copy($deepCopy = false) 
	{
		$copyObj = new NotificationQueue();
		$copyObj->setSection($this->section);
		$copyObj->setRefId($this->ref_id);
		$copyObj->setUserId($this->user_id);
		$copyObj->setSubject($this->subject);
		$copyObj->setBody($this->body);
		$copyObj->setQueueDate($this->queue_date);
		$copyObj->setSendDate($this->send_date);
		$copyObj->setMessageId($this->message_id);
		$copyObj->setInReplyTo($this->in_reply_to);
		$copyObj->setRefMessage($this->ref_message);
		$copyObj->setNotificationId($this->notification_id);
		
		$copyObj->setNew(true);
		
		$copyObj->setNotificationQueueId(NULL); // this is a pkey column, so set to default value

		return $copyObj;
	}
		

	/**
	 * returns a peer instance associated with this om.  Since Peer classes	
	 * are not to have any instance attributes, this method returns the
	 * same instance for all member of this class. The method could therefore
	 * be static, but this would prevent one from overriding the behavior.
	 * @return NotificationQueuePeer
	 */
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new NotificationQueuePeer();
		}
		return self::$peer;
	}

}
