<?php 

require_once 'propel/om/BaseObject.php';

 
require_once 'propel/om/Persistent.php';

 

include_once 'propel/util/Criteria.php';
 

// (on-demand) include_once 'core/Plugin.php';
// (on-demand) include_once 'core/PluginPeer.php';
 

// (on-demand) include_once 'core/Plugin.php';
// (on-demand) include_once 'core/PluginPeer.php';

include_once 'core/PluginDependencyPeer.php';

/**
 * Base class that represents a row from the 'plugin_dependency' table.
 *
 *  
 *
 * You should not use this class directly.  It should not even be
 * extended; all references should be to PluginDependency class. 
 * 
 * @package core 
 */
abstract class BasePluginDependency extends BaseObject implements Persistent {
	
	/** 
	 * The Peer class.
	 * Instance provides a convenient way of calling static methods on a class
	 * that calling code may not be able to identify.
	 * @var PluginDependencyPeer
	 */
	protected static $peer;

	/**
	 * The value for the plugin_dependency_id field.
	 * @var int	  
	 */
	protected $plugin_dependency_id;	

	/**
	 * The value for the plugin_id field.
	 * @var int	  
	 */
	protected $plugin_id;	

	/**
	 * The value for the dependson_plugin_id field.
	 * @var int	  
	 */
	protected $dependson_plugin_id;	
  
	/**
	 * Get the PluginDependencyId column value.
	 *  
	 * @return int	  
	 */
	public function getPluginDependencyId()
	{
		return $this->plugin_dependency_id;
	}


	/**
	 * Set the value of `plugin_dependency_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 *  
	 */
	public function setPluginDependencyId($v)
	{
		if ($this->plugin_dependency_id !== $v) {
			$this->plugin_dependency_id = $v;
			$this->modifiedColumns[] = PluginDependencyPeer::PLUGIN_DEPENDENCY_ID;
		}
				
	}

  
	/**
	 * Get the PluginId column value.
	 *  
	 * @return int	  
	 */
	public function getPluginId()
	{
		return $this->plugin_id;
	}


	/**
	 * Set the value of `plugin_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setPluginId($v)
	{
		if ($this->plugin_id !== $v) {
			$this->plugin_id = $v;
			$this->modifiedColumns[] = PluginDependencyPeer::PLUGIN_ID;
		}
			
		if ($this->aPluginRelatedByPluginId !== null && $this->aPluginRelatedByPluginId->getPluginId() !== $v) {
			$this->aPluginRelatedByPluginId = null;
		}
			
	}

  
	/**
	 * Get the DependsonPluginId column value.
	 *  
	 * @return int	  
	 */
	public function getDependsonPluginId()
	{
		return $this->dependson_plugin_id;
	}


	/**
	 * Set the value of `dependson_plugin_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setDependsonPluginId($v)
	{
		if ($this->dependson_plugin_id !== $v) {
			$this->dependson_plugin_id = $v;
			$this->modifiedColumns[] = PluginDependencyPeer::DEPENDSON_PLUGIN_ID;
		}
			
		if ($this->aPluginRelatedByDependsonPluginId !== null && $this->aPluginRelatedByDependsonPluginId->getPluginId() !== $v) {
			$this->aPluginRelatedByDependsonPluginId = null;
		}
			
	}


	
	/**
	 * Hydrates (populates) the object variables with values from the database resultset.
	 *
	 * An offset (1-based "start column") is specified so that objects can be hydrated
	 * with a subset of the columns in the resultset rows.  This is needed, for example,
	 * for results of JOIN queries where the resultset row includes columns from two or
	 * more tables.
	 *
	 * @param ResultSet $rs The ResultSet class with cursor advanced to desired record pos.
	 * @param int $startcol 1-based offset column which indicates which restultset column to start with.
	 * @return void
	 * @throws PropelException  - Any caught Exception will be rewrapped as a PropelException.
	 */
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {
			$this->plugin_dependency_id = $rs->getInt($startcol + 0);					
			$this->plugin_id = $rs->getInt($startcol + 1);					
			$this->dependson_plugin_id = $rs->getInt($startcol + 2);					
			 
			$this->resetModified();
			$this->setNew(false);
		
		} catch (Exception $e) {
			throw new PropelException("Error populating PluginDependency object", $e);
		}		
	
	}
	
	/**
	 * Builds a Criteria object containing the primary key for this object.
	 *
	 * Unlike buildCriteria() this method includes the primary key values regardless
	 * of whether or not they have been modified.
	 * 
	 * @return Criteria The Criteria object containing value(s) for primary key(s).
	 */
	public function buildPkeyCriteria()
	{		
		$criteria = new Criteria(PluginDependencyPeer::DATABASE_NAME);
		$criteria->add(PluginDependencyPeer::PLUGIN_DEPENDENCY_ID, $this->plugin_dependency_id);
		return $criteria;			
	}
	
	/**
	 * Build a Criteria object containing the values of all modified columns in this object.
	 *
	 * @return Criteria The Criteria object containing all modified values.
	 */
	public function buildCriteria()
	{		
		$criteria = new Criteria(PluginDependencyPeer::DATABASE_NAME);
		if ($this->isColumnModified(PluginDependencyPeer::PLUGIN_DEPENDENCY_ID)) $criteria->add(PluginDependencyPeer::PLUGIN_DEPENDENCY_ID, $this->plugin_dependency_id);
		if ($this->isColumnModified(PluginDependencyPeer::PLUGIN_ID)) $criteria->add(PluginDependencyPeer::PLUGIN_ID, $this->plugin_id);
		if ($this->isColumnModified(PluginDependencyPeer::DEPENDSON_PLUGIN_ID)) $criteria->add(PluginDependencyPeer::DEPENDSON_PLUGIN_ID, $this->dependson_plugin_id);
		return $criteria;			
	}
	
	

	/**
	 * @var Plugin	  
	 */
	protected $aPluginRelatedByDependsonPluginId;

	/**
	 * Declares an association between this object and a Plugin object
	 *
	 * @param Plugin $v
	 * @return void
	 * @throws PropelException
	 */
	public function setPluginRelatedByDependsonPluginId($v)
	{
			
		if ($v === null) {
			$this->setDependsonPluginId(NULL);
		} else {
			$this->setDependsonPluginId($v->getPluginId());
		}
   
		$this->aPluginRelatedByDependsonPluginId = $v;
	}


	/**
	 * Get the associated Plugin object
	 *
	 * @param Connection Optional Connection object.
	 * @return Plugin The associated Plugin object.
	 * @throws PropelException
	 */
	public function getPluginRelatedByDependsonPluginId($con = null)
	{
		// include the Peer class
		include_once 'core/PluginPeer.php';

		if ($this->aPluginRelatedByDependsonPluginId === null && ($this->dependson_plugin_id !== null)) {
	
			$this->aPluginRelatedByDependsonPluginId = PluginPeer::retrieveByPK($this->dependson_plugin_id, $con);
	
			/* The following can be used instead of the line above to
			   guarantee the related object contains a reference
			   to this object, but this level of coupling
			   may be undesirable in many circumstances.
			   As it can lead to a db query with many results that may
			   never be used.
			   $obj = PluginPeer::retrieveByPK($this->dependson_plugin_id, $con);
			   $obj->addPluginDependencysRelatedByDependsonPluginId($this);
			 */
		}
		return $this->aPluginRelatedByDependsonPluginId;
	}

	/**
	 * Provides convenient way to set a relationship based on a
	 * key.  e.g.
	 * <code>$bar->setFooKey($foo->getPrimaryKey())</code>
	 *
 
	 * @return void
	 * @throws PropelException
	 */
	public function setPluginRelatedByDependsonPluginIdKey($key)
	{

		$this->setDependsonPluginId( (int) $key);			
		
	}

	/**
	 * @var Plugin	  
	 */
	protected $aPluginRelatedByPluginId;

	/**
	 * Declares an association between this object and a Plugin object
	 *
	 * @param Plugin $v
	 * @return void
	 * @throws PropelException
	 */
	public function setPluginRelatedByPluginId($v)
	{
			
		if ($v === null) {
			$this->setPluginId(NULL);
		} else {
			$this->setPluginId($v->getPluginId());
		}
   
		$this->aPluginRelatedByPluginId = $v;
	}


	/**
	 * Get the associated Plugin object
	 *
	 * @param Connection Optional Connection object.
	 * @return Plugin The associated Plugin object.
	 * @throws PropelException
	 */
	public function getPluginRelatedByPluginId($con = null)
	{
		// include the Peer class
		include_once 'core/PluginPeer.php';

		if ($this->aPluginRelatedByPluginId === null && ($this->plugin_id !== null)) {
	
			$this->aPluginRelatedByPluginId = PluginPeer::retrieveByPK($this->plugin_id, $con);
	
			/* The following can be used instead of the line above to
			   guarantee the related object contains a reference
			   to this object, but this level of coupling
			   may be undesirable in many circumstances.
			   As it can lead to a db query with many results that may
			   never be used.
			   $obj = PluginPeer::retrieveByPK($this->plugin_id, $con);
			   $obj->addPluginDependencysRelatedByPluginId($this);
			 */
		}
		return $this->aPluginRelatedByPluginId;
	}

	/**
	 * Provides convenient way to set a relationship based on a
	 * key.  e.g.
	 * <code>$bar->setFooKey($foo->getPrimaryKey())</code>
	 *
 
	 * @return void
	 * @throws PropelException
	 */
	public function setPluginRelatedByPluginIdKey($key)
	{

		$this->setPluginId( (int) $key);			
		
	}

	private $fieldNames;

	/**
	 * Generate a list of field names.
	 *
	 * @return array A list of field names
	 */
	public function getFieldNames()
	{
		if ($this->fieldNames === null) {
			$this->fieldNames = array("plugin_dependency_id", "plugin_id", "dependson_plugin_id", );
		}
		return $this->fieldNames;
	}
	
	/**
	 * Retrieves a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @return mixed Value of field.
	 */
	public function getByName($name)
	{
		switch($name) {
	  
			case PluginDependencyPeer::PLUGIN_DEPENDENCY_ID:
				return $this->getPluginDependencyId();
				break;
		  
			case PluginDependencyPeer::PLUGIN_ID:
				return $this->getPluginId();
				break;
		  
			case PluginDependencyPeer::DEPENDSON_PLUGIN_ID:
				return $this->getDependsonPluginId();
				break;
	  
			default:
				return null;
				
		} // switch()
	}

	/**
	 * Retrieves a field from the object by Position as specified in the xml schema. 
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @return mixed Value of field at $pos
	 */
	public function getByPosition($pos)
	{
		switch($pos) {
  
			case 0:
				return $this->getPluginDependencyId();
				break;
  
			case 1:
				return $this->getPluginId();
				break;
  
			case 2:
				return $this->getDependsonPluginId();
				break;
			default:
				return null;
		} // switch()
	}



	
	/**
	 * Convenience method to populate the object using an array.
	 * This is particularly useful when populating an object from one of the request arrays (e.g. $_POST).  This method
	 * goest through the column (peer) names, checking to see whether a matching key exists in populated array. If
	 * so the setByName() method is called for that column.
	 * @param array $arr An array where keys are column names.
	 * @return void
	 */
	public function populateFromArray($arr)
	{
  
		if (array_key_exists(PluginDependencyPeer::PLUGIN_DEPENDENCY_ID, $arr)) $this->setPluginDependencyId($arr[PluginDependencyPeer::PLUGIN_DEPENDENCY_ID]);
  
		if (array_key_exists(PluginDependencyPeer::PLUGIN_ID, $arr)) $this->setPluginId($arr[PluginDependencyPeer::PLUGIN_ID]);
  
		if (array_key_exists(PluginDependencyPeer::DEPENDSON_PLUGIN_ID, $arr)) $this->setDependsonPluginId($arr[PluginDependencyPeer::DEPENDSON_PLUGIN_ID]);
 
	}
	
	/**
	 * Sets a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByName($name, $value)
	{
		switch($name) {
	  
			case PluginDependencyPeer::PLUGIN_DEPENDENCY_ID:
				$this->setPluginDependencyId($value);
				break;
	  
			case PluginDependencyPeer::PLUGIN_ID:
				$this->setPluginId($value);
				break;
	  
			case PluginDependencyPeer::DEPENDSON_PLUGIN_ID:
				$this->setDependsonPluginId($value);
				break;
				  
		} // switch()
	}

	/**
	 * Sets a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByPosition($pos, $value)
	{
		switch($pos) {
  
			case 0:
				$this->setPluginDependencyId($value);
				break;
  
			case 1:
				$this->setPluginId($value);
				break;
  
			case 2:
				$this->setDependsonPluginId($value);
				break;
		} // switch()
	}


 
	/**
	 * Removes this object from datastore and sets delete attribute.
	 * 
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 * @see BaseObject::setDeleted()
	 * @see BaseObject::isDeleted()
	 */
	public function delete($con = null)
	{	
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}
		
		if ($con === null)
			$con = Propel::getConnection(PluginDependencyPeer::DATABASE_NAME);

		try {
			$con->begin();
			PluginDependencyPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
	

	/**
	 * flag to prevent endless save loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	private $alreadyInSave = false;

	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.  This method
	 * wraps the doSave() worker method in a transaction.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
	public function save($con = null)
	{
		if ($this->isDeleted()) {
		//	throw new PropelException("You cannot save an object that has been deleted.");
			return;
		}
		
		if ($con === null)
			$con = Propel::getConnection(PluginDependencyPeer::DATABASE_NAME);

		try {
			$con->begin();
			$this->doSave($con);			
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
  
	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
		protected function doSave($con)	{ 
		
	 
		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;

			// We call the save method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.
 
			if ($this->aPluginRelatedByDependsonPluginId !== null) {
				if ($this->aPluginRelatedByDependsonPluginId->isModified()) $this->aPluginRelatedByDependsonPluginId->save($con);
				$this->setPluginRelatedByDependsonPluginId($this->aPluginRelatedByDependsonPluginId);
			}
 
			if ($this->aPluginRelatedByPluginId !== null) {
				if ($this->aPluginRelatedByPluginId->isModified()) $this->aPluginRelatedByPluginId->save($con);
				$this->setPluginRelatedByPluginId($this->aPluginRelatedByPluginId);
			}

			// If this object has been modified, then save it to the database.
			if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = PluginDependencyPeer::doInsert($this, $con);
					$this->setPluginDependencyId( $pk );  //[IMV] update autoincrement primary key
					$this->setNew(false);
				} else {
					PluginDependencyPeer::doUpdate($this, $con);
				}			
				$this->resetModified(); // [HL] After being saved an object is no longer 'modified'
			}

			$this->alreadyInSave = false;
		}
	}

	/**
	 * Validates the objects modified field values.
	 * This includes all objects related to this table.
	 *
	 * If $columns is either a column name or an array of column names
	 * only those columns are validated.
	 *
	 * @param mixed $columns Column name or an array of column names.
	 *
	 * @return mixed <code>true</code> if all columns pass validation
	 *			  or an array of <code>ValidationFailed</code> objects for columns that fail.
	 */
	public function validate($columns = null)
	{
	  if ($columns)
	  {
		return PluginDependencyPeer::doValidate($this, $columns);
	  }

		return $this->doValidate();
	}

	/**
	 * flag to prevent endless validation loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	protected $alreadyInValidation = false;
  
	/**
	 * This function performs the validation work for complex object models.
	 * 
	 * In addition to checking the current object, all related objects will
	 * also be validated.  If all pass then <code>true</code> is returned; otherwise
	 * an aggreagated array of ValidationFailed objects will be returned.
	 *
	 * @return mixed <code>true</code> if all validations pass; array of <code>ValidationFailed</code> objets otherwise.
	 */
	protected function doValidate()
	{
		if (! $this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;
	  
			$failureMap = array();	  
	  
			// We call the validate method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.
			if ($this->aPluginRelatedByDependsonPluginId !== null) {
				if (($retval = $this->aPluginRelatedByDependsonPluginId->validate()) !== true) {
					$failureMap = array_merge($failureMap, $retval);
				}
			}
			if ($this->aPluginRelatedByPluginId !== null) {
				if (($retval = $this->aPluginRelatedByPluginId->validate()) !== true) {
					$failureMap = array_merge($failureMap, $retval);
				}
			}

			if (($retval = PluginDependencyPeer::doValidate($this)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}
	  
	  
			$this->alreadyInValidation = false;
		}
	
		return (!empty($failureMap) ? $failureMap : true);
	}
  

	/**
	 * Set the PrimaryKey.
	 *
	 * @param mixed plugin_dependency_id Primary key.
	 * @return void
	 * @throws PropelException	 */
	public function setPrimaryKey($key) 
	{		
		$this->setPluginDependencyId($key);
	}
	

	/**
	 * Returns an id that differentiates this object from others
	 * of its class.
	 * @return int 
	 */
	public function getPrimaryKey()
	{

		return $this->getPluginDependencyId();

	}

	
	/**
	 * Makes a copy of this object that will be inserted as a new row in table when saved.
	 * It creates a new object filling in the simple attributes, but skipping any primary
	 * keys that are defined for the table.
	 *  
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 *  
	 * @return PluginDependency Clone of current object.
	 * @throws PropelException
	 */
	public function copy($deepCopy = false) 
	{
		$copyObj = new PluginDependency();
		$copyObj->setPluginId($this->plugin_id);
		$copyObj->setDependsonPluginId($this->dependson_plugin_id);
		
		$copyObj->setNew(true);
		
		$copyObj->setPluginDependencyId(NULL); // this is a pkey column, so set to default value

		return $copyObj;
	}
		

	/**
	 * returns a peer instance associated with this om.  Since Peer classes	
	 * are not to have any instance attributes, this method returns the
	 * same instance for all member of this class. The method could therefore
	 * be static, but this would prevent one from overriding the behavior.
	 * @return PluginDependencyPeer
	 */
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new PluginDependencyPeer();
		}
		return self::$peer;
	}

}
