<?php 

require_once 'propel/om/BaseObject.php';

 
require_once 'propel/om/Persistent.php';

 

include_once 'propel/util/Criteria.php';
 

// (on-demand) include_once 'core/TroveCategory.php';
// (on-demand) include_once 'core/TroveCategoryPeer.php';

include_once 'core/TroveLinkPeer.php';

/**
 * Base class that represents a row from the 'trove_link' table.
 *
 *  
 *
 * You should not use this class directly.  It should not even be
 * extended; all references should be to TroveLink class. 
 * 
 * @package core 
 */
abstract class BaseTroveLink extends BaseObject implements Persistent {
	
	/** 
	 * The Peer class.
	 * Instance provides a convenient way of calling static methods on a class
	 * that calling code may not be able to identify.
	 * @var TroveLinkPeer
	 */
	protected static $peer;

	/**
	 * The value for the section field.
	 * @var string	  
	 */
	protected $section;	

	/**
	 * The value for the ref_id field.
	 * @var int	  
	 */
	protected $ref_id;	

	/**
	 * The value for the trove_category_id field.
	 * @var int	  
	 */
	protected $trove_category_id;	
  
	/**
	 * Get the Section column value.
	 *  
	 * @return string	  
	 */
	public function getSection()
	{
		return $this->section;
	}


	/**
	 * Set the value of `section` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setSection($v)
	{
		if ($this->section !== $v) {
			$this->section = $v;
			$this->modifiedColumns[] = TroveLinkPeer::SECTION;
		}
				
	}

  
	/**
	 * Get the RefId column value.
	 *  
	 * @return int	  
	 */
	public function getRefId()
	{
		return $this->ref_id;
	}


	/**
	 * Set the value of `ref_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 *  
	 */
	public function setRefId($v)
	{
		if ($this->ref_id !== $v) {
			$this->ref_id = $v;
			$this->modifiedColumns[] = TroveLinkPeer::REF_ID;
		}
				
	}

  
	/**
	 * Get the TroveCategoryId column value.
	 *  
	 * @return int	  
	 */
	public function getTroveCategoryId()
	{
		return $this->trove_category_id;
	}


	/**
	 * Set the value of `trove_category_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setTroveCategoryId($v)
	{
		if ($this->trove_category_id !== $v) {
			$this->trove_category_id = $v;
			$this->modifiedColumns[] = TroveLinkPeer::TROVE_CATEGORY_ID;
		}
			
		if ($this->aTroveCategory !== null && $this->aTroveCategory->getTroveCategoryId() !== $v) {
			$this->aTroveCategory = null;
		}
			
	}


	
	/**
	 * Hydrates (populates) the object variables with values from the database resultset.
	 *
	 * An offset (1-based "start column") is specified so that objects can be hydrated
	 * with a subset of the columns in the resultset rows.  This is needed, for example,
	 * for results of JOIN queries where the resultset row includes columns from two or
	 * more tables.
	 *
	 * @param ResultSet $rs The ResultSet class with cursor advanced to desired record pos.
	 * @param int $startcol 1-based offset column which indicates which restultset column to start with.
	 * @return void
	 * @throws PropelException  - Any caught Exception will be rewrapped as a PropelException.
	 */
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {
			$this->section = $rs->getString($startcol + 0);					
			$this->ref_id = $rs->getInt($startcol + 1);					
			$this->trove_category_id = $rs->getInt($startcol + 2);					
			 
			$this->resetModified();
			$this->setNew(false);
		
		} catch (Exception $e) {
			throw new PropelException("Error populating TroveLink object", $e);
		}		
	
	}
	
	/**
	 * Builds a Criteria object containing the primary key for this object.
	 *
	 * Unlike buildCriteria() this method includes the primary key values regardless
	 * of whether or not they have been modified.
	 * 
	 * @return Criteria The Criteria object containing value(s) for primary key(s).
	 */
	public function buildPkeyCriteria()
	{		
		$criteria = new Criteria(TroveLinkPeer::DATABASE_NAME);
		$criteria->add(TroveLinkPeer::SECTION, $this->section);
		$criteria->add(TroveLinkPeer::REF_ID, $this->ref_id);
		$criteria->add(TroveLinkPeer::TROVE_CATEGORY_ID, $this->trove_category_id);
		return $criteria;			
	}
	
	/**
	 * Build a Criteria object containing the values of all modified columns in this object.
	 *
	 * @return Criteria The Criteria object containing all modified values.
	 */
	public function buildCriteria()
	{		
		$criteria = new Criteria(TroveLinkPeer::DATABASE_NAME);
		if ($this->isColumnModified(TroveLinkPeer::SECTION)) $criteria->add(TroveLinkPeer::SECTION, $this->section);
		if ($this->isColumnModified(TroveLinkPeer::REF_ID)) $criteria->add(TroveLinkPeer::REF_ID, $this->ref_id);
		if ($this->isColumnModified(TroveLinkPeer::TROVE_CATEGORY_ID)) $criteria->add(TroveLinkPeer::TROVE_CATEGORY_ID, $this->trove_category_id);
		return $criteria;			
	}
	
	

	/**
	 * @var TroveCategory	  
	 */
	protected $aTroveCategory;

	/**
	 * Declares an association between this object and a TroveCategory object
	 *
	 * @param TroveCategory $v
	 * @return void
	 * @throws PropelException
	 */
	public function setTroveCategory($v)
	{
			
		if ($v === null) {
			$this->setTroveCategoryId(NULL);
		} else {
			$this->setTroveCategoryId($v->getTroveCategoryId());
		}
   
		$this->aTroveCategory = $v;
	}


	/**
	 * Get the associated TroveCategory object
	 *
	 * @param Connection Optional Connection object.
	 * @return TroveCategory The associated TroveCategory object.
	 * @throws PropelException
	 */
	public function getTroveCategory($con = null)
	{
		// include the Peer class
		include_once 'core/TroveCategoryPeer.php';

		if ($this->aTroveCategory === null && ($this->trove_category_id !== null)) {
	
			$this->aTroveCategory = TroveCategoryPeer::retrieveByPK($this->trove_category_id, $con);
	
			/* The following can be used instead of the line above to
			   guarantee the related object contains a reference
			   to this object, but this level of coupling
			   may be undesirable in many circumstances.
			   As it can lead to a db query with many results that may
			   never be used.
			   $obj = TroveCategoryPeer::retrieveByPK($this->trove_category_id, $con);
			   $obj->addTroveLinks($this);
			 */
		}
		return $this->aTroveCategory;
	}

	/**
	 * Provides convenient way to set a relationship based on a
	 * key.  e.g.
	 * <code>$bar->setFooKey($foo->getPrimaryKey())</code>
	 *
 
	 * @return void
	 * @throws PropelException
	 */
	public function setTroveCategoryKey($key)
	{

		$this->setTroveCategoryId( (int) $key);			
		
	}

	private $fieldNames;

	/**
	 * Generate a list of field names.
	 *
	 * @return array A list of field names
	 */
	public function getFieldNames()
	{
		if ($this->fieldNames === null) {
			$this->fieldNames = array("section", "ref_id", "trove_category_id", );
		}
		return $this->fieldNames;
	}
	
	/**
	 * Retrieves a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @return mixed Value of field.
	 */
	public function getByName($name)
	{
		switch($name) {
	  
			case TroveLinkPeer::SECTION:
				return $this->getSection();
				break;
		  
			case TroveLinkPeer::REF_ID:
				return $this->getRefId();
				break;
		  
			case TroveLinkPeer::TROVE_CATEGORY_ID:
				return $this->getTroveCategoryId();
				break;
	  
			default:
				return null;
				
		} // switch()
	}

	/**
	 * Retrieves a field from the object by Position as specified in the xml schema. 
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @return mixed Value of field at $pos
	 */
	public function getByPosition($pos)
	{
		switch($pos) {
  
			case 0:
				return $this->getSection();
				break;
  
			case 1:
				return $this->getRefId();
				break;
  
			case 2:
				return $this->getTroveCategoryId();
				break;
			default:
				return null;
		} // switch()
	}



	
	/**
	 * Convenience method to populate the object using an array.
	 * This is particularly useful when populating an object from one of the request arrays (e.g. $_POST).  This method
	 * goest through the column (peer) names, checking to see whether a matching key exists in populated array. If
	 * so the setByName() method is called for that column.
	 * @param array $arr An array where keys are column names.
	 * @return void
	 */
	public function populateFromArray($arr)
	{
  
		if (array_key_exists(TroveLinkPeer::SECTION, $arr)) $this->setSection($arr[TroveLinkPeer::SECTION]);
  
		if (array_key_exists(TroveLinkPeer::REF_ID, $arr)) $this->setRefId($arr[TroveLinkPeer::REF_ID]);
  
		if (array_key_exists(TroveLinkPeer::TROVE_CATEGORY_ID, $arr)) $this->setTroveCategoryId($arr[TroveLinkPeer::TROVE_CATEGORY_ID]);
 
	}
	
	/**
	 * Sets a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByName($name, $value)
	{
		switch($name) {
	  
			case TroveLinkPeer::SECTION:
				$this->setSection($value);
				break;
	  
			case TroveLinkPeer::REF_ID:
				$this->setRefId($value);
				break;
	  
			case TroveLinkPeer::TROVE_CATEGORY_ID:
				$this->setTroveCategoryId($value);
				break;
				  
		} // switch()
	}

	/**
	 * Sets a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByPosition($pos, $value)
	{
		switch($pos) {
  
			case 0:
				$this->setSection($value);
				break;
  
			case 1:
				$this->setRefId($value);
				break;
  
			case 2:
				$this->setTroveCategoryId($value);
				break;
		} // switch()
	}


 
	/**
	 * Removes this object from datastore and sets delete attribute.
	 * 
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 * @see BaseObject::setDeleted()
	 * @see BaseObject::isDeleted()
	 */
	public function delete($con = null)
	{	
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}
		
		if ($con === null)
			$con = Propel::getConnection(TroveLinkPeer::DATABASE_NAME);

		try {
			$con->begin();
			TroveLinkPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
	

	/**
	 * flag to prevent endless save loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	private $alreadyInSave = false;

	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.  This method
	 * wraps the doSave() worker method in a transaction.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
	public function save($con = null)
	{
		if ($this->isDeleted()) {
		//	throw new PropelException("You cannot save an object that has been deleted.");
			return;
		}
		
		if ($con === null)
			$con = Propel::getConnection(TroveLinkPeer::DATABASE_NAME);

		try {
			$con->begin();
			$this->doSave($con);			
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
  
	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
		protected function doSave($con)	{ 
		
	 
		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;

			// We call the save method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.
 
			if ($this->aTroveCategory !== null) {
				if ($this->aTroveCategory->isModified()) $this->aTroveCategory->save($con);
				$this->setTroveCategory($this->aTroveCategory);
			}

			// If this object has been modified, then save it to the database.
			if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = TroveLinkPeer::doInsert($this, $con);
					$this->setNew(false);
				} else {
					TroveLinkPeer::doUpdate($this, $con);
				}			
				$this->resetModified(); // [HL] After being saved an object is no longer 'modified'
			}

			$this->alreadyInSave = false;
		}
	}

	/**
	 * Validates the objects modified field values.
	 * This includes all objects related to this table.
	 *
	 * If $columns is either a column name or an array of column names
	 * only those columns are validated.
	 *
	 * @param mixed $columns Column name or an array of column names.
	 *
	 * @return mixed <code>true</code> if all columns pass validation
	 *			  or an array of <code>ValidationFailed</code> objects for columns that fail.
	 */
	public function validate($columns = null)
	{
	  if ($columns)
	  {
		return TroveLinkPeer::doValidate($this, $columns);
	  }

		return $this->doValidate();
	}

	/**
	 * flag to prevent endless validation loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	protected $alreadyInValidation = false;
  
	/**
	 * This function performs the validation work for complex object models.
	 * 
	 * In addition to checking the current object, all related objects will
	 * also be validated.  If all pass then <code>true</code> is returned; otherwise
	 * an aggreagated array of ValidationFailed objects will be returned.
	 *
	 * @return mixed <code>true</code> if all validations pass; array of <code>ValidationFailed</code> objets otherwise.
	 */
	protected function doValidate()
	{
		if (! $this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;
	  
			$failureMap = array();	  
	  
			// We call the validate method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.
			if ($this->aTroveCategory !== null) {
				if (($retval = $this->aTroveCategory->validate()) !== true) {
					$failureMap = array_merge($failureMap, $retval);
				}
			}

			if (($retval = TroveLinkPeer::doValidate($this)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}
	  
	  
			$this->alreadyInValidation = false;
		}
	
		return (!empty($failureMap) ? $failureMap : true);
	}
  


	private $pks = array();
	
	/**
	 * Set the PrimaryKey.
	 *
	 * @param array $keys The elements of the composite key (order must match the order in XML file).
	 * @return void
	 * @throws PropelException
	 */
	public function setPrimaryKey($keys)
	{						

		$this->setSection($keys[0]);

		$this->setRefId($keys[1]);

		$this->setTroveCategoryId($keys[2]);

	}


	/**
	 * Returns an id that differentiates this object from others
	 * of its class.
	 * @return array 
	 */
	public function getPrimaryKey()
	{
		$this->pks[0] = $this->getSection();
		$this->pks[1] = $this->getRefId();
		$this->pks[2] = $this->getTroveCategoryId();
		return $this->pks;

	}

	
	/**
	 * Makes a copy of this object that will be inserted as a new row in table when saved.
	 * It creates a new object filling in the simple attributes, but skipping any primary
	 * keys that are defined for the table.
	 *  
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 *  
	 * @return TroveLink Clone of current object.
	 * @throws PropelException
	 */
	public function copy($deepCopy = false) 
	{
		$copyObj = new TroveLink();
		
		$copyObj->setNew(true);
		
		$copyObj->setSection(NULL); // this is a pkey column, so set to default value
		$copyObj->setRefId(NULL); // this is a pkey column, so set to default value
		$copyObj->setTroveCategoryId(NULL); // this is a pkey column, so set to default value

		return $copyObj;
	}
		

	/**
	 * returns a peer instance associated with this om.  Since Peer classes	
	 * are not to have any instance attributes, this method returns the
	 * same instance for all member of this class. The method could therefore
	 * be static, but this would prevent one from overriding the behavior.
	 * @return TroveLinkPeer
	 */
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new TroveLinkPeer();
		}
		return self::$peer;
	}

}
