<?php 

require_once 'propel/om/BaseObject.php';

 
require_once 'propel/om/Persistent.php';

 

include_once 'propel/util/Criteria.php';
 

// (on-demand) include_once 'core/Project.php';
// (on-demand) include_once 'core/ProjectPeer.php';
 

// (on-demand) include_once 'core/User.php';
// (on-demand) include_once 'core/UserPeer.php';

include_once 'core/UserProjectPeer.php';

/**
 * Base class that represents a row from the 'user_project' table.
 *
 *  
 *
 * You should not use this class directly.  It should not even be
 * extended; all references should be to UserProject class. 
 * 
 * @package core 
 */
abstract class BaseUserProject extends BaseObject implements Persistent {
	
	/** 
	 * The Peer class.
	 * Instance provides a convenient way of calling static methods on a class
	 * that calling code may not be able to identify.
	 * @var UserProjectPeer
	 */
	protected static $peer;

	/**
	 * The value for the user_id field.
	 * @var int	  
	 */
	protected $user_id;	

	/**
	 * The value for the project_id field.
	 * @var int	  
	 */
	protected $project_id;	

	/**
	 * The value for the user_project_id field.
	 * @var int	  
	 */
	protected $user_project_id;	

	/**
	 * The value for the join_date field.
	 * @var int	  
	 */
	protected $join_date = -1;	
  
	/**
	 * Get the UserId column value.
	 *  
	 * @return int	  
	 */
	public function getUserId()
	{
		return $this->user_id;
	}


	/**
	 * Set the value of `user_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setUserId($v)
	{
		if ($this->user_id !== $v) {
			$this->user_id = $v;
			$this->modifiedColumns[] = UserProjectPeer::USER_ID;
		}
			
		if ($this->aUser !== null && $this->aUser->getUserId() !== $v) {
			$this->aUser = null;
		}
			
	}

  
	/**
	 * Get the ProjectId column value.
	 *  
	 * @return int	  
	 */
	public function getProjectId()
	{
		return $this->project_id;
	}


	/**
	 * Set the value of `project_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setProjectId($v)
	{
		if ($this->project_id !== $v) {
			$this->project_id = $v;
			$this->modifiedColumns[] = UserProjectPeer::PROJECT_ID;
		}
			
		if ($this->aProject !== null && $this->aProject->getProjectId() !== $v) {
			$this->aProject = null;
		}
			
	}

  
	/**
	 * Get the UserProjectId column value.
	 *  
	 * @return int	  
	 */
	public function getUserProjectId()
	{
		return $this->user_project_id;
	}


	/**
	 * Set the value of `user_project_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setUserProjectId($v)
	{
		if ($this->user_project_id !== $v) {
			$this->user_project_id = $v;
			$this->modifiedColumns[] = UserProjectPeer::USER_PROJECT_ID;
		}
			
		  // update associated UserProjectRole		  
		  if ($this->collUserProjectRoles !== null) {
			  for ($i=0,$size=count($this->collUserProjectRoles); $i < $size; $i++) {
				  $this->collUserProjectRoles[$i]->setUserProjectId($v);
			  }
		  }
			  		
	}


	/**
	 * Get the [optionally formatted] `join_date` column value.
	 *  
	 * @param string $format The date/time format string (either date()-style or strftime()-style).
	 *							If format is NULL, then the integer unix timestamp will be returned.
	 * @return mixed Formatted date/time value as string or integer unix timestamp (if format is NULL).
	 * @throws PropelException - if unable to convert the date/time to timestamp.
	 */
	public function getJoinDate($format = 'Y-m-d H:i:s')
	{
		if ($this->join_date === null || $this->join_date === '') {
			return null;
		} elseif (!is_int($this->join_date)) {
			// a non-timestamp value was set externally, so we convert it
			$ts = strtotime($this->join_date);
			if ($ts === -1) {
				throw new PropelException("Unable to parse value of join_date as date/time value: " . var_export($this->join_date, true));
			}
		} else {
			$ts = $this->join_date;
		}
		if ($format === null) {
			return $ts;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $ts);
		} else {
			return date($format, $ts);
		}
	}


	/**
	 * Set the value of `join_date` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException - If passed [not-null] date/time is in an invalid format. 
	 */
	public function setJoinDate($v)
	{
		if ($v !== null && !is_int($v)) {
			$ts = strtotime($v);
			if ($ts === -1) {
				throw new PropelException("Unable to parse date/time value for join_date from input: " . var_export($v, true));
			}
		} else {
			$ts = $v;
		}
		if ($this->join_date !== $ts || $ts === -1) {
			$this->join_date = $ts;
			$this->modifiedColumns[] = UserProjectPeer::JOIN_DATE;
		}
		
	}


	
	/**
	 * Hydrates (populates) the object variables with values from the database resultset.
	 *
	 * An offset (1-based "start column") is specified so that objects can be hydrated
	 * with a subset of the columns in the resultset rows.  This is needed, for example,
	 * for results of JOIN queries where the resultset row includes columns from two or
	 * more tables.
	 *
	 * @param ResultSet $rs The ResultSet class with cursor advanced to desired record pos.
	 * @param int $startcol 1-based offset column which indicates which restultset column to start with.
	 * @return void
	 * @throws PropelException  - Any caught Exception will be rewrapped as a PropelException.
	 */
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {
			$this->user_id = $rs->getInt($startcol + 0);					
			$this->project_id = $rs->getInt($startcol + 1);					
			$this->user_project_id = $rs->getInt($startcol + 2);					
			$this->join_date = $rs->getTimestamp($startcol + 3, null);
			 
			$this->resetModified();
			$this->setNew(false);
		
		} catch (Exception $e) {
			throw new PropelException("Error populating UserProject object", $e);
		}		
	
	}
	
	/**
	 * Builds a Criteria object containing the primary key for this object.
	 *
	 * Unlike buildCriteria() this method includes the primary key values regardless
	 * of whether or not they have been modified.
	 * 
	 * @return Criteria The Criteria object containing value(s) for primary key(s).
	 */
	public function buildPkeyCriteria()
	{		
		$criteria = new Criteria(UserProjectPeer::DATABASE_NAME);
		$criteria->add(UserProjectPeer::USER_PROJECT_ID, $this->user_project_id);
		return $criteria;			
	}
	
	/**
	 * Build a Criteria object containing the values of all modified columns in this object.
	 *
	 * @return Criteria The Criteria object containing all modified values.
	 */
	public function buildCriteria()
	{		
		$criteria = new Criteria(UserProjectPeer::DATABASE_NAME);
		if ($this->isColumnModified(UserProjectPeer::USER_ID)) $criteria->add(UserProjectPeer::USER_ID, $this->user_id);
		if ($this->isColumnModified(UserProjectPeer::PROJECT_ID)) $criteria->add(UserProjectPeer::PROJECT_ID, $this->project_id);
		if ($this->isColumnModified(UserProjectPeer::USER_PROJECT_ID)) $criteria->add(UserProjectPeer::USER_PROJECT_ID, $this->user_project_id);
		if ($this->isColumnModified(UserProjectPeer::JOIN_DATE)) $criteria->add(UserProjectPeer::JOIN_DATE, $this->join_date);
		return $criteria;			
	}
	
	

	/**
	 * @var Project	  
	 */
	protected $aProject;

	/**
	 * Declares an association between this object and a Project object
	 *
	 * @param Project $v
	 * @return void
	 * @throws PropelException
	 */
	public function setProject($v)
	{
			
		if ($v === null) {
			$this->setProjectId(NULL);
		} else {
			$this->setProjectId($v->getProjectId());
		}
   
		$this->aProject = $v;
	}


	/**
	 * Get the associated Project object
	 *
	 * @param Connection Optional Connection object.
	 * @return Project The associated Project object.
	 * @throws PropelException
	 */
	public function getProject($con = null)
	{
		// include the Peer class
		include_once 'core/ProjectPeer.php';

		if ($this->aProject === null && ($this->project_id !== null)) {
	
			$this->aProject = ProjectPeer::retrieveByPK($this->project_id, $con);
	
			/* The following can be used instead of the line above to
			   guarantee the related object contains a reference
			   to this object, but this level of coupling
			   may be undesirable in many circumstances.
			   As it can lead to a db query with many results that may
			   never be used.
			   $obj = ProjectPeer::retrieveByPK($this->project_id, $con);
			   $obj->addUserProjects($this);
			 */
		}
		return $this->aProject;
	}

	/**
	 * Provides convenient way to set a relationship based on a
	 * key.  e.g.
	 * <code>$bar->setFooKey($foo->getPrimaryKey())</code>
	 *
 
	 * @return void
	 * @throws PropelException
	 */
	public function setProjectKey($key)
	{

		$this->setProjectId( (int) $key);			
		
	}

	/**
	 * @var User	  
	 */
	protected $aUser;

	/**
	 * Declares an association between this object and a User object
	 *
	 * @param User $v
	 * @return void
	 * @throws PropelException
	 */
	public function setUser($v)
	{
			
		if ($v === null) {
			$this->setUserId(NULL);
		} else {
			$this->setUserId($v->getUserId());
		}
   
		$this->aUser = $v;
	}


	/**
	 * Get the associated User object
	 *
	 * @param Connection Optional Connection object.
	 * @return User The associated User object.
	 * @throws PropelException
	 */
	public function getUser($con = null)
	{
		// include the Peer class
		include_once 'core/UserPeer.php';

		if ($this->aUser === null && ($this->user_id !== null)) {
	
			$this->aUser = UserPeer::retrieveByPK($this->user_id, $con);
	
			/* The following can be used instead of the line above to
			   guarantee the related object contains a reference
			   to this object, but this level of coupling
			   may be undesirable in many circumstances.
			   As it can lead to a db query with many results that may
			   never be used.
			   $obj = UserPeer::retrieveByPK($this->user_id, $con);
			   $obj->addUserProjects($this);
			 */
		}
		return $this->aUser;
	}

	/**
	 * Provides convenient way to set a relationship based on a
	 * key.  e.g.
	 * <code>$bar->setFooKey($foo->getPrimaryKey())</code>
	 *
 
	 * @return void
	 * @throws PropelException
	 */
	public function setUserKey($key)
	{

		$this->setUserId( (int) $key);			
		
	}

	/**
	 * Collection to store aggregation of collUserProjectRoles	  
	 * @var array
	 */
	protected $collUserProjectRoles; 

	/**
	 * Temporary storage of collUserProjectRoles to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initUserProjectRoles()
	{
		if ($this->collUserProjectRoles === null) {
			$this->collUserProjectRoles = array();
		}
	}

	/**
	 * Method called to associate a UserProjectRole object to this object
	 * through the UserProjectRole foreign key attribute
	 *
	 * @param UserProjectRole $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addUserProjectRole(UserProjectRole $l)
	{
		$this->collUserProjectRoles[] = $l;
		$l->setUserProject($this);
	}

	/**
	 * The criteria used to select the current contents of collUserProjectRoles.
	 * @var Criteria
	 */
	private $lastUserProjectRolesCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this UserProject has previously
	 * been saved, it will retrieve related UserProjectRoles from storage.
	 * If this UserProject is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getUserProjectRoles($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'core/UserProjectRolePeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collUserProjectRoles === null) {
			if ($this->isNew()) {
			   $this->collUserProjectRoles = array();
			} else {
	
				$criteria->add(UserProjectRolePeer::USER_PROJECT_ID, $this->getUserProjectId() );

				$this->collUserProjectRoles = UserProjectRolePeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(UserProjectRolePeer::USER_PROJECT_ID, $this->getUserProjectId());

				if (!isset($this->lastUserProjectRolesCriteria) || !$this->lastUserProjectRolesCriteria->equals($criteria)) {
					$this->collUserProjectRoles = UserProjectRolePeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastUserProjectRolesCriteria = $criteria;

		return $this->collUserProjectRoles;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this UserProject is new, it will return
	 * an empty collection; or if this UserProject has previously
	 * been saved, it will retrieve related UserProjectRoles from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in UserProject.
	 */
	public function getUserProjectRolesJoinRole($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'core/UserProjectRolePeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collUserProjectRoles === null) {
			if ($this->isNew()) {
			   $this->collUserProjectRoles = array();
			} else {
	   
				$criteria->add(UserProjectRolePeer::USER_PROJECT_ID, $this->getUserProjectId());
				$this->collUserProjectRoles = UserProjectRolePeer::doSelectJoinRole($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(UserProjectRolePeer::USER_PROJECT_ID, $this->getUserProjectId());
			if (!isset($this->lastUserProjectRolesCriteria) || !$this->lastUserProjectRolesCriteria->equals($criteria)) {
				$this->collUserProjectRoles = UserProjectRolePeer::doSelectJoinRole($criteria, $con);
			}
		}
		$this->lastUserProjectRolesCriteria = $criteria;

		return $this->collUserProjectRoles;
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this UserProject is new, it will return
	 * an empty collection; or if this UserProject has previously
	 * been saved, it will retrieve related UserProjectRoles from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in UserProject.
	 */
	public function getUserProjectRolesJoinUserProject($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'core/UserProjectRolePeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collUserProjectRoles === null) {
			if ($this->isNew()) {
			   $this->collUserProjectRoles = array();
			} else {
	   
				$criteria->add(UserProjectRolePeer::USER_PROJECT_ID, $this->getUserProjectId());
				$this->collUserProjectRoles = UserProjectRolePeer::doSelectJoinUserProject($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(UserProjectRolePeer::USER_PROJECT_ID, $this->getUserProjectId());
			if (!isset($this->lastUserProjectRolesCriteria) || !$this->lastUserProjectRolesCriteria->equals($criteria)) {
				$this->collUserProjectRoles = UserProjectRolePeer::doSelectJoinUserProject($criteria, $con);
			}
		}
		$this->lastUserProjectRolesCriteria = $criteria;

		return $this->collUserProjectRoles;
	}

	private $fieldNames;

	/**
	 * Generate a list of field names.
	 *
	 * @return array A list of field names
	 */
	public function getFieldNames()
	{
		if ($this->fieldNames === null) {
			$this->fieldNames = array("user_id", "project_id", "user_project_id", "join_date", );
		}
		return $this->fieldNames;
	}
	
	/**
	 * Retrieves a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @return mixed Value of field.
	 */
	public function getByName($name)
	{
		switch($name) {
	  
			case UserProjectPeer::USER_ID:
				return $this->getUserId();
				break;
		  
			case UserProjectPeer::PROJECT_ID:
				return $this->getProjectId();
				break;
		  
			case UserProjectPeer::USER_PROJECT_ID:
				return $this->getUserProjectId();
				break;
		  
			case UserProjectPeer::JOIN_DATE:
				return $this->getJoinDate();
				break;
	  
			default:
				return null;
				
		} // switch()
	}

	/**
	 * Retrieves a field from the object by Position as specified in the xml schema. 
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @return mixed Value of field at $pos
	 */
	public function getByPosition($pos)
	{
		switch($pos) {
  
			case 0:
				return $this->getUserId();
				break;
  
			case 1:
				return $this->getProjectId();
				break;
  
			case 2:
				return $this->getUserProjectId();
				break;
  
			case 3:
				return $this->getJoinDate();
				break;
			default:
				return null;
		} // switch()
	}



	
	/**
	 * Convenience method to populate the object using an array.
	 * This is particularly useful when populating an object from one of the request arrays (e.g. $_POST).  This method
	 * goest through the column (peer) names, checking to see whether a matching key exists in populated array. If
	 * so the setByName() method is called for that column.
	 * @param array $arr An array where keys are column names.
	 * @return void
	 */
	public function populateFromArray($arr)
	{
  
		if (array_key_exists(UserProjectPeer::USER_ID, $arr)) $this->setUserId($arr[UserProjectPeer::USER_ID]);
  
		if (array_key_exists(UserProjectPeer::PROJECT_ID, $arr)) $this->setProjectId($arr[UserProjectPeer::PROJECT_ID]);
  
		if (array_key_exists(UserProjectPeer::USER_PROJECT_ID, $arr)) $this->setUserProjectId($arr[UserProjectPeer::USER_PROJECT_ID]);
  
		if (array_key_exists(UserProjectPeer::JOIN_DATE, $arr)) $this->setJoinDate($arr[UserProjectPeer::JOIN_DATE]);
 
	}
	
	/**
	 * Sets a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByName($name, $value)
	{
		switch($name) {
	  
			case UserProjectPeer::USER_ID:
				$this->setUserId($value);
				break;
	  
			case UserProjectPeer::PROJECT_ID:
				$this->setProjectId($value);
				break;
	  
			case UserProjectPeer::USER_PROJECT_ID:
				$this->setUserProjectId($value);
				break;
	  
			case UserProjectPeer::JOIN_DATE:
				$this->setJoinDate($value);
				break;
				  
		} // switch()
	}

	/**
	 * Sets a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByPosition($pos, $value)
	{
		switch($pos) {
  
			case 0:
				$this->setUserId($value);
				break;
  
			case 1:
				$this->setProjectId($value);
				break;
  
			case 2:
				$this->setUserProjectId($value);
				break;
  
			case 3:
				$this->setJoinDate($value);
				break;
		} // switch()
	}


 
	/**
	 * Removes this object from datastore and sets delete attribute.
	 * 
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 * @see BaseObject::setDeleted()
	 * @see BaseObject::isDeleted()
	 */
	public function delete($con = null)
	{	
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}
		
		if ($con === null)
			$con = Propel::getConnection(UserProjectPeer::DATABASE_NAME);

		try {
			$con->begin();
			UserProjectPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
	

	/**
	 * flag to prevent endless save loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	private $alreadyInSave = false;

	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.  This method
	 * wraps the doSave() worker method in a transaction.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
	public function save($con = null, $skipPermCheck = false)
	{
		if ($this->isDeleted()) {
		//	throw new PropelException("You cannot save an object that has been deleted.");
			return;
		}
		
		if ($con === null)
			$con = Propel::getConnection(UserProjectPeer::DATABASE_NAME);

		try {
			$con->begin();
			$this->doSave($con, $skipPermCheck);			
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
  
	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
		protected function doSave($con, $skipPermCheck = false)	{ 
		
	 
		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;

			// We call the save method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.
 
			if ($this->aProject !== null) {
				if ($this->aProject->isModified()) $this->aProject->save($con);
				$this->setProject($this->aProject);
			}
 
			if ($this->aUser !== null) {
				if ($this->aUser->isModified()) $this->aUser->save($con);
				$this->setUser($this->aUser);
			}

			// If this object has been modified, then save it to the database.
			if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = UserProjectPeer::doInsert($this, $con);
					$this->setUserProjectId( $pk );  //[IMV] update autoincrement primary key
					$this->setNew(false);
				} else {
					UserProjectPeer::doUpdate($this, $con);
				}			
				$this->resetModified(); // [HL] After being saved an object is no longer 'modified'
			}
			if ($this->collUserProjectRoles !== null) {
				for ($i=0,$size=count($this->collUserProjectRoles); $i < $size; $i++) {
					$this->collUserProjectRoles[$i]->save($con, $skipPermCheck);
				}
			  }

			$this->alreadyInSave = false;
		}
	}

	/**
	 * Validates the objects modified field values.
	 * This includes all objects related to this table.
	 *
	 * If $columns is either a column name or an array of column names
	 * only those columns are validated.
	 *
	 * @param mixed $columns Column name or an array of column names.
	 *
	 * @return mixed <code>true</code> if all columns pass validation
	 *			  or an array of <code>ValidationFailed</code> objects for columns that fail.
	 */
	public function validate($columns = null)
	{
	  if ($columns)
	  {
		return UserProjectPeer::doValidate($this, $columns);
	  }

		return $this->doValidate();
	}

	/**
	 * flag to prevent endless validation loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	protected $alreadyInValidation = false;
  
	/**
	 * This function performs the validation work for complex object models.
	 * 
	 * In addition to checking the current object, all related objects will
	 * also be validated.  If all pass then <code>true</code> is returned; otherwise
	 * an aggreagated array of ValidationFailed objects will be returned.
	 *
	 * @return mixed <code>true</code> if all validations pass; array of <code>ValidationFailed</code> objets otherwise.
	 */
	protected function doValidate()
	{
		if (! $this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;
	  
			$failureMap = array();	  
	  
			// We call the validate method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.
			if ($this->aProject !== null) {
				if (($retval = $this->aProject->validate()) !== true) {
					$failureMap = array_merge($failureMap, $retval);
				}
			}
			if ($this->aUser !== null) {
				if (($retval = $this->aUser->validate()) !== true) {
					$failureMap = array_merge($failureMap, $retval);
				}
			}

			if (($retval = UserProjectPeer::doValidate($this)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}
	  
			if ($this->collUserProjectRoles !== null) {
				for ($i=0,$size=count($this->collUserProjectRoles); $i < $size; $i++) {
					if (($retval = $this->collUserProjectRoles[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
	  
			$this->alreadyInValidation = false;
		}
	
		return (!empty($failureMap) ? $failureMap : true);
	}
  

	/**
	 * Set the PrimaryKey.
	 *
	 * @param mixed user_project_id Primary key.
	 * @return void
	 * @throws PropelException	 */
	public function setPrimaryKey($key) 
	{		
		$this->setUserProjectId($key);
	}
	

	/**
	 * Returns an id that differentiates this object from others
	 * of its class.
	 * @return int 
	 */
	public function getPrimaryKey()
	{

		return $this->getUserProjectId();

	}

	
	/**
	 * Makes a copy of this object that will be inserted as a new row in table when saved.
	 * It creates a new object filling in the simple attributes, but skipping any primary
	 * keys that are defined for the table.
	 *  
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 *  
	 * @return UserProject Clone of current object.
	 * @throws PropelException
	 */
	public function copy($deepCopy = false) 
	{
		$copyObj = new UserProject();
		$copyObj->setUserId($this->user_id);
		$copyObj->setProjectId($this->project_id);
		$copyObj->setJoinDate($this->join_date);

		if ($deepCopy) {		
			// important: setNew(false) because this affects the behavior of
			// the getter/setter methods for fkey referrer objects.
			$copyObj->setNew(false);

			foreach($this->getUserProjectRoles() as $relObj) {
				$copyObj->addUserProjectRole($relObj->copy());
			}
		} // if ($deepCopy)
		
		$copyObj->setNew(true);
		
		$copyObj->setUserProjectId(NULL); // this is a pkey column, so set to default value

		return $copyObj;
	}
		

	/**
	 * returns a peer instance associated with this om.  Since Peer classes	
	 * are not to have any instance attributes, this method returns the
	 * same instance for all member of this class. The method could therefore
	 * be static, but this would prevent one from overriding the behavior.
	 * @return UserProjectPeer
	 */
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new UserProjectPeer();
		}
		return self::$peer;
	}

}
