<?php 

require_once 'propel/om/BaseObject.php';

 
require_once 'propel/om/Persistent.php';

 

include_once 'propel/util/Criteria.php';
 

// (on-demand) include_once 'core/WallPost.php';
// (on-demand) include_once 'core/WallPostPeer.php';
 

// (on-demand) include_once 'core/User.php';
// (on-demand) include_once 'core/UserPeer.php';

include_once 'core/WallPostCommentPeer.php';

/**
 * Base class that represents a row from the 'wall_post_comment' table.
 *
 *  
 *
 * You should not use this class directly.  It should not even be
 * extended; all references should be to WallPostComment class. 
 * 
 * @package core 
 */
abstract class BaseWallPostComment extends BaseObject implements Persistent {
	
	/** 
	 * The Peer class.
	 * Instance provides a convenient way of calling static methods on a class
	 * that calling code may not be able to identify.
	 * @var WallPostCommentPeer
	 */
	protected static $peer;

	/**
	 * The value for the wall_post_comment_id field.
	 * @var int	  
	 */
	protected $wall_post_comment_id;	

	/**
	 * The value for the wall_post_id field.
	 * @var int	  
	 */
	protected $wall_post_id;	

	/**
	 * The value for the posted_by field.
	 * @var int	  
	 */
	protected $posted_by;	

	/**
	 * The value for the post_date field.
	 * @var int	  
	 */
	protected $post_date = -1;	

	/**
	 * The value for the comment field.
	 * @var string	  
	 */
	protected $comment;	
  
	/**
	 * Get the WallPostCommentId column value.
	 *  
	 * @return int	  
	 */
	public function getWallPostCommentId()
	{
		return $this->wall_post_comment_id;
	}


	/**
	 * Set the value of `wall_post_comment_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 *  
	 */
	public function setWallPostCommentId($v)
	{
		if ($this->wall_post_comment_id !== $v) {
			$this->wall_post_comment_id = $v;
			$this->modifiedColumns[] = WallPostCommentPeer::WALL_POST_COMMENT_ID;
		}
				
	}

  
	/**
	 * Get the WallPostId column value.
	 *  
	 * @return int	  
	 */
	public function getWallPostId()
	{
		return $this->wall_post_id;
	}


	/**
	 * Set the value of `wall_post_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setWallPostId($v)
	{
		if ($this->wall_post_id !== $v) {
			$this->wall_post_id = $v;
			$this->modifiedColumns[] = WallPostCommentPeer::WALL_POST_ID;
		}
			
		if ($this->aWallPost !== null && $this->aWallPost->getWallPostId() !== $v) {
			$this->aWallPost = null;
		}
			
	}

  
	/**
	 * Get the PostedBy column value.
	 *  
	 * @return int	  
	 */
	public function getPostedBy()
	{
		return $this->posted_by;
	}


	/**
	 * Set the value of `posted_by` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setPostedBy($v)
	{
		if ($this->posted_by !== $v) {
			$this->posted_by = $v;
			$this->modifiedColumns[] = WallPostCommentPeer::POSTED_BY;
		}
			
		if ($this->aUser !== null && $this->aUser->getUserId() !== $v) {
			$this->aUser = null;
		}
			
	}


	/**
	 * Get the [optionally formatted] `post_date` column value.
	 *  
	 * @param string $format The date/time format string (either date()-style or strftime()-style).
	 *							If format is NULL, then the integer unix timestamp will be returned.
	 * @return mixed Formatted date/time value as string or integer unix timestamp (if format is NULL).
	 * @throws PropelException - if unable to convert the date/time to timestamp.
	 */
	public function getPostDate($format = 'Y-m-d H:i:s')
	{
		if ($this->post_date === null || $this->post_date === '') {
			return null;
		} elseif (!is_int($this->post_date)) {
			// a non-timestamp value was set externally, so we convert it
			$ts = strtotime($this->post_date);
			if ($ts === -1) {
				throw new PropelException("Unable to parse value of post_date as date/time value: " . var_export($this->post_date, true));
			}
		} else {
			$ts = $this->post_date;
		}
		if ($format === null) {
			return $ts;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $ts);
		} else {
			return date($format, $ts);
		}
	}


	/**
	 * Set the value of `post_date` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException - If passed [not-null] date/time is in an invalid format. 
	 */
	public function setPostDate($v)
	{
		if ($v !== null && !is_int($v)) {
			$ts = strtotime($v);
			if ($ts === -1) {
				throw new PropelException("Unable to parse date/time value for post_date from input: " . var_export($v, true));
			}
		} else {
			$ts = $v;
		}
		if ($this->post_date !== $ts || $ts === -1) {
			$this->post_date = $ts;
			$this->modifiedColumns[] = WallPostCommentPeer::POST_DATE;
		}
		
	}

  
	/**
	 * Get the Comment column value.
	 *  
	 * @return string	  
	 */
	public function getComment()
	{
		return $this->comment;
	}


	/**
	 * Set the value of `comment` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setComment($v)
	{
		if ($this->comment !== $v) {
			$this->comment = $v;
			$this->modifiedColumns[] = WallPostCommentPeer::COMMENT;
		}
				
	}


	
	/**
	 * Hydrates (populates) the object variables with values from the database resultset.
	 *
	 * An offset (1-based "start column") is specified so that objects can be hydrated
	 * with a subset of the columns in the resultset rows.  This is needed, for example,
	 * for results of JOIN queries where the resultset row includes columns from two or
	 * more tables.
	 *
	 * @param ResultSet $rs The ResultSet class with cursor advanced to desired record pos.
	 * @param int $startcol 1-based offset column which indicates which restultset column to start with.
	 * @return void
	 * @throws PropelException  - Any caught Exception will be rewrapped as a PropelException.
	 */
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {
			$this->wall_post_comment_id = $rs->getInt($startcol + 0);					
			$this->wall_post_id = $rs->getInt($startcol + 1);					
			$this->posted_by = $rs->getInt($startcol + 2);					
			$this->post_date = $rs->getTimestamp($startcol + 3, null);
			$this->comment = $rs->getString($startcol + 4);					
			 
			$this->resetModified();
			$this->setNew(false);
		
		} catch (Exception $e) {
			throw new PropelException("Error populating WallPostComment object", $e);
		}		
	
	}
	
	/**
	 * Builds a Criteria object containing the primary key for this object.
	 *
	 * Unlike buildCriteria() this method includes the primary key values regardless
	 * of whether or not they have been modified.
	 * 
	 * @return Criteria The Criteria object containing value(s) for primary key(s).
	 */
	public function buildPkeyCriteria()
	{		
		$criteria = new Criteria(WallPostCommentPeer::DATABASE_NAME);
		$criteria->add(WallPostCommentPeer::WALL_POST_COMMENT_ID, $this->wall_post_comment_id);
		return $criteria;			
	}
	
	/**
	 * Build a Criteria object containing the values of all modified columns in this object.
	 *
	 * @return Criteria The Criteria object containing all modified values.
	 */
	public function buildCriteria()
	{		
		$criteria = new Criteria(WallPostCommentPeer::DATABASE_NAME);
		if ($this->isColumnModified(WallPostCommentPeer::WALL_POST_COMMENT_ID)) $criteria->add(WallPostCommentPeer::WALL_POST_COMMENT_ID, $this->wall_post_comment_id);
		if ($this->isColumnModified(WallPostCommentPeer::WALL_POST_ID)) $criteria->add(WallPostCommentPeer::WALL_POST_ID, $this->wall_post_id);
		if ($this->isColumnModified(WallPostCommentPeer::POSTED_BY)) $criteria->add(WallPostCommentPeer::POSTED_BY, $this->posted_by);
		if ($this->isColumnModified(WallPostCommentPeer::POST_DATE)) $criteria->add(WallPostCommentPeer::POST_DATE, $this->post_date);
		if ($this->isColumnModified(WallPostCommentPeer::COMMENT)) $criteria->add(WallPostCommentPeer::COMMENT, $this->comment);
		return $criteria;			
	}
	
	

	/**
	 * @var WallPost	  
	 */
	protected $aWallPost;

	/**
	 * Declares an association between this object and a WallPost object
	 *
	 * @param WallPost $v
	 * @return void
	 * @throws PropelException
	 */
	public function setWallPost($v)
	{
			
		if ($v === null) {
			$this->setWallPostId(NULL);
		} else {
			$this->setWallPostId($v->getWallPostId());
		}
   
		$this->aWallPost = $v;
	}


	/**
	 * Get the associated WallPost object
	 *
	 * @param Connection Optional Connection object.
	 * @return WallPost The associated WallPost object.
	 * @throws PropelException
	 */
	public function getWallPost($con = null)
	{
		// include the Peer class
		include_once 'core/WallPostPeer.php';

		if ($this->aWallPost === null && ($this->wall_post_id !== null)) {
	
			$this->aWallPost = WallPostPeer::retrieveByPK($this->wall_post_id, $con);
	
			/* The following can be used instead of the line above to
			   guarantee the related object contains a reference
			   to this object, but this level of coupling
			   may be undesirable in many circumstances.
			   As it can lead to a db query with many results that may
			   never be used.
			   $obj = WallPostPeer::retrieveByPK($this->wall_post_id, $con);
			   $obj->addWallPostComments($this);
			 */
		}
		return $this->aWallPost;
	}

	/**
	 * Provides convenient way to set a relationship based on a
	 * key.  e.g.
	 * <code>$bar->setFooKey($foo->getPrimaryKey())</code>
	 *
 
	 * @return void
	 * @throws PropelException
	 */
	public function setWallPostKey($key)
	{

		$this->setWallPostId( (int) $key);			
		
	}

	/**
	 * @var User	  
	 */
	protected $aUser;

	/**
	 * Declares an association between this object and a User object
	 *
	 * @param User $v
	 * @return void
	 * @throws PropelException
	 */
	public function setUser($v)
	{
			
		if ($v === null) {
			$this->setPostedBy(NULL);
		} else {
			$this->setPostedBy($v->getUserId());
		}
   
		$this->aUser = $v;
	}


	/**
	 * Get the associated User object
	 *
	 * @param Connection Optional Connection object.
	 * @return User The associated User object.
	 * @throws PropelException
	 */
	public function getUser($con = null)
	{
		// include the Peer class
		include_once 'core/UserPeer.php';

		if ($this->aUser === null && ($this->posted_by !== null)) {
	
			$this->aUser = UserPeer::retrieveByPK($this->posted_by, $con);
	
			/* The following can be used instead of the line above to
			   guarantee the related object contains a reference
			   to this object, but this level of coupling
			   may be undesirable in many circumstances.
			   As it can lead to a db query with many results that may
			   never be used.
			   $obj = UserPeer::retrieveByPK($this->posted_by, $con);
			   $obj->addWallPostComments($this);
			 */
		}
		return $this->aUser;
	}

	/**
	 * Provides convenient way to set a relationship based on a
	 * key.  e.g.
	 * <code>$bar->setFooKey($foo->getPrimaryKey())</code>
	 *
 
	 * @return void
	 * @throws PropelException
	 */
	public function setUserKey($key)
	{

		$this->setPostedBy( (int) $key);			
		
	}

	private $fieldNames;

	/**
	 * Generate a list of field names.
	 *
	 * @return array A list of field names
	 */
	public function getFieldNames()
	{
		if ($this->fieldNames === null) {
			$this->fieldNames = array("wall_post_comment_id", "wall_post_id", "posted_by", "post_date", "comment", );
		}
		return $this->fieldNames;
	}
	
	/**
	 * Retrieves a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @return mixed Value of field.
	 */
	public function getByName($name)
	{
		switch($name) {
	  
			case WallPostCommentPeer::WALL_POST_COMMENT_ID:
				return $this->getWallPostCommentId();
				break;
		  
			case WallPostCommentPeer::WALL_POST_ID:
				return $this->getWallPostId();
				break;
		  
			case WallPostCommentPeer::POSTED_BY:
				return $this->getPostedBy();
				break;
		  
			case WallPostCommentPeer::POST_DATE:
				return $this->getPostDate();
				break;
		  
			case WallPostCommentPeer::COMMENT:
				return $this->getComment();
				break;
	  
			default:
				return null;
				
		} // switch()
	}

	/**
	 * Retrieves a field from the object by Position as specified in the xml schema. 
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @return mixed Value of field at $pos
	 */
	public function getByPosition($pos)
	{
		switch($pos) {
  
			case 0:
				return $this->getWallPostCommentId();
				break;
  
			case 1:
				return $this->getWallPostId();
				break;
  
			case 2:
				return $this->getPostedBy();
				break;
  
			case 3:
				return $this->getPostDate();
				break;
  
			case 4:
				return $this->getComment();
				break;
			default:
				return null;
		} // switch()
	}



	
	/**
	 * Convenience method to populate the object using an array.
	 * This is particularly useful when populating an object from one of the request arrays (e.g. $_POST).  This method
	 * goest through the column (peer) names, checking to see whether a matching key exists in populated array. If
	 * so the setByName() method is called for that column.
	 * @param array $arr An array where keys are column names.
	 * @return void
	 */
	public function populateFromArray($arr)
	{
  
		if (array_key_exists(WallPostCommentPeer::WALL_POST_COMMENT_ID, $arr)) $this->setWallPostCommentId($arr[WallPostCommentPeer::WALL_POST_COMMENT_ID]);
  
		if (array_key_exists(WallPostCommentPeer::WALL_POST_ID, $arr)) $this->setWallPostId($arr[WallPostCommentPeer::WALL_POST_ID]);
  
		if (array_key_exists(WallPostCommentPeer::POSTED_BY, $arr)) $this->setPostedBy($arr[WallPostCommentPeer::POSTED_BY]);
  
		if (array_key_exists(WallPostCommentPeer::POST_DATE, $arr)) $this->setPostDate($arr[WallPostCommentPeer::POST_DATE]);
  
		if (array_key_exists(WallPostCommentPeer::COMMENT, $arr)) $this->setComment($arr[WallPostCommentPeer::COMMENT]);
 
	}
	
	/**
	 * Sets a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByName($name, $value)
	{
		switch($name) {
	  
			case WallPostCommentPeer::WALL_POST_COMMENT_ID:
				$this->setWallPostCommentId($value);
				break;
	  
			case WallPostCommentPeer::WALL_POST_ID:
				$this->setWallPostId($value);
				break;
	  
			case WallPostCommentPeer::POSTED_BY:
				$this->setPostedBy($value);
				break;
	  
			case WallPostCommentPeer::POST_DATE:
				$this->setPostDate($value);
				break;
	  
			case WallPostCommentPeer::COMMENT:
				$this->setComment($value);
				break;
				  
		} // switch()
	}

	/**
	 * Sets a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByPosition($pos, $value)
	{
		switch($pos) {
  
			case 0:
				$this->setWallPostCommentId($value);
				break;
  
			case 1:
				$this->setWallPostId($value);
				break;
  
			case 2:
				$this->setPostedBy($value);
				break;
  
			case 3:
				$this->setPostDate($value);
				break;
  
			case 4:
				$this->setComment($value);
				break;
		} // switch()
	}


 
	/**
	 * Removes this object from datastore and sets delete attribute.
	 * 
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 * @see BaseObject::setDeleted()
	 * @see BaseObject::isDeleted()
	 */
	public function delete($con = null)
	{	
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}
		
		if ($con === null)
			$con = Propel::getConnection(WallPostCommentPeer::DATABASE_NAME);

		try {
			$con->begin();
			WallPostCommentPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
	

	/**
	 * flag to prevent endless save loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	private $alreadyInSave = false;

	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.  This method
	 * wraps the doSave() worker method in a transaction.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
	public function save($con = null)
	{
		if ($this->isDeleted()) {
		//	throw new PropelException("You cannot save an object that has been deleted.");
			return;
		}
		
		if ($con === null)
			$con = Propel::getConnection(WallPostCommentPeer::DATABASE_NAME);

		try {
			$con->begin();
			$this->doSave($con);			
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
  
	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
		protected function doSave($con)	{ 
		
	 
		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;

			// We call the save method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.
 
			if ($this->aWallPost !== null) {
				if ($this->aWallPost->isModified()) $this->aWallPost->save($con);
				$this->setWallPost($this->aWallPost);
			}
 
			if ($this->aUser !== null) {
				if ($this->aUser->isModified()) $this->aUser->save($con);
				$this->setUser($this->aUser);
			}

			// If this object has been modified, then save it to the database.
			if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = WallPostCommentPeer::doInsert($this, $con);
					$this->setWallPostCommentId( $pk );  //[IMV] update autoincrement primary key
					$this->setNew(false);
				} else {
					WallPostCommentPeer::doUpdate($this, $con);
				}			
				$this->resetModified(); // [HL] After being saved an object is no longer 'modified'
			}

			$this->alreadyInSave = false;
		}
	}

	/**
	 * Validates the objects modified field values.
	 * This includes all objects related to this table.
	 *
	 * If $columns is either a column name or an array of column names
	 * only those columns are validated.
	 *
	 * @param mixed $columns Column name or an array of column names.
	 *
	 * @return mixed <code>true</code> if all columns pass validation
	 *			  or an array of <code>ValidationFailed</code> objects for columns that fail.
	 */
	public function validate($columns = null)
	{
	  if ($columns)
	  {
		return WallPostCommentPeer::doValidate($this, $columns);
	  }

		return $this->doValidate();
	}

	/**
	 * flag to prevent endless validation loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	protected $alreadyInValidation = false;
  
	/**
	 * This function performs the validation work for complex object models.
	 * 
	 * In addition to checking the current object, all related objects will
	 * also be validated.  If all pass then <code>true</code> is returned; otherwise
	 * an aggreagated array of ValidationFailed objects will be returned.
	 *
	 * @return mixed <code>true</code> if all validations pass; array of <code>ValidationFailed</code> objets otherwise.
	 */
	protected function doValidate()
	{
		if (! $this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;
	  
			$failureMap = array();	  
	  
			// We call the validate method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.
			if ($this->aWallPost !== null) {
				if (($retval = $this->aWallPost->validate()) !== true) {
					$failureMap = array_merge($failureMap, $retval);
				}
			}
			if ($this->aUser !== null) {
				if (($retval = $this->aUser->validate()) !== true) {
					$failureMap = array_merge($failureMap, $retval);
				}
			}

			if (($retval = WallPostCommentPeer::doValidate($this)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}
	  
	  
			$this->alreadyInValidation = false;
		}
	
		return (!empty($failureMap) ? $failureMap : true);
	}
  

	/**
	 * Set the PrimaryKey.
	 *
	 * @param mixed wall_post_comment_id Primary key.
	 * @return void
	 * @throws PropelException	 */
	public function setPrimaryKey($key) 
	{		
		$this->setWallPostCommentId($key);
	}
	

	/**
	 * Returns an id that differentiates this object from others
	 * of its class.
	 * @return int 
	 */
	public function getPrimaryKey()
	{

		return $this->getWallPostCommentId();

	}

	
	/**
	 * Makes a copy of this object that will be inserted as a new row in table when saved.
	 * It creates a new object filling in the simple attributes, but skipping any primary
	 * keys that are defined for the table.
	 *  
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 *  
	 * @return WallPostComment Clone of current object.
	 * @throws PropelException
	 */
	public function copy($deepCopy = false) 
	{
		$copyObj = new WallPostComment();
		$copyObj->setWallPostId($this->wall_post_id);
		$copyObj->setPostedBy($this->posted_by);
		$copyObj->setPostDate($this->post_date);
		$copyObj->setComment($this->comment);
		
		$copyObj->setNew(true);
		
		$copyObj->setWallPostCommentId(NULL); // this is a pkey column, so set to default value

		return $copyObj;
	}
		

	/**
	 * returns a peer instance associated with this om.  Since Peer classes	
	 * are not to have any instance attributes, this method returns the
	 * same instance for all member of this class. The method could therefore
	 * be static, but this would prevent one from overriding the behavior.
	 * @return WallPostCommentPeer
	 */
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new WallPostCommentPeer();
		}
		return self::$peer;
	}

}
