function FileUploadWidgetInit(container_id, widget_id, server_url, extra_parameters) {
	this.container_id = container_id;
	this.widget_id = widget_id;
	this.server_url = server_url;

	if (!extra_parameters) {
		extra_parameters = [];
	} else if (typeof extra_parameters == 'string') {
		extra_parameters = [extra_parameters];
	}

	this.extra_parameters = extra_parameters;
	
	$(function () {
		'use strict';

		//Create data object for the template
		var tmpl_data = {widget_id : widget_id, server_url : server_url, extra_parameters : extra_parameters};

		//Render the widget template
		var widget_html = new EJS({url: '/upload_widget.ejs'}).render(tmpl_data);

		//Set the rendered widget to the DIV container
		$('#' + container_id).html(widget_html);
	
		// Initialize the jQuery File Upload widget:

		try {
			$('#' + widget_id).fileupload();
		}catch(err) {
			alert(err);
		}

	});
}

function FileUploadWidgetSetParameter(parameter_id, parameter_value) {
	$('#' + parameter_id).attr('value', parameter_value);
}


/**
 * Shows the upload widget popup
 */
function showUpload() {
$("#fileupload_wrapper").dialog({
	resizable: false,
	height:360,
	width: 530,
	title: "File upload",
	modal: false,
	buttons: {
		close: function() {
			$( this ).dialog( "close" );
		}
	}
});
}
