<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id$
 * @author Daniel A. Perez	daniel@gforgegroup.com
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
 
require_once('html/ProjectTemplate.php');
require_once('lib/plugin/PluginResult.php');

class ProjectAdminTemplate extends ProjectTemplate {

	function header($params) {
		$Lang=Session::getSession()->getLanguage();
		if (!$params['project']->userIsAdmin()) {
			throw new PermissionDeniedException();
		}
		$params['selectedbottomtab']='project_admin';
		$this->addBreadCrumb('<a href="'.GFUrl::getUrl()->projectUrl($params['project'],'','','admin').'">'.$Lang->getText('Tabs.Admin').'</a>');
		parent::header($params);
	}
	/**
	 *      getPluginNavElements - this overrides parent class and adds its own
	 *      plugin listener
	 *      @return PluginResultSet
	 */
	function getPluginNavElements($params) {
		$prs = parent::getPluginNavElements($params);
		$tprs = ActionManager::Notify('GET_PROJECT_ADMIN_NAV_ELEMENTS',$params);
		foreach ($tprs as $pr) {
			$prs->addResult($pr);
		}
		return $prs;
	}


	function getTemplateNavElements($params) {
		$pine = $this->getPluginNavElements($params);
		$ret=array();
		foreach ($pine as $result) {
			$ret[]=$result->getResult();
		}
		$project = GFUrl::getUrl()->getProject();
		return $ret;
	}


}

?>
