<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id$
 * @author Daniel A. Perez	daniel@gforgegroup.com
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
 
require_once('html/ProjectTemplate.php');
require_once('lib/plugin/PluginResult.php');

class ProjectReportingTemplate extends ProjectTemplate {

	function header($params) {
		$Lang=Session::getSession()->getLanguage();
/*		if (!isset($params['title'])) {
			$params['title']=$Lang->getText('Tabs.ProjectReporting');
			$this->addBreadCrumb('<a href="/gf/project/'.$params['project']->getUnixName().'/reporting/">'.$params['title'].'</a>');
		} else {
			$this->addBreadCrumb('<a href="'.GFUrl::getUrl()->currentURL().'">'.$params['title'].'</a>');
*/
			$this->addBreadCrumb('<a href="/gf/project/'.$params['project']->getUnixName().'/reporting/">'.$Lang->getText('Tabs.ProjectReporting').'</a>');
/*			$params['title']=$Lang->getText('Tabs.ProjectReporting').' > '.$params['title'];
		}*/
		$params['selectedbottomtab']='reporting';
		return parent::header($params);
	}

	/**
	 *      getPluginNavElements - this overrides parent class and adds its own
	 *      plugin listener
	 *      @return PluginResultSet
	 */
	function getPluginNavElements($params) {
		$prs = parent::getPluginNavElements($params);
		$tprs = ActionManager::Notify('GET_PROJECT_REPORTING_NAV_ELEMENTS',$params);
		foreach ($tprs as $pr) {
			$prs->addResult($pr);
		}
		return $prs;
	}

	function getTemplateNavElements($params) {
		$pine = $this->getPluginNavElements($params);
		$ret=array();
		//TODO: maybe we should check if Tracker plugin is installed, but it will always be
		$ret[] = array(
				'title'=> Language::getSessText('Common.Project'),
				'elements'=> array(
				array('link'=>'/gf/project/'.$params['project']->getUnixName().'/reporting/',
							'description'=>Language::getSessText('FrsRelease.DevelopmentRoadmap')),
				array('link'=>'/gf/project/'.$params['project']->getUnixName().'/reporting/?action=Activity',
							'description'=>Language::getSessText('ProjectActivity.title')),
			//	array('link'=>'/gf/project/'.$params['project']->getUnixName().'/reporting/?action=Stats',
			//				'description'=>Language::getSessText('ProjectReporting.Stats')),
				array('link'=>'/gf/project/'.$params['project']->getUnixName().'/reporting/?action=DiskUsage',
							'description'=>Language::getSessText('ProjectReporting.DiskUsage'))
				)
			);		

		foreach ($pine as $result) {
			$ret[]=$result->getResult();
		}
/*
		$ret[] = array(
				'title'=>'Project Admin',
				'elements'=> array(
				array('link'=>GFUrl::getUrl()->currentBaseURL('EditDescription'),
					'description'=>Language::getSessText('Project.EditDescription')),
				array('link'=> 'sarasa',
					'description'=>'Item 2'),
				array('link'=>'sarasa',
					'description'=>'Item 3')
				)
			);
*/		return $ret;
	}

}

?>
