<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id$
 * @author Tim Perdue tim@gforge.org
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

require_once('PluginResult.php');

/**
 *	Class is returned by a plugin action
 *	And contains 0 to many PluginResult objects.
 *  Note that this class can be iterated using foreach()
 */
class PluginResultSet implements Iterator {

	private $results = array();
	private $error = false;
	private $index = 0;

	function __construct() {

	}

	/**
	 *	isError - whether any errors are in any of 
	 *	the PluginResult objects
	 *	@return	boolean
	 */
	function isError() {
		return $this->error;
	}

	/**
	 *	addResult	add another PluginResult object.
	 *	@param	PluginResult
	 *	@return	boolean
	 */
	function addResult(PluginResult $PluginResult) {
		if ($PluginResult->isError()) {
			$this->error=true;
		}
		$this->results[]=$PluginResult;
	}
	
	// Functions below allow using the foreach() construct

	function rewind() {
		$this->index=0;
	}
	
	/**
	 * get the current PluginResult
	 */
	function current() {
		return $this->results[$this->index];
	}
	
	function key() {
		return $this->index;
	}
	
	function next() {
		$this->index++;
	}
	
	function valid() {
		return ($this->index < count($this->results));
	}
	
	function count() {
		return count($this->results);
	}

}

?>