<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id$
 * @author Marcelo Mottalli	<marcelo@gforgegroup.com>
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
 
require_once('core/CronHistory.php');

abstract class Cronjob {
	protected $cronEntry;	//Cronhistory object that will log error output (if any)
	protected $jobname;
	protected $logText;
	
	// The cronjob parameters will be shared by all the cronjobs
	protected static $parameters = array();

	public function __construct() {
		$this->cronEntry = new CronHistory();
		$this->logText = '';
	}
	/**
	 * Run the cronjob
	 */
	abstract public function run();
	
	public static function setGlobalParameters($parameters) {
		self::$parameters = $parameters;
	}
	
	public static function getCronjobParameter($parameter_idx) {
		if (array_key_exists($parameter_idx, self::$parameters)) {
			return self::$parameters[$parameter_idx];
		} else {
			return null;
		}
	}	
	
	/**
	 * Logs the cronjob's activity
	 */
	protected function logCron($text) {
		$this->logText .= $text."\n";
		echo $text."\n";
	}
	
	protected function commitLog() {
		if (empty($this->logText)) {
			$this->logText = '(no log)';
		}
		$this->cronEntry->setJob($this->jobname); 
		$this->cronEntry->setOutput($this->logText);
		$this->cronEntry->save();
		$this->logText = '';
	}
	
	public function __destruct() {
		// See if we need to save the log
		if (!empty($this->logText)) {
			$this->commitLog();
		}
	}
}
?>