<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id$
 * @author Ruben Gutierrez ruben@gforgegroup.com
 * @date 2006-02-27
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

class CCHelper {

	function __construct() {
	}

	public static function buildersToJavaScript($options, $selected='', $prefs=array(), $logtypes, $logtype) {
		$session = Session::getSession();
		$Lang = $session->getLanguage();
		$interval = (isset($prefs['build_interval']) ? $prefs['build_interval'] : '60');

		$count = count($options);
		echo "<script type='text/javascript'>\n";
		echo "var builders = new Array($count);\n";
		$i=0;
		foreach($options as $name => $opt) {
			echo "builders[$i] = '$name';\n";
			$i++;
		}
		echo "</script>\n";
		foreach($options as $builder => $opt) {
			echo "<span id='$builder' style=\"display:none; position:relative;\">\n";
			echo "<table border='0' cellspacing='0'>";
			echo "<tr>
					<td><strong>".$Lang->getText('Build.BuildInterval')."</strong><br />
						<input type='text' name='build_interval' value='".$interval."'>
					</td>
				</tr>";

			foreach($opt as $key => $val) {
				$key_name = $builder.'_'.$key;
				$val = (isset($prefs[$key_name]) ? $prefs[$key_name] : $val);
				echo "<tr><td><strong>".ucwords($key)."</strong><br />\n";
				echo "<input type='text' name='$key_name' value='$val'></td></tr>\n";
			}
			echo "<tr>
					<td><strong>".$Lang->getText('Build.LogType')."</strong><br />
						".HTMLWidget::selectBoxFromAssoc($logtypes,'logtype', $logtype, false, false)."
					</td>
				</tr>";
			echo "</table></span>\n";
		}
	
		if (count($options) > 0) {
			echo "<script type='text/javascript'>\n";
			echo "_showHide('$selected', builders);\n";
			echo "</script>\n";
		}
	}
	
	public static function trackerJavaScript($tracker=0) {
		if ($tracker > 0) {
			echo "<script type='text/javascript'>\n";
			echo "_changeOptions('assigned_to[]', $tracker, trackers, techs);\n";
			echo "</script>\n";
		}
	}

	public static function techsToJavaScript($techs, $assignees=array()) {
		$count = count($techs);
		echo "<script type='text/javascript'>\n";
		echo "var trackers = new Array($count);\n";
		echo "var techs    = new Array($count);\n";
		$i=0;
		foreach($techs as $tid => $arr) {
			$countaux = count($arr);
			echo "trackers[$i]  = '$tid';\n";
			echo "techs[$i]     = new Array($countaux);\n";
			$j=0;
			foreach($arr as $id => $name) {
				$selected =  (isset($assignees[$tid][$id]) ? 'true' : 'false');
				echo "techs[$i][$j] = new Array('$name', '$id', $selected);\n";
				$j++;
			}
			$i++;
		}
		echo "</script>\n";
	}
	
	public static function selectBoxFromAssoc($assoc, $select_name, $checked_val='', $options='') {
		$return = '<select name="'.$select_name.'" '.$options.'>';
		foreach ($assoc as $val => $text) {
			$return .= '
				<option value="'.$val.'"';
			if ($val === $checked_val) {
				$return .= ' selected="selected" ';
			}
			$return .= '>'.$text.'</option>';
		}
		$return .= '</select>';
		return $return;
	}
}
?>