<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id$
 * @author Tim Perdue tim@gforge.org
 * @date 2007-09-27
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
require_once 'plugins/build/lib/om/BaseCruisecontrolAssignee.php';
require_once("exceptions/PermissionDeniedException.php");
require_once("GFPermission.interface.php");
require_once("plugin/ActionManager.php");

/** 
 * The skeleton for this class was autogenerated by Propel  * You should add additional methods to this class to meet the
 * application requirements.  This class will only be generated as
 * long as it does not already exist in the output directory.
 *
 * @package plugins.build.lib 
 */
class CruisecontrolAssignee extends BaseCruisecontrolAssignee implements GFPermission {

	/**
	 * isPublic - true/false
	 * @return boolean
	 */
	function isPublic() {
		return $this->getCruisecontrol()->isPublic();
	}

	/**
	 * Specifies if the current user can create an entry in the database for this object
	 *
	 * @return bool
	 * @todo Program the logic
	 */
	public function userCanCreate() {
		return $this->getCruisecontrol()->userCanCreate();
	}

	/**
	 * If this person is an admin for this object
	 * @return boolean
	 */
	private function userIsAdmin() {
		return $this->getCruisecontrol()->userIsAdmin();
	}

	/**
	 * Specifies if the current user can update this object's entry in the database
	 *
	 * @return bool
	 * @todo Program the logic
	 */
	public function userCanUpdate() {
		return $this->getCruisecontrol()->userCanUpdate();
	}
	
	/**
	 * Specifies if the current user can delete this object's entry from the database
	 *
	 * @return bool
	 * @todo Program the logic
	 */
	public function userCanDelete() {
		return $this->getCruisecontrol()->userCanDelete();
	}

	/**
	 * Specifies if the current user has permissions to access this object
	 *
	 * @return bool
	 * @todo Program the logic
	 */
	public function userCanRead() {
		return $this->getCruisecontrol()->userCanRead();
	}

	
	/**
	 * Removes this object from datastore and sets delete attribute. Informs the plugin manager.
	 * This method was added by propel_customizer.php.
	 * 
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 * @see CruisecontrolAssignee::setDeleted()
	 * @see CruisecontrolAssignee::isDeleted()
	 */
	function delete($con = null) {
		if (!$this->userIsAdmin()) {
			throw new PermissionDeniedException("Could not delete CruisecontrolAssignee object: permission denied");
		}
		ActionManager::notify("CRUISECONTROL_ASSIGNEE_DELETE", $this);
		parent::delete($con);		
	}

	/**
	 * Stores the object in the database using the Propel methods. Informs the plugin manager.
	 * This method was added by propel_customizer.php.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
	function save($con = null) {
		if ($this->isNew() && !$this->userIsAdmin()) {
			throw new PermissionDeniedException("Could not create CruisecontrolAssignee object: permission denied");
		} else if (!$this->userIsAdmin()) {
			throw new PermissionDeniedException("Could not update CruisecontrolAssignee object: permission denied");
		}
		parent::save($con);
		ActionManager::notify("CRUISECONTROL_ASSIGNEE_SAVE", $this);
	}


}
?>
