<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id$
 * @author Ruben Gutierrez ruben@gforgegroup.com
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

require_once('plugins/build/lib/html/BuildTemplate.php');

class BuildAdminTemplate extends BuildTemplate {

	function header($params) {	
		if(!isset($params['project']) || !is_object($params['project'])) {
			Throw new exception('Missing project object in tracker template');
		}
		if (!Session::getSession()->isLoggedIn()) {
			Throw new PermissionDeniedException();
		}		
		if(!$params['project']->getPermission()->check(BuildPlugin::SECTION, 0, BuildPlugin::PERMLEVEL_ADMIN)) {
			Throw new PermissionDeniedException();
		}
		$Lang = Session::getSession()->getLanguage();
	
		$this->addBreadCrumb('<a href="'.GFUrl::getUrl()->projectUrl($params['project'],'','build', 'admin').'">Admin</a>');	
		return parent::header($params);
	}

	/**
	 * getTemplateNavElements - this function adds admin menu links
	 * 
	 * @return array - complex array of data.
	 */
	function getTemplateNavElements($params) {
		$pine = $this->getPluginNavElements($params);
		foreach ($pine as $result) {
			$ret[]=$result->getResult();
		}
		if (!isset($params['project'])) {
			echo 'missing project param';
		}
		$ret[] = array(
			'title'=>'CruiseControl',
			'elements'=> array(
			array('link'=>'/gf/project/'.$params['project']->getUnixName().'/build/admin/',
				'description'=>'Admin')
			)
		);

		return $ret;
	}
}

?>