<?php 

require_once 'propel/om/BaseObject.php';

 
require_once 'propel/om/Persistent.php';

 

include_once 'propel/util/Criteria.php';
 

// (on-demand) include_once 'plugins/build/lib/Cruisecontrol.php';
// (on-demand) include_once 'plugins/build/lib/CruisecontrolPeer.php';
 

// (on-demand) include_once 'plugins/build/lib/CruisecontrolDefect.php';
// (on-demand) include_once 'plugins/build/lib/CruisecontrolDefectPeer.php';

include_once 'plugins/build/lib/CruisecontrolBuildPeer.php';

/**
 * Base class that represents a row from the 'cruisecontrol_build' table.
 *
 *  
 *
 * You should not use this class directly.  It should not even be
 * extended; all references should be to CruisecontrolBuild class. 
 * 
 * @package plugins.build.lib 
 */
abstract class BaseCruisecontrolBuild extends BaseObject implements Persistent {
	
	/** 
	 * The Peer class.
	 * Instance provides a convenient way of calling static methods on a class
	 * that calling code may not be able to identify.
	 * @var CruisecontrolBuildPeer
	 */
	protected static $peer;

	/**
	 * The value for the cruisecontrol_build_id field.
	 * @var int	  
	 */
	protected $cruisecontrol_build_id;	

	/**
	 * The value for the cruisecontrol_id field.
	 * @var int	  
	 */
	protected $cruisecontrol_id;	

	/**
	 * The value for the cruisecontrol_defect_id field.
	 * @var int	  
	 */
	protected $cruisecontrol_defect_id;	

	/**
	 * The value for the build_date field.
	 * @var int	  
	 */
	protected $build_date = -1;	

	/**
	 * The value for the was_successful field.
	 * @var boolean	  
	 */
	protected $was_successful = true;	

	/**
	 * The value for the was_fix field.
	 * @var boolean	  
	 */
	protected $was_fix = true;	

	/**
	 * The value for the was_necessary field.
	 * @var boolean	  
	 */
	protected $was_necessary = true;	

	/**
	 * The value for the description field.
	 * @var string	  
	 */
	protected $description;	

	/**
	 * The value for the event_type field.
	 * @var int	  
	 */
	protected $event_type = 0;	
  
	/**
	 * Get the CruisecontrolBuildId column value.
	 *  
	 * @return int	  
	 */
	public function getCruisecontrolBuildId()
	{
		return $this->cruisecontrol_build_id;
	}


	/**
	 * Set the value of `cruisecontrol_build_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setCruisecontrolBuildId($v)
	{
		if ($this->cruisecontrol_build_id !== $v) {
			$this->cruisecontrol_build_id = $v;
			$this->modifiedColumns[] = CruisecontrolBuildPeer::CRUISECONTROL_BUILD_ID;
		}
			
		  // update associated CruisecontrolBuildChangeUser		  
		  if ($this->collCruisecontrolBuildChangeUsers !== null) {
			  for ($i=0,$size=count($this->collCruisecontrolBuildChangeUsers); $i < $size; $i++) {
				  $this->collCruisecontrolBuildChangeUsers[$i]->setCruisecontrolBuildId($v);
			  }
		  }
			  		
	}

  
	/**
	 * Get the CruisecontrolId column value.
	 *  
	 * @return int	  
	 */
	public function getCruisecontrolId()
	{
		return $this->cruisecontrol_id;
	}


	/**
	 * Set the value of `cruisecontrol_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setCruisecontrolId($v)
	{
		if ($this->cruisecontrol_id !== $v) {
			$this->cruisecontrol_id = $v;
			$this->modifiedColumns[] = CruisecontrolBuildPeer::CRUISECONTROL_ID;
		}
			
		if ($this->aCruisecontrol !== null && $this->aCruisecontrol->getCruisecontrolId() !== $v) {
			$this->aCruisecontrol = null;
		}
			
	}

  
	/**
	 * Get the CruisecontrolDefectId column value.
	 *  
	 * @return int	  
	 */
	public function getCruisecontrolDefectId()
	{
		return $this->cruisecontrol_defect_id;
	}


	/**
	 * Set the value of `cruisecontrol_defect_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setCruisecontrolDefectId($v)
	{
		if ($this->cruisecontrol_defect_id !== $v) {
			$this->cruisecontrol_defect_id = $v;
			$this->modifiedColumns[] = CruisecontrolBuildPeer::CRUISECONTROL_DEFECT_ID;
		}
			
		if ($this->aCruisecontrolDefect !== null && $this->aCruisecontrolDefect->getCruisecontrolDefectId() !== $v) {
			$this->aCruisecontrolDefect = null;
		}
			
	}


	/**
	 * Get the [optionally formatted] `build_date` column value.
	 *  
	 * @param string $format The date/time format string (either date()-style or strftime()-style).
	 *							If format is NULL, then the integer unix timestamp will be returned.
	 * @return mixed Formatted date/time value as string or integer unix timestamp (if format is NULL).
	 * @throws PropelException - if unable to convert the date/time to timestamp.
	 */
	public function getBuildDate($format = 'Y-m-d H:i:s')
	{
		if ($this->build_date === null || $this->build_date === '') {
			return null;
		} elseif (!is_int($this->build_date)) {
			// a non-timestamp value was set externally, so we convert it
			$ts = strtotime($this->build_date);
			if ($ts === -1) {
				throw new PropelException("Unable to parse value of build_date as date/time value: " . var_export($this->build_date, true));
			}
		} else {
			$ts = $this->build_date;
		}
		if ($format === null) {
			return $ts;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $ts);
		} else {
			return date($format, $ts);
		}
	}


	/**
	 * Set the value of `build_date` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException - If passed [not-null] date/time is in an invalid format. 
	 */
	public function setBuildDate($v)
	{
		if ($v !== null && !is_int($v)) {
			$ts = strtotime($v);
			if ($ts === -1) {
				throw new PropelException("Unable to parse date/time value for build_date from input: " . var_export($v, true));
			}
		} else {
			$ts = $v;
		}
		if ($this->build_date !== $ts || $ts === -1) {
			$this->build_date = $ts;
			$this->modifiedColumns[] = CruisecontrolBuildPeer::BUILD_DATE;
		}
		
	}

  
	/**
	 * Get the WasSuccessful column value.
	 *  
	 * @return boolean	  
	 */
	public function getWasSuccessful()
	{
		return $this->was_successful;
	}


	/**
	 * Set the value of `was_successful` column.	  
	 *  
	 * @param boolean $v new value
	 * @return void
	 *  
	 */
	public function setWasSuccessful($v)
	{
		if ($this->was_successful !== $v || $v === true) {
			$this->was_successful = $v;
			$this->modifiedColumns[] = CruisecontrolBuildPeer::WAS_SUCCESSFUL;
		}
				
	}

  
	/**
	 * Get the WasFix column value.
	 *  
	 * @return boolean	  
	 */
	public function getWasFix()
	{
		return $this->was_fix;
	}


	/**
	 * Set the value of `was_fix` column.	  
	 *  
	 * @param boolean $v new value
	 * @return void
	 *  
	 */
	public function setWasFix($v)
	{
		if ($this->was_fix !== $v || $v === true) {
			$this->was_fix = $v;
			$this->modifiedColumns[] = CruisecontrolBuildPeer::WAS_FIX;
		}
				
	}

  
	/**
	 * Get the WasNecessary column value.
	 *  
	 * @return boolean	  
	 */
	public function getWasNecessary()
	{
		return $this->was_necessary;
	}


	/**
	 * Set the value of `was_necessary` column.	  
	 *  
	 * @param boolean $v new value
	 * @return void
	 *  
	 */
	public function setWasNecessary($v)
	{
		if ($this->was_necessary !== $v || $v === true) {
			$this->was_necessary = $v;
			$this->modifiedColumns[] = CruisecontrolBuildPeer::WAS_NECESSARY;
		}
				
	}

  
	/**
	 * Get the Description column value.
	 *  
	 * @return string	  
	 */
	public function getDescription()
	{
		return $this->description;
	}


	/**
	 * Set the value of `description` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setDescription($v)
	{
		if ($this->description !== $v) {
			$this->description = $v;
			$this->modifiedColumns[] = CruisecontrolBuildPeer::DESCRIPTION;
		}
				
	}

  
	/**
	 * Get the EventType column value.
	 *  
	 * @return int	  
	 */
	public function getEventType()
	{
		return $this->event_type;
	}


	/**
	 * Set the value of `event_type` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 *  
	 */
	public function setEventType($v)
	{
		if ($this->event_type !== $v || $v === 0) {
			$this->event_type = $v;
			$this->modifiedColumns[] = CruisecontrolBuildPeer::EVENT_TYPE;
		}
				
	}


	
	/**
	 * Hydrates (populates) the object variables with values from the database resultset.
	 *
	 * An offset (1-based "start column") is specified so that objects can be hydrated
	 * with a subset of the columns in the resultset rows.  This is needed, for example,
	 * for results of JOIN queries where the resultset row includes columns from two or
	 * more tables.
	 *
	 * @param ResultSet $rs The ResultSet class with cursor advanced to desired record pos.
	 * @param int $startcol 1-based offset column which indicates which restultset column to start with.
	 * @return void
	 * @throws PropelException  - Any caught Exception will be rewrapped as a PropelException.
	 */
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {
			$this->cruisecontrol_build_id = $rs->getInt($startcol + 0);					
			$this->cruisecontrol_id = $rs->getInt($startcol + 1);					
			$this->cruisecontrol_defect_id = $rs->getInt($startcol + 2);					
			$this->build_date = $rs->getTimestamp($startcol + 3, null);
			$this->was_successful = $rs->getBoolean($startcol + 4);					
			$this->was_fix = $rs->getBoolean($startcol + 5);					
			$this->was_necessary = $rs->getBoolean($startcol + 6);					
			$this->description = $rs->getString($startcol + 7);					
			$this->event_type = $rs->getInt($startcol + 8);					
			 
			$this->resetModified();
			$this->setNew(false);
		
		} catch (Exception $e) {
			throw new PropelException("Error populating CruisecontrolBuild object", $e);
		}		
	
	}
	
	/**
	 * Builds a Criteria object containing the primary key for this object.
	 *
	 * Unlike buildCriteria() this method includes the primary key values regardless
	 * of whether or not they have been modified.
	 * 
	 * @return Criteria The Criteria object containing value(s) for primary key(s).
	 */
	public function buildPkeyCriteria()
	{		
		$criteria = new Criteria(CruisecontrolBuildPeer::DATABASE_NAME);
		$criteria->add(CruisecontrolBuildPeer::CRUISECONTROL_BUILD_ID, $this->cruisecontrol_build_id);
		return $criteria;			
	}
	
	/**
	 * Build a Criteria object containing the values of all modified columns in this object.
	 *
	 * @return Criteria The Criteria object containing all modified values.
	 */
	public function buildCriteria()
	{		
		$criteria = new Criteria(CruisecontrolBuildPeer::DATABASE_NAME);
		if ($this->isColumnModified(CruisecontrolBuildPeer::CRUISECONTROL_BUILD_ID)) $criteria->add(CruisecontrolBuildPeer::CRUISECONTROL_BUILD_ID, $this->cruisecontrol_build_id);
		if ($this->isColumnModified(CruisecontrolBuildPeer::CRUISECONTROL_ID)) $criteria->add(CruisecontrolBuildPeer::CRUISECONTROL_ID, $this->cruisecontrol_id);
		if ($this->isColumnModified(CruisecontrolBuildPeer::CRUISECONTROL_DEFECT_ID)) $criteria->add(CruisecontrolBuildPeer::CRUISECONTROL_DEFECT_ID, $this->cruisecontrol_defect_id);
		if ($this->isColumnModified(CruisecontrolBuildPeer::BUILD_DATE)) $criteria->add(CruisecontrolBuildPeer::BUILD_DATE, $this->build_date);
		if ($this->isColumnModified(CruisecontrolBuildPeer::WAS_SUCCESSFUL)) $criteria->add(CruisecontrolBuildPeer::WAS_SUCCESSFUL, $this->was_successful);
		if ($this->isColumnModified(CruisecontrolBuildPeer::WAS_FIX)) $criteria->add(CruisecontrolBuildPeer::WAS_FIX, $this->was_fix);
		if ($this->isColumnModified(CruisecontrolBuildPeer::WAS_NECESSARY)) $criteria->add(CruisecontrolBuildPeer::WAS_NECESSARY, $this->was_necessary);
		if ($this->isColumnModified(CruisecontrolBuildPeer::DESCRIPTION)) $criteria->add(CruisecontrolBuildPeer::DESCRIPTION, $this->description);
		if ($this->isColumnModified(CruisecontrolBuildPeer::EVENT_TYPE)) $criteria->add(CruisecontrolBuildPeer::EVENT_TYPE, $this->event_type);
		return $criteria;			
	}
	
	

	/**
	 * @var Cruisecontrol	  
	 */
	protected $aCruisecontrol;

	/**
	 * Declares an association between this object and a Cruisecontrol object
	 *
	 * @param Cruisecontrol $v
	 * @return void
	 * @throws PropelException
	 */
	public function setCruisecontrol($v)
	{
			
		if ($v === null) {
			$this->setCruisecontrolId(NULL);
		} else {
			$this->setCruisecontrolId($v->getCruisecontrolId());
		}
   
		$this->aCruisecontrol = $v;
	}


	/**
	 * Get the associated Cruisecontrol object
	 *
	 * @param Connection Optional Connection object.
	 * @return Cruisecontrol The associated Cruisecontrol object.
	 * @throws PropelException
	 */
	public function getCruisecontrol($con = null)
	{
		// include the Peer class
		include_once 'plugins/build/lib/CruisecontrolPeer.php';

		if ($this->aCruisecontrol === null && ($this->cruisecontrol_id !== null)) {
	
			$this->aCruisecontrol = CruisecontrolPeer::retrieveByPK($this->cruisecontrol_id, $con);
	
			/* The following can be used instead of the line above to
			   guarantee the related object contains a reference
			   to this object, but this level of coupling
			   may be undesirable in many circumstances.
			   As it can lead to a db query with many results that may
			   never be used.
			   $obj = CruisecontrolPeer::retrieveByPK($this->cruisecontrol_id, $con);
			   $obj->addCruisecontrolBuilds($this);
			 */
		}
		return $this->aCruisecontrol;
	}

	/**
	 * Provides convenient way to set a relationship based on a
	 * key.  e.g.
	 * <code>$bar->setFooKey($foo->getPrimaryKey())</code>
	 *
 
	 * @return void
	 * @throws PropelException
	 */
	public function setCruisecontrolKey($key)
	{

		$this->setCruisecontrolId( (int) $key);			
		
	}

	/**
	 * @var CruisecontrolDefect	  
	 */
	protected $aCruisecontrolDefect;

	/**
	 * Declares an association between this object and a CruisecontrolDefect object
	 *
	 * @param CruisecontrolDefect $v
	 * @return void
	 * @throws PropelException
	 */
	public function setCruisecontrolDefect($v)
	{
			
		if ($v === null) {
			$this->setCruisecontrolDefectId(NULL);
		} else {
			$this->setCruisecontrolDefectId($v->getCruisecontrolDefectId());
		}
   
		$this->aCruisecontrolDefect = $v;
	}


	/**
	 * Get the associated CruisecontrolDefect object
	 *
	 * @param Connection Optional Connection object.
	 * @return CruisecontrolDefect The associated CruisecontrolDefect object.
	 * @throws PropelException
	 */
	public function getCruisecontrolDefect($con = null)
	{
		// include the Peer class
		include_once 'plugins/build/lib/CruisecontrolDefectPeer.php';

		if ($this->aCruisecontrolDefect === null && ($this->cruisecontrol_defect_id !== null)) {
	
			$this->aCruisecontrolDefect = CruisecontrolDefectPeer::retrieveByPK($this->cruisecontrol_defect_id, $con);
	
			/* The following can be used instead of the line above to
			   guarantee the related object contains a reference
			   to this object, but this level of coupling
			   may be undesirable in many circumstances.
			   As it can lead to a db query with many results that may
			   never be used.
			   $obj = CruisecontrolDefectPeer::retrieveByPK($this->cruisecontrol_defect_id, $con);
			   $obj->addCruisecontrolBuilds($this);
			 */
		}
		return $this->aCruisecontrolDefect;
	}

	/**
	 * Provides convenient way to set a relationship based on a
	 * key.  e.g.
	 * <code>$bar->setFooKey($foo->getPrimaryKey())</code>
	 *
 
	 * @return void
	 * @throws PropelException
	 */
	public function setCruisecontrolDefectKey($key)
	{

		$this->setCruisecontrolDefectId( (int) $key);			
		
	}

	/**
	 * Collection to store aggregation of collCruisecontrolBuildChangeUsers	  
	 * @var array
	 */
	protected $collCruisecontrolBuildChangeUsers; 

	/**
	 * Temporary storage of collCruisecontrolBuildChangeUsers to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initCruisecontrolBuildChangeUsers()
	{
		if ($this->collCruisecontrolBuildChangeUsers === null) {
			$this->collCruisecontrolBuildChangeUsers = array();
		}
	}

	/**
	 * Method called to associate a CruisecontrolBuildChangeUser object to this object
	 * through the CruisecontrolBuildChangeUser foreign key attribute
	 *
	 * @param CruisecontrolBuildChangeUser $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addCruisecontrolBuildChangeUser(CruisecontrolBuildChangeUser $l)
	{
		$this->collCruisecontrolBuildChangeUsers[] = $l;
		$l->setCruisecontrolBuild($this);
	}

	/**
	 * The criteria used to select the current contents of collCruisecontrolBuildChangeUsers.
	 * @var Criteria
	 */
	private $lastCruisecontrolBuildChangeUsersCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this CruisecontrolBuild has previously
	 * been saved, it will retrieve related CruisecontrolBuildChangeUsers from storage.
	 * If this CruisecontrolBuild is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getCruisecontrolBuildChangeUsers($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/build/lib/CruisecontrolBuildChangeUserPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collCruisecontrolBuildChangeUsers === null) {
			if ($this->isNew()) {
			   $this->collCruisecontrolBuildChangeUsers = array();
			} else {
	
				$criteria->add(CruisecontrolBuildChangeUserPeer::CRUISECONTROL_BUILD_ID, $this->getCruisecontrolBuildId() );

				$this->collCruisecontrolBuildChangeUsers = CruisecontrolBuildChangeUserPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(CruisecontrolBuildChangeUserPeer::CRUISECONTROL_BUILD_ID, $this->getCruisecontrolBuildId());

				if (!isset($this->lastCruisecontrolBuildChangeUsersCriteria) || !$this->lastCruisecontrolBuildChangeUsersCriteria->equals($criteria)) {
					$this->collCruisecontrolBuildChangeUsers = CruisecontrolBuildChangeUserPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastCruisecontrolBuildChangeUsersCriteria = $criteria;

		return $this->collCruisecontrolBuildChangeUsers;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this CruisecontrolBuild is new, it will return
	 * an empty collection; or if this CruisecontrolBuild has previously
	 * been saved, it will retrieve related CruisecontrolBuildChangeUsers from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in CruisecontrolBuild.
	 */
	public function getCruisecontrolBuildChangeUsersJoinCruisecontrolBuild($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/build/lib/CruisecontrolBuildChangeUserPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collCruisecontrolBuildChangeUsers === null) {
			if ($this->isNew()) {
			   $this->collCruisecontrolBuildChangeUsers = array();
			} else {
	   
				$criteria->add(CruisecontrolBuildChangeUserPeer::CRUISECONTROL_BUILD_ID, $this->getCruisecontrolBuildId());
				$this->collCruisecontrolBuildChangeUsers = CruisecontrolBuildChangeUserPeer::doSelectJoinCruisecontrolBuild($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(CruisecontrolBuildChangeUserPeer::CRUISECONTROL_BUILD_ID, $this->getCruisecontrolBuildId());
			if (!isset($this->lastCruisecontrolBuildChangeUsersCriteria) || !$this->lastCruisecontrolBuildChangeUsersCriteria->equals($criteria)) {
				$this->collCruisecontrolBuildChangeUsers = CruisecontrolBuildChangeUserPeer::doSelectJoinCruisecontrolBuild($criteria, $con);
			}
		}
		$this->lastCruisecontrolBuildChangeUsersCriteria = $criteria;

		return $this->collCruisecontrolBuildChangeUsers;
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this CruisecontrolBuild is new, it will return
	 * an empty collection; or if this CruisecontrolBuild has previously
	 * been saved, it will retrieve related CruisecontrolBuildChangeUsers from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in CruisecontrolBuild.
	 */
	public function getCruisecontrolBuildChangeUsersJoinUser($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/build/lib/CruisecontrolBuildChangeUserPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collCruisecontrolBuildChangeUsers === null) {
			if ($this->isNew()) {
			   $this->collCruisecontrolBuildChangeUsers = array();
			} else {
	   
				$criteria->add(CruisecontrolBuildChangeUserPeer::CRUISECONTROL_BUILD_ID, $this->getCruisecontrolBuildId());
				$this->collCruisecontrolBuildChangeUsers = CruisecontrolBuildChangeUserPeer::doSelectJoinUser($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(CruisecontrolBuildChangeUserPeer::CRUISECONTROL_BUILD_ID, $this->getCruisecontrolBuildId());
			if (!isset($this->lastCruisecontrolBuildChangeUsersCriteria) || !$this->lastCruisecontrolBuildChangeUsersCriteria->equals($criteria)) {
				$this->collCruisecontrolBuildChangeUsers = CruisecontrolBuildChangeUserPeer::doSelectJoinUser($criteria, $con);
			}
		}
		$this->lastCruisecontrolBuildChangeUsersCriteria = $criteria;

		return $this->collCruisecontrolBuildChangeUsers;
	}

	private $fieldNames;

	/**
	 * Generate a list of field names.
	 *
	 * @return array A list of field names
	 */
	public function getFieldNames()
	{
		if ($this->fieldNames === null) {
			$this->fieldNames = array("cruisecontrol_build_id", "cruisecontrol_id", "cruisecontrol_defect_id", "build_date", "was_successful", "was_fix", "was_necessary", "description", "event_type", );
		}
		return $this->fieldNames;
	}
	
	/**
	 * Retrieves a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @return mixed Value of field.
	 */
	public function getByName($name)
	{
		switch($name) {
	  
			case CruisecontrolBuildPeer::CRUISECONTROL_BUILD_ID:
				return $this->getCruisecontrolBuildId();
				break;
		  
			case CruisecontrolBuildPeer::CRUISECONTROL_ID:
				return $this->getCruisecontrolId();
				break;
		  
			case CruisecontrolBuildPeer::CRUISECONTROL_DEFECT_ID:
				return $this->getCruisecontrolDefectId();
				break;
		  
			case CruisecontrolBuildPeer::BUILD_DATE:
				return $this->getBuildDate();
				break;
		  
			case CruisecontrolBuildPeer::WAS_SUCCESSFUL:
				return $this->getWasSuccessful();
				break;
		  
			case CruisecontrolBuildPeer::WAS_FIX:
				return $this->getWasFix();
				break;
		  
			case CruisecontrolBuildPeer::WAS_NECESSARY:
				return $this->getWasNecessary();
				break;
		  
			case CruisecontrolBuildPeer::DESCRIPTION:
				return $this->getDescription();
				break;
		  
			case CruisecontrolBuildPeer::EVENT_TYPE:
				return $this->getEventType();
				break;
	  
			default:
				return null;
				
		} // switch()
	}

	/**
	 * Retrieves a field from the object by Position as specified in the xml schema. 
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @return mixed Value of field at $pos
	 */
	public function getByPosition($pos)
	{
		switch($pos) {
  
			case 0:
				return $this->getCruisecontrolBuildId();
				break;
  
			case 1:
				return $this->getCruisecontrolId();
				break;
  
			case 2:
				return $this->getCruisecontrolDefectId();
				break;
  
			case 3:
				return $this->getBuildDate();
				break;
  
			case 4:
				return $this->getWasSuccessful();
				break;
  
			case 5:
				return $this->getWasFix();
				break;
  
			case 6:
				return $this->getWasNecessary();
				break;
  
			case 7:
				return $this->getDescription();
				break;
  
			case 8:
				return $this->getEventType();
				break;
			default:
				return null;
		} // switch()
	}



	
	/**
	 * Convenience method to populate the object using an array.
	 * This is particularly useful when populating an object from one of the request arrays (e.g. $_POST).  This method
	 * goest through the column (peer) names, checking to see whether a matching key exists in populated array. If
	 * so the setByName() method is called for that column.
	 * @param array $arr An array where keys are column names.
	 * @return void
	 */
	public function populateFromArray($arr)
	{
  
		if (array_key_exists(CruisecontrolBuildPeer::CRUISECONTROL_BUILD_ID, $arr)) $this->setCruisecontrolBuildId($arr[CruisecontrolBuildPeer::CRUISECONTROL_BUILD_ID]);
  
		if (array_key_exists(CruisecontrolBuildPeer::CRUISECONTROL_ID, $arr)) $this->setCruisecontrolId($arr[CruisecontrolBuildPeer::CRUISECONTROL_ID]);
  
		if (array_key_exists(CruisecontrolBuildPeer::CRUISECONTROL_DEFECT_ID, $arr)) $this->setCruisecontrolDefectId($arr[CruisecontrolBuildPeer::CRUISECONTROL_DEFECT_ID]);
  
		if (array_key_exists(CruisecontrolBuildPeer::BUILD_DATE, $arr)) $this->setBuildDate($arr[CruisecontrolBuildPeer::BUILD_DATE]);
  
		if (array_key_exists(CruisecontrolBuildPeer::WAS_SUCCESSFUL, $arr)) $this->setWasSuccessful($arr[CruisecontrolBuildPeer::WAS_SUCCESSFUL]);
  
		if (array_key_exists(CruisecontrolBuildPeer::WAS_FIX, $arr)) $this->setWasFix($arr[CruisecontrolBuildPeer::WAS_FIX]);
  
		if (array_key_exists(CruisecontrolBuildPeer::WAS_NECESSARY, $arr)) $this->setWasNecessary($arr[CruisecontrolBuildPeer::WAS_NECESSARY]);
  
		if (array_key_exists(CruisecontrolBuildPeer::DESCRIPTION, $arr)) $this->setDescription($arr[CruisecontrolBuildPeer::DESCRIPTION]);
  
		if (array_key_exists(CruisecontrolBuildPeer::EVENT_TYPE, $arr)) $this->setEventType($arr[CruisecontrolBuildPeer::EVENT_TYPE]);
 
	}
	
	/**
	 * Sets a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByName($name, $value)
	{
		switch($name) {
	  
			case CruisecontrolBuildPeer::CRUISECONTROL_BUILD_ID:
				$this->setCruisecontrolBuildId($value);
				break;
	  
			case CruisecontrolBuildPeer::CRUISECONTROL_ID:
				$this->setCruisecontrolId($value);
				break;
	  
			case CruisecontrolBuildPeer::CRUISECONTROL_DEFECT_ID:
				$this->setCruisecontrolDefectId($value);
				break;
	  
			case CruisecontrolBuildPeer::BUILD_DATE:
				$this->setBuildDate($value);
				break;
	  
			case CruisecontrolBuildPeer::WAS_SUCCESSFUL:
				$this->setWasSuccessful($value);
				break;
	  
			case CruisecontrolBuildPeer::WAS_FIX:
				$this->setWasFix($value);
				break;
	  
			case CruisecontrolBuildPeer::WAS_NECESSARY:
				$this->setWasNecessary($value);
				break;
	  
			case CruisecontrolBuildPeer::DESCRIPTION:
				$this->setDescription($value);
				break;
	  
			case CruisecontrolBuildPeer::EVENT_TYPE:
				$this->setEventType($value);
				break;
				  
		} // switch()
	}

	/**
	 * Sets a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByPosition($pos, $value)
	{
		switch($pos) {
  
			case 0:
				$this->setCruisecontrolBuildId($value);
				break;
  
			case 1:
				$this->setCruisecontrolId($value);
				break;
  
			case 2:
				$this->setCruisecontrolDefectId($value);
				break;
  
			case 3:
				$this->setBuildDate($value);
				break;
  
			case 4:
				$this->setWasSuccessful($value);
				break;
  
			case 5:
				$this->setWasFix($value);
				break;
  
			case 6:
				$this->setWasNecessary($value);
				break;
  
			case 7:
				$this->setDescription($value);
				break;
  
			case 8:
				$this->setEventType($value);
				break;
		} // switch()
	}


 
	/**
	 * Removes this object from datastore and sets delete attribute.
	 * 
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 * @see BaseObject::setDeleted()
	 * @see BaseObject::isDeleted()
	 */
	public function delete($con = null)
	{	
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}
		
		if ($con === null)
			$con = Propel::getConnection(CruisecontrolBuildPeer::DATABASE_NAME);

		try {
			$con->begin();
			CruisecontrolBuildPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
	

	/**
	 * flag to prevent endless save loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	private $alreadyInSave = false;

	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.  This method
	 * wraps the doSave() worker method in a transaction.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
	public function save($con = null)
	{
		if ($this->isDeleted()) {
		//	throw new PropelException("You cannot save an object that has been deleted.");
			return;
		}
		
		if ($con === null)
			$con = Propel::getConnection(CruisecontrolBuildPeer::DATABASE_NAME);

		try {
			$con->begin();
			$this->doSave($con);			
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
  
	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
		protected function doSave($con)	{ 
		
	 
		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;

			// We call the save method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.
 
			if ($this->aCruisecontrol !== null) {
				if ($this->aCruisecontrol->isModified()) $this->aCruisecontrol->save($con);
				$this->setCruisecontrol($this->aCruisecontrol);
			}
 
			if ($this->aCruisecontrolDefect !== null) {
				if ($this->aCruisecontrolDefect->isModified()) $this->aCruisecontrolDefect->save($con);
				$this->setCruisecontrolDefect($this->aCruisecontrolDefect);
			}

			// If this object has been modified, then save it to the database.
			if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = CruisecontrolBuildPeer::doInsert($this, $con);
					$this->setCruisecontrolBuildId( $pk );  //[IMV] update autoincrement primary key
					$this->setNew(false);
				} else {
					CruisecontrolBuildPeer::doUpdate($this, $con);
				}			
				$this->resetModified(); // [HL] After being saved an object is no longer 'modified'
			}
			if ($this->collCruisecontrolBuildChangeUsers !== null) {
				for ($i=0,$size=count($this->collCruisecontrolBuildChangeUsers); $i < $size; $i++) {
					$this->collCruisecontrolBuildChangeUsers[$i]->save($con);
				}
			  }

			$this->alreadyInSave = false;
		}
	}

	/**
	 * Validates the objects modified field values.
	 * This includes all objects related to this table.
	 *
	 * If $columns is either a column name or an array of column names
	 * only those columns are validated.
	 *
	 * @param mixed $columns Column name or an array of column names.
	 *
	 * @return mixed <code>true</code> if all columns pass validation
	 *			  or an array of <code>ValidationFailed</code> objects for columns that fail.
	 */
	public function validate($columns = null)
	{
	  if ($columns)
	  {
		return CruisecontrolBuildPeer::doValidate($this, $columns);
	  }

		return $this->doValidate();
	}

	/**
	 * flag to prevent endless validation loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	protected $alreadyInValidation = false;
  
	/**
	 * This function performs the validation work for complex object models.
	 * 
	 * In addition to checking the current object, all related objects will
	 * also be validated.  If all pass then <code>true</code> is returned; otherwise
	 * an aggreagated array of ValidationFailed objects will be returned.
	 *
	 * @return mixed <code>true</code> if all validations pass; array of <code>ValidationFailed</code> objets otherwise.
	 */
	protected function doValidate()
	{
		if (! $this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;
	  
			$failureMap = array();	  
	  
			// We call the validate method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.
			if ($this->aCruisecontrol !== null) {
				if (($retval = $this->aCruisecontrol->validate()) !== true) {
					$failureMap = array_merge($failureMap, $retval);
				}
			}
			if ($this->aCruisecontrolDefect !== null) {
				if (($retval = $this->aCruisecontrolDefect->validate()) !== true) {
					$failureMap = array_merge($failureMap, $retval);
				}
			}

			if (($retval = CruisecontrolBuildPeer::doValidate($this)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}
	  
			if ($this->collCruisecontrolBuildChangeUsers !== null) {
				for ($i=0,$size=count($this->collCruisecontrolBuildChangeUsers); $i < $size; $i++) {
					if (($retval = $this->collCruisecontrolBuildChangeUsers[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
	  
			$this->alreadyInValidation = false;
		}
	
		return (!empty($failureMap) ? $failureMap : true);
	}
  

	/**
	 * Set the PrimaryKey.
	 *
	 * @param mixed cruisecontrol_build_id Primary key.
	 * @return void
	 * @throws PropelException	 */
	public function setPrimaryKey($key) 
	{		
		$this->setCruisecontrolBuildId($key);
	}
	

	/**
	 * Returns an id that differentiates this object from others
	 * of its class.
	 * @return int 
	 */
	public function getPrimaryKey()
	{

		return $this->getCruisecontrolBuildId();

	}

	
	/**
	 * Makes a copy of this object that will be inserted as a new row in table when saved.
	 * It creates a new object filling in the simple attributes, but skipping any primary
	 * keys that are defined for the table.
	 *  
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 *  
	 * @return CruisecontrolBuild Clone of current object.
	 * @throws PropelException
	 */
	public function copy($deepCopy = false) 
	{
		$copyObj = new CruisecontrolBuild();
		$copyObj->setCruisecontrolId($this->cruisecontrol_id);
		$copyObj->setCruisecontrolDefectId($this->cruisecontrol_defect_id);
		$copyObj->setBuildDate($this->build_date);
		$copyObj->setWasSuccessful($this->was_successful);
		$copyObj->setWasFix($this->was_fix);
		$copyObj->setWasNecessary($this->was_necessary);
		$copyObj->setDescription($this->description);
		$copyObj->setEventType($this->event_type);

		if ($deepCopy) {		
			// important: setNew(false) because this affects the behavior of
			// the getter/setter methods for fkey referrer objects.
			$copyObj->setNew(false);

			foreach($this->getCruisecontrolBuildChangeUsers() as $relObj) {
				$copyObj->addCruisecontrolBuildChangeUser($relObj->copy());
			}
		} // if ($deepCopy)
		
		$copyObj->setNew(true);
		
		$copyObj->setCruisecontrolBuildId(NULL); // this is a pkey column, so set to default value

		return $copyObj;
	}
		

	/**
	 * returns a peer instance associated with this om.  Since Peer classes	
	 * are not to have any instance attributes, this method returns the
	 * same instance for all member of this class. The method could therefore
	 * be static, but this would prevent one from overriding the behavior.
	 * @return CruisecontrolBuildPeer
	 */
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new CruisecontrolBuildPeer();
		}
		return self::$peer;
	}

}
