<?php 

require_once 'propel/om/BaseObject.php';

 
require_once 'propel/om/Persistent.php';

 

include_once 'propel/util/Criteria.php';
 

// (on-demand) include_once 'plugins/build/lib/Cruisecontrol.php';
// (on-demand) include_once 'plugins/build/lib/CruisecontrolPeer.php';
 

// (on-demand) include_once 'plugins/tracker/lib/TrackerItem.php';
// (on-demand) include_once 'plugins/tracker/lib/TrackerItemPeer.php';

include_once 'plugins/build/lib/CruisecontrolDefectPeer.php';

/**
 * Base class that represents a row from the 'cruisecontrol_defect' table.
 *
 *  
 *
 * You should not use this class directly.  It should not even be
 * extended; all references should be to CruisecontrolDefect class. 
 * 
 * @package plugins.build.lib 
 */
abstract class BaseCruisecontrolDefect extends BaseObject implements Persistent {
	
	/** 
	 * The Peer class.
	 * Instance provides a convenient way of calling static methods on a class
	 * that calling code may not be able to identify.
	 * @var CruisecontrolDefectPeer
	 */
	protected static $peer;

	/**
	 * The value for the cruisecontrol_defect_id field.
	 * @var int	  
	 */
	protected $cruisecontrol_defect_id;	

	/**
	 * The value for the cruisecontrol_id field.
	 * @var int	  
	 */
	protected $cruisecontrol_id;	

	/**
	 * The value for the tracker_item_id field.
	 * @var int	  
	 */
	protected $tracker_item_id;	

	/**
	 * The value for the open field.
	 * @var boolean	  
	 */
	protected $open = true;	
  
	/**
	 * Get the CruisecontrolDefectId column value.
	 *  
	 * @return int	  
	 */
	public function getCruisecontrolDefectId()
	{
		return $this->cruisecontrol_defect_id;
	}


	/**
	 * Set the value of `cruisecontrol_defect_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setCruisecontrolDefectId($v)
	{
		if ($this->cruisecontrol_defect_id !== $v) {
			$this->cruisecontrol_defect_id = $v;
			$this->modifiedColumns[] = CruisecontrolDefectPeer::CRUISECONTROL_DEFECT_ID;
		}
			
		  // update associated CruisecontrolBuild		  
		  if ($this->collCruisecontrolBuilds !== null) {
			  for ($i=0,$size=count($this->collCruisecontrolBuilds); $i < $size; $i++) {
				  $this->collCruisecontrolBuilds[$i]->setCruisecontrolDefectId($v);
			  }
		  }
			  		
	}

  
	/**
	 * Get the CruisecontrolId column value.
	 *  
	 * @return int	  
	 */
	public function getCruisecontrolId()
	{
		return $this->cruisecontrol_id;
	}


	/**
	 * Set the value of `cruisecontrol_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setCruisecontrolId($v)
	{
		if ($this->cruisecontrol_id !== $v) {
			$this->cruisecontrol_id = $v;
			$this->modifiedColumns[] = CruisecontrolDefectPeer::CRUISECONTROL_ID;
		}
			
		if ($this->aCruisecontrol !== null && $this->aCruisecontrol->getCruisecontrolId() !== $v) {
			$this->aCruisecontrol = null;
		}
			
	}

  
	/**
	 * Get the TrackerItemId column value.
	 *  
	 * @return int	  
	 */
	public function getTrackerItemId()
	{
		return $this->tracker_item_id;
	}


	/**
	 * Set the value of `tracker_item_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setTrackerItemId($v)
	{
		if ($this->tracker_item_id !== $v) {
			$this->tracker_item_id = $v;
			$this->modifiedColumns[] = CruisecontrolDefectPeer::TRACKER_ITEM_ID;
		}
			
		if ($this->aTrackerItem !== null && $this->aTrackerItem->getTrackerItemId() !== $v) {
			$this->aTrackerItem = null;
		}
			
	}

  
	/**
	 * Get the Open column value.
	 *  
	 * @return boolean	  
	 */
	public function getOpen()
	{
		return $this->open;
	}


	/**
	 * Set the value of `open` column.	  
	 *  
	 * @param boolean $v new value
	 * @return void
	 *  
	 */
	public function setOpen($v)
	{
		if ($this->open !== $v || $v === true) {
			$this->open = $v;
			$this->modifiedColumns[] = CruisecontrolDefectPeer::OPEN;
		}
				
	}


	
	/**
	 * Hydrates (populates) the object variables with values from the database resultset.
	 *
	 * An offset (1-based "start column") is specified so that objects can be hydrated
	 * with a subset of the columns in the resultset rows.  This is needed, for example,
	 * for results of JOIN queries where the resultset row includes columns from two or
	 * more tables.
	 *
	 * @param ResultSet $rs The ResultSet class with cursor advanced to desired record pos.
	 * @param int $startcol 1-based offset column which indicates which restultset column to start with.
	 * @return void
	 * @throws PropelException  - Any caught Exception will be rewrapped as a PropelException.
	 */
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {
			$this->cruisecontrol_defect_id = $rs->getInt($startcol + 0);					
			$this->cruisecontrol_id = $rs->getInt($startcol + 1);					
			$this->tracker_item_id = $rs->getInt($startcol + 2);					
			$this->open = $rs->getBoolean($startcol + 3);					
			 
			$this->resetModified();
			$this->setNew(false);
		
		} catch (Exception $e) {
			throw new PropelException("Error populating CruisecontrolDefect object", $e);
		}		
	
	}
	
	/**
	 * Builds a Criteria object containing the primary key for this object.
	 *
	 * Unlike buildCriteria() this method includes the primary key values regardless
	 * of whether or not they have been modified.
	 * 
	 * @return Criteria The Criteria object containing value(s) for primary key(s).
	 */
	public function buildPkeyCriteria()
	{		
		$criteria = new Criteria(CruisecontrolDefectPeer::DATABASE_NAME);
		$criteria->add(CruisecontrolDefectPeer::CRUISECONTROL_DEFECT_ID, $this->cruisecontrol_defect_id);
		return $criteria;			
	}
	
	/**
	 * Build a Criteria object containing the values of all modified columns in this object.
	 *
	 * @return Criteria The Criteria object containing all modified values.
	 */
	public function buildCriteria()
	{		
		$criteria = new Criteria(CruisecontrolDefectPeer::DATABASE_NAME);
		if ($this->isColumnModified(CruisecontrolDefectPeer::CRUISECONTROL_DEFECT_ID)) $criteria->add(CruisecontrolDefectPeer::CRUISECONTROL_DEFECT_ID, $this->cruisecontrol_defect_id);
		if ($this->isColumnModified(CruisecontrolDefectPeer::CRUISECONTROL_ID)) $criteria->add(CruisecontrolDefectPeer::CRUISECONTROL_ID, $this->cruisecontrol_id);
		if ($this->isColumnModified(CruisecontrolDefectPeer::TRACKER_ITEM_ID)) $criteria->add(CruisecontrolDefectPeer::TRACKER_ITEM_ID, $this->tracker_item_id);
		if ($this->isColumnModified(CruisecontrolDefectPeer::OPEN)) $criteria->add(CruisecontrolDefectPeer::OPEN, $this->open);
		return $criteria;			
	}
	
	

	/**
	 * @var Cruisecontrol	  
	 */
	protected $aCruisecontrol;

	/**
	 * Declares an association between this object and a Cruisecontrol object
	 *
	 * @param Cruisecontrol $v
	 * @return void
	 * @throws PropelException
	 */
	public function setCruisecontrol($v)
	{
			
		if ($v === null) {
			$this->setCruisecontrolId(NULL);
		} else {
			$this->setCruisecontrolId($v->getCruisecontrolId());
		}
   
		$this->aCruisecontrol = $v;
	}


	/**
	 * Get the associated Cruisecontrol object
	 *
	 * @param Connection Optional Connection object.
	 * @return Cruisecontrol The associated Cruisecontrol object.
	 * @throws PropelException
	 */
	public function getCruisecontrol($con = null)
	{
		// include the Peer class
		include_once 'plugins/build/lib/CruisecontrolPeer.php';

		if ($this->aCruisecontrol === null && ($this->cruisecontrol_id !== null)) {
	
			$this->aCruisecontrol = CruisecontrolPeer::retrieveByPK($this->cruisecontrol_id, $con);
	
			/* The following can be used instead of the line above to
			   guarantee the related object contains a reference
			   to this object, but this level of coupling
			   may be undesirable in many circumstances.
			   As it can lead to a db query with many results that may
			   never be used.
			   $obj = CruisecontrolPeer::retrieveByPK($this->cruisecontrol_id, $con);
			   $obj->addCruisecontrolDefects($this);
			 */
		}
		return $this->aCruisecontrol;
	}

	/**
	 * Provides convenient way to set a relationship based on a
	 * key.  e.g.
	 * <code>$bar->setFooKey($foo->getPrimaryKey())</code>
	 *
 
	 * @return void
	 * @throws PropelException
	 */
	public function setCruisecontrolKey($key)
	{

		$this->setCruisecontrolId( (int) $key);			
		
	}

	/**
	 * @var TrackerItem	  
	 */
	protected $aTrackerItem;

	/**
	 * Declares an association between this object and a TrackerItem object
	 *
	 * @param TrackerItem $v
	 * @return void
	 * @throws PropelException
	 */
	public function setTrackerItem($v)
	{
			
		if ($v === null) {
			$this->setTrackerItemId(NULL);
		} else {
			$this->setTrackerItemId($v->getTrackerItemId());
		}
   
		$this->aTrackerItem = $v;
	}


	/**
	 * Get the associated TrackerItem object
	 *
	 * @param Connection Optional Connection object.
	 * @return TrackerItem The associated TrackerItem object.
	 * @throws PropelException
	 */
	public function getTrackerItem($con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerItemPeer.php';

		if ($this->aTrackerItem === null && ($this->tracker_item_id !== null)) {
	
			$this->aTrackerItem = TrackerItemPeer::retrieveByPK($this->tracker_item_id, $con);
	
			/* The following can be used instead of the line above to
			   guarantee the related object contains a reference
			   to this object, but this level of coupling
			   may be undesirable in many circumstances.
			   As it can lead to a db query with many results that may
			   never be used.
			   $obj = TrackerItemPeer::retrieveByPK($this->tracker_item_id, $con);
			   $obj->addCruisecontrolDefects($this);
			 */
		}
		return $this->aTrackerItem;
	}

	/**
	 * Provides convenient way to set a relationship based on a
	 * key.  e.g.
	 * <code>$bar->setFooKey($foo->getPrimaryKey())</code>
	 *
 
	 * @return void
	 * @throws PropelException
	 */
	public function setTrackerItemKey($key)
	{

		$this->setTrackerItemId( (int) $key);			
		
	}

	/**
	 * Collection to store aggregation of collCruisecontrolBuilds	  
	 * @var array
	 */
	protected $collCruisecontrolBuilds; 

	/**
	 * Temporary storage of collCruisecontrolBuilds to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initCruisecontrolBuilds()
	{
		if ($this->collCruisecontrolBuilds === null) {
			$this->collCruisecontrolBuilds = array();
		}
	}

	/**
	 * Method called to associate a CruisecontrolBuild object to this object
	 * through the CruisecontrolBuild foreign key attribute
	 *
	 * @param CruisecontrolBuild $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addCruisecontrolBuild(CruisecontrolBuild $l)
	{
		$this->collCruisecontrolBuilds[] = $l;
		$l->setCruisecontrolDefect($this);
	}

	/**
	 * The criteria used to select the current contents of collCruisecontrolBuilds.
	 * @var Criteria
	 */
	private $lastCruisecontrolBuildsCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this CruisecontrolDefect has previously
	 * been saved, it will retrieve related CruisecontrolBuilds from storage.
	 * If this CruisecontrolDefect is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getCruisecontrolBuilds($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/build/lib/CruisecontrolBuildPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collCruisecontrolBuilds === null) {
			if ($this->isNew()) {
			   $this->collCruisecontrolBuilds = array();
			} else {
	
				$criteria->add(CruisecontrolBuildPeer::CRUISECONTROL_DEFECT_ID, $this->getCruisecontrolDefectId() );

				$this->collCruisecontrolBuilds = CruisecontrolBuildPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(CruisecontrolBuildPeer::CRUISECONTROL_DEFECT_ID, $this->getCruisecontrolDefectId());

				if (!isset($this->lastCruisecontrolBuildsCriteria) || !$this->lastCruisecontrolBuildsCriteria->equals($criteria)) {
					$this->collCruisecontrolBuilds = CruisecontrolBuildPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastCruisecontrolBuildsCriteria = $criteria;

		return $this->collCruisecontrolBuilds;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this CruisecontrolDefect is new, it will return
	 * an empty collection; or if this CruisecontrolDefect has previously
	 * been saved, it will retrieve related CruisecontrolBuilds from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in CruisecontrolDefect.
	 */
	public function getCruisecontrolBuildsJoinCruisecontrol($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/build/lib/CruisecontrolBuildPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collCruisecontrolBuilds === null) {
			if ($this->isNew()) {
			   $this->collCruisecontrolBuilds = array();
			} else {
	   
				$criteria->add(CruisecontrolBuildPeer::CRUISECONTROL_DEFECT_ID, $this->getCruisecontrolDefectId());
				$this->collCruisecontrolBuilds = CruisecontrolBuildPeer::doSelectJoinCruisecontrol($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(CruisecontrolBuildPeer::CRUISECONTROL_DEFECT_ID, $this->getCruisecontrolDefectId());
			if (!isset($this->lastCruisecontrolBuildsCriteria) || !$this->lastCruisecontrolBuildsCriteria->equals($criteria)) {
				$this->collCruisecontrolBuilds = CruisecontrolBuildPeer::doSelectJoinCruisecontrol($criteria, $con);
			}
		}
		$this->lastCruisecontrolBuildsCriteria = $criteria;

		return $this->collCruisecontrolBuilds;
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this CruisecontrolDefect is new, it will return
	 * an empty collection; or if this CruisecontrolDefect has previously
	 * been saved, it will retrieve related CruisecontrolBuilds from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in CruisecontrolDefect.
	 */
	public function getCruisecontrolBuildsJoinCruisecontrolDefect($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/build/lib/CruisecontrolBuildPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collCruisecontrolBuilds === null) {
			if ($this->isNew()) {
			   $this->collCruisecontrolBuilds = array();
			} else {
	   
				$criteria->add(CruisecontrolBuildPeer::CRUISECONTROL_DEFECT_ID, $this->getCruisecontrolDefectId());
				$this->collCruisecontrolBuilds = CruisecontrolBuildPeer::doSelectJoinCruisecontrolDefect($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(CruisecontrolBuildPeer::CRUISECONTROL_DEFECT_ID, $this->getCruisecontrolDefectId());
			if (!isset($this->lastCruisecontrolBuildsCriteria) || !$this->lastCruisecontrolBuildsCriteria->equals($criteria)) {
				$this->collCruisecontrolBuilds = CruisecontrolBuildPeer::doSelectJoinCruisecontrolDefect($criteria, $con);
			}
		}
		$this->lastCruisecontrolBuildsCriteria = $criteria;

		return $this->collCruisecontrolBuilds;
	}

	private $fieldNames;

	/**
	 * Generate a list of field names.
	 *
	 * @return array A list of field names
	 */
	public function getFieldNames()
	{
		if ($this->fieldNames === null) {
			$this->fieldNames = array("cruisecontrol_defect_id", "cruisecontrol_id", "tracker_item_id", "open", );
		}
		return $this->fieldNames;
	}
	
	/**
	 * Retrieves a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @return mixed Value of field.
	 */
	public function getByName($name)
	{
		switch($name) {
	  
			case CruisecontrolDefectPeer::CRUISECONTROL_DEFECT_ID:
				return $this->getCruisecontrolDefectId();
				break;
		  
			case CruisecontrolDefectPeer::CRUISECONTROL_ID:
				return $this->getCruisecontrolId();
				break;
		  
			case CruisecontrolDefectPeer::TRACKER_ITEM_ID:
				return $this->getTrackerItemId();
				break;
		  
			case CruisecontrolDefectPeer::OPEN:
				return $this->getOpen();
				break;
	  
			default:
				return null;
				
		} // switch()
	}

	/**
	 * Retrieves a field from the object by Position as specified in the xml schema. 
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @return mixed Value of field at $pos
	 */
	public function getByPosition($pos)
	{
		switch($pos) {
  
			case 0:
				return $this->getCruisecontrolDefectId();
				break;
  
			case 1:
				return $this->getCruisecontrolId();
				break;
  
			case 2:
				return $this->getTrackerItemId();
				break;
  
			case 3:
				return $this->getOpen();
				break;
			default:
				return null;
		} // switch()
	}



	
	/**
	 * Convenience method to populate the object using an array.
	 * This is particularly useful when populating an object from one of the request arrays (e.g. $_POST).  This method
	 * goest through the column (peer) names, checking to see whether a matching key exists in populated array. If
	 * so the setByName() method is called for that column.
	 * @param array $arr An array where keys are column names.
	 * @return void
	 */
	public function populateFromArray($arr)
	{
  
		if (array_key_exists(CruisecontrolDefectPeer::CRUISECONTROL_DEFECT_ID, $arr)) $this->setCruisecontrolDefectId($arr[CruisecontrolDefectPeer::CRUISECONTROL_DEFECT_ID]);
  
		if (array_key_exists(CruisecontrolDefectPeer::CRUISECONTROL_ID, $arr)) $this->setCruisecontrolId($arr[CruisecontrolDefectPeer::CRUISECONTROL_ID]);
  
		if (array_key_exists(CruisecontrolDefectPeer::TRACKER_ITEM_ID, $arr)) $this->setTrackerItemId($arr[CruisecontrolDefectPeer::TRACKER_ITEM_ID]);
  
		if (array_key_exists(CruisecontrolDefectPeer::OPEN, $arr)) $this->setOpen($arr[CruisecontrolDefectPeer::OPEN]);
 
	}
	
	/**
	 * Sets a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByName($name, $value)
	{
		switch($name) {
	  
			case CruisecontrolDefectPeer::CRUISECONTROL_DEFECT_ID:
				$this->setCruisecontrolDefectId($value);
				break;
	  
			case CruisecontrolDefectPeer::CRUISECONTROL_ID:
				$this->setCruisecontrolId($value);
				break;
	  
			case CruisecontrolDefectPeer::TRACKER_ITEM_ID:
				$this->setTrackerItemId($value);
				break;
	  
			case CruisecontrolDefectPeer::OPEN:
				$this->setOpen($value);
				break;
				  
		} // switch()
	}

	/**
	 * Sets a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByPosition($pos, $value)
	{
		switch($pos) {
  
			case 0:
				$this->setCruisecontrolDefectId($value);
				break;
  
			case 1:
				$this->setCruisecontrolId($value);
				break;
  
			case 2:
				$this->setTrackerItemId($value);
				break;
  
			case 3:
				$this->setOpen($value);
				break;
		} // switch()
	}


 
	/**
	 * Removes this object from datastore and sets delete attribute.
	 * 
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 * @see BaseObject::setDeleted()
	 * @see BaseObject::isDeleted()
	 */
	public function delete($con = null)
	{	
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}
		
		if ($con === null)
			$con = Propel::getConnection(CruisecontrolDefectPeer::DATABASE_NAME);

		try {
			$con->begin();
			CruisecontrolDefectPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
	

	/**
	 * flag to prevent endless save loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	private $alreadyInSave = false;

	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.  This method
	 * wraps the doSave() worker method in a transaction.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
	public function save($con = null)
	{
		if ($this->isDeleted()) {
		//	throw new PropelException("You cannot save an object that has been deleted.");
			return;
		}
		
		if ($con === null)
			$con = Propel::getConnection(CruisecontrolDefectPeer::DATABASE_NAME);

		try {
			$con->begin();
			$this->doSave($con);			
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
  
	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
		protected function doSave($con)	{ 
		
	 
		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;

			// We call the save method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.
 
			if ($this->aCruisecontrol !== null) {
				if ($this->aCruisecontrol->isModified()) $this->aCruisecontrol->save($con);
				$this->setCruisecontrol($this->aCruisecontrol);
			}
 
			if ($this->aTrackerItem !== null) {
				if ($this->aTrackerItem->isModified()) $this->aTrackerItem->save($con);
				$this->setTrackerItem($this->aTrackerItem);
			}

			// If this object has been modified, then save it to the database.
			if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = CruisecontrolDefectPeer::doInsert($this, $con);
					$this->setCruisecontrolDefectId( $pk );  //[IMV] update autoincrement primary key
					$this->setNew(false);
				} else {
					CruisecontrolDefectPeer::doUpdate($this, $con);
				}			
				$this->resetModified(); // [HL] After being saved an object is no longer 'modified'
			}
			if ($this->collCruisecontrolBuilds !== null) {
				for ($i=0,$size=count($this->collCruisecontrolBuilds); $i < $size; $i++) {
					$this->collCruisecontrolBuilds[$i]->save($con);
				}
			  }

			$this->alreadyInSave = false;
		}
	}

	/**
	 * Validates the objects modified field values.
	 * This includes all objects related to this table.
	 *
	 * If $columns is either a column name or an array of column names
	 * only those columns are validated.
	 *
	 * @param mixed $columns Column name or an array of column names.
	 *
	 * @return mixed <code>true</code> if all columns pass validation
	 *			  or an array of <code>ValidationFailed</code> objects for columns that fail.
	 */
	public function validate($columns = null)
	{
	  if ($columns)
	  {
		return CruisecontrolDefectPeer::doValidate($this, $columns);
	  }

		return $this->doValidate();
	}

	/**
	 * flag to prevent endless validation loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	protected $alreadyInValidation = false;
  
	/**
	 * This function performs the validation work for complex object models.
	 * 
	 * In addition to checking the current object, all related objects will
	 * also be validated.  If all pass then <code>true</code> is returned; otherwise
	 * an aggreagated array of ValidationFailed objects will be returned.
	 *
	 * @return mixed <code>true</code> if all validations pass; array of <code>ValidationFailed</code> objets otherwise.
	 */
	protected function doValidate()
	{
		if (! $this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;
	  
			$failureMap = array();	  
	  
			// We call the validate method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.
			if ($this->aCruisecontrol !== null) {
				if (($retval = $this->aCruisecontrol->validate()) !== true) {
					$failureMap = array_merge($failureMap, $retval);
				}
			}
			if ($this->aTrackerItem !== null) {
				if (($retval = $this->aTrackerItem->validate()) !== true) {
					$failureMap = array_merge($failureMap, $retval);
				}
			}

			if (($retval = CruisecontrolDefectPeer::doValidate($this)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}
	  
			if ($this->collCruisecontrolBuilds !== null) {
				for ($i=0,$size=count($this->collCruisecontrolBuilds); $i < $size; $i++) {
					if (($retval = $this->collCruisecontrolBuilds[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
	  
			$this->alreadyInValidation = false;
		}
	
		return (!empty($failureMap) ? $failureMap : true);
	}
  

	/**
	 * Set the PrimaryKey.
	 *
	 * @param mixed cruisecontrol_defect_id Primary key.
	 * @return void
	 * @throws PropelException	 */
	public function setPrimaryKey($key) 
	{		
		$this->setCruisecontrolDefectId($key);
	}
	

	/**
	 * Returns an id that differentiates this object from others
	 * of its class.
	 * @return int 
	 */
	public function getPrimaryKey()
	{

		return $this->getCruisecontrolDefectId();

	}

	
	/**
	 * Makes a copy of this object that will be inserted as a new row in table when saved.
	 * It creates a new object filling in the simple attributes, but skipping any primary
	 * keys that are defined for the table.
	 *  
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 *  
	 * @return CruisecontrolDefect Clone of current object.
	 * @throws PropelException
	 */
	public function copy($deepCopy = false) 
	{
		$copyObj = new CruisecontrolDefect();
		$copyObj->setCruisecontrolId($this->cruisecontrol_id);
		$copyObj->setTrackerItemId($this->tracker_item_id);
		$copyObj->setOpen($this->open);

		if ($deepCopy) {		
			// important: setNew(false) because this affects the behavior of
			// the getter/setter methods for fkey referrer objects.
			$copyObj->setNew(false);

			foreach($this->getCruisecontrolBuilds() as $relObj) {
				$copyObj->addCruisecontrolBuild($relObj->copy());
			}
		} // if ($deepCopy)
		
		$copyObj->setNew(true);
		
		$copyObj->setCruisecontrolDefectId(NULL); // this is a pkey column, so set to default value

		return $copyObj;
	}
		

	/**
	 * returns a peer instance associated with this om.  Since Peer classes	
	 * are not to have any instance attributes, this method returns the
	 * same instance for all member of this class. The method could therefore
	 * be static, but this would prevent one from overriding the behavior.
	 * @return CruisecontrolDefectPeer
	 */
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new CruisecontrolDefectPeer();
		}
		return self::$peer;
	}

}
