<?php
require_once('plugins/build/lib/CruisecontrolPlatformPeer.php');

// Get all platforms for this project
$crit = new Criteria();
$crit->add(CruisecontrolPlatformPeer::PROJECT_ID, $Project->getProjectId());
$CCPlatforms = CruisecontrolPlatformPeer::doSelect($crit);

echo '<h3>'.$Lang->getText('Build.LastBuildStatusTitle').'</h3>';

$theader = array();
$theader[] = $Lang->getText('Build.Platform');
$theader[] = $Lang->getText('Build.ExternalBuildStatus');
$theader[] = $Lang->getText('Build.ExternalBuildDate');
$theader[] = $Lang->getText('Build.ExternalBuildLabel');
$theader[] = $Lang->getText('Build.ExternalPreviousStatus');
$theader[] = $Lang->getText('Build.ExternalNecessary');
$theader[] = $Lang->getText('Build.ExternalWasFix');
$theader[] = $Lang->getText('Build.ExternalUsers');
$theader[] = $Lang->getText('Build.ExternalLink');
echo $theme->tableTop($theader);

foreach($CCPlatforms as $CCPlatform) {
	$data = array($CCPlatform->getName());
	$helper = LogFactory::getPlatformLog($CCPlatform->getCruisecontrolPlatformId());
	$ti = $CCPlatform->getTrackerItem();
	if ($helper != null && is_object($helper)) {
		$data[] = ($helper->isBuildSuccessful() ? 
						'<font color=\'#009900\'><b>'.$Lang->getText('Build.BuildSucceed').'</b></font>' : 
						'<font color=\'#FF0000\'><b>'.$Lang->getText('Build.BuildFailed').'</b></font>');
		$data[] = $helper->getBuildTimestamp();
		$data[] = $helper->getLabel();
		$data[] = ($helper->wasPreviousBuildSuccessful() ? 
						'<font color=\'#009900\'><b>'.$Lang->getText('Build.BuildSucceed').'</b></font>' : 
						'<font color=\'#FF0000\'><b>'.$Lang->getText('Build.BuildFailed').'</b></font>');
		$data[] = ($helper->wasBuildNecessary() ? 
						$Lang->getText('Common.Yes') : $Lang->getText('Common.No'));
		$data[] = ($helper->isBuildFix() ? 
						$Lang->getText('Common.Yes') : $Lang->getText('Common.No'));
						
		$users = array_keys($helper->getBuildParticipants());
		$data[] = implode('<br />', $users);
		if ($ti != null) {
			$data[] = '[<a href="'. GFUrl::getUrl()->projectUrl($params['project'],'TrackerItemEdit','tracker').
						'&tracker_id='.$ti->getTrackerId().'&amp;tracker_item_id='.$ti->getTrackerItemID() .'">#'.$ti->getTrackerItemID().'</a>]';
		} else {
			$data[] = '';
		}
	} else {
		$unknown = '<i>'.$Lang->getText('Build.Unknown').'</i>';
		$data[] = $unknown;
		$data[] = $unknown;
		$data[] = $unknown;
		$data[] = $unknown;
		$data[] = $unknown;
		$data[] = $unknown;
		$data[] = '';
		$data[] = '';
	}
	echo $theme->tableRow($data);
}

echo $theme->tableBottom();
?>