<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code lists Cruisecontrol
//
require_once('plugins/build/lib/CruisecontrolPeer.php');
require_once('plugins/build/lib/CruisecontrolBuildPeer.php');
require_once('plugins/build/lib/Cruisecontrol.php');
require_once('lib/html/HTMLWidget.php');

$session = Session::getSession();
$Lang = $session->getLanguage();

require_once('plugins/build/lib/html/BuildTemplate.php');
$theme = new BuildTemplate();

$Project = GFUrl::getUrl()->getProject();

$params = array(
		'project' => $Project,
		'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : ''),
		'title' => $Lang->getText('Build.HistoryPageTitle')
		);
$theme->addBreadCrumb('<a href="'. GFUrl::getUrl()->currentBaseUrl('BuildHistory').'">'.$Lang->getText('Build.HistoryPageTitle').'</a>');	
$theme->header($params);


$theader = array();
$theader[] = $Lang->getText('Build.BuildDate');
$theader[] = $Lang->getText('Build.EventType');
$theader[] = $Lang->getText('Build.BuildStatus');
$theader[] = $Lang->getText('Build.WasBuildNecessary');
$theader[] = $Lang->getText('Build.WasBuildFix');
$theader[] = $Lang->getText('Build.TicketLink');

$cruisecontrol_id = ((isset($_REQUEST['cruisecontrol_id'])) ? $_REQUEST['cruisecontrol_id'] : 0 );
$begin=((isset($_REQUEST['start_date']) && strlen($_REQUEST['start_date']) > 5) ? $_REQUEST['start_date'] : 0 );
$end=((isset($_REQUEST['end_date']) && strlen($_REQUEST['end_date']) > 5) ? $_REQUEST['end_date'] : 0 );

if ($begin=='0') {
        $begin = (time()-(86400));
} else {
        $begin = strtotime($begin);
}
if ($end=='0') {
        $end = time();                                                                                                                          } else {
        $end=strtotime($end)+86399;
}
if ($begin > $end) {
        $endtmp=$end;
        $end=$begin;
        $begin=$endtmp;
}

$params = array(
                'project' => $Project,
                'feedback' => (isset($feedback) ? $feedback : ''),
                'title' => $Lang->getText('CruiseControlBuildReport.Title')
               );

$theme->header($params);

// Retrieve the objects array
$crit = new Criteria();
$crit->add(CruisecontrolPeer::PROJECT_ID, $Project->getProjectId());
$CControls = CruisecontrolPeer::doSelect($crit);

$cruisecontrols = array();
$cruisecontrols[0]=$Lang->getText('Build.AllConfigurations');

foreach ($CControls as $CControl) {
	$cruisecontrols[$CControl->getCruisecontrolId()]=$CControl->getBuildName();
}
?>
<script language="javascript" type="text/javascript" src="/datetimepicker.js"></script>

<table border="0" cellspacing="0" cellpadding="3" bgcolor="#E0E0E0">
<form action="<?php echo $_SERVER['REQUEST_URI']; ?>" method="post">
<tr>
	<td><strong><?php echo $Lang->getText('Build.Configuration') ?></strong></td>
	<td><strong><?php echo $Lang->getText('Build.StartDate') ?></strong></td>
	<td><strong><?php echo $Lang->getText('Build.EndDate') ?></strong></td>
	<td>&nbsp;</td>
</tr>
<tr>
	<td valign="top"><?php echo HTMLWidget::selectBoxFromAssoc($cruisecontrols,'cruisecontrol_id',$cruisecontrol_id,false,false) ?></td>
    <td><input id="startdate" name="start_date" value="<?php echo date('M d Y',$begin); ?>" size="11" maxlength="11" /><a href="javascript:NewCal('startdate','MMMddyyyy')"><img src="/themes/gforge5/images/cal.gif" width="16" height="16" border="0" alt="Pick a date"/></a></td>
	<td><input id="enddate" name="end_date" value="<?php echo date('M d Y',$end); ?>" size="11" maxlength="11" /><a href="javascript:NewCal('enddate','MMMddyyyy')"><img src="/themes/gforge5/images/cal.gif" width="16" height="16" border="0" alt="Pick a date"/></a></td>
	<td><?php echo HTMLWidget::button("submit","" .   $Lang->getText('Common.Submit')  . " ","submit","","")?></td>
</tr>
</form>
</table>
<br />
<br />
<?php

if (count($CControls) < 1) {
	echo $theme->tableTop($theader);
	echo $theme->tableFullRow('<span class="nonefound">'.$Lang->getText('Build.NoneFound').'</span>');
	echo $theme->tableBottom();
} else {
	foreach ($CControls as $CControl) {
		if ($cruisecontrol_id > 0 && $CControl->getCruisecontrolId() != $cruisecontrol_id) {
			continue;
		}
		
		$crit = new Criteria();
		$crit->add(CruisecontrolBuildPeer::CRUISECONTROL_ID, $CControl->getCruisecontrolId());
		$criterion = $crit->getNewCriterion(CruisecontrolBuildPeer::BUILD_DATE , date('Y-m-d', $begin).' 00:00:00', Criteria::GREATER_EQUAL  );
		$criterion->addAnd($crit->getNewCriterion(CruisecontrolBuildPeer::BUILD_DATE , date('Y-m-d', $end).' 23:59:59', Criteria::LESS_EQUAL ));
		$crit->add($criterion);
		$crit->addDescendingOrderByColumn(CruisecontrolBuildPeer::BUILD_DATE);
		$CCBuilds = CruisecontrolBuildPeer::doSelect($crit);
		
		echo '<h2>'.$CControl->getBuildName().'</h2>';
		echo $theme->tableTop($theader);
		foreach($CCBuilds as $CCBuild) {
			$unknown = '<i>'.$Lang->getText('Build.Unknown').'</i>';
			$trow = array();
			if (!$CCBuild || !is_object($CCBuild)) {
				$trow[]=$unknown;
				$trow[]=$unknown;
				$trow[]=$unknown;
				$trow[]=$unknown;
				$trow[]=$unknown;
			} else {
				$trow[]=$CCBuild->getBuildDate();
				$trow[]='<font color=\'#009900\'><b>'.CruiseControlBuildPeer::getEventTypeDescription($CCBuild->getEventType()).'</b></font>';
				$trow[]=$CCBuild->getWasSuccessful() ? 
							'<font color=\'#009900\'><b>'.$Lang->getText('Build.BuildSucceed').'</b></font>' : 
							'<font color=\'#FF0000\'><b>'.$Lang->getText('Build.BuildFailed').'</b></font>';
				$trow[]=$CCBuild->getWasNecessary() ? 
							$Lang->getText('Common.Yes') : $Lang->getText('Common.No');
				$trow[]=$CCBuild->getWasFix() ? 
							$Lang->getText('Common.Yes') : $Lang->getText('Common.No');
			}
			$CCDefect = $CCBuild->getCruisecontrolDefect();
			if (!is_null($CCDefect) && is_object($CCDefect)) {
				$tracker_item_id = $CCDefect->getTrackerItemId();
				$ti = TrackerItemPeer::retrieveByPK($tracker_item_id);
				$trow[]='<a href="'. GFUrl::getUrl()->projectUrl($params['project'],'TrackerItemEdit','tracker').
				'&tracker_id='.$ti->getTrackerId().'&amp;tracker_item_id='.$ti->getTrackerItemID() .'">[#'.$ti->getTrackerItemID().'] '.$ti->getSummary().'</a>';
			} else {
				$trow[]='&nbsp;';
			}
			echo $theme->tableRow($trow);
		}
		echo $theme->tableBottom();
	}
}


$theme->footer($params);

?>
