<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code shows a form for editing Cruisecontrol
//
require_once('plugins/build/lib/CruisecontrolPeer.php');
require_once('plugins/build/lib/Cruisecontrol.php');
require_once('plugins/build/lib/CCHelper.php');
require_once('exceptions/PermissionDeniedException.php');
require_once('lib/html/HTMLWidget.php');

$session = Session::getSession();
$Lang = $session->getLanguage();

require_once('plugins/build/lib/html/BuildAdminTemplate.php');
$theme = new BuildAdminTemplate();

$Project = GFUrl::getUrl()->getProject();
$cc_id = (isset($_GET['id'])) ? Validator::sanitizeInt($_GET['id']) : ((isset($cc_id)) ? $cc_id : '');
$Cruisecontrol = CruisecontrolPeer::retrieveByPk($cc_id);
$objCC = $Cruisecontrol;
if ($objCC == null || !is_object($objCC)) {
	throw new PermissionDeniedException();
}

$params = array(
		'project' => $Project,
		'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : ''),
		'action' => isset($action) ? $action : '',
		'title' => $Lang->getText('Build.EditPageTitle')
		);
$theme->header($params);

$build_name = ( (isset($_POST) && isset($_POST['build_name'])) ? htmlspecialchars($_POST['build_name']) : $objCC->getBuildName() );
$build_description = ( (isset($_POST) && isset($_POST['build_desc'])) ? htmlspecialchars($_POST['build_desc']) : $objCC->getBuildDescription());
$user_id=((isset($_POST['user_id'])) ? Validator::sanitizeInt($_POST['user_id']) : $objCC->getSubmitterId() );
$tracker_id=(isset($_POST['tracker'])) ?
		Validator::sanitizeInt($_POST['tracker']) :
		($objCC->getPublisher() != null) ? $objCC->getPublisher()->getTrackerId() : 0;

// Get Project Members
$users = array();
foreach ($Project->getMembers() as $member) {
        $users[$member->getUserId()] = $member->getFullName();
}

// Arrays for tracker and asignees
$arrTrackers = $Project->getTrackers();

$trackers = array(100=>$Lang->getText('Options.None'));
$techs = array(100 => array(100 => 'Nobody'));
foreach($arrTrackers as $tracker){
	$trackers[$tracker->getTrackerID()] = $tracker->getTrackerName();
	$tech = $tracker->getTechnicians();
	$arrTech = array(100=>'Nobody');
	foreach($tech as $value){
		$arrTech[$value->getId()] = $value->getName();
	}
	$techs[$tracker->getTrackerID()] = $arrTech;
}

// Get already saved assignnes
$ass_objs = $objCC->getAssignees();
$assignees = array();
$assignees[$tracker_id] = array();
if (count($ass_objs) > 0) {
	foreach($ass_objs as $ass_obj) {
		$assignees[$tracker_id][$ass_obj->getAssignee()] = true;
	}
} else {
	$assignees[$tracker_id][100] = true;
}

include ('forms/BuildEdit-tpl.php');

$theme->footer($params);
?>
