<?php
require_once 'plugins/calendar/lib/om/BaseCalendarEventReminder.php';

/** 
 * The skeleton for this class was autogenerated by Propel  * You should add additional methods to this class to meet the
 * application requirements.  This class will only be generated as
 * long as it does not already exist in the output directory.
 *
 * @package plugins.calendar.lib 
 */
class CalendarEventReminder extends BaseCalendarEventReminder {

	const R_HOUR=1;
	const R_DAY=2;
	const R_WEEK=3;
	const R_CUSTOM=4;


	public function setNewReminder($event, $reminder_type, $date=null){
		
		if(is_null($event) || !is_object($event)){
			return;
		}

		if(!$this->isNew()){
			return null;
		}
			
		switch($reminder_type){
			case self::R_HOUR:{
				$this->setSendTime($event->getFromDate(null) - 60 * 60);
				break;
			}
			case self::R_DAY:{
				$this->setSendTime($event->getFromDate(null) - 60 * 60 * 24);
				break;
			}
			case self::R_WEEK:{
				$this->setSendTime($event->getFromDate(null) - 60 * 60 * 24 * 7);
				break;
			}
			case self::R_CUSTOM:{
				//Just in case we want a custom date for reminders
				break;
			}
		}

		$this->setTimeUnit($reminder_type);
		$this->setCalendarEventId($event->getCalendarEventId());

	}

	public function editReminder($event, $reminder_type, $date=null){

		if(is_null($event) || !is_object($event)){
			return;
		}
		$selectCriteria = $this->buildPkeyCriteria();
			
		switch($reminder_type){
			case self::R_HOUR:{
				$this->setSendTime($event->getFromDate(null) - 60 * 60);
				break;
			}
			case self::R_DAY:{
				$this->setSendTime($event->getFromDate(null) - 60 * 60 * 24);
				break;
			}
			case self::R_WEEK:{
				$this->setSendTime($event->getFromDate(null) - 60 * 60 * 24 * 7);
				break;
			}
			case self::R_CUSTOM:{
				//Just in case we want a custom date for reminders
				break;
			}
		}
		$this->setTimeUnit($reminder_type);

		$updateCriteria = $this->buildCriteria();

		$con = Propel::getConnection(CalendarEventReminderPeer::DATABASE_NAME);
		BasePeer::doUpdate($selectCriteria, $updateCriteria, $con);
	
		
	}




}
