<?php
require_once 'propel/map/MapBuilder.php';
include_once 'creole/CreoleTypes.php';

/**
 * This class adds structure of 'calendar_event_reminder' table to 'gf5' DatabaseMap object.
 *
 * These statically-built map classes are used by Propel to do runtime db structure discovery.
 * For example, the createSelectSql() method checks the type of a given column used in an 
 * ORDER BY clause to know whether it needs to apply SQL to make the ORDER BY case-insensitive 
 * (i.e. if it's a text column type).
 *
 * @see BasePeer
 * @see DatabaseMap
 * @package plugins.calendar.lib.map
 */
class CalendarEventReminderMapBuilder implements MapBuilder {

    /**
     * The name of this class
     */
    const CLASS_NAME = "plugins.calendar.lib.map.CalendarEventReminderMapBuilder";
	
    /**
     * The database map.
     */
    private $dbMap = null;

    /**
     * Tells us if this DatabaseMapBuilder is built so that we
     * don't have to re-build it every time.
     *
     * @return true if this DatabaseMapBuilder is built
     */
    public function isBuilt()
    {
        return ($this->dbMap !== null);
    }

    /**
     * Gets the databasemap this map builder built.
     *
     * @return the databasemap
     */
    public function getDatabaseMap()
    {
        return $this->dbMap;
    }

    /**
     * The doBuild() method builds the DatabaseMap
     *
	 * @return void
     * @throws PropelException
     */
    public function doBuild()
    {
		$this->dbMap = Propel::getDatabaseMap("gf5");
		
		$tMap = $this->dbMap->addTable("calendar_event_reminder");
		$tMap->setPhpName("CalendarEventReminder");
		
         
		$tMap->setUseIdGenerator(false);
		 
						
		 
		
		// Add columns to map
		$tMap->addForeignPrimaryKey("CALENDAR_EVENT_ID", "CalendarEventId", "int" , CreoleTypes::INTEGER, "calendar_event", "CALENDAR_EVENT_ID", true);
		$tMap->addColumn("SEND_TIME", "SendTime", "int", CreoleTypes::TIMESTAMP, true, null);
		$tMap->addPrimaryKey("TIME_UNIT", "TimeUnit", "int", CreoleTypes::INTEGER, true);
				
    }
}
