<?php
require_once('core/ProjectPeer.php');
require_once('core/Language.php');
require_once('lib/core/SettingPeer.php');

$lang = Language::getSessLang();
require_once('html/templates/SiteAdminTemplate.php');
$theme = new SiteAdminTemplate();

$Project = ProjectPeer::retrieveByPk((int)$_GET['id']);
if (!is_object($Project) || !$Project->userCanUpdate()) {
    throw new PermissionDeniedException();
}

$diskUsage = SettingPeer::FindSetting('project', $Project->getId(), 'disk-used');
$diskQuota = SettingPeer::FindSetting('project', $Project->getId(), 'project-quota');

$diskQuotaValue = is_object($diskQuota) ? (float)$diskQuota->getSettingValue() : GFConf::get('diskquota.projectMaxQuota'); 

$project_name = ( (isset($_POST) && isset($_POST['project_name'])) ? htmlspecialchars($_POST['project_name']) : $Project->getProjectName() );
$unix_name = ( (isset($_POST) && isset($_POST['unix_name'])) ? htmlspecialchars($_POST['unix_name']) : $Project->getUnixName() );
$disk_usage = is_object($diskUsage) ? (float)$diskUsage->getSettingValue() / (1024*1024) : '0';
$disk_quota = isset($_POST) && isset($_POST['disk_quota']) ? $_POST['disk_quota'] : $diskQuotaValue / (1024*1024);

$params = array(
    'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : ''),
    'action'   => isset($action) ? $action : '',
    'title'    => $lang->getText('Diskquota.Title')
);

include ('forms/EditDiskQuota-tpl.php');