<?php
require_once 'propel/map/MapBuilder.php';
include_once 'creole/CreoleTypes.php';

/**
 * This class adds structure of 'docman_file_folder' table to 'gf5' DatabaseMap object.
 *
 * These statically-built map classes are used by Propel to do runtime db structure discovery.
 * For example, the createSelectSql() method checks the type of a given column used in an 
 * ORDER BY clause to know whether it needs to apply SQL to make the ORDER BY case-insensitive 
 * (i.e. if it's a text column type).
 *
 * @see BasePeer
 * @see DatabaseMap
 * @package plugins.docman.lib.map
 */
class DocmanFileFolderMapBuilder implements MapBuilder {

    /**
     * The name of this class
     */
    const CLASS_NAME = "plugins.docman.lib.map.DocmanFileFolderMapBuilder";
	
    /**
     * The database map.
     */
    private $dbMap = null;

    /**
     * Tells us if this DatabaseMapBuilder is built so that we
     * don't have to re-build it every time.
     *
     * @return true if this DatabaseMapBuilder is built
     */
    public function isBuilt()
    {
        return ($this->dbMap !== null);
    }

    /**
     * Gets the databasemap this map builder built.
     *
     * @return the databasemap
     */
    public function getDatabaseMap()
    {
        return $this->dbMap;
    }

    /**
     * The doBuild() method builds the DatabaseMap
     *
	 * @return void
     * @throws PropelException
     */
    public function doBuild()
    {
		$this->dbMap = Propel::getDatabaseMap("gf5");
		
		$tMap = $this->dbMap->addTable("docman_file_folder");
		$tMap->setPhpName("DocmanFileFolder");
		
         
		$tMap->setUseIdGenerator(true);
		 
						
		 
		$tMap->setPrimaryKeyMethodInfo("docman_file_folder_docman_file_folder_id_seq");
		 
		
		// Add columns to map
		$tMap->addPrimaryKey("DOCMAN_FILE_FOLDER_ID", "DocmanFileFolderId", "int", CreoleTypes::INTEGER, true);
		$tMap->addForeignKey("DOCMAN_FOLDER_ID", "DocmanFolderId", "int", CreoleTypes::INTEGER, "docman_folder" , "DOCMAN_FOLDER_ID", true);
		$tMap->addForeignKey("DOCMAN_FILE_ID", "DocmanFileId", "int", CreoleTypes::INTEGER, "docman_file" , "DOCMAN_FILE_ID", true);
				
    }
}
