<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version $Id$
 * @author Daniel A. Pérez	daniel@gforgegroup.com
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

$session = Session::getSession();
$Lang = $session->getLanguage();

require_once('plugins/docman/lib/DocmanFolderPeer.php');
require_once('plugins/docman/lib/DocmanFolder.php');
require_once('plugins/docman/lib/DocmanFilePeer.php');
require_once('plugins/docman/lib/DocmanFile.php');
require_once('plugins/docman/lib/FastJSON.php');
require_once('external/fckeditor/fckeditor.php');

$project=GFUrl::getUrl()->getProject();
$docman_file = DocmanFilePeer::retrieveByPk($_POST['file_id']);
$description = isset($_POST['description']) ? Validator::sanitizeString($_POST['description']) : '';
$file_name = isset($_POST['file_name']) ? Validator::sanitizeString($_POST['file_name']) : '';

if (!is_object($docman_file) 
	|| !$docman_file->userCanUpdate()) {
	header('HTTP/1.1 401');
	$arr_feedback = array();
	$arr_feedback["error_message"] = "Permission denied";
	echo FastJSON::encode($arr_feedback);
	exit;
}

try {
	$docman_file->setDescription($description);
	$docman_file->setFilename($file_name);
	$docman_file->save();
	header('HTTP/1.1 200');
	$arr_feedback = array();
	echo FastJSON::encode($arr_feedback);
	exit;
} catch (InvalidDataException $ex) {
	header('HTTP/1.1 401');
	$arr_feedback = array();
 	$feedback = implode('<br />',$errors);
	$arr_feedback["error_message"] = $feedback;
	echo FastJSON::encode($arr_feedback);
	exit;
} catch (PermissionDeniedException $ex) {
	header('HTTP/1.1 401');
	$arr_feedback = array();
 	$arr_feedback["error_message"] = 'Permission denied';
	echo FastJSON::encode($arr_feedback);
	exit;
}
?>
