<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
require_once('plugins/docman/lib/DocmanFolder.php');
require_once('plugins/docman/lib/DocmanFolderPeer.php');
require_once('exceptions/PermissionDeniedException.php');
require_once('core/Language.php');
require_once('plugins/docman/lib/FastJSON.php');

$Lang = Language::getSessLang();
$status = '';

if (!$session->isLoggedIn()) {
	header('HTTP/1.1 401');
}

$user = Session::getSession()->getUser();

if (!is_object($user)) {
	header('HTTP/1.1 401');
}
 
if (isset($_GET['file_id'])) {
	$file_id = Validator::sanitizeInt($_GET['file_id']);

	$c = new Criteria();
	$c->add(MonitorPeer::SECTION, 'docmanfile');
	$c->add(MonitorPeer::REF_ID, $file_id);
	$c->add(MonitorPeer::USER_ID, $user->getUserId());
	$mon = MonitorPeer::doSelectOne($c);

	try {
		if (is_null($mon)) {
			$mon = new Monitor();
			$mon->setSection('docmanfile');
			$mon->setRefId($file_id);
			$mon->setUserId($user->getUserId());
			$mon->save();
			
		} else {
			$mon->delete();
		}
		$status = '200';
	} catch(PermissionDeniedException $e) {
//		print_r ($e);
		$status = '401';
	}
	
} else {
	$status = '401';
}

header('HTTP/1.1 ' . $status);

?>