<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
require_once('plugins/docman/lib/DocmanFolder.php');
require_once('plugins/docman/lib/DocmanFolderPeer.php');
require_once('exceptions/PermissionDeniedException.php');
require_once('core/Language.php');
require_once('plugins/docman/lib/FastJSON.php');


function buildBreadcrumbs($arr_breadcrumbs, $folder_id) {
	$folder = DocmanFolderPeer::retrieveByPk($folder_id);
	
	if (is_object($folder)) {
		$arr_breadcrumb = array();
		$arr_breadcrumb['folder_id'] = $folder->getDocmanFolderId();
		$arr_breadcrumb['folder_name'] = $folder->getFolderName();
		$arr_breadcrumbs[] = $arr_breadcrumb;

		if ($folder->getParentFolderId() > 0) {
			$arr_breadcrumbs = buildBreadcrumbs($arr_breadcrumbs, $folder->getParentFolderId());
			return $arr_breadcrumbs;
		} else {
			return $arr_breadcrumbs;
		}
	} else {
		return $arr_breadcrumbs;
	}
}


if (isset($_GET['folder_id'])) {
	$folder = DocmanFolderPeer::retrieveByPk(intval($_GET['folder_id']));
	$arr_breadcrumbs = array();
	if (is_object($folder)) {
		$arr_breadcrumbs = buildBreadcrumbs($arr_breadcrumbs, $folder->getDocmanFolderId());
		$arr_breadcrumbs = array_reverse($arr_breadcrumbs);
		
		header('HTTP/1.1 200');
		echo FastJSON::encode($arr_breadcrumbs);
	}
} else {
	header('HTTP/1.1 401');
}
?>