<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code moves a docman file to another folder
// database
//
require_once('plugins/docman/lib/DocmanFile.php');
require_once('Validator.php');
require_once('exceptions/PermissionDeniedException.php');
require_once('core/Language.php');
require_once('plugins/docman/lib/FastJSON.php');

$session = Session::getSession();

if ($_SERVER['REQUEST_METHOD'] != 'GET') {
	header('HTTP/1.1 401');
	$arr_feedback = array();
	$arr_feedback["error_message"] = "Permission denied";
	echo FastJSON::encode($arr_feedback);
	exit;
}

if (!$session->isLoggedIn()) {
	header('HTTP/1.1 401');
	$arr_feedback = array();
	$arr_feedback["error_message"] = "Permission denied";
	echo FastJSON::encode($arr_feedback);
	exit;
}

$file_id = isset($_GET['file_id']) ? intval($_GET['file_id']) : 0;

	
try {
	$c = new Criteria();
	$c->add(DocmanFileFolderPeer::DOCMAN_FILE_ID, $file_id);
	$DocmanFileFolder = DocmanFileFolderPeer::doSelect($c);
	
	$association_count = sizeof($DocmanFileFolder);

	header('HTTP/1.1 200');
	$arr_feedback = array("association_count" => $association_count);
	echo FastJSON::encode($arr_feedback);
	exit;
} catch (InvalidDataException $ex) {
	$errors=$ex->getErrors();
	$feedback = implode('<br />', $errors);
	header('HTTP/1.1 401');
	$arr_feedback = array();
	$arr_feedback["error_message"] = $feedback;
	echo FastJSON::encode($arr_feedback);
	exit;
}

?>
