<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id$
 * @author Tim Perdue tim@gforge.org
 * @date 2006-02-27
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

//
// This code lists Docman
//
require_once('plugins/docman/lib/html/DocmanTemplate.php');
require_once('plugins/docman/lib/InfoParser.php');
require_once('plugins/docman/lib/DocmanTreeRenderer.php');
require_once('plugins/docman/lib/DocmanFolder.php');
require_once('plugins/docman/lib/DocmanFolderPeer.php');
require_once('plugins/docman/lib/DocmanFileFolder.php');
require_once('plugins/docman/lib/DocmanFileFolderPeer.php');
require_once('plugins/docman/lib/DocmanFile.php');
require_once('plugins/docman/lib/DocmanFilePeer.php');
require_once('lib/exceptions/PermissionDeniedException.php');
require_once('html/ProjectTemplate.php');
require_once('plugins/docman/lib/FastJSON.php');

$session = Session::getSession();
$Lang = $session->getLanguage();
$template = new ProjectTemplate();

$theme = new DocmanTemplate();
$project = GFUrl::getUrl()->getProject();

if (!$project->isPublic() && !$session->isLoggedIn()) {
	header('HTTP/1.1 401');
	exit;
}

$file_id = isset($_REQUEST['file_id']) ? intval($_REQUEST['file_id']) : 0;

$docman_file = DocmanFilePeer::retrieveByPk($file_id);
if (!is_object($docman_file) || !$docman_file->userCanRead()) {	
	if (!is_object($docman_file)) {
		$message = 'The file does not exist';
	} else {
		$message = 'You don\'t have permission to view this file';
	}
	$arr_response = array();
	$arr_response['error_message'] = $message;
	header('HTTP/1.1 401');
	echo FastJSON::encode($arr_response);
	exit;
}

$docmanRenderer = new DocmanFolderSearchRenderer(array($file_id));
$arr_data = $docmanRenderer->renderSearchResults();

$status = '200';
header('HTTP/1.1 ' . $status);
echo FastJSON::encode($arr_data);
?>
