<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id$
 * @author Tim Perdue tim@gforge.org
 * @date 2006-02-27
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

//
// This code lists Docman
//
require_once('plugins/docman/lib/html/DocmanTemplate.php');
require_once('plugins/docman/lib/InfoParser.php');
require_once('plugins/docman/lib/DocmanTreeRenderer.php');
require_once('plugins/docman/lib/DocmanFolder.php');
require_once('plugins/docman/lib/DocmanFolderPeer.php');
require_once('plugins/docman/lib/DocmanFileFolder.php');
require_once('plugins/docman/lib/DocmanFileFolderPeer.php');
require_once('plugins/docman/lib/DocmanFile.php');
require_once('plugins/docman/lib/DocmanFilePeer.php');
require_once('lib/exceptions/PermissionDeniedException.php');
require_once('html/ProjectTemplate.php');
require_once('plugins/docman/lib/FastJSON.php');

$session = Session::getSession();
$Lang = $session->getLanguage();
$template = new ProjectTemplate();

$theme = new DocmanTemplate();
$project = GFUrl::getUrl()->getProject();

if (!$project->isPublic() && !$session->isLoggedIn()) {
	header('HTTP/1.1 401');
	exit;
}

$folder_id = isset($_REQUEST['folder_id']) ? $_REQUEST['folder_id'] : 0;

//Gets/creates the default "incoming" folder
$c = new Criteria();
$c->add(DocmanFolderPeer::PROJECT_ID,$project->getProjectId());
$c->add(DocmanFolderPeer::FOLDER_NAME,'incoming'); // default master folder
$c->add(DocmanFolderPeer::PARENT_FOLDER_ID,0);
$incoming = DocmanFolderPeer::doSelectOne($c);
if (!is_object($incoming)) {
	$incoming = new DocmanFolder();
	$incoming->setFolderName('incoming');
	$incoming->setProject($project);
	$incoming->save();
}

if($folder_id == $incoming->getDocmanFolderId()) {
	$folder_id = 0;
}

$docmanRenderer = new DocmanFolderContentsRenderer($folder_id, $project->getProjectId(), $incoming->getDocmanFolderId());
$folder_contents = FastJSON::convert($docmanRenderer->getFolderContents());

$status = '200';
header('HTTP/1.1 ' . $status);
echo $folder_contents;
?>