<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code moves a docman file to another folder
// database
//
require_once('plugins/docman/lib/DocmanFile.php');
require_once('Validator.php');
require_once('exceptions/PermissionDeniedException.php');
require_once('core/Language.php');
require_once('plugins/docman/lib/FastJSON.php');

$session = Session::getSession();
$project = GFUrl::getUrl()->getProject();

$folder_id = isset($_REQUEST['folder_id']) ? intval($_REQUEST['folder_id']) : 0;
$type = isset($_REQUEST['type']) ? intval($_REQUEST['type']) : '';
$docman_folder = DocmanFolderPeer::retrieveByPk($folder_id);

if (is_object($docman_folder)) {
	$permission = 'n';
	if ($type == 'parent' && $docman_folder->getParentFolderId() == 0) {
		//We need the parent permission, and since it's a root folder, we need the root folder permission
		
		//Get root (incoming) folder
		$c = new Criteria();
		$c->add(DocmanFolderPeer::PROJECT_ID,$project->getProjectId());
		$c->add(DocmanFolderPeer::FOLDER_NAME,'incoming'); // default master folder
		$c->add(DocmanFolderPeer::PARENT_FOLDER_ID,0);
		$incoming = DocmanFolderPeer::doSelectOne($c);
		if (is_object($incoming)) {
			$docman_folder = $incoming;
		}
		
	}
	
	//Get the folder permission
	if ($docman_folder->userCanCreate()) {
		$permission = 'w';
	}	elseif($docman_folder->userCanRead()) {
		$permission = 'r';
	}

	header('HTTP/1.1 200');
	$arr_feedback = array();
	$arr_feedback["permission"] = $permission;
	$arr_feedback["is_public"] = $docman_folder->getIsPublic();
	echo FastJSON::encode($arr_feedback);
	exit;
	
} else {
	header('HTTP/1.1 401');
	$arr_feedback = array();
	$arr_feedback["error_message"] = "Permission denied";
	echo FastJSON::encode($arr_feedback);
	exit;
}



?>
