<?php

/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version $Id$
 * @author Daniel A. Perez	daniel@gforgegroup.com
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

require_once('lib/core/Filesystem.php');
require_once('lib/core/FilesystemPeer.php');
require_once('plugins/docman/lib/DocmanFile.php');
require_once('plugins/docman/lib/DocmanFilePeer.php');
require_once('plugins/docman/lib/DocmanFileVersion.php');
require_once('plugins/docman/lib/DocmanFileVersionPeer.php');
require_once('plugins/docman/lib/DocmanFolder.php');
require_once('plugins/docman/lib/DocmanFolderPeer.php');
require_once('lib/exceptions/PermissionDeniedException.php');
require_once('plugins/docman/lib/FastJSON.php');
require_once('Validator.php');

$Lang = Language::getSessLang();

$project = GFUrl::getUrl()->getProject();

if (!Session::getSession()->isLoggedIn()) {
	throw new PermissionDeniedException();
}

$dfv = DocmanFileVersionPeer::retrieveByPK($_REQUEST['file_version_id']);
if (!is_object($dfv) 
	|| $dfv->getDocmanFile()->getDocmanFolder()->getProjectId()!=$project->getProjectId()
	|| !$dfv->userCanDelete()) {
	header('HTTP/1.1 401');
	$arr_feedback = array();
	$arr_feedback["error_message"] = "Permission denied";
	echo FastJSON::encode($arr_feedback);
	exit;
}

try {
	$subdir=$dfv->getDocmanFile()->getDocmanFolder()->getDocmanFolderId();
	$fileid=$dfv->getDocmanFile()->getDocmanFileId();
	
	if (count($dfv->getDocmanFile()->getDocmanFileVersions()) < 2) {
		$dfv->getDocmanFile()->delete();
	} else {
		$dfv->delete();
	}

	header('HTTP/1.1 200');
	$arr_feedback = array();
	$arr_feedback[""] = "";
	echo FastJSON::encode($arr_feedback);
	exit;
} catch(Exception $e) {
	header('HTTP/1.1 401');
	$arr_feedback = array();
	$arr_feedback["error_message"] = "Permission denied";
	echo FastJSON::encode($arr_feedback);
	exit;
}
?>
