<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code creates a new DocmanFolder and saves it to the 
// database
//
require_once('plugins/docman/lib/DocmanFolder.php');
require_once('plugins/docman/lib/DocmanFolderPeer.php');
require_once('exceptions/PermissionDeniedException.php');
require_once('core/Language.php');
require_once('plugins/docman/lib/FastJSON.php');

$Lang = Language::getSessLang();
$status = '';

if (!$session->isLoggedIn()) {
	header('HTTP/1.1 401');
	exit;
}

$DocmanFolder = DocmanFolderPeer::retrieveByPk($_POST['id']);
if (!is_object($DocmanFolder)) {
	$status = '401';
	$message = $Lang->getText('Docman.FolderNotExists', array());
} elseif ($DocmanFolder->getParentFolderId() == 0 && $DocmanFolder->getFolderName() == 'incoming') {
	//If Folder is root (no parent folder), it cannot be deleted
	$status = '401';
	$message = $Lang->getText('Common.PermissionDenied', array());
} else {
	if (isset($_POST['sure'])) {
		if (is_object($DocmanFolder) && $DocmanFolder->userCanDelete()) {
			$DocmanFolder->delete();
			$status = '201';
			$message = $Lang->getText('DocmanFolder.PositiveDeleteFeedback', array('folder_id' => $DocmanFolder->getDocmanFolderId(), 'folder_name' => $DocmanFolder->getFolderName()));
		} else {
			$status = '401';
			$message = $Lang->getText('DocmanFolder.NegativeDeleteFeedback', array('folder_id' => $DocmanFolder->getDocmanFolderId(), 'folder_name' => $DocmanFolder->getFolderName()));
		}
	} else {
		$status = '401';
		$message = $Lang->getText('DocmanFolder.NegativeDeleteFeedback', array('folder_id' => $DocmanFolder->getDocmanFolderId(), 'folder_name' => $DocmanFolder->getFolderName()));
	}
}

$arr_feedback = array('message' => $message);
echo FastJSON::encode($arr_feedback);
header('HTTP/1.1 ' . $status);
?>