<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code edits a DocmanFolder and saves it to the 
// database
//
require_once('plugins/docman/lib/DocmanFolder.php');
require_once('Validator.php');
require_once('exceptions/PermissionDeniedException.php');
require_once('core/Language.php');
require_once('plugins/docman/lib/FastJSON.php');

if ($_SERVER['REQUEST_METHOD'] != 'GET') {
	header('HTTP/1.1 401');
	$arr_feedback = array();
	$arr_feedback["error_message"] = "Permission denied";
	echo FastJSON::encode($arr_feedback);
	exit;
}

$project = GFUrl::getUrl()->getProject();

$DocmanFolder = DocmanFolderPeer::retrieveByPk($_GET['folder_id']);
if (!is_object($DocmanFolder) || !$DocmanFolder->userCanCreate()) {
	header('HTTP/1.1 401');
	$arr_feedback = array();
	$arr_feedback["error_message"] = "Permission denied";
	echo FastJSON::encode($arr_feedback);
	exit;
} else {
	if ($DocmanFolder->getProject()->getProjectId() != $project->getProjectId()) {
		header('HTTP/1.1 401');
		$arr_feedback = array();
		$arr_feedback["error_message"] = "Permission denied";
		echo FastJSON::encode($arr_feedback);
		exit;
	} else {
		$Lang = Language::getSessLang();
		
		try {
			$parent_folder_id = $_GET['parent_folder_id'];
				$c = new Criteria();
			$c->add(DocmanFolderPeer::PROJECT_ID,$project->getProjectId());
			$c->add(DocmanFolderPeer::FOLDER_NAME,'incoming'); // default master folder
			$c->add(DocmanFolderPeer::PARENT_FOLDER_ID,0);
			$incoming = DocmanFolderPeer::doSelectOne($c);
			if (is_object($incoming)) {
				if ($incoming->getDocmanFolderId() == $parent_folder_id) {
					$parent_folder_id = 0;
				}
			}
			$DocmanFolder->setParentFolderId($parent_folder_id);
			$DocmanFolder->save();
			header('HTTP/1.1 200');
			$arr_feedback = array();
			$arr_feedback["folder_id"] = $DocmanFolder->getDocmanFolderId();
			$arr_feedback["parent_folder_id"] = $DocmanFolder->getParentFolderId();
			$arr_feedback["folder_name"] = $DocmanFolder->getFolderName();
			echo FastJSON::encode($arr_feedback);
			exit;
		} catch (InvalidDataException $ex) {
			$errors=$ex->getErrors();
			$feedback = implode('<br />', $errors);
			header('HTTP/1.1 401');
			$arr_feedback = array();
			$arr_feedback["error_message"] = $feedback;
			//$arr_feedback["error_message"] = "error";
			echo FastJSON::encode($arr_feedback);
			exit;
		}
	}
}
		


?>
