<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code edits a DocmanFolder and saves it to the 
// database
//
require_once('plugins/docman/lib/DocmanFolder.php');
require_once('Validator.php');
require_once('exceptions/PermissionDeniedException.php');
require_once('core/Language.php');
require_once('plugins/docman/lib/FastJSON.php');

if ($_SERVER['REQUEST_METHOD'] != 'GET') {
	header('HTTP/1.1 401');
	$arr_feedback = array();
	$arr_feedback["error_message"] = "Permission denied";
	echo FastJSON::encode($arr_feedback);
	exit;
}

$project = GFUrl::getUrl()->getProject();
if ($_GET['parent_folder_id'] > 0) {
	$DocmanFolder = DocmanFolderPeer::retrieveByPk($_GET['folder_id']);
	$DocmanSiblingFolder = DocmanFolderPeer::retrieveByPk($_GET['parent_folder_id']);
	if (!is_object($DocmanFolder) || !$DocmanFolder->userCanCreate() || !is_object($DocmanSiblingFolder)) {
		header('HTTP/1.1 401');
		$arr_feedback = array();
		$arr_feedback["error_message"] = "Permission denied";
		echo FastJSON::encode($arr_feedback);
		exit;
	} else {
		if ($DocmanFolder->getProject()->getProjectId() != $project->getProjectId()) {
		
			header('HTTP/1.1 401');
			$arr_feedback = array();
			$arr_feedback["error_message"] = "Permission denied";
	
			echo FastJSON::encode($arr_feedback);
			exit;
		} else {
			$Lang = Language::getSessLang();
			
			try {
				$DocmanFolder->setParentFolderId($DocmanSiblingFolder->getParentFolderId());
				$DocmanFolder->save();

				header('HTTP/1.1 200');
				$arr_feedback = array();
				$arr_feedback["folder_id"] = $DocmanFolder->getDocmanFolderId();
				$arr_feedback["parent_folder_id"] = $DocmanSiblingFolder->getParentFolderId();
				$arr_feedback["folder_name"] = $DocmanFolder->getFolderName();
				echo FastJSON::encode($arr_feedback);
				exit;
			} catch (InvalidDataException $ex) {
				$errors=$ex->getErrors();
				$feedback = implode('<br />', $errors);
				header('HTTP/1.1 401');
				$arr_feedback = array();
				$arr_feedback["error_message"] = $feedback;
				//$arr_feedback["error_message"] = "error";
				echo FastJSON::encode($arr_feedback);
				exit;
			}
		}
	}
		
}

?>
