<script type="text/javascript">

var docmanFile = namespace('GForge.Plugins.Docman.DocmanFile');
	
	/**
	* Creates the context menu for files
	* @return {}    This method does not return anything. 
	*/  
	function createFileMenu() {
		$(function() {
		    $.contextMenu({
		        selector: '.menu_file', 
		        callback: function(key, options) {
		            var m = "clicked: " + key;
		            var str_id = options.$trigger.attr("id");
		            var aux_id = str_id.split("_");
		            var file_id = aux_id[0];
		            var folder_id = aux_id[1];

		            var name = options.$trigger.attr("fname");
		            
		            switch(key) {
				        	case "monitor":
				        		docmanFile.monitorFile(file_id, name);
				        	break;
				
				        	case "whosmonitoring":
				        		docmanFile.whosMonitoringFile(file_id, name);
				        	break;
			
				        	case "viewdetails":
				        		docmanFile.viewDetails(file_id, name);
				        	break;
				        	
				        	case "uploadversion":
				        		docmanFile.uploadVersion(file_id, name);
				        	break;

				        	case "editfileinline":
				        		docmanFile.editFileInline(file_id, name);
				        	break;
				
				        	case "deletefile":
				        		docmanFile.deleteFile(file_id, folder_id, name);
				        	break;
				        	
									case "viewfiledownloads":
				        		docmanFile.viewFileDownloads(file_id, name);
				        	break;
				        	
				        	case "downloadfile":
				        		docmanFile.downloadFile(file_id, name);
				        	break;
							        	
				        	case "organizefile":
				        		docmanFile.organizeFile(file_id, name);
				        	break;
				        	
				        	case "approvefile":
				        		docmanFile.approveFile(file_id);
				        	break;
				        	
				        	case "rejectfile":
				        		docmanFile.rejectFile(file_id);
				        	break;
						
				        	case "renamefile":
				        		docmanFile.renameFile(file_id);
				        	break;
				        	
		            }
		            
		        },
		        items: {
		            "monitor": {name: "Add Files", icon: "copy"},
		            "sep1": "---------",
		            "whosmonitoring": {name: "Who's monitoring", icon: "copy"},
		            "viewdetails": {name: "View Details", icon: "copy", disabled: true},
		            "uploadversion": {name: "Upload Version", icon: "copy"},
		            "editfileinline": {name: "Edit File Inline", icon: "edit"},
		            "deletefile": {name: "Delete File", icon: "delete"},
		            "downloadfile": {name: "Download File", icon: "copy"},
		            "organizefile": {name: "Organize File", icon: "copy"},
		            "sep2": "---------",
		            "quit": {name: "Quit", icon: "quit"}
		        }
		    });
		    
		    $('.menu_file').on('click', function(e){
		    })
		});
		
		
		$(function() {
		    $.contextMenu({
		        selector: '.menu_file_locked', 
		        callback: function(key, options) {
		            var m = "clicked: " + key;
		            var str_id = options.$trigger.attr("id");
		            var aux_id = str_id.split("_");
		            var file_id = aux_id[0];
		            var folder_id = aux_id[1];
		            var name = options.$trigger.attr("fname");
		            
		            switch(key) {
				        	case "monitor":
				        		docmanFile.monitorFile(file_id, name);
				        	break;
				
				        	case "whosmonitoring":
				        		docmanFile.whosMonitoringFile(file_id, name);
				        	break;
			
				        	case "viewdetails":
				        		docmanFile.viewDetails(file_id, name);
				        	break;
			        	
									case "viewfiledownloads":
				        		docmanFile.viewFileDownloads(file_id, name);
				        	break;
			        	
				        	case "downloadfile":
				        		docmanFile.downloadFile(file_id, name);
				        	break;
		            }
		            
		        },
		        items: {
		            "monitor": {name: "Add Files", icon: "copy"},
		            "whosmonitoring": {name: "Who's monitoring", icon: "copy"},
		            "viewdetails": {name: "Add New File Inline", icon: "copy"},
		            "downloadfile": {name: "Download File", icon: "copy"},
		            "sep2": "---------",
		            "quit": {name: "Quit", icon: "quit"}
		        }
		    });
		    
		    $('.menu_file_locked').on('click', function(e){
		    })
		});
	}

	docmanFile.addFileVersion = false;
	docmanFile.viewDetailsDialog = null;

	/**
	* Loads a specific file on the panel. Used for linking docman files from other plugins, or the My Stuff section
	* @param {int} file_id    id of the file to load
	* @return {}    This method does not return anything.
	*/
	docmanFile.loadFile = function(file_id) {
		docman_mode = 'search';
		
		$('#upload_folder_id').attr('value', incoming_folder);
		var spinner = new Spinner(spinner_opts).spin(spinner_target);				
		var _url = '<?php echo GFUrl::getUrl()->projectURL($project,'DocmanGetFileData','docman','', array()); ?>&file_id=' + file_id;

		$.ajax({
			  url: _url,
			  type: "GET",
			  data: null,
			  dataType: 'html',
				
			  success: function(response){
			  	var folder_file_data = JSON.parse(response);
					docmanFolder.parseFolderFilesData(folder_file_data);
			  	try {
						var rendered_table = new EJS({url: '/docman_contents_search.ejs'}).render({ data : folder_file_data, parent_folder : 0, show_pending_queue_files : false, search_results_mode : true});
					}
					catch(err) { alert(err); }
			  	
			  	$("#docman_files").html(rendered_table);

					createFileMenu();
					spinner = null;
					docman.activateTablesorter();
			  },
			  error: function(response){
			  	var arr_response = JSON.parse(response.responseText);
					var params_dialog = {title : "Docman File", message : arr_response.error_message};
					var options = {width : 400, height : 200, prevent_auto_fade : true, div_dialog : 'docman-modal-dialog' };
					docman.statusConfirm('generic-confirm-template', params_dialog, options);
			  }
			});	
	}



	docmanFile.getFileType = function(file_id) {
		return docman_data.files[file_id].file_type;
	}


	docmanFile.renderDocmanFileRow = function(params) {
		var data = {file : params};
		if (params.approved) {
			data.approved = '1';
		} else {
			data.approved = '0';
		}
		data.show_pending_queue_files = true;
		var rendered_row = new EJS({url: '/docman_document_row.ejs'}).render(data);	
		return (rendered_row);
	};
	

  docmanFile.lockUnlockFile = function(file_id, file_name) { 	
  	if (!docmanFile.checkPermission(file_id, docman_data.current.folder_id, 'w')) {
  		return false;	
  	}
  	
  	if (docman_data.files[file_id].is_locked) {
	 		docmanFile.unlockFile(file_id, file_name);
  	} else {
  		docmanFile.lockFile(file_id, file_name);
  	}
  	
  	return false;
  };


  docmanFile.lockFile = function(file_id, file_name) {
  	
  	if (docman_data.current.permission != 'w') { 
  		return;
  	}
  	
  	var tmpl = new EJS({element: 'file-lock-dialog-template'}); 
  	$('#docman-modal-dialog').html(tmpl.render({file_id : file_id, file_name : file_name}));

		var _url = '<?php echo GFUrl::getUrl()->projectURL($project,'DocmanFileLockAction','docman','', array()); ?>';

		var post_data = {'file_id' : file_id};

		var jqxhr = $.post( _url, post_data,
			function( data ) {
				var content = $( data ).find( '#content' );
				$( "#result" ).empty().append( content );
			}
		)
		.success (function(data, textStatus, xhr) {	
			docman.setFileAttr(file_id, 'lock', 'src', '/themes/gforge5/images_docman/locked.png');
			docman.setFileAttr(file_id, 'lock', 'class', 'locked');
			docman_data.files[file_id].is_locked = true;
			
			var str_html = '<br/>Locked By: ' + user_full_name + ' (' + user_unix_name + ')';
			docman.setHtml(file_id, 'lock_label', str_html);
  	})
		.error (function(xhr, textStatus) {
			var params_dialog = {title: "File lock confirmation", status : false, file_id : file_id, file_name : file_name};
   		docman.statusConfirm('file-lock-dialog-template-confirm', params_dialog, {});
  	});

  };
  
  
  
  docmanFile.unlockFile = function(file_id, file_name) {
  	if (!docmanFile.checkPermission(file_id, docman_data.current.folder_id, 'w')) {
  		return false;	
  	}
 	
  	var tmpl = new EJS({element: 'file-lock-dialog-template'}); 
  	$('#docman-modal-dialog').html(tmpl.render({file_id : file_id, file_name : file_name}));

		var _url = '<?php echo GFUrl::getUrl()->projectURL($project,'DocmanFileUnlockAction','docman','', array()); ?>';

		var post_data = {'file_id' : file_id};

		var jqxhr = $.post( _url, post_data,
			function( data ) {
				var content = $( data ).find( '#content' );
				$( "#result" ).empty().append( content );
			}
		)
		.success (function(data, textStatus, xhr) {
			docman.setFileAttr(file_id, 'lock', 'src', '/themes/gforge5/images_docman/unlocked.png');
			docman.setFileAttr(file_id, 'lock', 'class', 'unlocked');	
			docman.setHtml(file_id, 'lock_label', '');
			docman_data.files[file_id].is_locked = false;
		})
		.error (function(xhr, textStatus) {
   		var params_dialog = {title: "File unlock confirmation", status : false, file_id : file_id, file_name : file_name};
   		docman.statusConfirm('file-unlock-dialog-template-confirm', params_dialog, {});
		});

  };
  
  docmanFile.deleteFile = function(file_id, folder_id, file_name) {
	 	if (!docmanFile.checkPermission(file_id, docman_data.current.folder_id, 'w')) {
  		return false;	
  	}

	  file_name = docman_data.files[file_id].file_name;

		var _url = '<?php echo GFUrl::getUrl()->projectURL($project,'DocmanGetFileAssociationCount','docman','', array()); ?>';
		var post_data = {'file_id' : file_id};
  
		$.ajax({
		  url: _url,
		  type: "GET",
		  data: post_data,
		  dataType: 'html',
					
		  success: function(json_string){
				var response = JSON.parse(json_string);
				var association_count = parseInt(response.association_count);
				var multassoc = false;
				if (association_count > 1) {
					multassoc = true;
				}

				docmanFile.deleteFileCallback(file_id, folder_id, file_name, multassoc);
		  },
		  error: function(html){
		    var params_dialog = {title: "File delete confirmation", status : false, file_id : file_id, file_name : file_name};
		    docman.statusConfirm('file-delete-dialog-template-confirm', params_dialog, {});
		  }
		});		
  	
  };
  
  
  docmanFile.deleteFileCallback = function(file_id, folder_id, file_name, multassoc) {
  	var tmpl = new EJS({element: 'file-delete-dialog-template'});
	file_name = file_name.replace(/"/g, '&quot;');

  	$('#docman-modal-dialog').html(tmpl.render({file_id : file_id, file_name : file_name, multassoc : multassoc}));

		$( "#docman-modal-dialog" ).dialog({
			title: "Delete File",
			resizable: false,
			scrollbars: false,
			height:'auto',
			width:400,
			position: ['center', 'center'],
			modal: true,
			buttons: {
				"Delete": function() {				
					var delete_option = 2;
					
					if (multassoc) {
						delete_option = getCheckedValue(document.getElementsByName('delete_selection'));
					}

					if (delete_option == 1) {
						docmanFile.deleteFileFromFolder(file_id, folder_id);
					} else {
						docmanFile.deleteFileHardDelete(file_id, file_name);
					}
					
					$( this ).dialog( "close" );
				},
				Cancel: function() {
					$( this ).dialog( "close" );
				}
			}
		});
  };
  
  
  docmanFile.deleteFileFromFolder = function(file_id, folder_id) {
			var _url = '<?php echo GFUrl::getUrl()->projectURL($project,'DocmanFileFolderSetAction','docman','', array()); ?>&folder_id=' + folder_id + '&file_id=' + file_id + '&operation=remove';

			$.ajax({
			  url: _url,
			  type: "GET",
			  data: null,
			  dataType: 'html',
			  success: function(json_string){
					 docmanFile.removeFileFromPanel(file_id, folder_id);
			  },
			  error: function(response) {
			  	var arr_response = JSON.parse(response.responseText);
			  }
			});			
  };

  
  docmanFile.deleteFileHardDelete = function(file_id, file_name) {
  	if (!docmanFile.checkPermission(file_id, docman_data.current.folder_id, 'w')) {
  		return false;	
  	}
  	
		var _url = '<?php echo GFUrl::getUrl()->projectURL($project,'DocmanFileDeleteAction','docman','admin', array()); ?>';
		var post_data = {'file_id' : file_id};
   			    			
		$.ajax({
		  url: _url,
		  type: "GET",
		  data: post_data,
		  dataType: 'html',
					
		  success: function(json_string){
		  	docmanFile.removeFileFromPanel(file_id, -1);
			
				var params_dialog = {title: "File delete confirmation", status : true, file_id : file_id, file_name : file_name};
				docman.statusConfirm('file-delete-dialog-template-confirm', params_dialog, {});
		  },
		  error: function(html){
		  	var params_dialog = {title: "File delete confirmation", status : false, file_id : file_id, file_name : file_name};
		    docman.statusConfirm('file-delete-dialog-template-confirm', params_dialog, {});
		  }
		});	

  };


	docmanFile.removeFileFromPanel = function(file_id, folder_id) {
		if (folder_id == -1) {
	  	var instances = $('[name="' + element_types['file'] + file_id + '"]');
	  	for (var i=0; i < instances.length; i++) {
	  		var element_id = $(instances[i]).attr('id');
	  		$('#' + element_id).remove();
	  	}
	  } else {
	  	if (docman_mode == 'search') {
	  		$('#' + element_types['file'] + file_id + '_' + folder_id).remove();
	  	} else {
	  		$('#' + element_types['file'] + file_id).remove();
	  	}
	  }

	};


	/**
	* Renames a file
	* @param {Int} file_id    ID of the file
	* @return {}    This method does not return anything
	*/   
  docmanFile.renameFile = function(file_id) { 	
	var file_name = docman_data.files[file_id].file_name;

  	var tmpl = new EJS({element: 'file-rename-dialog-template'});
  	$('#docman-modal-dialog').html(tmpl.render({file_id : file_id, file_name : file_name.replace(/"/g, '&quot;')}));
		$('#docman-modal-dialog').attr('title', 'Rename File');


		$( "#docman-modal-dialog" ).dialog({
			resizable: false,
			height:'auto',
			width: 400,
			title: "Rename File",
			modal: true,
			buttons: {
				"Accept": function() {
					var post_data = {};
					$.each($('#form-file-rename-rendered').serializeArray(), function(i, field) {
    					post_data[field.name] = escape(field.value);
					});

					var _url = '<?php echo GFUrl::getUrl()->projectURL($project,'DocmanFileRename','docman','admin', array()); ?>';

					/* Send the data using post  */
					$.ajax({
					  url: _url,
					  type: "GET",
					  data: post_data,
					  dataType: 'html',
					  success: function(json_string){
					  	var arr_folder = JSON.parse(json_string);

						docmanFolder.loadFolderFiles(docman_data.current.folder_id, null, null, null, true);
						
						var params_dialog = {title : "File rename confirmation", status : true, file_id : file_id, file_name: file_name, error_message : ''};	
					  	docman.statusConfirm('file-rename-dialog-template-confirm', params_dialog, {});
					  },
					  error: function(response) {
					  	var arr_response = JSON.parse(response.responseText);

						var params_dialog = {title : "File rename confirmation", status : false, file_id : file_id, file_name: file_name, error_message : arr_response.error_message };
					  	docman.statusConfirm('file-rename-dialog-template-confirm', params_dialog, {});
					  }
					 });
					  
					
					$( this ).dialog( "close" );
				},
				Cancel: function() {
					$( this ).dialog( "close" );
				}
			}
		});
  };


  docmanFile.addFileInline = function(folder_id) {
  	if (folder_id === undefined) {
  		folder_id = docman_data.current.folder_id;
  	}

		folder_id = folder_id.toString().replace("folder-", "");
		if (!((docmanFolder.checkPermission(folder_id, 'w')) || (user_is_logged_in && docman_data.unprivileged_upload))) {
  		return false;	
  	}

		$('#add_inline_filename').attr("value",'');
		$('#add_inline_description').attr("value",'');
		$('#add_inline_changes').attr("value",'');

		$( "#file-add-inline-dialog-template" ).dialog({
			title: "Create new file inline",
			resizable: false,
			scrollbars: false,
			height:800,
			width:810,
			position: ['center', 'center'],
			modal: true,
			open: function() {
				CKEDITOR.replace("file_inline_contents", {height: 350});
			},
			close: function() {
				CKEDITOR.instances.file_inline_contents.destroy();
			},
			buttons: {
				"Save": function() {
					var _url = '<?php echo GFUrl::getUrl()->projectURL($project,'DocmanFileAddAction','docman','', array()); ?>' + '&folder_id=' + folder_id;
					var post_data = {};
					$.each($('#form-file-add-inline-rendered').serializeArray(), function(i, field) {
    					post_data[field.name] = field.value;
					});

					post_data['filename'] = $('#add_inline_filename').attr("value");
					post_data['description'] = $('#add_inline_description').attr("value");
					post_data['changes'] = $('#add_inline_changes').attr("value");
					post_data['folder_id'] = folder_id;

					var file_contents = CKEDITOR.instances['file_inline_contents'].getData();

					post_data['message'] = file_contents;

					var main_dialog = this;

					$.ajax({
					  url: _url,
					  type: "POST",
					  data: post_data,
					  dataType: 'html',
					  success: function(json_string) {
					  	var arr_filedata = JSON.parse(json_string);

						if (folder_id == docman_data.current.folder_id && arr_filedata.is_approved == true) {
							docmanFolder.loadFolderFiles(docman_data.current.folder_id, null, null, null, true);
						}
							
						//Makes sure to remove the no documents message
						docman.removeNoFilesMessage();
							
						$(main_dialog).dialog( "close" );
						var params_dialog = {title: "File add confirmation", status : true, error_message : ''};
						var options = {height : 250};
						docman.statusConfirm('file-inline-add-dialog-template-confirm', params_dialog, options);
							
					  },
					  error: function(response) {
					  	var op_response = JSON.parse(response.responseText);
						var params_dialog = {title: "File add confirmation", status : false, folder_id : folder_id, error_message : op_response.error_message};
						var options = {height : 250, prevent_auto_fade : true, div_dialog : 'docman-modal-dialog2'};
					  	docman.statusConfirm('file-inline-add-dialog-template-confirm', params_dialog, options);
					  }
					});

				},
				Cancel: function() {
					$( this ).dialog( "close" );
				}
			}
		});
  };


  docmanFile.editFileInline = function(file_id, file_name) {
  	if (!docmanFile.checkPermission(file_id, docman_data.current.folder_id, 'w')) { 
  		return false;
  	}
  	
  	var _url = '<?php echo GFUrl::getUrl()->projectURL($project,'DocmanFileInlineEdit','docman','', array()); ?>';
  	
  	var post_data = {};
  	post_data['id'] = file_id;
  	
		$.ajax({
		  url: _url,
		  type: "POST",
		  data: post_data,
		  dataType: 'html',
	  	success: function(str_response){
		    var response = JSON.parse(str_response);
		    var file_content = response.file_content;
		    var description = response.description;
		    var changes = response.changes;
		  	docmanFile.editFileInlineCallback(file_id, file_name, file_content, description, changes);
			}, 
			error: function(json_string) {
			}
		});
	};



  docmanFile.editFileInlineCallback = function(file_id, file_name, file_content, description, changes) {
		$('#add_inline_filename').attr("value", file_name);
		$('#add_inline_description').attr("value",description);
		$('#add_inline_changes').attr("value",changes);	
  	
		$( "#file-add-inline-dialog-template" ).dialog({
			title: "Edit file inline",
			resizable: false,
			scrollbars: false,
			height:810,
			width:800,
			position: ['center', 'center'],
			modal: false,
			open: function() {
				CKEDITOR.replace("file_inline_contents", {height: 350});
				CKEDITOR.instances.file_inline_contents.setData(file_content);
			},
			close: function() {
				CKEDITOR.instances.file_inline_contents.destroy();
			},
			buttons: {
				"Save": function() {
					var _url = '<?php echo GFUrl::getUrl()->projectURL($project,'DocmanFileInlineEditAction','docman','', array()); ?>';

					var post_data = {};

					post_data['id'] = file_id;			
					post_data['file_name'] = $('#add_inline_filename').attr("value");
					post_data['description'] = $('#add_inline_description').attr("value");
					post_data['changes'] = $('#add_inline_changes').attr("value");
					post_data['folder_id'] = docman_data.current.folder_id;
					var file_contents = CKEDITOR.instances['file_inline_contents'].getData();
					post_data['file_content'] = file_contents;
			
					$.ajax({
					  url: _url,
					  type: "POST",
					  data: post_data,
					  dataType: 'html',
					  success: function(json_string){
					  	var arr_filedata = JSON.parse(json_string);
							var params_dialog = {title: "File edit confirmation", status : true, file_id : file_id, file_name : file_name};
							docman.statusConfirm('file-inline-edit-dialog-template-confirm', params_dialog, {});
					  },
					  error: function(html){
					    var params_dialog = {title: "File edit confirmation", status : false, file_id : file_id, file_name : file_name};
					    docman.statusConfirm('file-inline-edit-dialog-template-confirm', params_dialog, {});
					  }
					});

					$( this ).dialog( "close" );
				},
				Cancel: function() {
					$( this ).dialog( "close" );
				}
			}
		});		
  };
  
  
  
  docmanFile.monitorFile = function(file_id, file_name) {
		var post_data = {'file_id' : file_id};
		var _url = '<?php echo GFUrl::getUrl()->projectURL($project,'DocmanFileMonitorAction','docman','', array()); ?>';

		$.ajax({
		  url: _url,
		  type: "GET",
		  data: post_data,
		  dataType: 'html',
		
		  success: function(json_string){
				var monitored = false;
				if (docman_data.files[file_id].monitor) {
					monitored = false;
					docman.setFileAttr(file_id, 'file', 'monitoring', '0');
					docman_data.files[file_id].monitor = false;
					docman.setFileAttr(file_id, 'monitoring', 'src', "/themes/gforge5/images_docman/monitoring_off.png");
				} else {
					monitored = true;
					docman.setFileAttr(file_id, 'file', 'monitoring', '1');
					docman_data.files[file_id].monitor = true;
					docman.setFileAttr(file_id, 'monitoring', 'src', "/themes/gforge5/images_docman/monitoring_on.png");
				}
		  },
		  error: function(html){
		  	var params_dialog = {title: "File monitor confirmation", status : false, file_id : file_id, file_name : file_name, monitored: false};
		    docman.statusConfirm('file-monitor-dialog-template-confirm', params_dialog, {});
		  }
		});	
		
		return false;
  };
  
  
  docmanFile.whosMonitoringFile = function(file_id, file_name) {
  	var post_data = {'file_id' : file_id};
		var _url = '<?php echo GFUrl::getUrl()->projectURL($project,'DocmanFileWhosMonitoringAction','docman','', array()); ?>';

		$.ajax({
		  url: _url,
		  type: "GET",
		  data: post_data,
		  dataType: 'html',
		
		  success: function(json_string){
		  	var arr_monitors = JSON.parse(json_string);

				var str_table = '<table class="tabular" summary="" cellpadding="5" cellspacing="1" width="100%">'
												+ '<tbody><tr class="th">'
												+ '<th nowrap="nowrap">Username</th>'
												+ '<th nowrap="nowrap">First name</th>'
												+ '<th nowrap="nowrap">Last name</th></tr>';

				for (var i=0; i < arr_monitors.length; i++) {
					str_table += '<tr class="l">';
					str_table += '<td>' + arr_monitors[i]['user_id'] + '</td>';
					str_table += '<td>' + arr_monitors[i]['unixname'] + '</td>';
					str_table += '<td>' + arr_monitors[i]['username'] + '</td>';
					str_table += '</tr>';
				} 			
				str_table += '</tbody></table>';
				var params_dialog = {title: "Who is monitoring", status : true, file_id : file_id, file_name : file_name, monitors : str_table};
				var options = {width : 600, height : 400, prevent_auto_fade : true};
				docman.statusConfirm('file-whos-monitoring-dialog-template-confirm', params_dialog, options);
		  },
		  error: function(html){
		  	var params_dialog = {title: "Who is monitoring", status : false, file_id : file_id, file_name : file_name, monitors : ''};
		    docman.statusConfirm('file-whos-monitoring-dialog-template-confirm', params_dialog, {});
		  }
		});	
  };
  
  
 
  docmanFile.downloadFile = function(file_id, file_name) {
		var str_url = docman_data.files[file_id].strict_download_url;
  	window.open(str_url, 'Download');
  	return false;
  };
  
  
  docmanFile.moveFile = function(parent_folder_id, file_id, operation_type) { 	
 		var file_name = docman.getFileAttr(file_id, 'file', 'fname');
  	var moved_row = $('#node-file' + file_id);
  	var params = {parent_folder_id : parent_folder_id, file_id : file_id, operation_type : operation_type, previous_folder_id : docman_data.current.folder_id, moved_row : moved_row, file_name : file_name };

		if (operation_type == 'moveup') {
			var _url = '<?php echo GFUrl::getUrl()->projectURL($project,'DocmanGetFolderPermission','docman','', array()); ?>&folder_id=' + parent_folder_id + '&type=parent';

			$.ajax({
			  url: _url,
			  type: "GET",
			  data: null,
			  dataType: 'html',
			  success: function(json_string){
			  	var arr_folder = JSON.parse(json_string);				  	
					var folder_perms = arr_folder.permission;
			
					if (folder_perms != 'w') {
						docmanFolder.showPermissionDenied(parent_folder_id, 'w');
						return;
					}
			
					docmanFile.moveFileCallback(params);			
			  },
				error: function(response) {
				}
			});
		} else {
	  	if (!docmanFile.checkPermission(file_id, parent_folder_id, 'w')) {
	  		return false;
	  	}
	  	docmanFile.moveFileCallback(params);			
		}

  }
  
  
  
  docmanFile.moveFileCallback = function(params) {	
  	var parent_folder_id = params.parent_folder_id;
  	var file_id = params.file_id;
  	var file_name = params.file_name;
  	var operation_type = params.operation_type;
  	var previous_folder_id = params.previous_folder_id;
  	var moved_row = params.moved_row;
  	
		//Get Parent folder name
		var parent_folder_name = $('#folder-' + parent_folder_id).attr("fname");

  	var tmpl = new EJS({element: 'file-move-dialog-template'}); 
  	$('#docman-modal-dialog').html(tmpl.render({file_id : file_id, file_name : file_name, parent_folder_id : parent_folder_id, parent_folder_name : parent_folder_name}));
		$('#docman-modal-dialog').attr('title', 'Move File');

		var post_data = {file_id : file_id, new_folder_id : parent_folder_id, current_folder_id : previous_folder_id, operation_type : operation_type, incoming_folder : incoming_folder};
		var _url = '<?php echo GFUrl::getUrl()->projectURL($project,'DocmanFileMoveAction','docman','admin', array()); ?>';

		$.ajax({
		  url: _url,
		  type: "GET",
		  data: post_data,
		  dataType: 'html',
		  success: function(json_string){
		  	var arr_folder = JSON.parse(json_string);
					
			  var tmpl = new EJS({element: 'file-move-dialog-template-confirm'}); 
			  var link = '<a href="javascript:;" onclick="docmanFile.undoFileMove(' + file_id + ', ' + previous_folder_id + ', ' + parent_folder_id + ', \'' + operation_type + '\');">here</a>';
  			$('#docman-modal-dialog').html(tmpl.render({file_id : file_id, file_name : file_name, parent_folder_name : parent_folder_name, previous_folder_id : previous_folder_id, parent_folder_id : parent_folder_id, operation_type : operation_type, link : link}));

				if (operation_type == 'moveup') {				
					docmanFolder.goUp(parent_folder_id);
				} else {
					docmanFolder.loadFolderFiles(parent_folder_id, null, null, null, false);
					docman_data.current.folder_id = parent_folder_id;
				}
					  	
				$( "#docman-modal-dialog" ).dialog({
					title: "File Moved",
					resizable: false,
					scrollbars: true,
					height:'auto',
					width:400,
					position: ['center', 'center'],
					modal: true,
					buttons: {
						"Close": function() {
							$( this ).dialog( "close" );
						}		
					}
				});
		  	
		  },
		  error: function(response) {
		  	var params_dialog = {title: "File move confirmation", status : false, file_id : file_id, file_name : file_name/*, folder_name: arr_folder.folder_name*/};
		  	docman.statusConfirm('file-move-error-dialog-template', params_dialog, {});
		  }
		});
					
  };


	docmanFile.undoFileMove = function(file_id, previous_folder_id, parent_folder_id, operation_type) {
		if (operation_type == 'moveup') {
			operation_type = 'folder';
			parent_folder_id = docman_data.current.folder_id;
		}
		var post_data = {file_id : file_id, new_folder_id : previous_folder_id, current_folder_id : parent_folder_id, operation_type : operation_type, incoming_folder : incoming_folder};
		var _url = '<?php echo GFUrl::getUrl()->projectURL($project,'DocmanFileMoveAction','docman','admin', array()); ?>';
							
		$.ajax({
		  url: _url,
		  type: "GET",
			  data: post_data,
			  dataType: 'html',
			  success: function(str_response){
					docmanFile.removeFileFromPanel(file_id, -1);
					$( "#docman-modal-dialog" ).dialog('close');						  	
				}, 
				error: function(json_string) {
					var params_dialog = {title: "File move confirmation", status : false, file_id : file_id};
					docman.statusConfirm('file-move-error-dialog-template', params_dialog, {});
				}
		});
							
	};



  docmanFile.viewDetails = function(file_id, file_name) {
  	docmanFolder.loadFolderFiles(docman_data.current.folder_id, null, null, null, true);
  	
  	var _url = '<?php echo GFUrl::getUrl()->projectURL($project,'DocmanFileDetails','docman','', array()); ?>';

  	var post_data = {};
  	post_data['file_id'] = file_id;
  	post_data['file_name'] = file_name;
  	
  	FileUploadWidgetSetParameter('file_id', file_id);
  	docmanFile.addFileVersion = true;
  	
		$.ajax({
		  url: _url,
		  type: "GET",
		  data: post_data,
		  dataType: 'html',
		  success: function(str_response){
		  	docmanFile.viewDetailsCallback(file_id, file_name, str_response);
			}, 
			error: function(json_string) {
				FileUploadWidgetSetParameter('file_id', 0);
			}
		});
	};
	

  docmanFile.viewDetailsCallback = function(file_id, file_name, details) {
  	$('#docman-modal-dialog').html('');
  	var tmpl = new EJS({element: 'file-view-details-dialog-template'}); 
  	$('#docman-modal-dialog').html(tmpl.render({file_id : file_id, file_name : file_name, details : details}));

		docmanFile.viewDetailsDialog = $( "#docman-modal-dialog" ).dialog({
			title: "View File Details",
			resizable: false,
			scrollbars: true,
			height:'auto',
			width:800,
			position: ['center', 'center'],
			modal: true,
			buttons: {
				"Close": function() {
					$( this ).dialog( "close" );
				}
			},
			beforeClose: function( event, ui ) {
					FileUploadWidgetSetParameter('file_id', 0);
					docmanFile.addFileVersion = false;
					docmanFile.viewDetailsDialog = null; 
				}
		});
  };



  docmanFile.addAssociation = function(file_id, file_name) {
  	var tmpl = new EJS({element: 'file-add-association-dialog-template'}); 
  	$('#docman-modal-dialog2').html(tmpl.render({file_id : file_id, file_name : file_name}));
		var association_dialog = null;
		$( "#docman-modal-dialog2" ).dialog({
			title: "Add association",
			resizable: false,
			scrollbars: false,
			height:'auto',
			width:400,
			position: ['center', 'center'],
			modal: true,
			stack: true,
			open: function() {
				 association_dialog = this;
			},
			buttons: {
				"Add": function() {
					var _url = '<?php echo GFUrl::getUrl()->projectURL($project,'AssociationAddAction','','association', array()); ?>';

					var post_data = {};
					$.each($('#form-file-add-association-rendered').serializeArray(), function(i, field) {
    					post_data[field.name] = field.value;
					});
					post_data['ajax'] = 1;

					$.ajax({
					  url: _url,
					  type: "POST",
					  data: post_data,
					  dataType: 'html',
					  success: function(json_string){
					  	var arr_filedata = JSON.parse(json_string);
					  	$("#tabs-2").html(arr_filedata.html);
					  	$( association_dialog ).dialog( "close" );
					  },
					  error: function(response){
					  	var op_response = JSON.parse(response.responseText);
					    var params_dialog = {title: "Add Association confirmation", status : false, file_id : file_id, file_name : file_name, error_message : op_response.error_message};
					    var options = {width : 500, height : 300, div_dialog : 'docman-modal-dialog3'};
					    docman.statusConfirm('file-add-association-dialog-template-confirm', params_dialog, options);
					  }
					});
				},
				Cancel: function() {
					$( this ).dialog( "close" );
				}
			}
		});

  };



  docmanFile.deleteAssociation = function(key, description) {
  	var tmpl = new EJS({element: 'file-delete-association-dialog-template'});
  	$('#docman-modal-dialog2').html(tmpl.render({description: description}));
		var association_dialog = null;
		$( "#docman-modal-dialog2" ).dialog({
			title: "Delete association",
			resizable: false,
			scrollbars: false,
			height:'auto',
			width:400,
			position: ['center', 'center'],
			modal: true,
			stack: true,
			open: function() {
				 association_dialog = this;
			},
			buttons: {
				"Yes": function() {
					var _url = '<?php echo GFUrl::getUrl()->projectURL($project,'AssociationDeleteAction','','association', array()); ?>';

					var post_data = {};
					post_data['key'] = key;
					post_data['ajax'] = '1';
					post_data['return_to'] = '';
					post_data['sure'] = '1';

					$.ajax({
					  url: _url,
					  type: "POST",
					  data: post_data,
					  dataType: 'html',
					  success: function(json_string){
					  	var arr_filedata = JSON.parse(json_string);
					  	$("#tabs-2").html(arr_filedata.html);
						$( association_dialog ).dialog( "close" );
					  },
					  error: function(response){
					  	var op_response = JSON.parse(response.responseText);
					    var params_dialog = {title: "Delete Association confirmation", status : false, file_id : file_id, file_name : file_name, error_message : op_response.error_message};
					    var options = {width : 500, height : 300, div_dialog : 'docman-modal-dialog3'};
					    docman.statusConfirm('file-delete-association-dialog-template-confirm', params_dialog, options);
					  }
					});

				},
				Cancel: function() {
					$( this ).dialog( "close" );
				}
			}
		});
		
	};


	docmanFile.getFileTypeIcon = function(file_type) {
		var file_type_icon = "html";
		if (file_type.indexOf('html') > 0) {
					file_type_icon = "document";
				} else {
					if (file_type.indexOf('pdf') > 0) {
						file_type_icon = "pdf";
					} else {
						if (file_type.indexOf('msword') > 0) {
							file_type_icon = "document";
						} else {
							if (file_type.indexOf('excel') > 0 || file_type.indexOf('officedocument.spreadsheetml') > 0) {
								file_type_icon = "document";
							} else {
								if (file_type.indexOf('mage') > 0) {
									file_type_icon = "graphic";
								} else {
									file_type_icon = "document";
								}
							}
						}
					}
				}
		return file_type_icon;
	};


  docmanFile.organizeFile = function(file_id, file_name) {
  	var _url = '<?php echo GFUrl::getUrl()->projectURL($project,'DocmanFileFolderTree','docman','', array()); ?>&file_id=' + file_id;
	file_name = docman_data.files[file_id].file_name;
  	var post_data = {};
  	post_data['id'] = file_id;
  	
		$.ajax({
		  url: _url,
		  type: "POST",
		  data: post_data,
		  dataType: 'html',
		  success: function(str_tree){	   
		  	docmanFile.organizeFileCallback(file_id, file_name, str_tree);
			}, 
			error: function(json_string) {
			}
		});

	};
	

  docmanFile.organizeFileCallback = function(file_id, file_name, str_tree) {
  	var tmpl = new EJS({element: 'file-organize-dialog-template'}); 
  	$('#docman-modal-dialog').html(tmpl.render({file_id : file_id, file_name : file_name, tree : str_tree}));
    $('#organizetree').checkboxTree();
       
		$( "#docman-modal-dialog" ).dialog({
			title: "Organize File",
			resizable: false,
			scrollbars: false,
			height: docman.getMaxHeight(),
			width: 800,
			position: ['center', 'center'],
			modal: true,
			buttons: {
				"Close": function() {
					$( this ).dialog( "close" );
				}
			}
		});
  };



  docmanFile.handleFileUpload = function(file_object) {
	  if (!(docman_data.current.permission == 'u' || docman_data.current.permission == 'w') && docman_data.unprivileged_upload) {
		  var tmpl = new EJS({element: 'file-unprivileged-upload-template-confirm'});
		  $('#docman-modal-dialog').html(tmpl.render({}));
		  $( "#docman-modal-dialog" ).dialog({
			  resizable: false,
			  height:'auto',
			  width: 400,
			  title: "File uploaded",
			  modal: true,
			  buttons: {
				  close: function() {
					  $( this ).dialog( "close" );
				  }
			  }
		  });
	  }

	  show_file_id = 0;

		if ($("#node-file" + file_object.file_id).length > 0) {
			docmanFolder.loadFolderFiles(docman_data.current.folder_id, null, null, null, true);
		} else {
			docmanFolder.loadFolderFiles(docman_data.current.folder_id, null, null, null, true);
		}
		
		if (docmanFile.addFileVersion) {
			if (docmanFile.viewDetailsDialog != null) {
				docmanFile.viewDetails(file_object.file_id, file_object.file_name);
			} else {
				docmanFile.addFileVersion = false;
				FileUploadWidgetSetParameter('file_id', 0);
			}
		}		
		
		$(docman.uploadDialog).dialog('close');

  };


	docmanFile.getIsApproved = function(file_id) {
		if (docman.getFileAttr(file_id, 'file', 'approved') == "1") {
			return true;
		} else {
			return false;
		}
	};
	
	
	docmanFile.approveFile = function(file_id) {
		var _url = '<?php echo GFUrl::getUrl()->projectURL($project,'DocmanFileVersionApprove','docman','admin', array()); ?>';

		var post_data = {file_id : file_id};

		$.ajax({
		  url: _url,
		  type: "POST",
		  data: post_data,
		  dataType: 'html',
		  success: function(json_string){
				//Remove the file from the pending queue
				docmanFile.removeFileFromPanel(file_id, -1);
				
				$( this ).dialog( "close" );
		  },
		  error: function(response){
		  	var op_response = JSON.parse(response.responseText);
		    docman.statusConfirm('fileversion-approval-error-dialog-template', {}, {});
		  }
		});
	};

	
	
	docmanFile.rejectFile = function(file_id) {
		var _url = '<?php echo GFUrl::getUrl()->projectURL($project,'DocmanFileVersionReject','docman','admin', array()); ?>';

		var post_data = {file_id : file_id};

		$.ajax({
		  url: _url,
		  type: "POST",
		  data: post_data,
		  dataType: 'html',
		  success: function(json_string){
				//Remove the file from the pending queue
				docmanFile.removeFileFromPanel(file_id, -1);
				
				$( this ).dialog( "close" );
		  },
		  error: function(response){
		  	var op_response = JSON.parse(response.responseText);
		    docman.statusConfirm('fileversion-approval-error-dialog-template', {}, {});
		  }
		});
	};	


	docmanFile.viewFileDownloads = function(file_id, file_name) {
		var _url = '<?php echo GFUrl::getUrl()->projectURL($project,'DocmanGetDownloadsData','docman','', array()); ?>&file_id=' + file_id;
		
		var data = {file_id : file_id};

		$.ajax({
		  url: _url,
		  type: "GET",
		  data: data,
		  dataType: 'html',
		  success: function(json_string) {
		  	var arr_download_data = JSON.parse(json_string);
		  	var test = {file_name : file_name, downloads : arr_download_data};
		  	
			  var tmpl = new EJS({url: '/docman_downloads.ejs'});
			  $('#docman-modal-dialog').html(tmpl.render({file_name : file_name, downloads : arr_download_data}));

				$( "#docman-modal-dialog" ).dialog({
					title: "Document Downloads",
					resizable: false,
					scrollbars: false,
					height: 500,
					width: 500,
					position: ['center', 'center'],
					modal: true,
					buttons: {
						"Close": function() {
							$( this ).dialog( "close" );
						}
					}
				});
		  						
				$( this ).dialog( "close" );
		  },
		  error: function(response){
		  }
		});
	}


	docmanFile.deleteFileVersion = function(file_id, file_version_id) {
		var _url = '<?php echo GFUrl::getUrl()->projectURL($project,'DocmanGetFileVersionCount','docman','', array()); ?>&file_version_id=' + file_version_id;

		file_name = docman_data.files[file_id].file_name;

		$.ajax({
		  url: _url,
		  type: "GET",
		  data: {},
		  dataType: 'html',
		  success: function(json_string) {
		  	try {
		  		var arr_data = JSON.parse(json_string);
		  		var is_last_version;
		  		if (arr_data.dfv_count > 1) {
		  			is_last_version = false;
		  		} else {
		  			is_last_version = true;
		  		}
		  			
		  		docmanFile.deleteFileVersionCallback(file_id, file_version_id, file_name, is_last_version);
		  	} catch(err) {
		  	}
		  },
		  error: function(response){
		  }
		});
		
	};
	
	
	docmanFile.deleteFileVersionCallback = function(file_id, file_version_id, file_name, is_last_version) {
  	var tmpl = new EJS({element: 'file-version-delete-template'}); 
  	$('#docman-modal-dialog2').html(tmpl.render({file_version_id : file_version_id, file_name : file_name, is_last_version : is_last_version}));

		$( "#docman-modal-dialog2" ).dialog({
			title: "File version delete",
			resizable: false,
			scrollbars: false,
			height:'auto',
			width:400,
			position: ['center', 'center'],
			modal: true,
			stack: true,
			buttons: {
				"Yes": function() {
					var _url = '<?php echo GFUrl::getUrl()->projectURL($project,'DocmanFileVersionDeleteAction','docman','admin', array()); ?>&file_version_id=' + file_version_id;
					var confirm_dialog_ref = this;
					
					$.ajax({
					  url: _url,
					  type: "GET",
					  data: {},
					  dataType: 'html',
					  success: function(json_string){
							docmanFolder.loadFolderFiles(docman_data.current.folder_id, null, null, null, true);
							if (is_last_version) {
								$('#docman-modal-dialog').dialog("close");
							} else {
								docmanFile.viewDetails(file_id, file_name);
							}
					  	$( confirm_dialog_ref ).dialog( "close" );
					  },
					  error: function(response){
					  	var op_response = JSON.parse(response.responseText);
					    var params_dialog = {title: "File version delete confirmation", status : false, file_version_id : file_version_id, file_name : file_name};
					    var options = {width : 500, height : 300, div_dialog : 'docman-modal-dialog3'};
					    docman.statusConfirm('file-delete-association-dialog-template-confirm', params_dialog, options);
					  }
					});
				},
				Cancel: function() {
					$( this ).dialog( "close" );
				}
			}
		});
	};
			


  docmanFile.editFileDescription = function(file_id) {
	var file_name = docman_data.files[file_id].file_name;
	var description = docman_data.files[file_id].description;

  	var tmpl = new EJS({element: 'file-edit-file-description-template'}); 
  	$('#docman-modal-dialog2').html(tmpl.render({file_id : file_id, file_name : file_name, description : description}));

		var description_edit_dialog = null;
		
		$( "#docman-modal-dialog2" ).dialog({
			title: "Edit File Version",
			resizable: false,
			scrollbars: false,
			height:'auto',
			width:400,
			position: ['center', 'center'],
			modal: true,
			stack: true,
			open: function() {
				description_edit_dialog = this;
			},
			buttons: {
				"Save": function() {
					var _url = '<?php echo GFUrl::getUrl()->projectURL($project,'DocmanEditFileDescription','','docman', array()); ?>';

					var post_data = {};
					$.each($('#form-edit-file-description-rendered').serializeArray(), function(i, field) {
    					post_data[field.name] = field.value;
					});
					post_data['file_name'] = file_name;
					$.ajax({
					  url: _url,
					  type: "POST",
					  data: post_data,
					  dataType: 'html',
					  success: function(json_string){
					  	$(description_edit_dialog).dialog( "close" );
							docmanFile.viewDetails(file_id, file_name);
					  },
					  error: function(response){
					  	var op_response = JSON.parse(response.responseText);
							$(description_edit_dialog).dialog( "close" );
					    var params_dialog = {title: "Edit File Description", status : false, file_id : file_id, file_name : file_name, error_message : op_response.error_message};
					    var options = {width : 500, height : 300, div_dialog : 'docman-modal-dialog3'};
					    docman.statusConfirm('file-edit-file-description-template-confirm', params_dialog, options);
					  }
					});
				},
				Cancel: function() {
					$( this ).dialog( "close" );
				}
			}
		});

  };
	
	
	
  docmanFile.editVersionChanges = function(file_id, file_name, file_version_id, version_number, version_date, changes) {
  	var tmpl = new EJS({element: 'file-edit-file-changes-template'}); 
  	$('#docman-modal-dialog2').html(tmpl.render({file_version_id : file_version_id, version_number : version_number, version_date : version_date, changes : changes}));

		var changes_edit_dialog = null;
		
		$( "#docman-modal-dialog2" ).dialog({
			title: "Edit File Version Changes",
			resizable: false,
			scrollbars: false,
			height:'auto',
			width:400,
			position: ['center', 'center'],
			modal: true,
			stack: true,
			open: function() {
				changes_edit_dialog = this;
			},
			buttons: {
				"Save": function() {
					var _url = '<?php echo GFUrl::getUrl()->projectURL($project,'DocmanEditFileVersion','','docman', array()); ?>';
					var post_data = {};
					$.each($('#form-edit-file-changes-rendered').serializeArray(), function(i, field) {
    					post_data[field.name] = field.value;
					});
					post_data['ajax'] = 1;
					$.ajax({
					  url: _url,
					  type: "POST",
					  data: post_data,
					  dataType: 'html',
					  success: function(json_string){
					  	var arr_filedata = JSON.parse(json_string);
					  	$(changes_edit_dialog).dialog( "close" );
							docmanFile.viewDetails(file_id, file_name);
					  },
					  error: function(response){
						  $(changes_edit_dialog).dialog( "close" );
					  	var op_response = JSON.parse(response.responseText);
					    var params_dialog = {title: "Edit file version changes", status : false, version_number : version_number, version_date : version_date , error_message : op_response.error_message};
					    var options = {width : 500, height : 300, div_dialog : 'docman-modal-dialog3'};
					    docman.statusConfirm('file-edit-file-changes-template-confirm', params_dialog, options);
					  }
					});
				},
				Cancel: function() {
					$( this ).dialog( "close" );
				}
			}
		});

  };
	
	docmanFile.uploadVersion = function(file_id, file_name) {
		docmanFile.addFileVersion = true;
		FileUploadWidgetSetParameter('file_id', file_id);
		showUpload(file_id, file_name);
	};
	
	docmanFile.userCanRead = function(file_id) {
		if (docman_wide_perms) {
			return true;
		}

		var perm = docman_data.files[file_id].permission;
		if (perm == 'w' || perm == 'r') {
			return true;
		} else {
			return false;
		}
	};


	docmanFile.userCanWrite = function(file_id) {
		if (docman_wide_perms) {
			return true;
		}

		var perm = docman_data.files[file_id].permission;
		if (perm == 'w') {
			return true;
		} else {
			return false;
		}
	};


	docmanFile.checkPermission = function(file_id, folder_id, perm_type) {
		if (docman_wide_perms) {
			return true;
		}

		switch (perm_type) {
			case 'r':
				var res = '';
				if (docman_mode == 'navigate') {
					var res = docmanFolder.checkPermission(folder_id, perm_type);
				} else {
					if (docman_mode == 'search') {
						var res = docmanFile.userCanRead(file_id);
					}
				}
				
				if (!res) {
					docmanFolder.showPermissionDenied(folder_id, perm_type);
					return false;
				} else {
					return true;
				}
			break;			
			
			case 'w':
				if (docman_mode == 'navigate') {
					var res = docmanFolder.checkPermission(folder_id, perm_type);
				} else {
					if (docman_mode == 'search') {
						var res = docmanFile.userCanWrite(file_id);
					}
				}
				
				if (!res) {
					docmanFolder.showPermissionDenied(folder_id, perm_type);
					return false;
				} else {
					return true;
				}
			break;
			
		}
	};


	function getCheckedValue(radioObj) {
		if(!radioObj)
			return "";
		var radioLength = radioObj.length;
		if(radioLength == undefined)
			if(radioObj.checked)
				return radioObj.value;
			else
				return "";
		for(var i = 0; i < radioLength; i++) {
			if(radioObj[i].checked) {
				return radioObj[i].value;
			}
		}
		return "";
	}

</script>