<script type="text/javascript">

var docmanFolder = namespace('GForge.Plugins.Docman.DocmanFolder');
	
  	function createFolderMenu() {

		$(function(){
		    $.contextMenu({
		        selector: '.menu_folder', 
		        callback: function(key, options) {
		            var m = "clicked: " + key;
		            var id = options.$trigger.attr("id");
		            var name = options.$trigger.attr("fname");
		            
		            switch(key) {
				        	case "addfiles":
				        		<?php if ($can_drag_drop) { ?>
				        		addFilesToFolder(id, name);
				        		<?php } else { ?>
				        		showUpload();
				        		<?php } ?>
				        	break;
				        	
				        	case "monitorfolder":
				        		docmanFile.monitorFolder(id, name);
				        	break;
				        	
				        	case "createfolder":
				        		docmanFolder.createFolder(id, name);
				        	break;
				
				        	case "addfileinline":
				        		docmanFile.addFileInline(id, name);
				        	break;
				
				        	case "deletefolder":
				        		docmanFolder.deleteFolder(id, name);
				        	break;
				        	
				        	case "editfolder":
				        		docmanFolder.editFolder(id, name);
				        	break;
		            }
		            
		        },
		        items: {
		            "addfiles": {name: "Add Files", icon: "edit"},
		            "sep1": "---------",
		            "createfolder": {name: "Create New Folder", icon: "copy"},
		            "addfileinline": {name: "Add New File Inline", icon: "copy"},
		            "deletefolder": {name: "Delete Folder", icon: "delete"},
		            "editfolder": {name: "Edit Folder", icon: "copy"},
		            "sep2": "---------",
		            "quit": {name: "Quit", icon: "quit"}
		        }
		    });

		    $('.context-menu-one').on('click', function(e){

		    })
		});
  	
   }

 
  	function createFolderMenuPanel() {
		$(function(){

		    $.contextMenu({
		        selector: '.menu_folder_panel',
		        callback: function(key, options) {
		            var m = "clicked: " + key;
		            var id = options.$trigger.attr("id");
		            id = id.replace('-panel', ''); 
		            var name = options.$trigger.attr("fname");
		            
		            switch(key) {
				        	case "addfiles":
				        		<?php if ($can_drag_drop) { ?>
				        		addFilesToFolder(id, name);
				        		<?php } else { ?>
				        		showUpload();
				        		<?php } ?>
				        	break;
				        	
				        	case "createfolder":
				        		docmanFolder.createFolder(id, name);
				        	break;
				
				        	case "addfileinline":
				        		docmanFile.addFileInline(id, name);
				        	break;
				
				        	case "deletefolder":
				        		docmanFolder.deleteFolder(id, name);
				        	break;
				        	
				        	case "editfolder":
				        		docmanFolder.editFolder(id, name);
				        	break;
		            }
		            
		        },
		        items: {
		            "addfiles": {name: "Add Files", icon: "edit"},
		            "sep1": "---------",
		            "createfolder": {name: "Create New Folder", icon: "copy"},
		            "addfileinline": {name: "Add New File Inline", icon: "copy"},
		            "deletefolder": {name: "Delete Folder", icon: "delete"},
		            "editfolder": {name: "Edit Folder", icon: "copy"},
		            "sep2": "---------",
		            "quit": {name: "Quit", icon: "quit"}
		        }
		    });

		});



	    $(function(){

				$.contextMenu({
					selector: '.menu_folder_root_panel',
					callback: function(key, options) {
						var m = "clicked: " + key;
						var id = options.$trigger.attr("id");
						id = id.replace('-panel', '');
						var name = options.$trigger.attr("fname");

						switch(key) {
							case "addfiles":
							<?php if ($can_drag_drop) { ?>
								addFilesToFolder(id, name);
							<?php } else { ?>
								showUpload();
							<?php } ?>
								break;

							case "createfolder":
								docmanFolder.createFolder(id, name);
								break;

							case "addfileinline":
								docmanFile.addFileInline(id, name);
								break;
						}

					},
					items: {
						"addfiles": {name: "Add Files", icon: "edit"},
						"sep1": "---------",
						"createfolder": {name: "Create New Folder", icon: "copy"},
						"addfileinline": {name: "Add New File Inline", icon: "copy"},
						"sep2": "---------",
						"quit": {name: "Quit", icon: "quit"}
					}
				});

		});
  	
   }


  docmanFolder.monitorFolder = function(folder_id, folder_name) {
		var post_data = {'folder_id' : folder_id};
		var _url = '<?php echo GFUrl::getUrl()->projectURL($project,'DocmanFolderMonitorAction','docman','', array()); ?>';

		$.ajax({
		  url: _url,
		  type: "GET",
		  data: post_data,
		  dataType: 'html',
		
		  success: function(json_string){
				var monitored = false;
				if (docman_data.folders[folder_id].monitor) {
					monitored = false;
					docman.setFolderAttr(folder_id, 'folder', 'monitoring', '0');
					docman_data.folders[folder_id].monitor = false;
					docman.setFolderAttr(folder_id, 'foldermonitoring', 'src', "/themes/gforge5/images_docman/monitoring_off.png");
				} else {
					monitored = true;
					docman.setFolderAttr(folder_id, 'folder', 'monitoring', '1');
					docman_data.folders[folder_id].monitor = true;
					docman.setFolderAttr(folder_id, 'foldermonitoring', 'src', "/themes/gforge5/images_docman/monitoring_on.png");
				}
		  },
		  error: function(html){
		  	var params_dialog = {title: "Folder monitor confirmation", status : false, folder_id : folder_id, folder_name : folder_name, monitored: false};
		    docman.statusConfirm('folder-monitor-dialog-template-confirm', params_dialog, {});
		  }
		});	
		
		return false;
  }

	/**
	* Function used by JQuery to sort folder by name
	* @param {object} folder object
	* @param {object} folder object
	* @boolean    
	*/  
  docmanFolder.sortFolders = function(a, b) {
		var aName = a.folder_name.toLowerCase();
  	var bName = b.folder_name.toLowerCase(); 
  	return ((aName < bName) ? -1 : ((aName > bName) ? 1 : 0));
	}



	/**
	* Function used by JQuery to sort files by filename
	* @param {object} file object
	* @param {object} file object
	* @boolean    
	*/  
  docmanFolder.sortFiles = function(a, b) {
		var aName = a.file_name.toLowerCase();
  	var bName = b.file_name.toLowerCase(); 
  	return ((aName < bName) ? -1 : ((aName > bName) ? 1 : 0));
	}


	/**
	* Parses JSON folder/files data and creates a memory object that contains all the 
	* folder/files data for the current parent folder
	* @param {String} folder_file_data    JSON string containing folder/files that belong to the current parent folder
	* @return {}    This method does not return anything. It sets two global variables: 
	*								docman.folderData and docman.fileData
	*/  
	docmanFolder.parseFolderFilesData = function(folder_file_data) {
		//Sort the folders by name
		folder_file_data.folders.sort(docmanFolder.sortFolders);

		docman_data.folders = new Object();
		for(var i=0; i < folder_file_data.folders.length; i++) {
			docman_data.folders[folder_file_data.folders[i].folder_id] = folder_file_data.folders[i];
		}

		//Sort the files in this folder by filename		
		folder_file_data.files.sort(docmanFolder.sortFiles);

		docman_data.files = new Object();
		for(var i=0; i < folder_file_data.files.length; i++) {
			docman_data.files[folder_file_data.files[i].file_id] = folder_file_data.files[i];
		}

	}

	/**
	* Renders HTML for a folder row
	* @param {Object} params    An object containing the data passed to the template engine
	* @return {String}   Returns a rendered row in HTML format
	*/
	docmanFolder.renderDocmanFolderRow = function(params) {
			var rendered_row = new EJS({url: '/docman_folder_row.ejs'}).render({folder : params});	
			return (rendered_row);
	};

 
	/**
	* Deletes a folder
	* @param {Int} folder_id    ID of the folder to be deleted
	* @param {String} folder_name    Name of the folder to be deleted
	* @return {}    This method does not return anything
	*/   
  docmanFolder.deleteFolder = function (folder_id, folder_name) { 	
  	folder_id = folder_id.replace('folder-', '');
		folder_id = folder_id.replace('node-name', '');
  	var tmpl = new EJS({element: 'folder-delete-dialog-template'}); 
  	$('#docman-modal-dialog').html(tmpl.render({folder_id : folder_id, folder_name : folder_name}));

		$( "#docman-modal-dialog" ).dialog({
			title: "Delete this folder?",
			resizable: false,
			height:'auto',
			modal: true,
			buttons: {
				"Delete Folder": function() {
					var post_data = {};
					$.each($('#form-folder-delete').serializeArray(), function(i, field) {
							post_data[field.name] = field.value;
					});
					var _url = '<?php echo GFUrl::getUrl()->projectURL($project,'DocmanFolderDeleteAction','docman','admin', array()); ?>';
					
					//Fix for IE7
					post_data['id'] = folder_id;
					if ($('#folder_delete_sure_rendered').attr('checked')) {
						post_data['sure'] = '1';
					} 

					/* Send the data using post  */
					$.ajax({
					  url: _url,
					  type: "POST",
					  data: post_data,
					  dataType: 'html',
					  success: function(json_string){
							$('tr[folder_' + folder_id + '="1"]').remove(); 

							try {							
								$('#node-folder' + folder_id).remove(); 
								$('#node-folder-divider' + folder_id).remove(); 
							} catch(err) { }
							
							var params_dialog = {title : "Folder delete confirmation", status : true, folder_id : folder_id, folder_name : folder_name};
							docman.statusConfirm('folder-delete-dialog-template-confirm', params_dialog, {});

						  docmanFolder.loadFolderOrganizer();
						},
						error: function(json_string) {
							var params_dialog = {title : "Folder delete confirmation", status : false, folder_id : folder_id, folder_name : folder_name};
							docman.statusConfirm('folder-delete-dialog-template-confirm', params_dialog, {});
						}
					});
										
					$( this ).dialog( "close" );
				},
				Cancel: function() {
					$( this ).dialog( "close" );
				}
			}
		});
  };


	/**
	* Creates a folder
	* @param {Int} parent_folder_id    ID of the parent folder
	* @param {String} parent_folder_name    Name of the parent folder
	* @return {}    This method does not return anything
	*/   
  docmanFolder.createFolder = function(parent_folder_id, parent_folder_name) {
    parent_folder_id = parent_folder_id.toString().replace("folder-", "");
								
		if (!docmanFolder.checkPermission(parent_folder_id, 'w')) {
			return false;
		}
 	
  	try {
  		if (!(typeof parent_folder_id === 'string')) {
  			parent_folder_id = parent_folder_id.toString();
  		}
  	} catch(err) { alert(err); }

  	var tmpl = new EJS({element: 'folder-create-dialog-template'}); 
  	$('#docman-modal-dialog').html(tmpl.render({parent_folder_id : parent_folder_id}));
		$('#docman-modal-dialog').attr('title', 'Create New Folder');

		var obj_dialog = '';

		$( "#docman-modal-dialog" ).dialog({
			resizable: false,
			height:'auto',
			width: 400,
			position: [200,130],
			modal: true,
			title: "Create Folder",
			open: function() {
				obj_dialog = this;
			},
			buttons: {
				"Create Folder": function() {
					var post_data = {};
					$.each($('#form-folder-create-rendered').serializeArray(), function(i, field) {
    					post_data[field.name] = field.value;
					});

					post_data['parent_folder_id'] = parent_folder_id;

					var _url = '<?php echo GFUrl::getUrl()->projectURL($project,'DocmanFolderAddAction','docman','admin', array()); ?>';

					var that = this;
					/* Send the data using post  */
					$.ajax({
					  url: _url,
					  type: "POST",
					  data: post_data,
					  dataType: 'html',
					  success: function(json_string){
					  	var arr_filedata = JSON.parse(json_string);

							var new_folder_name = "new folder";

	      			var strnewrow = '<tr id="node-' + arr_filedata.folder_id + '" class="child-of-node-' + arr_filedata.folder_id + ' ispublic="1">'
	        			+ '<td><span fname="' + arr_filedata.folder_name + '" id="folder-' + arr_filedata.folder_id + '" class="folder menu_folder_panel"></span><span><a href="javascript:;" onclick="docmanFolder.loadFolderFiles(' + arr_filedata.folder_id + ');" id="node-name' + arr_filedata.folder_id + '">' + arr_filedata.folder_name + '</a></span></td>'
	      				+ '</tr>';
					
							//Add new row
					    var newrow = $(strnewrow);
					    $('#node-' + arr_filedata.parent_folder_id).after(newrow);
							newrow.insertAfter('#node-' + arr_filedata.parent_folder_id);
							$('.example').initialize(newrow);
								
							//Gets attributes from parent folder to be inherited in child folder
							var arrattr = document.getElementById('node-' + arr_filedata.parent_folder_id).attributes, attributes = [];
							for(var i = 0; i < arrattr.length; i++) {
					  		if (arrattr[i].name.indexOf("node-") != -1) {
					  			//attributes.push(arrattr[i].name);
					  			newrow.Attributes.Add(arrattr[i].name, "1");
							  }
							}
					
							//Sets padding to new folder, adding 20px to padding of parent folder
							var padvalue = parseInt(($('td:first', $('#node-' + arr_filedata.parent_folder_id)).css("padding-left")).replace('px', '')) + 20;
					    $('td:first', $(newrow)).css({'padding-left' : padvalue.toString() + 'px'});
					
							$('#node-' + arr_filedata.parent_folder_id).removeClass('initialized');
							$('.example').initialize($('#node-' + arr_filedata.parent_folder_id));
											
			      	if (parseInt(parent_folder_id) == parseInt(docman_data.current.folder_id)) {
								docmanFolder.loadFolderFiles(docman_data.current.folder_id, null, null, null, true);								
							}

							//Makes sure to remove the no documents message
							docman.removeNoFilesMessage();

						  docmanFolder.loadFolderOrganizer();

							var params_dialog = {title : "Folder created", status : true, folder_id : arr_filedata.folder_id, folder_name : arr_filedata.folder_name, error_message : ''}
							var options = {width : 400, height : 200, position_top : 200, position_left : 130, prevent_auto_fade : false };
					  	docman.statusConfirm('folder-create-dialog-template-confirm', params_dialog , options);
					  	$( that ).dialog( "close" );
					  },
					  error: function(response) {
					  	var op_response = JSON.parse(response.responseText);
								if (op_response.error_code == 2) {
									$(obj_dialog).dialog("close");
								}
						
								var params_dialog = {title : "Folder not created", status : false, error_message : op_response.error_message, folder_name : ''}
							var options = {width : 400, height : 200, position_top : 200, position_left : 130, prevent_auto_fade : false, div_dialog : 'docman-modal-dialog3' };
					  	docman.statusConfirm('folder-create-dialog-template-confirm', params_dialog, options );
					  }
					 });
					  					

				},
				Cancel: function() {
					$( this ).dialog( "close" );
				}
			}
		});
		
		return false;
  };


	/**
	* Edits a folder
	* @param {Int} parent_folder_id    ID of the parent folder
	* @param {String} parent_folder_name    Name of the parent folder
	* @return {}    This method does not return anything
	*/   
  docmanFolder.editFolder = function(folder_id, folder_name) {
    var folder_id = folder_id.replace('node-folder-name', '');
  	folder_id = folder_id.replace('folder-', '');
  	var is_public = docman_data.folders[folder_id].is_public;

		var str_is_public = '<input type="checkbox" name="is_public" />';
		if (is_public) {
			str_is_public = '<input type="checkbox" name="is_public" checked />';
		} 

  	var tmpl = new EJS({element: 'folder-edit-dialog-template'}); 
  	$('#docman-modal-dialog').html(tmpl.render({folder_id : folder_id, folder_name : folder_name, is_public : str_is_public}));
		$('#docman-modal-dialog').attr('title', 'Edit Folder');

		$( "#docman-modal-dialog" ).dialog({
			resizable: false,
			height:'auto',
			width: 400,
			title: "Edit Folder",
			modal: true,
			buttons: {
				"Edit Folder": function() {
					var post_data = {};
					$.each($('#form-folder-edit-rendered').serializeArray(), function(i, field) {
    					post_data[field.name] = field.value;
					});

					if (post_data['is_public'] === undefined) {
						is_public = false;
					} else {
						is_public = true;
					}

					var _url = '<?php echo GFUrl::getUrl()->projectURL($project,'DocmanFolderEditAction','docman','admin', array()); ?>';

					/* Send the data using post  */
					$.ajax({
					  url: _url,
					  type: "GET",
					  data: post_data,
					  dataType: 'html',
					  success: function(json_string){
					  	var arr_folder = JSON.parse(json_string);

					  	$("#node-name"+folder_id).html(post_data.folder_name);
					  	$("#folder-"+folder_id).attr('fname', post_data.folder_name);

							docman_data.folders[folder_id].is_public = is_public;
							docman_data.folders[folder_id].folder_name = folder_name;

							try {
					  		$("#node-folder-name"+folder_id).html(post_data.folder_name);
					  		$("#folder-panel-"+folder_id).attr('fname', post_data.folder_name);
					  	} catch(err) {}

							var params_dialog = {title : "Folder edit confirmation", status : true, folder_id : folder_id, folder_name: post_data.folder_name};	
					  	docman.statusConfirm('folder-edit-dialog-template-confirm', params_dialog, {});
						  docmanFolder.loadFolderFiles(docman_data.current.folder_id, null, null, null, true);
					  },
					  error: function(response) {
					  	var arr_response = JSON.parse(response.responseText);

							var params_dialog = {title : "Folder edit confirmation", status : false, folder_id : folder_id, folder_name: folder_name};
					  	docman.statusConfirm('folder-edit-dialog-template-confirm', params_dialog, {});
					  }
					 });
					  
					
					$( this ).dialog( "close" );
				},
				Cancel: function() {
					$( this ).dialog( "close" );
				}
			}
		});
  };

	/**
	* Makes a folder a sibling of the current parent folder
	* @param {Int} parent_folder_id    ID of the parent folder
	* @param {Object} ui    JQuery object representing the moved (dragged) folder
	* @param {Boolean} is_main_table    True if dragging a folder on the main panel, False if dragging on the folders dialog
	* @return {}    This method does not return anything
	*/   
  docmanFolder.makeSibling = function(parent_folder_id, ui, is_main_table) {
		parent_folder_id = parent_folder_id.replace('node-folder-up', '');
		parent_folder_id = parent_folder_id.replace('node-folder', '');
		parent_folder_id = parent_folder_id.replace('node-', '');
		parent_folder_id = parent_folder_id.replace('folder', '');

		var _url = '<?php echo GFUrl::getUrl()->projectURL($project,'DocmanGetFolderPermission','docman','', array()); ?>&folder_id=' + parent_folder_id + '&type=parent';

		/* Send the data using post  */
		$.ajax({
		  url: _url,
		  type: "GET",
		  data: null,
		  dataType: 'html',
		  success: function(json_string){
		  	var arr_folder = JSON.parse(json_string);				  	
				var folder_perms = arr_folder.permission;

				if (folder_perms != 'w') {
					docmanFolder.showPermissionDenied(parent_folder_id, 'w');
					return;
				}

				//Get moved folder id
				var folder_id = $(ui.draggable)[0].id;
				folder_id = folder_id.replace('node-folder-up', '');
				folder_id = folder_id.replace('node-folder', '');
				folder_id = folder_id.replace('node-', '');
				
				//Get parent folder id  	
				parent_folder_id = parent_folder_id.replace('node-folder-up', '');
				parent_folder_id = parent_folder_id.replace('node-folder', '');
				parent_folder_id = parent_folder_id.replace('node-', '');
				parent_folder_id = parent_folder_id.replace('folder', '');
				
				//Get moved folder name
				var folder_name = $('#folder-' + folder_id).attr("fname");
				//Get Parent folder name
				var parent_folder_name = $('#folder-' + parent_folder_id).attr("fname");
				
		  	var tmpl = new EJS({element: 'folder-move-dialog-template'}); 
		  	$('#docman-modal-dialog').html(tmpl.render({folder_id : folder_id, parent_folder_id : parent_folder_id, parent_folder_name : parent_folder_name, folder_name : folder_name, make_sibling : true}));
				$('#docman-modal-dialog').attr('title', 'Move Folder');
		
				$( "#docman-modal-dialog" ).dialog({
					resizable: false,
					height:'auto',
					width: 400,
					title: "Move Folder",
					modal: true,
					buttons: {
						"Move Folder": function() {
							var post_data = {folder_id : folder_id, parent_folder_id : parent_folder_id};
							var _url = '<?php echo GFUrl::getUrl()->projectURL($project,'DocmanMakeSiblingAction','docman','admin', array()); ?>';

							var that = this;

							/* Send the data using post  */
							$.ajax({
							  url: _url,
							  type: "GET",
							  data: post_data,
							  dataType: 'html',
							  success: function(json_string){
							  	var arr_folder = JSON.parse(json_string);				  	
		
							  	if (is_main_table) {
							  		docmanFolder.loadFolderOrganizer();
							  	} else {
							  		$($(ui.draggable).parents("tr")[0]).appendBranchTo(move_object);
							  	}
							  	
							  	try {
								  	//Remove moved folder from main table
								  	$('#node-folder' + folder_id).remove();
								  	$('#node-folder-divider' + folder_id).remove();
							  	} catch(err) {
							  	}
		
							  	$( that ).dialog( "close" );
							  	
							  	var params_dialog = {title : "Folder move confirmation", status : true, folder_id : folder_id, folder_name: folder_name, parent_folder_name : parent_folder_name, make_sibling : true};
							  	docman.statusConfirm('folder-move-dialog-template-confirm', params_dialog, {});
							  },
							  error: function(response) {
							  	var arr_response = JSON.parse(response.responseText);
									$( that ).dialog( "close" );
									
									var params_dialog = {title : "Folder move confirmation", status : false, folder_id : folder_id, folder_name: folder_name, make_sibling : true};
							  	docman.statusConfirm('folder-move-dialog-template-confirm', params_dialog, {});
							  }
							 });
							  
							
						},
						Cancel: function() {
							$( this ).dialog( "close" );
						}
					}
				});

			
		  },
			error: function(response) {
			}
		});

		
  	

  };
  



  docmanFolder.moveFolder = function(parent_folder_id, ui, is_main_table) {
		//Get moved folder id
		var folder_id = $(ui.draggable)[0].id;
		folder_id = folder_id.replace('node-folder-up', '');
		folder_id = folder_id.replace('node-folder', '');
		folder_id = folder_id.replace('node-', '');
		folder_id = folder_id.replace('folder-', '');
		
		//Get parent folder id  	
		parent_folder_id = parent_folder_id.replace('node-folder-up', '');
		parent_folder_id = parent_folder_id.replace('node-folder', '');
		parent_folder_id = parent_folder_id.replace('node-', '');
		parent_folder_id = parent_folder_id.replace('folder', '');

		//If parent is root folder, set parent to 0
		if (docman_data.root.folder_id == parent_folder_id) {
			parent_folder_id = 0;
		}

		if (!docmanFolder.checkPermission(parent_folder_id, 'w')) {
			return;
		}

		//Get moved folder name
		var folder_name = $('#folder-' + folder_id).attr("fname");
		
		//Get Parent folder name
		if (parent_folder_id == incoming_folder) {
			var parent_folder_name = 'Home';
		} else {
			var parent_folder_name = $('#folder-' + parent_folder_id).attr("fname");
		}

  	var tmpl = new EJS({element: 'folder-move-dialog-template'}); 
  	$('#docman-modal-dialog').html(tmpl.render({folder_id : folder_id, folder_name : folder_name, parent_folder_id : parent_folder_id, parent_folder_name : parent_folder_name, make_sibling : false}));
		$('#docman-modal-dialog').attr('title', 'Move Folder');

		$( "#docman-modal-dialog" ).dialog({
			resizable: false,
			height:'auto',
			width: 400,
			title: "Move Folder",
			modal: true,
			buttons: {
				"Move Folder": function() {
					var post_data = {folder_id : folder_id, parent_folder_id : parent_folder_id};
					var _url = '<?php echo GFUrl::getUrl()->projectURL($project,'DocmanFolderMoveAction','docman','admin', array()); ?>';

					var that = this;

					/* Send the data using post  */
					$.ajax({
					  url: _url,
					  type: "GET",
					  data: post_data,
					  dataType: 'html',
					  success: function(json_string){
					  	var arr_folder = JSON.parse(json_string);				  	

				  		docmanFolder.loadFolderOrganizer();

					  	$( that ).dialog( "close" );
					  	try {
					  		var params_dialog = {title : "Folder move confirmation", status : true, folder_id : folder_id, folder_name: arr_folder.folder_name, parent_folder_name : parent_folder_name, make_sibling : false};
					  		docman.statusConfirm('folder-move-dialog-template-confirm', params_dialog, {});
					  	} catch(err) {
					  	}


						if (docman_data.current.folder_id !== undefined) {
							docmanFolder.loadFolderFiles(docman_data.current.folder_id, null, null, null, true);
						}

					  },
					  error: function(response) {
					  	var arr_response = JSON.parse(response.responseText);
							$( that ).dialog( "close" );
							
							var params_dialog = {title : "Folder move confirmation", status : false, folder_id : folder_id, folder_name: folder_name, parent_folder_name : parent_folder_name, make_sibling : false};
					  	docman.statusConfirm('folder-move-dialog-template-confirm', params_dialog, {});
					  }
					 });
					  
					
					
				},
				Cancel: function() {
					$( this ).dialog( "close" );
				}
			}
		});
  };
  
  
  
  
	docmanFolder.assignFileToFolder = function(folder_id, file_id) {
		if ($('#folder-assign-' + folder_id).attr("is_checked") == "checked") {			
			var _url = '<?php echo GFUrl::getUrl()->projectURL($project,'DocmanFileFolderSetAction','docman','', array()); ?>&folder_id=' + folder_id + '&file_id=' + file_id + '&operation=remove';

			/* Send the data using post  */
			$.ajax({
			  url: _url,
			  type: "GET",
			  data: null,
			  dataType: 'html',
			  success: function(json_string){
			  	//var arr_folder = JSON.parse(json_string);				  	
					$('#folder-assign-' + folder_id).css('color', '#A3A3A3');
					$('#img-folder-assign-' + folder_id).attr('src', '/themes/gforge5/images/checkbox_unchecked.png');
					$('#folder-assign-' + folder_id).attr("is_checked", "");		
					
					//if assigning to current folder, refresh panel
					if (docman_data.current.folder_id == folder_id) {
						docmanFolder.loadFolderFiles(folder_id, null, null, null, true);
					}
			  },
			  error: function(response) {
			  	var arr_response = JSON.parse(response.responseText);
			  				  	
					var params_dialog = {title : "Remove Document from Folder", message : arr_response.error_message};
					var options = {width : 400, height : 200, prevent_auto_fade : true, div_dialog : 'docman-modal-dialog2' };
					docman.statusConfirm('generic-confirm-template', params_dialog, options);
			  }
			});
			
		} else {
			var _url = '<?php echo GFUrl::getUrl()->projectURL($project,'DocmanFileFolderSetAction','docman','', array()); ?>&folder_id=' + folder_id + '&file_id=' + file_id + '&operation=add';

			/* Send the data using post  */
			$.ajax({
			  url: _url,
			  type: "GET",
			  data: null,
			  dataType: 'html',
			  success: function(json_string){
			  	//var arr_folder = JSON.parse(json_string);				  	
					$('#folder-assign-' + folder_id).css('color', '#1C1C1C');
					$('#img-folder-assign-' + folder_id).attr('src', '/themes/gforge5/images/checkbox_checked.png');
					$('#folder-assign-' + folder_id).attr("is_checked", "checked");
					
					//if assigning to current folder, refresh panel
					if (docman_data.current.folder_id == folder_id) {
						docmanFolder.loadFolderFiles(folder_id, null, null, null, true);
					}
			  },
			  error: function(response) {
			  	var arr_response = JSON.parse(response.responseText);
			  	
					var params_dialog = {title : "Assign Document to Folder", message : arr_response.error_message};
					var options = {width : 400, height : 200, prevent_auto_fade : true, div_dialog : 'docman-modal-dialog2' };
					docman.statusConfirm('generic-confirm-template', params_dialog, options);
			  }
			});
			
		}
		

	};

  
	docmanFolder.setFolder = function(folder_id, file_id, origin_folder_id) {
		if ($('#folder-assign-' + folder_id).attr("checked") == "checked") {
			//get this file's row
						
		} else {
		}
	};
	
	
	docmanFolder.goUp = function(folder_id) {
		//folder_stack.pop();

		//docmanFolder.renderBreadcrumbs();
		
		//var folder_id = (folder_stack.pop()).folder_id;
		var folder_id = '';
		if (folder_stack.length >= 2) {
			//folder_id = folder_stack[folder_stack.length-2].folder_id;
			folder_stack.pop();
			
			//docmanFolder.renderBreadcrumbs();
			
			folder_id = folder_stack[folder_stack.length-1].folder_id;
			//folder_id = (folder_stack.pop()).folder_id;
			docmanFolder.loadFolderFiles(folder_id, null, null, 'up', true);
		}

	}
	
	docmanFolder.jumpToFolderFromBreadcrumb = function(folder_id) {
		var folder_obj = null;
		while (folder_stack.length > 0) {
			folder_obj = folder_stack.pop();
			if (folder_obj.folder_id === folder_id) {
				break;
			}
		}

		if (folder_obj == null) {
			folder_stack = new Array();			
			docmanFolder.loadFolderFiles(folder_id);	
		} else {
			docmanFolder.loadFolderFiles(folder_obj);	
		}
		
		return false;
	};


	docmanFolder.jumpToFolderDirect = function(folder_id) {
		docmanFolder.loadFolderFiles(folder_obj);
	};
	
	
	docmanFolder.loadBreadcrumbsFromUrl = function(breadcrumb_data) {
		folder_stack = new Array();

		folder_stack.push({folder_id : incoming_folder, folder_name : 'home', folder_perm : 'r'});

		for (var i=0; i < breadcrumb_data.path_info.length; i++) {
			folder_stack.push({folder_id : breadcrumb_data.path_info[i].docman_folder_id, folder_name : breadcrumb_data.path_info[i].folder_name, folder_perm : 'r'});
		}
		docman_data.current.folder_id = folder_stack[folder_stack.length-1].folder_id
		docmanFolder.loadFolderFiles(docman_data.current.folder_id, null, null, null, true);
	}
	
	docmanFolder.renderBreadcrumbs = function() {
		
		var str_path = '<?php echo GFUrl::getUrl()->projectURL($project,'','docman','', array()); ?>';
		var rendered_breadcrumbs = new EJS({url: '/docman_breadcrumbs.ejs'}).render({breadcrumbs : folder_stack, str_path : str_path});
		$('#folder_breadcrumbs').html(rendered_breadcrumbs);
		
		//renders URI with the new breadcrumbs
		docmanFolder.renderUri();
	};
	
	
	docmanFolder.renderUri = function() {
		//Create string for folder paths
		var str_folders = '';

		for(var i=0; i < folder_stack.length; i++) {
			if (incoming_folder != folder_stack[i].folder_id) {
				str_folders += folder_stack[i].folder_name + '/';
			}
		}
	
		var state_data = {folder_stack : folder_stack};
		History.pushState(state_data, document.title, base_docman_uri + str_folders);
	};
	
	
	
	docmanFolder.loadFolderFiles = function(folder_obj, callback, callback_params, direction, prevent_push_stack) {
		show_file_id = 0;

		docman_mode = 'navigate';

		//Enables drad and drop
		//Disables temporarily drag and drop
		$('#fileupload').fileupload({dropZone : $(document)});
	
		if (prevent_push_stack === undefined) {
			prevent_push_stack = false;
		}
	
		var folder_id = 0;
		var folder_name = '';
	
		if (folder_obj === undefined || folder_obj == null) {
			return;
		}

		if (folder_obj.folder_id != undefined) {
			folder_id = folder_obj.folder_id;
			folder_name = folder_obj.folder_name;
		} else {
			folder_id = folder_obj;
			
			//Get folder name
			if (folder_id != incoming_folder) {
				folder_name = $('#node-folder' + folder_id).attr('fname');
			} else {
				folder_name = 'home';
			}
		}

		if (direction != 'up') {
			if ((docmanFolder.userCanRead(folder_id) == false) && (folder_id != incoming_folder)) {
				return false;
			}
		}

		//Sets current folder as parent folder
		var parent_folder_id = docman_data.current.folder_id;
		
		//Get current folder name
		if (docman_data.current.folder_id != incoming_folder) {
			var current_folder_name = $('#node-folder' + docman_data.current.folder_id).attr('fname');
		} else {
			var current_folder_name = 'home';
		}
		
		//Prevent double clicking and reloading the same folder
		if (docman_data.working) {
			return;
		}
		
		docman_data.working = true;
		
		/*
		if (docman_data.current.folder_id == folder_id && folder_id != incoming_folder) {
			return;
		}
		*/
		
		//Updates current folder
		docman_data.current.folder_id = folder_id;
		
		/*
		if (docmanFolder.userCanWrite(folder_id)) {
			docman_data.current.permission = 'w';
		} else {
			docman_data.current.permission = 'r';
		}
		*/
		if (folder_id > 0) {
			var _url = '<?php echo GFUrl::getUrl()->projectURL($project,'DocmanGetFolderPermission','docman','', array()); ?>&folder_id=' + folder_id;
			/* Send the data using post  */
			$.ajax({
			  url: _url,
			  type: "GET",
			  data: null,
			  dataType: 'html',
			  success: function(json_string){
			    var arr_folder = JSON.parse(json_string);
					docman_data.current.permission = arr_folder.permission;
					docman_data.current.is_public = arr_folder.is_public;
				docmanFolder.loadFolderFilesCallback(folder_id, folder_name, current_folder_name, prevent_push_stack, direction, callback);
			  },
				error: function(response) {
					spinner = null;
					docmanFolder.showAccessError(folder_id, folder_name);
					docmanFolder.loadFolderFiles(docman_data.root);
					return;
				}
			});
		}

		return false;
	};


	docmanFolder.loadFolderFilesCallback = function(folder_id, folder_name, current_folder_name, prevent_push_stack, direction, callback) {
		$('#upload_folder_id').attr('value', folder_id);
		var spinner = new Spinner(spinner_opts).spin(spinner_target);
		var _url = '<?php echo GFUrl::getUrl()->projectURL($project,'DocmanGetFolderContentsAction','docman','', array()); ?>&folder_id=' + folder_id;

		$.ajax({
			url: _url,
			type: "GET",
			data: null,
			dataType: 'html',

			success: function(response) {
				docman_data.working = false;
				var folder_file_data = JSON.parse(response);

				var show_pending_queue = false;
				if (folder_id == incoming_folder) {
					show_pending_queue = true;
				}

				var show_pending_queue_files = false;
				if (folder_id == -1) {
					show_pending_queue_files = true;
				}

				var folder_data = { data : folder_file_data, parent_folder : folder_id, current_folder_id : docman_data.current.folder_id, current_folder_name : current_folder_name, show_pending_queue : show_pending_queue, show_pending_queue_files : show_pending_queue_files, search_results_mode : false};

				docmanFolder.parseFolderFilesData(folder_file_data);

				if (!prevent_push_stack) {
					folder_stack.push({folder_id : folder_id, folder_name : folder_name, folder_perm : docmanFolder.getFolderPermission(folder_id)});
				}

				if (direction === undefined) {
					direction = 'down';
				}

				//if (direction != 'up') {
				docmanFolder.renderBreadcrumbs();
				//}

				//Sets the global variable docman_data.current.folder_id
				//docman_data.current.folder_id = folder_id;

				//Render the widget template
				var rendered_table = new EJS({url: '/docman_contents.ejs'}).render(folder_data);

				$("#docman_files").html(rendered_table);
				createFileMenu();

				if (docman_data.current.folder_id != -1) {
					docman.activateTreeRows();
				}
				spinner = null;

				docman.activateTablesorter();

				//Activates inline document open
				//$(".iframe").colorbox({iframe:true, width:"80%", height:"80%"});
				//$(".image").colorbox({rel:'image', scalePhotos: false,  width:"80%", height:"80%"});


				//If there's a callback function, call it
				if (callback != undefined) {
					callback(callback_params);
				}

			},
			error: function(html){
				docman_data.working = false;
				spinner = null;
			}
		});
	};


	docmanFolder.loadSearchResult = function(words, search_contents_only) {
		docman_mode = 'search';
		
		$('#upload_folder_id').attr('value', incoming_folder);
		var spinner = new Spinner(spinner_opts).spin(spinner_target);				
    var _url = '<?php echo GFUrl::getUrl()->projectURL($project,'DocmanRenderFolderFilesAction','docman','', array()); ?>&words=' + words + '&search_contents_only=' + search_contents_only;

		$.ajax({
			  url: _url,
			  type: "GET",
			  data: null,
			  dataType: 'html',
				
			  success: function(response){
			  	var folder_file_data = JSON.parse(response);

					docmanFolder.parseFolderFilesData(folder_file_data);

			  	try {
						var rendered_table = new EJS({url: '/docman_contents_search.ejs'}).render({ data : folder_file_data, parent_folder : 0, show_pending_queue_files : false, search_results_mode : true});
					}
					catch(err) { alert(err); }
			  	
			  	$("#docman_files").html(rendered_table);
					createFileMenu();
					spinner = null;
					
					docman.activateTablesorter();
			  },
			  error: function(html){
			  	spinner = null;
			  }
			});	
	};



	docmanFolder.loadFolderOrganizer = function() {
		
    var _url = '<?php echo GFUrl::getUrl()->projectURL($project,'DocmanGetFolderOrganizerAction','docman','', array()); ?>';

		$.ajax({
			  url: _url,
			  type: "GET",
			  data: null,
			  dataType: 'html',
				
			  success: function(response){
			  	$("#organize_folders_inner").html(response);
					
					createFolderMenu();

					docman.activateTreeRows();
					
			    $(".cls_docman_folder_table").treeTable({
			      initialState: "expanded"
			    }); 
			  },
			  error: function(html){
			  }
			});	
	};


	docmanFolder.userCanUpdate = function(folder_id) {
		if (docman_wide_perms) {
			return true;
		}
		if (docman_data.current.folder_id == folder_id) {
			var perm = docman_data.current.permission;
		} else {
			if (docman_data.root.folder_id == folder_id) {
				var perm = docman_data.root.permission;
			} else {
				var perm = docman_data.folders[folder_id].permission;
			}
		}
		if (perm == 'u') {
			return true;
		} else {
			return false;
		}
	};


	docmanFolder.userCanWrite = function(folder_id) {
		if (docman_wide_perms) {
			return true;
		}
		var is_public = false;
		if (docman_data.current.folder_id == folder_id) {
			var perm = docman_data.current.permission;
			is_public = docman_data.current.is_public;
		} else {
			if (docman_data.root.folder_id == folder_id) {
				var perm = docman_data.root.permission;
				is_public = docman_data.root.is_public;
			} else {
				var perm = docman_data.folders[folder_id].permission;
				is_public = docman_data.folders[folder_id].is_public;
			}
		}
		if ((perm == 'w' || perm == 'u') && user_is_logged_in) {
			return true;
		} else {
			return false;
		}
	};


	docmanFolder.userCanRead = function(folder_id) {
		if (docman_wide_perms) {
			return true;
		}
		if (docman_data.current.folder_id == folder_id) {
			var perm = docman_data.current.permission;
		} else {
			if (docman_data.root.folder_id == folder_id) {
				var perm = docman_data.root.permission;
			} else {
				var perm = docman_data.folders[folder_id].permission;
			}
		}
		if (perm == 'r' || perm == 'w' || perm == 'u') {
			return true;
		} else {
			return false;
		}
	};


	docmanFolder.getFolderPermission = function(folder_id) {
		return $('#node-folder' + folder_id).attr('permission');
	}


	docmanFolder.checkPermission = function(folder_id, perm_type) {
		if (docman_wide_perms) {
			return true;
		}

		switch (perm_type) {
			case 'u':
				var res = docmanFolder.userCanUpdate(folder_id);
				if (!res) {
					docmanFolder.showPermissionDenied(folder_id, perm_type);
					return false;
				} else {
					return true;
				}
			break;			
			
			case 'w':
				var res = docmanFolder.userCanWrite(folder_id);
				if (!res) {
					docmanFolder.showPermissionDenied(folder_id, perm_type);
					return false;
				} else {
					return true;
				}
			break;
			
			case 'r':
				var res = docmanFolder.userCanRead(folder_id);
				if (!res) {
					docmanFolder.showPermissionDenied(folder_id, perm_type);
					return false;
				} else {
					return true;
				}
			break;
		}
	};
	
	
	docmanFolder.showPermissionDenied = function(folder_id, perm_type) {
		perm_description = '';
		switch(perm_type) {
			case 'r':
				perm_description = 'read';
			break;
			
			case 'w':
				perm_description = 'write';
			break;
		}

  	var tmpl = new EJS({element: 'folder-permission-dialog-template'});
  	$('#docman-modal-dialog').html(tmpl.render({perm_description : perm_description}));
		$( "#docman-modal-dialog" ).dialog({
				resizable: false,
				height:'auto',
				width: 400,
				title: "Permission denied",
				modal: true,
				buttons: {
					close: function() {
						$( this ).dialog( "close" );
					}
				}
			});
	};



	docmanFolder.showAccessError = function(folder_id, folder_name) {
		var tmpl = new EJS({element: 'folder-access-error-dialog-template'});
		$('#docman-modal-dialog').html(tmpl.render({folder_name : folder_name}));
		$( "#docman-modal-dialog" ).dialog({
			resizable: false,
			height:'auto',
			width: 400,
			title: "Folder access error",
			modal: true,
			buttons: {
				close: function() {
					$( this ).dialog( "close" );
				}
			}
		});
	};

</script>
