<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code shows a form for Forum
//
require_once('plugins/forum/lib/ForumPeer.php');
require_once('plugins/forum/lib/Forum.php');
require_once('plugins/forum/lib/html/ForumAdminTemplate.php');
require_once('plugins/forum/lib/html/ForumAdminFormRenderer.php');

$theme = new ForumAdminTemplate();
$project = GFUrl::getUrl()->getProject();
$Lang = Session::getSession()->getLanguage();

$renderer = new ForumAdminFormRenderer('project', $project->getProjectId(), $theme, $Lang);
$form = $renderer->addNewForumForm(GFUrl::getUrl()->currentBaseUrl('ForumBrowse'));
if ($renderer->hasErrors()) {
	$errors = $renderer->getErrors();
	$feedback = '* '.implode('<br />* ', $errors);
}

$params = array(
		'project' => $project,
		'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : ''),
		'action' => isset($action) ? $action : '',
		'title' => $Lang->getText('Forum.EditPageTitle')
		);

echo $theme->header($params);
echo $form;
echo $theme->footer($params);

?>