<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code shows a form for editing Forum
//
require_once('plugins/forum/lib/ForumPeer.php');
require_once('plugins/forum/lib/Forum.php');
require_once('exceptions/PermissionDeniedException.php');
require_once('plugins/forum/lib/html/ForumAdminTemplate.php');
require_once('plugins/forum/lib/html/ForumAdminFormRenderer.php');
require_once('Validator.php');

$theme = new ForumAdminTemplate();
$project = GFUrl::getUrl()->getProject();
$Lang = Session::getSession()->getLanguage();

$forum_id = Validator::sanitizeInt($_GET['id']);
$Forum = ForumPeer::retrieveByPk($forum_id);
if (!$forum_id) {
	$feedback = $Lang->getText('ForumEdit.InvalidForumID');
	$form = '';
} else {
	$renderer = new ForumAdminFormRenderer('project', $project->getProjectId(), $theme, $Lang);
	$form = $renderer->deleteForumForm($forum_id, GFUrl::getUrl()->currentBaseUrl(''));
	if ($renderer->hasErrors()) {
		$errors = $renderer->getErrors();
		$feedback = '* '.implode('<br />* ', $errors);
	}
}

$params = array(
		'project'	=> $project,
		'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : ''),
		'action' => isset($action) ? $action : '',
		'title' => $Lang->getText('Forum.EditPageTitle'),
		'selectedbottomtab'	=> 'forum',
		);

echo $theme->header($params);
echo $form;
echo $theme->footer($params);
?>
