<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code edits a FrsPackage and saves it to the 
// database
//
require_once('plugins/frs/lib/FrsPackage.php');
require_once('Validator.php');
require_once('exceptions/PermissionDeniedException.php');
require_once('core/Language.php');

if ($_SERVER['REQUEST_METHOD'] != 'POST') {
	throw new PermissionDeniedException();
}

$Project = GFUrl::getURL()->getProject();
$FrsPackage = FrsPackagePeer::retrieveByPk($_REQUEST['frs_package_id']);
if (!is_object($FrsPackage) || $FrsPackage->getProject()->getProjectId() != $Project->getProjectId()) {
	throw new PermissionDeniedException();
}
if (!$FrsPackage->userCanUpdate()) {
	throw new PermissionDeniedException();
}

$errors = array();
$Lang = Language::getSessLang();

//
// TODO Validate the values passed by $_POST. Store the errors in $error like
// $errors["field_name"] = error_description
//

if (count($errors) == 0) {
	
	try {
		//names are sanitized internally
		$FrsPackage->setPackageName( $_POST['package_name'] );
		$FrsPackage->setStatusId( (isset($_POST['status_id']) ? FrsPackage::STATUS_ACTIVE : FrsPackage::STATUS_HIDDEN ) );
		$FrsPackage->setIsPublic( (isset($_POST['is_public']) ? 1 : 0 ) );
		$FrsPackage->setRequireLogin( (isset($_POST['require_login']) ? 1 : 0 ) );
		$FrsPackage->save();
		$url = GFUrl::getUrl();
		GFUrl::redirect($url->currentBaseURL('FrsPackageEdit'), array('frs_package_id'=>$FrsPackage->getFrsPackageId(),'feedback' => $Lang->getText('FrsPackage.EditFeedback')));
	} catch (InvalidDataException $ex) {
		$errors = array_merge($errors, $ex->getErrors());
		$feedback = '* '.implode('<br />* ', $errors);
		include('FrsPackageEdit.php');
	}

} else {
	$feedback = implode('<br />', $errors);
	include('FrsPackageEdit.php');
}

?>
