<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code lists FrsRelease
//
require_once('plugins/frs/lib/FrsReleasePeer.php');
require_once('plugins/frs/lib/FrsRelease.php');
require_once('lib/exceptions/PermissionDeniedException.php');

$session = Session::getSession();
$Lang = $session->getLanguage();

require_once('plugins/frs/lib/html/FrsAdminTemplate.php');
$theme = new FrsAdminTemplate();

$Project = GFUrl::getUrl()->getProject();
$FrsPackage = FrsPackagePeer::retrieveByPK($_REQUEST['frs_package_id']);
if (!is_object($FrsPackage) || $FrsPackage->getProject()->getProjectId() != $Project->getProjectId()) {
	throw new PermissionDeniedException();
}

$params = array(
		'project' => $Project,
		'action' => isset($action) ? $action : '',
		'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : ''),
		'title' => $Lang->getText('FrsRelease.BrowsePageTitle'),
		'frspackage' => $FrsPackage
		);
$theme->header($params);


// Retrieve the objects array
$crit = new Criteria();
$crit->add(FrsReleasePeer::FRS_PACKAGE_ID, $FrsPackage->getFrsPackageId());
$crit->add(FrsReleasePeer::FRS_PACKAGE_ID, $FrsPackage->getFrsPackageId());
$crit->addDescendingOrderByColumn(FrsReleasePeer::FRS_RELEASE_ID);
$arr = FrsReleasePeer::doSelect($crit);


$theader = array();

$theader[] = $Lang->getText('FrsRelease.ReleaseNameName');
$theader[] = $Lang->getText('FrsRelease.StatusIdName');
$theader[] = $Lang->getText('FrsRelease.ReleaseDateName');
//$theader[] = $Lang->getText('FrsRelease.ReleasedByName');
$theader[] = $Lang->getText('Edit');
$theader[] = $Lang->getText('Delete');

echo $theme->tableTop($theader);

if (count($arr) < 1) {
	echo $theme->tableFullRow($Lang->getText('FrsRelease.NoneFound'));
} else {
	foreach ($arr as $item) {
		$trow = array();
//		$trow[]=$item->getFrsReleaseId();
//		$trow[]=$item->getFrsPackageId();
		$trow[]=$item->getReleaseName();
//		$trow[]=$item->getReleaseNotes();
//		$trow[]=$item->getChanges();
		$trow[]=($item->getStatusId() == FrsRelease::STATUS_HIDDEN) ? $Lang->getText('FrsRelease.Hidden') : '';
//		$trow[]=$item->getPreformatted();
                $date = $item->getReleaseDate("Y-m-d");
		$trow[]=$date;
//		$trow[]=$item->getReleasedBy();
		$trow[]='<a href="'. GFUrl::getUrl()->currentBaseUrl('FrsReleaseEdit').'&amp;frs_release_id='.$item->getFrsReleaseId() .'">'. $Lang->getText('Edit') .'</a>';
		$trow[]='<a href="'. GFUrl::getUrl()->currentBaseUrl('FrsReleaseDelete').'&amp;frs_release_id='.$item->getFrsReleaseId() .'">'. $Lang->getText('Delete') .'</a>';

		echo $theme->tableRow($trow);
	}
}

echo $theme->tableBottom(array('<a href="'. GFUrl::getUrl()->currentBaseUrl('FrsReleaseAdd').'&amp;frs_package_id='.$FrsPackage->getFrsPackageId() .'">'. $Lang->getText('FrsRelease.AddNew') .'</a>'));

$theme->footer($params);

?>
