<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code lists FrsPackage
//
require_once('plugins/frs/lib/FrsPackagePeer.php');
require_once('plugins/frs/lib/FrsPackage.php');

$session = Session::getSession();
$Lang = $session->getLanguage();

require_once('plugins/frs/lib/html/FrsAdminTemplate.php');
$theme = new FrsAdminTemplate();

$Project = GFUrl::getUrl()->getProject();

$params = array(
		'project' => $Project,
		'action' => isset($action) ? $action : '',
		'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : ''),
		'title' => $Lang->getText('FrsPackage.BrowsePageTitle')
		);
$theme->header($params);


// Retrieve the objects array
$crit = new Criteria();
$crit->add(FrsPackagePeer::PROJECT_ID, $Project->getProjectId());
$crit->addDescendingOrderByColumn(FrsPackagePeer::FRS_PACKAGE_ID);
$arr = FrsPackagePeer::doSelect($crit);


$theader = array();

$theader[] = $Lang->getText('FrsPackage.PackageNameName');
//$theader[] = $Lang->getText('FrsPackage.StatusIdName');
$theader[] = $Lang->getText('Edit');
$theader[] = $Lang->getText('FrsPackage.EditReleases');
$theader[] = $Lang->getText('Delete');

echo $theme->tableTop($theader);

if (count($arr) < 1) {
	 echo $theme->tableFullRow('<span class="nonefound">'.$Lang->getText('FrsPackage.NoneFound').'</span>');
} else {
	foreach ($arr as $item) {
		$trow = array();
//		$trow[]=$item->getFrsPackageId();
//		$trow[]=$item->getProjectId();
		$trow[]=$item->getPackageName();
//		$trow[]=$item->getStatusId();
//		$trow[]=$item->getIsPublic();
//		$trow[]=$item->getRequireLogin();
		$trow[]='<a href="'. GFUrl::getUrl()->currentBaseUrl('FrsPackageEdit').'&amp;frs_package_id='.$item->getFrsPackageID() .'">'. $Lang->getText('Edit') .'</a>';
		$trow[]='<a href="'. GFUrl::getUrl()->currentBaseUrl('FrsReleaseBrowse').'&amp;frs_package_id='.$item->getFrsPackageID() .'">'. $Lang->getText('FrsPackage.EditReleases') .'</a>';
		$trow[]='<a href="'. GFUrl::getUrl()->currentBaseUrl('FrsPackageDelete').'&amp;frs_package_id='.$item->getFrsPackageID() .'">'. $Lang->getText('Delete') .'</a>';

		echo $theme->tableRow($trow);
	}
}

echo $theme->tableBottom(array('<a href="'. GFUrl::getUrl()->currentBaseUrl('FrsPackageAdd').'">'. $Lang->getText('FrsPackage.AddNew') .'</a>'));

$theme->footer($params);
?>
