<?php 

require_once 'propel/om/BaseObject.php';

 
require_once 'propel/om/Persistent.php';

 

include_once 'propel/util/Criteria.php';
 

// (on-demand) include_once 'core/Project.php';
// (on-demand) include_once 'core/ProjectPeer.php';
 

// (on-demand) include_once 'core/User.php';
// (on-demand) include_once 'core/UserPeer.php';

include_once 'plugins/mailman/lib/MailmanPeer.php';

/**
 * Base class that represents a row from the 'mailman' table.
 *
 *  
 *
 * You should not use this class directly.  It should not even be
 * extended; all references should be to Mailman class. 
 * 
 * @package plugins.mailman.lib 
 */
abstract class BaseMailman extends BaseObject implements Persistent {
	
	/** 
	 * The Peer class.
	 * Instance provides a convenient way of calling static methods on a class
	 * that calling code may not be able to identify.
	 * @var MailmanPeer
	 */
	protected static $peer;

	/**
	 * The value for the mailman_id field.
	 * @var int	  
	 */
	protected $mailman_id;	

	/**
	 * The value for the project_id field.
	 * @var int	  
	 */
	protected $project_id;	

	/**
	 * The value for the list_name field.
	 * @var string	  
	 */
	protected $list_name;	

	/**
	 * The value for the is_public field.
	 * @var boolean	  
	 */
	protected $is_public = true;	

	/**
	 * The value for the list_password field.
	 * @var string	  
	 */
	protected $list_password;	

	/**
	 * The value for the created_by field.
	 * @var int	  
	 */
	protected $created_by;	

	/**
	 * The value for the status field.
	 * @var int	  
	 */
	protected $status = 1;	

	/**
	 * The value for the list_description field.
	 * @var string	  
	 */
	protected $list_description;	

	/**
	 * The value for the create_date field.
	 * @var int	  
	 */
	protected $create_date = -1;	

	/**
	 * The value for the bytes_used field.
	 * @var int	  
	 */
	protected $bytes_used;	
  
	/**
	 * Get the MailmanId column value.
	 *  
	 * @return int	  
	 */
	public function getMailmanId()
	{
		return $this->mailman_id;
	}


	/**
	 * Set the value of `mailman_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 *  
	 */
	public function setMailmanId($v)
	{
		if ($this->mailman_id !== $v) {
			$this->mailman_id = $v;
			$this->modifiedColumns[] = MailmanPeer::MAILMAN_ID;
		}
				
	}

  
	/**
	 * Get the ProjectId column value.
	 *  
	 * @return int	  
	 */
	public function getProjectId()
	{
		return $this->project_id;
	}


	/**
	 * Set the value of `project_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setProjectId($v)
	{
		if ($this->project_id !== $v) {
			$this->project_id = $v;
			$this->modifiedColumns[] = MailmanPeer::PROJECT_ID;
		}
			
		if ($this->aProject !== null && $this->aProject->getProjectId() !== $v) {
			$this->aProject = null;
		}
			
	}

  
	/**
	 * Get the ListName column value.
	 *  
	 * @return string	  
	 */
	public function getListName()
	{
		return $this->list_name;
	}


	/**
	 * Set the value of `list_name` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setListName($v)
	{
		if ($this->list_name !== $v) {
			$this->list_name = $v;
			$this->modifiedColumns[] = MailmanPeer::LIST_NAME;
		}
				
	}

  
	/**
	 * Get the IsPublic column value.
	 *  
	 * @return boolean	  
	 */
	public function getIsPublic()
	{
		return $this->is_public;
	}


	/**
	 * Set the value of `is_public` column.	  
	 *  
	 * @param boolean $v new value
	 * @return void
	 *  
	 */
	public function setIsPublic($v)
	{
		if ($this->is_public !== $v || $v === true) {
			$this->is_public = $v;
			$this->modifiedColumns[] = MailmanPeer::IS_PUBLIC;
		}
				
	}

  
	/**
	 * Get the ListPassword column value.
	 *  
	 * @return string	  
	 */
	public function getListPassword()
	{
		return $this->list_password;
	}


	/**
	 * Set the value of `list_password` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setListPassword($v)
	{
		if ($this->list_password !== $v) {
			$this->list_password = $v;
			$this->modifiedColumns[] = MailmanPeer::LIST_PASSWORD;
		}
				
	}

  
	/**
	 * Get the CreatedBy column value.
	 *  
	 * @return int	  
	 */
	public function getCreatedBy()
	{
		return $this->created_by;
	}


	/**
	 * Set the value of `created_by` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setCreatedBy($v)
	{
		if ($this->created_by !== $v) {
			$this->created_by = $v;
			$this->modifiedColumns[] = MailmanPeer::CREATED_BY;
		}
			
		if ($this->aUser !== null && $this->aUser->getUserId() !== $v) {
			$this->aUser = null;
		}
			
	}

  
	/**
	 * Get the Status column value.
	 *  
	 * @return int	  
	 */
	public function getStatus()
	{
		return $this->status;
	}


	/**
	 * Set the value of `status` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 *  
	 */
	public function setStatus($v)
	{
		if ($this->status !== $v || $v === 1) {
			$this->status = $v;
			$this->modifiedColumns[] = MailmanPeer::STATUS;
		}
				
	}

  
	/**
	 * Get the ListDescription column value.
	 *  
	 * @return string	  
	 */
	public function getListDescription()
	{
		return $this->list_description;
	}


	/**
	 * Set the value of `list_description` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setListDescription($v)
	{
		if ($this->list_description !== $v) {
			$this->list_description = $v;
			$this->modifiedColumns[] = MailmanPeer::LIST_DESCRIPTION;
		}
				
	}


	/**
	 * Get the [optionally formatted] `create_date` column value.
	 *  
	 * @param string $format The date/time format string (either date()-style or strftime()-style).
	 *							If format is NULL, then the integer unix timestamp will be returned.
	 * @return mixed Formatted date/time value as string or integer unix timestamp (if format is NULL).
	 * @throws PropelException - if unable to convert the date/time to timestamp.
	 */
	public function getCreateDate($format = 'Y-m-d H:i:s')
	{
		if ($this->create_date === null || $this->create_date === '') {
			return null;
		} elseif (!is_int($this->create_date)) {
			// a non-timestamp value was set externally, so we convert it
			$ts = strtotime($this->create_date);
			if ($ts === -1) {
				throw new PropelException("Unable to parse value of create_date as date/time value: " . var_export($this->create_date, true));
			}
		} else {
			$ts = $this->create_date;
		}
		if ($format === null) {
			return $ts;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $ts);
		} else {
			return date($format, $ts);
		}
	}


	/**
	 * Set the value of `create_date` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException - If passed [not-null] date/time is in an invalid format. 
	 */
	public function setCreateDate($v)
	{
		if ($v !== null && !is_int($v)) {
			$ts = strtotime($v);
			if ($ts === -1) {
				throw new PropelException("Unable to parse date/time value for create_date from input: " . var_export($v, true));
			}
		} else {
			$ts = $v;
		}
		if ($this->create_date !== $ts || $ts === -1) {
			$this->create_date = $ts;
			$this->modifiedColumns[] = MailmanPeer::CREATE_DATE;
		}
		
	}

  
	/**
	 * Get the BytesUsed column value.
	 *  
	 * @return int	  
	 */
	public function getBytesUsed()
	{
		return $this->bytes_used;
	}


	/**
	 * Set the value of `bytes_used` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 *  
	 */
	public function setBytesUsed($v)
	{
		if ($this->bytes_used !== $v) {
			$this->bytes_used = $v;
			$this->modifiedColumns[] = MailmanPeer::BYTES_USED;
		}
				
	}


	
	/**
	 * Hydrates (populates) the object variables with values from the database resultset.
	 *
	 * An offset (1-based "start column") is specified so that objects can be hydrated
	 * with a subset of the columns in the resultset rows.  This is needed, for example,
	 * for results of JOIN queries where the resultset row includes columns from two or
	 * more tables.
	 *
	 * @param ResultSet $rs The ResultSet class with cursor advanced to desired record pos.
	 * @param int $startcol 1-based offset column which indicates which restultset column to start with.
	 * @return void
	 * @throws PropelException  - Any caught Exception will be rewrapped as a PropelException.
	 */
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {
			$this->mailman_id = $rs->getInt($startcol + 0);					
			$this->project_id = $rs->getInt($startcol + 1);					
			$this->list_name = $rs->getString($startcol + 2);					
			$this->is_public = $rs->getBoolean($startcol + 3);					
			$this->list_password = $rs->getString($startcol + 4);					
			$this->created_by = $rs->getInt($startcol + 5);					
			$this->status = $rs->getInt($startcol + 6);					
			$this->list_description = $rs->getString($startcol + 7);					
			$this->create_date = $rs->getTimestamp($startcol + 8, null);
			$this->bytes_used = $rs->getInt($startcol + 9);					
			 
			$this->resetModified();
			$this->setNew(false);
		
		} catch (Exception $e) {
			throw new PropelException("Error populating Mailman object", $e);
		}		
	
	}
	
	/**
	 * Builds a Criteria object containing the primary key for this object.
	 *
	 * Unlike buildCriteria() this method includes the primary key values regardless
	 * of whether or not they have been modified.
	 * 
	 * @return Criteria The Criteria object containing value(s) for primary key(s).
	 */
	public function buildPkeyCriteria()
	{		
		$criteria = new Criteria(MailmanPeer::DATABASE_NAME);
		$criteria->add(MailmanPeer::MAILMAN_ID, $this->mailman_id);
		return $criteria;			
	}
	
	/**
	 * Build a Criteria object containing the values of all modified columns in this object.
	 *
	 * @return Criteria The Criteria object containing all modified values.
	 */
	public function buildCriteria()
	{		
		$criteria = new Criteria(MailmanPeer::DATABASE_NAME);
		if ($this->isColumnModified(MailmanPeer::MAILMAN_ID)) $criteria->add(MailmanPeer::MAILMAN_ID, $this->mailman_id);
		if ($this->isColumnModified(MailmanPeer::PROJECT_ID)) $criteria->add(MailmanPeer::PROJECT_ID, $this->project_id);
		if ($this->isColumnModified(MailmanPeer::LIST_NAME)) $criteria->add(MailmanPeer::LIST_NAME, $this->list_name);
		if ($this->isColumnModified(MailmanPeer::IS_PUBLIC)) $criteria->add(MailmanPeer::IS_PUBLIC, $this->is_public);
		if ($this->isColumnModified(MailmanPeer::LIST_PASSWORD)) $criteria->add(MailmanPeer::LIST_PASSWORD, $this->list_password);
		if ($this->isColumnModified(MailmanPeer::CREATED_BY)) $criteria->add(MailmanPeer::CREATED_BY, $this->created_by);
		if ($this->isColumnModified(MailmanPeer::STATUS)) $criteria->add(MailmanPeer::STATUS, $this->status);
		if ($this->isColumnModified(MailmanPeer::LIST_DESCRIPTION)) $criteria->add(MailmanPeer::LIST_DESCRIPTION, $this->list_description);
		if ($this->isColumnModified(MailmanPeer::CREATE_DATE)) $criteria->add(MailmanPeer::CREATE_DATE, $this->create_date);
		if ($this->isColumnModified(MailmanPeer::BYTES_USED)) $criteria->add(MailmanPeer::BYTES_USED, $this->bytes_used);
		return $criteria;			
	}
	
	

	/**
	 * @var Project	  
	 */
	protected $aProject;

	/**
	 * Declares an association between this object and a Project object
	 *
	 * @param Project $v
	 * @return void
	 * @throws PropelException
	 */
	public function setProject($v)
	{
			
		if ($v === null) {
			$this->setProjectId(NULL);
		} else {
			$this->setProjectId($v->getProjectId());
		}
   
		$this->aProject = $v;
	}


	/**
	 * Get the associated Project object
	 *
	 * @param Connection Optional Connection object.
	 * @return Project The associated Project object.
	 * @throws PropelException
	 */
	public function getProject($con = null)
	{
		// include the Peer class
		include_once 'core/ProjectPeer.php';

		if ($this->aProject === null && ($this->project_id !== null)) {
	
			$this->aProject = ProjectPeer::retrieveByPK($this->project_id, $con);
	
			/* The following can be used instead of the line above to
			   guarantee the related object contains a reference
			   to this object, but this level of coupling
			   may be undesirable in many circumstances.
			   As it can lead to a db query with many results that may
			   never be used.
			   $obj = ProjectPeer::retrieveByPK($this->project_id, $con);
			   $obj->addMailmans($this);
			 */
		}
		return $this->aProject;
	}

	/**
	 * Provides convenient way to set a relationship based on a
	 * key.  e.g.
	 * <code>$bar->setFooKey($foo->getPrimaryKey())</code>
	 *
 
	 * @return void
	 * @throws PropelException
	 */
	public function setProjectKey($key)
	{

		$this->setProjectId( (int) $key);			
		
	}

	/**
	 * @var User	  
	 */
	protected $aUser;

	/**
	 * Declares an association between this object and a User object
	 *
	 * @param User $v
	 * @return void
	 * @throws PropelException
	 */
	public function setUser($v)
	{
			
		if ($v === null) {
			$this->setCreatedBy(NULL);
		} else {
			$this->setCreatedBy($v->getUserId());
		}
   
		$this->aUser = $v;
	}


	/**
	 * Get the associated User object
	 *
	 * @param Connection Optional Connection object.
	 * @return User The associated User object.
	 * @throws PropelException
	 */
	public function getUser($con = null)
	{
		// include the Peer class
		include_once 'core/UserPeer.php';

		if ($this->aUser === null && ($this->created_by !== null)) {
	
			$this->aUser = UserPeer::retrieveByPK($this->created_by, $con);
	
			/* The following can be used instead of the line above to
			   guarantee the related object contains a reference
			   to this object, but this level of coupling
			   may be undesirable in many circumstances.
			   As it can lead to a db query with many results that may
			   never be used.
			   $obj = UserPeer::retrieveByPK($this->created_by, $con);
			   $obj->addMailmans($this);
			 */
		}
		return $this->aUser;
	}

	/**
	 * Provides convenient way to set a relationship based on a
	 * key.  e.g.
	 * <code>$bar->setFooKey($foo->getPrimaryKey())</code>
	 *
 
	 * @return void
	 * @throws PropelException
	 */
	public function setUserKey($key)
	{

		$this->setCreatedBy( (int) $key);			
		
	}

	private $fieldNames;

	/**
	 * Generate a list of field names.
	 *
	 * @return array A list of field names
	 */
	public function getFieldNames()
	{
		if ($this->fieldNames === null) {
			$this->fieldNames = array("mailman_id", "project_id", "list_name", "is_public", "list_password", "created_by", "status", "list_description", "create_date", "bytes_used", );
		}
		return $this->fieldNames;
	}
	
	/**
	 * Retrieves a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @return mixed Value of field.
	 */
	public function getByName($name)
	{
		switch($name) {
	  
			case MailmanPeer::MAILMAN_ID:
				return $this->getMailmanId();
				break;
		  
			case MailmanPeer::PROJECT_ID:
				return $this->getProjectId();
				break;
		  
			case MailmanPeer::LIST_NAME:
				return $this->getListName();
				break;
		  
			case MailmanPeer::IS_PUBLIC:
				return $this->getIsPublic();
				break;
		  
			case MailmanPeer::LIST_PASSWORD:
				return $this->getListPassword();
				break;
		  
			case MailmanPeer::CREATED_BY:
				return $this->getCreatedBy();
				break;
		  
			case MailmanPeer::STATUS:
				return $this->getStatus();
				break;
		  
			case MailmanPeer::LIST_DESCRIPTION:
				return $this->getListDescription();
				break;
		  
			case MailmanPeer::CREATE_DATE:
				return $this->getCreateDate();
				break;
		  
			case MailmanPeer::BYTES_USED:
				return $this->getBytesUsed();
				break;
	  
			default:
				return null;
				
		} // switch()
	}

	/**
	 * Retrieves a field from the object by Position as specified in the xml schema. 
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @return mixed Value of field at $pos
	 */
	public function getByPosition($pos)
	{
		switch($pos) {
  
			case 0:
				return $this->getMailmanId();
				break;
  
			case 1:
				return $this->getProjectId();
				break;
  
			case 2:
				return $this->getListName();
				break;
  
			case 3:
				return $this->getIsPublic();
				break;
  
			case 4:
				return $this->getListPassword();
				break;
  
			case 5:
				return $this->getCreatedBy();
				break;
  
			case 6:
				return $this->getStatus();
				break;
  
			case 7:
				return $this->getListDescription();
				break;
  
			case 8:
				return $this->getCreateDate();
				break;
  
			case 9:
				return $this->getBytesUsed();
				break;
			default:
				return null;
		} // switch()
	}



	
	/**
	 * Convenience method to populate the object using an array.
	 * This is particularly useful when populating an object from one of the request arrays (e.g. $_POST).  This method
	 * goest through the column (peer) names, checking to see whether a matching key exists in populated array. If
	 * so the setByName() method is called for that column.
	 * @param array $arr An array where keys are column names.
	 * @return void
	 */
	public function populateFromArray($arr)
	{
  
		if (array_key_exists(MailmanPeer::MAILMAN_ID, $arr)) $this->setMailmanId($arr[MailmanPeer::MAILMAN_ID]);
  
		if (array_key_exists(MailmanPeer::PROJECT_ID, $arr)) $this->setProjectId($arr[MailmanPeer::PROJECT_ID]);
  
		if (array_key_exists(MailmanPeer::LIST_NAME, $arr)) $this->setListName($arr[MailmanPeer::LIST_NAME]);
  
		if (array_key_exists(MailmanPeer::IS_PUBLIC, $arr)) $this->setIsPublic($arr[MailmanPeer::IS_PUBLIC]);
  
		if (array_key_exists(MailmanPeer::LIST_PASSWORD, $arr)) $this->setListPassword($arr[MailmanPeer::LIST_PASSWORD]);
  
		if (array_key_exists(MailmanPeer::CREATED_BY, $arr)) $this->setCreatedBy($arr[MailmanPeer::CREATED_BY]);
  
		if (array_key_exists(MailmanPeer::STATUS, $arr)) $this->setStatus($arr[MailmanPeer::STATUS]);
  
		if (array_key_exists(MailmanPeer::LIST_DESCRIPTION, $arr)) $this->setListDescription($arr[MailmanPeer::LIST_DESCRIPTION]);
  
		if (array_key_exists(MailmanPeer::CREATE_DATE, $arr)) $this->setCreateDate($arr[MailmanPeer::CREATE_DATE]);
  
		if (array_key_exists(MailmanPeer::BYTES_USED, $arr)) $this->setBytesUsed($arr[MailmanPeer::BYTES_USED]);
 
	}
	
	/**
	 * Sets a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByName($name, $value)
	{
		switch($name) {
	  
			case MailmanPeer::MAILMAN_ID:
				$this->setMailmanId($value);
				break;
	  
			case MailmanPeer::PROJECT_ID:
				$this->setProjectId($value);
				break;
	  
			case MailmanPeer::LIST_NAME:
				$this->setListName($value);
				break;
	  
			case MailmanPeer::IS_PUBLIC:
				$this->setIsPublic($value);
				break;
	  
			case MailmanPeer::LIST_PASSWORD:
				$this->setListPassword($value);
				break;
	  
			case MailmanPeer::CREATED_BY:
				$this->setCreatedBy($value);
				break;
	  
			case MailmanPeer::STATUS:
				$this->setStatus($value);
				break;
	  
			case MailmanPeer::LIST_DESCRIPTION:
				$this->setListDescription($value);
				break;
	  
			case MailmanPeer::CREATE_DATE:
				$this->setCreateDate($value);
				break;
	  
			case MailmanPeer::BYTES_USED:
				$this->setBytesUsed($value);
				break;
				  
		} // switch()
	}

	/**
	 * Sets a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByPosition($pos, $value)
	{
		switch($pos) {
  
			case 0:
				$this->setMailmanId($value);
				break;
  
			case 1:
				$this->setProjectId($value);
				break;
  
			case 2:
				$this->setListName($value);
				break;
  
			case 3:
				$this->setIsPublic($value);
				break;
  
			case 4:
				$this->setListPassword($value);
				break;
  
			case 5:
				$this->setCreatedBy($value);
				break;
  
			case 6:
				$this->setStatus($value);
				break;
  
			case 7:
				$this->setListDescription($value);
				break;
  
			case 8:
				$this->setCreateDate($value);
				break;
  
			case 9:
				$this->setBytesUsed($value);
				break;
		} // switch()
	}


 
	/**
	 * Removes this object from datastore and sets delete attribute.
	 * 
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 * @see BaseObject::setDeleted()
	 * @see BaseObject::isDeleted()
	 */
	public function delete($con = null)
	{	
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}
		
		if ($con === null)
			$con = Propel::getConnection(MailmanPeer::DATABASE_NAME);

		try {
			$con->begin();
			MailmanPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
	

	/**
	 * flag to prevent endless save loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	private $alreadyInSave = false;

	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.  This method
	 * wraps the doSave() worker method in a transaction.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
	public function save($con = null)
	{
		if ($this->isDeleted()) {
		//	throw new PropelException("You cannot save an object that has been deleted.");
			return;
		}
		
		if ($con === null)
			$con = Propel::getConnection(MailmanPeer::DATABASE_NAME);

		try {
			$con->begin();
			$this->doSave($con);			
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
  
	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
		protected function doSave($con)	{ 
		
	 
		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;

			// We call the save method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.
 
			if ($this->aProject !== null) {
				if ($this->aProject->isModified()) $this->aProject->save($con);
				$this->setProject($this->aProject);
			}
 
			if ($this->aUser !== null) {
				if ($this->aUser->isModified()) $this->aUser->save($con);
				$this->setUser($this->aUser);
			}

			// If this object has been modified, then save it to the database.
			if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = MailmanPeer::doInsert($this, $con);
					$this->setMailmanId( $pk );  //[IMV] update autoincrement primary key
					$this->setNew(false);
				} else {
					MailmanPeer::doUpdate($this, $con);
				}			
				$this->resetModified(); // [HL] After being saved an object is no longer 'modified'
			}

			$this->alreadyInSave = false;
		}
	}

	/**
	 * Validates the objects modified field values.
	 * This includes all objects related to this table.
	 *
	 * If $columns is either a column name or an array of column names
	 * only those columns are validated.
	 *
	 * @param mixed $columns Column name or an array of column names.
	 *
	 * @return mixed <code>true</code> if all columns pass validation
	 *			  or an array of <code>ValidationFailed</code> objects for columns that fail.
	 */
	public function validate($columns = null)
	{
	  if ($columns)
	  {
		return MailmanPeer::doValidate($this, $columns);
	  }

		return $this->doValidate();
	}

	/**
	 * flag to prevent endless validation loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	protected $alreadyInValidation = false;
  
	/**
	 * This function performs the validation work for complex object models.
	 * 
	 * In addition to checking the current object, all related objects will
	 * also be validated.  If all pass then <code>true</code> is returned; otherwise
	 * an aggreagated array of ValidationFailed objects will be returned.
	 *
	 * @return mixed <code>true</code> if all validations pass; array of <code>ValidationFailed</code> objets otherwise.
	 */
	protected function doValidate()
	{
		if (! $this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;
	  
			$failureMap = array();	  
	  
			// We call the validate method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.
			if ($this->aProject !== null) {
				if (($retval = $this->aProject->validate()) !== true) {
					$failureMap = array_merge($failureMap, $retval);
				}
			}
			if ($this->aUser !== null) {
				if (($retval = $this->aUser->validate()) !== true) {
					$failureMap = array_merge($failureMap, $retval);
				}
			}

			if (($retval = MailmanPeer::doValidate($this)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}
	  
	  
			$this->alreadyInValidation = false;
		}
	
		return (!empty($failureMap) ? $failureMap : true);
	}
  

	/**
	 * Set the PrimaryKey.
	 *
	 * @param mixed mailman_id Primary key.
	 * @return void
	 * @throws PropelException	 */
	public function setPrimaryKey($key) 
	{		
		$this->setMailmanId($key);
	}
	

	/**
	 * Returns an id that differentiates this object from others
	 * of its class.
	 * @return int 
	 */
	public function getPrimaryKey()
	{

		return $this->getMailmanId();

	}

	
	/**
	 * Makes a copy of this object that will be inserted as a new row in table when saved.
	 * It creates a new object filling in the simple attributes, but skipping any primary
	 * keys that are defined for the table.
	 *  
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 *  
	 * @return Mailman Clone of current object.
	 * @throws PropelException
	 */
	public function copy($deepCopy = false) 
	{
		$copyObj = new Mailman();
		$copyObj->setProjectId($this->project_id);
		$copyObj->setListName($this->list_name);
		$copyObj->setIsPublic($this->is_public);
		$copyObj->setListPassword($this->list_password);
		$copyObj->setCreatedBy($this->created_by);
		$copyObj->setStatus($this->status);
		$copyObj->setListDescription($this->list_description);
		$copyObj->setCreateDate($this->create_date);
		$copyObj->setBytesUsed($this->bytes_used);
		
		$copyObj->setNew(true);
		
		$copyObj->setMailmanId(NULL); // this is a pkey column, so set to default value

		return $copyObj;
	}
		

	/**
	 * returns a peer instance associated with this om.  Since Peer classes	
	 * are not to have any instance attributes, this method returns the
	 * same instance for all member of this class. The method could therefore
	 * be static, but this would prevent one from overriding the behavior.
	 * @return MailmanPeer
	 */
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new MailmanPeer();
		}
		return self::$peer;
	}

}
