<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code creates a new Mailman and saves it to the 
// database
//
require_once('plugins/mailman/lib/Mailman.php');
require_once('Validator.php');
require_once('exceptions/InvalidDataException.php');
require_once('exceptions/PermissionDeniedException.php');
require_once('exceptions/NotLoggedInException.php');
require_once('core/Language.php');


$Mailman = new Mailman();

$errors = array();
$language = Language::getSessLang();
$project = GFUrl::getUrl()->getProject();
$session = Session::getSession();
$user = $session->getUser();

$listPassword= substr(md5(rand(0,10000)), 0, 16);

if (count($errors) == 0) {
	$Mailman->setProjectId($project->getProjectId());
	$Mailman->setListName(strtolower(Validator::sanitizeString($project->getUnixName()."-".$_POST['list_name'])));
	$Mailman->setIsPublic(Validator::sanitizeBool($_POST['is_public']));
	$Mailman->setListPassword($listPassword );
	$Mailman->setCreatedBy($user->getUserId());
	$Mailman->setStatus(Mailman::STATUS_REQUESTED);
	$Mailman->setListDescription(Validator::sanitizeString($_POST['description']));

	
	try {
		$Mailman->save();

	} catch (InvalidDataException $ex) {
		$errors = array_merge($errors, $ex->getErrors());		// attach object errors to validation errors
	}

}
	
if (count($errors) > 0) {
	$feedback = '* '.implode('<br />* ', $errors);
	include('MailmanAdd.php');
} else {

	if(GFConf::get('system.useDaemon')){
		GFDaemon::notify('DAEMON_LIST_CREATE', $Mailman->getProject()->getUnixName());
	}
	GFUrl::getUrl()->redirect(GFUrl::getUrl()->currentBaseURL('Mailman'), array('feedback' => $language->getText('Mailman.AddFeedback')));
}

?>
