<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code edits a Mailman and saves it to the 
// database
//
require_once('plugins/mailman/lib/Mailman.php');
require_once('Validator.php');
require_once('exceptions/PermissionDeniedException.php');
require_once('core/Language.php');

if ($_SERVER['REQUEST_METHOD'] != 'POST') {
	throw new PermissionDeniedException();
}

$Mailman = MailmanPeer::retrieveByPk($_POST['id']);
/*if (!is_object($Mailman) || !$Mailman->userCanUpdate()) {
	throw new PermissionDeniedException();
}
*/

$errors = array();
$language = Language::getSessLang();


if (count($errors) == 0) {
	$Mailman->setIsPublic( Validator::sanitizeBool($_POST['is_public']) );
	$Mailman->setListDescription( Validator::sanitizeString($_POST['description']) );
	
	$Mailman->save();
	if(GFConf::get('system.useDaemon')){
		GFDaemon::notify('DAEMON_LIST_EDIT', $Mailman->getListName());
	}
	GFUrl::getUrl()->redirect(GFUrl::getUrl()->currentBaseURL('Mailman'), array('feedback' => $language->getText('Mailman.EditFeedback')));
} else {
	$feedback = implode('<br />', $errors);
	include('MailmanEdit.php');
}

?>
