<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code shows a form for editing News
//
require_once('plugins/news/lib/NewsPeer.php');
require_once('plugins/news/lib/News.php');
require_once('exceptions/PermissionDeniedException.php');
//require_once('plugins/forum/lib/html/ForumFormRenderer.php');

$kept_vars = array('action', 'id');

$session = Session::getSession();
$Lang = $session->getLanguage();

$forum_action = $_REQUEST['_forum_action'];

require_once('plugins/news/lib/html/NewsTemplate.php');
$theme = new NewsTemplate();

$Project = GFUrl::getUrl()->getProject();
$News = NewsPeer::retrieveByPk($_GET['id']);
if (!is_object($News) || !$News->userCanRead()) {
	throw new PermissionDeniedException();
}
$obj = $News;

/*
 * Generate the forum page. This is done BEFORE outputting any text before 
 * this code could redirect.
 */
include_once('plugins/news/lib/html/NewsCommentsRenderer.php');
$renderer = new NewsCommentsRenderer(News::SECTION, $News->getPrimaryKey(), $theme, $Lang, $kept_vars);

$forum_page = $renderer->handleBrowse($forum, $News);

if ($renderer->hasErrors()) {
	$feedback = "*".implode('<br />*', $renderer->getErrors());
}

GFUrl::redirect(GFUrl::getUrl()->projectURL($Project,'','news','',array('feedback'=>$feedback)));
?>
