<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id$
 * @author Tim Perdue tim@gforge.org
 * @date 2006-02-27
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

echo $theme->header($params);
?>
<div id="hidden_form" style="display: none">
	<?php echo (isset($form)) ? $form : ""; ?>
</div>
<style type="text/css">
     #newscontainer { float: left; background: url(images/example-7.gif) bottom center no-repeat; padding-bottom: 1px; }
     #newsinner { float: left; overflow: hidden; }
     #newsinner div { float: left; background: #fff; border: 0px solid #000; width: 600px; margin-right: 10px; margin-bottom: -1000px; padding-bottom: 1000px; }
     #newsinner .newscol2 { background: #eee; margin-right: 0; width: 200px; }
     .clear { clear: both; padding-top: 10px; }
</style>

<script type="text/javascript">
var cur_news_id = <?php echo (isset($news_id) ? $news_id : 0); ?>;
var cur_thread_id = <?php echo (isset($thread_id) ? $thread_id : 0); ?>;
var cur_message_id = <?php echo (isset($message_id) ? $message_id : 0); ?>;
var cur_forum_action = "<?php echo (isset($forum_action) ? $forum_action : ""); ?>";
var cur_form = document.getElementById("hidden_form").innerHTML;
var cur_feedback = "<?php echo $feedback; ?>";
var opened_window_id = 0;
document.getElementById("hidden_form").innerHTML = "";

window.onload = function () {
	REDIPS.dialog.init();

	var previous = CKEDITOR.instances['message'];
	if(previous){
		previous.destroy(true);
	}

	selected_message_id = 0;
	opened_window_id = 0;

	switch (cur_forum_action) {
		case "ForumThreadAdd":
			//document.getElementById("new_thread").innerHTML = "<span class=\"feedback\">*" + cur_feedback + "</span><br />" + cur_form;
			if ($('#new_thread') !== undefined) {
				$('#new_thread').html("<span class=\"feedback\">*" + cur_feedback + "</span><br />" + cur_form);
			}
			window.scroll(0, document.getElementById("new_thread").offsetTop);			
			opened_window_id = "new_thread";	
		break;
		
		case "MessageReply":
			document.getElementById("comment_area_" + cur_message_id).innerHTML = "<span class=\"feedback\">*" + cur_feedback + "</span><br />" + cur_form;
			window.scroll(0, document.getElementById("comment_area_" + cur_message_id).offsetTop);
			opened_window_id = "comment_area_" + cur_message_id;
		break;		
		
		case "MessageEdit":
			document.getElementById("comment_area_" + cur_message_id).innerHTML = "<span class=\"feedback\">*" + cur_feedback + "</span><br />" + cur_form;
			window.scroll(0, document.getElementById("comment_area_" + cur_message_id).offsetTop);
			opened_window_id = "comment_area_" + cur_message_id;
		break;		
	}
}
	

function closeCurrentWindow() {
	var obj = document.getElementById(opened_window_id);
	if (obj != undefined) {
		obj.innerHTML = "";
	}
	opened_window_id = "";
}

function showMessages(thread_id) {
	//spin_div('new_comments_' + news_id);
	closeCurrentWindow();
	var url_base = '<?php echo GFUrl::getUrl()->projectURL($Project,'NewsProcessAjaxAction','news','', array())?>&_forum_action=ForumMessageBrowse&thread_id=';
	$(document).ready(function(){
		$.get(url_base + thread_id,
			function(data){
				$('#thread_'+thread_id).html(data);
				$('#thread_'+thread_id).slideDown();
			}
		);
	});

	return;
}	

function showThreadAdd(news_id) {
	//spin_div('new_comments_' + news_id);
	closeCurrentWindow();
	if (console) console.log('showThreadAdd('+news_id+')');
	var url_base = '<?php echo GFUrl::getUrl()->projectURL($Project,'NewsLoadAddThreadForm','news','', array())?>&_forum_action='+cur_forum_action+'&id=';
	$(document).ready(function(){
		$.get(url_base + news_id,
			function(data){
				$('#new_thread_'+news_id).html(data);
				opened_window_id = 'new_thread_'+news_id;
			}
		);
	});

	return;
}	

function performMessageAction(action_type, url_action, message_id) {
	//spin_div('new_comments_' + news_id);
	closeCurrentWindow();

	$(document).ready(function(){
		$.get(url_action,
		function(data){
			var container = $('#comment_area_' + message_id);
			$(container).html(data);
			$('.comment-form-table', container).slideDown();
			opened_window_id = 'comment_area_' + message_id;
			var controlName = 'body_'+action_type+'_'+message_id;
		});
	});


	return;
}	


function deleteMessage(message_id, message_text) {
	//spin_div('new_comments_' + news_id);
	closeCurrentWindow();
	selected_message_id = message_id;

	url_action = '<?php echo GFUrl::getUrl()->projectURL($Project,'NewsProcessAjaxAction','news','', array()) ?>&_forum_action=MessageDelete&id=<?php echo $news_id; ?>&message_id=' + selected_message_id;
	$(document).ready(function(){
		$.get(url_action,
		function(data){
			REDIPS.dialog.show(350, 200, data, '', '');
		});
	});

	return;
}


function lockThread(thread_id, url_action) {
	//spin_div('new_comments_' + news_id);
	closeCurrentWindow();
	
	$(document).ready(function(){
		$.get(url_action,
		function(data){
			showMessages(thread_id);
		});
	});


	return;
}

</script>

<?php
	if (sizeof($arr) == 0) {
		echo "<h4>" . $Lang->getText('News.NoPosts') . "</h4>";	
	} else {
?>

<!-- Forces proper loading of CKEditor -->
<div style='display:none; visibility:hidden'>
<?php
	$CKEditor = new GFCKEditor();
	$CKEditor->editor('__hiden_editor__', '')
?>
</div>

<table width="98%" style="padding: 2px;">
	<tr>
		<td width="80%" style="margin-right: 10px;">

<?php
	// Generate the forum page. This is done BEFORE outputting any text before this code could redirect.
	include_once('plugins/news/lib/html/NewsCommentsRenderer.php');

	foreach ($arr as $item) {
		//Get user that posted the item
		$user_id = $item->getSubmittedBy();
		$user_posted = UserPeer::retrieveByPk($user_id);
		$url = GFUrl::getUrl();
		$item_url = GFUrl::getUrl()->projectURL($item->getProject(),'','news', '',array('id'=>$item->getNewsId()));
		if (is_object($user_posted)) {
			$user_posted_name = $user_posted->getFullname();
			$user_posted_unixname = $user_posted->getUnixName();
		} else {
			$user_posted_name = "anonymous";
		}
		
		// Try to create a forum for this news on the fly
		$c = new Criteria();
		$c->add(ForumPeer::SECTION, News::SECTION);
		$c->add(ForumPeer::REF_ID, $item->getPrimaryKey());
		$forum = ForumPeer::doSelectOne($c);
		if (is_null($forum)) {
			$forum = new Forum();
			$forum->setSection(News::SECTION);
			$forum->setRefId($item->getPrimaryKey());
			$forum->setForumName($item->getSummary());
			// We do this because we may be logged in as any user, so we must skip
			// permission checks
			$forum->forceSave();
			$forum->save();
		}

		$c = new Criteria();
		$c->addJoin(ForumMessagePeer::FORUM_THREAD_ID, ForumThreadPeer::FORUM_THREAD_ID);
		$c->addJoin(ForumThreadPeer::FORUM_ID, ForumPeer::FORUM_ID);
		$c->add(ForumPeer::SECTION, News::SECTION);
		$c->add(ForumPeer::REF_ID, $item->getNewsId());
		$message_count = ForumMessagePeer::doCount($c);

		//Get the threads
		$kept_vars = array();

		$renderer = new NewsCommentsRenderer(News::SECTION, NewsPlugin::getFormPaths(), $item->getPrimaryKey(), $theme, Language::getSessLang(), $kept_vars, '');
		$forum_page = $renderer->handleBrowse($forum, $item->getSummary(), 0, 0, '', '');
?>
<!-- #start news item block -->
			<div id="post" class="post">
				<h1 class="entry-title"><a href="<?php echo $item_url ?>" title="<?php echo $item->getSummary() ?>"><?php echo $item->getSummary() ?></a></h1>

					<div class="entry-meta">
						<span class="meta-prep meta-prep-author">Posted on</span> <span class="entry-date"><?php echo $item->getPostDate('Y-m-d'); ?></span> <span class="meta-sep">by</span> <span class="author vcard"><a class="url fn n" href="<?php echo $url->userUrl($user_posted); ?>" title=""><?php echo $user_posted_name; ?></a></span>
					</div>
					<!-- .entry-meta -->

					<div class="entry-content" style="margin-top: 8px; margin-bottom: 5px; padding: 1px; line-height: 1.5em;">
						<?php echo ($news_id == 0) ? $item->getShortDetails(true) : $item->getDetails(); ?>
					</div><!-- .entry-content -->

					<?php if ($news_id != 0): ?>
					<br />					
					<?php 
						$user = Session::getSession()->getUser();
						$project = GFUrl::getUrl()->getProject();
						if (Session::getSession()->isLoggedIn() && ($project->isPublic() || $user->isProjectMember($project)) ) {
							echo "<script type=\"text/javascript\">showThreadAdd({$item->getNewsId()});</script>";
							//echo HTMLWidget::button("button","New Thread","button","btn_new_thread","showThreadAdd('" . $item->getNewsId() . "')", true);
						} else {
							//echo HTMLWidget::button("button","New Thread","button","btn_new_thread","", false);
						}
					?>
					<div id="new_thread_<?php echo $item->getNewsId(); ?>">
						
					</div>
					<?php endif; ?>

					<!--START THREADS-->
					<?php if ($news_id == 0) { ?>
					<div style="margin-top: 5px;">
							<a href="<?php echo GFUrl::getUrl()->projectURL($item->getProject(),'','news', '',array('id'=>$item->getNewsId())); ?>"><img src="/images/forum_icon.gif" alt="5" />&nbsp;&nbsp;Comments (<?php echo $message_count; ?>)</a>
					</div>
					<?php } else {
						echo $forum_page;
					} ?>

					<!--END THREADS-->
			</div>

			<?php if ($news_id == 0): ?>
			<div>
				<img src="<?php echo $theme->getImgUrl("blog/thread_separator.png"); ?>" />
			</div>
			<?php endif; ?>

<!-- #end news item block -->
<?php
	} //End news foreach
?>
	</td>

	<td width="20%" valign="top">
		<div style="padding: 10px; background: #EEE;">
			<!-- Start Archives -->
			<?php if (sizeof($arr_archives) > 0): ?>
			<h3>Archives</h3>
			<br />
			<ul>
				<?php 
					foreach ($arr_archives as $arr_archive) {
						echo '<li><a href="' . GFUrl::getUrl()->projectURL($Project,'','news','',array('year'=>$arr_archive['year'],'month'=>$arr_archive['month'])) . '">' . $arr_archive['desc'] . '</a></li>';
					} 
				?>
			</ul>
			<!-- Finish search -->
			<br /><br />
			<?php endif; ?>
			<!-- Start Tagcloud -->
			<?php if (sizeof($arr_tags) > 0): ?>
			<h3>Tag Cloud</h3>
			<br />
			<?php
				foreach($arr_tags as $tag_name => $tag_size) {
					$style = "font-size: " . $tag_size . "px;";
					echo '<span style="' . $style . '"><a href="' . GFUrl::getUrl()->projectURL($Project,'','news','',array('tag'=>$tag_name)) . '">' . $tag_name . '</a></span> ';
				}
			?>
			<?php endif; ?>
			<!-- Finish Tagcloud -->
		</div>
	</td>


	</tr>
</table>
<?php } ?>
<div class="clear"></div>
