<?php
require_once 'propel/map/MapBuilder.php';
include_once 'creole/CreoleTypes.php';

/**
 * This class adds structure of 'user_project_rating' table to 'gf5' DatabaseMap object.
 *
 * These statically-built map classes are used by Propel to do runtime db structure discovery.
 * For example, the createSelectSql() method checks the type of a given column used in an 
 * ORDER BY clause to know whether it needs to apply SQL to make the ORDER BY case-insensitive 
 * (i.e. if it's a text column type).
 *
 * @see BasePeer
 * @see DatabaseMap
 * @package plugins.projectrating.lib.map
 */
class UserProjectRatingMapBuilder implements MapBuilder {

    /**
     * The name of this class
     */
    const CLASS_NAME = "plugins.projectrating.lib.map.UserProjectRatingMapBuilder";
	
    /**
     * The database map.
     */
    private $dbMap = null;

    /**
     * Tells us if this DatabaseMapBuilder is built so that we
     * don't have to re-build it every time.
     *
     * @return true if this DatabaseMapBuilder is built
     */
    public function isBuilt()
    {
        return ($this->dbMap !== null);
    }

    /**
     * Gets the databasemap this map builder built.
     *
     * @return the databasemap
     */
    public function getDatabaseMap()
    {
        return $this->dbMap;
    }

    /**
     * The doBuild() method builds the DatabaseMap
     *
	 * @return void
     * @throws PropelException
     */
    public function doBuild()
    {
		$this->dbMap = Propel::getDatabaseMap("gf5");
		
		$tMap = $this->dbMap->addTable("user_project_rating");
		$tMap->setPhpName("UserProjectRating");
		
         
		$tMap->setUseIdGenerator(false);
		 
						
		 
		
		// Add columns to map
		$tMap->addForeignPrimaryKey("USER_ID", "UserId", "int" , CreoleTypes::INTEGER, "user", "USER_ID", true);
		$tMap->addForeignPrimaryKey("PROJECT_ID", "ProjectId", "int" , CreoleTypes::INTEGER, "project", "PROJECT_ID", true);
		$tMap->addColumn("RATING", "Rating", "int", CreoleTypes::INTEGER, true, null);
		$tMap->addColumn("COMMENT", "Comment", "string", CreoleTypes::VARCHAR, false, null);
		$tMap->addColumn("RATING_DATE", "RatingDate", "int", CreoleTypes::TIMESTAMP, false, null);
				
    }
}
