<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id$
 * @author Tim Perdue tim@gforge.org
 * @date 2006-01-03
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
require_once 'plugins/scm/lib/om/BaseScmPreference.php';
require_once("plugin/ActionManager.php");

/** 
 * The skeleton for this class was autogenerated by Propel  on:
 *
 * [Wed Jan  4 05:51:25 2006]
 *
 * You should add additional methods to this class to meet the
 * application requirements.  This class will only be generated as
 * long as it does not already exist in the output directory.
 *
 * @package plugins.scm.lib 
 */
class ScmPreference extends BaseScmPreference {
	/**
	 * Removes this object from datastore and sets delete attribute. Informs the plugin manager.
	 * This method was added by propel_customizer.php.
	 * 
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 * @see ScmPreference::setDeleted()
	 * @see ScmPreference::isDeleted()
	 */
	function delete($con = null) {
		ActionManager::notify("SCM_PREFERENCE_DELETE", $this);
		parent::delete($con);		
	}

	/**
	 * Stores the object in the database using the Propel methods. Informs the plugin manager.
	 * This method was added by propel_customizer.php.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
	function save($con = null) {
		ActionManager::notify("SCM_PREFERENCE_SAVE_BEFORE", $this);
		$mail_changed = $this->isColumnModified(ScmPreferencePeer::MAIL_COMMITS);
		parent::save($con);
		ActionManager::notify("SCM_PREFERENCE_SAVE", $this);
		if($mail_changed) {
			GFDaemon::notify("DAEMON_SCM_EMAIL_COMMIT", $this->getProject()->getUnixName());
		}
	}


}
?>
