<?php
require_once 'propel/map/MapBuilder.php';
include_once 'creole/CreoleTypes.php';

/**
 * This class adds structure of 'project_scm' table to 'gf5' DatabaseMap object.
 *
 * These statically-built map classes are used by Propel to do runtime db structure discovery.
 * For example, the createSelectSql() method checks the type of a given column used in an 
 * ORDER BY clause to know whether it needs to apply SQL to make the ORDER BY case-insensitive 
 * (i.e. if it's a text column type).
 *
 * @see BasePeer
 * @see DatabaseMap
 * @package plugins.scm.lib.map
 */
class ProjectScmMapBuilder implements MapBuilder {

    /**
     * The name of this class
     */
    const CLASS_NAME = "plugins.scm.lib.map.ProjectScmMapBuilder";
	
    /**
     * The database map.
     */
    private $dbMap = null;

    /**
     * Tells us if this DatabaseMapBuilder is built so that we
     * don't have to re-build it every time.
     *
     * @return true if this DatabaseMapBuilder is built
     */
    public function isBuilt()
    {
        return ($this->dbMap !== null);
    }

    /**
     * Gets the databasemap this map builder built.
     *
     * @return the databasemap
     */
    public function getDatabaseMap()
    {
        return $this->dbMap;
    }

    /**
     * The doBuild() method builds the DatabaseMap
     *
	 * @return void
     * @throws PropelException
     */
    public function doBuild()
    {
		$this->dbMap = Propel::getDatabaseMap("gf5");
		
		$tMap = $this->dbMap->addTable("project_scm");
		$tMap->setPhpName("ProjectScm");
		
         
		$tMap->setUseIdGenerator(false);
		 
						
		 
		
		// Add columns to map
		$tMap->addForeignPrimaryKey("PROJECT_ID", "ProjectId", "int" , CreoleTypes::INTEGER, "project", "PROJECT_ID", true);
		$tMap->addColumn("ENABLE_ANONREAD", "EnableAnonread", "boolean", CreoleTypes::BOOLEAN, false, null);
		$tMap->addForeignKey("SCM_SERVER_ID", "ScmServerId", "int", CreoleTypes::INTEGER, "scm_server" , "SCM_SERVER_ID", true);
		$tMap->addColumn("CONTROLLED", "Controlled", "boolean", CreoleTypes::BOOLEAN, false, null);
		$tMap->addColumn("HOSTNAME", "Hostname", "string", CreoleTypes::VARCHAR, false, null);
		$tMap->addColumn("ROOT_DIRECTORY", "RootDirectory", "string", CreoleTypes::VARCHAR, false, null);
		$tMap->addColumn("EXTERNAL_BROWSE_URL", "ExternalBrowseUrl", "string", CreoleTypes::VARCHAR, false, null);
		$tMap->addColumn("BROWSE_TEXT", "BrowseText", "string", CreoleTypes::VARCHAR, false, null);
		$tMap->addColumn("ACCESS_TEXT", "AccessText", "string", CreoleTypes::VARCHAR, false, null);
		$tMap->addColumn("BYTES_USED", "BytesUsed", "double", CreoleTypes::FLOAT, false, null);
		$tMap->addColumn("USE_SSH", "UseSsh", "boolean", CreoleTypes::BOOLEAN, false, null);
				
    }
}
