<?php 

require_once 'propel/om/BaseObject.php';

 
require_once 'propel/om/Persistent.php';

 

include_once 'propel/util/Criteria.php';
 

// (on-demand) include_once 'core/Plugin.php';
// (on-demand) include_once 'core/PluginPeer.php';

include_once 'plugins/scm/lib/ScmCommitFilterPeer.php';

/**
 * Base class that represents a row from the 'scm_commit_filter' table.
 *
 *  
 *
 * You should not use this class directly.  It should not even be
 * extended; all references should be to ScmCommitFilter class. 
 * 
 * @package plugins.scm.lib 
 */
abstract class BaseScmCommitFilter extends BaseObject implements Persistent {
	
	/** 
	 * The Peer class.
	 * Instance provides a convenient way of calling static methods on a class
	 * that calling code may not be able to identify.
	 * @var ScmCommitFilterPeer
	 */
	protected static $peer;

	/**
	 * The value for the scm_commit_filter_id field.
	 * @var int	  
	 */
	protected $scm_commit_filter_id;	

	/**
	 * The value for the filter_description field.
	 * @var string	  
	 */
	protected $filter_description;	

	/**
	 * The value for the plugin_id field.
	 * @var int	  
	 */
	protected $plugin_id;	

	/**
	 * The value for the filter_string field.
	 * @var string	  
	 */
	protected $filter_string;	

	/**
	 * The value for the filter_type field.
	 * @var int	  
	 */
	protected $filter_type;	
  
	/**
	 * Get the ScmCommitFilterId column value.
	 *  
	 * @return int	  
	 */
	public function getScmCommitFilterId()
	{
		return $this->scm_commit_filter_id;
	}


	/**
	 * Set the value of `scm_commit_filter_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setScmCommitFilterId($v)
	{
		if ($this->scm_commit_filter_id !== $v) {
			$this->scm_commit_filter_id = $v;
			$this->modifiedColumns[] = ScmCommitFilterPeer::SCM_COMMIT_FILTER_ID;
		}
			
		  // update associated ScmCommitFilterProject		  
		  if ($this->collScmCommitFilterProjects !== null) {
			  for ($i=0,$size=count($this->collScmCommitFilterProjects); $i < $size; $i++) {
				  $this->collScmCommitFilterProjects[$i]->setScmCommitFilterId($v);
			  }
		  }
			  		
	}

  
	/**
	 * Get the FilterDescription column value.
	 *  
	 * @return string	  
	 */
	public function getFilterDescription()
	{
		return $this->filter_description;
	}


	/**
	 * Set the value of `filter_description` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setFilterDescription($v)
	{
		if ($this->filter_description !== $v) {
			$this->filter_description = $v;
			$this->modifiedColumns[] = ScmCommitFilterPeer::FILTER_DESCRIPTION;
		}
				
	}

  
	/**
	 * Get the PluginId column value.
	 *  
	 * @return int	  
	 */
	public function getPluginId()
	{
		return $this->plugin_id;
	}


	/**
	 * Set the value of `plugin_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setPluginId($v)
	{
		if ($this->plugin_id !== $v) {
			$this->plugin_id = $v;
			$this->modifiedColumns[] = ScmCommitFilterPeer::PLUGIN_ID;
		}
			
		if ($this->aPlugin !== null && $this->aPlugin->getPluginId() !== $v) {
			$this->aPlugin = null;
		}
			
	}

  
	/**
	 * Get the FilterString column value.
	 *  
	 * @return string	  
	 */
	public function getFilterString()
	{
		return $this->filter_string;
	}


	/**
	 * Set the value of `filter_string` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setFilterString($v)
	{
		if ($this->filter_string !== $v) {
			$this->filter_string = $v;
			$this->modifiedColumns[] = ScmCommitFilterPeer::FILTER_STRING;
		}
				
	}

  
	/**
	 * Get the FilterType column value.
	 *  
	 * @return int	  
	 */
	public function getFilterType()
	{
		return $this->filter_type;
	}


	/**
	 * Set the value of `filter_type` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 *  
	 */
	public function setFilterType($v)
	{
		if ($this->filter_type !== $v) {
			$this->filter_type = $v;
			$this->modifiedColumns[] = ScmCommitFilterPeer::FILTER_TYPE;
		}
				
	}


	
	/**
	 * Hydrates (populates) the object variables with values from the database resultset.
	 *
	 * An offset (1-based "start column") is specified so that objects can be hydrated
	 * with a subset of the columns in the resultset rows.  This is needed, for example,
	 * for results of JOIN queries where the resultset row includes columns from two or
	 * more tables.
	 *
	 * @param ResultSet $rs The ResultSet class with cursor advanced to desired record pos.
	 * @param int $startcol 1-based offset column which indicates which restultset column to start with.
	 * @return void
	 * @throws PropelException  - Any caught Exception will be rewrapped as a PropelException.
	 */
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {
			$this->scm_commit_filter_id = $rs->getInt($startcol + 0);					
			$this->filter_description = $rs->getString($startcol + 1);					
			$this->plugin_id = $rs->getInt($startcol + 2);					
			$this->filter_string = $rs->getString($startcol + 3);					
			$this->filter_type = $rs->getInt($startcol + 4);					
			 
			$this->resetModified();
			$this->setNew(false);
		
		} catch (Exception $e) {
			throw new PropelException("Error populating ScmCommitFilter object", $e);
		}		
	
	}
	
	/**
	 * Builds a Criteria object containing the primary key for this object.
	 *
	 * Unlike buildCriteria() this method includes the primary key values regardless
	 * of whether or not they have been modified.
	 * 
	 * @return Criteria The Criteria object containing value(s) for primary key(s).
	 */
	public function buildPkeyCriteria()
	{		
		$criteria = new Criteria(ScmCommitFilterPeer::DATABASE_NAME);
		$criteria->add(ScmCommitFilterPeer::SCM_COMMIT_FILTER_ID, $this->scm_commit_filter_id);
		return $criteria;			
	}
	
	/**
	 * Build a Criteria object containing the values of all modified columns in this object.
	 *
	 * @return Criteria The Criteria object containing all modified values.
	 */
	public function buildCriteria()
	{		
		$criteria = new Criteria(ScmCommitFilterPeer::DATABASE_NAME);
		if ($this->isColumnModified(ScmCommitFilterPeer::SCM_COMMIT_FILTER_ID)) $criteria->add(ScmCommitFilterPeer::SCM_COMMIT_FILTER_ID, $this->scm_commit_filter_id);
		if ($this->isColumnModified(ScmCommitFilterPeer::FILTER_DESCRIPTION)) $criteria->add(ScmCommitFilterPeer::FILTER_DESCRIPTION, $this->filter_description);
		if ($this->isColumnModified(ScmCommitFilterPeer::PLUGIN_ID)) $criteria->add(ScmCommitFilterPeer::PLUGIN_ID, $this->plugin_id);
		if ($this->isColumnModified(ScmCommitFilterPeer::FILTER_STRING)) $criteria->add(ScmCommitFilterPeer::FILTER_STRING, $this->filter_string);
		if ($this->isColumnModified(ScmCommitFilterPeer::FILTER_TYPE)) $criteria->add(ScmCommitFilterPeer::FILTER_TYPE, $this->filter_type);
		return $criteria;			
	}
	
	

	/**
	 * @var Plugin	  
	 */
	protected $aPlugin;

	/**
	 * Declares an association between this object and a Plugin object
	 *
	 * @param Plugin $v
	 * @return void
	 * @throws PropelException
	 */
	public function setPlugin($v)
	{
			
		if ($v === null) {
			$this->setPluginId(NULL);
		} else {
			$this->setPluginId($v->getPluginId());
		}
   
		$this->aPlugin = $v;
	}


	/**
	 * Get the associated Plugin object
	 *
	 * @param Connection Optional Connection object.
	 * @return Plugin The associated Plugin object.
	 * @throws PropelException
	 */
	public function getPlugin($con = null)
	{
		// include the Peer class
		include_once 'core/PluginPeer.php';

		if ($this->aPlugin === null && ($this->plugin_id !== null)) {
	
			$this->aPlugin = PluginPeer::retrieveByPK($this->plugin_id, $con);
	
			/* The following can be used instead of the line above to
			   guarantee the related object contains a reference
			   to this object, but this level of coupling
			   may be undesirable in many circumstances.
			   As it can lead to a db query with many results that may
			   never be used.
			   $obj = PluginPeer::retrieveByPK($this->plugin_id, $con);
			   $obj->addScmCommitFilters($this);
			 */
		}
		return $this->aPlugin;
	}

	/**
	 * Provides convenient way to set a relationship based on a
	 * key.  e.g.
	 * <code>$bar->setFooKey($foo->getPrimaryKey())</code>
	 *
 
	 * @return void
	 * @throws PropelException
	 */
	public function setPluginKey($key)
	{

		$this->setPluginId( (int) $key);			
		
	}

	/**
	 * Collection to store aggregation of collScmCommitFilterProjects	  
	 * @var array
	 */
	protected $collScmCommitFilterProjects; 

	/**
	 * Temporary storage of collScmCommitFilterProjects to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initScmCommitFilterProjects()
	{
		if ($this->collScmCommitFilterProjects === null) {
			$this->collScmCommitFilterProjects = array();
		}
	}

	/**
	 * Method called to associate a ScmCommitFilterProject object to this object
	 * through the ScmCommitFilterProject foreign key attribute
	 *
	 * @param ScmCommitFilterProject $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addScmCommitFilterProject(ScmCommitFilterProject $l)
	{
		$this->collScmCommitFilterProjects[] = $l;
		$l->setScmCommitFilter($this);
	}

	/**
	 * The criteria used to select the current contents of collScmCommitFilterProjects.
	 * @var Criteria
	 */
	private $lastScmCommitFilterProjectsCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this ScmCommitFilter has previously
	 * been saved, it will retrieve related ScmCommitFilterProjects from storage.
	 * If this ScmCommitFilter is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getScmCommitFilterProjects($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/scm/lib/ScmCommitFilterProjectPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collScmCommitFilterProjects === null) {
			if ($this->isNew()) {
			   $this->collScmCommitFilterProjects = array();
			} else {
	
				$criteria->add(ScmCommitFilterProjectPeer::SCM_COMMIT_FILTER_ID, $this->getScmCommitFilterId() );

				$this->collScmCommitFilterProjects = ScmCommitFilterProjectPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(ScmCommitFilterProjectPeer::SCM_COMMIT_FILTER_ID, $this->getScmCommitFilterId());

				if (!isset($this->lastScmCommitFilterProjectsCriteria) || !$this->lastScmCommitFilterProjectsCriteria->equals($criteria)) {
					$this->collScmCommitFilterProjects = ScmCommitFilterProjectPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastScmCommitFilterProjectsCriteria = $criteria;

		return $this->collScmCommitFilterProjects;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this ScmCommitFilter is new, it will return
	 * an empty collection; or if this ScmCommitFilter has previously
	 * been saved, it will retrieve related ScmCommitFilterProjects from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in ScmCommitFilter.
	 */
	public function getScmCommitFilterProjectsJoinScmCommitFilter($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/scm/lib/ScmCommitFilterProjectPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collScmCommitFilterProjects === null) {
			if ($this->isNew()) {
			   $this->collScmCommitFilterProjects = array();
			} else {
	   
				$criteria->add(ScmCommitFilterProjectPeer::SCM_COMMIT_FILTER_ID, $this->getScmCommitFilterId());
				$this->collScmCommitFilterProjects = ScmCommitFilterProjectPeer::doSelectJoinScmCommitFilter($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(ScmCommitFilterProjectPeer::SCM_COMMIT_FILTER_ID, $this->getScmCommitFilterId());
			if (!isset($this->lastScmCommitFilterProjectsCriteria) || !$this->lastScmCommitFilterProjectsCriteria->equals($criteria)) {
				$this->collScmCommitFilterProjects = ScmCommitFilterProjectPeer::doSelectJoinScmCommitFilter($criteria, $con);
			}
		}
		$this->lastScmCommitFilterProjectsCriteria = $criteria;

		return $this->collScmCommitFilterProjects;
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this ScmCommitFilter is new, it will return
	 * an empty collection; or if this ScmCommitFilter has previously
	 * been saved, it will retrieve related ScmCommitFilterProjects from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in ScmCommitFilter.
	 */
	public function getScmCommitFilterProjectsJoinProject($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/scm/lib/ScmCommitFilterProjectPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collScmCommitFilterProjects === null) {
			if ($this->isNew()) {
			   $this->collScmCommitFilterProjects = array();
			} else {
	   
				$criteria->add(ScmCommitFilterProjectPeer::SCM_COMMIT_FILTER_ID, $this->getScmCommitFilterId());
				$this->collScmCommitFilterProjects = ScmCommitFilterProjectPeer::doSelectJoinProject($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(ScmCommitFilterProjectPeer::SCM_COMMIT_FILTER_ID, $this->getScmCommitFilterId());
			if (!isset($this->lastScmCommitFilterProjectsCriteria) || !$this->lastScmCommitFilterProjectsCriteria->equals($criteria)) {
				$this->collScmCommitFilterProjects = ScmCommitFilterProjectPeer::doSelectJoinProject($criteria, $con);
			}
		}
		$this->lastScmCommitFilterProjectsCriteria = $criteria;

		return $this->collScmCommitFilterProjects;
	}

	private $fieldNames;

	/**
	 * Generate a list of field names.
	 *
	 * @return array A list of field names
	 */
	public function getFieldNames()
	{
		if ($this->fieldNames === null) {
			$this->fieldNames = array("scm_commit_filter_id", "filter_description", "plugin_id", "filter_string", "filter_type", );
		}
		return $this->fieldNames;
	}
	
	/**
	 * Retrieves a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @return mixed Value of field.
	 */
	public function getByName($name)
	{
		switch($name) {
	  
			case ScmCommitFilterPeer::SCM_COMMIT_FILTER_ID:
				return $this->getScmCommitFilterId();
				break;
		  
			case ScmCommitFilterPeer::FILTER_DESCRIPTION:
				return $this->getFilterDescription();
				break;
		  
			case ScmCommitFilterPeer::PLUGIN_ID:
				return $this->getPluginId();
				break;
		  
			case ScmCommitFilterPeer::FILTER_STRING:
				return $this->getFilterString();
				break;
		  
			case ScmCommitFilterPeer::FILTER_TYPE:
				return $this->getFilterType();
				break;
	  
			default:
				return null;
				
		} // switch()
	}

	/**
	 * Retrieves a field from the object by Position as specified in the xml schema. 
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @return mixed Value of field at $pos
	 */
	public function getByPosition($pos)
	{
		switch($pos) {
  
			case 0:
				return $this->getScmCommitFilterId();
				break;
  
			case 1:
				return $this->getFilterDescription();
				break;
  
			case 2:
				return $this->getPluginId();
				break;
  
			case 3:
				return $this->getFilterString();
				break;
  
			case 4:
				return $this->getFilterType();
				break;
			default:
				return null;
		} // switch()
	}



	
	/**
	 * Convenience method to populate the object using an array.
	 * This is particularly useful when populating an object from one of the request arrays (e.g. $_POST).  This method
	 * goest through the column (peer) names, checking to see whether a matching key exists in populated array. If
	 * so the setByName() method is called for that column.
	 * @param array $arr An array where keys are column names.
	 * @return void
	 */
	public function populateFromArray($arr)
	{
  
		if (array_key_exists(ScmCommitFilterPeer::SCM_COMMIT_FILTER_ID, $arr)) $this->setScmCommitFilterId($arr[ScmCommitFilterPeer::SCM_COMMIT_FILTER_ID]);
  
		if (array_key_exists(ScmCommitFilterPeer::FILTER_DESCRIPTION, $arr)) $this->setFilterDescription($arr[ScmCommitFilterPeer::FILTER_DESCRIPTION]);
  
		if (array_key_exists(ScmCommitFilterPeer::PLUGIN_ID, $arr)) $this->setPluginId($arr[ScmCommitFilterPeer::PLUGIN_ID]);
  
		if (array_key_exists(ScmCommitFilterPeer::FILTER_STRING, $arr)) $this->setFilterString($arr[ScmCommitFilterPeer::FILTER_STRING]);
  
		if (array_key_exists(ScmCommitFilterPeer::FILTER_TYPE, $arr)) $this->setFilterType($arr[ScmCommitFilterPeer::FILTER_TYPE]);
 
	}
	
	/**
	 * Sets a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByName($name, $value)
	{
		switch($name) {
	  
			case ScmCommitFilterPeer::SCM_COMMIT_FILTER_ID:
				$this->setScmCommitFilterId($value);
				break;
	  
			case ScmCommitFilterPeer::FILTER_DESCRIPTION:
				$this->setFilterDescription($value);
				break;
	  
			case ScmCommitFilterPeer::PLUGIN_ID:
				$this->setPluginId($value);
				break;
	  
			case ScmCommitFilterPeer::FILTER_STRING:
				$this->setFilterString($value);
				break;
	  
			case ScmCommitFilterPeer::FILTER_TYPE:
				$this->setFilterType($value);
				break;
				  
		} // switch()
	}

	/**
	 * Sets a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByPosition($pos, $value)
	{
		switch($pos) {
  
			case 0:
				$this->setScmCommitFilterId($value);
				break;
  
			case 1:
				$this->setFilterDescription($value);
				break;
  
			case 2:
				$this->setPluginId($value);
				break;
  
			case 3:
				$this->setFilterString($value);
				break;
  
			case 4:
				$this->setFilterType($value);
				break;
		} // switch()
	}


 
	/**
	 * Removes this object from datastore and sets delete attribute.
	 * 
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 * @see BaseObject::setDeleted()
	 * @see BaseObject::isDeleted()
	 */
	public function delete($con = null)
	{	
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}
		
		if ($con === null)
			$con = Propel::getConnection(ScmCommitFilterPeer::DATABASE_NAME);

		try {
			$con->begin();
			ScmCommitFilterPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
	

	/**
	 * flag to prevent endless save loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	private $alreadyInSave = false;

	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.  This method
	 * wraps the doSave() worker method in a transaction.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
	public function save($con = null)
	{
		if ($this->isDeleted()) {
		//	throw new PropelException("You cannot save an object that has been deleted.");
			return;
		}
		
		if ($con === null)
			$con = Propel::getConnection(ScmCommitFilterPeer::DATABASE_NAME);

		try {
			$con->begin();
			$this->doSave($con);			
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
  
	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
		protected function doSave($con)	{ 
		
	 
		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;

			// We call the save method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.
 
			if ($this->aPlugin !== null) {
				if ($this->aPlugin->isModified()) $this->aPlugin->save($con);
				$this->setPlugin($this->aPlugin);
			}

			// If this object has been modified, then save it to the database.
			if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = ScmCommitFilterPeer::doInsert($this, $con);
					$this->setScmCommitFilterId( $pk );  //[IMV] update autoincrement primary key
					$this->setNew(false);
				} else {
					ScmCommitFilterPeer::doUpdate($this, $con);
				}			
				$this->resetModified(); // [HL] After being saved an object is no longer 'modified'
			}
			if ($this->collScmCommitFilterProjects !== null) {
				for ($i=0,$size=count($this->collScmCommitFilterProjects); $i < $size; $i++) {
					$this->collScmCommitFilterProjects[$i]->save($con);
				}
			  }

			$this->alreadyInSave = false;
		}
	}

	/**
	 * Validates the objects modified field values.
	 * This includes all objects related to this table.
	 *
	 * If $columns is either a column name or an array of column names
	 * only those columns are validated.
	 *
	 * @param mixed $columns Column name or an array of column names.
	 *
	 * @return mixed <code>true</code> if all columns pass validation
	 *			  or an array of <code>ValidationFailed</code> objects for columns that fail.
	 */
	public function validate($columns = null)
	{
	  if ($columns)
	  {
		return ScmCommitFilterPeer::doValidate($this, $columns);
	  }

		return $this->doValidate();
	}

	/**
	 * flag to prevent endless validation loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	protected $alreadyInValidation = false;
  
	/**
	 * This function performs the validation work for complex object models.
	 * 
	 * In addition to checking the current object, all related objects will
	 * also be validated.  If all pass then <code>true</code> is returned; otherwise
	 * an aggreagated array of ValidationFailed objects will be returned.
	 *
	 * @return mixed <code>true</code> if all validations pass; array of <code>ValidationFailed</code> objets otherwise.
	 */
	protected function doValidate()
	{
		if (! $this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;
	  
			$failureMap = array();	  
	  
			// We call the validate method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.
			if ($this->aPlugin !== null) {
				if (($retval = $this->aPlugin->validate()) !== true) {
					$failureMap = array_merge($failureMap, $retval);
				}
			}

			if (($retval = ScmCommitFilterPeer::doValidate($this)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}
	  
			if ($this->collScmCommitFilterProjects !== null) {
				for ($i=0,$size=count($this->collScmCommitFilterProjects); $i < $size; $i++) {
					if (($retval = $this->collScmCommitFilterProjects[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
	  
			$this->alreadyInValidation = false;
		}
	
		return (!empty($failureMap) ? $failureMap : true);
	}
  

	/**
	 * Set the PrimaryKey.
	 *
	 * @param mixed scm_commit_filter_id Primary key.
	 * @return void
	 * @throws PropelException	 */
	public function setPrimaryKey($key) 
	{		
		$this->setScmCommitFilterId($key);
	}
	

	/**
	 * Returns an id that differentiates this object from others
	 * of its class.
	 * @return int 
	 */
	public function getPrimaryKey()
	{

		return $this->getScmCommitFilterId();

	}

	
	/**
	 * Makes a copy of this object that will be inserted as a new row in table when saved.
	 * It creates a new object filling in the simple attributes, but skipping any primary
	 * keys that are defined for the table.
	 *  
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 *  
	 * @return ScmCommitFilter Clone of current object.
	 * @throws PropelException
	 */
	public function copy($deepCopy = false) 
	{
		$copyObj = new ScmCommitFilter();
		$copyObj->setFilterDescription($this->filter_description);
		$copyObj->setPluginId($this->plugin_id);
		$copyObj->setFilterString($this->filter_string);
		$copyObj->setFilterType($this->filter_type);

		if ($deepCopy) {		
			// important: setNew(false) because this affects the behavior of
			// the getter/setter methods for fkey referrer objects.
			$copyObj->setNew(false);

			foreach($this->getScmCommitFilterProjects() as $relObj) {
				$copyObj->addScmCommitFilterProject($relObj->copy());
			}
		} // if ($deepCopy)
		
		$copyObj->setNew(true);
		
		$copyObj->setScmCommitFilterId(NULL); // this is a pkey column, so set to default value

		return $copyObj;
	}
		

	/**
	 * returns a peer instance associated with this om.  Since Peer classes	
	 * are not to have any instance attributes, this method returns the
	 * same instance for all member of this class. The method could therefore
	 * be static, but this would prevent one from overriding the behavior.
	 * @return ScmCommitFilterPeer
	 */
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new ScmCommitFilterPeer();
		}
		return self::$peer;
	}

}
