<?php 

require_once 'propel/om/BaseObject.php';

 
require_once 'propel/om/Persistent.php';

 

include_once 'propel/util/Criteria.php';

include_once 'plugins/scm/lib/ScmServerPeer.php';

/**
 * Base class that represents a row from the 'scm_server' table.
 *
 *  
 *
 * You should not use this class directly.  It should not even be
 * extended; all references should be to ScmServer class. 
 * 
 * @package plugins.scm.lib 
 */
abstract class BaseScmServer extends BaseObject implements Persistent {
	
	/** 
	 * The Peer class.
	 * Instance provides a convenient way of calling static methods on a class
	 * that calling code may not be able to identify.
	 * @var ScmServerPeer
	 */
	protected static $peer;

	/**
	 * The value for the scm_server_id field.
	 * @var int	  
	 */
	protected $scm_server_id;	

	/**
	 * The value for the scm_type field.
	 * @var string	  
	 */
	protected $scm_type;	

	/**
	 * The value for the hostname field.
	 * @var string	  
	 */
	protected $hostname;	
  
	/**
	 * Get the ScmServerId column value.
	 *  
	 * @return int	  
	 */
	public function getScmServerId()
	{
		return $this->scm_server_id;
	}


	/**
	 * Set the value of `scm_server_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setScmServerId($v)
	{
		if ($this->scm_server_id !== $v) {
			$this->scm_server_id = $v;
			$this->modifiedColumns[] = ScmServerPeer::SCM_SERVER_ID;
		}
			
		  // update associated ProjectScm		  
		  if ($this->collProjectScms !== null) {
			  for ($i=0,$size=count($this->collProjectScms); $i < $size; $i++) {
				  $this->collProjectScms[$i]->setScmServerId($v);
			  }
		  }
			  		
	}

  
	/**
	 * Get the ScmType column value.
	 *  
	 * @return string	  
	 */
	public function getScmType()
	{
		return $this->scm_type;
	}


	/**
	 * Set the value of `scm_type` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setScmType($v)
	{
		if ($this->scm_type !== $v) {
			$this->scm_type = $v;
			$this->modifiedColumns[] = ScmServerPeer::SCM_TYPE;
		}
				
	}

  
	/**
	 * Get the Hostname column value.
	 *  
	 * @return string	  
	 */
	public function getHostname()
	{
		return $this->hostname;
	}


	/**
	 * Set the value of `hostname` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setHostname($v)
	{
		if ($this->hostname !== $v) {
			$this->hostname = $v;
			$this->modifiedColumns[] = ScmServerPeer::HOSTNAME;
		}
				
	}


	
	/**
	 * Hydrates (populates) the object variables with values from the database resultset.
	 *
	 * An offset (1-based "start column") is specified so that objects can be hydrated
	 * with a subset of the columns in the resultset rows.  This is needed, for example,
	 * for results of JOIN queries where the resultset row includes columns from two or
	 * more tables.
	 *
	 * @param ResultSet $rs The ResultSet class with cursor advanced to desired record pos.
	 * @param int $startcol 1-based offset column which indicates which restultset column to start with.
	 * @return void
	 * @throws PropelException  - Any caught Exception will be rewrapped as a PropelException.
	 */
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {
			$this->scm_server_id = $rs->getInt($startcol + 0);					
			$this->scm_type = $rs->getString($startcol + 1);					
			$this->hostname = $rs->getString($startcol + 2);					
			 
			$this->resetModified();
			$this->setNew(false);
		
		} catch (Exception $e) {
			throw new PropelException("Error populating ScmServer object", $e);
		}		
	
	}
	
	/**
	 * Builds a Criteria object containing the primary key for this object.
	 *
	 * Unlike buildCriteria() this method includes the primary key values regardless
	 * of whether or not they have been modified.
	 * 
	 * @return Criteria The Criteria object containing value(s) for primary key(s).
	 */
	public function buildPkeyCriteria()
	{		
		$criteria = new Criteria(ScmServerPeer::DATABASE_NAME);
		$criteria->add(ScmServerPeer::SCM_SERVER_ID, $this->scm_server_id);
		return $criteria;			
	}
	
	/**
	 * Build a Criteria object containing the values of all modified columns in this object.
	 *
	 * @return Criteria The Criteria object containing all modified values.
	 */
	public function buildCriteria()
	{		
		$criteria = new Criteria(ScmServerPeer::DATABASE_NAME);
		if ($this->isColumnModified(ScmServerPeer::SCM_SERVER_ID)) $criteria->add(ScmServerPeer::SCM_SERVER_ID, $this->scm_server_id);
		if ($this->isColumnModified(ScmServerPeer::SCM_TYPE)) $criteria->add(ScmServerPeer::SCM_TYPE, $this->scm_type);
		if ($this->isColumnModified(ScmServerPeer::HOSTNAME)) $criteria->add(ScmServerPeer::HOSTNAME, $this->hostname);
		return $criteria;			
	}
	
	

	/**
	 * Collection to store aggregation of collProjectScms	  
	 * @var array
	 */
	protected $collProjectScms; 

	/**
	 * Temporary storage of collProjectScms to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initProjectScms()
	{
		if ($this->collProjectScms === null) {
			$this->collProjectScms = array();
		}
	}

	/**
	 * Method called to associate a ProjectScm object to this object
	 * through the ProjectScm foreign key attribute
	 *
	 * @param ProjectScm $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addProjectScm(ProjectScm $l)
	{
		$this->collProjectScms[] = $l;
		$l->setScmServer($this);
	}

	/**
	 * The criteria used to select the current contents of collProjectScms.
	 * @var Criteria
	 */
	private $lastProjectScmsCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this ScmServer has previously
	 * been saved, it will retrieve related ProjectScms from storage.
	 * If this ScmServer is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getProjectScms($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/scm/lib/ProjectScmPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collProjectScms === null) {
			if ($this->isNew()) {
			   $this->collProjectScms = array();
			} else {
	
				$criteria->add(ProjectScmPeer::SCM_SERVER_ID, $this->getScmServerId() );

				$this->collProjectScms = ProjectScmPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(ProjectScmPeer::SCM_SERVER_ID, $this->getScmServerId());

				if (!isset($this->lastProjectScmsCriteria) || !$this->lastProjectScmsCriteria->equals($criteria)) {
					$this->collProjectScms = ProjectScmPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastProjectScmsCriteria = $criteria;

		return $this->collProjectScms;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this ScmServer is new, it will return
	 * an empty collection; or if this ScmServer has previously
	 * been saved, it will retrieve related ProjectScms from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in ScmServer.
	 */
	public function getProjectScmsJoinProject($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/scm/lib/ProjectScmPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collProjectScms === null) {
			if ($this->isNew()) {
			   $this->collProjectScms = array();
			} else {
	   
				$criteria->add(ProjectScmPeer::SCM_SERVER_ID, $this->getScmServerId());
				$this->collProjectScms = ProjectScmPeer::doSelectJoinProject($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(ProjectScmPeer::SCM_SERVER_ID, $this->getScmServerId());
			if (!isset($this->lastProjectScmsCriteria) || !$this->lastProjectScmsCriteria->equals($criteria)) {
				$this->collProjectScms = ProjectScmPeer::doSelectJoinProject($criteria, $con);
			}
		}
		$this->lastProjectScmsCriteria = $criteria;

		return $this->collProjectScms;
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this ScmServer is new, it will return
	 * an empty collection; or if this ScmServer has previously
	 * been saved, it will retrieve related ProjectScms from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in ScmServer.
	 */
	public function getProjectScmsJoinScmServer($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/scm/lib/ProjectScmPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collProjectScms === null) {
			if ($this->isNew()) {
			   $this->collProjectScms = array();
			} else {
	   
				$criteria->add(ProjectScmPeer::SCM_SERVER_ID, $this->getScmServerId());
				$this->collProjectScms = ProjectScmPeer::doSelectJoinScmServer($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(ProjectScmPeer::SCM_SERVER_ID, $this->getScmServerId());
			if (!isset($this->lastProjectScmsCriteria) || !$this->lastProjectScmsCriteria->equals($criteria)) {
				$this->collProjectScms = ProjectScmPeer::doSelectJoinScmServer($criteria, $con);
			}
		}
		$this->lastProjectScmsCriteria = $criteria;

		return $this->collProjectScms;
	}

	private $fieldNames;

	/**
	 * Generate a list of field names.
	 *
	 * @return array A list of field names
	 */
	public function getFieldNames()
	{
		if ($this->fieldNames === null) {
			$this->fieldNames = array("scm_server_id", "scm_type", "hostname", );
		}
		return $this->fieldNames;
	}
	
	/**
	 * Retrieves a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @return mixed Value of field.
	 */
	public function getByName($name)
	{
		switch($name) {
	  
			case ScmServerPeer::SCM_SERVER_ID:
				return $this->getScmServerId();
				break;
		  
			case ScmServerPeer::SCM_TYPE:
				return $this->getScmType();
				break;
		  
			case ScmServerPeer::HOSTNAME:
				return $this->getHostname();
				break;
	  
			default:
				return null;
				
		} // switch()
	}

	/**
	 * Retrieves a field from the object by Position as specified in the xml schema. 
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @return mixed Value of field at $pos
	 */
	public function getByPosition($pos)
	{
		switch($pos) {
  
			case 0:
				return $this->getScmServerId();
				break;
  
			case 1:
				return $this->getScmType();
				break;
  
			case 2:
				return $this->getHostname();
				break;
			default:
				return null;
		} // switch()
	}



	
	/**
	 * Convenience method to populate the object using an array.
	 * This is particularly useful when populating an object from one of the request arrays (e.g. $_POST).  This method
	 * goest through the column (peer) names, checking to see whether a matching key exists in populated array. If
	 * so the setByName() method is called for that column.
	 * @param array $arr An array where keys are column names.
	 * @return void
	 */
	public function populateFromArray($arr)
	{
  
		if (array_key_exists(ScmServerPeer::SCM_SERVER_ID, $arr)) $this->setScmServerId($arr[ScmServerPeer::SCM_SERVER_ID]);
  
		if (array_key_exists(ScmServerPeer::SCM_TYPE, $arr)) $this->setScmType($arr[ScmServerPeer::SCM_TYPE]);
  
		if (array_key_exists(ScmServerPeer::HOSTNAME, $arr)) $this->setHostname($arr[ScmServerPeer::HOSTNAME]);
 
	}
	
	/**
	 * Sets a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByName($name, $value)
	{
		switch($name) {
	  
			case ScmServerPeer::SCM_SERVER_ID:
				$this->setScmServerId($value);
				break;
	  
			case ScmServerPeer::SCM_TYPE:
				$this->setScmType($value);
				break;
	  
			case ScmServerPeer::HOSTNAME:
				$this->setHostname($value);
				break;
				  
		} // switch()
	}

	/**
	 * Sets a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByPosition($pos, $value)
	{
		switch($pos) {
  
			case 0:
				$this->setScmServerId($value);
				break;
  
			case 1:
				$this->setScmType($value);
				break;
  
			case 2:
				$this->setHostname($value);
				break;
		} // switch()
	}


 
	/**
	 * Removes this object from datastore and sets delete attribute.
	 * 
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 * @see BaseObject::setDeleted()
	 * @see BaseObject::isDeleted()
	 */
	public function delete($con = null)
	{	
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}
		
		if ($con === null)
			$con = Propel::getConnection(ScmServerPeer::DATABASE_NAME);

		try {
			$con->begin();
			ScmServerPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
	

	/**
	 * flag to prevent endless save loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	private $alreadyInSave = false;

	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.  This method
	 * wraps the doSave() worker method in a transaction.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
	public function save($con = null)
	{
		if ($this->isDeleted()) {
		//	throw new PropelException("You cannot save an object that has been deleted.");
			return;
		}
		
		if ($con === null)
			$con = Propel::getConnection(ScmServerPeer::DATABASE_NAME);

		try {
			$con->begin();
			$this->doSave($con);			
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
  
	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
		protected function doSave($con)	{ 
		
	 
		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;

			// If this object has been modified, then save it to the database.
			if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = ScmServerPeer::doInsert($this, $con);
					$this->setScmServerId( $pk );  //[IMV] update autoincrement primary key
					$this->setNew(false);
				} else {
					ScmServerPeer::doUpdate($this, $con);
				}			
				$this->resetModified(); // [HL] After being saved an object is no longer 'modified'
			}
			if ($this->collProjectScms !== null) {
				for ($i=0,$size=count($this->collProjectScms); $i < $size; $i++) {
					$this->collProjectScms[$i]->save($con);
				}
			  }

			$this->alreadyInSave = false;
		}
	}

	/**
	 * Validates the objects modified field values.
	 * This includes all objects related to this table.
	 *
	 * If $columns is either a column name or an array of column names
	 * only those columns are validated.
	 *
	 * @param mixed $columns Column name or an array of column names.
	 *
	 * @return mixed <code>true</code> if all columns pass validation
	 *			  or an array of <code>ValidationFailed</code> objects for columns that fail.
	 */
	public function validate($columns = null)
	{
	  if ($columns)
	  {
		return ScmServerPeer::doValidate($this, $columns);
	  }

		return $this->doValidate();
	}

	/**
	 * flag to prevent endless validation loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	protected $alreadyInValidation = false;
  
	/**
	 * This function performs the validation work for complex object models.
	 * 
	 * In addition to checking the current object, all related objects will
	 * also be validated.  If all pass then <code>true</code> is returned; otherwise
	 * an aggreagated array of ValidationFailed objects will be returned.
	 *
	 * @return mixed <code>true</code> if all validations pass; array of <code>ValidationFailed</code> objets otherwise.
	 */
	protected function doValidate()
	{
		if (! $this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;
	  
			$failureMap = array();	  

			if (($retval = ScmServerPeer::doValidate($this)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}
	  
			if ($this->collProjectScms !== null) {
				for ($i=0,$size=count($this->collProjectScms); $i < $size; $i++) {
					if (($retval = $this->collProjectScms[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
	  
			$this->alreadyInValidation = false;
		}
	
		return (!empty($failureMap) ? $failureMap : true);
	}
  

	/**
	 * Set the PrimaryKey.
	 *
	 * @param mixed scm_server_id Primary key.
	 * @return void
	 * @throws PropelException	 */
	public function setPrimaryKey($key) 
	{		
		$this->setScmServerId($key);
	}
	

	/**
	 * Returns an id that differentiates this object from others
	 * of its class.
	 * @return int 
	 */
	public function getPrimaryKey()
	{

		return $this->getScmServerId();

	}

	
	/**
	 * Makes a copy of this object that will be inserted as a new row in table when saved.
	 * It creates a new object filling in the simple attributes, but skipping any primary
	 * keys that are defined for the table.
	 *  
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 *  
	 * @return ScmServer Clone of current object.
	 * @throws PropelException
	 */
	public function copy($deepCopy = false) 
	{
		$copyObj = new ScmServer();
		$copyObj->setScmType($this->scm_type);
		$copyObj->setHostname($this->hostname);

		if ($deepCopy) {		
			// important: setNew(false) because this affects the behavior of
			// the getter/setter methods for fkey referrer objects.
			$copyObj->setNew(false);

			foreach($this->getProjectScms() as $relObj) {
				$copyObj->addProjectScm($relObj->copy());
			}
		} // if ($deepCopy)
		
		$copyObj->setNew(true);
		
		$copyObj->setScmServerId(NULL); // this is a pkey column, so set to default value

		return $copyObj;
	}
		

	/**
	 * returns a peer instance associated with this om.  Since Peer classes	
	 * are not to have any instance attributes, this method returns the
	 * same instance for all member of this class. The method could therefore
	 * be static, but this would prevent one from overriding the behavior.
	 * @return ScmServerPeer
	 */
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new ScmServerPeer();
		}
		return self::$peer;
	}

}
