<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id: index.php 620 2006-03-23 16:13:34Z tperdue $
 * @author Tim Perdue tim@gforge.org
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

require_once('plugins/scm/lib/ScmUserStats.php');
require_once('plugins/scm/lib/ScmProjectStats.php');

/**
 * This script is included by the specific SCM plugins in order to display statistics
 * about a repository
 */
// $template and $params must be set by the including script
$template->header($params);
$stats = ScmProjectStatsPeer::getProjectStats($project->getProjectId());

$project_scm = ProjectScmPeer::retrieveByPk($project->getProjectId());

if (is_object($project_scm)) {
	$scm_type = strtolower($project_scm->getScmServer()->getScmType());
}

//Notice: this is a temporary "hack" to avoid showing the "adds" column on GIT
$bolShowAdds = isset($bolShowAdds) ? $bolShowAdds : true;
?>

<p><h3><?php echo $lang->getText('ScmStats.GeneralStats.Title', array($project->getProjectName())); ?></h3></p>
<?php if (!is_null($stats)) { ?>
<p>
<?php if (isset($scm_type) && $scm_type != 'svn' && $scm_type != 'git') { ?>
<strong><?php echo $lang->getText('ScmStats.GeneralStats.Checkouts'); ?></strong>: <?php echo $stats['checkouts'] ?><br />
<?php } ?>
<strong><?php echo $lang->getText('ScmStats.GeneralStats.Commits'); ?></strong>: <?php echo $stats['commits'] ?><br />
<?php if ($bolShowAdds) { ?>
<strong><?php echo $lang->getText('ScmStats.GeneralStats.Adds'); ?></strong>: <?php echo $stats['adds'] ?><br />
<?php } ?>
</p>
<?php 
	} else {
		echo "<p>" . $lang->getText('ScmStats.GeneralStats.NoStats') . "</p>";
	}
?>
<p><h3><?php echo $lang->getText('ScmStats.UserStats.Title'); ?></h3></p>
	<?php
		$theader = array();
		$theader[] = $lang->getText('ScmStats.UserStats.Username');
		if ($bolShowAdds) {
			$theader[] = $lang->getText('ScmStats.UserStats.Adds');
		}
		$theader[] = $lang->getText('ScmStats.UserStats.Commits');
		echo $template->tableTop($theader);
		
		$url = GFUrl::getUrl();

		$userstats = ScmUserStatsPeer::retrieveUserStats($project->getProjectId());
		
		if (count($userstats) > 0) {
			foreach ($userstats as $userstat) {
				$user = $userstat['user'];

				$trow = array();
				if ($user->isUndefinedUser()) {
					$trow[] = $lang->getText('ScmStats.UserStats.OtherUsers');
				} else {
					$trow[] = '<a href="'.$url->userURL($user).'">'.$user->getFullName().'</a>';
				}
				
				if ($bolShowAdds) {
					$trow[] = $userstat['adds'];
				}
				$trow[] = $userstat['commits'];
				echo $template->tableRow($trow);
			}
		} else {
			echo $template->tableFullRow($lang->getText('ScmStats.UserStats.NoStats'));
		}
		
		echo $template->tableBottom();
	?>
<?php
$template->footer($params);
?>
