<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code creates a new ScmModule and saves it to the 
// database
//
require_once('plugins/scm/lib/ScmModule.php');
require_once('Validator.php');
require_once('exceptions/InvalidDataException.php');
require_once('exceptions/PermissionDeniedException.php');
require_once('core/Language.php');

$project = GFUrl::getUrl()->getProject();
$Lang = Language::getSessLang();

if ($_SERVER['REQUEST_METHOD'] != 'POST' || !$project->getPermission()->isAdmin()) {
	throw new PermissionDeniedException();
}

try {
	if (!isset($_POST['module']) || empty($_POST['module'])) {
		$errors = array($Lang->getText('CodeSearchModule.EmptyModule', array($CODE_SEARCH_MODULE_NAME)));
		throw new InvalidDataException($errors);
	}
	
	$stmt = Propel::getConnection()->prepareStatement('INSERT INTO code_search_module(project_id,module) VALUES(?,?)');
	$stmt->setInt(1, $project->getProjectId());
	$stmt->setString(2, Validator::sanitizeString($_POST['module']));
	$stmt->executeQuery();

	GFUrl::redirect(GFUrl::getUrl()->currentBaseURL('CodeSearchModuleBrowse'), array('feedback' => $Lang->getText('CodeSearchModule.AddFeedback', array($CODE_SEARCH_MODULE_NAME))));
} catch (InvalidDataException $ex) {
	$errors = $ex->getErrors();		// attach object errors to validation errors
	$feedback = '* '.implode('<br />* ', $errors);
	include('CodeSearchModuleAdd.php');
}
?>
