<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @author	Marcelo Mottalli <marcelo@gforgegroup.com>
 * @version   $Id$
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

$project = GFUrl::getUrl()->getProject();

// Retrieve the objects recordset
$conn = Propel::getConnection();
$stmt = $conn->prepareStatement('SELECT * FROM code_search_module WHERE project_id=?');
$stmt->setInt(1, $project->getProjectId());
$rs = $stmt->executeQuery();

$theader = array();
$theader[] = ucfirst($CODE_SEARCH_MODULE_NAME);
$theader[] = $Lang->getText('Edit');
$theader[] = $Lang->getText('Delete');

?>
<?php
echo $theme->tableTop($theader);

$c = 0;
while ($rs->next()) {
	$c++;

	$trow = array();
	$trow[] = $rs->getString('module');
	$trow[] = '<a href="'. GFUrl::getUrl()->currentBaseUrl('CodeSearchModuleEdit', array('id' => $rs->getInt('code_search_module_id'))).'">'. $Lang->getText('Edit') .'</a>';
	$trow[] = '<a href="'. GFUrl::getUrl()->currentBaseUrl('CodeSearchModuleDelete', array('id' => $rs->getInt('code_search_module_id'))).'">'. $Lang->getText('Delete') .'</a>';

	echo $theme->tableRow($trow);
}

if ($c == 0) {
	echo $theme->tableFullRow('<span class="nonefound">'.$Lang->getText('CodeSearchModule.NoneFound', array(strtolower($CODE_SEARCH_MODULE_NAME_PLURAL))).'</span>');
}

echo $theme->tableBottom(array('<a href="'. GFUrl::getUrl()->currentBaseUrl('CodeSearchModuleAdd').'">'. $Lang->getText('CodeSearchModule.AddNew', array(strtolower($CODE_SEARCH_MODULE_NAME))) .'</a>'));

?>
