<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id$
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code edits a ScmModule and saves it to the 
// database
//
require_once('plugins/scm/lib/ScmModule.php');
require_once('Validator.php');
require_once('exceptions/PermissionDeniedException.php');
require_once('core/Language.php');

if ($_SERVER['REQUEST_METHOD'] != 'POST') {
	throw new PermissionDeniedException();
}

$ScmModule = ScmModulePeer::retrieveByPk($_POST['id']);
if (!is_object($ScmModule) || !$ScmModule->userCanUpdate()) {
	throw new PermissionDeniedException();
}

$Lang = Language::getSessLang();

try {
	$ScmModule->setPath( Validator::sanitizeString($_POST['path']) );
	$ScmModule->save();


	$url = GFUrl::getUrl();
	GFUrl::redirect($url->currentBaseURL('ScmModuleBrowse'), array('feedback' => $Lang->getText('ScmModule.EditFeedback')));
} catch (InvalidDataException $ex) {
	$errors = $ex->getErrors();		// attach object errors to validation errors
	$feedback = '* '.implode('<br />* ', $errors);
	include('ScmModuleEdit.php');
}

?>
