<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id$
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code edits a ScmModule and saves it to the 
// database
//
require_once('plugins/scm/lib/ScmModule.php');
require_once('Validator.php');
require_once('exceptions/PermissionDeniedException.php');
require_once('core/Language.php');
require_once('plugins/scm/lib/ScmModuleUser.php');

if ($_SERVER['REQUEST_METHOD'] != 'POST') {
	throw new PermissionDeniedException();
}

$ScmModule = ScmModulePeer::retrieveByPk($_POST['id']);
if (!is_object($ScmModule) || !$ScmModule->userCanUpdate()) {
	throw new PermissionDeniedException();
}

$Lang = Language::getSessLang();

try {
	
	if (isset($_POST['access']) && is_array($_POST['access'])) {
		foreach ($_POST['access'] as $user_id => $access) {
			$c = new Criteria();
			$c->add(ScmModuleUserPeer::SCM_MODULE_ID, $ScmModule->getScmModuleId());
			$c->add(ScmModuleUserPeer::USER_ID, $user_id);
			$module_user = ScmModuleUserPeer::doSelectOne($c);
			if (is_null($module_user)) {
				$module_user = new ScmModuleUser();
				$module_user->setScmModuleId($ScmModule->getScmModuleId());
				$module_user->setUserId($user_id);
			}
			
			$module_user->setAccess($access);
			$module_user->save();
		}
		if(GFConf::get('system.useDaemon')){
			GFDaemon::notify('DAEMON_MODULE_USER_SAVE', $ScmModule->getProject()->getUnixName());
		}
	}

	$url = GFUrl::getUrl();
	if (isset($_REQUEST['redirect_to'])) {
		// Usually used when linked from viewvc
		GFUrl::redirect($_REQUEST['redirect_to'], array('feedback' => $Lang->getText('ScmModuleUser.EditFeedback')));
	} else {
		GFUrl::redirect($url->currentBaseURL('ScmModuleBrowse'), array('feedback' => $Lang->getText('ScmModuleUser.EditFeedback')));
	}

} catch (InvalidDataException $ex) {
	$errors = $ex->getErrors();		// attach object errors to validation errors
	$feedback = '* '.implode('<br />* ', $errors);
	include('ScmModuleBrowse.php');
}

?>
