<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code edits a ScmServer and saves it to the 
// database
//
require_once('plugins/scm/lib/ScmServer.php');
require_once('Validator.php');
require_once('exceptions/PermissionDeniedException.php');
require_once('core/Language.php');

if ($_SERVER['REQUEST_METHOD'] != 'POST') {
	throw new PermissionDeniedException();
}

$ScmServer = ScmServerPeer::retrieveByPk($_POST['id']);
if (!is_object($ScmServer) || !$ScmServer->userCanUpdate()) {
	throw new PermissionDeniedException();
}

$errors = array();
$Lang = Language::getSessLang();

if (count($errors) == 0) {
	$ScmServer->setHostname( Validator::sanitizeString($_POST['hostname']) );
	$ScmServer->save();
	$url = GFUrl::getUrl();
	GFUrl::redirect($url->currentBaseURL('ScmServerBrowse'), array('feedback' => $Lang->getText('ScmServer.EditFeedback')));
} else {
	$feedback = implode('<br />', $errors);
	include('ScmServerEdit.php');
}

?>