<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id$
 * @author Tim Perdue tim@gforge.org
 * @date 2006-02-27
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

$project = GFUrl::getUrl()->getProject();
$scmplugin = $project->getPluginByName('scm');
if (is_null($scmplugin)) {
	throw new InvalidPluginException('scm');
}

// this retrieves the handler for the selected SCM (CVS, SVN, etc)
$selectedPlugin = $scmplugin->getScmHandler();

if (!is_null($selectedPlugin)) {
	// If the plugin exists, redirect to the plugin page.
	// Otherwise, it means the plugin is not selected, so display selection page

	//@todo	We'll have to change the way this URL is generated once we program
	//support for sub-plugins
	Webutils::redirect(GFUrl::getUrl()->projectURL($project, '', $selectedPlugin->getName()));
}



require_once('html/SiteTemplate.php');

$session = Session::getSession();
$lang = $session->getLanguage();

$template = new SiteTemplate();
$params = array(
		'selectedbottomtab'	=> 'scm',
		'project' => $project
	);
$template->header($params);
?>
<a href="<?php echo GFUrl::getUrl()->projectURL($project, '', 'scm', 'admin'); ?>"><?php echo $lang->getText('Scm.Admin'); ?></a>

<p><h3><?php echo $lang->getText('Scm.AdminTitle'); ?></h3></p>

<p><?php echo $lang->getText('Scm.NotConfigured') ?></p>

<?php
$template->footer($params);
?>
