<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id$
 * @author Tim Perdue tim@gforge.org
 * @date 2006-02-27
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

/**
 * Leonel Corso <leonelcorso@yahoo.com.ar>
 *
 * @version   $Id$
 */
require_once("system/Cronjob.php");
require_once('core/CronHistory.php');
require_once('core/DeletedProjectPeer.php');
require_once('plugins/scmcvs/lib/CVSRepository.php');

class CleanupCronjob extends Cronjob {

	public function __construct() {
		$this->jobname = basename(__FILE__);
		parent::__construct();
	}

	public function run() {
		$c = new Criteria();	
		$c->add(DeletedProjectPeer::ISDELETED, 0);	
		$deletedProjects = DeletedProjectPeer::doSelect($c);
		$cvsroot = GFConf::get('scmcvs.localCVSRoot');

		$deletedRoot = SystemUtils::buildFilePath($cvsroot, '/.deleted');
		if (!is_dir($deletedRoot)) {
			mkdir($deletedRoot);
		}

		$output = array();
		
		foreach ($deletedProjects as $deletedProject){
			$deletedUnixName = $deletedProject->getUnixGroupName();

			$reposPath = SystemUtils::buildFilePath($cvsroot, $deletedUnixName);
			if (!is_dir($reposPath)) {
				// Repository doesn't exist
				continue;
			}

			$deletedPath = SystemUtils::buildFilePath($deletedRoot, '/'.$deletedUnixName);

			SystemUtils::execute('mv -f '.$reposPath.' '.$deletedPath, $output);
			$deletedProject->delete();
		}	

		SystemUtils::execute('chown -h -R root:root '.$deletedRoot, $output);
		SystemUtils::execute('chmod -R o-rwx '.$deletedRoot, $output);
	}
}
$cronjob = new CleanupCronjob();
$cronjob->run();
?>