<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id: index.php 620 2006-03-23 16:13:34Z tperdue $
 * @author Tim Perdue tim@gforge.org
 * @date 2006-02-27
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

require_once('GFUrl.php');
require_once('plugins/scmsvn/lib/html/ScmSVNTemplate.php');
require_once('plugins/scm/lib/RepositoryBrowser.php');
require_once('plugins/scmsvn/lib/SVNRepository.php');

$project = GFUrl::getUrl()->getProject();
$scmplugin = $project->getPluginByName('scmsvn');
if (is_null($scmplugin)) {
	throw new InvalidPluginException('scmsvn');
}

$session = Session::getSession();
$lang = $session->getLanguage();

$template = new ScmSVNTemplate();

$params = array(
	'selectedbottomtab'	=> 'scmsvn',
	'project' => $project,
	'action' => isset($action) ? $action : '',
	'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : ''),
	'title' => $lang->getText('Scm.CommitDetails')
	);

// this shows the page from the generic SCM plugin
include_once('plugins/scm/wwwlib/ScmStats.php');
?>