<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id:
 * @author Federico Tarantini federico@gforgegroup.com
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
require_once('plugins/scm/lib/html/ScmTemplate.php');
require_once('lib/plugin/PluginResult.php');

class ScmVSSTemplate extends ScmTemplate {

	/**
	 * Header - this subclasses header and just passes params and data that is specific
	 * to this template
	 * @param array array of parameters
	 */
	function header($params) {
		$params['selectedbottomtab']='vss';
		$Lang = Session::getSession()->getLanguage();
		if (isset($params['title'])) {
			$params['title']=' '.$Lang->getText('Scmvss.TabString').' > '.$params['title'];
		} else {
			Throw new exception('Missing title in scmvss template');
		}
		
		$this->addBreadCrumb('<a href="'.GFUrl::getUrl()->projectUrl($params['project'],'','scmvss').'">'.$Lang->getText('Scmvss.TabString').'</a>');
		
		return parent::header($params);
	}

	/**
	 *      getPluginNavElements - this overrides parent class and adds its own
	 *      plugin listener
	 *      @return PluginResultSet
	 */
	function getPluginNavElements($params) {
		$prs = parent::getPluginNavElements($params);
		$tprs = ActionManager::Notify('GET_SCMVSS_NAV_ELEMENTS',$params);
		foreach ($tprs as $pr) {
			$prs->addResult($pr);
		}
		return $prs;
	}
	
	/**
	 * This overrides GFTheme::getExtraCSS()
	 */
	function getExtraCSS() {
		return array('/themes/'.$this->getName().'/viewvc.css');
	}

}

?>
