<?php
require_once 'propel/map/MapBuilder.php';
include_once 'creole/CreoleTypes.php';

/**
 * This class adds structure of 'snippet' table to 'gf5' DatabaseMap object.
 *
 * These statically-built map classes are used by Propel to do runtime db structure discovery.
 * For example, the createSelectSql() method checks the type of a given column used in an 
 * ORDER BY clause to know whether it needs to apply SQL to make the ORDER BY case-insensitive 
 * (i.e. if it's a text column type).
 *
 * @see BasePeer
 * @see DatabaseMap
 * @package plugins.snippet.lib.map
 */
class SnippetMapBuilder implements MapBuilder {

    /**
     * The name of this class
     */
    const CLASS_NAME = "plugins.snippet.lib.map.SnippetMapBuilder";
	
    /**
     * The database map.
     */
    private $dbMap = null;

    /**
     * Tells us if this DatabaseMapBuilder is built so that we
     * don't have to re-build it every time.
     *
     * @return true if this DatabaseMapBuilder is built
     */
    public function isBuilt()
    {
        return ($this->dbMap !== null);
    }

    /**
     * Gets the databasemap this map builder built.
     *
     * @return the databasemap
     */
    public function getDatabaseMap()
    {
        return $this->dbMap;
    }

    /**
     * The doBuild() method builds the DatabaseMap
     *
	 * @return void
     * @throws PropelException
     */
    public function doBuild()
    {
		$this->dbMap = Propel::getDatabaseMap("gf5");
		
		$tMap = $this->dbMap->addTable("snippet");
		$tMap->setPhpName("Snippet");
		
         
		$tMap->setUseIdGenerator(true);
		 
						
		 
		$tMap->setPrimaryKeyMethodInfo("snippet_snippet_id_seq");
		 
		
		// Add columns to map
		$tMap->addPrimaryKey("SNIPPET_ID", "SnippetId", "int", CreoleTypes::INTEGER, true);
		$tMap->addColumn("SECTION", "Section", "string", CreoleTypes::VARCHAR, true, 20);
		$tMap->addColumn("REF_ID", "RefId", "int", CreoleTypes::INTEGER, true, null);
		$tMap->addForeignKey("CREATED_BY", "CreatedBy", "int", CreoleTypes::INTEGER, "user" , "USER_ID", true);
		$tMap->addColumn("CREATE_DATE", "CreateDate", "int", CreoleTypes::TIMESTAMP, false, null);
		$tMap->addColumn("SNIPPET_NAME", "SnippetName", "string", CreoleTypes::VARCHAR, false, null);
		$tMap->addColumn("SNIPPET_DESCRIPTION", "SnippetDescription", "string", CreoleTypes::VARCHAR, false, null);
				
    }
}
