<?php 

require_once 'propel/om/BaseObject.php';

 
require_once 'propel/om/Persistent.php';

 

include_once 'propel/util/Criteria.php';
 

// (on-demand) include_once 'core/User.php';
// (on-demand) include_once 'core/UserPeer.php';

include_once 'plugins/snippet/lib/SnippetPeer.php';

/**
 * Base class that represents a row from the 'snippet' table.
 *
 *  
 *
 * You should not use this class directly.  It should not even be
 * extended; all references should be to Snippet class. 
 * 
 * @package plugins.snippet.lib 
 */
abstract class BaseSnippet extends BaseObject implements Persistent {
	
	/** 
	 * The Peer class.
	 * Instance provides a convenient way of calling static methods on a class
	 * that calling code may not be able to identify.
	 * @var SnippetPeer
	 */
	protected static $peer;

	/**
	 * The value for the snippet_id field.
	 * @var int	  
	 */
	protected $snippet_id;	

	/**
	 * The value for the section field.
	 * @var string	  
	 */
	protected $section;	

	/**
	 * The value for the ref_id field.
	 * @var int	  
	 */
	protected $ref_id;	

	/**
	 * The value for the created_by field.
	 * @var int	  
	 */
	protected $created_by;	

	/**
	 * The value for the create_date field.
	 * @var int	  
	 */
	protected $create_date = -1;	

	/**
	 * The value for the snippet_name field.
	 * @var string	  
	 */
	protected $snippet_name;	

	/**
	 * The value for the snippet_description field.
	 * @var string	  
	 */
	protected $snippet_description;	
  
	/**
	 * Get the SnippetId column value.
	 *  
	 * @return int	  
	 */
	public function getSnippetId()
	{
		return $this->snippet_id;
	}


	/**
	 * Set the value of `snippet_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 *  
	 */
	public function setSnippetId($v)
	{
		if ($this->snippet_id !== $v) {
			$this->snippet_id = $v;
			$this->modifiedColumns[] = SnippetPeer::SNIPPET_ID;
		}
				
	}

  
	/**
	 * Get the Section column value.
	 *  
	 * @return string	  
	 */
	public function getSection()
	{
		return $this->section;
	}


	/**
	 * Set the value of `section` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setSection($v)
	{
		if ($this->section !== $v) {
			$this->section = $v;
			$this->modifiedColumns[] = SnippetPeer::SECTION;
		}
				
	}

  
	/**
	 * Get the RefId column value.
	 *  
	 * @return int	  
	 */
	public function getRefId()
	{
		return $this->ref_id;
	}


	/**
	 * Set the value of `ref_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 *  
	 */
	public function setRefId($v)
	{
		if ($this->ref_id !== $v) {
			$this->ref_id = $v;
			$this->modifiedColumns[] = SnippetPeer::REF_ID;
		}
				
	}

  
	/**
	 * Get the CreatedBy column value.
	 *  
	 * @return int	  
	 */
	public function getCreatedBy()
	{
		return $this->created_by;
	}


	/**
	 * Set the value of `created_by` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setCreatedBy($v)
	{
		if ($this->created_by !== $v) {
			$this->created_by = $v;
			$this->modifiedColumns[] = SnippetPeer::CREATED_BY;
		}
			
		if ($this->aUser !== null && $this->aUser->getUserId() !== $v) {
			$this->aUser = null;
		}
			
	}


	/**
	 * Get the [optionally formatted] `create_date` column value.
	 *  
	 * @param string $format The date/time format string (either date()-style or strftime()-style).
	 *							If format is NULL, then the integer unix timestamp will be returned.
	 * @return mixed Formatted date/time value as string or integer unix timestamp (if format is NULL).
	 * @throws PropelException - if unable to convert the date/time to timestamp.
	 */
	public function getCreateDate($format = 'Y-m-d H:i:s')
	{
		if ($this->create_date === null || $this->create_date === '') {
			return null;
		} elseif (!is_int($this->create_date)) {
			// a non-timestamp value was set externally, so we convert it
			$ts = strtotime($this->create_date);
			if ($ts === -1) {
				throw new PropelException("Unable to parse value of create_date as date/time value: " . var_export($this->create_date, true));
			}
		} else {
			$ts = $this->create_date;
		}
		if ($format === null) {
			return $ts;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $ts);
		} else {
			return date($format, $ts);
		}
	}


	/**
	 * Set the value of `create_date` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException - If passed [not-null] date/time is in an invalid format. 
	 */
	public function setCreateDate($v)
	{
		if ($v !== null && !is_int($v)) {
			$ts = strtotime($v);
			if ($ts === -1) {
				throw new PropelException("Unable to parse date/time value for create_date from input: " . var_export($v, true));
			}
		} else {
			$ts = $v;
		}
		if ($this->create_date !== $ts || $ts === -1) {
			$this->create_date = $ts;
			$this->modifiedColumns[] = SnippetPeer::CREATE_DATE;
		}
		
	}

  
	/**
	 * Get the SnippetName column value.
	 *  
	 * @return string	  
	 */
	public function getSnippetName()
	{
		return $this->snippet_name;
	}


	/**
	 * Set the value of `snippet_name` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setSnippetName($v)
	{
		if ($this->snippet_name !== $v) {
			$this->snippet_name = $v;
			$this->modifiedColumns[] = SnippetPeer::SNIPPET_NAME;
		}
				
	}

  
	/**
	 * Get the SnippetDescription column value.
	 *  
	 * @return string	  
	 */
	public function getSnippetDescription()
	{
		return $this->snippet_description;
	}


	/**
	 * Set the value of `snippet_description` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setSnippetDescription($v)
	{
		if ($this->snippet_description !== $v) {
			$this->snippet_description = $v;
			$this->modifiedColumns[] = SnippetPeer::SNIPPET_DESCRIPTION;
		}
				
	}


	
	/**
	 * Hydrates (populates) the object variables with values from the database resultset.
	 *
	 * An offset (1-based "start column") is specified so that objects can be hydrated
	 * with a subset of the columns in the resultset rows.  This is needed, for example,
	 * for results of JOIN queries where the resultset row includes columns from two or
	 * more tables.
	 *
	 * @param ResultSet $rs The ResultSet class with cursor advanced to desired record pos.
	 * @param int $startcol 1-based offset column which indicates which restultset column to start with.
	 * @return void
	 * @throws PropelException  - Any caught Exception will be rewrapped as a PropelException.
	 */
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {
			$this->snippet_id = $rs->getInt($startcol + 0);					
			$this->section = $rs->getString($startcol + 1);					
			$this->ref_id = $rs->getInt($startcol + 2);					
			$this->created_by = $rs->getInt($startcol + 3);					
			$this->create_date = $rs->getTimestamp($startcol + 4, null);
			$this->snippet_name = $rs->getString($startcol + 5);					
			$this->snippet_description = $rs->getString($startcol + 6);					
			 
			$this->resetModified();
			$this->setNew(false);
		
		} catch (Exception $e) {
			throw new PropelException("Error populating Snippet object", $e);
		}		
	
	}
	
	/**
	 * Builds a Criteria object containing the primary key for this object.
	 *
	 * Unlike buildCriteria() this method includes the primary key values regardless
	 * of whether or not they have been modified.
	 * 
	 * @return Criteria The Criteria object containing value(s) for primary key(s).
	 */
	public function buildPkeyCriteria()
	{		
		$criteria = new Criteria(SnippetPeer::DATABASE_NAME);
		$criteria->add(SnippetPeer::SNIPPET_ID, $this->snippet_id);
		return $criteria;			
	}
	
	/**
	 * Build a Criteria object containing the values of all modified columns in this object.
	 *
	 * @return Criteria The Criteria object containing all modified values.
	 */
	public function buildCriteria()
	{		
		$criteria = new Criteria(SnippetPeer::DATABASE_NAME);
		if ($this->isColumnModified(SnippetPeer::SNIPPET_ID)) $criteria->add(SnippetPeer::SNIPPET_ID, $this->snippet_id);
		if ($this->isColumnModified(SnippetPeer::SECTION)) $criteria->add(SnippetPeer::SECTION, $this->section);
		if ($this->isColumnModified(SnippetPeer::REF_ID)) $criteria->add(SnippetPeer::REF_ID, $this->ref_id);
		if ($this->isColumnModified(SnippetPeer::CREATED_BY)) $criteria->add(SnippetPeer::CREATED_BY, $this->created_by);
		if ($this->isColumnModified(SnippetPeer::CREATE_DATE)) $criteria->add(SnippetPeer::CREATE_DATE, $this->create_date);
		if ($this->isColumnModified(SnippetPeer::SNIPPET_NAME)) $criteria->add(SnippetPeer::SNIPPET_NAME, $this->snippet_name);
		if ($this->isColumnModified(SnippetPeer::SNIPPET_DESCRIPTION)) $criteria->add(SnippetPeer::SNIPPET_DESCRIPTION, $this->snippet_description);
		return $criteria;			
	}
	
	

	/**
	 * @var User	  
	 */
	protected $aUser;

	/**
	 * Declares an association between this object and a User object
	 *
	 * @param User $v
	 * @return void
	 * @throws PropelException
	 */
	public function setUser($v)
	{
			
		if ($v === null) {
			$this->setCreatedBy(NULL);
		} else {
			$this->setCreatedBy($v->getUserId());
		}
   
		$this->aUser = $v;
	}


	/**
	 * Get the associated User object
	 *
	 * @param Connection Optional Connection object.
	 * @return User The associated User object.
	 * @throws PropelException
	 */
	public function getUser($con = null)
	{
		// include the Peer class
		include_once 'core/UserPeer.php';

		if ($this->aUser === null && ($this->created_by !== null)) {
	
			$this->aUser = UserPeer::retrieveByPK($this->created_by, $con);
	
			/* The following can be used instead of the line above to
			   guarantee the related object contains a reference
			   to this object, but this level of coupling
			   may be undesirable in many circumstances.
			   As it can lead to a db query with many results that may
			   never be used.
			   $obj = UserPeer::retrieveByPK($this->created_by, $con);
			   $obj->addSnippets($this);
			 */
		}
		return $this->aUser;
	}

	/**
	 * Provides convenient way to set a relationship based on a
	 * key.  e.g.
	 * <code>$bar->setFooKey($foo->getPrimaryKey())</code>
	 *
 
	 * @return void
	 * @throws PropelException
	 */
	public function setUserKey($key)
	{

		$this->setCreatedBy( (int) $key);			
		
	}

	private $fieldNames;

	/**
	 * Generate a list of field names.
	 *
	 * @return array A list of field names
	 */
	public function getFieldNames()
	{
		if ($this->fieldNames === null) {
			$this->fieldNames = array("snippet_id", "section", "ref_id", "created_by", "create_date", "snippet_name", "snippet_description", );
		}
		return $this->fieldNames;
	}
	
	/**
	 * Retrieves a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @return mixed Value of field.
	 */
	public function getByName($name)
	{
		switch($name) {
	  
			case SnippetPeer::SNIPPET_ID:
				return $this->getSnippetId();
				break;
		  
			case SnippetPeer::SECTION:
				return $this->getSection();
				break;
		  
			case SnippetPeer::REF_ID:
				return $this->getRefId();
				break;
		  
			case SnippetPeer::CREATED_BY:
				return $this->getCreatedBy();
				break;
		  
			case SnippetPeer::CREATE_DATE:
				return $this->getCreateDate();
				break;
		  
			case SnippetPeer::SNIPPET_NAME:
				return $this->getSnippetName();
				break;
		  
			case SnippetPeer::SNIPPET_DESCRIPTION:
				return $this->getSnippetDescription();
				break;
	  
			default:
				return null;
				
		} // switch()
	}

	/**
	 * Retrieves a field from the object by Position as specified in the xml schema. 
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @return mixed Value of field at $pos
	 */
	public function getByPosition($pos)
	{
		switch($pos) {
  
			case 0:
				return $this->getSnippetId();
				break;
  
			case 1:
				return $this->getSection();
				break;
  
			case 2:
				return $this->getRefId();
				break;
  
			case 3:
				return $this->getCreatedBy();
				break;
  
			case 4:
				return $this->getCreateDate();
				break;
  
			case 5:
				return $this->getSnippetName();
				break;
  
			case 6:
				return $this->getSnippetDescription();
				break;
			default:
				return null;
		} // switch()
	}



	
	/**
	 * Convenience method to populate the object using an array.
	 * This is particularly useful when populating an object from one of the request arrays (e.g. $_POST).  This method
	 * goest through the column (peer) names, checking to see whether a matching key exists in populated array. If
	 * so the setByName() method is called for that column.
	 * @param array $arr An array where keys are column names.
	 * @return void
	 */
	public function populateFromArray($arr)
	{
  
		if (array_key_exists(SnippetPeer::SNIPPET_ID, $arr)) $this->setSnippetId($arr[SnippetPeer::SNIPPET_ID]);
  
		if (array_key_exists(SnippetPeer::SECTION, $arr)) $this->setSection($arr[SnippetPeer::SECTION]);
  
		if (array_key_exists(SnippetPeer::REF_ID, $arr)) $this->setRefId($arr[SnippetPeer::REF_ID]);
  
		if (array_key_exists(SnippetPeer::CREATED_BY, $arr)) $this->setCreatedBy($arr[SnippetPeer::CREATED_BY]);
  
		if (array_key_exists(SnippetPeer::CREATE_DATE, $arr)) $this->setCreateDate($arr[SnippetPeer::CREATE_DATE]);
  
		if (array_key_exists(SnippetPeer::SNIPPET_NAME, $arr)) $this->setSnippetName($arr[SnippetPeer::SNIPPET_NAME]);
  
		if (array_key_exists(SnippetPeer::SNIPPET_DESCRIPTION, $arr)) $this->setSnippetDescription($arr[SnippetPeer::SNIPPET_DESCRIPTION]);
 
	}
	
	/**
	 * Sets a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByName($name, $value)
	{
		switch($name) {
	  
			case SnippetPeer::SNIPPET_ID:
				$this->setSnippetId($value);
				break;
	  
			case SnippetPeer::SECTION:
				$this->setSection($value);
				break;
	  
			case SnippetPeer::REF_ID:
				$this->setRefId($value);
				break;
	  
			case SnippetPeer::CREATED_BY:
				$this->setCreatedBy($value);
				break;
	  
			case SnippetPeer::CREATE_DATE:
				$this->setCreateDate($value);
				break;
	  
			case SnippetPeer::SNIPPET_NAME:
				$this->setSnippetName($value);
				break;
	  
			case SnippetPeer::SNIPPET_DESCRIPTION:
				$this->setSnippetDescription($value);
				break;
				  
		} // switch()
	}

	/**
	 * Sets a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByPosition($pos, $value)
	{
		switch($pos) {
  
			case 0:
				$this->setSnippetId($value);
				break;
  
			case 1:
				$this->setSection($value);
				break;
  
			case 2:
				$this->setRefId($value);
				break;
  
			case 3:
				$this->setCreatedBy($value);
				break;
  
			case 4:
				$this->setCreateDate($value);
				break;
  
			case 5:
				$this->setSnippetName($value);
				break;
  
			case 6:
				$this->setSnippetDescription($value);
				break;
		} // switch()
	}


 
	/**
	 * Removes this object from datastore and sets delete attribute.
	 * 
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 * @see BaseObject::setDeleted()
	 * @see BaseObject::isDeleted()
	 */
	public function delete($con = null)
	{	
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}
		
		if ($con === null)
			$con = Propel::getConnection(SnippetPeer::DATABASE_NAME);

		try {
			$con->begin();
			SnippetPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
	

	/**
	 * flag to prevent endless save loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	private $alreadyInSave = false;

	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.  This method
	 * wraps the doSave() worker method in a transaction.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
	public function save($con = null)
	{
		if ($this->isDeleted()) {
		//	throw new PropelException("You cannot save an object that has been deleted.");
			return;
		}
		
		if ($con === null)
			$con = Propel::getConnection(SnippetPeer::DATABASE_NAME);

		try {
			$con->begin();
			$this->doSave($con);			
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
  
	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
		protected function doSave($con)	{ 
		
	 
		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;

			// We call the save method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.
 
			if ($this->aUser !== null) {
				if ($this->aUser->isModified()) $this->aUser->save($con);
				$this->setUser($this->aUser);
			}

			// If this object has been modified, then save it to the database.
			if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = SnippetPeer::doInsert($this, $con);
					$this->setSnippetId( $pk );  //[IMV] update autoincrement primary key
					$this->setNew(false);
				} else {
					SnippetPeer::doUpdate($this, $con);
				}			
				$this->resetModified(); // [HL] After being saved an object is no longer 'modified'
			}

			$this->alreadyInSave = false;
		}
	}

	/**
	 * Validates the objects modified field values.
	 * This includes all objects related to this table.
	 *
	 * If $columns is either a column name or an array of column names
	 * only those columns are validated.
	 *
	 * @param mixed $columns Column name or an array of column names.
	 *
	 * @return mixed <code>true</code> if all columns pass validation
	 *			  or an array of <code>ValidationFailed</code> objects for columns that fail.
	 */
	public function validate($columns = null)
	{
	  if ($columns)
	  {
		return SnippetPeer::doValidate($this, $columns);
	  }

		return $this->doValidate();
	}

	/**
	 * flag to prevent endless validation loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	protected $alreadyInValidation = false;
  
	/**
	 * This function performs the validation work for complex object models.
	 * 
	 * In addition to checking the current object, all related objects will
	 * also be validated.  If all pass then <code>true</code> is returned; otherwise
	 * an aggreagated array of ValidationFailed objects will be returned.
	 *
	 * @return mixed <code>true</code> if all validations pass; array of <code>ValidationFailed</code> objets otherwise.
	 */
	protected function doValidate()
	{
		if (! $this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;
	  
			$failureMap = array();	  
	  
			// We call the validate method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.
			if ($this->aUser !== null) {
				if (($retval = $this->aUser->validate()) !== true) {
					$failureMap = array_merge($failureMap, $retval);
				}
			}

			if (($retval = SnippetPeer::doValidate($this)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}
	  
	  
			$this->alreadyInValidation = false;
		}
	
		return (!empty($failureMap) ? $failureMap : true);
	}
  

	/**
	 * Set the PrimaryKey.
	 *
	 * @param mixed snippet_id Primary key.
	 * @return void
	 * @throws PropelException	 */
	public function setPrimaryKey($key) 
	{		
		$this->setSnippetId($key);
	}
	

	/**
	 * Returns an id that differentiates this object from others
	 * of its class.
	 * @return int 
	 */
	public function getPrimaryKey()
	{

		return $this->getSnippetId();

	}

	
	/**
	 * Makes a copy of this object that will be inserted as a new row in table when saved.
	 * It creates a new object filling in the simple attributes, but skipping any primary
	 * keys that are defined for the table.
	 *  
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 *  
	 * @return Snippet Clone of current object.
	 * @throws PropelException
	 */
	public function copy($deepCopy = false) 
	{
		$copyObj = new Snippet();
		$copyObj->setSection($this->section);
		$copyObj->setRefId($this->ref_id);
		$copyObj->setCreatedBy($this->created_by);
		$copyObj->setCreateDate($this->create_date);
		$copyObj->setSnippetName($this->snippet_name);
		$copyObj->setSnippetDescription($this->snippet_description);
		
		$copyObj->setNew(true);
		
		$copyObj->setSnippetId(NULL); // this is a pkey column, so set to default value

		return $copyObj;
	}
		

	/**
	 * returns a peer instance associated with this om.  Since Peer classes	
	 * are not to have any instance attributes, this method returns the
	 * same instance for all member of this class. The method could therefore
	 * be static, but this would prevent one from overriding the behavior.
	 * @return SnippetPeer
	 */
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new SnippetPeer();
		}
		return self::$peer;
	}

}
