<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
//
require_once('plugins/snippet/lib/SnippetPeer.php');
require_once('plugins/snippet/lib/Snippet.php');
require_once('lib/core/FilesystemPeer.php');
require_once('exceptions/PermissionDeniedException.php');

$session = Session::getSession();
$Lang = $session->getLanguage();

require_once('plugins/snippet/lib/html/SnippetTemplate.php');
$theme = new SnippetTemplate();

//$Project = GFUrl::getUrl()->getProject();
//$News = $NewsPeer::retrieveByPk($_GET['id']);

$params = array(
		'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : ''),
		'action' => isset($action) ? $action : '',
		'title' => $Lang->getText('Snippet.BrowsePageTitle')
		);
		
if (array_key_exists('id',$_REQUEST)) {
	$snippet_id = Validator::sanitizeInt($_REQUEST['id']);
} else {
	$snippet_id = null;
}

// Retrieve the objects array
$c = new Criteria();
$c->add(SnippetPeer::SNIPPET_ID,$snippet_id);
$snippet = SnippetPeer::doSelectOne($c);

if (!is_object($snippet) || is_null($snippet)) {
	echo '<span class="nonefound">'.$Lang->getText('Snippet.NoneFound').'</span>';
} else {
	// retrieve the trove data for this item
	$trove_licenses_obj = TroveLinkPeer::getSelectedRootCategoryValues('snippet', $snippet->getSnippetId(), GFConf::get('system.troveLicense'));
	$trove_programming_languages_obj = TroveLinkPeer::getSelectedRootCategoryValues('snippet', $snippet->getSnippetId(), GFConf::get('system.troveProgrammingLanguage'));
	$trove_topics_obj = TroveLinkPeer::getSelectedRootCategoryValues('snippet', $snippet->getSnippetId(), GFConf::get('system.troveTopic'));
	
	$trove_licenses = array();
	foreach ($trove_licenses_obj as $trove_obj) {
		$trove_licenses[] = $trove_obj->getCategoryName();
	}
	
	$trove_programming_languages = array();
	foreach ($trove_programming_languages_obj as $trove_obj) {
		$trove_programming_languages[] = $trove_obj->getCategoryName();
	}

	$trove_topics = array();
	foreach ($trove_topics_obj as $trove_obj) {
		$trove_topics[] = $trove_obj->getCategoryName();
	}

	require_once('forms/SnippetBrowse-tpl.php');
}


?>