<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code shows a form for editing Snippet
//
require_once('plugins/snippet/lib/SnippetPeer.php');
require_once('plugins/snippet/lib/Snippet.php');
require_once('exceptions/PermissionDeniedException.php');

$session = Session::getSession();
$Lang = $session->getLanguage();

require_once('plugins/snippet/lib/html/SnippetTemplate.php');
require_once('html/TroveRenderer.php');
require_once('html/HTMLWidget.php');
$theme = new SnippetTemplate();

$c = new Criteria();
$c->add(SnippetPeer::SNIPPET_ID,$_REQUEST['snippet_id']);
$Snippet = SnippetPeer::doSelectOne($c);
if (!is_object($Snippet) || !$Snippet->userCanUpdate()) {
	throw new PermissionDeniedException();
}
$obj = $Snippet;

$params = array(
		'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : ''),
		'action' => isset($action) ? $action : '',
		'title' => $Lang->getText('Snippet.EditPageTitle')
		);

$name = ( (isset($_POST) && isset($_POST['name'])) ? htmlspecialchars($_POST['name']) : $obj->getSnippetName() );
$description = ( (isset($_POST) && isset($_POST['description'])) ? htmlspecialchars($_POST['description']) : $obj->getSnippetDescription() );


include ('forms/SnippetEdit-tpl.php');

?>