<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id$
 * @author Tim Perdue tim@gforge.org
 * @date 2006-02-27
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

echo $theme->header($params);
$user = $snippet->getUser();
?>

<p><h3><?php echo $Lang->getText('Snippet.BrowsePageTitle') ?></h3></p>
	
<strong><?php echo $snippet->getSnippetName(); ?></strong>

<table border="0" width="100%">
	<tr>
		<td>
			<strong><?php echo $Lang->getText('Trove.License') ?></strong><br />
			<?php echo implode(', ', $trove_licenses); ?>
		</td>
		<td>
			<strong><?php echo $Lang->getText('Trove.ProgrammingLanguage') ?></strong><br />
			<?php echo implode(', ', $trove_programming_languages); ?>
		</td>
	</tr>
	<tr>
		<td>
			<strong><?php echo $Lang->getText('Trove.Topic') ?></strong><br />
			<?php echo implode(', ', $trove_topics); ?>
		</td>
		<td>&nbsp;</td>
	</tr>
</table>

<br />
<p><h3><?php echo $Lang->getText('Snippet.DescriptionName') ?>:</h3></p>
<?php echo nl2br($snippet->getSnippetDescription()); ?>

<br />
<p><h3><?php echo $Lang->getText('Snippet.Files') ?>:</h3></p>
<?php
	$theader = array();

	$theader[] = $Lang->getText('Snippet.File');
	$theader[] = $Lang->getText('Snippet.FileSize');

	// get the files
	$c = new Criteria();
	$c->add(FilesystemPeer::SECTION,Snippet::SECTION);
	$c->add(FilesystemPeer::REF_ID,$snippet->getSnippetId());
	$fsos = FilesystemPeer::doSelect($c);
	
	if (count($fsos)>0) {
		echo $theme->tableTop($theader);
		
		foreach ($fsos as $item) {
			$trow = array();
			$trow[] = '<a href="'.GFUrl::getURL()->downloadURL(Snippet::SECTION,$snippet->getSnippetId(),$item->getPrimaryKey(),$item->getFileNameSafe()).'">'.$item->getFileName().'</a>';
			$trow[] = SystemUtils::getReadableSize($item->getFileSize());
			echo $theme->tableRow($trow);
		}
	
		echo $theme->tableBottom();
	} else {
		echo Language::getSessText('Snippet.NoFiles');
	}

?>
<br />
<?php echo $Lang->getText('Snippet.SubmittedBy', array($user->getUserLink(), $snippet->getCreateDate())) ?>

<?php
echo $theme->footer($params);
?>
