<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id$
 * @author Tim Perdue tim@gforge.org
 * @date 2005-11-11
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
require_once 'plugins/tracker/lib/om/BaseTrackerItemAssignee.php';
require_once("plugin/ActionManager.php");
require_once('core/AuditTrail.php');
require_once('core/UserPeer.php');
require_once('plugins/tracker/lib/TrackerItem.php');

/** 
 * The skeleton for this class was autogenerated by Propel  on:
 *
 * [Wed Nov 16 20:42:33 2005]
 *
 * You should add additional methods to this class to meet the
 * application requirements.  This class will only be generated as
 * long as it does not already exist in the output directory.
 *
 * @package plugins.tracker.lib 
 */
class TrackerItemAssignee extends BaseTrackerItemAssignee {
	
	
	/**
	 * Removes this object from datastore and sets delete attribute. Informs the plugin manager.
	 * This method was added by propel_customizer.php.
	 * 
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 * @see TrackerItemAssignee::setDeleted()
	 * @see TrackerItemAssignee::isDeleted()
	 */
	function delete($con = null) {
		if (!$this->getTrackerItem()->userCanUpdate()) {
			throw new PermissionDeniedException();
		}
/*
		if (!$this->isNew()) { // maybe we deleted an object without storing it first, we wont audit that
			// we are just auditing the assignee change
			$user_id = $this->getTrackerItem()->getUser()->getUserId();
			$section = TrackerItem::SECTION;
			$ref_id = $this->getTrackerItemId();
			$field_name = substr(strtolower(substr(TrackerItemAssigneePeer::ASSIGNEE,strlen(TrackerItemAssigneePeer::TABLE_NAME)+1)),0,20); // since were getting things like Tablename.field_name, we just want to store the field name
			$new_value = null;
			$old_user = UserPeer::retrieveByPk($this->getByName(TrackerItemAssigneePeer::ASSIGNEE));
			$old_value = $old_user->getFirstname() . " " . $old_user->getLastname();
			$Audit = new AuditTrail();
			// set the audit object and save it to DB
			$Audit->setOldValue($old_value);
			$Audit->setNewValue($new_value);
			$Audit->setRefId($ref_id);
			$Audit->setSection($section);
			$Audit->setUserId($user_id);
			$Audit->setFieldName($field_name);
			$Audit->save();
		}
*/
		ActionManager::notify("TRACKER_ITEM_ASSIGNEE_DELETE", $this);
		parent::delete($con);		
	}

	/**
	 * Stores the object in the database using the Propel methods. Informs the plugin manager.
	 * This method was added by propel_customizer.php.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
	function save($con = null) {
	/*	if ($this->getTrackerItem()->isNew()) {
			if (!$this->getTrackerItem()->userCanCreate()) {
				throw new PermissionDeniedException();
			}
		} else {
			if (!$this->getTrackerItem()->userCanUpdate()) {
				throw new PermissionDeniedException();
			}
		}
		//  only audit on new objects (we wont be updating this object but deleting/creating new one)

		if ( (!$this->getTrackerItem()->isNew()) && ($this->isNew())) { // only audit if the objects Tracker Item is not new (adding new assigned user)
			// we are just auditing the assignee change
			$user_id = $this->getTrackerItem()->getUser()->getUserId();
			$section = TrackerItem::SECTION;
			$ref_id = $this->getTrackerItemId();
			$field_name = substr(strtolower(substr(TrackerItemAssigneePeer::ASSIGNEE,strlen(TrackerItemAssigneePeer::TABLE_NAME)+1)),0,20); // since were getting things like Tablename.field_name, we just want to store the field name
			$old_value = null;
			$new_user = UserPeer::retrieveByPk($this->getByName(TrackerItemAssigneePeer::ASSIGNEE));
			$new_value = $new_user->getFirstname() . " " . $new_user->getLastname();
			$Audit = new AuditTrail();
			// set the audit object and save it to DB
			$Audit->setOldValue($old_value);
			$Audit->setNewValue($new_value);
			$Audit->setRefId($ref_id);
			$Audit->setSection($section);
			$Audit->setUserId($user_id);
			$Audit->setFieldName($field_name);
			$Audit->save();
		}
*/		parent::save($con);
		ActionManager::notify("TRACKER_ITEM_ASSIGNEE_SAVE", $this);
	}
	
}
?>
