<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id$
 * @author Tim Perdue tim@gforge.org
 * @date 2005-11-11
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
// The parent class
require_once 'plugins/tracker/lib/om/BaseTrackerItemPeer.php';

// The object class
include_once 'plugins/tracker/lib/TrackerItem.php';
include_once 'plugins/tracker/lib/TrackerItemTime.php';

/** 
 * The skeleton for this class was autogenerated by Propel on:
 *
 * [Wed Nov 16 20:42:33 2005]
 *
 *  You should add additional methods to this class to meet the
 *  application requirements.  This class will only be generated as
 *  long as it does not already exist in the output directory.
 *
 * @package plugins.tracker.lib 
 */
class TrackerItemPeer extends BaseTrackerItemPeer {
	private static $_pkCache = array();

	/**
	 * Retrieve a single object by pkey or NULL if not found.
	 * This method was added by propel_customizer.php.
	 *
	 * @param	mixed $pk	The primary key
	 * @param	bool $useCache	Whether to use caching. This will increase performance if the same object
	 *							is accessed several times
	 * @param	Connection $con	The connection to use
	 * @return	TrackerItem
	 */
	public static function retrieveByPk($pk, $useCache = true, $con = null) {
		if ($useCache && array_key_exists($pk, TrackerItemPeer::$_pkCache)) {
			return TrackerItemPeer::$_pkCache[$pk];
		}
		
		$object = parent::retrieveByPk($pk, $con);
		if ($useCache) {
			TrackerItemPeer::$_pkCache[$pk] = $object;
		}
		return $object;
	}
	
	/**
	 * Removes an object from the cache. This is usually done after saving.
	 * This method was added by propel_customizer.php.
	 *
	 * @param	mixed $pk	The primary key of the object to remove
	 */
	public static function invalidate($pk) {
		if (array_key_exists($pk, TrackerItemPeer::$_pkCache)) {
			unset(TrackerItemPeer::$_pkCache[$pk]);
		}
	}


	public static function changeTiStatus($tid, $status) {
		$tracker_item = TrackerItemPeer::retrieveByPk($tid);
		$user = Session::getSession()->getUser();

		if (is_object($tracker_item) && ($tracker_item->userCanUpdate() || $user->getUserId() == User::UNDEFINED_USER_ID)) {
			$status_obj = $tracker_item->getTracker()->getStatusByAlias($status);

			if (!is_object($status_obj)) {
				return false;
			}

			try {
				$tracker_item->updateExtraFields(array($status_obj->getTrackerExtraField()->getTrackerExtraFieldId()=>$status_obj->getElementId()));
				$tracker_item->save();
				return true;
			} catch(Exception $e) {
				return false;
			}
		}
		return false;
	}


	public static function createTimeEntry($tid, $time) {
		$tracker_item = TrackerItemPeer::retrieveByPk($tid);

		if (is_object($tracker_item) && $tracker_item->userCanUpdate()) {
			//Get time entry categories
			$c = new Criteria();
			$c->addAscendingOrderByColumn(TrackerTimeCodePeer::TRACKER_TIME_CODE_ID);
			$tracker_time_codes = TrackerTimeCodePeer::doSelect($c);
			if (count($tracker_time_codes) > 0) {
				$tracker_time_code = $tracker_time_codes[0];
				$tracker_time_code_id = $tracker_time_code->getTrackerTimeCodeId();

				$tit = new TrackerItemTime();
				$tit->setTrackerItemId($tracker_item->getTrackerItemId());
				$tit->setHours(floatval($time));
				$tit->setUser(Session::getSession()->getUser());
				$tit->setTrackerTimeCodeId($tracker_time_code_id);
				$tit->save();
			}
		}
	}


	public static function updateLastModified($tid, $user_id) {
		$tracker_item = TrackerItemPeer::retrieveByPk($tid);
		if ($user_id == 0) {
			$user = Session::getSession()->getUser();
		} else {
			$user = UserPeer::retrieveByPk($user_id);
		}

		if (is_object($tracker_item) && is_object($user)) {
			$tracker_item->setLastModifiedDate(time());
			$tracker_item->setLastModifiedBy($user_id);
			$tracker_item->save();
		}
	}
}
?>