<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id$
 * @author Tim Perdue tim@gforge.org
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
require_once('plugins/tracker/lib/html/TrackerTemplate.php');
require_once('lib/plugin/PluginResult.php');

class TrackerAdminTemplate extends TrackerTemplate {

	/**
	 * Header - this subclasses header and just passes params and data that is specific
	 * to this template
	 * @param array array of parameters
	 */
	function header($params) { 
		$params['selectedbottomtab']='tracker';
		//hack - pass this into the TrackerTemplate where it will suppress one of the breadcrumbs
		$params['istrackeradmin']='istrackeradmin';
		$Lang = Session::getSession()->getLanguage();
					
		if (!$params['tracker']->userIsAdmin()) {
			Throw new PermissionDeniedException();
		}

		$params['title']=$Lang->getText('Tabs.Admin').' > '.$params['title'];
		
		$this->addBreadCrumb('<a href="'.GFUrl::getUrl()->projectUrl($params['project'],'','tracker','admin',array('tracker_id'=>$params['tracker']->getTrackerId(),'action'=>'TrackerEdit')).'">'.$params['tracker']->getTrackerName().'</a>');
		$this->addBreadCrumb('<a href="'.GFUrl::getUrl()->projectUrl($params['project'],'','tracker','admin').'">'.$Lang->getText('Tabs.Admin').'</a>');
		return parent::header($params);
	}

	/**
	 *	getPluginNavElements - this overrides parent class and adds its own 
	 *	plugin listener
	 *	@return	PluginResultSet
	 */
	function getPluginNavElements($params) {
		$prs = parent::getPluginNavElements($params);
	       	$tprs = ActionManager::Notify('GET_TRACKER_NAV_ELEMENTS',$params);
		foreach ($tprs as $pr) {
			$prs->addResult($pr);
		}
		return $prs;
	}

	/**
	 * getTemplateNavElements - this function can be overridden
	 * by subclasses so you can add navigation entries
	 * @return array - complex array of data.
	 * /
	function getTemplateNavElements($params) {
		$pine = $this->getPluginNavElements($params);
		$ret = array();
		foreach ($pine as $result) {
			$ret[]=$result->getResult();
		}
		if (isset($params['tracker']) && is_object($params['tracker'])) {
			$trk = $params['tracker'];
			if (!isset($params['project'])) {
echo 'missing project param';
			}
			$ret[] = array(
				'title'=>$trk->getTrackerName(). ' Admin',
				'elements'=> array(
				array('link'=>'/gf/project/'.$params['project']->getUnixName().'/tracker/admin/?tracker_id='.$trk->getTrackerId(),
					'description'=>'Trackers'),
				array('link'=>'/gf/project/'.$params['project']->getUnixName().'/tracker/admin/?action=TrackerItemAdd&amp;tracker_id='.$trk->getTrackerId(),
					'description'=>'Submit')
					)
				);
		}
		return $ret;
	}
	*/
}

?>
