<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id$
 * @author Federico Tarantini federico@gforgegroup.com 
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
require_once('lib/html/ProjectTemplate.php');
require_once('lib/plugin/PluginResult.php');

class TrackerSprintTemplate extends ProjectTemplate {

        /**
         * Header - this subclasses header and just passes params and data that is specific
         * to this template
         * @param array array of parameters
         */
        function header($params) {
                $Lang = Session::getSession()->getLanguage();
                if (isset($params['title'])) {
                        $params['title']=' '.$Lang->getText('TrackerSprint.TabString').' > '.$params['title'];
                } else {
                        Throw new exception('Missing title in trackersprint template');
                }
                $this->addBreadCrumb('<a href="'.GFUrl::getUrl()->currentBaseURL('TrackerSprintBrowse').'">'.$Lang->getText('TrackerSprint.TabString').'</a>');
                return parent::header($params);
        }

        /**
         *      getPluginNavElements - this overrides parent class and adds its own
         *      plugin listener
         *      @return PluginResultSet
         */
        function getPluginNavElements($params) {
                $prs = parent::getPluginNavElements($params);
                $tprs = ActionManager::Notify('GET_NAV_ELEMENTS',$params);
                foreach ($tprs as $pr) {
                        $prs->addResult($pr);
                }
                return $prs;
        }

        /**
         * getTemplateNavElements - this function can be overridden
         * by subclasses so you can add navigation entries
         * @return array - complex array of data.
         */
        function getTemplateNavElements($params) {
                $url = GFurl::getUrl();
                $lang = Session::getSession()->getLanguage();
                $user = Session::getSession()->getUser();
                $loggedin = Session::getSession()->isLoggedIn();
                $project = $params['project'];

                $pine = $this->getPluginNavElements($params);
                $ret = array();
                foreach ($pine as $result) {
                        $ret[]=$result->getResult();
                }
                
                $elements = array();
                $elements[] = array('link'=>'/gf/project/'.$params['project']->getUnixName().'/tracker/?action=TrackerSprintAdd',
                        'description'=> $lang->getText('TrackerItem.AddNew'));
                return $ret;
        }


}

?>
