<?php
require_once 'propel/map/MapBuilder.php';
include_once 'creole/CreoleTypes.php';

/**
 * This class adds structure of 'tracker_extra_field_element' table to 'gf5' DatabaseMap object.
 *
 * These statically-built map classes are used by Propel to do runtime db structure discovery.
 * For example, the createSelectSql() method checks the type of a given column used in an 
 * ORDER BY clause to know whether it needs to apply SQL to make the ORDER BY case-insensitive 
 * (i.e. if it's a text column type).
 *
 * @see BasePeer
 * @see DatabaseMap
 * @package plugins.tracker.lib.map
 */
class TrackerExtraFieldElementMapBuilder implements MapBuilder {

    /**
     * The name of this class
     */
    const CLASS_NAME = "plugins.tracker.lib.map.TrackerExtraFieldElementMapBuilder";
	
    /**
     * The database map.
     */
    private $dbMap = null;

    /**
     * Tells us if this DatabaseMapBuilder is built so that we
     * don't have to re-build it every time.
     *
     * @return true if this DatabaseMapBuilder is built
     */
    public function isBuilt()
    {
        return ($this->dbMap !== null);
    }

    /**
     * Gets the databasemap this map builder built.
     *
     * @return the databasemap
     */
    public function getDatabaseMap()
    {
        return $this->dbMap;
    }

    /**
     * The doBuild() method builds the DatabaseMap
     *
	 * @return void
     * @throws PropelException
     */
    public function doBuild()
    {
		$this->dbMap = Propel::getDatabaseMap("gf5");
		
		$tMap = $this->dbMap->addTable("tracker_extra_field_element");
		$tMap->setPhpName("TrackerExtraFieldElement");
		
         
		$tMap->setUseIdGenerator(true);
		 
						
		 
		$tMap->setPrimaryKeyMethodInfo("tracker_extra_field_element_element_id_seq");
		 
		
		// Add columns to map
		$tMap->addPrimaryKey("ELEMENT_ID", "ElementId", "int", CreoleTypes::INTEGER, true);
		$tMap->addForeignKey("TRACKER_EXTRA_FIELD_ID", "TrackerExtraFieldId", "int", CreoleTypes::INTEGER, "tracker_extra_field" , "TRACKER_EXTRA_FIELD_ID", true);
		$tMap->addColumn("ELEMENT_NAME", "ElementName", "string", CreoleTypes::VARCHAR, true, null);
		$tMap->addColumn("STATUS_ID", "StatusId", "int", CreoleTypes::INTEGER, false, null);
		$tMap->addColumn("DEFAULT_SELECTED", "DefaultSelected", "boolean", CreoleTypes::BOOLEAN, false, null);
		$tMap->addColumn("SORT_ORDER", "SortOrder", "int", CreoleTypes::INTEGER, false, null);
		$tMap->addColumn("AUTO_ASSIGN_TO", "AutoAssignTo", "int", CreoleTypes::INTEGER, false, null);
		$tMap->addColumn("CAN_COMMIT", "CanCommit", "boolean", CreoleTypes::BOOLEAN, false, null);
		$tMap->addColumn("ALIAS", "Alias", "string", CreoleTypes::VARCHAR, true, null);
				
    }
}
