<?php 

require_once 'propel/om/BaseObject.php';

 
require_once 'propel/om/Persistent.php';

 

include_once 'propel/util/Criteria.php';
 

// (on-demand) include_once 'core/Project.php';
// (on-demand) include_once 'core/ProjectPeer.php';

include_once 'plugins/tracker/lib/TrackerPeer.php';

/**
 * Base class that represents a row from the 'tracker' table.
 *
 *  
 *
 * You should not use this class directly.  It should not even be
 * extended; all references should be to Tracker class. 
 * 
 * @package plugins.tracker.lib 
 */
abstract class BaseTracker extends BaseObject implements Persistent {
	
	/** 
	 * The Peer class.
	 * Instance provides a convenient way of calling static methods on a class
	 * that calling code may not be able to identify.
	 * @var TrackerPeer
	 */
	protected static $peer;

	/**
	 * The value for the tracker_id field.
	 * @var int	  
	 */
	protected $tracker_id;	

	/**
	 * The value for the project_id field.
	 * @var int	  
	 */
	protected $project_id;	

	/**
	 * The value for the tracker_name field.
	 * @var string	  
	 */
	protected $tracker_name;	

	/**
	 * The value for the description field.
	 * @var string	  
	 */
	protected $description;	

	/**
	 * The value for the is_public field.
	 * @var boolean	  
	 */
	protected $is_public = true;	

	/**
	 * The value for the restrict_browse field.
	 * @var boolean	  
	 */
	protected $restrict_browse = false;	

	/**
	 * The value for the email_all_updates field.
	 * @var boolean	  
	 */
	protected $email_all_updates = false;	

	/**
	 * The value for the email_address field.
	 * @var string	  
	 */
	protected $email_address;	

	/**
	 * The value for the due_period field.
	 * @var int	  
	 */
	protected $due_period = 2592000;	

	/**
	 * The value for the submit_instructions field.
	 * @var string	  
	 */
	protected $submit_instructions;	

	/**
	 * The value for the browse_instructions field.
	 * @var string	  
	 */
	protected $browse_instructions;	

	/**
	 * The value for the datatype field.
	 * @var int	  
	 */
	protected $datatype;	

	/**
	 * The value for the item_total field.
	 * @var int	  
	 */
	protected $item_total = 0;	

	/**
	 * The value for the open_count field.
	 * @var int	  
	 */
	protected $open_count = 0;	

	/**
	 * The value for the show_dependencies_tab field.
	 * @var boolean	  
	 */
	protected $show_dependencies_tab = true;	

	/**
	 * The value for the show_duplicates_tab field.
	 * @var boolean	  
	 */
	protected $show_duplicates_tab = true;	

	/**
	 * The value for the show_associations_tab field.
	 * @var boolean	  
	 */
	protected $show_associations_tab = true;	

	/**
	 * The value for the show_time_tracking_tab field.
	 * @var boolean	  
	 */
	protected $show_time_tracking_tab = true;	

	/**
	 * The value for the show_tags_tab field.
	 * @var boolean	  
	 */
	protected $show_tags_tab = true;	

	/**
	 * The value for the send_abbreviated_email field.
	 * @var boolean	  
	 */
	protected $send_abbreviated_email = false;	

	/**
	 * The value for the autoresponse_instructions field.
	 * @var string	  
	 */
	protected $autoresponse_instructions;	
  
	/**
	 * Get the TrackerId column value.
	 *  
	 * @return int	  
	 */
	public function getTrackerId()
	{
		return $this->tracker_id;
	}


	/**
	 * Set the value of `tracker_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setTrackerId($v)
	{
		if ($this->tracker_id !== $v) {
			$this->tracker_id = $v;
			$this->modifiedColumns[] = TrackerPeer::TRACKER_ID;
		}
			
		  // update associated CruisecontrolPublisher		  
		  if ($this->collCruisecontrolPublishers !== null) {
			  for ($i=0,$size=count($this->collCruisecontrolPublishers); $i < $size; $i++) {
				  $this->collCruisecontrolPublishers[$i]->setTrackerId($v);
			  }
		  }
			  	
		  // update associated TrackerCannedResponse		  
		  if ($this->collTrackerCannedResponses !== null) {
			  for ($i=0,$size=count($this->collTrackerCannedResponses); $i < $size; $i++) {
				  $this->collTrackerCannedResponses[$i]->setTrackerId($v);
			  }
		  }
			  	
		  // update associated TrackerExtraField		  
		  if ($this->collTrackerExtraFields !== null) {
			  for ($i=0,$size=count($this->collTrackerExtraFields); $i < $size; $i++) {
				  $this->collTrackerExtraFields[$i]->setTrackerId($v);
			  }
		  }
			  	
		  // update associated TrackerCommitTrigger		  
		  if ($this->collTrackerCommitTriggers !== null) {
			  for ($i=0,$size=count($this->collTrackerCommitTriggers); $i < $size; $i++) {
				  $this->collTrackerCommitTriggers[$i]->setTrackerId($v);
			  }
		  }
			  	
		  // update associated TrackerCommitReassignTrigger		  
		  if ($this->collTrackerCommitReassignTriggers !== null) {
			  for ($i=0,$size=count($this->collTrackerCommitReassignTriggers); $i < $size; $i++) {
				  $this->collTrackerCommitReassignTriggers[$i]->setTrackerId($v);
			  }
		  }
			  	
		  // update associated TrackerItem		  
		  if ($this->collTrackerItems !== null) {
			  for ($i=0,$size=count($this->collTrackerItems); $i < $size; $i++) {
				  $this->collTrackerItems[$i]->setTrackerId($v);
			  }
		  }
			  	
		  // update associated TrackerQuery		  
		  if ($this->collTrackerQuerys !== null) {
			  for ($i=0,$size=count($this->collTrackerQuerys); $i < $size; $i++) {
				  $this->collTrackerQuerys[$i]->setTrackerId($v);
			  }
		  }
			  	
		  // update associated MyReportTracker		  
		  if ($this->collMyReportTrackers !== null) {
			  for ($i=0,$size=count($this->collMyReportTrackers); $i < $size; $i++) {
				  $this->collMyReportTrackers[$i]->setTrackerId($v);
			  }
		  }
			  		
	}

  
	/**
	 * Get the ProjectId column value.
	 *  
	 * @return int	  
	 */
	public function getProjectId()
	{
		return $this->project_id;
	}


	/**
	 * Set the value of `project_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setProjectId($v)
	{
		if ($this->project_id !== $v) {
			$this->project_id = $v;
			$this->modifiedColumns[] = TrackerPeer::PROJECT_ID;
		}
			
		if ($this->aProject !== null && $this->aProject->getProjectId() !== $v) {
			$this->aProject = null;
		}
			
	}

  
	/**
	 * Get the TrackerName column value.
	 *  
	 * @return string	  
	 */
	public function getTrackerName()
	{
		return $this->tracker_name;
	}


	/**
	 * Set the value of `tracker_name` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setTrackerName($v)
	{
		if ($this->tracker_name !== $v) {
			$this->tracker_name = $v;
			$this->modifiedColumns[] = TrackerPeer::TRACKER_NAME;
		}
				
	}

  
	/**
	 * Get the Description column value.
	 *  
	 * @return string	  
	 */
	public function getDescription()
	{
		return $this->description;
	}


	/**
	 * Set the value of `description` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setDescription($v)
	{
		if ($this->description !== $v) {
			$this->description = $v;
			$this->modifiedColumns[] = TrackerPeer::DESCRIPTION;
		}
				
	}

  
	/**
	 * Get the IsPublic column value.
	 *  
	 * @return boolean	  
	 */
	public function getIsPublic()
	{
		return $this->is_public;
	}


	/**
	 * Set the value of `is_public` column.	  
	 *  
	 * @param boolean $v new value
	 * @return void
	 *  
	 */
	public function setIsPublic($v)
	{
		if ($this->is_public !== $v || $v === true) {
			$this->is_public = $v;
			$this->modifiedColumns[] = TrackerPeer::IS_PUBLIC;
		}
				
	}

  
	/**
	 * Get the RestrictBrowse column value.
	 *  
	 * @return boolean	  
	 */
	public function getRestrictBrowse()
	{
		return $this->restrict_browse;
	}


	/**
	 * Set the value of `restrict_browse` column.	  
	 *  
	 * @param boolean $v new value
	 * @return void
	 *  
	 */
	public function setRestrictBrowse($v)
	{
		if ($this->restrict_browse !== $v || $v === false) {
			$this->restrict_browse = $v;
			$this->modifiedColumns[] = TrackerPeer::RESTRICT_BROWSE;
		}
				
	}

  
	/**
	 * Get the EmailAllUpdates column value.
	 *  
	 * @return boolean	  
	 */
	public function getEmailAllUpdates()
	{
		return $this->email_all_updates;
	}


	/**
	 * Set the value of `email_all_updates` column.	  
	 *  
	 * @param boolean $v new value
	 * @return void
	 *  
	 */
	public function setEmailAllUpdates($v)
	{
		if ($this->email_all_updates !== $v || $v === false) {
			$this->email_all_updates = $v;
			$this->modifiedColumns[] = TrackerPeer::EMAIL_ALL_UPDATES;
		}
				
	}

  
	/**
	 * Get the EmailAddress column value.
	 *  
	 * @return string	  
	 */
	public function getEmailAddress()
	{
		return $this->email_address;
	}


	/**
	 * Set the value of `email_address` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setEmailAddress($v)
	{
		if ($this->email_address !== $v) {
			$this->email_address = $v;
			$this->modifiedColumns[] = TrackerPeer::EMAIL_ADDRESS;
		}
				
	}

  
	/**
	 * Get the DuePeriod column value.
	 *  
	 * @return int	  
	 */
	public function getDuePeriod()
	{
		return $this->due_period;
	}


	/**
	 * Set the value of `due_period` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 *  
	 */
	public function setDuePeriod($v)
	{
		if ($this->due_period !== $v || $v === 2592000) {
			$this->due_period = $v;
			$this->modifiedColumns[] = TrackerPeer::DUE_PERIOD;
		}
				
	}

  
	/**
	 * Get the SubmitInstructions column value.
	 *  
	 * @return string	  
	 */
	public function getSubmitInstructions()
	{
		return $this->submit_instructions;
	}


	/**
	 * Set the value of `submit_instructions` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setSubmitInstructions($v)
	{
		if ($this->submit_instructions !== $v) {
			$this->submit_instructions = $v;
			$this->modifiedColumns[] = TrackerPeer::SUBMIT_INSTRUCTIONS;
		}
				
	}

  
	/**
	 * Get the BrowseInstructions column value.
	 *  
	 * @return string	  
	 */
	public function getBrowseInstructions()
	{
		return $this->browse_instructions;
	}


	/**
	 * Set the value of `browse_instructions` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setBrowseInstructions($v)
	{
		if ($this->browse_instructions !== $v) {
			$this->browse_instructions = $v;
			$this->modifiedColumns[] = TrackerPeer::BROWSE_INSTRUCTIONS;
		}
				
	}

  
	/**
	 * Get the Datatype column value.
	 *  
	 * @return int	  
	 */
	public function getDatatype()
	{
		return $this->datatype;
	}


	/**
	 * Set the value of `datatype` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 *  
	 */
	public function setDatatype($v)
	{
		if ($this->datatype !== $v) {
			$this->datatype = $v;
			$this->modifiedColumns[] = TrackerPeer::DATATYPE;
		}
				
	}

  
	/**
	 * Get the ItemTotal column value.
	 *  
	 * @return int	  
	 */
	public function getItemTotal()
	{
		return $this->item_total;
	}


	/**
	 * Set the value of `item_total` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 *  
	 */
	public function setItemTotal($v)
	{
		if ($this->item_total !== $v || $v === 0) {
			$this->item_total = $v;
			$this->modifiedColumns[] = TrackerPeer::ITEM_TOTAL;
		}
				
	}

  
	/**
	 * Get the OpenCount column value.
	 *  
	 * @return int	  
	 */
	public function getOpenCount()
	{
		return $this->open_count;
	}


	/**
	 * Set the value of `open_count` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 *  
	 */
	public function setOpenCount($v)
	{
		if ($this->open_count !== $v || $v === 0) {
			$this->open_count = $v;
			$this->modifiedColumns[] = TrackerPeer::OPEN_COUNT;
		}
				
	}

  
	/**
	 * Get the ShowDependenciesTab column value.
	 *  
	 * @return boolean	  
	 */
	public function getShowDependenciesTab()
	{
		return $this->show_dependencies_tab;
	}


	/**
	 * Set the value of `show_dependencies_tab` column.	  
	 *  
	 * @param boolean $v new value
	 * @return void
	 *  
	 */
	public function setShowDependenciesTab($v)
	{
		if ($this->show_dependencies_tab !== $v || $v === true) {
			$this->show_dependencies_tab = $v;
			$this->modifiedColumns[] = TrackerPeer::SHOW_DEPENDENCIES_TAB;
		}
				
	}

  
	/**
	 * Get the ShowDuplicatesTab column value.
	 *  
	 * @return boolean	  
	 */
	public function getShowDuplicatesTab()
	{
		return $this->show_duplicates_tab;
	}


	/**
	 * Set the value of `show_duplicates_tab` column.	  
	 *  
	 * @param boolean $v new value
	 * @return void
	 *  
	 */
	public function setShowDuplicatesTab($v)
	{
		if ($this->show_duplicates_tab !== $v || $v === true) {
			$this->show_duplicates_tab = $v;
			$this->modifiedColumns[] = TrackerPeer::SHOW_DUPLICATES_TAB;
		}
				
	}

  
	/**
	 * Get the ShowAssociationsTab column value.
	 *  
	 * @return boolean	  
	 */
	public function getShowAssociationsTab()
	{
		return $this->show_associations_tab;
	}


	/**
	 * Set the value of `show_associations_tab` column.	  
	 *  
	 * @param boolean $v new value
	 * @return void
	 *  
	 */
	public function setShowAssociationsTab($v)
	{
		if ($this->show_associations_tab !== $v || $v === true) {
			$this->show_associations_tab = $v;
			$this->modifiedColumns[] = TrackerPeer::SHOW_ASSOCIATIONS_TAB;
		}
				
	}

  
	/**
	 * Get the ShowTimeTrackingTab column value.
	 *  
	 * @return boolean	  
	 */
	public function getShowTimeTrackingTab()
	{
		return $this->show_time_tracking_tab;
	}


	/**
	 * Set the value of `show_time_tracking_tab` column.	  
	 *  
	 * @param boolean $v new value
	 * @return void
	 *  
	 */
	public function setShowTimeTrackingTab($v)
	{
		if ($this->show_time_tracking_tab !== $v || $v === true) {
			$this->show_time_tracking_tab = $v;
			$this->modifiedColumns[] = TrackerPeer::SHOW_TIME_TRACKING_TAB;
		}
				
	}

  
	/**
	 * Get the ShowTagsTab column value.
	 *  
	 * @return boolean	  
	 */
	public function getShowTagsTab()
	{
		return $this->show_tags_tab;
	}


	/**
	 * Set the value of `show_tags_tab` column.	  
	 *  
	 * @param boolean $v new value
	 * @return void
	 *  
	 */
	public function setShowTagsTab($v)
	{
		if ($this->show_tags_tab !== $v || $v === true) {
			$this->show_tags_tab = $v;
			$this->modifiedColumns[] = TrackerPeer::SHOW_TAGS_TAB;
		}
				
	}

  
	/**
	 * Get the SendAbbreviatedEmail column value.
	 *  
	 * @return boolean	  
	 */
	public function getSendAbbreviatedEmail()
	{
		return $this->send_abbreviated_email;
	}


	/**
	 * Set the value of `send_abbreviated_email` column.	  
	 *  
	 * @param boolean $v new value
	 * @return void
	 *  
	 */
	public function setSendAbbreviatedEmail($v)
	{
		if ($this->send_abbreviated_email !== $v || $v === false) {
			$this->send_abbreviated_email = $v;
			$this->modifiedColumns[] = TrackerPeer::SEND_ABBREVIATED_EMAIL;
		}
				
	}

  
	/**
	 * Get the AutoresponseInstructions column value.
	 *  
	 * @return string	  
	 */
	public function getAutoresponseInstructions()
	{
		return $this->autoresponse_instructions;
	}


	/**
	 * Set the value of `autoresponse_instructions` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setAutoresponseInstructions($v)
	{
		if ($this->autoresponse_instructions !== $v) {
			$this->autoresponse_instructions = $v;
			$this->modifiedColumns[] = TrackerPeer::AUTORESPONSE_INSTRUCTIONS;
		}
				
	}


	
	/**
	 * Hydrates (populates) the object variables with values from the database resultset.
	 *
	 * An offset (1-based "start column") is specified so that objects can be hydrated
	 * with a subset of the columns in the resultset rows.  This is needed, for example,
	 * for results of JOIN queries where the resultset row includes columns from two or
	 * more tables.
	 *
	 * @param ResultSet $rs The ResultSet class with cursor advanced to desired record pos.
	 * @param int $startcol 1-based offset column which indicates which restultset column to start with.
	 * @return void
	 * @throws PropelException  - Any caught Exception will be rewrapped as a PropelException.
	 */
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {
			$this->tracker_id = $rs->getInt($startcol + 0);					
			$this->project_id = $rs->getInt($startcol + 1);					
			$this->tracker_name = $rs->getString($startcol + 2);					
			$this->description = $rs->getString($startcol + 3);					
			$this->is_public = $rs->getBoolean($startcol + 4);					
			$this->restrict_browse = $rs->getBoolean($startcol + 5);					
			$this->email_all_updates = $rs->getBoolean($startcol + 6);					
			$this->email_address = $rs->getString($startcol + 7);					
			$this->due_period = $rs->getInt($startcol + 8);					
			$this->submit_instructions = $rs->getString($startcol + 9);					
			$this->browse_instructions = $rs->getString($startcol + 10);					
			$this->datatype = $rs->getInt($startcol + 11);					
			$this->item_total = $rs->getInt($startcol + 12);					
			$this->open_count = $rs->getInt($startcol + 13);					
			$this->show_dependencies_tab = $rs->getBoolean($startcol + 14);					
			$this->show_duplicates_tab = $rs->getBoolean($startcol + 15);					
			$this->show_associations_tab = $rs->getBoolean($startcol + 16);					
			$this->show_time_tracking_tab = $rs->getBoolean($startcol + 17);					
			$this->show_tags_tab = $rs->getBoolean($startcol + 18);					
			$this->send_abbreviated_email = $rs->getBoolean($startcol + 19);					
			$this->autoresponse_instructions = $rs->getString($startcol + 20);					
			 
			$this->resetModified();
			$this->setNew(false);
		
		} catch (Exception $e) {
			throw new PropelException("Error populating Tracker object", $e);
		}		
	
	}
	
	/**
	 * Builds a Criteria object containing the primary key for this object.
	 *
	 * Unlike buildCriteria() this method includes the primary key values regardless
	 * of whether or not they have been modified.
	 * 
	 * @return Criteria The Criteria object containing value(s) for primary key(s).
	 */
	public function buildPkeyCriteria()
	{		
		$criteria = new Criteria(TrackerPeer::DATABASE_NAME);
		$criteria->add(TrackerPeer::TRACKER_ID, $this->tracker_id);
		return $criteria;			
	}
	
	/**
	 * Build a Criteria object containing the values of all modified columns in this object.
	 *
	 * @return Criteria The Criteria object containing all modified values.
	 */
	public function buildCriteria()
	{		
		$criteria = new Criteria(TrackerPeer::DATABASE_NAME);
		if ($this->isColumnModified(TrackerPeer::TRACKER_ID)) $criteria->add(TrackerPeer::TRACKER_ID, $this->tracker_id);
		if ($this->isColumnModified(TrackerPeer::PROJECT_ID)) $criteria->add(TrackerPeer::PROJECT_ID, $this->project_id);
		if ($this->isColumnModified(TrackerPeer::TRACKER_NAME)) $criteria->add(TrackerPeer::TRACKER_NAME, $this->tracker_name);
		if ($this->isColumnModified(TrackerPeer::DESCRIPTION)) $criteria->add(TrackerPeer::DESCRIPTION, $this->description);
		if ($this->isColumnModified(TrackerPeer::IS_PUBLIC)) $criteria->add(TrackerPeer::IS_PUBLIC, $this->is_public);
		if ($this->isColumnModified(TrackerPeer::RESTRICT_BROWSE)) $criteria->add(TrackerPeer::RESTRICT_BROWSE, $this->restrict_browse);
		if ($this->isColumnModified(TrackerPeer::EMAIL_ALL_UPDATES)) $criteria->add(TrackerPeer::EMAIL_ALL_UPDATES, $this->email_all_updates);
		if ($this->isColumnModified(TrackerPeer::EMAIL_ADDRESS)) $criteria->add(TrackerPeer::EMAIL_ADDRESS, $this->email_address);
		if ($this->isColumnModified(TrackerPeer::DUE_PERIOD)) $criteria->add(TrackerPeer::DUE_PERIOD, $this->due_period);
		if ($this->isColumnModified(TrackerPeer::SUBMIT_INSTRUCTIONS)) $criteria->add(TrackerPeer::SUBMIT_INSTRUCTIONS, $this->submit_instructions);
		if ($this->isColumnModified(TrackerPeer::BROWSE_INSTRUCTIONS)) $criteria->add(TrackerPeer::BROWSE_INSTRUCTIONS, $this->browse_instructions);
		if ($this->isColumnModified(TrackerPeer::DATATYPE)) $criteria->add(TrackerPeer::DATATYPE, $this->datatype);
		if ($this->isColumnModified(TrackerPeer::ITEM_TOTAL)) $criteria->add(TrackerPeer::ITEM_TOTAL, $this->item_total);
		if ($this->isColumnModified(TrackerPeer::OPEN_COUNT)) $criteria->add(TrackerPeer::OPEN_COUNT, $this->open_count);
		if ($this->isColumnModified(TrackerPeer::SHOW_DEPENDENCIES_TAB)) $criteria->add(TrackerPeer::SHOW_DEPENDENCIES_TAB, $this->show_dependencies_tab);
		if ($this->isColumnModified(TrackerPeer::SHOW_DUPLICATES_TAB)) $criteria->add(TrackerPeer::SHOW_DUPLICATES_TAB, $this->show_duplicates_tab);
		if ($this->isColumnModified(TrackerPeer::SHOW_ASSOCIATIONS_TAB)) $criteria->add(TrackerPeer::SHOW_ASSOCIATIONS_TAB, $this->show_associations_tab);
		if ($this->isColumnModified(TrackerPeer::SHOW_TIME_TRACKING_TAB)) $criteria->add(TrackerPeer::SHOW_TIME_TRACKING_TAB, $this->show_time_tracking_tab);
		if ($this->isColumnModified(TrackerPeer::SHOW_TAGS_TAB)) $criteria->add(TrackerPeer::SHOW_TAGS_TAB, $this->show_tags_tab);
		if ($this->isColumnModified(TrackerPeer::SEND_ABBREVIATED_EMAIL)) $criteria->add(TrackerPeer::SEND_ABBREVIATED_EMAIL, $this->send_abbreviated_email);
		if ($this->isColumnModified(TrackerPeer::AUTORESPONSE_INSTRUCTIONS)) $criteria->add(TrackerPeer::AUTORESPONSE_INSTRUCTIONS, $this->autoresponse_instructions);
		return $criteria;			
	}
	
	

	/**
	 * @var Project	  
	 */
	protected $aProject;

	/**
	 * Declares an association between this object and a Project object
	 *
	 * @param Project $v
	 * @return void
	 * @throws PropelException
	 */
	public function setProject($v)
	{
			
		if ($v === null) {
			$this->setProjectId(NULL);
		} else {
			$this->setProjectId($v->getProjectId());
		}
   
		$this->aProject = $v;
	}


	/**
	 * Get the associated Project object
	 *
	 * @param Connection Optional Connection object.
	 * @return Project The associated Project object.
	 * @throws PropelException
	 */
	public function getProject($con = null)
	{
		// include the Peer class
		include_once 'core/ProjectPeer.php';

		if ($this->aProject === null && ($this->project_id !== null)) {
	
			$this->aProject = ProjectPeer::retrieveByPK($this->project_id, $con);
	
			/* The following can be used instead of the line above to
			   guarantee the related object contains a reference
			   to this object, but this level of coupling
			   may be undesirable in many circumstances.
			   As it can lead to a db query with many results that may
			   never be used.
			   $obj = ProjectPeer::retrieveByPK($this->project_id, $con);
			   $obj->addTrackers($this);
			 */
		}
		return $this->aProject;
	}

	/**
	 * Provides convenient way to set a relationship based on a
	 * key.  e.g.
	 * <code>$bar->setFooKey($foo->getPrimaryKey())</code>
	 *
 
	 * @return void
	 * @throws PropelException
	 */
	public function setProjectKey($key)
	{

		$this->setProjectId( (int) $key);			
		
	}

	/**
	 * Collection to store aggregation of collCruisecontrolPublishers	  
	 * @var array
	 */
	protected $collCruisecontrolPublishers; 

	/**
	 * Temporary storage of collCruisecontrolPublishers to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initCruisecontrolPublishers()
	{
		if ($this->collCruisecontrolPublishers === null) {
			$this->collCruisecontrolPublishers = array();
		}
	}

	/**
	 * Method called to associate a CruisecontrolPublisher object to this object
	 * through the CruisecontrolPublisher foreign key attribute
	 *
	 * @param CruisecontrolPublisher $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addCruisecontrolPublisher(CruisecontrolPublisher $l)
	{
		$this->collCruisecontrolPublishers[] = $l;
		$l->setTracker($this);
	}

	/**
	 * The criteria used to select the current contents of collCruisecontrolPublishers.
	 * @var Criteria
	 */
	private $lastCruisecontrolPublishersCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Tracker has previously
	 * been saved, it will retrieve related CruisecontrolPublishers from storage.
	 * If this Tracker is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getCruisecontrolPublishers($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/cruisecontrol/lib/CruisecontrolPublisherPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collCruisecontrolPublishers === null) {
			if ($this->isNew()) {
			   $this->collCruisecontrolPublishers = array();
			} else {
	
				$criteria->add(CruisecontrolPublisherPeer::TRACKER_ID, $this->getTrackerId() );

				$this->collCruisecontrolPublishers = CruisecontrolPublisherPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(CruisecontrolPublisherPeer::TRACKER_ID, $this->getTrackerId());

				if (!isset($this->lastCruisecontrolPublishersCriteria) || !$this->lastCruisecontrolPublishersCriteria->equals($criteria)) {
					$this->collCruisecontrolPublishers = CruisecontrolPublisherPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastCruisecontrolPublishersCriteria = $criteria;

		return $this->collCruisecontrolPublishers;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Tracker is new, it will return
	 * an empty collection; or if this Tracker has previously
	 * been saved, it will retrieve related CruisecontrolPublishers from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Tracker.
	 */
	public function getCruisecontrolPublishersJoinCruisecontrol($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/cruisecontrol/lib/CruisecontrolPublisherPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collCruisecontrolPublishers === null) {
			if ($this->isNew()) {
			   $this->collCruisecontrolPublishers = array();
			} else {
	   
				$criteria->add(CruisecontrolPublisherPeer::TRACKER_ID, $this->getTrackerId());
				$this->collCruisecontrolPublishers = CruisecontrolPublisherPeer::doSelectJoinCruisecontrol($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(CruisecontrolPublisherPeer::TRACKER_ID, $this->getTrackerId());
			if (!isset($this->lastCruisecontrolPublishersCriteria) || !$this->lastCruisecontrolPublishersCriteria->equals($criteria)) {
				$this->collCruisecontrolPublishers = CruisecontrolPublisherPeer::doSelectJoinCruisecontrol($criteria, $con);
			}
		}
		$this->lastCruisecontrolPublishersCriteria = $criteria;

		return $this->collCruisecontrolPublishers;
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Tracker is new, it will return
	 * an empty collection; or if this Tracker has previously
	 * been saved, it will retrieve related CruisecontrolPublishers from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Tracker.
	 */
	public function getCruisecontrolPublishersJoinTracker($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/cruisecontrol/lib/CruisecontrolPublisherPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collCruisecontrolPublishers === null) {
			if ($this->isNew()) {
			   $this->collCruisecontrolPublishers = array();
			} else {
	   
				$criteria->add(CruisecontrolPublisherPeer::TRACKER_ID, $this->getTrackerId());
				$this->collCruisecontrolPublishers = CruisecontrolPublisherPeer::doSelectJoinTracker($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(CruisecontrolPublisherPeer::TRACKER_ID, $this->getTrackerId());
			if (!isset($this->lastCruisecontrolPublishersCriteria) || !$this->lastCruisecontrolPublishersCriteria->equals($criteria)) {
				$this->collCruisecontrolPublishers = CruisecontrolPublisherPeer::doSelectJoinTracker($criteria, $con);
			}
		}
		$this->lastCruisecontrolPublishersCriteria = $criteria;

		return $this->collCruisecontrolPublishers;
	}

	/**
	 * Collection to store aggregation of collTrackerCannedResponses	  
	 * @var array
	 */
	protected $collTrackerCannedResponses; 

	/**
	 * Temporary storage of collTrackerCannedResponses to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initTrackerCannedResponses()
	{
		if ($this->collTrackerCannedResponses === null) {
			$this->collTrackerCannedResponses = array();
		}
	}

	/**
	 * Method called to associate a TrackerCannedResponse object to this object
	 * through the TrackerCannedResponse foreign key attribute
	 *
	 * @param TrackerCannedResponse $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addTrackerCannedResponse(TrackerCannedResponse $l)
	{
		$this->collTrackerCannedResponses[] = $l;
		$l->setTracker($this);
	}

	/**
	 * The criteria used to select the current contents of collTrackerCannedResponses.
	 * @var Criteria
	 */
	private $lastTrackerCannedResponsesCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Tracker has previously
	 * been saved, it will retrieve related TrackerCannedResponses from storage.
	 * If this Tracker is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getTrackerCannedResponses($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerCannedResponsePeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collTrackerCannedResponses === null) {
			if ($this->isNew()) {
			   $this->collTrackerCannedResponses = array();
			} else {
	
				$criteria->add(TrackerCannedResponsePeer::TRACKER_ID, $this->getTrackerId() );

				$this->collTrackerCannedResponses = TrackerCannedResponsePeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(TrackerCannedResponsePeer::TRACKER_ID, $this->getTrackerId());

				if (!isset($this->lastTrackerCannedResponsesCriteria) || !$this->lastTrackerCannedResponsesCriteria->equals($criteria)) {
					$this->collTrackerCannedResponses = TrackerCannedResponsePeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastTrackerCannedResponsesCriteria = $criteria;

		return $this->collTrackerCannedResponses;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Tracker is new, it will return
	 * an empty collection; or if this Tracker has previously
	 * been saved, it will retrieve related TrackerCannedResponses from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Tracker.
	 */
	public function getTrackerCannedResponsesJoinTracker($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerCannedResponsePeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collTrackerCannedResponses === null) {
			if ($this->isNew()) {
			   $this->collTrackerCannedResponses = array();
			} else {
	   
				$criteria->add(TrackerCannedResponsePeer::TRACKER_ID, $this->getTrackerId());
				$this->collTrackerCannedResponses = TrackerCannedResponsePeer::doSelectJoinTracker($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(TrackerCannedResponsePeer::TRACKER_ID, $this->getTrackerId());
			if (!isset($this->lastTrackerCannedResponsesCriteria) || !$this->lastTrackerCannedResponsesCriteria->equals($criteria)) {
				$this->collTrackerCannedResponses = TrackerCannedResponsePeer::doSelectJoinTracker($criteria, $con);
			}
		}
		$this->lastTrackerCannedResponsesCriteria = $criteria;

		return $this->collTrackerCannedResponses;
	}

	/**
	 * Collection to store aggregation of collTrackerExtraFields	  
	 * @var array
	 */
	protected $collTrackerExtraFields; 

	/**
	 * Temporary storage of collTrackerExtraFields to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initTrackerExtraFields()
	{
		if ($this->collTrackerExtraFields === null) {
			$this->collTrackerExtraFields = array();
		}
	}

	/**
	 * Method called to associate a TrackerExtraField object to this object
	 * through the TrackerExtraField foreign key attribute
	 *
	 * @param TrackerExtraField $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addTrackerExtraField(TrackerExtraField $l)
	{
		$this->collTrackerExtraFields[] = $l;
		$l->setTracker($this);
	}

	/**
	 * The criteria used to select the current contents of collTrackerExtraFields.
	 * @var Criteria
	 */
	private $lastTrackerExtraFieldsCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Tracker has previously
	 * been saved, it will retrieve related TrackerExtraFields from storage.
	 * If this Tracker is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getTrackerExtraFields($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerExtraFieldPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collTrackerExtraFields === null) {
			if ($this->isNew()) {
			   $this->collTrackerExtraFields = array();
			} else {
	
				$criteria->add(TrackerExtraFieldPeer::TRACKER_ID, $this->getTrackerId() );

				$this->collTrackerExtraFields = TrackerExtraFieldPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(TrackerExtraFieldPeer::TRACKER_ID, $this->getTrackerId());

				if (!isset($this->lastTrackerExtraFieldsCriteria) || !$this->lastTrackerExtraFieldsCriteria->equals($criteria)) {
					$this->collTrackerExtraFields = TrackerExtraFieldPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastTrackerExtraFieldsCriteria = $criteria;

		return $this->collTrackerExtraFields;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Tracker is new, it will return
	 * an empty collection; or if this Tracker has previously
	 * been saved, it will retrieve related TrackerExtraFields from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Tracker.
	 */
	public function getTrackerExtraFieldsJoinTracker($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerExtraFieldPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collTrackerExtraFields === null) {
			if ($this->isNew()) {
			   $this->collTrackerExtraFields = array();
			} else {
	   
				$criteria->add(TrackerExtraFieldPeer::TRACKER_ID, $this->getTrackerId());
				$this->collTrackerExtraFields = TrackerExtraFieldPeer::doSelectJoinTracker($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(TrackerExtraFieldPeer::TRACKER_ID, $this->getTrackerId());
			if (!isset($this->lastTrackerExtraFieldsCriteria) || !$this->lastTrackerExtraFieldsCriteria->equals($criteria)) {
				$this->collTrackerExtraFields = TrackerExtraFieldPeer::doSelectJoinTracker($criteria, $con);
			}
		}
		$this->lastTrackerExtraFieldsCriteria = $criteria;

		return $this->collTrackerExtraFields;
	}

	/**
	 * Collection to store aggregation of collTrackerCommitTriggers	  
	 * @var array
	 */
	protected $collTrackerCommitTriggers; 

	/**
	 * Temporary storage of collTrackerCommitTriggers to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initTrackerCommitTriggers()
	{
		if ($this->collTrackerCommitTriggers === null) {
			$this->collTrackerCommitTriggers = array();
		}
	}

	/**
	 * Method called to associate a TrackerCommitTrigger object to this object
	 * through the TrackerCommitTrigger foreign key attribute
	 *
	 * @param TrackerCommitTrigger $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addTrackerCommitTrigger(TrackerCommitTrigger $l)
	{
		$this->collTrackerCommitTriggers[] = $l;
		$l->setTracker($this);
	}

	/**
	 * The criteria used to select the current contents of collTrackerCommitTriggers.
	 * @var Criteria
	 */
	private $lastTrackerCommitTriggersCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Tracker has previously
	 * been saved, it will retrieve related TrackerCommitTriggers from storage.
	 * If this Tracker is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getTrackerCommitTriggers($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerCommitTriggerPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collTrackerCommitTriggers === null) {
			if ($this->isNew()) {
			   $this->collTrackerCommitTriggers = array();
			} else {
	
				$criteria->add(TrackerCommitTriggerPeer::TRACKER_ID, $this->getTrackerId() );

				$this->collTrackerCommitTriggers = TrackerCommitTriggerPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(TrackerCommitTriggerPeer::TRACKER_ID, $this->getTrackerId());

				if (!isset($this->lastTrackerCommitTriggersCriteria) || !$this->lastTrackerCommitTriggersCriteria->equals($criteria)) {
					$this->collTrackerCommitTriggers = TrackerCommitTriggerPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastTrackerCommitTriggersCriteria = $criteria;

		return $this->collTrackerCommitTriggers;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Tracker is new, it will return
	 * an empty collection; or if this Tracker has previously
	 * been saved, it will retrieve related TrackerCommitTriggers from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Tracker.
	 */
	public function getTrackerCommitTriggersJoinTracker($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerCommitTriggerPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collTrackerCommitTriggers === null) {
			if ($this->isNew()) {
			   $this->collTrackerCommitTriggers = array();
			} else {
	   
				$criteria->add(TrackerCommitTriggerPeer::TRACKER_ID, $this->getTrackerId());
				$this->collTrackerCommitTriggers = TrackerCommitTriggerPeer::doSelectJoinTracker($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(TrackerCommitTriggerPeer::TRACKER_ID, $this->getTrackerId());
			if (!isset($this->lastTrackerCommitTriggersCriteria) || !$this->lastTrackerCommitTriggersCriteria->equals($criteria)) {
				$this->collTrackerCommitTriggers = TrackerCommitTriggerPeer::doSelectJoinTracker($criteria, $con);
			}
		}
		$this->lastTrackerCommitTriggersCriteria = $criteria;

		return $this->collTrackerCommitTriggers;
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Tracker is new, it will return
	 * an empty collection; or if this Tracker has previously
	 * been saved, it will retrieve related TrackerCommitTriggers from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Tracker.
	 */
	public function getTrackerCommitTriggersJoinTrackerExtraField($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerCommitTriggerPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collTrackerCommitTriggers === null) {
			if ($this->isNew()) {
			   $this->collTrackerCommitTriggers = array();
			} else {
	   
				$criteria->add(TrackerCommitTriggerPeer::TRACKER_ID, $this->getTrackerId());
				$this->collTrackerCommitTriggers = TrackerCommitTriggerPeer::doSelectJoinTrackerExtraField($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(TrackerCommitTriggerPeer::TRACKER_ID, $this->getTrackerId());
			if (!isset($this->lastTrackerCommitTriggersCriteria) || !$this->lastTrackerCommitTriggersCriteria->equals($criteria)) {
				$this->collTrackerCommitTriggers = TrackerCommitTriggerPeer::doSelectJoinTrackerExtraField($criteria, $con);
			}
		}
		$this->lastTrackerCommitTriggersCriteria = $criteria;

		return $this->collTrackerCommitTriggers;
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Tracker is new, it will return
	 * an empty collection; or if this Tracker has previously
	 * been saved, it will retrieve related TrackerCommitTriggers from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Tracker.
	 */
	public function getTrackerCommitTriggersJoinTrackerExtraFieldElement($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerCommitTriggerPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collTrackerCommitTriggers === null) {
			if ($this->isNew()) {
			   $this->collTrackerCommitTriggers = array();
			} else {
	   
				$criteria->add(TrackerCommitTriggerPeer::TRACKER_ID, $this->getTrackerId());
				$this->collTrackerCommitTriggers = TrackerCommitTriggerPeer::doSelectJoinTrackerExtraFieldElement($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(TrackerCommitTriggerPeer::TRACKER_ID, $this->getTrackerId());
			if (!isset($this->lastTrackerCommitTriggersCriteria) || !$this->lastTrackerCommitTriggersCriteria->equals($criteria)) {
				$this->collTrackerCommitTriggers = TrackerCommitTriggerPeer::doSelectJoinTrackerExtraFieldElement($criteria, $con);
			}
		}
		$this->lastTrackerCommitTriggersCriteria = $criteria;

		return $this->collTrackerCommitTriggers;
	}

	/**
	 * Collection to store aggregation of collTrackerCommitReassignTriggers	  
	 * @var array
	 */
	protected $collTrackerCommitReassignTriggers; 

	/**
	 * Temporary storage of collTrackerCommitReassignTriggers to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initTrackerCommitReassignTriggers()
	{
		if ($this->collTrackerCommitReassignTriggers === null) {
			$this->collTrackerCommitReassignTriggers = array();
		}
	}

	/**
	 * Method called to associate a TrackerCommitReassignTrigger object to this object
	 * through the TrackerCommitReassignTrigger foreign key attribute
	 *
	 * @param TrackerCommitReassignTrigger $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addTrackerCommitReassignTrigger(TrackerCommitReassignTrigger $l)
	{
		$this->collTrackerCommitReassignTriggers[] = $l;
		$l->setTracker($this);
	}

	/**
	 * The criteria used to select the current contents of collTrackerCommitReassignTriggers.
	 * @var Criteria
	 */
	private $lastTrackerCommitReassignTriggersCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Tracker has previously
	 * been saved, it will retrieve related TrackerCommitReassignTriggers from storage.
	 * If this Tracker is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getTrackerCommitReassignTriggers($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerCommitReassignTriggerPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collTrackerCommitReassignTriggers === null) {
			if ($this->isNew()) {
			   $this->collTrackerCommitReassignTriggers = array();
			} else {
	
				$criteria->add(TrackerCommitReassignTriggerPeer::TRACKER_ID, $this->getTrackerId() );

				$this->collTrackerCommitReassignTriggers = TrackerCommitReassignTriggerPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(TrackerCommitReassignTriggerPeer::TRACKER_ID, $this->getTrackerId());

				if (!isset($this->lastTrackerCommitReassignTriggersCriteria) || !$this->lastTrackerCommitReassignTriggersCriteria->equals($criteria)) {
					$this->collTrackerCommitReassignTriggers = TrackerCommitReassignTriggerPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastTrackerCommitReassignTriggersCriteria = $criteria;

		return $this->collTrackerCommitReassignTriggers;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Tracker is new, it will return
	 * an empty collection; or if this Tracker has previously
	 * been saved, it will retrieve related TrackerCommitReassignTriggers from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Tracker.
	 */
	public function getTrackerCommitReassignTriggersJoinTracker($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerCommitReassignTriggerPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collTrackerCommitReassignTriggers === null) {
			if ($this->isNew()) {
			   $this->collTrackerCommitReassignTriggers = array();
			} else {
	   
				$criteria->add(TrackerCommitReassignTriggerPeer::TRACKER_ID, $this->getTrackerId());
				$this->collTrackerCommitReassignTriggers = TrackerCommitReassignTriggerPeer::doSelectJoinTracker($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(TrackerCommitReassignTriggerPeer::TRACKER_ID, $this->getTrackerId());
			if (!isset($this->lastTrackerCommitReassignTriggersCriteria) || !$this->lastTrackerCommitReassignTriggersCriteria->equals($criteria)) {
				$this->collTrackerCommitReassignTriggers = TrackerCommitReassignTriggerPeer::doSelectJoinTracker($criteria, $con);
			}
		}
		$this->lastTrackerCommitReassignTriggersCriteria = $criteria;

		return $this->collTrackerCommitReassignTriggers;
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Tracker is new, it will return
	 * an empty collection; or if this Tracker has previously
	 * been saved, it will retrieve related TrackerCommitReassignTriggers from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Tracker.
	 */
	public function getTrackerCommitReassignTriggersJoinRole($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerCommitReassignTriggerPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collTrackerCommitReassignTriggers === null) {
			if ($this->isNew()) {
			   $this->collTrackerCommitReassignTriggers = array();
			} else {
	   
				$criteria->add(TrackerCommitReassignTriggerPeer::TRACKER_ID, $this->getTrackerId());
				$this->collTrackerCommitReassignTriggers = TrackerCommitReassignTriggerPeer::doSelectJoinRole($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(TrackerCommitReassignTriggerPeer::TRACKER_ID, $this->getTrackerId());
			if (!isset($this->lastTrackerCommitReassignTriggersCriteria) || !$this->lastTrackerCommitReassignTriggersCriteria->equals($criteria)) {
				$this->collTrackerCommitReassignTriggers = TrackerCommitReassignTriggerPeer::doSelectJoinRole($criteria, $con);
			}
		}
		$this->lastTrackerCommitReassignTriggersCriteria = $criteria;

		return $this->collTrackerCommitReassignTriggers;
	}

	/**
	 * Collection to store aggregation of collTrackerItems	  
	 * @var array
	 */
	protected $collTrackerItems; 

	/**
	 * Temporary storage of collTrackerItems to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initTrackerItems()
	{
		if ($this->collTrackerItems === null) {
			$this->collTrackerItems = array();
		}
	}

	/**
	 * Method called to associate a TrackerItem object to this object
	 * through the TrackerItem foreign key attribute
	 *
	 * @param TrackerItem $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addTrackerItem(TrackerItem $l)
	{
		$this->collTrackerItems[] = $l;
		$l->setTracker($this);
	}

	/**
	 * The criteria used to select the current contents of collTrackerItems.
	 * @var Criteria
	 */
	private $lastTrackerItemsCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Tracker has previously
	 * been saved, it will retrieve related TrackerItems from storage.
	 * If this Tracker is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getTrackerItems($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerItemPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collTrackerItems === null) {
			if ($this->isNew()) {
			   $this->collTrackerItems = array();
			} else {
	
				$criteria->add(TrackerItemPeer::TRACKER_ID, $this->getTrackerId() );

				$this->collTrackerItems = TrackerItemPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(TrackerItemPeer::TRACKER_ID, $this->getTrackerId());

				if (!isset($this->lastTrackerItemsCriteria) || !$this->lastTrackerItemsCriteria->equals($criteria)) {
					$this->collTrackerItems = TrackerItemPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastTrackerItemsCriteria = $criteria;

		return $this->collTrackerItems;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Tracker is new, it will return
	 * an empty collection; or if this Tracker has previously
	 * been saved, it will retrieve related TrackerItems from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Tracker.
	 */
	public function getTrackerItemsJoinUser($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerItemPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collTrackerItems === null) {
			if ($this->isNew()) {
			   $this->collTrackerItems = array();
			} else {
	   
				$criteria->add(TrackerItemPeer::TRACKER_ID, $this->getTrackerId());
				$this->collTrackerItems = TrackerItemPeer::doSelectJoinUser($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(TrackerItemPeer::TRACKER_ID, $this->getTrackerId());
			if (!isset($this->lastTrackerItemsCriteria) || !$this->lastTrackerItemsCriteria->equals($criteria)) {
				$this->collTrackerItems = TrackerItemPeer::doSelectJoinUser($criteria, $con);
			}
		}
		$this->lastTrackerItemsCriteria = $criteria;

		return $this->collTrackerItems;
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Tracker is new, it will return
	 * an empty collection; or if this Tracker has previously
	 * been saved, it will retrieve related TrackerItems from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Tracker.
	 */
	public function getTrackerItemsJoinTrackerSprint($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerItemPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collTrackerItems === null) {
			if ($this->isNew()) {
			   $this->collTrackerItems = array();
			} else {
	   
				$criteria->add(TrackerItemPeer::TRACKER_ID, $this->getTrackerId());
				$this->collTrackerItems = TrackerItemPeer::doSelectJoinTrackerSprint($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(TrackerItemPeer::TRACKER_ID, $this->getTrackerId());
			if (!isset($this->lastTrackerItemsCriteria) || !$this->lastTrackerItemsCriteria->equals($criteria)) {
				$this->collTrackerItems = TrackerItemPeer::doSelectJoinTrackerSprint($criteria, $con);
			}
		}
		$this->lastTrackerItemsCriteria = $criteria;

		return $this->collTrackerItems;
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Tracker is new, it will return
	 * an empty collection; or if this Tracker has previously
	 * been saved, it will retrieve related TrackerItems from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Tracker.
	 */
	public function getTrackerItemsJoinTracker($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerItemPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collTrackerItems === null) {
			if ($this->isNew()) {
			   $this->collTrackerItems = array();
			} else {
	   
				$criteria->add(TrackerItemPeer::TRACKER_ID, $this->getTrackerId());
				$this->collTrackerItems = TrackerItemPeer::doSelectJoinTracker($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(TrackerItemPeer::TRACKER_ID, $this->getTrackerId());
			if (!isset($this->lastTrackerItemsCriteria) || !$this->lastTrackerItemsCriteria->equals($criteria)) {
				$this->collTrackerItems = TrackerItemPeer::doSelectJoinTracker($criteria, $con);
			}
		}
		$this->lastTrackerItemsCriteria = $criteria;

		return $this->collTrackerItems;
	}

	/**
	 * Collection to store aggregation of collTrackerQuerys	  
	 * @var array
	 */
	protected $collTrackerQuerys; 

	/**
	 * Temporary storage of collTrackerQuerys to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initTrackerQuerys()
	{
		if ($this->collTrackerQuerys === null) {
			$this->collTrackerQuerys = array();
		}
	}

	/**
	 * Method called to associate a TrackerQuery object to this object
	 * through the TrackerQuery foreign key attribute
	 *
	 * @param TrackerQuery $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addTrackerQuery(TrackerQuery $l)
	{
		$this->collTrackerQuerys[] = $l;
		$l->setTracker($this);
	}

	/**
	 * The criteria used to select the current contents of collTrackerQuerys.
	 * @var Criteria
	 */
	private $lastTrackerQuerysCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Tracker has previously
	 * been saved, it will retrieve related TrackerQuerys from storage.
	 * If this Tracker is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getTrackerQuerys($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerQueryPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collTrackerQuerys === null) {
			if ($this->isNew()) {
			   $this->collTrackerQuerys = array();
			} else {
	
				$criteria->add(TrackerQueryPeer::TRACKER_ID, $this->getTrackerId() );

				$this->collTrackerQuerys = TrackerQueryPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(TrackerQueryPeer::TRACKER_ID, $this->getTrackerId());

				if (!isset($this->lastTrackerQuerysCriteria) || !$this->lastTrackerQuerysCriteria->equals($criteria)) {
					$this->collTrackerQuerys = TrackerQueryPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastTrackerQuerysCriteria = $criteria;

		return $this->collTrackerQuerys;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Tracker is new, it will return
	 * an empty collection; or if this Tracker has previously
	 * been saved, it will retrieve related TrackerQuerys from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Tracker.
	 */
	public function getTrackerQuerysJoinTracker($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerQueryPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collTrackerQuerys === null) {
			if ($this->isNew()) {
			   $this->collTrackerQuerys = array();
			} else {
	   
				$criteria->add(TrackerQueryPeer::TRACKER_ID, $this->getTrackerId());
				$this->collTrackerQuerys = TrackerQueryPeer::doSelectJoinTracker($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(TrackerQueryPeer::TRACKER_ID, $this->getTrackerId());
			if (!isset($this->lastTrackerQuerysCriteria) || !$this->lastTrackerQuerysCriteria->equals($criteria)) {
				$this->collTrackerQuerys = TrackerQueryPeer::doSelectJoinTracker($criteria, $con);
			}
		}
		$this->lastTrackerQuerysCriteria = $criteria;

		return $this->collTrackerQuerys;
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Tracker is new, it will return
	 * an empty collection; or if this Tracker has previously
	 * been saved, it will retrieve related TrackerQuerys from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Tracker.
	 */
	public function getTrackerQuerysJoinUser($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerQueryPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collTrackerQuerys === null) {
			if ($this->isNew()) {
			   $this->collTrackerQuerys = array();
			} else {
	   
				$criteria->add(TrackerQueryPeer::TRACKER_ID, $this->getTrackerId());
				$this->collTrackerQuerys = TrackerQueryPeer::doSelectJoinUser($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(TrackerQueryPeer::TRACKER_ID, $this->getTrackerId());
			if (!isset($this->lastTrackerQuerysCriteria) || !$this->lastTrackerQuerysCriteria->equals($criteria)) {
				$this->collTrackerQuerys = TrackerQueryPeer::doSelectJoinUser($criteria, $con);
			}
		}
		$this->lastTrackerQuerysCriteria = $criteria;

		return $this->collTrackerQuerys;
	}

	/**
	 * Collection to store aggregation of collMyReportTrackers	  
	 * @var array
	 */
	protected $collMyReportTrackers; 

	/**
	 * Temporary storage of collMyReportTrackers to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initMyReportTrackers()
	{
		if ($this->collMyReportTrackers === null) {
			$this->collMyReportTrackers = array();
		}
	}

	/**
	 * Method called to associate a MyReportTracker object to this object
	 * through the MyReportTracker foreign key attribute
	 *
	 * @param MyReportTracker $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addMyReportTracker(MyReportTracker $l)
	{
		$this->collMyReportTrackers[] = $l;
		$l->setTracker($this);
	}

	/**
	 * The criteria used to select the current contents of collMyReportTrackers.
	 * @var Criteria
	 */
	private $lastMyReportTrackersCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Tracker has previously
	 * been saved, it will retrieve related MyReportTrackers from storage.
	 * If this Tracker is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getMyReportTrackers($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'core/MyReportTrackerPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collMyReportTrackers === null) {
			if ($this->isNew()) {
			   $this->collMyReportTrackers = array();
			} else {
	
				$criteria->add(MyReportTrackerPeer::TRACKER_ID, $this->getTrackerId() );

				$this->collMyReportTrackers = MyReportTrackerPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(MyReportTrackerPeer::TRACKER_ID, $this->getTrackerId());

				if (!isset($this->lastMyReportTrackersCriteria) || !$this->lastMyReportTrackersCriteria->equals($criteria)) {
					$this->collMyReportTrackers = MyReportTrackerPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastMyReportTrackersCriteria = $criteria;

		return $this->collMyReportTrackers;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Tracker is new, it will return
	 * an empty collection; or if this Tracker has previously
	 * been saved, it will retrieve related MyReportTrackers from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Tracker.
	 */
	public function getMyReportTrackersJoinTracker($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'core/MyReportTrackerPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collMyReportTrackers === null) {
			if ($this->isNew()) {
			   $this->collMyReportTrackers = array();
			} else {
	   
				$criteria->add(MyReportTrackerPeer::TRACKER_ID, $this->getTrackerId());
				$this->collMyReportTrackers = MyReportTrackerPeer::doSelectJoinTracker($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(MyReportTrackerPeer::TRACKER_ID, $this->getTrackerId());
			if (!isset($this->lastMyReportTrackersCriteria) || !$this->lastMyReportTrackersCriteria->equals($criteria)) {
				$this->collMyReportTrackers = MyReportTrackerPeer::doSelectJoinTracker($criteria, $con);
			}
		}
		$this->lastMyReportTrackersCriteria = $criteria;

		return $this->collMyReportTrackers;
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Tracker is new, it will return
	 * an empty collection; or if this Tracker has previously
	 * been saved, it will retrieve related MyReportTrackers from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Tracker.
	 */
	public function getMyReportTrackersJoinMyReport($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'core/MyReportTrackerPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collMyReportTrackers === null) {
			if ($this->isNew()) {
			   $this->collMyReportTrackers = array();
			} else {
	   
				$criteria->add(MyReportTrackerPeer::TRACKER_ID, $this->getTrackerId());
				$this->collMyReportTrackers = MyReportTrackerPeer::doSelectJoinMyReport($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(MyReportTrackerPeer::TRACKER_ID, $this->getTrackerId());
			if (!isset($this->lastMyReportTrackersCriteria) || !$this->lastMyReportTrackersCriteria->equals($criteria)) {
				$this->collMyReportTrackers = MyReportTrackerPeer::doSelectJoinMyReport($criteria, $con);
			}
		}
		$this->lastMyReportTrackersCriteria = $criteria;

		return $this->collMyReportTrackers;
	}

	private $fieldNames;

	/**
	 * Generate a list of field names.
	 *
	 * @return array A list of field names
	 */
	public function getFieldNames()
	{
		if ($this->fieldNames === null) {
			$this->fieldNames = array("tracker_id", "project_id", "tracker_name", "description", "is_public", "restrict_browse", "email_all_updates", "email_address", "due_period", "submit_instructions", "browse_instructions", "datatype", "item_total", "open_count", "show_dependencies_tab", "show_duplicates_tab", "show_associations_tab", "show_time_tracking_tab", "show_tags_tab", "send_abbreviated_email", "autoresponse_instructions", );
		}
		return $this->fieldNames;
	}
	
	/**
	 * Retrieves a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @return mixed Value of field.
	 */
	public function getByName($name)
	{
		switch($name) {
	  
			case TrackerPeer::TRACKER_ID:
				return $this->getTrackerId();
				break;
		  
			case TrackerPeer::PROJECT_ID:
				return $this->getProjectId();
				break;
		  
			case TrackerPeer::TRACKER_NAME:
				return $this->getTrackerName();
				break;
		  
			case TrackerPeer::DESCRIPTION:
				return $this->getDescription();
				break;
		  
			case TrackerPeer::IS_PUBLIC:
				return $this->getIsPublic();
				break;
		  
			case TrackerPeer::RESTRICT_BROWSE:
				return $this->getRestrictBrowse();
				break;
		  
			case TrackerPeer::EMAIL_ALL_UPDATES:
				return $this->getEmailAllUpdates();
				break;
		  
			case TrackerPeer::EMAIL_ADDRESS:
				return $this->getEmailAddress();
				break;
		  
			case TrackerPeer::DUE_PERIOD:
				return $this->getDuePeriod();
				break;
		  
			case TrackerPeer::SUBMIT_INSTRUCTIONS:
				return $this->getSubmitInstructions();
				break;
		  
			case TrackerPeer::BROWSE_INSTRUCTIONS:
				return $this->getBrowseInstructions();
				break;
		  
			case TrackerPeer::DATATYPE:
				return $this->getDatatype();
				break;
		  
			case TrackerPeer::ITEM_TOTAL:
				return $this->getItemTotal();
				break;
		  
			case TrackerPeer::OPEN_COUNT:
				return $this->getOpenCount();
				break;
		  
			case TrackerPeer::SHOW_DEPENDENCIES_TAB:
				return $this->getShowDependenciesTab();
				break;
		  
			case TrackerPeer::SHOW_DUPLICATES_TAB:
				return $this->getShowDuplicatesTab();
				break;
		  
			case TrackerPeer::SHOW_ASSOCIATIONS_TAB:
				return $this->getShowAssociationsTab();
				break;
		  
			case TrackerPeer::SHOW_TIME_TRACKING_TAB:
				return $this->getShowTimeTrackingTab();
				break;
		  
			case TrackerPeer::SHOW_TAGS_TAB:
				return $this->getShowTagsTab();
				break;
		  
			case TrackerPeer::SEND_ABBREVIATED_EMAIL:
				return $this->getSendAbbreviatedEmail();
				break;
		  
			case TrackerPeer::AUTORESPONSE_INSTRUCTIONS:
				return $this->getAutoresponseInstructions();
				break;
	  
			default:
				return null;
				
		} // switch()
	}

	/**
	 * Retrieves a field from the object by Position as specified in the xml schema. 
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @return mixed Value of field at $pos
	 */
	public function getByPosition($pos)
	{
		switch($pos) {
  
			case 0:
				return $this->getTrackerId();
				break;
  
			case 1:
				return $this->getProjectId();
				break;
  
			case 2:
				return $this->getTrackerName();
				break;
  
			case 3:
				return $this->getDescription();
				break;
  
			case 4:
				return $this->getIsPublic();
				break;
  
			case 5:
				return $this->getRestrictBrowse();
				break;
  
			case 6:
				return $this->getEmailAllUpdates();
				break;
  
			case 7:
				return $this->getEmailAddress();
				break;
  
			case 8:
				return $this->getDuePeriod();
				break;
  
			case 9:
				return $this->getSubmitInstructions();
				break;
  
			case 10:
				return $this->getBrowseInstructions();
				break;
  
			case 11:
				return $this->getDatatype();
				break;
  
			case 12:
				return $this->getItemTotal();
				break;
  
			case 13:
				return $this->getOpenCount();
				break;
  
			case 14:
				return $this->getShowDependenciesTab();
				break;
  
			case 15:
				return $this->getShowDuplicatesTab();
				break;
  
			case 16:
				return $this->getShowAssociationsTab();
				break;
  
			case 17:
				return $this->getShowTimeTrackingTab();
				break;
  
			case 18:
				return $this->getShowTagsTab();
				break;
  
			case 19:
				return $this->getSendAbbreviatedEmail();
				break;
  
			case 20:
				return $this->getAutoresponseInstructions();
				break;
			default:
				return null;
		} // switch()
	}



	
	/**
	 * Convenience method to populate the object using an array.
	 * This is particularly useful when populating an object from one of the request arrays (e.g. $_POST).  This method
	 * goest through the column (peer) names, checking to see whether a matching key exists in populated array. If
	 * so the setByName() method is called for that column.
	 * @param array $arr An array where keys are column names.
	 * @return void
	 */
	public function populateFromArray($arr)
	{
  
		if (array_key_exists(TrackerPeer::TRACKER_ID, $arr)) $this->setTrackerId($arr[TrackerPeer::TRACKER_ID]);
  
		if (array_key_exists(TrackerPeer::PROJECT_ID, $arr)) $this->setProjectId($arr[TrackerPeer::PROJECT_ID]);
  
		if (array_key_exists(TrackerPeer::TRACKER_NAME, $arr)) $this->setTrackerName($arr[TrackerPeer::TRACKER_NAME]);
  
		if (array_key_exists(TrackerPeer::DESCRIPTION, $arr)) $this->setDescription($arr[TrackerPeer::DESCRIPTION]);
  
		if (array_key_exists(TrackerPeer::IS_PUBLIC, $arr)) $this->setIsPublic($arr[TrackerPeer::IS_PUBLIC]);
  
		if (array_key_exists(TrackerPeer::RESTRICT_BROWSE, $arr)) $this->setRestrictBrowse($arr[TrackerPeer::RESTRICT_BROWSE]);
  
		if (array_key_exists(TrackerPeer::EMAIL_ALL_UPDATES, $arr)) $this->setEmailAllUpdates($arr[TrackerPeer::EMAIL_ALL_UPDATES]);
  
		if (array_key_exists(TrackerPeer::EMAIL_ADDRESS, $arr)) $this->setEmailAddress($arr[TrackerPeer::EMAIL_ADDRESS]);
  
		if (array_key_exists(TrackerPeer::DUE_PERIOD, $arr)) $this->setDuePeriod($arr[TrackerPeer::DUE_PERIOD]);
  
		if (array_key_exists(TrackerPeer::SUBMIT_INSTRUCTIONS, $arr)) $this->setSubmitInstructions($arr[TrackerPeer::SUBMIT_INSTRUCTIONS]);
  
		if (array_key_exists(TrackerPeer::BROWSE_INSTRUCTIONS, $arr)) $this->setBrowseInstructions($arr[TrackerPeer::BROWSE_INSTRUCTIONS]);
  
		if (array_key_exists(TrackerPeer::DATATYPE, $arr)) $this->setDatatype($arr[TrackerPeer::DATATYPE]);
  
		if (array_key_exists(TrackerPeer::ITEM_TOTAL, $arr)) $this->setItemTotal($arr[TrackerPeer::ITEM_TOTAL]);
  
		if (array_key_exists(TrackerPeer::OPEN_COUNT, $arr)) $this->setOpenCount($arr[TrackerPeer::OPEN_COUNT]);
  
		if (array_key_exists(TrackerPeer::SHOW_DEPENDENCIES_TAB, $arr)) $this->setShowDependenciesTab($arr[TrackerPeer::SHOW_DEPENDENCIES_TAB]);
  
		if (array_key_exists(TrackerPeer::SHOW_DUPLICATES_TAB, $arr)) $this->setShowDuplicatesTab($arr[TrackerPeer::SHOW_DUPLICATES_TAB]);
  
		if (array_key_exists(TrackerPeer::SHOW_ASSOCIATIONS_TAB, $arr)) $this->setShowAssociationsTab($arr[TrackerPeer::SHOW_ASSOCIATIONS_TAB]);
  
		if (array_key_exists(TrackerPeer::SHOW_TIME_TRACKING_TAB, $arr)) $this->setShowTimeTrackingTab($arr[TrackerPeer::SHOW_TIME_TRACKING_TAB]);
  
		if (array_key_exists(TrackerPeer::SHOW_TAGS_TAB, $arr)) $this->setShowTagsTab($arr[TrackerPeer::SHOW_TAGS_TAB]);
  
		if (array_key_exists(TrackerPeer::SEND_ABBREVIATED_EMAIL, $arr)) $this->setSendAbbreviatedEmail($arr[TrackerPeer::SEND_ABBREVIATED_EMAIL]);
  
		if (array_key_exists(TrackerPeer::AUTORESPONSE_INSTRUCTIONS, $arr)) $this->setAutoresponseInstructions($arr[TrackerPeer::AUTORESPONSE_INSTRUCTIONS]);
 
	}
	
	/**
	 * Sets a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByName($name, $value)
	{
		switch($name) {
	  
			case TrackerPeer::TRACKER_ID:
				$this->setTrackerId($value);
				break;
	  
			case TrackerPeer::PROJECT_ID:
				$this->setProjectId($value);
				break;
	  
			case TrackerPeer::TRACKER_NAME:
				$this->setTrackerName($value);
				break;
	  
			case TrackerPeer::DESCRIPTION:
				$this->setDescription($value);
				break;
	  
			case TrackerPeer::IS_PUBLIC:
				$this->setIsPublic($value);
				break;
	  
			case TrackerPeer::RESTRICT_BROWSE:
				$this->setRestrictBrowse($value);
				break;
	  
			case TrackerPeer::EMAIL_ALL_UPDATES:
				$this->setEmailAllUpdates($value);
				break;
	  
			case TrackerPeer::EMAIL_ADDRESS:
				$this->setEmailAddress($value);
				break;
	  
			case TrackerPeer::DUE_PERIOD:
				$this->setDuePeriod($value);
				break;
	  
			case TrackerPeer::SUBMIT_INSTRUCTIONS:
				$this->setSubmitInstructions($value);
				break;
	  
			case TrackerPeer::BROWSE_INSTRUCTIONS:
				$this->setBrowseInstructions($value);
				break;
	  
			case TrackerPeer::DATATYPE:
				$this->setDatatype($value);
				break;
	  
			case TrackerPeer::ITEM_TOTAL:
				$this->setItemTotal($value);
				break;
	  
			case TrackerPeer::OPEN_COUNT:
				$this->setOpenCount($value);
				break;
	  
			case TrackerPeer::SHOW_DEPENDENCIES_TAB:
				$this->setShowDependenciesTab($value);
				break;
	  
			case TrackerPeer::SHOW_DUPLICATES_TAB:
				$this->setShowDuplicatesTab($value);
				break;
	  
			case TrackerPeer::SHOW_ASSOCIATIONS_TAB:
				$this->setShowAssociationsTab($value);
				break;
	  
			case TrackerPeer::SHOW_TIME_TRACKING_TAB:
				$this->setShowTimeTrackingTab($value);
				break;
	  
			case TrackerPeer::SHOW_TAGS_TAB:
				$this->setShowTagsTab($value);
				break;
	  
			case TrackerPeer::SEND_ABBREVIATED_EMAIL:
				$this->setSendAbbreviatedEmail($value);
				break;
	  
			case TrackerPeer::AUTORESPONSE_INSTRUCTIONS:
				$this->setAutoresponseInstructions($value);
				break;
				  
		} // switch()
	}

	/**
	 * Sets a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByPosition($pos, $value)
	{
		switch($pos) {
  
			case 0:
				$this->setTrackerId($value);
				break;
  
			case 1:
				$this->setProjectId($value);
				break;
  
			case 2:
				$this->setTrackerName($value);
				break;
  
			case 3:
				$this->setDescription($value);
				break;
  
			case 4:
				$this->setIsPublic($value);
				break;
  
			case 5:
				$this->setRestrictBrowse($value);
				break;
  
			case 6:
				$this->setEmailAllUpdates($value);
				break;
  
			case 7:
				$this->setEmailAddress($value);
				break;
  
			case 8:
				$this->setDuePeriod($value);
				break;
  
			case 9:
				$this->setSubmitInstructions($value);
				break;
  
			case 10:
				$this->setBrowseInstructions($value);
				break;
  
			case 11:
				$this->setDatatype($value);
				break;
  
			case 12:
				$this->setItemTotal($value);
				break;
  
			case 13:
				$this->setOpenCount($value);
				break;
  
			case 14:
				$this->setShowDependenciesTab($value);
				break;
  
			case 15:
				$this->setShowDuplicatesTab($value);
				break;
  
			case 16:
				$this->setShowAssociationsTab($value);
				break;
  
			case 17:
				$this->setShowTimeTrackingTab($value);
				break;
  
			case 18:
				$this->setShowTagsTab($value);
				break;
  
			case 19:
				$this->setSendAbbreviatedEmail($value);
				break;
  
			case 20:
				$this->setAutoresponseInstructions($value);
				break;
		} // switch()
	}


 
	/**
	 * Removes this object from datastore and sets delete attribute.
	 * 
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 * @see BaseObject::setDeleted()
	 * @see BaseObject::isDeleted()
	 */
	public function delete($con = null)
	{	
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}
		
		if ($con === null)
			$con = Propel::getConnection(TrackerPeer::DATABASE_NAME);

		try {
			$con->begin();
			TrackerPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
	

	/**
	 * flag to prevent endless save loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	private $alreadyInSave = false;

	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.  This method
	 * wraps the doSave() worker method in a transaction.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
	public function save($con = null)
	{
		if ($this->isDeleted()) {
		//	throw new PropelException("You cannot save an object that has been deleted.");
			return;
		}
		
		if ($con === null)
			$con = Propel::getConnection(TrackerPeer::DATABASE_NAME);

		try {
			$con->begin();
			$this->doSave($con);			
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
  
	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
		protected function doSave($con)	{ 
		
	 
		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;

			// We call the save method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.
 
			if ($this->aProject !== null) {
				if ($this->aProject->isModified()) $this->aProject->save($con);
				$this->setProject($this->aProject);
			}

			// If this object has been modified, then save it to the database.
			if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = TrackerPeer::doInsert($this, $con);
					$this->setTrackerId( $pk );  //[IMV] update autoincrement primary key
					$this->setNew(false);
				} else {
					TrackerPeer::doUpdate($this, $con);
				}			
				$this->resetModified(); // [HL] After being saved an object is no longer 'modified'
			}
			if ($this->collCruisecontrolPublishers !== null) {
				for ($i=0,$size=count($this->collCruisecontrolPublishers); $i < $size; $i++) {
					$this->collCruisecontrolPublishers[$i]->save($con);
				}
			  }
			if ($this->collTrackerCannedResponses !== null) {
				for ($i=0,$size=count($this->collTrackerCannedResponses); $i < $size; $i++) {
					$this->collTrackerCannedResponses[$i]->save($con);
				}
			  }
			if ($this->collTrackerExtraFields !== null) {
				for ($i=0,$size=count($this->collTrackerExtraFields); $i < $size; $i++) {
					$this->collTrackerExtraFields[$i]->save($con);
				}
			  }
			if ($this->collTrackerCommitTriggers !== null) {
				for ($i=0,$size=count($this->collTrackerCommitTriggers); $i < $size; $i++) {
					$this->collTrackerCommitTriggers[$i]->save($con);
				}
			  }
			if ($this->collTrackerCommitReassignTriggers !== null) {
				for ($i=0,$size=count($this->collTrackerCommitReassignTriggers); $i < $size; $i++) {
					$this->collTrackerCommitReassignTriggers[$i]->save($con);
				}
			  }
			if ($this->collTrackerItems !== null) {
				for ($i=0,$size=count($this->collTrackerItems); $i < $size; $i++) {
					$this->collTrackerItems[$i]->save($con);
				}
			  }
			if ($this->collTrackerQuerys !== null) {
				for ($i=0,$size=count($this->collTrackerQuerys); $i < $size; $i++) {
					$this->collTrackerQuerys[$i]->save($con);
				}
			  }
			if ($this->collMyReportTrackers !== null) {
				for ($i=0,$size=count($this->collMyReportTrackers); $i < $size; $i++) {
					$this->collMyReportTrackers[$i]->save($con);
				}
			  }

			$this->alreadyInSave = false;
		}
	}

	/**
	 * Validates the objects modified field values.
	 * This includes all objects related to this table.
	 *
	 * If $columns is either a column name or an array of column names
	 * only those columns are validated.
	 *
	 * @param mixed $columns Column name or an array of column names.
	 *
	 * @return mixed <code>true</code> if all columns pass validation
	 *			  or an array of <code>ValidationFailed</code> objects for columns that fail.
	 */
	public function validate($columns = null)
	{
	  if ($columns)
	  {
		return TrackerPeer::doValidate($this, $columns);
	  }

		return $this->doValidate();
	}

	/**
	 * flag to prevent endless validation loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	protected $alreadyInValidation = false;
  
	/**
	 * This function performs the validation work for complex object models.
	 * 
	 * In addition to checking the current object, all related objects will
	 * also be validated.  If all pass then <code>true</code> is returned; otherwise
	 * an aggreagated array of ValidationFailed objects will be returned.
	 *
	 * @return mixed <code>true</code> if all validations pass; array of <code>ValidationFailed</code> objets otherwise.
	 */
	protected function doValidate()
	{
		if (! $this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;
	  
			$failureMap = array();	  
	  
			// We call the validate method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.
			if ($this->aProject !== null) {
				if (($retval = $this->aProject->validate()) !== true) {
					$failureMap = array_merge($failureMap, $retval);
				}
			}

			if (($retval = TrackerPeer::doValidate($this)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}
	  
			if ($this->collCruisecontrolPublishers !== null) {
				for ($i=0,$size=count($this->collCruisecontrolPublishers); $i < $size; $i++) {
					if (($retval = $this->collCruisecontrolPublishers[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
			if ($this->collTrackerCannedResponses !== null) {
				for ($i=0,$size=count($this->collTrackerCannedResponses); $i < $size; $i++) {
					if (($retval = $this->collTrackerCannedResponses[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
			if ($this->collTrackerExtraFields !== null) {
				for ($i=0,$size=count($this->collTrackerExtraFields); $i < $size; $i++) {
					if (($retval = $this->collTrackerExtraFields[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
			if ($this->collTrackerCommitTriggers !== null) {
				for ($i=0,$size=count($this->collTrackerCommitTriggers); $i < $size; $i++) {
					if (($retval = $this->collTrackerCommitTriggers[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
			if ($this->collTrackerCommitReassignTriggers !== null) {
				for ($i=0,$size=count($this->collTrackerCommitReassignTriggers); $i < $size; $i++) {
					if (($retval = $this->collTrackerCommitReassignTriggers[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
			if ($this->collTrackerItems !== null) {
				for ($i=0,$size=count($this->collTrackerItems); $i < $size; $i++) {
					if (($retval = $this->collTrackerItems[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
			if ($this->collTrackerQuerys !== null) {
				for ($i=0,$size=count($this->collTrackerQuerys); $i < $size; $i++) {
					if (($retval = $this->collTrackerQuerys[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
			if ($this->collMyReportTrackers !== null) {
				for ($i=0,$size=count($this->collMyReportTrackers); $i < $size; $i++) {
					if (($retval = $this->collMyReportTrackers[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
	  
			$this->alreadyInValidation = false;
		}
	
		return (!empty($failureMap) ? $failureMap : true);
	}
  

	/**
	 * Set the PrimaryKey.
	 *
	 * @param mixed tracker_id Primary key.
	 * @return void
	 * @throws PropelException	 */
	public function setPrimaryKey($key) 
	{		
		$this->setTrackerId($key);
	}
	

	/**
	 * Returns an id that differentiates this object from others
	 * of its class.
	 * @return int 
	 */
	public function getPrimaryKey()
	{

		return $this->getTrackerId();

	}

	
	/**
	 * Makes a copy of this object that will be inserted as a new row in table when saved.
	 * It creates a new object filling in the simple attributes, but skipping any primary
	 * keys that are defined for the table.
	 *  
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 *  
	 * @return Tracker Clone of current object.
	 * @throws PropelException
	 */
	public function copy($deepCopy = false) 
	{
		$copyObj = new Tracker();
		$copyObj->setProjectId($this->project_id);
		$copyObj->setTrackerName($this->tracker_name);
		$copyObj->setDescription($this->description);
		$copyObj->setIsPublic($this->is_public);
		$copyObj->setRestrictBrowse($this->restrict_browse);
		$copyObj->setEmailAllUpdates($this->email_all_updates);
		$copyObj->setEmailAddress($this->email_address);
		$copyObj->setDuePeriod($this->due_period);
		$copyObj->setSubmitInstructions($this->submit_instructions);
		$copyObj->setBrowseInstructions($this->browse_instructions);
		$copyObj->setDatatype($this->datatype);
		$copyObj->setItemTotal($this->item_total);
		$copyObj->setOpenCount($this->open_count);
		$copyObj->setShowDependenciesTab($this->show_dependencies_tab);
		$copyObj->setShowDuplicatesTab($this->show_duplicates_tab);
		$copyObj->setShowAssociationsTab($this->show_associations_tab);
		$copyObj->setShowTimeTrackingTab($this->show_time_tracking_tab);
		$copyObj->setShowTagsTab($this->show_tags_tab);
		$copyObj->setSendAbbreviatedEmail($this->send_abbreviated_email);
		$copyObj->setAutoresponseInstructions($this->autoresponse_instructions);

		if ($deepCopy) {		
			// important: setNew(false) because this affects the behavior of
			// the getter/setter methods for fkey referrer objects.
			$copyObj->setNew(false);

			foreach($this->getCruisecontrolPublishers() as $relObj) {
				$copyObj->addCruisecontrolPublisher($relObj->copy());
			}

			foreach($this->getTrackerCannedResponses() as $relObj) {
				$copyObj->addTrackerCannedResponse($relObj->copy());
			}

			foreach($this->getTrackerExtraFields() as $relObj) {
				$copyObj->addTrackerExtraField($relObj->copy());
			}

			foreach($this->getTrackerCommitTriggers() as $relObj) {
				$copyObj->addTrackerCommitTrigger($relObj->copy());
			}

			foreach($this->getTrackerCommitReassignTriggers() as $relObj) {
				$copyObj->addTrackerCommitReassignTrigger($relObj->copy());
			}

			foreach($this->getTrackerItems() as $relObj) {
				$copyObj->addTrackerItem($relObj->copy());
			}

			foreach($this->getTrackerQuerys() as $relObj) {
				$copyObj->addTrackerQuery($relObj->copy());
			}

			foreach($this->getMyReportTrackers() as $relObj) {
				$copyObj->addMyReportTracker($relObj->copy());
			}
		} // if ($deepCopy)
		
		$copyObj->setNew(true);
		
		$copyObj->setTrackerId(NULL); // this is a pkey column, so set to default value

		return $copyObj;
	}
		

	/**
	 * returns a peer instance associated with this om.  Since Peer classes	
	 * are not to have any instance attributes, this method returns the
	 * same instance for all member of this class. The method could therefore
	 * be static, but this would prevent one from overriding the behavior.
	 * @return TrackerPeer
	 */
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new TrackerPeer();
		}
		return self::$peer;
	}

}
