<?php 

require_once 'propel/om/BaseObject.php';

 
require_once 'propel/om/Persistent.php';

 

include_once 'propel/util/Criteria.php';
 

// (on-demand) include_once 'plugins/tracker/lib/TrackerExtraField.php';
// (on-demand) include_once 'plugins/tracker/lib/TrackerExtraFieldPeer.php';

include_once 'plugins/tracker/lib/TrackerExtraFieldElementPeer.php';

/**
 * Base class that represents a row from the 'tracker_extra_field_element' table.
 *
 *  
 *
 * You should not use this class directly.  It should not even be
 * extended; all references should be to TrackerExtraFieldElement class. 
 * 
 * @package plugins.tracker.lib 
 */
abstract class BaseTrackerExtraFieldElement extends BaseObject implements Persistent {
	
	/** 
	 * The Peer class.
	 * Instance provides a convenient way of calling static methods on a class
	 * that calling code may not be able to identify.
	 * @var TrackerExtraFieldElementPeer
	 */
	protected static $peer;

	/**
	 * The value for the element_id field.
	 * @var int	  
	 */
	protected $element_id;	

	/**
	 * The value for the tracker_extra_field_id field.
	 * @var int	  
	 */
	protected $tracker_extra_field_id;	

	/**
	 * The value for the element_name field.
	 * @var string	  
	 */
	protected $element_name;	

	/**
	 * The value for the status_id field.
	 * @var int	  
	 */
	protected $status_id = 1;	

	/**
	 * The value for the default_selected field.
	 * @var boolean	  
	 */
	protected $default_selected = false;	

	/**
	 * The value for the sort_order field.
	 * @var int	  
	 */
	protected $sort_order = 0;	

	/**
	 * The value for the auto_assign_to field.
	 * @var int	  
	 */
	protected $auto_assign_to = 0;	

	/**
	 * The value for the can_commit field.
	 * @var boolean	  
	 */
	protected $can_commit = true;	

	/**
	 * The value for the alias field.
	 * @var string	  
	 */
	protected $alias;	
  
	/**
	 * Get the ElementId column value.
	 *  
	 * @return int	  
	 */
	public function getElementId()
	{
		return $this->element_id;
	}


	/**
	 * Set the value of `element_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setElementId($v)
	{
		if ($this->element_id !== $v) {
			$this->element_id = $v;
			$this->modifiedColumns[] = TrackerExtraFieldElementPeer::ELEMENT_ID;
		}
			
		  // update associated TrackerEfeTransitionTrigger		  
		  if ($this->collTrackerEfeTransitionTriggers !== null) {
			  for ($i=0,$size=count($this->collTrackerEfeTransitionTriggers); $i < $size; $i++) {
				  $this->collTrackerEfeTransitionTriggers[$i]->setToElementId($v);
			  }
		  }
			  	
		  // update associated TrackerCommitTrigger		  
		  if ($this->collTrackerCommitTriggers !== null) {
			  for ($i=0,$size=count($this->collTrackerCommitTriggers); $i < $size; $i++) {
				  $this->collTrackerCommitTriggers[$i]->setToElementId($v);
			  }
		  }
			  	
		  // update associated TrackerExtraFieldElementTransition		  
		  if ($this->collTrackerExtraFieldElementTransitionsRelatedByElementId !== null) {
			  for ($i=0,$size=count($this->collTrackerExtraFieldElementTransitionsRelatedByElementId); $i < $size; $i++) {
				  $this->collTrackerExtraFieldElementTransitionsRelatedByElementId[$i]->setElementId($v);
			  }
		  }
			  	
		  // update associated TrackerExtraFieldElementTransition		  
		  if ($this->collTrackerExtraFieldElementTransitionsRelatedByToElementId !== null) {
			  for ($i=0,$size=count($this->collTrackerExtraFieldElementTransitionsRelatedByToElementId); $i < $size; $i++) {
				  $this->collTrackerExtraFieldElementTransitionsRelatedByToElementId[$i]->setToElementId($v);
			  }
		  }
			  		
	}

  
	/**
	 * Get the TrackerExtraFieldId column value.
	 *  
	 * @return int	  
	 */
	public function getTrackerExtraFieldId()
	{
		return $this->tracker_extra_field_id;
	}


	/**
	 * Set the value of `tracker_extra_field_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setTrackerExtraFieldId($v)
	{
		if ($this->tracker_extra_field_id !== $v) {
			$this->tracker_extra_field_id = $v;
			$this->modifiedColumns[] = TrackerExtraFieldElementPeer::TRACKER_EXTRA_FIELD_ID;
		}
			
		if ($this->aTrackerExtraField !== null && $this->aTrackerExtraField->getTrackerExtraFieldId() !== $v) {
			$this->aTrackerExtraField = null;
		}
			
	}

  
	/**
	 * Get the ElementName column value.
	 *  
	 * @return string	  
	 */
	public function getElementName()
	{
		return $this->element_name;
	}


	/**
	 * Set the value of `element_name` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setElementName($v)
	{
		if ($this->element_name !== $v) {
			$this->element_name = $v;
			$this->modifiedColumns[] = TrackerExtraFieldElementPeer::ELEMENT_NAME;
		}
				
	}

  
	/**
	 * Get the StatusId column value.
	 *  
	 * @return int	  
	 */
	public function getStatusId()
	{
		return $this->status_id;
	}


	/**
	 * Set the value of `status_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 *  
	 */
	public function setStatusId($v)
	{
		if ($this->status_id !== $v || $v === 1) {
			$this->status_id = $v;
			$this->modifiedColumns[] = TrackerExtraFieldElementPeer::STATUS_ID;
		}
				
	}

  
	/**
	 * Get the DefaultSelected column value.
	 *  
	 * @return boolean	  
	 */
	public function getDefaultSelected()
	{
		return $this->default_selected;
	}


	/**
	 * Set the value of `default_selected` column.	  
	 *  
	 * @param boolean $v new value
	 * @return void
	 *  
	 */
	public function setDefaultSelected($v)
	{
		if ($this->default_selected !== $v || $v === false) {
			$this->default_selected = $v;
			$this->modifiedColumns[] = TrackerExtraFieldElementPeer::DEFAULT_SELECTED;
		}
				
	}

  
	/**
	 * Get the SortOrder column value.
	 *  
	 * @return int	  
	 */
	public function getSortOrder()
	{
		return $this->sort_order;
	}


	/**
	 * Set the value of `sort_order` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 *  
	 */
	public function setSortOrder($v)
	{
		if ($this->sort_order !== $v || $v === 0) {
			$this->sort_order = $v;
			$this->modifiedColumns[] = TrackerExtraFieldElementPeer::SORT_ORDER;
		}
				
	}

  
	/**
	 * Get the AutoAssignTo column value.
	 *  
	 * @return int	  
	 */
	public function getAutoAssignTo()
	{
		return $this->auto_assign_to;
	}


	/**
	 * Set the value of `auto_assign_to` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 *  
	 */
	public function setAutoAssignTo($v)
	{
		if ($this->auto_assign_to !== $v || $v === 0) {
			$this->auto_assign_to = $v;
			$this->modifiedColumns[] = TrackerExtraFieldElementPeer::AUTO_ASSIGN_TO;
		}
				
	}

  
	/**
	 * Get the CanCommit column value.
	 *  
	 * @return boolean	  
	 */
	public function getCanCommit()
	{
		return $this->can_commit;
	}


	/**
	 * Set the value of `can_commit` column.	  
	 *  
	 * @param boolean $v new value
	 * @return void
	 *  
	 */
	public function setCanCommit($v)
	{
		if ($this->can_commit !== $v || $v === true) {
			$this->can_commit = $v;
			$this->modifiedColumns[] = TrackerExtraFieldElementPeer::CAN_COMMIT;
		}
				
	}

  
	/**
	 * Get the Alias column value.
	 *  
	 * @return string	  
	 */
	public function getAlias()
	{
		return $this->alias;
	}


	/**
	 * Set the value of `alias` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setAlias($v)
	{
		if ($this->alias !== $v) {
			$this->alias = $v;
			$this->modifiedColumns[] = TrackerExtraFieldElementPeer::ALIAS;
		}
				
	}


	
	/**
	 * Hydrates (populates) the object variables with values from the database resultset.
	 *
	 * An offset (1-based "start column") is specified so that objects can be hydrated
	 * with a subset of the columns in the resultset rows.  This is needed, for example,
	 * for results of JOIN queries where the resultset row includes columns from two or
	 * more tables.
	 *
	 * @param ResultSet $rs The ResultSet class with cursor advanced to desired record pos.
	 * @param int $startcol 1-based offset column which indicates which restultset column to start with.
	 * @return void
	 * @throws PropelException  - Any caught Exception will be rewrapped as a PropelException.
	 */
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {
			$this->element_id = $rs->getInt($startcol + 0);					
			$this->tracker_extra_field_id = $rs->getInt($startcol + 1);					
			$this->element_name = $rs->getString($startcol + 2);					
			$this->status_id = $rs->getInt($startcol + 3);					
			$this->default_selected = $rs->getBoolean($startcol + 4);					
			$this->sort_order = $rs->getInt($startcol + 5);					
			$this->auto_assign_to = $rs->getInt($startcol + 6);					
			$this->can_commit = $rs->getBoolean($startcol + 7);					
			$this->alias = $rs->getString($startcol + 8);					
			 
			$this->resetModified();
			$this->setNew(false);
		
		} catch (Exception $e) {
			throw new PropelException("Error populating TrackerExtraFieldElement object", $e);
		}		
	
	}
	
	/**
	 * Builds a Criteria object containing the primary key for this object.
	 *
	 * Unlike buildCriteria() this method includes the primary key values regardless
	 * of whether or not they have been modified.
	 * 
	 * @return Criteria The Criteria object containing value(s) for primary key(s).
	 */
	public function buildPkeyCriteria()
	{		
		$criteria = new Criteria(TrackerExtraFieldElementPeer::DATABASE_NAME);
		$criteria->add(TrackerExtraFieldElementPeer::ELEMENT_ID, $this->element_id);
		return $criteria;			
	}
	
	/**
	 * Build a Criteria object containing the values of all modified columns in this object.
	 *
	 * @return Criteria The Criteria object containing all modified values.
	 */
	public function buildCriteria()
	{		
		$criteria = new Criteria(TrackerExtraFieldElementPeer::DATABASE_NAME);
		if ($this->isColumnModified(TrackerExtraFieldElementPeer::ELEMENT_ID)) $criteria->add(TrackerExtraFieldElementPeer::ELEMENT_ID, $this->element_id);
		if ($this->isColumnModified(TrackerExtraFieldElementPeer::TRACKER_EXTRA_FIELD_ID)) $criteria->add(TrackerExtraFieldElementPeer::TRACKER_EXTRA_FIELD_ID, $this->tracker_extra_field_id);
		if ($this->isColumnModified(TrackerExtraFieldElementPeer::ELEMENT_NAME)) $criteria->add(TrackerExtraFieldElementPeer::ELEMENT_NAME, $this->element_name);
		if ($this->isColumnModified(TrackerExtraFieldElementPeer::STATUS_ID)) $criteria->add(TrackerExtraFieldElementPeer::STATUS_ID, $this->status_id);
		if ($this->isColumnModified(TrackerExtraFieldElementPeer::DEFAULT_SELECTED)) $criteria->add(TrackerExtraFieldElementPeer::DEFAULT_SELECTED, $this->default_selected);
		if ($this->isColumnModified(TrackerExtraFieldElementPeer::SORT_ORDER)) $criteria->add(TrackerExtraFieldElementPeer::SORT_ORDER, $this->sort_order);
		if ($this->isColumnModified(TrackerExtraFieldElementPeer::AUTO_ASSIGN_TO)) $criteria->add(TrackerExtraFieldElementPeer::AUTO_ASSIGN_TO, $this->auto_assign_to);
		if ($this->isColumnModified(TrackerExtraFieldElementPeer::CAN_COMMIT)) $criteria->add(TrackerExtraFieldElementPeer::CAN_COMMIT, $this->can_commit);
		if ($this->isColumnModified(TrackerExtraFieldElementPeer::ALIAS)) $criteria->add(TrackerExtraFieldElementPeer::ALIAS, $this->alias);
		return $criteria;			
	}
	
	

	/**
	 * @var TrackerExtraField	  
	 */
	protected $aTrackerExtraField;

	/**
	 * Declares an association between this object and a TrackerExtraField object
	 *
	 * @param TrackerExtraField $v
	 * @return void
	 * @throws PropelException
	 */
	public function setTrackerExtraField($v)
	{
			
		if ($v === null) {
			$this->setTrackerExtraFieldId(NULL);
		} else {
			$this->setTrackerExtraFieldId($v->getTrackerExtraFieldId());
		}
   
		$this->aTrackerExtraField = $v;
	}


	/**
	 * Get the associated TrackerExtraField object
	 *
	 * @param Connection Optional Connection object.
	 * @return TrackerExtraField The associated TrackerExtraField object.
	 * @throws PropelException
	 */
	public function getTrackerExtraField($con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerExtraFieldPeer.php';

		if ($this->aTrackerExtraField === null && ($this->tracker_extra_field_id !== null)) {
	
			$this->aTrackerExtraField = TrackerExtraFieldPeer::retrieveByPK($this->tracker_extra_field_id, $con);
	
			/* The following can be used instead of the line above to
			   guarantee the related object contains a reference
			   to this object, but this level of coupling
			   may be undesirable in many circumstances.
			   As it can lead to a db query with many results that may
			   never be used.
			   $obj = TrackerExtraFieldPeer::retrieveByPK($this->tracker_extra_field_id, $con);
			   $obj->addTrackerExtraFieldElements($this);
			 */
		}
		return $this->aTrackerExtraField;
	}

	/**
	 * Provides convenient way to set a relationship based on a
	 * key.  e.g.
	 * <code>$bar->setFooKey($foo->getPrimaryKey())</code>
	 *
 
	 * @return void
	 * @throws PropelException
	 */
	public function setTrackerExtraFieldKey($key)
	{

		$this->setTrackerExtraFieldId( (int) $key);			
		
	}

	/**
	 * Collection to store aggregation of collTrackerEfeTransitionTriggers	  
	 * @var array
	 */
	protected $collTrackerEfeTransitionTriggers; 

	/**
	 * Temporary storage of collTrackerEfeTransitionTriggers to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initTrackerEfeTransitionTriggers()
	{
		if ($this->collTrackerEfeTransitionTriggers === null) {
			$this->collTrackerEfeTransitionTriggers = array();
		}
	}

	/**
	 * Method called to associate a TrackerEfeTransitionTrigger object to this object
	 * through the TrackerEfeTransitionTrigger foreign key attribute
	 *
	 * @param TrackerEfeTransitionTrigger $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addTrackerEfeTransitionTrigger(TrackerEfeTransitionTrigger $l)
	{
		$this->collTrackerEfeTransitionTriggers[] = $l;
		$l->setTrackerExtraFieldElement($this);
	}

	/**
	 * The criteria used to select the current contents of collTrackerEfeTransitionTriggers.
	 * @var Criteria
	 */
	private $lastTrackerEfeTransitionTriggersCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this TrackerExtraFieldElement has previously
	 * been saved, it will retrieve related TrackerEfeTransitionTriggers from storage.
	 * If this TrackerExtraFieldElement is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getTrackerEfeTransitionTriggers($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerEfeTransitionTriggerPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collTrackerEfeTransitionTriggers === null) {
			if ($this->isNew()) {
			   $this->collTrackerEfeTransitionTriggers = array();
			} else {
	
				$criteria->add(TrackerEfeTransitionTriggerPeer::TO_ELEMENT_ID, $this->getElementId() );

				$this->collTrackerEfeTransitionTriggers = TrackerEfeTransitionTriggerPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(TrackerEfeTransitionTriggerPeer::TO_ELEMENT_ID, $this->getElementId());

				if (!isset($this->lastTrackerEfeTransitionTriggersCriteria) || !$this->lastTrackerEfeTransitionTriggersCriteria->equals($criteria)) {
					$this->collTrackerEfeTransitionTriggers = TrackerEfeTransitionTriggerPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastTrackerEfeTransitionTriggersCriteria = $criteria;

		return $this->collTrackerEfeTransitionTriggers;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this TrackerExtraFieldElement is new, it will return
	 * an empty collection; or if this TrackerExtraFieldElement has previously
	 * been saved, it will retrieve related TrackerEfeTransitionTriggers from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in TrackerExtraFieldElement.
	 */
	public function getTrackerEfeTransitionTriggersJoinTrackerExtraFieldElementTransition($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerEfeTransitionTriggerPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collTrackerEfeTransitionTriggers === null) {
			if ($this->isNew()) {
			   $this->collTrackerEfeTransitionTriggers = array();
			} else {
	   
				$criteria->add(TrackerEfeTransitionTriggerPeer::TO_ELEMENT_ID, $this->getElementId());
				$this->collTrackerEfeTransitionTriggers = TrackerEfeTransitionTriggerPeer::doSelectJoinTrackerExtraFieldElementTransition($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(TrackerEfeTransitionTriggerPeer::TO_ELEMENT_ID, $this->getElementId());
			if (!isset($this->lastTrackerEfeTransitionTriggersCriteria) || !$this->lastTrackerEfeTransitionTriggersCriteria->equals($criteria)) {
				$this->collTrackerEfeTransitionTriggers = TrackerEfeTransitionTriggerPeer::doSelectJoinTrackerExtraFieldElementTransition($criteria, $con);
			}
		}
		$this->lastTrackerEfeTransitionTriggersCriteria = $criteria;

		return $this->collTrackerEfeTransitionTriggers;
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this TrackerExtraFieldElement is new, it will return
	 * an empty collection; or if this TrackerExtraFieldElement has previously
	 * been saved, it will retrieve related TrackerEfeTransitionTriggers from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in TrackerExtraFieldElement.
	 */
	public function getTrackerEfeTransitionTriggersJoinTrackerExtraField($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerEfeTransitionTriggerPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collTrackerEfeTransitionTriggers === null) {
			if ($this->isNew()) {
			   $this->collTrackerEfeTransitionTriggers = array();
			} else {
	   
				$criteria->add(TrackerEfeTransitionTriggerPeer::TO_ELEMENT_ID, $this->getElementId());
				$this->collTrackerEfeTransitionTriggers = TrackerEfeTransitionTriggerPeer::doSelectJoinTrackerExtraField($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(TrackerEfeTransitionTriggerPeer::TO_ELEMENT_ID, $this->getElementId());
			if (!isset($this->lastTrackerEfeTransitionTriggersCriteria) || !$this->lastTrackerEfeTransitionTriggersCriteria->equals($criteria)) {
				$this->collTrackerEfeTransitionTriggers = TrackerEfeTransitionTriggerPeer::doSelectJoinTrackerExtraField($criteria, $con);
			}
		}
		$this->lastTrackerEfeTransitionTriggersCriteria = $criteria;

		return $this->collTrackerEfeTransitionTriggers;
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this TrackerExtraFieldElement is new, it will return
	 * an empty collection; or if this TrackerExtraFieldElement has previously
	 * been saved, it will retrieve related TrackerEfeTransitionTriggers from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in TrackerExtraFieldElement.
	 */
	public function getTrackerEfeTransitionTriggersJoinTrackerExtraFieldElement($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerEfeTransitionTriggerPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collTrackerEfeTransitionTriggers === null) {
			if ($this->isNew()) {
			   $this->collTrackerEfeTransitionTriggers = array();
			} else {
	   
				$criteria->add(TrackerEfeTransitionTriggerPeer::TO_ELEMENT_ID, $this->getElementId());
				$this->collTrackerEfeTransitionTriggers = TrackerEfeTransitionTriggerPeer::doSelectJoinTrackerExtraFieldElement($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(TrackerEfeTransitionTriggerPeer::TO_ELEMENT_ID, $this->getElementId());
			if (!isset($this->lastTrackerEfeTransitionTriggersCriteria) || !$this->lastTrackerEfeTransitionTriggersCriteria->equals($criteria)) {
				$this->collTrackerEfeTransitionTriggers = TrackerEfeTransitionTriggerPeer::doSelectJoinTrackerExtraFieldElement($criteria, $con);
			}
		}
		$this->lastTrackerEfeTransitionTriggersCriteria = $criteria;

		return $this->collTrackerEfeTransitionTriggers;
	}

	/**
	 * Collection to store aggregation of collTrackerCommitTriggers	  
	 * @var array
	 */
	protected $collTrackerCommitTriggers; 

	/**
	 * Temporary storage of collTrackerCommitTriggers to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initTrackerCommitTriggers()
	{
		if ($this->collTrackerCommitTriggers === null) {
			$this->collTrackerCommitTriggers = array();
		}
	}

	/**
	 * Method called to associate a TrackerCommitTrigger object to this object
	 * through the TrackerCommitTrigger foreign key attribute
	 *
	 * @param TrackerCommitTrigger $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addTrackerCommitTrigger(TrackerCommitTrigger $l)
	{
		$this->collTrackerCommitTriggers[] = $l;
		$l->setTrackerExtraFieldElement($this);
	}

	/**
	 * The criteria used to select the current contents of collTrackerCommitTriggers.
	 * @var Criteria
	 */
	private $lastTrackerCommitTriggersCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this TrackerExtraFieldElement has previously
	 * been saved, it will retrieve related TrackerCommitTriggers from storage.
	 * If this TrackerExtraFieldElement is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getTrackerCommitTriggers($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerCommitTriggerPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collTrackerCommitTriggers === null) {
			if ($this->isNew()) {
			   $this->collTrackerCommitTriggers = array();
			} else {
	
				$criteria->add(TrackerCommitTriggerPeer::TO_ELEMENT_ID, $this->getElementId() );

				$this->collTrackerCommitTriggers = TrackerCommitTriggerPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(TrackerCommitTriggerPeer::TO_ELEMENT_ID, $this->getElementId());

				if (!isset($this->lastTrackerCommitTriggersCriteria) || !$this->lastTrackerCommitTriggersCriteria->equals($criteria)) {
					$this->collTrackerCommitTriggers = TrackerCommitTriggerPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastTrackerCommitTriggersCriteria = $criteria;

		return $this->collTrackerCommitTriggers;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this TrackerExtraFieldElement is new, it will return
	 * an empty collection; or if this TrackerExtraFieldElement has previously
	 * been saved, it will retrieve related TrackerCommitTriggers from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in TrackerExtraFieldElement.
	 */
	public function getTrackerCommitTriggersJoinTracker($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerCommitTriggerPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collTrackerCommitTriggers === null) {
			if ($this->isNew()) {
			   $this->collTrackerCommitTriggers = array();
			} else {
	   
				$criteria->add(TrackerCommitTriggerPeer::TO_ELEMENT_ID, $this->getElementId());
				$this->collTrackerCommitTriggers = TrackerCommitTriggerPeer::doSelectJoinTracker($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(TrackerCommitTriggerPeer::TO_ELEMENT_ID, $this->getElementId());
			if (!isset($this->lastTrackerCommitTriggersCriteria) || !$this->lastTrackerCommitTriggersCriteria->equals($criteria)) {
				$this->collTrackerCommitTriggers = TrackerCommitTriggerPeer::doSelectJoinTracker($criteria, $con);
			}
		}
		$this->lastTrackerCommitTriggersCriteria = $criteria;

		return $this->collTrackerCommitTriggers;
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this TrackerExtraFieldElement is new, it will return
	 * an empty collection; or if this TrackerExtraFieldElement has previously
	 * been saved, it will retrieve related TrackerCommitTriggers from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in TrackerExtraFieldElement.
	 */
	public function getTrackerCommitTriggersJoinTrackerExtraField($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerCommitTriggerPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collTrackerCommitTriggers === null) {
			if ($this->isNew()) {
			   $this->collTrackerCommitTriggers = array();
			} else {
	   
				$criteria->add(TrackerCommitTriggerPeer::TO_ELEMENT_ID, $this->getElementId());
				$this->collTrackerCommitTriggers = TrackerCommitTriggerPeer::doSelectJoinTrackerExtraField($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(TrackerCommitTriggerPeer::TO_ELEMENT_ID, $this->getElementId());
			if (!isset($this->lastTrackerCommitTriggersCriteria) || !$this->lastTrackerCommitTriggersCriteria->equals($criteria)) {
				$this->collTrackerCommitTriggers = TrackerCommitTriggerPeer::doSelectJoinTrackerExtraField($criteria, $con);
			}
		}
		$this->lastTrackerCommitTriggersCriteria = $criteria;

		return $this->collTrackerCommitTriggers;
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this TrackerExtraFieldElement is new, it will return
	 * an empty collection; or if this TrackerExtraFieldElement has previously
	 * been saved, it will retrieve related TrackerCommitTriggers from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in TrackerExtraFieldElement.
	 */
	public function getTrackerCommitTriggersJoinTrackerExtraFieldElement($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerCommitTriggerPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collTrackerCommitTriggers === null) {
			if ($this->isNew()) {
			   $this->collTrackerCommitTriggers = array();
			} else {
	   
				$criteria->add(TrackerCommitTriggerPeer::TO_ELEMENT_ID, $this->getElementId());
				$this->collTrackerCommitTriggers = TrackerCommitTriggerPeer::doSelectJoinTrackerExtraFieldElement($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(TrackerCommitTriggerPeer::TO_ELEMENT_ID, $this->getElementId());
			if (!isset($this->lastTrackerCommitTriggersCriteria) || !$this->lastTrackerCommitTriggersCriteria->equals($criteria)) {
				$this->collTrackerCommitTriggers = TrackerCommitTriggerPeer::doSelectJoinTrackerExtraFieldElement($criteria, $con);
			}
		}
		$this->lastTrackerCommitTriggersCriteria = $criteria;

		return $this->collTrackerCommitTriggers;
	}

	/**
	 * Collection to store aggregation of collTrackerExtraFieldElementTransitionsRelatedByElementId	  
	 * @var array
	 */
	protected $collTrackerExtraFieldElementTransitionsRelatedByElementId; 

	/**
	 * Temporary storage of collTrackerExtraFieldElementTransitionsRelatedByElementId to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initTrackerExtraFieldElementTransitionsRelatedByElementId()
	{
		if ($this->collTrackerExtraFieldElementTransitionsRelatedByElementId === null) {
			$this->collTrackerExtraFieldElementTransitionsRelatedByElementId = array();
		}
	}

	/**
	 * Method called to associate a TrackerExtraFieldElementTransition object to this object
	 * through the TrackerExtraFieldElementTransition foreign key attribute
	 *
	 * @param TrackerExtraFieldElementTransition $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addTrackerExtraFieldElementTransitionRelatedByElementId(TrackerExtraFieldElementTransition $l)
	{
		$this->collTrackerExtraFieldElementTransitionsRelatedByElementId[] = $l;
		$l->setTrackerExtraFieldElementRelatedByElementId($this);
	}

	/**
	 * The criteria used to select the current contents of collTrackerExtraFieldElementTransitionsRelatedByElementId.
	 * @var Criteria
	 */
	private $lastTrackerExtraFieldElementTransitionsRelatedByElementIdCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this TrackerExtraFieldElement has previously
	 * been saved, it will retrieve related TrackerExtraFieldElementTransitionsRelatedByElementId from storage.
	 * If this TrackerExtraFieldElement is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getTrackerExtraFieldElementTransitionsRelatedByElementId($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerExtraFieldElementTransitionPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collTrackerExtraFieldElementTransitionsRelatedByElementId === null) {
			if ($this->isNew()) {
			   $this->collTrackerExtraFieldElementTransitionsRelatedByElementId = array();
			} else {
	
				$criteria->add(TrackerExtraFieldElementTransitionPeer::ELEMENT_ID, $this->getElementId() );

				$this->collTrackerExtraFieldElementTransitionsRelatedByElementId = TrackerExtraFieldElementTransitionPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(TrackerExtraFieldElementTransitionPeer::ELEMENT_ID, $this->getElementId());

				if (!isset($this->lastTrackerExtraFieldElementTransitionsRelatedByElementIdCriteria) || !$this->lastTrackerExtraFieldElementTransitionsRelatedByElementIdCriteria->equals($criteria)) {
					$this->collTrackerExtraFieldElementTransitionsRelatedByElementId = TrackerExtraFieldElementTransitionPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastTrackerExtraFieldElementTransitionsRelatedByElementIdCriteria = $criteria;

		return $this->collTrackerExtraFieldElementTransitionsRelatedByElementId;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this TrackerExtraFieldElement is new, it will return
	 * an empty collection; or if this TrackerExtraFieldElement has previously
	 * been saved, it will retrieve related TrackerExtraFieldElementTransitionsRelatedByElementId from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in TrackerExtraFieldElement.
	 */
	public function getTrackerExtraFieldElementTransitionsRelatedByElementIdJoinTrackerExtraFieldElementRelatedByToElementId($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerExtraFieldElementTransitionPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collTrackerExtraFieldElementTransitionsRelatedByElementId === null) {
			if ($this->isNew()) {
			   $this->collTrackerExtraFieldElementTransitionsRelatedByElementId = array();
			} else {
	   
				$criteria->add(TrackerExtraFieldElementTransitionPeer::ELEMENT_ID, $this->getElementId());
				$this->collTrackerExtraFieldElementTransitionsRelatedByElementId = TrackerExtraFieldElementTransitionPeer::doSelectJoinTrackerExtraFieldElementRelatedByToElementId($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(TrackerExtraFieldElementTransitionPeer::ELEMENT_ID, $this->getElementId());
			if (!isset($this->lastTrackerExtraFieldElementTransitionsRelatedByElementIdCriteria) || !$this->lastTrackerExtraFieldElementTransitionsRelatedByElementIdCriteria->equals($criteria)) {
				$this->collTrackerExtraFieldElementTransitionsRelatedByElementId = TrackerExtraFieldElementTransitionPeer::doSelectJoinTrackerExtraFieldElementRelatedByToElementId($criteria, $con);
			}
		}
		$this->lastTrackerExtraFieldElementTransitionsRelatedByElementIdCriteria = $criteria;

		return $this->collTrackerExtraFieldElementTransitionsRelatedByElementId;
	}

	/**
	 * Collection to store aggregation of collTrackerExtraFieldElementTransitionsRelatedByToElementId	  
	 * @var array
	 */
	protected $collTrackerExtraFieldElementTransitionsRelatedByToElementId; 

	/**
	 * Temporary storage of collTrackerExtraFieldElementTransitionsRelatedByToElementId to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initTrackerExtraFieldElementTransitionsRelatedByToElementId()
	{
		if ($this->collTrackerExtraFieldElementTransitionsRelatedByToElementId === null) {
			$this->collTrackerExtraFieldElementTransitionsRelatedByToElementId = array();
		}
	}

	/**
	 * Method called to associate a TrackerExtraFieldElementTransition object to this object
	 * through the TrackerExtraFieldElementTransition foreign key attribute
	 *
	 * @param TrackerExtraFieldElementTransition $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addTrackerExtraFieldElementTransitionRelatedByToElementId(TrackerExtraFieldElementTransition $l)
	{
		$this->collTrackerExtraFieldElementTransitionsRelatedByToElementId[] = $l;
		$l->setTrackerExtraFieldElementRelatedByToElementId($this);
	}

	/**
	 * The criteria used to select the current contents of collTrackerExtraFieldElementTransitionsRelatedByToElementId.
	 * @var Criteria
	 */
	private $lastTrackerExtraFieldElementTransitionsRelatedByToElementIdCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this TrackerExtraFieldElement has previously
	 * been saved, it will retrieve related TrackerExtraFieldElementTransitionsRelatedByToElementId from storage.
	 * If this TrackerExtraFieldElement is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getTrackerExtraFieldElementTransitionsRelatedByToElementId($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerExtraFieldElementTransitionPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collTrackerExtraFieldElementTransitionsRelatedByToElementId === null) {
			if ($this->isNew()) {
			   $this->collTrackerExtraFieldElementTransitionsRelatedByToElementId = array();
			} else {
	
				$criteria->add(TrackerExtraFieldElementTransitionPeer::TO_ELEMENT_ID, $this->getElementId() );

				$this->collTrackerExtraFieldElementTransitionsRelatedByToElementId = TrackerExtraFieldElementTransitionPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(TrackerExtraFieldElementTransitionPeer::TO_ELEMENT_ID, $this->getElementId());

				if (!isset($this->lastTrackerExtraFieldElementTransitionsRelatedByToElementIdCriteria) || !$this->lastTrackerExtraFieldElementTransitionsRelatedByToElementIdCriteria->equals($criteria)) {
					$this->collTrackerExtraFieldElementTransitionsRelatedByToElementId = TrackerExtraFieldElementTransitionPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastTrackerExtraFieldElementTransitionsRelatedByToElementIdCriteria = $criteria;

		return $this->collTrackerExtraFieldElementTransitionsRelatedByToElementId;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this TrackerExtraFieldElement is new, it will return
	 * an empty collection; or if this TrackerExtraFieldElement has previously
	 * been saved, it will retrieve related TrackerExtraFieldElementTransitionsRelatedByToElementId from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in TrackerExtraFieldElement.
	 */
	public function getTrackerExtraFieldElementTransitionsRelatedByToElementIdJoinTrackerExtraFieldElementRelatedByElementId($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerExtraFieldElementTransitionPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collTrackerExtraFieldElementTransitionsRelatedByToElementId === null) {
			if ($this->isNew()) {
			   $this->collTrackerExtraFieldElementTransitionsRelatedByToElementId = array();
			} else {
	   
				$criteria->add(TrackerExtraFieldElementTransitionPeer::TO_ELEMENT_ID, $this->getElementId());
				$this->collTrackerExtraFieldElementTransitionsRelatedByToElementId = TrackerExtraFieldElementTransitionPeer::doSelectJoinTrackerExtraFieldElementRelatedByElementId($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(TrackerExtraFieldElementTransitionPeer::TO_ELEMENT_ID, $this->getElementId());
			if (!isset($this->lastTrackerExtraFieldElementTransitionsRelatedByToElementIdCriteria) || !$this->lastTrackerExtraFieldElementTransitionsRelatedByToElementIdCriteria->equals($criteria)) {
				$this->collTrackerExtraFieldElementTransitionsRelatedByToElementId = TrackerExtraFieldElementTransitionPeer::doSelectJoinTrackerExtraFieldElementRelatedByElementId($criteria, $con);
			}
		}
		$this->lastTrackerExtraFieldElementTransitionsRelatedByToElementIdCriteria = $criteria;

		return $this->collTrackerExtraFieldElementTransitionsRelatedByToElementId;
	}

	private $fieldNames;

	/**
	 * Generate a list of field names.
	 *
	 * @return array A list of field names
	 */
	public function getFieldNames()
	{
		if ($this->fieldNames === null) {
			$this->fieldNames = array("element_id", "tracker_extra_field_id", "element_name", "status_id", "default_selected", "sort_order", "auto_assign_to", "can_commit", "alias", );
		}
		return $this->fieldNames;
	}
	
	/**
	 * Retrieves a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @return mixed Value of field.
	 */
	public function getByName($name)
	{
		switch($name) {
	  
			case TrackerExtraFieldElementPeer::ELEMENT_ID:
				return $this->getElementId();
				break;
		  
			case TrackerExtraFieldElementPeer::TRACKER_EXTRA_FIELD_ID:
				return $this->getTrackerExtraFieldId();
				break;
		  
			case TrackerExtraFieldElementPeer::ELEMENT_NAME:
				return $this->getElementName();
				break;
		  
			case TrackerExtraFieldElementPeer::STATUS_ID:
				return $this->getStatusId();
				break;
		  
			case TrackerExtraFieldElementPeer::DEFAULT_SELECTED:
				return $this->getDefaultSelected();
				break;
		  
			case TrackerExtraFieldElementPeer::SORT_ORDER:
				return $this->getSortOrder();
				break;
		  
			case TrackerExtraFieldElementPeer::AUTO_ASSIGN_TO:
				return $this->getAutoAssignTo();
				break;
		  
			case TrackerExtraFieldElementPeer::CAN_COMMIT:
				return $this->getCanCommit();
				break;
		  
			case TrackerExtraFieldElementPeer::ALIAS:
				return $this->getAlias();
				break;
	  
			default:
				return null;
				
		} // switch()
	}

	/**
	 * Retrieves a field from the object by Position as specified in the xml schema. 
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @return mixed Value of field at $pos
	 */
	public function getByPosition($pos)
	{
		switch($pos) {
  
			case 0:
				return $this->getElementId();
				break;
  
			case 1:
				return $this->getTrackerExtraFieldId();
				break;
  
			case 2:
				return $this->getElementName();
				break;
  
			case 3:
				return $this->getStatusId();
				break;
  
			case 4:
				return $this->getDefaultSelected();
				break;
  
			case 5:
				return $this->getSortOrder();
				break;
  
			case 6:
				return $this->getAutoAssignTo();
				break;
  
			case 7:
				return $this->getCanCommit();
				break;
  
			case 8:
				return $this->getAlias();
				break;
			default:
				return null;
		} // switch()
	}



	
	/**
	 * Convenience method to populate the object using an array.
	 * This is particularly useful when populating an object from one of the request arrays (e.g. $_POST).  This method
	 * goest through the column (peer) names, checking to see whether a matching key exists in populated array. If
	 * so the setByName() method is called for that column.
	 * @param array $arr An array where keys are column names.
	 * @return void
	 */
	public function populateFromArray($arr)
	{
  
		if (array_key_exists(TrackerExtraFieldElementPeer::ELEMENT_ID, $arr)) $this->setElementId($arr[TrackerExtraFieldElementPeer::ELEMENT_ID]);
  
		if (array_key_exists(TrackerExtraFieldElementPeer::TRACKER_EXTRA_FIELD_ID, $arr)) $this->setTrackerExtraFieldId($arr[TrackerExtraFieldElementPeer::TRACKER_EXTRA_FIELD_ID]);
  
		if (array_key_exists(TrackerExtraFieldElementPeer::ELEMENT_NAME, $arr)) $this->setElementName($arr[TrackerExtraFieldElementPeer::ELEMENT_NAME]);
  
		if (array_key_exists(TrackerExtraFieldElementPeer::STATUS_ID, $arr)) $this->setStatusId($arr[TrackerExtraFieldElementPeer::STATUS_ID]);
  
		if (array_key_exists(TrackerExtraFieldElementPeer::DEFAULT_SELECTED, $arr)) $this->setDefaultSelected($arr[TrackerExtraFieldElementPeer::DEFAULT_SELECTED]);
  
		if (array_key_exists(TrackerExtraFieldElementPeer::SORT_ORDER, $arr)) $this->setSortOrder($arr[TrackerExtraFieldElementPeer::SORT_ORDER]);
  
		if (array_key_exists(TrackerExtraFieldElementPeer::AUTO_ASSIGN_TO, $arr)) $this->setAutoAssignTo($arr[TrackerExtraFieldElementPeer::AUTO_ASSIGN_TO]);
  
		if (array_key_exists(TrackerExtraFieldElementPeer::CAN_COMMIT, $arr)) $this->setCanCommit($arr[TrackerExtraFieldElementPeer::CAN_COMMIT]);
  
		if (array_key_exists(TrackerExtraFieldElementPeer::ALIAS, $arr)) $this->setAlias($arr[TrackerExtraFieldElementPeer::ALIAS]);
 
	}
	
	/**
	 * Sets a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByName($name, $value)
	{
		switch($name) {
	  
			case TrackerExtraFieldElementPeer::ELEMENT_ID:
				$this->setElementId($value);
				break;
	  
			case TrackerExtraFieldElementPeer::TRACKER_EXTRA_FIELD_ID:
				$this->setTrackerExtraFieldId($value);
				break;
	  
			case TrackerExtraFieldElementPeer::ELEMENT_NAME:
				$this->setElementName($value);
				break;
	  
			case TrackerExtraFieldElementPeer::STATUS_ID:
				$this->setStatusId($value);
				break;
	  
			case TrackerExtraFieldElementPeer::DEFAULT_SELECTED:
				$this->setDefaultSelected($value);
				break;
	  
			case TrackerExtraFieldElementPeer::SORT_ORDER:
				$this->setSortOrder($value);
				break;
	  
			case TrackerExtraFieldElementPeer::AUTO_ASSIGN_TO:
				$this->setAutoAssignTo($value);
				break;
	  
			case TrackerExtraFieldElementPeer::CAN_COMMIT:
				$this->setCanCommit($value);
				break;
	  
			case TrackerExtraFieldElementPeer::ALIAS:
				$this->setAlias($value);
				break;
				  
		} // switch()
	}

	/**
	 * Sets a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByPosition($pos, $value)
	{
		switch($pos) {
  
			case 0:
				$this->setElementId($value);
				break;
  
			case 1:
				$this->setTrackerExtraFieldId($value);
				break;
  
			case 2:
				$this->setElementName($value);
				break;
  
			case 3:
				$this->setStatusId($value);
				break;
  
			case 4:
				$this->setDefaultSelected($value);
				break;
  
			case 5:
				$this->setSortOrder($value);
				break;
  
			case 6:
				$this->setAutoAssignTo($value);
				break;
  
			case 7:
				$this->setCanCommit($value);
				break;
  
			case 8:
				$this->setAlias($value);
				break;
		} // switch()
	}


 
	/**
	 * Removes this object from datastore and sets delete attribute.
	 * 
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 * @see BaseObject::setDeleted()
	 * @see BaseObject::isDeleted()
	 */
	public function delete($con = null)
	{	
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}
		
		if ($con === null)
			$con = Propel::getConnection(TrackerExtraFieldElementPeer::DATABASE_NAME);

		try {
			$con->begin();
			TrackerExtraFieldElementPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
	

	/**
	 * flag to prevent endless save loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	private $alreadyInSave = false;

	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.  This method
	 * wraps the doSave() worker method in a transaction.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
	public function save($con = null)
	{
		if ($this->isDeleted()) {
		//	throw new PropelException("You cannot save an object that has been deleted.");
			return;
		}
		
		if ($con === null)
			$con = Propel::getConnection(TrackerExtraFieldElementPeer::DATABASE_NAME);

		try {
			$con->begin();
			$this->doSave($con);			
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
  
	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
		protected function doSave($con)	{ 
		
	 
		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;

			// We call the save method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.
 
			if ($this->aTrackerExtraField !== null) {
				if ($this->aTrackerExtraField->isModified()) $this->aTrackerExtraField->save($con);
				$this->setTrackerExtraField($this->aTrackerExtraField);
			}

			// If this object has been modified, then save it to the database.
			if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = TrackerExtraFieldElementPeer::doInsert($this, $con);
					$this->setElementId( $pk );  //[IMV] update autoincrement primary key
					$this->setNew(false);
				} else {
					TrackerExtraFieldElementPeer::doUpdate($this, $con);
				}			
				$this->resetModified(); // [HL] After being saved an object is no longer 'modified'
			}
			if ($this->collTrackerEfeTransitionTriggers !== null) {
				for ($i=0,$size=count($this->collTrackerEfeTransitionTriggers); $i < $size; $i++) {
					$this->collTrackerEfeTransitionTriggers[$i]->save($con);
				}
			  }
			if ($this->collTrackerCommitTriggers !== null) {
				for ($i=0,$size=count($this->collTrackerCommitTriggers); $i < $size; $i++) {
					$this->collTrackerCommitTriggers[$i]->save($con);
				}
			  }
			if ($this->collTrackerExtraFieldElementTransitionsRelatedByElementId !== null) {
				for ($i=0,$size=count($this->collTrackerExtraFieldElementTransitionsRelatedByElementId); $i < $size; $i++) {
					$this->collTrackerExtraFieldElementTransitionsRelatedByElementId[$i]->save($con);
				}
			  }
			if ($this->collTrackerExtraFieldElementTransitionsRelatedByToElementId !== null) {
				for ($i=0,$size=count($this->collTrackerExtraFieldElementTransitionsRelatedByToElementId); $i < $size; $i++) {
					$this->collTrackerExtraFieldElementTransitionsRelatedByToElementId[$i]->save($con);
				}
			  }

			$this->alreadyInSave = false;
		}
	}

	/**
	 * Validates the objects modified field values.
	 * This includes all objects related to this table.
	 *
	 * If $columns is either a column name or an array of column names
	 * only those columns are validated.
	 *
	 * @param mixed $columns Column name or an array of column names.
	 *
	 * @return mixed <code>true</code> if all columns pass validation
	 *			  or an array of <code>ValidationFailed</code> objects for columns that fail.
	 */
	public function validate($columns = null)
	{
	  if ($columns)
	  {
		return TrackerExtraFieldElementPeer::doValidate($this, $columns);
	  }

		return $this->doValidate();
	}

	/**
	 * flag to prevent endless validation loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	protected $alreadyInValidation = false;
  
	/**
	 * This function performs the validation work for complex object models.
	 * 
	 * In addition to checking the current object, all related objects will
	 * also be validated.  If all pass then <code>true</code> is returned; otherwise
	 * an aggreagated array of ValidationFailed objects will be returned.
	 *
	 * @return mixed <code>true</code> if all validations pass; array of <code>ValidationFailed</code> objets otherwise.
	 */
	protected function doValidate()
	{
		if (! $this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;
	  
			$failureMap = array();	  
	  
			// We call the validate method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.
			if ($this->aTrackerExtraField !== null) {
				if (($retval = $this->aTrackerExtraField->validate()) !== true) {
					$failureMap = array_merge($failureMap, $retval);
				}
			}

			if (($retval = TrackerExtraFieldElementPeer::doValidate($this)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}
	  
			if ($this->collTrackerEfeTransitionTriggers !== null) {
				for ($i=0,$size=count($this->collTrackerEfeTransitionTriggers); $i < $size; $i++) {
					if (($retval = $this->collTrackerEfeTransitionTriggers[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
			if ($this->collTrackerCommitTriggers !== null) {
				for ($i=0,$size=count($this->collTrackerCommitTriggers); $i < $size; $i++) {
					if (($retval = $this->collTrackerCommitTriggers[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
			if ($this->collTrackerExtraFieldElementTransitionsRelatedByElementId !== null) {
				for ($i=0,$size=count($this->collTrackerExtraFieldElementTransitionsRelatedByElementId); $i < $size; $i++) {
					if (($retval = $this->collTrackerExtraFieldElementTransitionsRelatedByElementId[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
			if ($this->collTrackerExtraFieldElementTransitionsRelatedByToElementId !== null) {
				for ($i=0,$size=count($this->collTrackerExtraFieldElementTransitionsRelatedByToElementId); $i < $size; $i++) {
					if (($retval = $this->collTrackerExtraFieldElementTransitionsRelatedByToElementId[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
	  
			$this->alreadyInValidation = false;
		}
	
		return (!empty($failureMap) ? $failureMap : true);
	}
  

	/**
	 * Set the PrimaryKey.
	 *
	 * @param mixed element_id Primary key.
	 * @return void
	 * @throws PropelException	 */
	public function setPrimaryKey($key) 
	{		
		$this->setElementId($key);
	}
	

	/**
	 * Returns an id that differentiates this object from others
	 * of its class.
	 * @return int 
	 */
	public function getPrimaryKey()
	{

		return $this->getElementId();

	}

	
	/**
	 * Makes a copy of this object that will be inserted as a new row in table when saved.
	 * It creates a new object filling in the simple attributes, but skipping any primary
	 * keys that are defined for the table.
	 *  
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 *  
	 * @return TrackerExtraFieldElement Clone of current object.
	 * @throws PropelException
	 */
	public function copy($deepCopy = false) 
	{
		$copyObj = new TrackerExtraFieldElement();
		$copyObj->setTrackerExtraFieldId($this->tracker_extra_field_id);
		$copyObj->setElementName($this->element_name);
		$copyObj->setStatusId($this->status_id);
		$copyObj->setDefaultSelected($this->default_selected);
		$copyObj->setSortOrder($this->sort_order);
		$copyObj->setAutoAssignTo($this->auto_assign_to);
		$copyObj->setCanCommit($this->can_commit);
		$copyObj->setAlias($this->alias);

		if ($deepCopy) {		
			// important: setNew(false) because this affects the behavior of
			// the getter/setter methods for fkey referrer objects.
			$copyObj->setNew(false);

			foreach($this->getTrackerEfeTransitionTriggers() as $relObj) {
				$copyObj->addTrackerEfeTransitionTrigger($relObj->copy());
			}

			foreach($this->getTrackerCommitTriggers() as $relObj) {
				$copyObj->addTrackerCommitTrigger($relObj->copy());
			}

			foreach($this->getTrackerExtraFieldElementTransitionsRelatedByElementId() as $relObj) {
				$copyObj->addTrackerExtraFieldElementTransitionRelatedByElementId($relObj->copy());
			}

			foreach($this->getTrackerExtraFieldElementTransitionsRelatedByToElementId() as $relObj) {
				$copyObj->addTrackerExtraFieldElementTransitionRelatedByToElementId($relObj->copy());
			}
		} // if ($deepCopy)
		
		$copyObj->setNew(true);
		
		$copyObj->setElementId(NULL); // this is a pkey column, so set to default value

		return $copyObj;
	}
		

	/**
	 * returns a peer instance associated with this om.  Since Peer classes	
	 * are not to have any instance attributes, this method returns the
	 * same instance for all member of this class. The method could therefore
	 * be static, but this would prevent one from overriding the behavior.
	 * @return TrackerExtraFieldElementPeer
	 */
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new TrackerExtraFieldElementPeer();
		}
		return self::$peer;
	}

}
