<?php 

require_once 'propel/om/BaseObject.php';

 
require_once 'propel/om/Persistent.php';

 

include_once 'propel/util/Criteria.php';
 

// (on-demand) include_once 'plugins/tracker/lib/TrackerItem.php';
// (on-demand) include_once 'plugins/tracker/lib/TrackerItemPeer.php';
 

// (on-demand) include_once 'plugins/tracker/lib/TrackerItem.php';
// (on-demand) include_once 'plugins/tracker/lib/TrackerItemPeer.php';

include_once 'plugins/tracker/lib/TrackerItemDuplicatePeer.php';

/**
 * Base class that represents a row from the 'tracker_item_duplicate' table.
 *
 *  
 *
 * You should not use this class directly.  It should not even be
 * extended; all references should be to TrackerItemDuplicate class. 
 * 
 * @package plugins.tracker.lib 
 */
abstract class BaseTrackerItemDuplicate extends BaseObject implements Persistent {
	
	/** 
	 * The Peer class.
	 * Instance provides a convenient way of calling static methods on a class
	 * that calling code may not be able to identify.
	 * @var TrackerItemDuplicatePeer
	 */
	protected static $peer;

	/**
	 * The value for the tracker_item_id field.
	 * @var int	  
	 */
	protected $tracker_item_id;	

	/**
	 * The value for the duplicate_of_tracker_item_id field.
	 * @var int	  
	 */
	protected $duplicate_of_tracker_item_id;	
  
	/**
	 * Get the TrackerItemId column value.
	 *  
	 * @return int	  
	 */
	public function getTrackerItemId()
	{
		return $this->tracker_item_id;
	}


	/**
	 * Set the value of `tracker_item_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setTrackerItemId($v)
	{
		if ($this->tracker_item_id !== $v) {
			$this->tracker_item_id = $v;
			$this->modifiedColumns[] = TrackerItemDuplicatePeer::TRACKER_ITEM_ID;
		}
			
		if ($this->aTrackerItemRelatedByTrackerItemId !== null && $this->aTrackerItemRelatedByTrackerItemId->getTrackerItemId() !== $v) {
			$this->aTrackerItemRelatedByTrackerItemId = null;
		}
			
	}

  
	/**
	 * Get the DuplicateOfTrackerItemId column value.
	 *  
	 * @return int	  
	 */
	public function getDuplicateOfTrackerItemId()
	{
		return $this->duplicate_of_tracker_item_id;
	}


	/**
	 * Set the value of `duplicate_of_tracker_item_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setDuplicateOfTrackerItemId($v)
	{
		if ($this->duplicate_of_tracker_item_id !== $v) {
			$this->duplicate_of_tracker_item_id = $v;
			$this->modifiedColumns[] = TrackerItemDuplicatePeer::DUPLICATE_OF_TRACKER_ITEM_ID;
		}
			
		if ($this->aTrackerItemRelatedByDuplicateOfTrackerItemId !== null && $this->aTrackerItemRelatedByDuplicateOfTrackerItemId->getTrackerItemId() !== $v) {
			$this->aTrackerItemRelatedByDuplicateOfTrackerItemId = null;
		}
			
	}


	
	/**
	 * Hydrates (populates) the object variables with values from the database resultset.
	 *
	 * An offset (1-based "start column") is specified so that objects can be hydrated
	 * with a subset of the columns in the resultset rows.  This is needed, for example,
	 * for results of JOIN queries where the resultset row includes columns from two or
	 * more tables.
	 *
	 * @param ResultSet $rs The ResultSet class with cursor advanced to desired record pos.
	 * @param int $startcol 1-based offset column which indicates which restultset column to start with.
	 * @return void
	 * @throws PropelException  - Any caught Exception will be rewrapped as a PropelException.
	 */
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {
			$this->tracker_item_id = $rs->getInt($startcol + 0);					
			$this->duplicate_of_tracker_item_id = $rs->getInt($startcol + 1);					
			 
			$this->resetModified();
			$this->setNew(false);
		
		} catch (Exception $e) {
			throw new PropelException("Error populating TrackerItemDuplicate object", $e);
		}		
	
	}
	
	/**
	 * Builds a Criteria object containing the primary key for this object.
	 *
	 * Unlike buildCriteria() this method includes the primary key values regardless
	 * of whether or not they have been modified.
	 * 
	 * @return Criteria The Criteria object containing value(s) for primary key(s).
	 */
	public function buildPkeyCriteria()
	{		
		$criteria = new Criteria(TrackerItemDuplicatePeer::DATABASE_NAME);
		$criteria->add(TrackerItemDuplicatePeer::TRACKER_ITEM_ID, $this->tracker_item_id);
		$criteria->add(TrackerItemDuplicatePeer::DUPLICATE_OF_TRACKER_ITEM_ID, $this->duplicate_of_tracker_item_id);
		return $criteria;			
	}
	
	/**
	 * Build a Criteria object containing the values of all modified columns in this object.
	 *
	 * @return Criteria The Criteria object containing all modified values.
	 */
	public function buildCriteria()
	{		
		$criteria = new Criteria(TrackerItemDuplicatePeer::DATABASE_NAME);
		if ($this->isColumnModified(TrackerItemDuplicatePeer::TRACKER_ITEM_ID)) $criteria->add(TrackerItemDuplicatePeer::TRACKER_ITEM_ID, $this->tracker_item_id);
		if ($this->isColumnModified(TrackerItemDuplicatePeer::DUPLICATE_OF_TRACKER_ITEM_ID)) $criteria->add(TrackerItemDuplicatePeer::DUPLICATE_OF_TRACKER_ITEM_ID, $this->duplicate_of_tracker_item_id);
		return $criteria;			
	}
	
	

	/**
	 * @var TrackerItem	  
	 */
	protected $aTrackerItemRelatedByDuplicateOfTrackerItemId;

	/**
	 * Declares an association between this object and a TrackerItem object
	 *
	 * @param TrackerItem $v
	 * @return void
	 * @throws PropelException
	 */
	public function setTrackerItemRelatedByDuplicateOfTrackerItemId($v)
	{
			
		if ($v === null) {
			$this->setDuplicateOfTrackerItemId(NULL);
		} else {
			$this->setDuplicateOfTrackerItemId($v->getTrackerItemId());
		}
   
		$this->aTrackerItemRelatedByDuplicateOfTrackerItemId = $v;
	}


	/**
	 * Get the associated TrackerItem object
	 *
	 * @param Connection Optional Connection object.
	 * @return TrackerItem The associated TrackerItem object.
	 * @throws PropelException
	 */
	public function getTrackerItemRelatedByDuplicateOfTrackerItemId($con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerItemPeer.php';

		if ($this->aTrackerItemRelatedByDuplicateOfTrackerItemId === null && ($this->duplicate_of_tracker_item_id !== null)) {
	
			$this->aTrackerItemRelatedByDuplicateOfTrackerItemId = TrackerItemPeer::retrieveByPK($this->duplicate_of_tracker_item_id, $con);
	
			/* The following can be used instead of the line above to
			   guarantee the related object contains a reference
			   to this object, but this level of coupling
			   may be undesirable in many circumstances.
			   As it can lead to a db query with many results that may
			   never be used.
			   $obj = TrackerItemPeer::retrieveByPK($this->duplicate_of_tracker_item_id, $con);
			   $obj->addTrackerItemDuplicatesRelatedByDuplicateOfTrackerItemId($this);
			 */
		}
		return $this->aTrackerItemRelatedByDuplicateOfTrackerItemId;
	}

	/**
	 * Provides convenient way to set a relationship based on a
	 * key.  e.g.
	 * <code>$bar->setFooKey($foo->getPrimaryKey())</code>
	 *
 
	 * @return void
	 * @throws PropelException
	 */
	public function setTrackerItemRelatedByDuplicateOfTrackerItemIdKey($key)
	{

		$this->setDuplicateOfTrackerItemId( (int) $key);			
		
	}

	/**
	 * @var TrackerItem	  
	 */
	protected $aTrackerItemRelatedByTrackerItemId;

	/**
	 * Declares an association between this object and a TrackerItem object
	 *
	 * @param TrackerItem $v
	 * @return void
	 * @throws PropelException
	 */
	public function setTrackerItemRelatedByTrackerItemId($v)
	{
			
		if ($v === null) {
			$this->setTrackerItemId(NULL);
		} else {
			$this->setTrackerItemId($v->getTrackerItemId());
		}
   
		$this->aTrackerItemRelatedByTrackerItemId = $v;
	}


	/**
	 * Get the associated TrackerItem object
	 *
	 * @param Connection Optional Connection object.
	 * @return TrackerItem The associated TrackerItem object.
	 * @throws PropelException
	 */
	public function getTrackerItemRelatedByTrackerItemId($con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerItemPeer.php';

		if ($this->aTrackerItemRelatedByTrackerItemId === null && ($this->tracker_item_id !== null)) {
	
			$this->aTrackerItemRelatedByTrackerItemId = TrackerItemPeer::retrieveByPK($this->tracker_item_id, $con);
	
			/* The following can be used instead of the line above to
			   guarantee the related object contains a reference
			   to this object, but this level of coupling
			   may be undesirable in many circumstances.
			   As it can lead to a db query with many results that may
			   never be used.
			   $obj = TrackerItemPeer::retrieveByPK($this->tracker_item_id, $con);
			   $obj->addTrackerItemDuplicatesRelatedByTrackerItemId($this);
			 */
		}
		return $this->aTrackerItemRelatedByTrackerItemId;
	}

	/**
	 * Provides convenient way to set a relationship based on a
	 * key.  e.g.
	 * <code>$bar->setFooKey($foo->getPrimaryKey())</code>
	 *
 
	 * @return void
	 * @throws PropelException
	 */
	public function setTrackerItemRelatedByTrackerItemIdKey($key)
	{

		$this->setTrackerItemId( (int) $key);			
		
	}

	private $fieldNames;

	/**
	 * Generate a list of field names.
	 *
	 * @return array A list of field names
	 */
	public function getFieldNames()
	{
		if ($this->fieldNames === null) {
			$this->fieldNames = array("tracker_item_id", "duplicate_of_tracker_item_id", );
		}
		return $this->fieldNames;
	}
	
	/**
	 * Retrieves a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @return mixed Value of field.
	 */
	public function getByName($name)
	{
		switch($name) {
	  
			case TrackerItemDuplicatePeer::TRACKER_ITEM_ID:
				return $this->getTrackerItemId();
				break;
		  
			case TrackerItemDuplicatePeer::DUPLICATE_OF_TRACKER_ITEM_ID:
				return $this->getDuplicateOfTrackerItemId();
				break;
	  
			default:
				return null;
				
		} // switch()
	}

	/**
	 * Retrieves a field from the object by Position as specified in the xml schema. 
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @return mixed Value of field at $pos
	 */
	public function getByPosition($pos)
	{
		switch($pos) {
  
			case 0:
				return $this->getTrackerItemId();
				break;
  
			case 1:
				return $this->getDuplicateOfTrackerItemId();
				break;
			default:
				return null;
		} // switch()
	}



	
	/**
	 * Convenience method to populate the object using an array.
	 * This is particularly useful when populating an object from one of the request arrays (e.g. $_POST).  This method
	 * goest through the column (peer) names, checking to see whether a matching key exists in populated array. If
	 * so the setByName() method is called for that column.
	 * @param array $arr An array where keys are column names.
	 * @return void
	 */
	public function populateFromArray($arr)
	{
  
		if (array_key_exists(TrackerItemDuplicatePeer::TRACKER_ITEM_ID, $arr)) $this->setTrackerItemId($arr[TrackerItemDuplicatePeer::TRACKER_ITEM_ID]);
  
		if (array_key_exists(TrackerItemDuplicatePeer::DUPLICATE_OF_TRACKER_ITEM_ID, $arr)) $this->setDuplicateOfTrackerItemId($arr[TrackerItemDuplicatePeer::DUPLICATE_OF_TRACKER_ITEM_ID]);
 
	}
	
	/**
	 * Sets a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByName($name, $value)
	{
		switch($name) {
	  
			case TrackerItemDuplicatePeer::TRACKER_ITEM_ID:
				$this->setTrackerItemId($value);
				break;
	  
			case TrackerItemDuplicatePeer::DUPLICATE_OF_TRACKER_ITEM_ID:
				$this->setDuplicateOfTrackerItemId($value);
				break;
				  
		} // switch()
	}

	/**
	 * Sets a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByPosition($pos, $value)
	{
		switch($pos) {
  
			case 0:
				$this->setTrackerItemId($value);
				break;
  
			case 1:
				$this->setDuplicateOfTrackerItemId($value);
				break;
		} // switch()
	}


 
	/**
	 * Removes this object from datastore and sets delete attribute.
	 * 
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 * @see BaseObject::setDeleted()
	 * @see BaseObject::isDeleted()
	 */
	public function delete($con = null)
	{	
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}
		
		if ($con === null)
			$con = Propel::getConnection(TrackerItemDuplicatePeer::DATABASE_NAME);

		try {
			$con->begin();
			TrackerItemDuplicatePeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
	

	/**
	 * flag to prevent endless save loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	private $alreadyInSave = false;

	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.  This method
	 * wraps the doSave() worker method in a transaction.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
	public function save($con = null)
	{
		if ($this->isDeleted()) {
		//	throw new PropelException("You cannot save an object that has been deleted.");
			return;
		}
		
		if ($con === null)
			$con = Propel::getConnection(TrackerItemDuplicatePeer::DATABASE_NAME);

		try {
			$con->begin();
			$this->doSave($con);			
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
  
	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
		protected function doSave($con)	{ 
		
	 
		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;

			// We call the save method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.
 
			if ($this->aTrackerItemRelatedByDuplicateOfTrackerItemId !== null) {
				if ($this->aTrackerItemRelatedByDuplicateOfTrackerItemId->isModified()) $this->aTrackerItemRelatedByDuplicateOfTrackerItemId->save($con);
				$this->setTrackerItemRelatedByDuplicateOfTrackerItemId($this->aTrackerItemRelatedByDuplicateOfTrackerItemId);
			}
 
			if ($this->aTrackerItemRelatedByTrackerItemId !== null) {
				if ($this->aTrackerItemRelatedByTrackerItemId->isModified()) $this->aTrackerItemRelatedByTrackerItemId->save($con);
				$this->setTrackerItemRelatedByTrackerItemId($this->aTrackerItemRelatedByTrackerItemId);
			}

			// If this object has been modified, then save it to the database.
			if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = TrackerItemDuplicatePeer::doInsert($this, $con);
					$this->setNew(false);
				} else {
					TrackerItemDuplicatePeer::doUpdate($this, $con);
				}			
				$this->resetModified(); // [HL] After being saved an object is no longer 'modified'
			}

			$this->alreadyInSave = false;
		}
	}

	/**
	 * Validates the objects modified field values.
	 * This includes all objects related to this table.
	 *
	 * If $columns is either a column name or an array of column names
	 * only those columns are validated.
	 *
	 * @param mixed $columns Column name or an array of column names.
	 *
	 * @return mixed <code>true</code> if all columns pass validation
	 *			  or an array of <code>ValidationFailed</code> objects for columns that fail.
	 */
	public function validate($columns = null)
	{
	  if ($columns)
	  {
		return TrackerItemDuplicatePeer::doValidate($this, $columns);
	  }

		return $this->doValidate();
	}

	/**
	 * flag to prevent endless validation loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	protected $alreadyInValidation = false;
  
	/**
	 * This function performs the validation work for complex object models.
	 * 
	 * In addition to checking the current object, all related objects will
	 * also be validated.  If all pass then <code>true</code> is returned; otherwise
	 * an aggreagated array of ValidationFailed objects will be returned.
	 *
	 * @return mixed <code>true</code> if all validations pass; array of <code>ValidationFailed</code> objets otherwise.
	 */
	protected function doValidate()
	{
		if (! $this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;
	  
			$failureMap = array();	  
	  
			// We call the validate method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.
			if ($this->aTrackerItemRelatedByDuplicateOfTrackerItemId !== null) {
				if (($retval = $this->aTrackerItemRelatedByDuplicateOfTrackerItemId->validate()) !== true) {
					$failureMap = array_merge($failureMap, $retval);
				}
			}
			if ($this->aTrackerItemRelatedByTrackerItemId !== null) {
				if (($retval = $this->aTrackerItemRelatedByTrackerItemId->validate()) !== true) {
					$failureMap = array_merge($failureMap, $retval);
				}
			}

			if (($retval = TrackerItemDuplicatePeer::doValidate($this)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}
	  
	  
			$this->alreadyInValidation = false;
		}
	
		return (!empty($failureMap) ? $failureMap : true);
	}
  


	private $pks = array();
	
	/**
	 * Set the PrimaryKey.
	 *
	 * @param array $keys The elements of the composite key (order must match the order in XML file).
	 * @return void
	 * @throws PropelException
	 */
	public function setPrimaryKey($keys)
	{						

		$this->setTrackerItemId($keys[0]);

		$this->setDuplicateOfTrackerItemId($keys[1]);

	}


	/**
	 * Returns an id that differentiates this object from others
	 * of its class.
	 * @return array 
	 */
	public function getPrimaryKey()
	{
		$this->pks[0] = $this->getTrackerItemId();
		$this->pks[1] = $this->getDuplicateOfTrackerItemId();
		return $this->pks;

	}

	
	/**
	 * Makes a copy of this object that will be inserted as a new row in table when saved.
	 * It creates a new object filling in the simple attributes, but skipping any primary
	 * keys that are defined for the table.
	 *  
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 *  
	 * @return TrackerItemDuplicate Clone of current object.
	 * @throws PropelException
	 */
	public function copy($deepCopy = false) 
	{
		$copyObj = new TrackerItemDuplicate();
		
		$copyObj->setNew(true);
		
		$copyObj->setTrackerItemId(NULL); // this is a pkey column, so set to default value
		$copyObj->setDuplicateOfTrackerItemId(NULL); // this is a pkey column, so set to default value

		return $copyObj;
	}
		

	/**
	 * returns a peer instance associated with this om.  Since Peer classes	
	 * are not to have any instance attributes, this method returns the
	 * same instance for all member of this class. The method could therefore
	 * be static, but this would prevent one from overriding the behavior.
	 * @return TrackerItemDuplicatePeer
	 */
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new TrackerItemDuplicatePeer();
		}
		return self::$peer;
	}

}
