<?php
require_once 'propel/util/BasePeer.php';

// The object class -- needed for instanceof checks in this class.
// actual class may be a subclass -- as returned by TrackerItemPeer::getOMClass()
include_once 'plugins/tracker/lib/TrackerItem.php';
	
include_once 'core/User.php';
include_once 'core/UserPeer.php';
	
include_once 'plugins/tracker/lib/TrackerSprint.php';
include_once 'plugins/tracker/lib/TrackerSprintPeer.php';
	
include_once 'plugins/tracker/lib/Tracker.php';
include_once 'plugins/tracker/lib/TrackerPeer.php';

/**
 * Base static class for performing query and update operations on the 'tracker_item' table.
 *
 *  
 *
 * @package plugins.tracker.lib 
 */
abstract class BaseTrackerItemPeer
{

	/** the default database name for this class */
	const DATABASE_NAME = "gf5";

	/** the table name for this class */
	const TABLE_NAME = "tracker_item";

 
	/** the column name for the TRACKER_ITEM_ID field */
	const TRACKER_ITEM_ID = "tracker_item.TRACKER_ITEM_ID";
 
	/** the column name for the TRACKER_ID field */
	const TRACKER_ID = "tracker_item.TRACKER_ID";
 
	/** the column name for the STATUS_ID field */
	const STATUS_ID = "tracker_item.STATUS_ID";
 
	/** the column name for the PRIORITY field */
	const PRIORITY = "tracker_item.PRIORITY";
 
	/** the column name for the SUBMITTED_BY field */
	const SUBMITTED_BY = "tracker_item.SUBMITTED_BY";
 
	/** the column name for the OPEN_DATE field */
	const OPEN_DATE = "tracker_item.OPEN_DATE";
 
	/** the column name for the CLOSE_DATE field */
	const CLOSE_DATE = "tracker_item.CLOSE_DATE";
 
	/** the column name for the SUMMARY field */
	const SUMMARY = "tracker_item.SUMMARY";
 
	/** the column name for the DETAILS field */
	const DETAILS = "tracker_item.DETAILS";
 
	/** the column name for the LAST_MODIFIED_DATE field */
	const LAST_MODIFIED_DATE = "tracker_item.LAST_MODIFIED_DATE";
 
	/** the column name for the LAST_MODIFIED_BY field */
	const LAST_MODIFIED_BY = "tracker_item.LAST_MODIFIED_BY";
 
	/** the column name for the SORT_ORDER field */
	const SORT_ORDER = "tracker_item.SORT_ORDER";
 
	/** the column name for the PARENT_ID field */
	const PARENT_ID = "tracker_item.PARENT_ID";
 
	/** the column name for the HAS_SUBITEMS field */
	const HAS_SUBITEMS = "tracker_item.HAS_SUBITEMS";
 
	/** the column name for the SUBITEMS_COUNT field */
	const SUBITEMS_COUNT = "tracker_item.SUBITEMS_COUNT";
 
	/** the column name for the WAITING_FOR field */
	const WAITING_FOR = "tracker_item.WAITING_FOR";
 
	/** the column name for the SPRINT_ID field */
	const SPRINT_ID = "tracker_item.SPRINT_ID";

	

	/** number of columns for this peer */
	public static $numColumns = 17;
	
	/** number of lazy load columns for this peer */
	public static $numLazyLoadColumns = 0;
	
	/** A class that can be returned by this peer. */
	const CLASS_DEFAULT = "plugins.tracker.lib.TrackerItem";

	/** The PHP to DB Name Mapping */
	private static $phpNameMap = null;

	/**
	 * @return MapBuilder the map builder for this peer
	 * @throws PropelException Any exceptions caught during processing will be
	 *		 rethrown wrapped into a PropelException.
	 */
	public static function getMapBuilder()		
	{
		include_once 'plugins/tracker/lib/map/TrackerItemMapBuilder.php';
		return BasePeer::getMapBuilder(TrackerItemMapBuilder::CLASS_NAME);
	}

	/**
	 * Gets a map (hash) of PHP names to DB column names.
	 *
	 * @return array The PHP to DB name map for this peer
	 * @throws PropelException Any exceptions caught during processing will be
	 *		 rethrown wrapped into a PropelException.
	 * @todo Consider having template build the array rather than doing it at runtime.
	 */
	public static function getPhpNameMap()
	{
		if (self::$phpNameMap === null) {
			$map = TrackerItemPeer::getTableMap();
			$columns = $map->getColumns();
			$nameMap = array();
			foreach ($columns as $column) {
				$nameMap[$column->getPhpName()] = $column->getColumnName();
			}
			self::$phpNameMap = $nameMap;
		}
		return self::$phpNameMap;
	}
	
	/**
	 * Convenience method which changes table.column to alias.column.
	 *
	 * Using this method you can maintain SQL abstraction while using column aliases.
	 * <code>
	 *		$c->addAlias("alias1", TablePeer::TABLE_NAME);
	 *		$c->addJoin(TablePeer::alias("alias1", TablePeer::PRIMARY_KEY_COLUMN), TablePeer::PRIMARY_KEY_COLUMN);
	 * </code>
	 * @param string $alias The alias for the current table.
	 * @param string $column The column name for current table. (i.e. TrackerItemPeer::COLUMN_NAME).
	 * @return string
	 */
	public static function alias($alias, $column)
	{
		return $alias . substr($column, strlen(self::TABLE_NAME));
	}
	
	/**
	 * Add all the columns needed to create a new object.
	 * 
	 * Note: any columns that were marked with lazyLoad="true" in the
	 * XML schema will not be added to the select list and only loaded
	 * on demand.
	 *
	 * @param criteria object containing the columns to add.
	 * @throws PropelException Any exceptions caught during processing will be
	 *		 rethrown wrapped into a PropelException.
	 */
	public static function addSelectColumns(Criteria $criteria)
	{
		$criteria->addSelectColumn(self::TRACKER_ITEM_ID);
		$criteria->addSelectColumn(self::TRACKER_ID);
		$criteria->addSelectColumn(self::STATUS_ID);
		$criteria->addSelectColumn(self::PRIORITY);
		$criteria->addSelectColumn(self::SUBMITTED_BY);
		$criteria->addSelectColumn(self::OPEN_DATE);
		$criteria->addSelectColumn(self::CLOSE_DATE);
		$criteria->addSelectColumn(self::SUMMARY);
		$criteria->addSelectColumn(self::DETAILS);
		$criteria->addSelectColumn(self::LAST_MODIFIED_DATE);
		$criteria->addSelectColumn(self::LAST_MODIFIED_BY);
		$criteria->addSelectColumn(self::SORT_ORDER);
		$criteria->addSelectColumn(self::PARENT_ID);
		$criteria->addSelectColumn(self::HAS_SUBITEMS);
		$criteria->addSelectColumn(self::SUBITEMS_COUNT);
		$criteria->addSelectColumn(self::WAITING_FOR);
		$criteria->addSelectColumn(self::SPRINT_ID);
	}
	
	const COUNT = "COUNT(tracker_item.TRACKER_ITEM_ID)";
	const COUNT_DISTINCT = "COUNT(DISTINCT tracker_item.TRACKER_ITEM_ID)";
  
	/**
	 * Returns the number of rows matching criteria.
	 *
	 * @param Criteria $criteria
	 * @param boolean $distinct Whether to select only distinct columns.
	 * @param Connection $con
	 * @return int Number of matching rows.
	 */
	public static function doCount(Criteria $criteria, $distinct = false, $con = null)
	{   
		// we're going to modify criteria, so copy it first
		$criteria = clone $criteria;
		
		// clear out anything that might confuse the ORDER BY clause
		$criteria->clearSelectColumns()->clearOrderByColumns();
		if ($distinct || in_array(Criteria::DISTINCT, $criteria->getSelectModifiers())) {
			$criteria->addSelectColumn(TrackerItemPeer::COUNT_DISTINCT);
		} else {
			$criteria->addSelectColumn(TrackerItemPeer::COUNT);	
		}
		
		$rs = TrackerItemPeer::doSelectRS($criteria, $con);		
		if ($rs->next()) {
			return $rs->getInt(1);
		} else {
			// no rows returned; we infer that means 0 matches.
			return 0;
		}
	}
  
	/**
	 * Method to select one object from the DB.
	 *
	 * @param Criteria $criteria object used to create the SELECT statement.
	 * @param Connection $con
	 * @return TrackerItem	 * @throws PropelException Any exceptions caught during processing will be
	 *		 rethrown wrapped into a PropelException.
	 */
	public static function doSelectOne(Criteria $criteria, $con = null)
	{
		$critcopy = clone $criteria;
		$critcopy->setLimit(1);
		$objects = TrackerItemPeer::doSelect($critcopy, $con);
		if ($objects) {
			return $objects[0];
		}
		return null;
	}

	/**
	 * Method to do selects.
	 *
	 * @param Criteria $criteria The Criteria object used to build the SELECT statement.
	 * @param Connection $con
	 * @return array Array of selected Objects
	 * @throws PropelException Any exceptions caught during processing will be
	 *		 rethrown wrapped into a PropelException.
	 */
	public static function doSelect(Criteria $criteria, $con = null)
	{
		return TrackerItemPeer::populateObjects(TrackerItemPeer::doSelectRS($criteria, $con));
	}
	
	/**
	 * Prepares the Criteria object and uses the parent doSelect()
	 * method to get a ResultSet.
	 * 
	 * Use this method directly if you want to just get the resultset
	 * (instead of an array of objects).
	 *
	 * @param Criteria $criteria The Criteria object used to build the SELECT statement.
	 * @param Connection $con the connection to use
	 * @throws PropelException Any exceptions caught during processing will be
	 *		 rethrown wrapped into a PropelException.
	 * @return ResultSet The resultset object with numerically-indexed fields.
	 * @see BasePeer::doSelect()
	 */
	public static function doSelectRS(Criteria $criteria, $con = null)
	{
		if ($con === null) {
			$con = Propel::getConnection(self::DATABASE_NAME);
		}				

		if (!$criteria->getSelectColumns()) {
			TrackerItemPeer::addSelectColumns($criteria);
		}
	
		// Set the correct dbName
		$criteria->setDbName(self::DATABASE_NAME);
		
		// BasePeer returns a Creole ResultSet, set to return
		// rows indexed numerically.		   
		return BasePeer::doSelect($criteria, $con);
	}

	/**
	 * The returned array will contain objects of the default type or
	 * objects that inherit from the default.
	 *
	 * @throws PropelException Any exceptions caught during processing will be
	 *		 rethrown wrapped into a PropelException.
	 */
	public static function populateObjects(ResultSet $rs)
	{
		$results = array();
		
		// set the class once to avoid overhead in the loop
		$cls = TrackerItemPeer::getOMClass();
		$cls = Propel::import($cls);

		// populate the object(s)
		while($rs->next()) {
			
			$obj = new $cls();
			$obj->hydrate($rs);
			$results[] = $obj;
		}
		return $results;
	}



	/**
	 * The class that the Peer will make instances of.
	 * If the BO is abstract then you must implement this method
	 * in the BO.
	 *
	 * @throws PropelException Any exceptions caught during processing will be
	 *		 rethrown wrapped into a PropelException.
	 */
	public static function getOMClass()
	{ 
		return self::CLASS_DEFAULT;
		 
	}
 

	/**
	 * Method perform an INSERT on the database, given a TrackerItem or Criteria object.
	 *
	 * @param mixed $values Criteria or TrackerItem object containing data that is used to create the INSERT statement.
	 * @param Connection $con the connection to use
	 * @return mixed The new primary key.
	 * @throws PropelException Any exceptions caught during processing will be
	 *		 rethrown wrapped into a PropelException.
	 */
	public static function doInsert($values, $con = null)
	{		
		if ($con === null)
			$con = Propel::getConnection(self::DATABASE_NAME);

		if ($values instanceof Criteria) {
			$criteria = $values;
		} else {
			$criteria = $values->buildCriteria();
		}
		
		
		$criteria->remove(self::TRACKER_ITEM_ID); // remove pkey col since this table uses auto-increment
		 
		
		// Set the correct dbName
		$criteria->setDbName(self::DATABASE_NAME);
		
		try {
			// use transaction because $criteria could contain info
			// for more than one table (I guess, conceivably)
			$con->begin();
			$pk = BasePeer::doInsert($criteria, $con);
			$con->commit();
		} catch(PropelException $e) {
			$con->rollback();
			throw $e;
		}
		
		return $pk;		
	}

	/**
	 * Method perform an UPDATE on the database, given a TrackerItem or Criteria object.
	 *
	 * @param mixed $values Criteria or TrackerItem object containing data that is used to create the UPDATE statement.
	 * @param Connection $con The connection to use (specify Connection object to exert more control over transactions).
	 * @return int The number of affected rows (if supported by underlying database driver).
	 * @throws PropelException Any exceptions caught during processing will be
	 *		 rethrown wrapped into a PropelException.
	 */
	public static function doUpdate($values, $con = null)
	{			
		if ($con === null) {
			$con = Propel::getConnection(self::DATABASE_NAME);
		}
		
		$selectCriteria = new Criteria(self::DATABASE_NAME);
				
		if ($values instanceof Criteria) {
			$criteria = $values;
			$selectCriteria->put(self::TRACKER_ITEM_ID, $criteria->remove(self::TRACKER_ITEM_ID));
 
		} else { // $values is TrackerItem object
			$criteria = $values->buildCriteria(); // gets full criteria
			$selectCriteria = $values->buildPkeyCriteria(); // gets criteria w/ primary key(s)			
		}	
		
		// set the correct dbName
		$criteria->setDbName(self::DATABASE_NAME);
		
		return BasePeer::doUpdate($selectCriteria, $criteria, $con);		
	}   
	
	/**
	 * Method to DELETE all rows from the tracker_item table.
	 *
	 * @return int The number of affected rows (if supported by underlying database driver).
	 */
	public static function doDeleteAll($con = null) 
	{
		if ($con === null) $con = Propel::getConnection(self::DATABASE_NAME);
		$affectedRows = 0; // initialize var to track total num of affected rows		
		try {
			// use transaction because $criteria could contain info
			// for more than one table or we could emulating ON DELETE CASCADE, etc.
			$con->begin();
			 
			$affectedRows += BasePeer::doDeleteAll(self::TABLE_NAME, $con);
			$con->commit();
			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
	
	/**
	 * Method perform a DELETE on the database, given a TrackerItem or Criteria object OR a primary key value.
	 *
	 * @param mixed $values Criteria or TrackerItem object or primary key which is used to create the DELETE statement 
	 * @param Connection $con the connection to use
	 * @return int 	The number of affected rows (if supported by underlying database driver).  This includes CASCADE-related rows
	 *				if supported by native driver or if emulated using Propel.
	 * @throws PropelException Any exceptions caught during processing will be
	 *		 rethrown wrapped into a PropelException.
	 */
	 public static function doDelete($values, $con = null)
	 {		
		if ($con === null)
			$con = Propel::getConnection(self::DATABASE_NAME);

		if ($values instanceof Criteria) {
			$criteria = $values;
		} elseif ($values instanceof TrackerItem) {
			$criteria = $values->buildPkeyCriteria();
		} else {
			// it must be the primary key
			$criteria = new Criteria(self::DATABASE_NAME);
			$criteria->add(self::TRACKER_ITEM_ID, $values);
		}
			 
		// Set the correct dbName
		$criteria->setDbName(self::DATABASE_NAME);
		
		$affectedRows = 0; // initialize var to track total num of affected rows		
		
		try {
			// use transaction because $criteria could contain info
			// for more than one table or we could emulating ON DELETE CASCADE, etc.
			$con->begin();
			 
			$affectedRows += BasePeer::doDelete($criteria, $con);
			$con->commit();
			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}		
	}	

	
	/**
	 * Validates all modified columns of given TrackerItem object.
	 * If parameter $columns is either a single column name or an array of column names
	 * than only those columns are validated.
	 *
	 * NOTICE: This does not apply to primary or foreign keys for now.
	 *
	 * @param TrackerItem $obj The object to validate.
	 * @param mixed $cols Column name or array of column names.
	 *
	 * @return mixed TRUE if all columns are valid or the error message of the first invalid column.
	 */
	public static function doValidate(TrackerItem $obj, $cols = null)
	{
		$columns = array();

		if ($cols)
		{
		  $dbMap = Propel::getDatabaseMap(self::DATABASE_NAME);
		  $tableMap = $dbMap->getTable(self::TABLE_NAME);

		  if (! is_array($cols)) {
			$cols = array($cols);
		  }

		  foreach($cols as $colName)
		  {
			if ($tableMap->containsColumn($colName))
			{
			  $get = 'get' . $tableMap->getColumn($colName)->getPhpName();
			  $columns[$colName] = $obj->$get();
			}
		  }
		}
		else
		{
		}

		return BasePeer::doValidate(self::DATABASE_NAME, self::TABLE_NAME, $columns);
	}
	  


	/**
	 * Retrieve a single object by pkey or NULL if not found.
	 *
	 * @param mixed $pk the primary key.
	 * @param Connection $con the connection to use
         * @return TrackerItem
	 */
	public static function retrieveByPK($pk, $con = null)
	{		
		if ($con === null) {
			$con = Propel::getConnection(self::DATABASE_NAME);
		}
		
		$criteria = new Criteria(self::DATABASE_NAME);
		$criteria->add(self::TRACKER_ITEM_ID, $pk);
						
		$v = TrackerItemPeer::doSelect($criteria, $con);
        return count($v) > 0 ? $v[0] : null;
	}

	/**
	 * Retrieve multiple objects by pkey.
	 *
	 * @param array $pks List of primary keys
	 * @param Connection $con the connection to use
	 * @throws PropelException Any exceptions caught during processing will be
	 *		 rethrown wrapped into a PropelException.
	 */
	public static function retrieveByPKs($pks, $con = null)
	{
		if ($con === null) {
			$con = Propel::getConnection(self::DATABASE_NAME);
		}
		
		$objs = null;
		if (empty($pks)) {
			$objs = array();
		} else {
			$criteria = new Criteria();
			$criteria->add(self::TRACKER_ITEM_ID, $pks, Criteria::IN);
  
			$objs = TrackerItemPeer::doSelect($criteria, $con);
		}
		return $objs;
	}

 

	/**
	 * Selects a collection of TrackerItem objects pre-filled with their
	 * User objects.
	 *
	 * @return array Array of TrackerItem objects.
	 * @throws PropelException Any exceptions caught during processing will be
	 *		 rethrown wrapped into a PropelException.
	 */
	public static function doSelectJoinUser(Criteria $c, $con = null)
	{

		// Set the correct dbName if it has not been overridden
		if ($c->getDbName() == Propel::getDefaultDB()) {
			$c->setDbName(self::DATABASE_NAME);
		}

		TrackerItemPeer::addSelectColumns($c);
		$startcol = (self::$numColumns - self::$numLazyLoadColumns) + 1;
		UserPeer::addSelectColumns($c);

			$c->addJoin(TrackerItemPeer::SUBMITTED_BY, UserPeer::USER_ID);
	 
		$rs = BasePeer::doSelect($c, $con);
		$results = array();

		while($rs->next()) {
			$omClass = TrackerItemPeer::getOMClass();
			$cls = Propel::import($omClass);
			$obj1 = new $cls();
			$obj1->hydrate($rs);

			$omClass = UserPeer::getOMClass();
			$cls = Propel::import($omClass);
			$obj2 = new $cls();
			$obj2->hydrate($rs, $startcol);

			$newObject = true;
			foreach($results as $temp_obj1) {
				$temp_obj2 = $temp_obj1->getUser();
				if ($temp_obj2->getPrimaryKey() === $obj2->getPrimaryKey()) {
					$newObject = false;
					$temp_obj2->addTrackerItem($obj1);
					break;
				}
			}
			if ($newObject) {
				$obj2->initTrackerItems();
				$obj2->addTrackerItem($obj1);
			}
			$results[] = $obj1;
		}
		return $results;
	}
	/**
	 * Selects a collection of TrackerItem objects pre-filled with their
	 * TrackerSprint objects.
	 *
	 * @return array Array of TrackerItem objects.
	 * @throws PropelException Any exceptions caught during processing will be
	 *		 rethrown wrapped into a PropelException.
	 */
	public static function doSelectJoinTrackerSprint(Criteria $c, $con = null)
	{

		// Set the correct dbName if it has not been overridden
		if ($c->getDbName() == Propel::getDefaultDB()) {
			$c->setDbName(self::DATABASE_NAME);
		}

		TrackerItemPeer::addSelectColumns($c);
		$startcol = (self::$numColumns - self::$numLazyLoadColumns) + 1;
		TrackerSprintPeer::addSelectColumns($c);

			$c->addJoin(TrackerItemPeer::SPRINT_ID, TrackerSprintPeer::SPRINT_ID);
	 
		$rs = BasePeer::doSelect($c, $con);
		$results = array();

		while($rs->next()) {
			$omClass = TrackerItemPeer::getOMClass();
			$cls = Propel::import($omClass);
			$obj1 = new $cls();
			$obj1->hydrate($rs);

			$omClass = TrackerSprintPeer::getOMClass();
			$cls = Propel::import($omClass);
			$obj2 = new $cls();
			$obj2->hydrate($rs, $startcol);

			$newObject = true;
			foreach($results as $temp_obj1) {
				$temp_obj2 = $temp_obj1->getTrackerSprint();
				if ($temp_obj2->getPrimaryKey() === $obj2->getPrimaryKey()) {
					$newObject = false;
					$temp_obj2->addTrackerItem($obj1);
					break;
				}
			}
			if ($newObject) {
				$obj2->initTrackerItems();
				$obj2->addTrackerItem($obj1);
			}
			$results[] = $obj1;
		}
		return $results;
	}
	/**
	 * Selects a collection of TrackerItem objects pre-filled with their
	 * Tracker objects.
	 *
	 * @return array Array of TrackerItem objects.
	 * @throws PropelException Any exceptions caught during processing will be
	 *		 rethrown wrapped into a PropelException.
	 */
	public static function doSelectJoinTracker(Criteria $c, $con = null)
	{

		// Set the correct dbName if it has not been overridden
		if ($c->getDbName() == Propel::getDefaultDB()) {
			$c->setDbName(self::DATABASE_NAME);
		}

		TrackerItemPeer::addSelectColumns($c);
		$startcol = (self::$numColumns - self::$numLazyLoadColumns) + 1;
		TrackerPeer::addSelectColumns($c);

			$c->addJoin(TrackerItemPeer::TRACKER_ID, TrackerPeer::TRACKER_ID);
	 
		$rs = BasePeer::doSelect($c, $con);
		$results = array();

		while($rs->next()) {
			$omClass = TrackerItemPeer::getOMClass();
			$cls = Propel::import($omClass);
			$obj1 = new $cls();
			$obj1->hydrate($rs);

			$omClass = TrackerPeer::getOMClass();
			$cls = Propel::import($omClass);
			$obj2 = new $cls();
			$obj2->hydrate($rs, $startcol);

			$newObject = true;
			foreach($results as $temp_obj1) {
				$temp_obj2 = $temp_obj1->getTracker();
				if ($temp_obj2->getPrimaryKey() === $obj2->getPrimaryKey()) {
					$newObject = false;
					$temp_obj2->addTrackerItem($obj1);
					break;
				}
			}
			if ($newObject) {
				$obj2->initTrackerItems();
				$obj2->addTrackerItem($obj1);
			}
			$results[] = $obj1;
		}
		return $results;
	}

	/**
	 * Selects a collection of TrackerItem objects pre-filled with
	 * all related objects.
	 *
	 * @return array Array of TrackerItem objects.
	 * @throws PropelException Any exceptions caught during processing will be
	 *		 rethrown wrapped into a PropelException.
	 */
	public static function doSelectJoinAll(Criteria $c, $con = null)
	{
		// Set the correct dbName if it has not been overridden
		if ($c->getDbName() == Propel::getDefaultDB()) {
			$c->setDbName(self::DATABASE_NAME);
		}

		TrackerItemPeer::addSelectColumns($c);
		$startcol2 = (self::$numColumns - self::$numLazyLoadColumns) + 1;
 
		UserPeer::addSelectColumns($c);
		$startcol3 = $startcol2 + UserPeer::$numColumns;
		 
		TrackerSprintPeer::addSelectColumns($c);
		$startcol4 = $startcol3 + TrackerSprintPeer::$numColumns;
		 
		TrackerPeer::addSelectColumns($c);
		$startcol5 = $startcol4 + TrackerPeer::$numColumns;
				$c->addJoin(TrackerItemPeer::SUBMITTED_BY, UserPeer::USER_ID);
	 		$c->addJoin(TrackerItemPeer::SPRINT_ID, TrackerSprintPeer::SPRINT_ID);
	 		$c->addJoin(TrackerItemPeer::TRACKER_ID, TrackerPeer::TRACKER_ID);
	 
		$rs = BasePeer::doSelect($c, $con);
		$results = array();
		
		while($rs->next()) {
 
			$omClass = TrackerItemPeer::getOMClass();
			
			$cls = Propel::import($omClass);
			$obj1 = new $cls();
			$obj1->hydrate($rs);
			
	 
			
			// Add objects for joined User rows
 
			$omClass = UserPeer::getOMClass();
	
			$cls = Propel::import($omClass);
			$obj2 = new $cls();
			$obj2->hydrate($rs, $startcol2);
			
			$newObject = true;
			for ($j=0, $resCount=count($results); $j < $resCount; $j++) {
				$temp_obj1 = $results[$j];
				$temp_obj2 = $temp_obj1->getUser();
				if ($temp_obj2->getPrimaryKey() === $obj2->getPrimaryKey()) {
					$newObject = false;
					$temp_obj2->addTrackerItem($obj1);
					break;
				}
			}
			
			if ($newObject) {
				$obj2->initTrackerItems();
				$obj2->addTrackerItem($obj1);
			}
	 
			
			// Add objects for joined TrackerSprint rows
 
			$omClass = TrackerSprintPeer::getOMClass();
	
			$cls = Propel::import($omClass);
			$obj3 = new $cls();
			$obj3->hydrate($rs, $startcol3);
			
			$newObject = true;
			for ($j=0, $resCount=count($results); $j < $resCount; $j++) {
				$temp_obj1 = $results[$j];
				$temp_obj3 = $temp_obj1->getTrackerSprint();
				if ($temp_obj3->getPrimaryKey() === $obj3->getPrimaryKey()) {
					$newObject = false;
					$temp_obj3->addTrackerItem($obj1);
					break;
				}
			}
			
			if ($newObject) {
				$obj3->initTrackerItems();
				$obj3->addTrackerItem($obj1);
			}
	 
			
			// Add objects for joined Tracker rows
 
			$omClass = TrackerPeer::getOMClass();
	
			$cls = Propel::import($omClass);
			$obj4 = new $cls();
			$obj4->hydrate($rs, $startcol4);
			
			$newObject = true;
			for ($j=0, $resCount=count($results); $j < $resCount; $j++) {
				$temp_obj1 = $results[$j];
				$temp_obj4 = $temp_obj1->getTracker();
				if ($temp_obj4->getPrimaryKey() === $obj4->getPrimaryKey()) {
					$newObject = false;
					$temp_obj4->addTrackerItem($obj1);
					break;
				}
			}
			
			if ($newObject) {
				$obj4->initTrackerItems();
				$obj4->addTrackerItem($obj1);
			}
				$results[] = $obj1;
		}
		return $results;
	}

	/**
	 * Selects a collection of TrackerItem objects pre-filled with
	 * all related objects except User.
	 *
	 * @return array Array of TrackerItem objects.
	 * @throws PropelException Any exceptions caught during processing will be
	 *		 rethrown wrapped into a PropelException.
	 */
	public static function doSelectJoinAllExceptUser(Criteria $c, $con = null)
	{
		// Set the correct dbName if it has not been overridden
		// $c->getDbName() will return the same object if not set to another value
		// so == check is okay and faster
		if ($c->getDbName() == Propel::getDefaultDB()) {
			$c->setDbName(self::DATABASE_NAME);
		}

		TrackerItemPeer::addSelectColumns($c);
		$startcol2 = (self::$numColumns - self::$numLazyLoadColumns) + 1;
	 
		TrackerSprintPeer::addSelectColumns($c);
		$startcol3 = $startcol2 + TrackerSprintPeer::$numColumns;
		 
		TrackerPeer::addSelectColumns($c);
		$startcol4 = $startcol3 + TrackerPeer::$numColumns;
				$c->addJoin(TrackerItemPeer::SPRINT_ID, TrackerSprintPeer::SPRINT_ID);
	 		$c->addJoin(TrackerItemPeer::TRACKER_ID, TrackerPeer::TRACKER_ID);
	 

		$rs = BasePeer::doSelect($c, $con);
		$results = array();
		
		while($rs->next()) {
				$omClass = TrackerItemPeer::getOMClass();
				
			$cls = Propel::import($omClass);
			$obj1 = new $cls();
			$obj1->hydrate($rs);
			
				$omClass = TrackerSprintPeer::getOMClass();
	
			$cls = Propel::import($omClass);
			$obj2  = new $cls();
			$obj2->hydrate($rs, $startcol2);
			
			$newObject = true;
			for ($j=0, $resCount=count($results); $j < $resCount; $j++) {
				$temp_obj1 = $results[$j];
				$temp_obj2 = $temp_obj1->getTrackerSprint();
				if ($temp_obj2->getPrimaryKey() === $obj2->getPrimaryKey()) {
					$newObject = false;
					$temp_obj2->addTrackerItem($obj1);
					break;
				}
			}
			
			if ($newObject) {
				$obj2->initTrackerItems();
				$obj2->addTrackerItem($obj1);
			}
				$omClass = TrackerPeer::getOMClass();
	
			$cls = Propel::import($omClass);
			$obj3  = new $cls();
			$obj3->hydrate($rs, $startcol3);
			
			$newObject = true;
			for ($j=0, $resCount=count($results); $j < $resCount; $j++) {
				$temp_obj1 = $results[$j];
				$temp_obj3 = $temp_obj1->getTracker();
				if ($temp_obj3->getPrimaryKey() === $obj3->getPrimaryKey()) {
					$newObject = false;
					$temp_obj3->addTrackerItem($obj1);
					break;
				}
			}
			
			if ($newObject) {
				$obj3->initTrackerItems();
				$obj3->addTrackerItem($obj1);
			}
				$results[] = $obj1;
		}
		return $results;
	}

	/**
	 * Selects a collection of TrackerItem objects pre-filled with
	 * all related objects except TrackerSprint.
	 *
	 * @return array Array of TrackerItem objects.
	 * @throws PropelException Any exceptions caught during processing will be
	 *		 rethrown wrapped into a PropelException.
	 */
	public static function doSelectJoinAllExceptTrackerSprint(Criteria $c, $con = null)
	{
		// Set the correct dbName if it has not been overridden
		// $c->getDbName() will return the same object if not set to another value
		// so == check is okay and faster
		if ($c->getDbName() == Propel::getDefaultDB()) {
			$c->setDbName(self::DATABASE_NAME);
		}

		TrackerItemPeer::addSelectColumns($c);
		$startcol2 = (self::$numColumns - self::$numLazyLoadColumns) + 1;
	 
		UserPeer::addSelectColumns($c);
		$startcol3 = $startcol2 + UserPeer::$numColumns;
		 
		TrackerPeer::addSelectColumns($c);
		$startcol4 = $startcol3 + TrackerPeer::$numColumns;
				$c->addJoin(TrackerItemPeer::SUBMITTED_BY, UserPeer::USER_ID);
	 		$c->addJoin(TrackerItemPeer::TRACKER_ID, TrackerPeer::TRACKER_ID);
	 

		$rs = BasePeer::doSelect($c, $con);
		$results = array();
		
		while($rs->next()) {
				$omClass = TrackerItemPeer::getOMClass();
				
			$cls = Propel::import($omClass);
			$obj1 = new $cls();
			$obj1->hydrate($rs);
			
				$omClass = UserPeer::getOMClass();
	
			$cls = Propel::import($omClass);
			$obj2  = new $cls();
			$obj2->hydrate($rs, $startcol2);
			
			$newObject = true;
			for ($j=0, $resCount=count($results); $j < $resCount; $j++) {
				$temp_obj1 = $results[$j];
				$temp_obj2 = $temp_obj1->getUser();
				if ($temp_obj2->getPrimaryKey() === $obj2->getPrimaryKey()) {
					$newObject = false;
					$temp_obj2->addTrackerItem($obj1);
					break;
				}
			}
			
			if ($newObject) {
				$obj2->initTrackerItems();
				$obj2->addTrackerItem($obj1);
			}
				$omClass = TrackerPeer::getOMClass();
	
			$cls = Propel::import($omClass);
			$obj3  = new $cls();
			$obj3->hydrate($rs, $startcol3);
			
			$newObject = true;
			for ($j=0, $resCount=count($results); $j < $resCount; $j++) {
				$temp_obj1 = $results[$j];
				$temp_obj3 = $temp_obj1->getTracker();
				if ($temp_obj3->getPrimaryKey() === $obj3->getPrimaryKey()) {
					$newObject = false;
					$temp_obj3->addTrackerItem($obj1);
					break;
				}
			}
			
			if ($newObject) {
				$obj3->initTrackerItems();
				$obj3->addTrackerItem($obj1);
			}
				$results[] = $obj1;
		}
		return $results;
	}

	/**
	 * Selects a collection of TrackerItem objects pre-filled with
	 * all related objects except Tracker.
	 *
	 * @return array Array of TrackerItem objects.
	 * @throws PropelException Any exceptions caught during processing will be
	 *		 rethrown wrapped into a PropelException.
	 */
	public static function doSelectJoinAllExceptTracker(Criteria $c, $con = null)
	{
		// Set the correct dbName if it has not been overridden
		// $c->getDbName() will return the same object if not set to another value
		// so == check is okay and faster
		if ($c->getDbName() == Propel::getDefaultDB()) {
			$c->setDbName(self::DATABASE_NAME);
		}

		TrackerItemPeer::addSelectColumns($c);
		$startcol2 = (self::$numColumns - self::$numLazyLoadColumns) + 1;
	 
		UserPeer::addSelectColumns($c);
		$startcol3 = $startcol2 + UserPeer::$numColumns;
		 
		TrackerSprintPeer::addSelectColumns($c);
		$startcol4 = $startcol3 + TrackerSprintPeer::$numColumns;
				$c->addJoin(TrackerItemPeer::SUBMITTED_BY, UserPeer::USER_ID);
	 		$c->addJoin(TrackerItemPeer::SPRINT_ID, TrackerSprintPeer::SPRINT_ID);
	 

		$rs = BasePeer::doSelect($c, $con);
		$results = array();
		
		while($rs->next()) {
				$omClass = TrackerItemPeer::getOMClass();
				
			$cls = Propel::import($omClass);
			$obj1 = new $cls();
			$obj1->hydrate($rs);
			
				$omClass = UserPeer::getOMClass();
	
			$cls = Propel::import($omClass);
			$obj2  = new $cls();
			$obj2->hydrate($rs, $startcol2);
			
			$newObject = true;
			for ($j=0, $resCount=count($results); $j < $resCount; $j++) {
				$temp_obj1 = $results[$j];
				$temp_obj2 = $temp_obj1->getUser();
				if ($temp_obj2->getPrimaryKey() === $obj2->getPrimaryKey()) {
					$newObject = false;
					$temp_obj2->addTrackerItem($obj1);
					break;
				}
			}
			
			if ($newObject) {
				$obj2->initTrackerItems();
				$obj2->addTrackerItem($obj1);
			}
				$omClass = TrackerSprintPeer::getOMClass();
	
			$cls = Propel::import($omClass);
			$obj3  = new $cls();
			$obj3->hydrate($rs, $startcol3);
			
			$newObject = true;
			for ($j=0, $resCount=count($results); $j < $resCount; $j++) {
				$temp_obj1 = $results[$j];
				$temp_obj3 = $temp_obj1->getTrackerSprint();
				if ($temp_obj3->getPrimaryKey() === $obj3->getPrimaryKey()) {
					$newObject = false;
					$temp_obj3->addTrackerItem($obj1);
					break;
				}
			}
			
			if ($newObject) {
				$obj3->initTrackerItems();
				$obj3->addTrackerItem($obj1);
			}
				$results[] = $obj1;
		}
		return $results;
	}
	/**
	 * Returns the TableMap related to this peer.  This method is not
	 * needed for general use but a specific application could have a need.
	 * @return TableMap
	 * @throws PropelException Any exceptions caught during processing will be
	 *		 rethrown wrapped into a PropelException.
	 */
	protected static function getTableMap()
	{
		return Propel::getDatabaseMap(self::DATABASE_NAME)->getTable(self::TABLE_NAME);
	}
	
}

// static code to register the map builder for this Peer with the main Propel class
if (Propel::isInit()) {
	// the MapBuilder classes register themselves with Propel during initialization
	// so we need to load them here.
	try {		
		BaseTrackerItemPeer::getMapBuilder();
	} catch (Exception $e) {
		Propel::log("Could not initialize Peer: " . $e->getMessage(), Propel::LOG_ERR);
	}
} else {
	// even if Propel is not yet initialized, the map builder class can be registered
	// now and then it will be loaded when Propel initializes.
	require_once 'plugins/tracker/lib/map/TrackerItemMapBuilder.php';
	Propel::registerMapBuilder(TrackerItemMapBuilder::CLASS_NAME);
}
