<?php 

require_once 'propel/om/BaseObject.php';

 
require_once 'propel/om/Persistent.php';

 

include_once 'propel/util/Criteria.php';
 

// (on-demand) include_once 'core/Project.php';
// (on-demand) include_once 'core/ProjectPeer.php';

include_once 'plugins/tracker/lib/TrackerSprintPeer.php';

/**
 * Base class that represents a row from the 'tracker_sprint' table.
 *
 *  
 *
 * You should not use this class directly.  It should not even be
 * extended; all references should be to TrackerSprint class. 
 * 
 * @package plugins.tracker.lib 
 */
abstract class BaseTrackerSprint extends BaseObject implements Persistent {
	
	/** 
	 * The Peer class.
	 * Instance provides a convenient way of calling static methods on a class
	 * that calling code may not be able to identify.
	 * @var TrackerSprintPeer
	 */
	protected static $peer;

	/**
	 * The value for the sprint_id field.
	 * @var int	  
	 */
	protected $sprint_id;	

	/**
	 * The value for the project_id field.
	 * @var int	  
	 */
	protected $project_id;	

  /**
	 * The value for the sprint_status field.
	 * @var int	  
	 */
	protected $sprint_status = 0;	


	/**
	 * The value for the sprint_progression field.
	 * @var int	  
	 */
	protected $sprint_progression = 1;	

	/**
	 * The value for the sprint_name field.
	 * @var string	  
	 */
	protected $sprint_name = '3';	

	/**
	 * The value for the sprint_start field.
	 * @var int	  
	 */
	protected $sprint_start = -1;	

	/**
	 * The value for the sprint_end field.
	 * @var int	  
	 */
	protected $sprint_end;	
  
	/**
	 * Get the SprintId column value.
	 *  
	 * @return int	  
	 */
	public function getSprintId()
	{
		return $this->sprint_id;
	}


	/**
	 * Set the value of `sprint_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setSprintId($v)
	{
		if ($this->sprint_id !== $v) {
			$this->sprint_id = $v;
			$this->modifiedColumns[] = TrackerSprintPeer::SPRINT_ID;
		}
			
		  // update associated TrackerItem		  
		  if ($this->collTrackerItems !== null) {
			  for ($i=0,$size=count($this->collTrackerItems); $i < $size; $i++) {
				  $this->collTrackerItems[$i]->setSprintId($v);
			  }
		  }
			  		
	}

  
	/**
	 * Get the ProjectId column value.
	 *  
	 * @return int	  
	 */
	public function getProjectId()
	{
		return $this->project_id;
	}


	/**
	 * Set the value of `project_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setProjectId($v)
	{
		if ($this->project_id !== $v) {
			$this->project_id = $v;
			$this->modifiedColumns[] = TrackerSprintPeer::PROJECT_ID;
		}
			
		if ($this->aProject !== null && $this->aProject->getProjectId() !== $v) {
			$this->aProject = null;
		}
			
	}

  /**
	 * Get the SprintStatus column value.
	 *  
	 * @return int	  
	 */
	public function getSprintStatus()
	{
		return $this->sprint_status;
	}


	/**
	 * Set the value of `sprint_status` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 *  
	 */
	public function setSprintStatus($v)
	{
		if ($this->sprint_status !== $v || $v === 1) {
			$this->sprint_status = $v;
			$this->modifiedColumns[] = TrackerSprintPeer::SPRINT_STATUS;
		}
				
	}

  
	/**
	 * Get the SprintProgression column value.
	 *  
	 * @return int	  
	 */
	public function getSprintProgression()
	{
		return $this->sprint_progression;
	}


	/**
	 * Set the value of `sprint_progression` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 *  
	 */
	public function setSprintProgression($v)
	{
		if ($this->sprint_progression !== $v || $v === 1) {
			$this->sprint_progression = $v;
			$this->modifiedColumns[] = TrackerSprintPeer::SPRINT_PROGRESSION;
		}
				
	}

  
	/**
	 * Get the SprintName column value.
	 *  
	 * @return string	  
	 */
	public function getSprintName()
	{
		return $this->sprint_name;
	}


	/**
	 * Set the value of `sprint_name` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setSprintName($v)
	{
		if ($this->sprint_name !== $v || $v === '3') {
			$this->sprint_name = $v;
			$this->modifiedColumns[] = TrackerSprintPeer::SPRINT_NAME;
		}
				
	}


	/**
	 * Get the [optionally formatted] `sprint_start` column value.
	 *  
	 * @param string $format The date/time format string (either date()-style or strftime()-style).
	 *							If format is NULL, then the integer unix timestamp will be returned.
	 * @return mixed Formatted date/time value as string or integer unix timestamp (if format is NULL).
	 * @throws PropelException - if unable to convert the date/time to timestamp.
	 */
	public function getSprintStart($format = 'Y-m-d H:i:s')
	{
		if ($this->sprint_start === null || $this->sprint_start === '') {
			return null;
		} elseif (!is_int($this->sprint_start)) {
			// a non-timestamp value was set externally, so we convert it
			$ts = strtotime($this->sprint_start);
			if ($ts === -1) {
				throw new PropelException("Unable to parse value of sprint_start as date/time value: " . var_export($this->sprint_start, true));
			}
		} else {
			$ts = $this->sprint_start;
		}
		if ($format === null) {
			return $ts;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $ts);
		} else {
			return date($format, $ts);
		}
	}


	/**
	 * Set the value of `sprint_start` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException - If passed [not-null] date/time is in an invalid format. 
	 */
	public function setSprintStart($v)
	{
		if ($v !== null && !is_int($v)) {
			$ts = strtotime($v);
			if ($ts === -1) {
				throw new PropelException("Unable to parse date/time value for sprint_start from input: " . var_export($v, true));
			}
		} else {
			$ts = $v;
		}
		if ($this->sprint_start !== $ts || $ts === -1) {
			$this->sprint_start = $ts;
			$this->modifiedColumns[] = TrackerSprintPeer::SPRINT_START;
		}
		
	}


	/**
	 * Get the [optionally formatted] `sprint_end` column value.
	 *  
	 * @param string $format The date/time format string (either date()-style or strftime()-style).
	 *							If format is NULL, then the integer unix timestamp will be returned.
	 * @return mixed Formatted date/time value as string or integer unix timestamp (if format is NULL).
	 * @throws PropelException - if unable to convert the date/time to timestamp.
	 */
	public function getSprintEnd($format = 'Y-m-d H:i:s')
	{
		if ($this->sprint_end === null || $this->sprint_end === '') {
			return null;
		} elseif (!is_int($this->sprint_end)) {
			// a non-timestamp value was set externally, so we convert it
			$ts = strtotime($this->sprint_end);
			if ($ts === -1) {
				throw new PropelException("Unable to parse value of sprint_end as date/time value: " . var_export($this->sprint_end, true));
			}
		} else {
			$ts = $this->sprint_end;
		}
		if ($format === null) {
			return $ts;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $ts);
		} else {
			return date($format, $ts);
		}
	}


	/**
	 * Set the value of `sprint_end` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException - If passed [not-null] date/time is in an invalid format. 
	 */
	public function setSprintEnd($v)
	{
		if ($v !== null && !is_int($v)) {
			$ts = strtotime($v);
			if ($ts === -1) {
				throw new PropelException("Unable to parse date/time value for sprint_end from input: " . var_export($v, true));
			}
		} else {
			$ts = $v;
		}
		if ($this->sprint_end !== $ts || $ts === -1) {
			$this->sprint_end = $ts;
			$this->modifiedColumns[] = TrackerSprintPeer::SPRINT_END;
		}
		
	}


	
	/**
	 * Hydrates (populates) the object variables with values from the database resultset.
	 *
	 * An offset (1-based "start column") is specified so that objects can be hydrated
	 * with a subset of the columns in the resultset rows.  This is needed, for example,
	 * for results of JOIN queries where the resultset row includes columns from two or
	 * more tables.
	 *
	 * @param ResultSet $rs The ResultSet class with cursor advanced to desired record pos.
	 * @param int $startcol 1-based offset column which indicates which restultset column to start with.
	 * @return void
	 * @throws PropelException  - Any caught Exception will be rewrapped as a PropelException.
	 */
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {
			$this->sprint_id = $rs->getInt($startcol + 0);					
			$this->project_id = $rs->getInt($startcol + 1);					
			$this->sprint_status = $rs->getInt($startcol + 2);					
			$this->sprint_progression = $rs->getInt($startcol + 3);					
			$this->sprint_name = $rs->getString($startcol + 4);					
			$this->sprint_start = $rs->getTimestamp($startcol + 5, null);
			$this->sprint_end = $rs->getTimestamp($startcol + 6, null);
			 
			$this->resetModified();
			$this->setNew(false);
		
		} catch (Exception $e) {
			throw new PropelException("Error populating TrackerSprint object", $e);
		}		
	
	}
	
	/**
	 * Builds a Criteria object containing the primary key for this object.
	 *
	 * Unlike buildCriteria() this method includes the primary key values regardless
	 * of whether or not they have been modified.
	 * 
	 * @return Criteria The Criteria object containing value(s) for primary key(s).
	 */
	public function buildPkeyCriteria()
	{		
		$criteria = new Criteria(TrackerSprintPeer::DATABASE_NAME);
		$criteria->add(TrackerSprintPeer::SPRINT_ID, $this->sprint_id);
		return $criteria;			
	}
	
	/**
	 * Build a Criteria object containing the values of all modified columns in this object.
	 *
	 * @return Criteria The Criteria object containing all modified values.
	 */
	public function buildCriteria()
	{		
		$criteria = new Criteria(TrackerSprintPeer::DATABASE_NAME);
		if ($this->isColumnModified(TrackerSprintPeer::SPRINT_ID)) $criteria->add(TrackerSprintPeer::SPRINT_ID, $this->sprint_id);
		if ($this->isColumnModified(TrackerSprintPeer::PROJECT_ID)) $criteria->add(TrackerSprintPeer::PROJECT_ID, $this->project_id);
		if ($this->isColumnModified(TrackerSprintPeer::SPRINT_STATUS)) $criteria->add(TrackerSprintPeer::SPRINT_STATUS, $this->sprint_status);
		if ($this->isColumnModified(TrackerSprintPeer::SPRINT_PROGRESSION)) $criteria->add(TrackerSprintPeer::SPRINT_PROGRESSION, $this->sprint_progression);
		if ($this->isColumnModified(TrackerSprintPeer::SPRINT_NAME)) $criteria->add(TrackerSprintPeer::SPRINT_NAME, $this->sprint_name);
		if ($this->isColumnModified(TrackerSprintPeer::SPRINT_START)) $criteria->add(TrackerSprintPeer::SPRINT_START, $this->sprint_start);
		if ($this->isColumnModified(TrackerSprintPeer::SPRINT_END)) $criteria->add(TrackerSprintPeer::SPRINT_END, $this->sprint_end);
		return $criteria;			
	}
	
	

	/**
	 * @var Project	  
	 */
	protected $aProject;

	/**
	 * Declares an association between this object and a Project object
	 *
	 * @param Project $v
	 * @return void
	 * @throws PropelException
	 */
	public function setProject($v)
	{
			
		if ($v === null) {
			$this->setProjectId(NULL);
		} else {
			$this->setProjectId($v->getProjectId());
		}
   
		$this->aProject = $v;
	}


	/**
	 * Get the associated Project object
	 *
	 * @param Connection Optional Connection object.
	 * @return Project The associated Project object.
	 * @throws PropelException
	 */
	public function getProject($con = null)
	{
		// include the Peer class
		include_once 'core/ProjectPeer.php';

		if ($this->aProject === null && ($this->project_id !== null)) {
	
			$this->aProject = ProjectPeer::retrieveByPK($this->project_id, $con);
	
			/* The following can be used instead of the line above to
			   guarantee the related object contains a reference
			   to this object, but this level of coupling
			   may be undesirable in many circumstances.
			   As it can lead to a db query with many results that may
			   never be used.
			   $obj = ProjectPeer::retrieveByPK($this->project_id, $con);
			   $obj->addTrackerSprints($this);
			 */
		}
		return $this->aProject;
	}

	/**
	 * Provides convenient way to set a relationship based on a
	 * key.  e.g.
	 * <code>$bar->setFooKey($foo->getPrimaryKey())</code>
	 *
 
	 * @return void
	 * @throws PropelException
	 */
	public function setProjectKey($key)
	{

		$this->setProjectId( (int) $key);			
		
	}

	/**
	 * Collection to store aggregation of collTrackerItems	  
	 * @var array
	 */
	protected $collTrackerItems; 

	/**
	 * Temporary storage of collTrackerItems to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initTrackerItems()
	{
		if ($this->collTrackerItems === null) {
			$this->collTrackerItems = array();
		}
	}

	/**
	 * Method called to associate a TrackerItem object to this object
	 * through the TrackerItem foreign key attribute
	 *
	 * @param TrackerItem $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addTrackerItem(TrackerItem $l)
	{
		$this->collTrackerItems[] = $l;
		$l->setTrackerSprint($this);
	}

	/**
	 * The criteria used to select the current contents of collTrackerItems.
	 * @var Criteria
	 */
	private $lastTrackerItemsCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this TrackerSprint has previously
	 * been saved, it will retrieve related TrackerItems from storage.
	 * If this TrackerSprint is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getTrackerItems($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerItemPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collTrackerItems === null) {
			if ($this->isNew()) {
			   $this->collTrackerItems = array();
			} else {
	
				$criteria->add(TrackerItemPeer::SPRINT_ID, $this->getSprintId() );

				$this->collTrackerItems = TrackerItemPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(TrackerItemPeer::SPRINT_ID, $this->getSprintId());

				if (!isset($this->lastTrackerItemsCriteria) || !$this->lastTrackerItemsCriteria->equals($criteria)) {
					$this->collTrackerItems = TrackerItemPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastTrackerItemsCriteria = $criteria;

		return $this->collTrackerItems;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this TrackerSprint is new, it will return
	 * an empty collection; or if this TrackerSprint has previously
	 * been saved, it will retrieve related TrackerItems from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in TrackerSprint.
	 */
	public function getTrackerItemsJoinUser($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerItemPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collTrackerItems === null) {
			if ($this->isNew()) {
			   $this->collTrackerItems = array();
			} else {
	   
				$criteria->add(TrackerItemPeer::SPRINT_ID, $this->getSprintId());
				$this->collTrackerItems = TrackerItemPeer::doSelectJoinUser($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(TrackerItemPeer::SPRINT_ID, $this->getSprintId());
			if (!isset($this->lastTrackerItemsCriteria) || !$this->lastTrackerItemsCriteria->equals($criteria)) {
				$this->collTrackerItems = TrackerItemPeer::doSelectJoinUser($criteria, $con);
			}
		}
		$this->lastTrackerItemsCriteria = $criteria;

		return $this->collTrackerItems;
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this TrackerSprint is new, it will return
	 * an empty collection; or if this TrackerSprint has previously
	 * been saved, it will retrieve related TrackerItems from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in TrackerSprint.
	 */
	public function getTrackerItemsJoinTrackerSprint($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerItemPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collTrackerItems === null) {
			if ($this->isNew()) {
			   $this->collTrackerItems = array();
			} else {
	   
				$criteria->add(TrackerItemPeer::SPRINT_ID, $this->getSprintId());
				$this->collTrackerItems = TrackerItemPeer::doSelectJoinTrackerSprint($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(TrackerItemPeer::SPRINT_ID, $this->getSprintId());
			if (!isset($this->lastTrackerItemsCriteria) || !$this->lastTrackerItemsCriteria->equals($criteria)) {
				$this->collTrackerItems = TrackerItemPeer::doSelectJoinTrackerSprint($criteria, $con);
			}
		}
		$this->lastTrackerItemsCriteria = $criteria;

		return $this->collTrackerItems;
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this TrackerSprint is new, it will return
	 * an empty collection; or if this TrackerSprint has previously
	 * been saved, it will retrieve related TrackerItems from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in TrackerSprint.
	 */
	public function getTrackerItemsJoinTracker($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerItemPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collTrackerItems === null) {
			if ($this->isNew()) {
			   $this->collTrackerItems = array();
			} else {
	   
				$criteria->add(TrackerItemPeer::SPRINT_ID, $this->getSprintId());
				$this->collTrackerItems = TrackerItemPeer::doSelectJoinTracker($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(TrackerItemPeer::SPRINT_ID, $this->getSprintId());
			if (!isset($this->lastTrackerItemsCriteria) || !$this->lastTrackerItemsCriteria->equals($criteria)) {
				$this->collTrackerItems = TrackerItemPeer::doSelectJoinTracker($criteria, $con);
			}
		}
		$this->lastTrackerItemsCriteria = $criteria;

		return $this->collTrackerItems;
	}

	private $fieldNames;

	/**
	 * Generate a list of field names.
	 *
	 * @return array A list of field names
	 */
	public function getFieldNames()
	{
		if ($this->fieldNames === null) {
			$this->fieldNames = array("sprint_id", "project_id", "sprint_status", "sprint_progression", "sprint_name", "sprint_start", "sprint_end", );
		}
		return $this->fieldNames;
	}
	
	/**
	 * Retrieves a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @return mixed Value of field.
	 */
	public function getByName($name)
	{
		switch($name) {
	  
			case TrackerSprintPeer::SPRINT_ID:
				return $this->getSprintId();
				break;
		  
			case TrackerSprintPeer::PROJECT_ID:
				return $this->getProjectId();
				break;

      case TrackerSprintPeer::SPRINT_STATUS:
				return $this->getSprintStatus();
				break;

			case TrackerSprintPeer::SPRINT_PROGRESSION:
				return $this->getSprintProgression();
				break;
		  
			case TrackerSprintPeer::SPRINT_NAME:
				return $this->getSprintName();
				break;
		  
			case TrackerSprintPeer::SPRINT_START:
				return $this->getSprintStart();
				break;
		  
			case TrackerSprintPeer::SPRINT_END:
				return $this->getSprintEnd();
				break;
	  
			default:
				return null;
				
		} // switch()
	}

	/**
	 * Retrieves a field from the object by Position as specified in the xml schema. 
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @return mixed Value of field at $pos
	 */
	public function getByPosition($pos)
	{
		switch($pos) {
  
			case 0:
				return $this->getSprintId();
				break;
  
			case 1:
				return $this->getProjectId();
				break;
  
			case 2:
				return $this->getSprintProgression();
				break;
  
			case 3:
				return $this->getSprintName();
				break;
  
			case 4:
				return $this->getSprintStart();
				break;
  
			case 5:
				return $this->getSprintEnd();
				break;
			default:
				return null;
		} // switch()
	}



	
	/**
	 * Convenience method to populate the object using an array.
	 * This is particularly useful when populating an object from one of the request arrays (e.g. $_POST).  This method
	 * goest through the column (peer) names, checking to see whether a matching key exists in populated array. If
	 * so the setByName() method is called for that column.
	 * @param array $arr An array where keys are column names.
	 * @return void
	 */
	public function populateFromArray($arr)
	{
  
		if (array_key_exists(TrackerSprintPeer::SPRINT_ID, $arr)) $this->setSprintId($arr[TrackerSprintPeer::SPRINT_ID]);
  
		if (array_key_exists(TrackerSprintPeer::PROJECT_ID, $arr)) $this->setProjectId($arr[TrackerSprintPeer::PROJECT_ID]);

    if (array_key_exists(TrackerSprintPeer::SPRINT_STATUS, $arr)) $this->setSprintStatus($arr[TrackerSprintPeer::SPRINT_STATUS]);
  
		if (array_key_exists(TrackerSprintPeer::SPRINT_PROGRESSION, $arr)) $this->setSprintProgression($arr[TrackerSprintPeer::SPRINT_PROGRESSION]);
  
		if (array_key_exists(TrackerSprintPeer::SPRINT_NAME, $arr)) $this->setSprintName($arr[TrackerSprintPeer::SPRINT_NAME]);
  
		if (array_key_exists(TrackerSprintPeer::SPRINT_START, $arr)) $this->setSprintStart($arr[TrackerSprintPeer::SPRINT_START]);
  
		if (array_key_exists(TrackerSprintPeer::SPRINT_END, $arr)) $this->setSprintEnd($arr[TrackerSprintPeer::SPRINT_END]);
 
	}
	
	/**
	 * Sets a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByName($name, $value)
	{
		switch($name) {
	  
			case TrackerSprintPeer::SPRINT_ID:
				$this->setSprintId($value);
				break;
	  
			case TrackerSprintPeer::PROJECT_ID:
				$this->setProjectId($value);
				break;

      case TrackerSprintPeer::SPRINT_STATUS:
				$this->setSprintStatus($value);
				break;
	  
			case TrackerSprintPeer::SPRINT_PROGRESSION:
				$this->setSprintProgression($value);
				break;
	  
			case TrackerSprintPeer::SPRINT_NAME:
				$this->setSprintName($value);
				break;
	  
			case TrackerSprintPeer::SPRINT_START:
				$this->setSprintStart($value);
				break;
	  
			case TrackerSprintPeer::SPRINT_END:
				$this->setSprintEnd($value);
				break;
				  
		} // switch()
	}

	/**
	 * Sets a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByPosition($pos, $value)
	{
		switch($pos) {
  
			case 0:
				$this->setSprintId($value);
				break;
  
			case 1:
				$this->setProjectId($value);
				break;
  
			case 2:
				$this->setSprintProgression($value);
				break;
  
			case 3:
				$this->setSprintName($value);
				break;
  
			case 4:
				$this->setSprintStart($value);
				break;
  
			case 5:
				$this->setSprintEnd($value);
				break;
		} // switch()
	}


 
	/**
	 * Removes this object from datastore and sets delete attribute.
	 * 
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 * @see BaseObject::setDeleted()
	 * @see BaseObject::isDeleted()
	 */
	public function delete($con = null)
	{	
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}
		
		if ($con === null)
			$con = Propel::getConnection(TrackerSprintPeer::DATABASE_NAME);

		try {
			$con->begin();
			TrackerSprintPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
	

	/**
	 * flag to prevent endless save loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	private $alreadyInSave = false;

	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.  This method
	 * wraps the doSave() worker method in a transaction.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
	public function save($con = null)
	{
		if ($this->isDeleted()) {
		//	throw new PropelException("You cannot save an object that has been deleted.");
			return;
		}
		
		if ($con === null)
			$con = Propel::getConnection(TrackerSprintPeer::DATABASE_NAME);

		try {
			$con->begin();
			$this->doSave($con);			
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
  
	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
		protected function doSave($con)	{ 
		
	 
		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;

			// We call the save method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.
 
			if ($this->aProject !== null) {
				if ($this->aProject->isModified()) $this->aProject->save($con);
				$this->setProject($this->aProject);
			}

			// If this object has been modified, then save it to the database.
			if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = TrackerSprintPeer::doInsert($this, $con);
					$this->setSprintId( $pk );  //[IMV] update autoincrement primary key
					$this->setNew(false);
				} else {
					TrackerSprintPeer::doUpdate($this, $con);
				}			
				$this->resetModified(); // [HL] After being saved an object is no longer 'modified'
			}
			if ($this->collTrackerItems !== null) {
				for ($i=0,$size=count($this->collTrackerItems); $i < $size; $i++) {
					$this->collTrackerItems[$i]->save($con);
				}
			  }

			$this->alreadyInSave = false;
		}
	}

	/**
	 * Validates the objects modified field values.
	 * This includes all objects related to this table.
	 *
	 * If $columns is either a column name or an array of column names
	 * only those columns are validated.
	 *
	 * @param mixed $columns Column name or an array of column names.
	 *
	 * @return mixed <code>true</code> if all columns pass validation
	 *			  or an array of <code>ValidationFailed</code> objects for columns that fail.
	 */
	public function validate($columns = null)
	{
	  if ($columns)
	  {
		return TrackerSprintPeer::doValidate($this, $columns);
	  }

		return $this->doValidate();
	}

	/**
	 * flag to prevent endless validation loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	protected $alreadyInValidation = false;
  
	/**
	 * This function performs the validation work for complex object models.
	 * 
	 * In addition to checking the current object, all related objects will
	 * also be validated.  If all pass then <code>true</code> is returned; otherwise
	 * an aggreagated array of ValidationFailed objects will be returned.
	 *
	 * @return mixed <code>true</code> if all validations pass; array of <code>ValidationFailed</code> objets otherwise.
	 */
	protected function doValidate()
	{
		if (! $this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;
	  
			$failureMap = array();	  
	  
			// We call the validate method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.
			if ($this->aProject !== null) {
				if (($retval = $this->aProject->validate()) !== true) {
					$failureMap = array_merge($failureMap, $retval);
				}
			}

			if (($retval = TrackerSprintPeer::doValidate($this)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}
	  
			if ($this->collTrackerItems !== null) {
				for ($i=0,$size=count($this->collTrackerItems); $i < $size; $i++) {
					if (($retval = $this->collTrackerItems[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
	  
			$this->alreadyInValidation = false;
		}
	
		return (!empty($failureMap) ? $failureMap : true);
	}
  

	/**
	 * Set the PrimaryKey.
	 *
	 * @param mixed sprint_id Primary key.
	 * @return void
	 * @throws PropelException	 */
	public function setPrimaryKey($key) 
	{		
		$this->setSprintId($key);
	}
	

	/**
	 * Returns an id that differentiates this object from others
	 * of its class.
	 * @return int 
	 */
	public function getPrimaryKey()
	{

		return $this->getSprintId();

	}

	
	/**
	 * Makes a copy of this object that will be inserted as a new row in table when saved.
	 * It creates a new object filling in the simple attributes, but skipping any primary
	 * keys that are defined for the table.
	 *  
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 *  
	 * @return TrackerSprint Clone of current object.
	 * @throws PropelException
	 */
	public function copy($deepCopy = false) 
	{
		$copyObj = new TrackerSprint();
		$copyObj->setProjectId($this->project_id);
		$copyObj->setSprintStatus($this->sprint_status);
		$copyObj->setSprintProgression($this->sprint_progression);
		$copyObj->setSprintName($this->sprint_name);
		$copyObj->setSprintStart($this->sprint_start);
		$copyObj->setSprintEnd($this->sprint_end);

		if ($deepCopy) {		
			// important: setNew(false) because this affects the behavior of
			// the getter/setter methods for fkey referrer objects.
			$copyObj->setNew(false);

			foreach($this->getTrackerItems() as $relObj) {
				$copyObj->addTrackerItem($relObj->copy());
			}
		} // if ($deepCopy)
		
		$copyObj->setNew(true);
		
		$copyObj->setSprintId(NULL); // this is a pkey column, so set to default value

		return $copyObj;
	}
		

	/**
	 * returns a peer instance associated with this om.  Since Peer classes	
	 * are not to have any instance attributes, this method returns the
	 * same instance for all member of this class. The method could therefore
	 * be static, but this would prevent one from overriding the behavior.
	 * @return TrackerSprintPeer
	 */
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new TrackerSprintPeer();
		}
		return self::$peer;
	}

}
