<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code shows a form for $OBJECT deletion
//
require_once('plugins/tracker/lib/TrackerItemPeer.php');
require_once('plugins/tracker/lib/TrackerItem.php');

$session = Session::getSession();
$Lang = $session->getLanguage();

require_once('plugins/tracker/lib/html/TrackerTemplate.php');
$theme = new TrackerTemplate();

$Project = GFUrl::getUrl()->getProject();

$tracker_id = isset($_REQUEST['tracker_id']) ? $_REQUEST['tracker_id'] : 0;
$str_tids_delete = isset($_REQUEST['tids_delete']) ? $_REQUEST['tids_delete'] : array();
$tids_delete = explode(',', $str_tids_delete);

if ($str_tids_delete == '' || count($tids_delete) == 0) {
	GFUrl::redirect($url->currentBaseURL('TrackerItemBrowse'),array('tracker_id' => $tracker_id, 'feedback' => Language::getSessLang()->getText('TrackerItem.NoTrackerItemsSelected')));
}

$Tracker = TrackerPeer::retrieveByPk($tracker_id);
if (!is_object($Tracker)) {
	throw new PermissionDeniedException();
}

$tracker_items = array();
foreach ($tids_delete as $tracker_item_id) {
	$TrackerItem = TrackerItemPeer::retrieveByPk($tracker_item_id);
	if (!is_object($TrackerItem) || !$TrackerItem->userCanDelete()) {
		throw new PermissionDeniedException();
	} else {
		$tracker_items[] = $TrackerItem;
	}
}

$params = array(
	'project' => $Project,
	'tracker' => $Tracker,
	'action' => isset($action) ? $action : '',
	'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : ''),
	'title' => $Lang->getText('TrackerItem.DeletePageTitle')
);

include('forms/TrackerItemMassDelete-tpl.php');
?>