<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code shows a form for editing TrackerItemTime
//
require_once('plugins/tracker/lib/TrackerItemTimePeer.php');
require_once('plugins/tracker/lib/TrackerItemTime.php');
require_once('exceptions/PermissionDeniedException.php');

$sess = Session::getSession();
if (!$sess->isLoggedIn()) {
	throw new NotLoggedInException();
}

$Lang = Session::getSession()->getLanguage();

$tracker_item_id = isset($_POST['tracker_item_id']) ? Validator::sanitizeInt($_POST['tracker_item_id']) : 0;
$TrackerItem = TrackerItemPeer::retrieveByPk($tracker_item_id);
if (is_object($TrackerItem)) {
	if (isset($_POST['hours']) && !empty($_POST['hours'])) {
		$tit = new TrackerItemTime();
		$tit->setTrackerItemId($tracker_item_id);
		$tit->setHours(floatval($_POST['hours']));
		$tit->setTrackerTimeCodeId(Validator::sanitizeInt($_POST['tracker_time_code_id']));
		$tit->setDateEntry(Validator::sanitizeDate($_POST['date_entry']));
		$tit->setUser($sess->getUser());
		$tit->save();
		$feedback = $Lang->getText('TrackerItemTime.Saved');
	} else {
		$feedback = $Lang->getText('TrackerItemTime.AddFailed');
	}
} else {
	$feedback = $Lang->getText('TrackerItemTime.AddFailed');
}

GFUrl::redirect($url->currentBaseURL('TrackerItemEdit', array('tracker_item_id' => $tracker_item_id, 'feedback' => $feedback)));
?>
