<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code shows a form for TrackerQuery
//
require_once('plugins/tracker/lib/TrackerQueryPeer.php');
require_once('plugins/tracker/lib/TrackerQuery.php');
require_once('GFUrl.php');
require_once('exceptions/PermissionDeniedException.php');
require_once('plugins/tracker/lib/html/TrackerExtraFieldRenderer.php');
require_once('plugins/tracker/lib/TrackerItemSavedQuery.php');

$session = Session::getSession();
$Lang = $session->getLanguage();

require_once('plugins/tracker/lib/html/TrackerTemplate.php');
$theme = new TrackerTemplate();

if (!$session->isLoggedIn()) {
	throw new NotLoggedInException();
}

$project = GFUrl::getUrl()->getProject();
$Tracker = TrackerPeer::retrieveByPk($_REQUEST['tracker_id']);
$tefr = new TrackerExtraFieldRenderer($Tracker);
$tefs = $Tracker->getTrackerExtraFields();

$tefs_arr = array();
foreach($tefs as $tef){
	$tefs_arr[$tef->getId()] = $tef->getName();
}

$tq=new TrackerItemSavedQuery($Tracker,new TrackerQuery(), $session->getUser());

$params = array(
		'project' => $project,
		'tracker' => $Tracker,
		'action' => isset($action) ? $action : '',
		'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : ''),
		'title' => $Lang->getText('TrackerQuery.AddNewPageTitle'),
		'extra_head' => array('<script language="javascript" type="text/javascript" src="/selectbox.js"></script>')
		);

//$tracker_id=((isset($_POST['tracker_id'])) ? htmlspecialchars($_POST['tracker_id']) : '' );
//$user_id=((isset($_POST['user_id'])) ? htmlspecialchars($_POST['user_id']) : '' );
$query_name=((isset($_POST['query_name'])) ? htmlspecialchars($_POST['query_name']) : '' );
//$is_selected=((isset($_POST['is_selected'])) ? htmlspecialchars($_POST['is_selected']) : '' );
$moddatestart=((isset($_POST['moddatestart'])) ? htmlspecialchars($_POST['moddatestart']) : '' );
$moddateend=((isset($_POST['moddateend'])) ? htmlspecialchars($_POST['moddateend']) : '' );
$opendatestart=((isset($_POST['opendatestart'])) ? htmlspecialchars($_POST['opendatestart']) : '' );
$opendateend=((isset($_POST['opendateend'])) ? htmlspecialchars($_POST['opendateend']) : '' );
$closedatestart=((isset($_POST['closedatestart'])) ? htmlspecialchars($_POST['closedatestart']) : '' );
$closedateend=((isset($_POST['closedateend'])) ? htmlspecialchars($_POST['closedateend']) : '' );
$sortcol=((isset($_POST['sortcol'])) ? $_POST['sortcol'] : '');
$sortord=((isset($_POST['sortord'])) ? $_POST['sortord'] : '');

		
$efs_tmp=((isset($_POST['efs_display'])) ? $_POST['efs_display'] : array());

$efs_selected = array();

foreach($efs_tmp as $ef){
	$efs_selected[$ef] =  $tefs_arr[$ef];
	unset($tefs_arr[$ef]);
}

include('forms/TrackerQueryAdd-tpl.php');

?>
