<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code shows a form for Sprint
//
//require_once('plugins/sprint/lib/SprintPeer.php');
//require_once('plugins/sprint/lib/Sprint.php');
require_once('GFUrl.php');

$DEFAULT_END_OFFSET = 604800; // one week in seconds

$session = Session::getSession();
$Lang = $session->getLanguage();

require_once('plugins/tracker/lib/html/TrackerTemplate.php');
$theme = new TrackerTemplate();
$strU = new StringUtils();

$Project = GFUrl::getUrl()->getProject();
$Ts = new TrackerSprint();
$Ts->setProject($Project);

if (!$Ts->userIsAdmin()) {
	throw new PermissionDeniedException();
}

//Nullify TrackerSprint now we checked the permissions
unset($Ts);

$params = array(
		'project' => $Project,
		'action' => isset($action) ? $action : '',
		'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : ''),
		'title' => $Lang->getText('TrackerSprint.AddNewPageTitle')
		);

$sprint_name=((isset($_POST['sprint_name'])) ? htmlspecialchars($_POST['sprint_name']) : '' );
$sprint_start_date=((isset($_POST['sprint_start_date'])) ? htmlspecialchars($_POST['sprint_start_date']) : date("M j Y") );
$sprint_end_date=((isset($_POST['sprint_end_date'])) ? htmlspecialchars($_POST['sprint_end_date']) : date("M j Y", time() + $DEFAULT_END_OFFSET) );


include('forms/TrackerSprintAdd-tpl.php');

?>
