<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code creates a new Sprint and saves it to the 
// database
//
require_once('plugins/tracker/lib/TrackerSprint.php');
require_once('Validator.php');
require_once('exceptions/InvalidDataException.php');
require_once('exceptions/PermissionDeniedException.php');
require_once('core/Language.php');

if ($_SERVER['REQUEST_METHOD'] != 'POST') {
	throw new PermissionDeniedException();
}

$session = Session::getSession();
$Lang = $session->getLanguage();

$Project = GFUrl::getUrl()->getProject();
$TrackerSprint = new TrackerSprint();
$TrackerSprint->setProject($Project);
if (!$TrackerSprint->userIsAdmin()) {
	throw new PermissionDeniedException();
}

$errors = array();
$language = Language::getSessLang();
$stringUtils = new StringUtils();


if (count($errors) == 0) {
	$TrackerSprint->setProject( $Project );
	$TrackerSprint->setSprintName( Validator::sanitizeString($_POST['sprint_name']) );
	$startdate = Validator::sanitizeString($_POST['sprint_start_date']);
	$TrackerSprint->setSprintStart(date('Y-m-d',strtotime($startdate)));
	$enddate = Validator::sanitizeString($_POST['sprint_end_date']);
	$TrackerSprint->setSprintEnd(date('Y-m-d',strtotime($enddate)));
	
	try {
		$TrackerSprint->save();
		GFUrl::getUrl()->redirect(GFUrl::getFullURL(GFUrl::getUrl()->projectURL($TrackerSprint->getProject(), 'TrackerSprintBrowse', 'tracker','',array('feedback' => $feedback))));
	} catch (InvalidDataException $ex) {
		$errors = array_merge($errors, $ex->getErrors());		// attach object errors to validation errors
		$feedback = '* '.implode('<br />* ', $errors);
		include('TrackerSprintAdd.php');
	}
} else {
	$feedback = '* '.implode('<br />* ', $errors);
	include('TrackerSprintAdd.php');
}
	
?>