<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code lists TrackerItem
//
require_once('plugins/tracker/lib/TrackerItemPeer.php');
require_once('plugins/tracker/lib/TrackerItem.php');
require_once('exceptions/PermissionDeniedException.php');
require_once('plugins/tracker/lib/TrackerSprint.php');
require_once('plugins/tracker/lib/TrackerSprintPeer.php');
require_once('plugins/tracker/lib/html/TrackerSprintTemplate.php');
require_once('plugins/tracker/lib/html/TrackerExtraFieldRenderer.php');

function goBack($TrackerSprint, $message, $returnUrl = '') {
	if ($returnUrl != '') {
		$returnUrl .= "&feedback={$message}";
	} else {
	  	$returnUrl = GFUrl::getUrl()->currentBaseURL('TrackerSprintView', array('feedback' => $message,'sprint_id'=>$TrackerSprint->getSprintId()));
	}
	GFUrl::getUrl()->redirect($returnUrl);
}

if ($_SERVER['REQUEST_METHOD'] != 'POST') {
	throw new PermissionDeniedException();
}

//force login
$Session = Session::getSession();
if (!$Session->isLoggedIn()) {
	throw new NotLoggedInException();
}

$Project = GFUrl::getUrl()->getProject();
$TrackerSprint = TrackerSprintPeer::retrieveByPk($_REQUEST['sprint_id']);
if (!$TrackerSprint || !is_object($TrackerSprint) || $TrackerSprint->getProject()->getProjectId() != $Project->getProjectId() || !$TrackerSprint->userCanRead()) {
        throw new PermissionDeniedException();
}

$return_url = isset($_REQUEST['return']) && !empty($_REQUEST['return']) ? $_REQUEST['return'] : null;

if (array_key_exists('tid', $_REQUEST)) {
  $tids = $_REQUEST['tid'];
} else {
  goBack($TrackerSprint, $language->getText('TrackerMassUpdate.NoItemsSelected'), $return_url);
}

$new_sprint_id = isset($_REQUEST['new_sprint_id']) && $_REQUEST['new_sprint_id'] != "" ? Validator::sanitizeInt($_REQUEST['new_sprint_id']) : null;

$priority = isset($_REQUEST['priority']) && !empty($_REQUEST['priority']) ? Validator::sanitizeInt($_REQUEST['priority']) : null;

$assignee = isset($_REQUEST['assignee']) && !empty($_REQUEST['assignee']) ? Validator::sanitizeInt($_REQUEST['assignee']) : null;

foreach ($tids as $tid) {
  $TrackerItem = TrackerItemPeer::retrieveByPk($tid);
  if (!$TrackerItem || !is_object($TrackerItem) 
    || !$TrackerItem->userCanUpdate()) {
    goBack($TrackerSprint, "Invalid Tracker Item with ID " . $tid, $return_url);
  }

  if ($new_sprint_id != null) {
    if ($new_sprint_id == 100) {
      $TrackerItem->setSprintId(null);
    } else {
      $TrackerItem->setSprintId($new_sprint_id);
    }
  }

  if ($priority != null) {
    $TrackerItem->setPriority($priority);
  }

  if ($assignee != null) {
    $TrackerItem->updateAssignees(array($assignee));
  }

  $TrackerItem->save();
}


goBack($TrackerSprint, $language->getText('TrackerItem.MassFeedback', array(count($tids))), $return_url);
?>
