<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code lists TrackerItem
//
require_once('plugins/tracker/lib/TrackerItemPeer.php');
require_once('plugins/tracker/lib/TrackerItem.php');
require_once('exceptions/PermissionDeniedException.php');
require_once('plugins/tracker/lib/TrackerSprint.php');
require_once('plugins/tracker/lib/TrackerSprintPeer.php');
require_once('plugins/tracker/lib/html/TrackerSprintTemplate.php');
require_once('plugins/tracker/lib/html/TrackerExtraFieldRenderer.php');
require_once ('lib/ProjectNotification.php');
require_once ('core/Notification.php');

if ($_SERVER['REQUEST_METHOD'] != 'GET') {
	throw new PermissionDeniedException();
}

//force login
$Session = Session::getSession();
if (!$Session->isLoggedIn()) {
	throw new NotLoggedInException();
}
$Lang =	$Session->getLanguage();
$sprint_id = Validator::sanitizeInt($_REQUEST['sprint_id']);

$Project = GFUrl::getUrl()->getProject();
$TrackerSprint = TrackerSprintPeer::retrieveByPk($sprint_id, $Project->getProjectId());
if (!$TrackerSprint) {
	throw new InvalidDataException('Invalid sprint id: '.$sprint_id);
}
if (!$TrackerSprint->userIsAdmin()) {
        throw new PermissionDeniedException();
}

if ($TrackerSprint->getSprintStatus() == TrackerSprint::STATUS_NOT_STARTED) {
  $TrackerSprint->setSprintStatus(TrackerSprint::STATUS_IN_PROGRESS);
  $TrackerSprint->save();
}

$message = $Lang->getText('TrackerSprint.StartFeedback', array($TrackerSprint->getSprintTitleText()));
GFUrl::getUrl()->redirect(GFUrl::getUrl()->currentBaseURL('TrackerSprintBrowse', array('feedback' => $message,'sprint_id'=>$TrackerSprint->getSprintId())));
?>
