<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code creates a new TrackerCannedResponse and saves it to the 
// database
//
require_once('plugins/tracker/lib/TrackerCannedResponse.php');
require_once('Validator.php');
require_once('exceptions/InvalidDataException.php');
require_once('exceptions/PermissionDeniedException.php');
require_once('core/Language.php');

if ($_SERVER['REQUEST_METHOD'] != 'POST') {
	throw new PermissionDeniedException();
}

$Project = GFUrl::getUrl()->getProject();
$Tracker = TrackerPeer::retrieveByPk($_REQUEST['tracker_id']);
if (!is_object($Tracker) || !$Tracker->userIsAdmin() || $Tracker->getProject()->getProjectId() != $Project->getProjectId()) {
	throw new PermissionDeniedException();
}


$TrackerCannedResponse = new TrackerCannedResponse();
$TrackerCannedResponse->setTracker($Tracker);

$errors = array();
$language = Language::getSessLang();

//TODO: do some verification, add error strings to $errors

if (count($errors) == 0) {
//	$TrackerCannedResponse->setTrackerId( Validator::sanitizeInt($_POST['tracker_id']) );
	$TrackerCannedResponse->setTitle( Validator::sanitizeString($_POST['title']) );
	$TrackerCannedResponse->setBody( Validator::sanitizeString($_POST['body']) );
	
	try {
		$TrackerCannedResponse->save();
	} catch (InvalidDataException $ex) {
		$errors = array_merge($errors, $ex->getErrors());		// attach object errors to validation errors
	}

}
	
if (count($errors) > 0) {
	$feedback = '* '.implode('<br />* ', $errors);
	include('TrackerCannedResponseAdd.php');
} else {
	GFUrl::getUrl()->redirect(GFUrl::getUrl()->currentBaseURL('TrackerCannedResponseBrowse'), array('feedback' => $language->getText('TrackerCannedResponse.AddFeedback'),'tracker_id'=>$Tracker->getTrackerId()));
}

?>