<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code edits a TrackerCannedResponse and saves it to the 
// database
//
require_once('plugins/tracker/lib/TrackerCannedResponse.php');
require_once('Validator.php');
require_once('exceptions/PermissionDeniedException.php');
require_once('core/Language.php');

if ($_SERVER['REQUEST_METHOD'] != 'POST') {
	throw new PermissionDeniedException();
}
$Project = GFUrl::getUrl()->getProject();
$TrackerCannedResponse = TrackerCannedResponsePeer::retrieveByPk($_POST['tracker_canned_response_id']);
$Tracker = $TrackerCannedResponse->getTracker();
if (!is_object($Tracker) || !$Tracker->userIsAdmin() || $Tracker->getProject()->getProjectId() != $Project->getProjectId()) {
	throw new PermissionDeniedException();
}

$errors = array();
$language = Language::getSessLang();

//
// TODO Validate the values passed by $_POST. Store the errors in $error like
// $errors["field_name"] = error_description
//

if (count($errors) == 0) {
	$TrackerCannedResponse->setTitle( Validator::sanitizeString($_POST['title']) );
	$TrackerCannedResponse->setBody( Validator::sanitizeString($_POST['body']) );
	
	$TrackerCannedResponse->save();
	GFUrl::getUrl()->redirect(GFUrl::getUrl()->currentBaseURL('TrackerCannedResponseBrowse'), array('feedback' => $language->getText('TrackerCannedResponse.EditFeedback'),'tracker_id'=>$Tracker->getTrackerId()));
} else {
	$feedback = implode('<br />', $errors);
	include('TrackerCannedResponseEdit.php');
}

?>