<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code shows a form for editing Tracker
//
require_once('lib/core/SettingPeer.php');
require_once('plugins/tracker/lib/TrackerPeer.php');
require_once('plugins/tracker/lib/Tracker.php');
require_once('exceptions/PermissionDeniedException.php');

$session = Session::getSession();
$Lang = $session->getLanguage();

require_once('plugins/tracker/lib/html/TrackerAdminTemplate.php');
$theme = new TrackerAdminTemplate();

$Project = GFUrl::getUrl()->getProject();
$Tracker = TrackerPeer::retrieveByPk($_REQUEST['tracker_id']);
if (!is_object($Tracker) || !$Tracker->userIsAdmin() || $Tracker->getProject()->getProjectId() != $Project->getProjectId()) {
	throw new PermissionDeniedException();
}

$enable_customer_nag_alerts = $Tracker->getStatusNag(true);
$enable_nag_alerts = $Tracker->getStatusNag();

$arr_customer_status = $Tracker->getStatusNagSettings(true);
$arr_status = $Tracker->getStatusNagSettings();
$tracker_customer_status_nag_text = $Tracker->getStatusNagText(true);
$tracker_status_nag_text = $Tracker->getStatusNagText();
$arr_closed_statuses = $Tracker->getTrackerStatuses(Tracker::STATUS_CLOSED, true);

$auto_close_setting = $Tracker->getAutoCloseSeting();
$auto_close_status = $Tracker->getAutoCloseStatus();

$strU = new StringUtils();

/** @var Tracker $obj */
$obj = $Tracker;

$params = array(
		'project' => $Project,
		'tracker' => $Tracker,
		'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : ''),
		'action' => isset($action) ? $action : '',
		'title' => $Lang->getText('Tracker.EditPageTitle')
		);

//$project_id = ( (isset($_POST) && isset($_POST['project_id'])) ? htmlspecialchars($_POST['project_id']) : $obj->getProjectId() );
$tracker_name = ( (isset($_POST) && isset($_POST['tracker_name'])) ? htmlspecialchars($_POST['tracker_name']) : $obj->getTrackerName() );
$description = ( (isset($_POST) && isset($_POST['description'])) ? htmlspecialchars($_POST['description']) : $obj->getDescription() );
$is_public = ( (isset($_POST) && isset($_POST['is_public'])) ? htmlspecialchars($_POST['is_public']) : $obj->getIsPublic() );
$restrict_browse = ( (isset($_POST) && isset($_POST['restrict_browse'])) ? htmlspecialchars($_POST['restrict_browse']) : $obj->getRestrictBrowse() );
$email_all_updates = ( (isset($_POST) && isset($_POST['email_all_updates'])) ? htmlspecialchars($_POST['email_all_updates']) : $obj->getEmailAllUpdates() );
$email_address = ( (isset($_POST) && isset($_POST['email_address'])) ? htmlspecialchars($_POST['email_address']) : $obj->getEmailAddress() );
$due_period = ( (isset($_POST) && isset($_POST['due_period'])) ? htmlspecialchars($_POST['due_period']) : $obj->getDuePeriod() );
$submit_instructions = ( (isset($_POST) && isset($_POST['submit_instructions'])) ? $strU->cleanHtml($_POST['submit_instructions']) : $obj->getSubmitInstructions(false) );
$browse_instructions = ( (isset($_POST) && isset($_POST['browse_instructions'])) ? $strU->cleanHtml($_POST['browse_instructions']) : $obj->getBrowseInstructions(false) );
$autoresponse_instructions=((isset($_POST['autoresponse_instructions'])) ? $strU->cleanHtml($_POST['autoresponse_instructions']) : $obj->getAutoresponseInstructions(false) );
if ($autoresponse_instructions == "") {
	//Enable this in case we want to provide a default set of instructions.
	//Currently disabled since there's already a default auto-responde message constructed in tracker_gateway.php
	//$autoresponse_instructions = $Lang->getText('Tracker.AutoresponseInstructionsDefault');
}


$email_alias = isset($_POST['email_alias']) ? Validator::sanitizeString($_POST['email_alias']) : $obj->getEmailAlias();

	

//$datatype = ( (isset($_POST) && isset($_POST['datatype'])) ? htmlspecialchars($_POST['datatype']) : $obj->getDatatype() );
//$item_total = ( (isset($_POST) && isset($_POST['item_total'])) ? htmlspecialchars($_POST['item_total']) : $obj->getItemTotal() );
//$open_count = ( (isset($_POST) && isset($_POST['open_count'])) ? htmlspecialchars($_POST['open_count']) : $obj->getOpenCount() );

$show_dependencies_tab = ( (isset($_POST) && isset($_POST['show_dependencies_tab']) ) ? htmlspecialchars($_POST['show_dependencies_tab']) : $obj->getShowDependenciesTab());
$show_duplicates_tab = ( (isset($_POST) && isset($_POST['show_duplicates_tab']) ) ? htmlspecialchars($_POST['show_duplicates_tab']) : $obj->getShowDuplicatesTab());
$show_associations_tab = ( (isset($_POST) && isset($_POST['show_associations_tab']) ) ? htmlspecialchars($_POST['show_associations_tab']) : $obj->getShowAssociationsTab());
$show_time_tracking_tab = ( (isset($_POST) && isset($_POST['show_time_tracking_tab']) ) ? htmlspecialchars($_POST['show_time_tracking_tab']) : $obj->getShowTimeTrackingTab());
$show_tags_tab = ( (isset($_POST) && isset($_POST['show_tags_tab']) ) ? htmlspecialchars($_POST['show_tags_tab']) : $obj->getShowTagsTab());
$send_abbreviated_email = ( (isset($_POST) && isset($_POST['send_abbreviated_email']) ) ? htmlspecialchars($_POST['send_abbreviated_email']) : $obj->getSendAbbreviatedEmail());

include ('forms/TrackerEdit-tpl.php');

?>
