<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code shows a form for TrackerExtraFieldElement
//
require_once('plugins/tracker/lib/TrackerExtraFieldElementPeer.php');
require_once('plugins/tracker/lib/TrackerExtraFieldElement.php');
require_once('GFUrl.php');
require_once('lib/exceptions/PermissionDeniedException.php');

$session = Session::getSession();
$Lang = $session->getLanguage();

require_once('plugins/tracker/lib/html/TrackerAdminTemplate.php');
$theme = new TrackerAdminTemplate();

$Project = GFUrl::getUrl()->getProject();
$TrackerExtraField = TrackerExtraFieldPeer::retrieveByPk($_REQUEST['tracker_extra_field_id']);
$Tracker = $TrackerExtraField->getTracker();
if (!is_object($Tracker) || !$Tracker->userIsAdmin()
	|| $Tracker->getProject()->getProjectId() != $Project->getProjectId()) {
	throw new PermissionDeniedException();
}

$theme->addBreadCrumb('<a href="'. GFUrl::getUrl()->currentBaseUrl('TrackerExtraFieldEdit').'&amp;tracker_extra_field_id='.$_REQUEST['tracker_extra_field_id'].'&amp;tracker_id='.$Tracker->getTrackerID() .'">'. $Lang->getText('TrackerExtraFieldElement.Edit') .'</a>');
$theme->addBreadCrumb('<a href="'. GFUrl::getUrl()->currentBaseUrl('TrackerExtraFieldEdit').'&amp;tracker_extra_field_id='.$_REQUEST['tracker_extra_field_id'] .'">'. $Lang->getText('TrackerExtraField.Edit') .'</a>');

$params = array(
		'project' => $Project,
		'tracker' => $Tracker,
		'action' => isset($action) ? $action : '',
		'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : ''),
		'title' => $Lang->getText('TrackerExtraFieldElement.AddNewPageTitle')
		);

//$tracker_extra_field_id=((isset($_POST['tracker_extra_field_id'])) ? htmlspecialchars($_POST['tracker_extra_field_id']) : '' );
$element_name=((isset($_POST['element_name'])) ? htmlspecialchars($_POST['element_name']) : '' );
$alias=((isset($_POST['alias'])) ? htmlspecialchars($_POST['alias']) : '' );
$status_id=((isset($_POST['status_id'])) ? htmlspecialchars($_POST['status_id']) : '' );
$default_selected=((isset($_POST['default_selected'])) ? htmlspecialchars($_POST['default_selected']) : '' );
$sort_order=((isset($_POST['sort_order'])) ? htmlspecialchars($_POST['sort_order']) : '' );

include('forms/TrackerExtraFieldElementAdd-tpl.php');

?>
