<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code edits a TrackerExtraFieldElement and saves it to the 
// database
//
require_once('plugins/tracker/lib/TrackerExtraFieldElement.php');
require_once('Validator.php');
require_once('exceptions/PermissionDeniedException.php');
require_once('core/Language.php');

if ($_SERVER['REQUEST_METHOD'] != 'POST') {
	throw new PermissionDeniedException();
}

$Lang = Language::getSessLang();
$Project = GFUrl::getUrl()->getProject();
$keys = array_keys($_POST['element_name']);
$errors=array();
foreach ($keys as $element_id) {
	$TrackerExtraFieldElement = TrackerExtraFieldElementPeer::retrieveByPk($element_id);
	$Tracker=$TrackerExtraFieldElement->getTrackerExtraField()->getTracker();
	if (!is_object($Tracker) || !$Tracker->userIsAdmin()
		|| $Tracker->getProject()->getProjectId() != $Project->getProjectId()) {
		throw new PermissionDeniedException();
	}

	$TrackerExtraFieldElement->setElementName( Validator::sanitizeString($_POST['element_name'][$element_id]) );
//	$TrackerExtraFieldElement->setStatusId( Validator::sanitizeInt($_POST['status_id'][]) );
	if (isset($_POST['default_selected']) && $_POST['default_selected']==$element_id) {
		$selected=1;
	} else {
		$selected=0;
	}
	$TrackerExtraFieldElement->setDefaultSelected( $selected );
	if (isset($_POST['can_commit']) && isset($_POST['can_commit'][$element_id]) && $_POST['can_commit'][$element_id]=='1' ) {
		$TrackerExtraFieldElement->setCanCommit(true);
	} else {
		$TrackerExtraFieldElement->setCanCommit(false);
	}
	$TrackerExtraFieldElement->setSortOrder( Validator::sanitizeInt($_POST['sort_order'][$element_id]) );
	if ($TrackerExtraFieldElement->getTrackerExtraField()->getUseAutoAssign()) {
		$TrackerExtraFieldElement->setAutoAssignTo(Validator::sanitizeInt($_POST['auto_assign_to'][$element_id]));
	} else {
		$TrackerExtraFieldElement->setAutoAssignTo(100);
	}
	
	try {
		$TrackerExtraFieldElement->save();
	} catch (InvalidDataException $ex) {
		$tracker_extra_field_id=$TrackerExtraFieldElement->getTrackerExtraField()->getTrackerExtraFieldId();
		$errors = array_merge($errors, $ex->getErrors());               // attach object errors to validation errors
		$feedback = '* '.implode('<br />* ', $errors);
		include('TrackerExtraFieldElementBrowse.php');
		exit;
        }
}

$url = GFUrl::getUrl();
GFUrl::redirect($url->currentBaseURL('TrackerExtraFieldElementBrowse'), array('feedback' => $Lang->getText('TrackerExtraFieldElement.EditFeedback'),'tracker_extra_field_id'=>$TrackerExtraFieldElement->getTrackerExtraField()->getTrackerExtraFieldId()));

?>
