<?php
/**
 * Copyright (c) 2005-2013 GForge, LLC
 *
 * @version   $Id$
 * @author Mario Papayannis mpapapyannis@gforgegroup.com
 * @date 2013-05-24
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

require_once('plugins/tracker/lib/TrackerItemMessagePeer.php');
require_once('plugins/tracker/lib/TrackerItemMessage.php');
require_once('exceptions/PermissionDeniedException.php');
require_once('core/Language.php');

$Lang = Language::getSessLang();

$Project = GFUrl::getUrl()->getProject();

if (!Session::getSession()->isLoggedIn() || !$Project->userIsAdmin()) {
	throw new PermissionDeniedException();
}

$tim = isset($_GET['tim']) ? Validator::sanitizeInt($_GET['tim']) : 0;

$tracker_item_message = TrackerItemMessagePeer::retrieveByPk($tim);
if (!is_object($tracker_item_message)) {
	throw new PermissionDeniedException();
}

include('forms/TrackerItemMessageDelete-tpl.php');	
?>
