<?php
/**
 * Copyright (c) 2005-2013 GForge, LLC
 *
 * @version   $Id$
 * @author Mario Papayannis mpapapyannis@gforgegroup.com
 * @date 2013-05-24
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

require_once('plugins/tracker/lib/TrackerItemMessagePeer.php');
require_once('plugins/tracker/lib/TrackerItemMessage.php');
require_once('exceptions/PermissionDeniedException.php');
require_once('core/Language.php');

$Lang = Language::getSessLang();

$Project = GFUrl::getUrl()->getProject();

if (!Session::getSession()->isLoggedIn() || !$Project->userIsAdmin()) {
	throw new PermissionDeniedException();
}

$stringUtils = new StringUtils();

$tim = isset($_POST['tim']) ? Validator::sanitizeInt($_POST['tim']) : 0;

$tracker_item_message = TrackerItemMessagePeer::retrieveByPk($tim);
if (!is_object($tracker_item_message)) {
	throw new PermissionDeniedException();
}
$tracker_item_id = $tracker_item_message->getTrackerItemId();
$project = $tracker_item_message->getTrackerItem()->getTracker()->getProject();

try {
	$tracker_item_message->delete();
	$feedback = $Lang->getText('TrackerItem.EditFeedback', array($tracker_item_id));
} catch(Exception $e) {
	$feedback = '* ' . implode('<br />* ', $e->getErrors());
}
GFUrl::getUrl()->redirect(GFUrl::getUrl()->projectURL($project, 'TrackerItemEdit', 'tracker', '', array('feedback' => $feedback, 'tracker_item_id' => $tracker_item_id)));
