<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id$
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
require_once('plugins/tracker/lib/TrackerTransitionScript.php');
require_once('exceptions/PermissionDeniedException.php');
require_once('core/Language.php');

$url = GFUrl::getUrl();
$project = $url->getProject();

if (!GFConf::get('tracker.enableWorkflowScripts') || ($project && !$project->getEnableWorkflowScripts())) {
	throw new PermissionDeniedException();
}

$url = GFUrl::getUrl();

$script = TrackerTransitionScriptPeer::retrieveByPk($_REQUEST['tracker_transition_script_id']);
if (!is_object($script) || !$script->userCanDelete()) {
	throw new PermissionDeniedException();
}


if (isset($_POST['sure'])) {
	$script->delete();
	$feedback = Language::getSessLang()->getText('Tracker.WorkflowScriptDeleteFeedback');
} else {
	$feedback = Language::getSessLang()->getText('TrackerDeleteForm.DidntConfirm');
}
$url->redirect($url->currentBaseUrl('TrackerTransitionScriptBrowse', array('feedback' => $feedback)));

?>
