<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id$
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code shows a form for TrackerTransitionScript
//
require_once('plugins/tracker/lib/TrackerTransitionScript.php');
require_once('lib/html/templates/SiteAdminTemplate.php');
require_once('GFUrl.php');

$session = Session::getSession();
$lang = $session->getLanguage();
$url = GFUrl::getUrl();
$project = $url->getProject();

if (!GFConf::get('tracker.enableWorkflowScripts') || ($project && !$project->getEnableWorkflowScripts())) {
	throw new PermissionDeniedException();
}

$tracker_transition_script_id = (isset($_REQUEST['tracker_transition_script_id']) ? Validator::sanitizeInt($_REQUEST['tracker_transition_script_id']) : null);

$action = ($tracker_transition_script_id ? 'edit' : 'add');
$script = ($tracker_transition_script_id ? TrackerTransitionScriptPeer::retrieveByPk($tracker_transition_script_id) : null);

if (is_null($project)) {
	include_once('lib/html/templates/SiteAdminTemplate.php');
	$theme = new SiteAdminTemplate();
} else {
	if (!$project->getEnableWorkflowScripts()) {
		throw new PermissionDeniedException();
	}
	include_once('lib/html/templates/ProjectAdminTemplate.php');
	$theme = new ProjectAdminTemplate();
}


$params = array(
		'action' => isset($action) ? $action : '',
		'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : ''),
		'title' => $lang->getText( ($action == 'add' ? 'Tracker.WorkflowScriptAdd' : 'Tracker.WorkflowScriptEdit') ),
		);
if (!is_null($project)) {
	$params['project'] = $project;
}

echo $theme->header($params);

$script_path = (isset($_REQUEST['script_path']) ? Validator::sanitizeString($_REQUEST['script_path']) : ($script ? $script->getScriptPath() : ''));
$description = (isset($_REQUEST['description']) ? Validator::sanitizeString($_REQUEST['description']) : ($script ? $script->getDescription() : ''));
$script_type = (isset($_REQUEST['description']) ? Validator::sanitizeString($_REQUEST['description']) : ($script ? $script->getScriptType() : 0));

include('forms/TrackerTransitionScriptForm-tpl.php');

echo $theme->footer($params);

?>
