<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
require_once('lib/html/association.php');
require_once('lib/html/TagsRenderer.php');
require_once('lib/html/HTMLWidget.php');
require_once('lib/html/GFCKEditor.php');
$theme->header($params);

$icon=(($Tracker->getDataType()==Tracker::DATATYPE_TASK) ? 'task' : 'tracker');

// Make sure key context vars are set
$Lang = Session::getSession()->getLanguage();

// Extract vars from params array
$Tracker = $params['tracker'];
$TrackerItem = $params['tracker_item'];
$user = $params['user'];

$tefr = $params['tefr'];
$uploadHandler = $params['uploadHandler'];
$start_date = $params['start_date'];
$end_date = $params['end_date'];
?>

<?php include('TrackerItemEdit-TemplateChooser-tpl.php');


$summary_data = htmlentities($TrackerItem->getSummary(false), ENT_COMPAT, 'UTF-8');
if ($IS_TECH) {
	$summary = '<input type="text" name="summary" value="' . $summary_data .  '" size="70" maxlength="255" /></td>';
} else {
	$summary = $summary_data;
}
?>
<?php if ($TrackerItem->getStatusId() != Tracker::STATUS_CLOSED &&
          $intrinsic_fields[Tracker::TRACKER_FIELD_WAITING_FOR]['is_enabled'] &&
          $intrinsic_fields[Tracker::TRACKER_FIELD_WAITING_FOR]['on_submit']) {
?>
<div class="waitingFor"><?php echo $TrackerItem->getWaitingForStringWithContext($user); ?></div>
<?php } ?>
<form name="TrackerItemEdit" action="<?php echo GFUrl::getUrl()->currentBaseURL('TrackerItemEditAction') ?>" method="post" enctype="multipart/form-data">
<?php
echo '<img src="/images/'.$icon.'_icon.gif" height="16" width="16" border="0" />&nbsp;[#'.$TrackerItem->getPrimaryKey().'] ' . $Lang->getText('TrackerItem.SummaryName') . ':&nbsp;' . $summary; ?>
<?php echo  HTMLWidget::discuss(
		$Tracker->getProject(),
		'Discuss this tracker item',
		TrackerItem::SECTION,
		$TrackerItem->getTrackerItemId(),
		$TrackerItem->getSummary());
?>

<br />
<script language="javascript" type="text/javascript" src="/datetimepicker.js"></script>

<?php echo $uploadHandler->getJavascriptSetup(); ?>

<SCRIPT LANGUAGE="JavaScript" type="text/javascript">

function checkRows(textArea){

if (/*navigator.appName.indexOf("Microsoft Internet Explorer") == 0 ||*/ navigator.appVersion.match("MSIE 6"))
{
textArea.style.overflow = 'visible';
return;
}

while (
textArea.rows > 1 &&
textArea.scrollHeight < textArea.offsetHeight
){
textArea.rows--;
}

while (textArea.scrollHeight > textArea.offsetHeight)
{
textArea.rows++;
}

textArea.rows++;


return;
}

function cancelClick(el) {
	if ( navigator.appVersion.match("MSIE 7") ) {
		el.href = "java"+"script:;";
	}
	return false;
}
</SCRIPT>
<br />
<?php if ($Tracker->userIsAdmin()) { ?>
<a href="<?php echo GFUrl::getUrl()->currentBaseUrl('TrackerItemMove', array('tracker_item_id' => $TrackerItem->getTrackerItemId())) ?>"><?php echo $Lang->getText('TrackerItem.MoveItem'); ?></a> |
<a href="<?php echo GFUrl::getUrl()->currentBaseUrl('TrackerItemDelete', array('tracker_item_id' => $TrackerItem->getTrackerItemId())) ?>"><?php echo $Lang->getText('TrackerItem.DeleteItem'); ?></a> |
<a href="<?php echo GFUrl::getUrl()->currentBaseUrl('TrackerItemClone', array('tracker_item_id' => $TrackerItem->getTrackerItemId())) ?>"><?php echo $Lang->getText('TrackerItem.Clone'); ?></a> |
<a href="<?php echo GFUrl::getUrl()->currentBaseUrl('TrackerItemMerge', array('tracker_item_id' => $TrackerItem->getTrackerItemId())) ?>"><?php echo $Lang->getText('TrackerItem.MergeItem'); ?></a> |
<?php } ?>

<?php
if (is_object($user)) {
	if ($TrackerItem->userIsMonitoring($user)) {
		$text = $Lang->getText('TrackerItem.StopMonitor');
		$url = GFUrl::getUrl()->getMonitorUrl(TrackerItem::SECTION, $TrackerItem->getPrimaryKey(), null, false);
	} else {
		$text = $Lang->getText('TrackerItem.Monitor');
		$url = GFUrl::getUrl()->getMonitorUrl(TrackerItem::SECTION, $TrackerItem->getPrimaryKey(), null, true);
	}
?>
<a href="<?php echo $url; ?>"><?php echo $text; ?></a>
<?php }  ?>

	<input type="hidden" name="tracker_item_id" value="<?php echo Validator::sanitizeInt($_REQUEST['tracker_item_id']); ?>" />
	<input type="hidden" name="start" value="<?php echo $start; ?>" />
	<table border="0" width="100%">
		<tr>
			<td colspan="2"><strong><?php echo $Lang->getText('TrackerItem.SubmittedByName'); ?>:</strong><br />
			<?php if ($Tracker->userIsAdmin() && $Tracker->getProject()->isUserMember($TrackerItem->getSubmittedBy())) {
				echo HTMLWidget::selectBoxFromUsers($Tracker->getProject()->getMembers(), 'submitted_by', $TrackerItem->getSubmittedBy());
			} else {
				echo UserPeer::retrieveByPk($TrackerItem->getSubmittedBy())->getUserLink();
			} ?>
			</td>
    </tr>
		<?php if (GFConf::get('system.displayAvatar') && !$Tracker->userIsAdmin()) { ?>
		<tr>
			<td>
				<?php echo UserPeer::retrieveByPk($TrackerItem->getSubmittedBy())->getAvatarHTML(); ?>
			</td>
		</tr>
		<?php } ?>
		<?php if ($Tracker->getDatatype()==Tracker::DATATYPE_TASK) { ?>
		<tr>
            <?php if ($intrinsic_fields[Tracker::TRACKER_FIELD_OPEN_DATE]['is_enabled']) { ?>
                <td><strong><?php echo $Lang->getText('TrackerItem.StartDate'); ?></strong><span class="required">*</span><br />
                <?php if ($IS_TECH) { ?>
                <input type="text" id="task_start" name="start_date" value="<?php echo $start_date; ?>" size="11" maxlength="11" /><a href="javascript:NewCal('task_start','MMMddyyyy')"><img src="/themes/gforge5/images/cal.gif" width="16" height="16" border="0" alt="Pick a date"/></a>
                <?php } else {
                    echo $start_date;
                } ?>
                </td>
            <?php } ?>
            <?php if ($intrinsic_fields[Tracker::TRACKER_FIELD_CLOSE_DATE]['is_enabled']) { ?>
                <td><strong><?php echo $Lang->getText('TrackerItem.EndDate'); ?></strong><span class="required">*</span><br />
                <?php if ($IS_TECH) { ?>
                <input type="text" id="task_end" name="end_date" value="<?php echo $end_date; ?>" size="11" maxlength="11" /><a href="javascript:NewCal('task_end','MMMddyyyy')"><img src="/themes/gforge5/images/cal.gif" width="16" height="16" border="0" alt="Pick a date"/></a>
                <?php } else {
                    echo $end_date;
                } ?>
                </td>
            <?php } ?>
		</tr>
		<?php } else { ?>
		<tr>
            <?php if ($intrinsic_fields[Tracker::TRACKER_FIELD_OPEN_DATE]['is_enabled']) { ?>
			    <td><strong><?php echo $Lang->getText('TrackerItem.OpenDateName'); ?></strong><br />
			    <?php echo $TrackerItem->getOpenDate(); ?></td>
            <?php } ?>
            <?php if ($intrinsic_fields[Tracker::TRACKER_FIELD_CLOSE_DATE]['is_enabled']) { ?>
			    <td><?php if ($TrackerItem->getStatusId()==Tracker::STATUS_CLOSED) { ?><strong><?php echo $Lang->getText('TrackerItem.CloseDateName'); ?></strong><br />
			    <?php echo $TrackerItem->getCloseDate(); } ?></td>
            <?php } ?>
		</tr>
		<?php } ?>
		<?php  echo (($IS_TECH) ? $tefr->renderFields('EDIT', $TrackerItem,null,$_POST) : $tefr->renderFieldsReadOnly($TrackerItem) ); ?>
		<?php if ($intrinsic_fields[Tracker::TRACKER_FIELD_DETAILS]['is_enabled']) { ?>
		<tr id='details_readonly' class='row_visible'>
			
			<?php if ($IS_TECH) { ?>
				<td colspan="2"><strong><?php echo $Lang->getText('TrackerItem.DetailsName'); ?></strong>
				<a href="javascript:void(0)" class='enable_link' onclick="e1=document.getElementById('details_textarea');e1.className='row_visible';
				e2=document.getElementById('details_readonly');e2.className='row_hidden';checkRows(document.getElementById('details'));
				return cancelClick(this);"> (Edit)</a><br />

				<?php echo '<span style="float:left;width: 700px;" id="details_readonly">'.wordwrap($TrackerItem->getDetails(false)).'</span>';?></td>
			<?php } else {?>
				<td colspan="2"><strong><?php echo $Lang->getText('TrackerItem.DetailsName'); ?></strong><br />
				<?php
				echo wordwrap($TrackerItem->getDetails(false),80);
				} ?>
		</tr>
		<tr id='details_textarea' class='row_hidden'>
			<td colspan="2"><strong><?php echo $Lang->getText('TrackerItem.DetailsName'); ?></strong><br />
			<?php if ($IS_TECH) { 
				$CKEditor = new GFCKEditor();
				$CKEditor->config['width']='700';
				$CKEditor->textareaAttributes = array('style'=>'overflow:hidden;','rows'=>7,'cols'=>70, 'id'=>'details', 'name'=>'details','onkeyup'=>'checkRow(this)');
				$CKEditor->editor("details",$TrackerItem->getDetails(false));
			?>
			<?php } else {
				//echo '<pre>'.wordwrap($TrackerItem->getDetails(false),80).'</pre>';
				echo wordwrap($TrackerItem->getDetails(false),80);
			} ?>
		</tr>
		<?php } ?>
		<?php if ($Tracker->getDatatype() == Tracker::DATATYPE_SUPPORT) { ?>
		<tr>
			<td>
				<?php echo $Lang->getText('TrackerItem.DisableAutoclose'); ?>:&nbsp;<input type="checkbox" name="disable_autoclose" <?php if (!$autoclose) echo "checked"; ?> />
			</td>
		</tr>
		<?php } ?>
	</table>
<br />
<table width="75%"><tr><td> 
<?php include('plugins/tracker/wwwlib/TrackerItemMessageAdd.php'); ?>
</td></tr></table> 
<div id="mainTabSet" class="tabber">
<?php $files_count = $TrackerItem->getFilesCount(); ?>
<div class="tabbertab<?php echo ((isset($_GET['selectedtab']) && $_GET['selectedtab']=='attachments') ? ' tabbertabdefault' : ''); ?>" title="<?php echo $Lang->getText('TrackerItem.Tabs.Files').'&nbsp('.$files_count.')' ?>" id="filestab">
<?php include('plugins/tracker/wwwlib/TrackerItemFileEdit.php'); ?>
</div>
<?php 
	include('plugins/tracker/wwwlib/TrackerItemAuditTrail.php'); 
?>
<div class="tabbertab<?php echo ((isset($_GET['selectedtab']) && $_GET['selectedtab']=='changes') ? ' tabbertabdefault' : ''); ?>" title="<?php echo $Lang->getText('TrackerItem.Tabs.Changes').'&nbsp('.$arr_auditrail['count'].')' ?>" id="changestab">
<?php echo $arr_auditrail['html']; ?>
</div>
<?php $arr_commits = createCommitsContentArray($Lang, $theme, $TrackerItem); ?>
<div class="tabbertab<?php echo ((isset($_GET['selectedtab']) && $_GET['selectedtab']=='commits') ? ' tabbertabdefault' : ''); ?>" title="<?php echo $Lang->getText('TrackerItem.Tabs.Commits').'&nbsp('.$arr_commits['count'].')' ?>" id="commitstab">
<?php echo $arr_commits['html']; ?>
</div>
<?php if(is_null($Tracker->getShowDependenciesTab()) || $Tracker->getShowDependenciesTab()){ ?>
	<?php 
		include('plugins/tracker/wwwlib/TrackerItemRelationEdit.php'); 
		$int_dependent_on = $arr_relations['dependenton'];
		$int_dependents = $arr_relations['dependents'];
		$str_dependents1 =  $int_dependent_on . '/' . $int_dependents;
		$str_dependents2 = '(' . $int_dependent_on . ' items depended on / ' . $int_dependents . ' dependents)';
	?>
	<div class="tabbertab<?php echo ((isset($_GET['selectedtab']) && $_GET['selectedtab']=='dependencies') ? ' tabbertabdefault' : ''); ?>" title="<?php echo $Lang->getText('TrackerItem.Tabs.Dependencies').'&nbsp('.$str_dependents1.')' ?>" id="dependenciestab"  data-alt-title="<?php echo $str_dependents2; ?>">
	<?php echo $arr_relations['html']; ?>
	</div>
<?php }?>
<?php if(is_null($Tracker->getShowDuplicatesTab()) || $Tracker->getShowDuplicatesTab()){ 
?>
	<?php 
		include('plugins/tracker/wwwlib/TrackerItemDuplicateEdit.php'); 
		$int_hasdpulicates_count = $arr_duplicates['hasduplicates_count'];
		$int_duplicateof_count = $arr_duplicates['duplicateof_count'];
		$str_duplicates1 =  $int_hasduplicates_count . '/' . $int_duplicateof_count;
		$str_duplicates2 = '(has ' . $int_hasduplicates_count . ' duplicates / is duplicate of ' . $int_duplicateof_count . ' items)';
	?>
	<div class="tabbertab<?php echo ((isset($_GET['selectedtab']) && $_GET['selectedtab']=='duplicates') ? ' tabbertabdefault' : ''); ?>" title="<?php echo $Lang->getText('TrackerItem.Tabs.Duplicates').'&nbsp('.$str_duplicates1.')' ?>" id="duplicatestab" data-alt-title="<?php echo $str_duplicates2; ?>">
	<?php echo $arr_duplicates['html']; ?>
	</div>
<?php }?>
<?php if(is_null($Tracker->getShowAssociationsTab()) || $Tracker->getShowAssociationsTab()){ 
	$association_count = AssociationPeer::getAssociationCount(TrackerItem::SECTION,$TrackerItem->getTrackerItemId());
?>
	<div class="tabbertab<?php echo ((isset($_GET['selectedtab']) && $_GET['selectedtab']=='associations') ? ' tabbertabdefault' : ''); ?>" title="<?php echo $Lang->getText('Associations').'&nbsp('.$association_count.')' ?>" id="associationstab">
<?php echo renderAssociationList(TrackerItem::SECTION,$TrackerItem->getTrackerItemId(),$IS_TECH,$theme,$Project); ?>
	</div>
<?php  } ?>
<?php if(is_null($Tracker->getShowTagsTab()) || $Tracker->getShowTagsTab()){ 
	$tags_count = TagsRenderer::getTagsCount($TrackerItem->getTrackerItemId(),TrackerItem::SECTION, $theme, $TrackerItem->getTrackerId());
?>
	<div class="tabbertab<?php echo ((isset($_GET['selectedtab']) && $_GET['selectedtab']=='tags') ? ' tabbertabdefault' : ''); ?>" title="<?php echo $Lang->getText('Tag.TabHeader').'&nbsp('.$tags_count.')' ?>" id="tagstab">
	<?php 
	echo TagsRenderer::getTagsTable($TrackerItem->getTrackerItemId(),TrackerItem::SECTION, $theme, $TrackerItem->getTrackerId());
	?>
	</div>
<?php } ?>
<?php
if ($IS_TECH) {
	if(is_null($Tracker->getShowTimeTrackingTab()) || $Tracker->getShowTimeTrackingTab()){
		include('plugins/tracker/wwwlib/TrackerItemTimeEdit.php');
		echo '
	<div class="tabbertab'. ((isset($_GET['selectedtab']) && $_GET['selectedtab']=='timetracking') ? ' tabbertabdefault' : '').'" title="'.$Lang->getText('TrackerItem.Tabs.TimeTracking').'&nbsp('.$arr_time['count'].')" id="timetrackingtab">'
	. $arr_time['html'] . '
		</div>';
	}
}
ActionManager::notify('TRACKER_ITEM_EDIT_FORM',$TrackerItem);
?>
</div>
<br />
<br />	<!-- Extra br solves a problem with IE6/7 rendering -->
<center>
	<?php echo HTMLWidget::button("submit","" .   $Lang->getText('submit.edit') . " ","submit_form","","")?>
	<?php echo HTMLWidget::button("button","" .   $Lang->getText('Common.Back') . " ","cancel","","window.location = '" .   GFUrl::getUrl()->projectURL(GFUrl::getUrl()->getProject(),'TrackerItemBrowse','tracker','',array('tracker_id' => $Tracker->getTrackerId())) . "'; ")?>
</center>
</form>


<?php
if (GFConf::get('feature.jst', false) == true) {
	include('wwwlib/forms/jst.html');
}

$theme->footer($params);
