<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id$
 * @author Ruben Gutierrez	ruben@gforgegroup.com
 * @date 2006-03-13
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

require_once('plugins/tracker/lib/Tracker.php');
require_once('lib/graphics/GraphicPie.php');

$session = Session::getSession();
$Lang = $session->getLanguage();

$Project = GFUrl::getUrl()->getProject();
$project_id = $Project->getProjectId();


// Check if we want to filter by user
$user = (isset($_GET['user_id']) ? Validator::sanitizeInt($_GET['user_id']) : 0);
$begin = Validator::sanitizeDate($_GET['start_date']);
$end = Validator::sanitizeDate($_GET['end_date']);
$subprojects=((isset($_REQUEST['subprojects'])) ? Validator::sanitizeInt($_REQUEST['subprojects']) : 0 );

$sqltime = "AND date_entry BETWEEN '$begin' AND '$end'";

// Get all valid Project Ids
$all_ids = array();
if ($subprojects == 1) {
	$all_ids = $Project->getAllSubprojectIds();
	$all_ids[] = $project_id;
} else {
	$all_ids[] = $project_id;
}

// If there's a valid project_id, we'll filter by project all the queries
if ($user > 0) {
	$sqluser = "AND tit.user_id = '$user'";
} else {
	$sqluser = '';
}

$sql = "SELECT ti.tracker_item_id, substr(ti.summary, 0, 25) as summary, SUM(tit.hours) AS hours 
FROM tracker_item_time tit, tracker_item ti, tracker t
WHERE tit.tracker_item_id = ti.tracker_item_id
AND ti.tracker_id = t.tracker_id
AND t.project_id IN (".implode(',',$all_ids).") 
$sqltime
$sqluser
GROUP BY ti.tracker_item_id, ti.summary 
ORDER BY hours DESC";

$gp = new GraphicPie($Lang->getText('TimeTrackingReporting.ByItem'), 400, 250);
$gp->setSQL($sql);
$gp->setSQLFields('summary', 'hours');

if (ob_get_level()) ob_end_clean();
$gp->showPie();

