<?php
require_once 'propel/map/MapBuilder.php';
include_once 'creole/CreoleTypes.php';

/**
 * This class adds structure of 'user_blog' table to 'gf5' DatabaseMap object.
 *
 * These statically-built map classes are used by Propel to do runtime db structure discovery.
 * For example, the createSelectSql() method checks the type of a given column used in an 
 * ORDER BY clause to know whether it needs to apply SQL to make the ORDER BY case-insensitive 
 * (i.e. if it's a text column type).
 *
 * @see BasePeer
 * @see DatabaseMap
 * @package plugins.userblog.lib.map
 */
class UserBlogMapBuilder implements MapBuilder {

    /**
     * The name of this class
     */
    const CLASS_NAME = "plugins.userblog.lib.map.UserBlogMapBuilder";
	
    /**
     * The database map.
     */
    private $dbMap = null;

    /**
     * Tells us if this DatabaseMapBuilder is built so that we
     * don't have to re-build it every time.
     *
     * @return true if this DatabaseMapBuilder is built
     */
    public function isBuilt()
    {
        return ($this->dbMap !== null);
    }

    /**
     * Gets the databasemap this map builder built.
     *
     * @return the databasemap
     */
    public function getDatabaseMap()
    {
        return $this->dbMap;
    }

    /**
     * The doBuild() method builds the DatabaseMap
     *
	 * @return void
     * @throws PropelException
     */
    public function doBuild()
    {
		$this->dbMap = Propel::getDatabaseMap("gf5");
		
		$tMap = $this->dbMap->addTable("user_blog");
		$tMap->setPhpName("UserBlog");
		
         
		$tMap->setUseIdGenerator(true);
		 
						
		 
		$tMap->setPrimaryKeyMethodInfo("user_blog_user_blog_id_seq");
		 
		
		// Add columns to map
		$tMap->addForeignKey("USER_ID", "UserId", "int", CreoleTypes::INTEGER, "user" , "USER_ID", true);
		$tMap->addPrimaryKey("USER_BLOG_ID", "UserBlogId", "int", CreoleTypes::INTEGER, true);
		$tMap->addColumn("SUBJECT", "Subject", "string", CreoleTypes::VARCHAR, false, null);
		$tMap->addColumn("CONTENT", "Content", "string", CreoleTypes::VARCHAR, false, null);
		$tMap->addColumn("POST_DATE", "PostDate", "int", CreoleTypes::TIMESTAMP, false, null);
				
    }
}
