<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code shows a form for editing News
//
require_once('plugins/userblog/lib/UserBlogPeer.php');
require_once('plugins/userblog/lib/UserBlog.php');
require_once('exceptions/PermissionDeniedException.php');
//require_once('plugins/forum/lib/html/ForumFormRenderer.php');

$kept_vars = array('action', 'id');

$session = Session::getSession();
$Lang = $session->getLanguage();

$forum_action = Validator::sanitizeString($_REQUEST['_forum_action']);

require_once('plugins/userblog/lib/html/UserblogMyTemplate.php');
$theme = new UserblogMyTemplate();

$Project = GFUrl::getUrl()->getProject();

$post_id = isset($_REQUEST['post_id']) ? Validator::sanitizeInt($_REQUEST['post_id']) : 0;
$thread_id = isset($_REQUEST['thread_id']) ? Validator::sanitizeInt($_REQUEST['thread_id']) : 0;
$message_id = isset($_REQUEST['message_id']) ? Validator::sanitizeInt($_REQUEST['message_id']) : 0;
$forum_action = isset($_REQUEST['_forum_action']) ? Validator::sanitizeString($_REQUEST['_forum_action']) : "";

if ($thread_id == 0) {
	if($message_id != 0) {
		$ForumMessage = ForumMessagePeer::retrieveByPk($message_id);
		if (is_object($ForumMessage)) {
			$Forum = $ForumMessage->getForumThread()->getForum();
			$post_id = $Forum->getRefId();
		}
	}
} else {
	$ForumThread = ForumThreadPeer::retrieveByPk($thread_id);
	if (is_object($ForumThread)) {
		$Forum = $ForumThread->getForum();
		$post_id = $Forum->getRefId();
	}
}


$Post = UserBlogPeer::retrieveByPk($post_id);
if (!is_object($Post)) {
	throw new PermissionDeniedException();
}
$obj = $Post;

/*
 * Generate the forum page. This is done BEFORE outputting any text before 
 * this code could redirect.
 */
include_once('plugins/news/lib/html/NewsCommentsRenderer.php');
$renderer = new NewsCommentsRenderer(UserBlog::SECTION, UserblogPlugin::getFormPaths(), $Post->getPrimaryKey(), $theme, $Lang, $kept_vars);

$forum_page = $renderer->handleBrowse($Forum, $Post->getSubject(), $thread_id, $message_id, $forum_action);

if ($renderer->hasErrors()) {
	$feedback = "*".implode('<br />*', $renderer->getErrors());
	echo $feedback;
} else {
	echo $forum_page;
}
?>
