<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code lists News
//
require_once('plugins/userblog/lib/UserBlogPeer.php');
require_once('plugins/userblog/lib/UserBlog.php');

$session = Session::getSession();
$Lang = $session->getLanguage();

require_once('plugins/userblog/lib/html/UserblogMyTemplate.php');
$theme = new UserblogMyTemplate();

$id = Validator::sanitizeInt($_REQUEST['id']);

$user = $session->getUser();

$Post = UserBlogPeer::retrieveByPk($_GET['id']);
if (!is_object($Post)) {
	throw new PermissionDeniedException();
}

/*
 * Generate the forum page. This is done BEFORE outputting any text before 
 * this code could redirect.
 */
// Try to create a forum for this news on the fly
$c = new Criteria();
$c->add(ForumPeer::SECTION, UserBlog::SECTION);
$c->add(ForumPeer::REF_ID, $Post->getPrimaryKey());
$forum = ForumPeer::doSelectOne($c);
if (is_null($forum)) {
	$forum = new Forum();
	$forum->setSection(UserBlog::SECTION);
	$forum->setRefId($Post->getPrimaryKey());
	$forum->setForumName($Post->getSubject());
	// We do this because we may be logged in as any user, so we must skip
	// permission checks
	$forum->forceSave();
	$forum->save();
}

include_once('plugins/news/lib/html/NewsCommentsRenderer.php');
$kept_vars = array();
$renderer = new NewsCommentsRenderer(UserBlog::SECTION, UserblogPlugin::getFormPaths(), $Post->getPrimaryKey(), $theme, $Lang, $kept_vars);

$form = $renderer->handleBrowse($forum, $Post->getSubject(), 0, 0, 'ForumThreadAdd');
echo $form;
//require_once("plugins/userblog/wwwlib/forms/UserblogThreadAdd-tpl.php");
?>