<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code creates a new News and saves it to the 
// database
//
require_once('plugins/userblog//lib/UserBlog.php');
require_once('Validator.php');
require_once('exceptions/InvalidDataException.php');
require_once('exceptions/PermissionDeniedException.php');
require_once('core/Language.php');

if ($_SERVER['REQUEST_METHOD'] != 'POST') {
	throw new PermissionDeniedException();
}

$UserBlog = new UserBlog();
$Str = new StringUtils(StringUtils::FULL_HTML);

if (!$UserBlog->userCanCreate()) {
	throw new PermissionDeniedException();
}

$errors = array();
$language = Language::getSessLang();
$session = Session::getSession();
$user = $session->getUser();

if (count($errors) == 0) {
	$UserBlog->setUserId($user->getUserId());
	$UserBlog->setSubject( Validator::sanitizeString($_POST['subject']) );
	$UserBlog->setContent( $Str->cleanHtml($_POST['content']) );
	
	try {
		$UserBlog->save();
	} catch (InvalidDataException $ex) {
		$errors = array_merge($errors, $ex->getErrors());		
	}

}
	
if (count($errors) > 0) {
	$feedback = '* '.implode('<br />* ', $errors);
	include('UserblogAdd.php');
} else {
	GFUrl::getUrl()->redirect(GFUrl::getUrl()->currentBaseURL(''), array('feedback' => $language->getText('News.AddFeedback')));
}

?>
