<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code shows a form for editing News
//
require_once('plugins/userblog/lib/UserBlogPeer.php');
require_once('plugins/userblog/lib/UserBlog.php');
require_once('exceptions/PermissionDeniedException.php');
require_once('lib/html/GFCKEditor.php');

$session = Session::getSession();
$Lang = $session->getLanguage();

require_once('plugins/userblog/lib/html/UserblogMyAdminTemplate.php');
$theme = new UserblogMyAdminTemplate();

$post_id = Validator::sanitizeInt($_REQUEST['id']);

$user = $session->getUser();
$UserBlog = UserBlogPeer::retrieveByPk($post_id);
if (!is_object($UserBlog) || !$UserBlog->userCanUpdate()) {
	throw new PermissionDeniedException();
}
$obj = $UserBlog;

$params = array(
		'user' => $user,
	//	'News' => $News,
		'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : ''),
		'action' => isset($action) ? $action : '',
		'title' => $Lang->getText('News.EditPageTitle')
		);

$sByUser = $user;
$submitted_by = $sByUser->getFirstname().' '.$sByUser->getLastname();

$subject = ( (isset($_POST) && isset($_POST['subject'])) ? htmlspecialchars($_POST['subject']) : $obj->getSubject() );
$content = ( (isset($_POST) && isset($_POST['content'])) ? $_POST['content'] : $obj->getContent() );

$CKEditor = new GFCKEditor(GFCKEditor::FULL);
$CKEditor->config['width'] = 700;
$CKEditor->config['height'] = 500;
$CKEditor->setConnectorURLs($user->getUserId());

/*
$oFCKeditor = new FCKeditor('content', $content) ;
$oFCKeditor->BasePath = GFUrl::getUrl()->buildURL('/fckeditor/');
$oFCKeditor->Width = "700";
$oFCKeditor->Height = "500";
$oFCKeditor->ToolbarSet = "GForge";
$oFCKeditor->setConnectorURLs($user->getUserId());*/

include ('forms/UserblogEdit-tpl.php');

?>