<?php

require_once('plugin/GFPlugin.php');
require_once('plugin/ActionManager.php');
require_once('plugin/PluginResult.php');
require_once('plugins/calendar/lib/Calendar.php');
require_once('plugins/calendar/lib/CalendarPeer.php');
require_once('GFUrl.php');

class UsercalendarPlugin implements GFPlugin {
	const NAME='usercalendar';
	

	function __construct(){
		//$user = GFUrl::getUser();
	}

	public function initialize(){
		ActionManager::registerListeners($this, $this->getListeners());

	}

	public function getType(){
		return GFPlugin::USER_PLUGIN;
	}

	public function getName(){
		return self::NAME;
	}

	public function getListeners(){
		return array(
			'BUILD_MYPAGE_TABS',
			'BUILD_USER_TABS',
			'GET_USERCALENDAR_NAV_ELEMENTS',
			'BUILD_MYPAGE_ELEMENTS'
		);
	}


	public function enableInUser() {
		$user = Session::getSession()->getUser();
		$c = new Criteria();
		$c->add(PluginPeer::PLUGIN_NAME,$this->getName());
		$plugin = PluginPeer::doSelectOne($c);
		$up = new UserPlugin();
		if (($user instanceof User) && ($plugin instanceof Plugin)) {
			$up->setUser($user);
			$up->setPlugin($plugin);
			try {
				$up->save();
			} catch (PropelException $e) {
				// just trying to double insert
				//return;
			}
		}
		//Create calendar entry if it doesn't exists
		$c = new Criteria();
		$c->add(CalendarPeer::REF_ID, $user->getUserId());
		$c->add(CalendarPeer::SECTION, 'user');
		$calendar = CalendarPeer::doSelectOne($c);
		if(!is_object($calendar)){
			//Create the entry
			$calendar = new Calendar();
			$calendar->setRefId($user->getUserId());
			$calendar->setSection('user');
			$calendar->setCalendarName('My Calendar');
			$calendar->setDescription('An user calendar');
			$calendar->setIsPublic(false);
			$calendar->setFirstDayOfWeek(1);
			$calendar->save();
		}

		return;
	}


	public function disableFromUser() {
		$c = new Criteria();
		$c->add(PluginPeer::PLUGIN_NAME,$this->getName());
		$plugin = PluginPeer::doSelectOne($c);
		$c->clear();
		$c->add(UserPluginPeer::USER_ID,Session::getSession()->getUser()->getUserId());
		$c->add(UserPluginPeer::PLUGIN_ID,$plugin->getPluginId());
		$pp = UserPluginPeer::doSelectOne($c);
		if (($pp instanceof UserPlugin )) {
			$pp->delete();
		}		
	}

	public function handleAction($listenerName, $params){
		switch($listenerName){
			case 'BUILD_MYPAGE_TABS': 
			case 'BUILD_USER_TABS': {
				return $this->_buildMainTabsListener($params);
				break;
			}

		}

	}

	public function search(GFSearch $search){
		return NULL;
	}

	private function _buildMainTabsListener($params){
		if (!isset($params['user']) || !is_object($params['user']) 
			|| !$params['user']->usesPlugin($this->getName())) {
			return;
		}		
		$user = $params['user'];

		$result = new PluginResult($this);
		$components = GFUrl::getUrl()->getURI();
		$arr = explode('/',$components);
		if (in_array('my',$arr)) {
			// for "my" page
			$value = array(
					'text'	=> Language::getSessText('UserCalendar.TabString'),
					'action'	=> '/gf/user/'.$user->getUnixName().'/usercalendar/my',
					'id'	=> 'usercalendar'
			);			
		} else {
			// for "user" page
			$value = array(
					'text'	=> Language::getSessText('UserCalendar.TabString'),
					'action'	=> '/gf/user/'.$user->getUnixName().'/usercalendar/',
					'id'	=> 'usercalendar'
				);				
		}

		$result->setResult($value);
		return $result;
	}

}

?>
