<?php

require_once('lib/html/UserTemplate.php');
require_once('lib/plugin/PluginResult.php');


class UsercalendarTemplate extends UserTemplate{
	/**
	 * Header - this subclasses header and just passes params and data that is specific
	 * to this template
	 * @param array array of parameters
	*/
	function header($params) {
		$params['selectedbottomtab']='usercalendar';
		$Lang = Session::getSession()->getLanguage();
		if (isset($params['calendar']) && is_object($params['calendar'])) {
			if (isset($params['title'])) {
				$params['title']=$Lang->getText('UserCalendar.TabString');
			} else {
				Throw new exception('Missing title in calendar template');
			}
		} else {
			//Throw new exception('Missing tracker object in tracker template');
		}
		if (isset($params['calendar'])) {
			if (!$params['calendar']->userCanRead()) {
				throw new PermissionDeniedException();
			}
			$this->addBreadCrumb('<a href="/gf/user/'.$params['user']->getUnixName().'/usercalendar/">'.$Lang->getText('UserCalendar.TabString').'</a>');
		}
		return parent::header($params);
	}

	function getExtraCSS(){
		return array('/themes/'.$this->getName().'/calendar.css');
	}


	/**
	 * getTemplateNavElements - this function can be overridden
	 * by subclasses so you can add navigation entries
	 * @return array - complex array of data.
	 */
	function getTemplateNavElements($params) {
		$url = GFurl::getUrl();
		$lang = Session::getSession()->getLanguage();
		$loggedin = Session::getSession()->isLoggedIn();
		$user = $params['user'];
		$ret = array();
		
		$elements = array(
			array('link'=>$url->userUrl($user, 'monthview', 'usercalendar', '', ''),
					'description'=>$lang->getText('UserCalendar.MonthView')),
			array('link'=>$url->userUrl($user, 'weekview', 'usercalendar', '', ''),
					'description'=>$lang->getText('UserCalendar.WeekView')),
			array('link'=>$url->userUrl($user, 'dayview', 'usercalendar', '', ''),
					'description'=>$lang->getText('UserCalendar.DayView'))
		);

		if($loggedin){
			if($user->getPrimaryKey() == Session::getSession()->getUser()->getPrimaryKey()){
				$elements[] = array(
					'link'=>$url->UserURL($user, '','usercalendar','my/admin',''),
					'description'=>$lang->getText('UserCalendar.Admin'),
				);
			}
		}

		$ret[] = array(
			'title' => $lang->getText('UserCalendar.MyCalendar'),
			'elements'=> $elements
		);

		return $ret;
	}


	
}
?>
