<?php

require_once('plugins/calendar/lib/CalendarEvent.php');
require_once('plugins/calendar/lib/CalendarEventReminder.php');

Validator::validatePOSTAction();


$user=GFUrl::getUrl()->getUser();
$lang= Language::getSessLang();

$errors = array();

$event_id = Validator::sanitizeInt($_POST['event_id']);
$from_date =Validator::sanitizeDate($_POST['from_date']);
$to_date = Validator::sanitizeDate($_POST['to_date']);
$from_hour_hour  = $_POST['from_hour_hour'];
$from_hour_minute = $_POST['from_hour_minute'];
$to_hour_hour = $_POST['to_hour_hour']; 
$to_hour_minute = $_POST['to_hour_minute'];
$subject = Validator::sanitizeString($_POST['subject']);
$description = isset($_POST['description']) ? Validator::sanitizeString($_POST['description']) : '';
/* Disabled for now
$occurrence = isset($_POST['occurrence']) ? Validator::sanitizeInt($_POST['occurrence']) : 0;
$occurrence_to = isset($_POST['occurrence_to']) ? Validator::sanitizeDate($_POST['occurrence_to']) : '';
*/
$is_public = (isset($_POST['is_public']) && $_POST['is_public'] == "true") ? true : false;
$start_date = $_POST['start_date'];
$redirect_to = $_POST['redirect_to'];
$reminder =  $_POST['reminder'];


$c = new Criteria();
$c->add(CalendarEventPeer::CALENDAR_EVENT_ID, $event_id);
$cal_event = CalendarEventPeer::doSelectOne($c);

if(!is_object($cal_event) || !$cal_event->userCanUpdate()){
	throw new PermissionDeniedException();
}
try{
	$cal_event->setFromDate($from_date . ' ' . $from_hour_hour . ':' . $from_hour_minute);
	$cal_event->setToDate($to_date . ' ' . $to_hour_hour . ':' . $to_hour_minute);
	$cal_event->setSubject($subject);
	$cal_event->setDescription($description);
	/*
	$cal_event->setOccurrence($occurrence);
	$cal_event->setOccurrenceTo($occurrence_to);
	*/
	$cal_event->setIsPublic($is_public);
	$cal_event->save();

} catch(InvalidDataException $e){
	$errors = array_merge($errors, $e->getErrors());
}
if(count($errors) > 0){
	$feedback = '* ' . implode('<br />* ', $errors);
	include('UsercalendarEventEdit.php');
} else {
	//set Remminder
	//TODO add support for multiple reminders
	if($reminder){
		$ers = $cal_event->getCalendarEventReminders();
		if(!empty($ers)){
			$ers[0]->editReminder($cal_event, $reminder);
			$ers[0]->save();
		} else {
			$er = new CalendarEventReminder();
			$er->setNewReminder($cal_event, $reminder);
			$er->save();
		}
	} else {
		//Delete reminder
		$ers = $cal_event->getCalendarEventReminders();
		if(isset($ers[0]) && is_object($ers[0])){
			$ers[0]->delete();
		}
	}
	GFUrl::redirect(GFUrl::getUrl()->currentBaseUrl($redirect_to, array('event_id'=>$_POST['event_id'], 'start_date'=>$start_date,'feedback'=>$lang->getText('UserCalendar.EventEditFeedback'))));
}
