<?php

require_once('plugins/usercalendar/lib/html/UsercalendarMyTemplate.php');
require_once('plugins/calendar/lib/Calendar.php');

$session = Session::getSession();
$lang= $session->getLanguage();

if(!$session->isLoggedIn()){
	throw new NotLoggedInException();
}
$theme = new UsercalendarMyTemplate();


$user = GFUrl::getUrl()->getUser();

$c = new Criteria();
$c->add(CalendarPeer::REF_ID, $user->getUserId());
$c->add(CalendarPeer::SECTION, 'user');
$calendar = CalendarPeer::doSelectOne($c);

if(is_null($calendar) || !is_object($calendar) || !$calendar->userIsAdmin()){
	throw new PermissionDeniedException();
}

$calendar_name = $calendar->getCalendarName();
$description = $calendar->getDescription();
$first_day_of_week = $calendar->getFirstDayOfWeek();

$params = array(
		'user' => $user,
		'action' => isset($action) ? $action : '',
		'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : ''),
		'title' => $lang->getText('UserCalendar.Admin')
);

$theme->header($params);

include('forms/UsercalendarEdit-tpl.php');

$theme->footer($params);

?>

