<?php

if(!isset($_POST['calendar_id'])){
	throw new InvalidDataException();
}
$calendar_id = $_POST['calendar_id'];
$calendar = CalendarPeer::retrieveByPk($calendar_id);

if(!is_object($calendar) || !$calendar->userIsAdmin()){
	throw new PermissionDeniedException();
}
$session = Session::getSession();
$lang = $session->getLanguage();

$errors = array();
$calendar_name = isset($_POST['calendar_name']) ? Validator::sanitizeString($_POST['calendar_name']) : '';
$description = isset($_POST['description']) ? Validator::sanitizeString($_POST['description']) : '';
$first_day_of_week = Validator::sanitizeInt($_POST['first_day_of_week']);

try{
	$calendar->setCalendarName($calendar_name);
	$calendar->setDescription($description);
	$calendar->setFirstDayOfWeek($first_day_of_week);
	$calendar->save();
	
} catch (InvalidDataException $e){
	$errors = array_merge($errors, $e->getErrors());
}

if(count($errors) > 0){
	$feedback = '* ' . implode('<br />* ', $errors);
	include('UsercalendarEventAdd.php');
} else {
	GFUrl::redirect(GFUrl::getUrl()->currentBaseUrl('UsercalendarEdit', array('feedback'=>$lang->getText('UserCalendar.CalendarEditFeedback'))));
}

