<?php

require_once('plugins/calendar/lib/CalendarPeer.php');
require_once('Validator.php');

$session = Session::getSession();
$lang = $session->getLanguage();

if(!$session->isLoggedIn()){
	throw new NotLoggedInException();
}


if(isset($_GET['calendar_id'])){
	$calendar_id = Validator::sanitizeInt($_GET['calendar_id']);
} else {
	throw new InvalidDataException(array('calendar_id'=>'Missing  calendar_id'));
}

//Get calendar
$c = new Criteria();
$c->add(CalendarPeer::CALENDAR_ID, $calendar_id);
$calendar = CalendarPeer::doSelectOne($c);
if(!is_object($calendar) || !$calendar->userIsAdmin()){
	throw new PermissionDeniedException();
}

$filename = 'MyCalendar';
header("Content-Type: text/calendar\n");
header("Expires: 0");
header("Cache-Control: must-revalidate, post-check=0, pre-check=0");
header("content-disposition: attachment;filename=$filename.ics");
echo $calendar->exportToICalendar();

?>
