<?php

require_once('plugins/usercalendar/lib/html/UsercalendarTemplate.php');
require_once('plugins/usercalendar/lib/html/UsercalendarMyTemplate.php');
require_once('plugins/usercalendar/lib/html/UsercalendarRenderer.php');
require_once('Validator.php');
$session = Session::getSession();
$lang = $session->getLanguage();



$components = GFUrl::getUrl()->getURI();
$arr = explode('/',$components);
if (in_array('my',$arr)) {
	if(!$session->isLoggedIn()){
		throw new NotLoggedInException();
	}
	$theme = new UsercalendarMyTemplate();
} else {
	$theme = new UsercalendarTemplate();
}

//start_date when comming from POST is a string, when comming from GET it is an int
if(isset($_POST['start_date'])){
	$start_date = strtotime(Validator::sanitizeString($_POST['start_date']));
	setcookie('start_date', $start_date, date(time() + 259200));
} else if(isset($_GET['start_date'])){
	$start_date = Validator::sanitizeInt($_GET['start_date']);
	setcookie('start_date', $start_date, date(time() + 259200));
}else if (isset($_GET['yearID']) && isset($_GET['monthID'])){
	//The url format used by the active calendar libs
	$start_date = strtotime($_GET['yearID'].'-'.$_GET['monthID']. (isset($_GET['dayID']) ? $_GET['dayID']:'-1'));
	setcookie('start_date', $start_date, date(time() + 259200));
}else if(isset($_COOKIE['start_date'])){
	$start_date = $_COOKIE['start_date'];
}else {
	$start_date = time();
}
//$start_date = isset($_POST['start_date']) ? strtotime($_POST['start_date']) : (isset($_GET['start_date']) ? $_GET['start_date'] : time());

$user = GFUrl::getUrl()->getUser();

$params = array(
		'user' => $user,
		'action' => isset($action) ? $action : '',
		'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : ''),
		'title' => $lang->getText('UserCalendar.MonthView')
);

$theme->header($params);
?>
<script language="javascript" type="text/javascript" src="/datetimepicker.js"></script>
<script language="javascript" type="text/javascript" src="/js/calendar.js"></script>
<form action="<?php echo $_SERVER['REQUEST_URI']; ?>" method="post">
<table border="0" cellspacing="0" cellpadding="3" bgcolor="#E0E0E0">
<tr>
<tr>
	<td><strong><?php echo $lang->getText('UserCalendar.SelectedDate') ?></strong></td>
	<td><input id="startdate" name="start_date" value="<?php echo  date('M d Y',$start_date); ?>" size="11" maxlength="11" /><a href="javascript:NewCal('startdate','MMMddyyyy')"><img src="/themes/gforge5/images/cal.gif" width="16" height="16" border="0" alt="Pick a date"/></a></td>
	<td valign="middle" rowspan="2"><?php echo HTMLWidget::button("submit","" .   $lang->getText('UserCalendar.Submit')  . " ","submit","","")?></td>
</tr>
</tr>
</table>
</form>
<br />
<?php
	$cal = new UsercalendarRenderer($start_date, $user->getUserId());
	echo $cal->renderMonthView($start_date);
	
	echo HTMLWidget::button("button", $lang->getText('UserCalendar.AddNewEvent'),"add","",
	"window.location='" . GFUrl::getUrl()->currentBaseUrl('UsercalendarEventAdd', array('redirect_to'=>'monthview', 'start_date'=>$start_date)) . "';", $cal->getCalendar()->userCanCreate());
	$theme->footer($params);
?>
