<?php

require_once('plugins/usercalendar/lib/html/UsercalendarTemplate.php');
require_once('plugins/usercalendar/lib/html/UsercalendarMyTemplate.php');
require_once('plugins/usercalendar/lib/html/UsercalendarRenderer.php');
$session = Session::getSession();
$lang = $session->getLanguage();

$components = GFUrl::getUrl()->getURI();
$arr = explode('/',$components);
if (in_array('my',$arr)) {
	$theme = new UsercalendarMyTemplate();
	if(!$session->isLoggedIn()){
		throw new NotLoggedInException();
	}
} else {
	$theme = new UsercalendarTemplate();
}




//The start_date
if(isset($_POST['start_date'])){
	$start_date = strtotime($_POST['start_date']);
} else if(isset($_GET['start_date'])){
	$start_date = $_GET['start_date'];
} else if(isset($_COOKIE['start_date'])){
	$start_date = $_COOKIE['start_date'];
} else {
	$start_date = time();
}

setcookie('start_date', $start_date, date(time() + 259200));

if(isset($_POST['show_weeks'])){
	$show_weeks = $_POST['show_weeks'];
	setcookie('show_weeks', $show_weeks, date(time() + 259200));
}else if(isset($_COOKIE['show_weeks'])){
	$show_weeks = $_COOKIE['show_weeks'];
} else {
	$show_weeks = 1;
}


$user = GFUrl::getUrl()->getUser();

$params = array(
		'user' => $user,
		'action' => isset($action) ? $action : '',
		'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : ''),
		'title' => $lang->getText('UserCalendar.WeekView')
);


$theme->header($params);
?>
<script language="javascript" type="text/javascript" src="/datetimepicker.js"></script>
<form action="<?php echo $_SERVER['REQUEST_URI']; ?>" method="post">
<table border="0" cellspacing="0" cellpadding="3" bgcolor="#E0E0E0">
<tr>
<tr>
	<td><strong><?php echo $lang->getText('UserCalendar.StartDate') ?></strong></td>
	<td><input id="startdate" name="start_date" value="<?php echo date('M d Y', $start_date); ?>" size="11" maxlength="11" /><a href="javascript:NewCal('startdate','MMMddyyyy')"><img src="/themes/gforge5/images/cal.gif" width="16" height="16" border="0" alt="Pick a date"/></a></td>
	<td><strong><?php echo $lang->getText('UserCalendar.WeeksToShow'); ?></strong></td>
	<td><select id="show_weeks" name="show_weeks"> 
		<option <?php echo (isset($show_weeks) && ($show_weeks) == 1) ? 'selected="selected"' : '' ?> value=1>			<?php echo $lang->getText('UserCalendar.OneWeek'); ?>
		</option>
		<option <?php echo (isset($show_weeks) && ($show_weeks) == 2) ? 'selected="selected"' : '' ?> value=2>
			<?php echo $lang->getText('UserCalendar.TwoWeeks'); ?>
		</option>
		<option <?php echo (isset($show_weeks) && ($show_weeks) == 3) ? 'selected="selected"' : '' ?> value=3>
			<?php echo $lang->getText('UserCalendar.ThreeWeeks'); ?>
		</option>
		<option <?php echo (isset($show_weeks) && ($show_weeks) == 4) ? 'selected="selected"' : '' ?> value=4>
			<?php echo $lang->getText('UserCalendar.FourWeeks'); ?>
		</option>
	</select></td>
	<td valign="middle" rowspan="2"><?php echo HTMLWidget::button("submit","" .   $lang->getText('Common.Submit')  . " ","submit","","")?></td>
</tr>
</tr>
</table>
</form>
<br />
<?php
	$cal = new UsercalendarRenderer($start_date, $user->getUserId());
	echo $cal->renderWeekView($show_weeks);
	echo HTMLWidget::button("button", $lang->getText('UserCalendar.AddNewEvent'),"add","",
	"window.location='" . GFUrl::getUrl()->currentBaseUrl('UsercalendarEventAdd', array('redirect_to'=>'weekview', 'start_date'=>$start_date)) . "';", $cal->getCalendar()->userCanCreate());
	$theme->footer($params);
?>
