<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id$
 * @author Tim Perdue tim@gforge.org
 * @date 2006-02-27
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

require_once 'plugins/userwiki/lib/om/BaseWikiVersion.php';
require_once("plugin/ActionManager.php");
require_once 'lib/core/FilesystemPeer.php';
require_once 'plugins/userwiki/lib/UserwikiPlugin.php';

/** 
 * The skeleton for this class was autogenerated by Propel  * You should add additional methods to this class to meet the
 * application requirements.  This class will only be generated as
 * long as it does not already exist in the output directory.
 *
 * @package plugins.wiki.lib 
 */
class UserWikiVersion extends BaseUserWikiVersion {
	/**
	 * Stores the object in the database using the Propel methods. Informs the plugin manager.
	 * This method was added by propel_customizer.php.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
	function save($con = null) {
		parent::save($con);
		ActionManager::notify("WIKI_VERSION_SAVE", $this);
	}

	public function delete($con = null) {
		// fetch all the filesystem objects related to this version and wipe them out
		$c = new Criteria();
		$c->add(FilesystemPeer::REF_ID,$this->getPrimaryKey());
		$c->add(FilesystemPeer::SECTION,UserwikiPlugin::SECTION);
		$files = FilesystemPeer::doSelect($c);
		foreach ($files as $file) {
			$file->delete();
		}
		parent::delete($con);
	}
}
?>