<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   
 * @author Daniel A. Perez	daniel@gforgegroup.com
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

require_once('plugins/userwiki/lib/Wiki.php');

$components = GFUrl::getUrl()->getURI();
$arr = explode('/',$components);
if (in_array('my',$arr)) {
	require_once('plugins/userwiki/lib/html/WikiMyTemplate.php');
	$theme = new WikiMyTemplate();
} else {
	require_once('plugins/userwiki/lib/html/WikiUserTemplate.php');
	$theme = new WikiUserTemplate();
}

$user = GFUrl::getUrl()->getUser();

$section = User::SECTION;
$ref_id = $user->getUserId();
$diff = (isset($_REQUEST['diff'])) ? Validator::sanitizeInt($_REQUEST['diff']) : null;
$from = (isset($_REQUEST['from'])) ? Validator::sanitizeInt($_REQUEST['from']) : null;
$to = (isset($_REQUEST['to'])) ? Validator::sanitizeInt($_REQUEST['to']) : null;

if ($diff != null && $to != null && $from != null) {
	$wiki = new UserWiki($section,$ref_id,$theme,$user);
	$PageContent = $wiki->showDiffFromTo($diff, $from, $to);
} else if ($diff != null && $to != null) {
	$wiki = new UserWiki($section,$ref_id,$theme,$user);
	$PageContent = $wiki->showDiffTo($diff, $to);
} else if ($diff != null) {
	$wiki = new UserWiki($section,$ref_id,$theme,$user);
	$PageContent = $wiki->showDiff($diff);
} else {
	throw new PermissionDeniedException();
}

$params = array(
		'user' => $user,
		'action' => isset($action) ? $action : '',
		'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : ''),
		'title' => Language::getSessText('UserWiki.ViewDiffTitle'),
		'wiki' => $wiki,
		'selectedbottomtab' => 'userwiki'
		);

$theme->header($params);

echo $PageContent;

$theme->footer();
?>
