<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   
 * @author Daniel A. Perez	daniel@gforgegroup.com
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

require_once('lib/core/ProjectPeer.php');
require_once('lib/core/UserPeer.php');
require_once('lib/core/User.php');
require_once('lib/core/RolePeer.php');
require_once('lib/core/Role.php');
require_once('lib/core/UserPeer.php');
require_once('plugins/userwiki/lib/Wiki.php');
require_once('plugins/userwiki/lib/html/WikiMyAdminTemplate.php');

$theme = new WikiMyAdminTemplate();
$user = GFUrl::getUrl()->getUser();
$params = array(
		'user' => $user,
		'action' => isset($action) ? $action : '',
		'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : ''),
		'title' => 'Wiki Admin'
		);
$theme->header($params);


if (array_key_exists('pagename',$_REQUEST)) {
	$pagename = Validator::sanitizeString($_REQUEST['pagename']);
} else {
	$pagename = null;
}
if (array_key_exists('pageid',$_REQUEST)) {
	$pageid = Validator::sanitizeInt($_REQUEST['pageid']);
} else {
	$pageid = null;
}
if (array_key_exists('version',$_REQUEST)) {
	$version = Validator::sanitizeInt($_REQUEST['version']);
} else {
	$version = null;
}
if (array_key_exists('_action',$_REQUEST)) {
	$action = $_REQUEST['_action'];
} else {
	$action = null;
}
$section = User::SECTION; // This should be changed if were in the user wiki wwwlib, for example
$ref_id = $user->getUserId(); // This should be changed if were in the user wiki wwwlib, for example

$wiki = new UserWiki($section,$ref_id,$theme,$user);
$wiki->setAdmin();

if ($action) {
	switch ($action) {
		case 'updatestatistics' : {
			$wiki->updateStatistics();
			echo $wiki->displayFrontPage('<font color="red">Statistics Updated</font>');
			break;
		}
	}
} elseif ($pageid) {
	// display page or display create-page page
	if ($version) {
		echo $wiki->displayPageById($pageid,$version);
	} else {
		echo $wiki->displayPageById($pageid);
	}
} elseif ($pagename) {
	// display page or display create-page page
	if ($version) {
		echo $wiki->displayPage($pagename,$version);
	} else {
		echo $wiki->displayPage($pagename);
	}
} else {
	echo $wiki->displayFrontPage();
}

$theme->footer();
?>
