<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   
 * @author Daniel A. Perez	daniel@gforgegroup.com
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

require_once('html/SiteTemplate.php');
require_once('lib/core/ProjectPeer.php');
require_once('lib/core/UserPeer.php');
require_once('lib/core/User.php');
require_once('lib/core/RolePeer.php');
require_once('lib/core/Role.php');
require_once('lib/core/UserPeer.php');
require_once('plugins/wiki/lib/Wiki.php');
require_once('plugins/wiki/lib/html/WikiAdminTemplate.php');

$theme = new WikiAdminTemplate();
$project = GFUrl::getUrl()->getProject();


if (array_key_exists('lock',$_REQUEST)) {
	$lock = Validator::sanitizeInt($_REQUEST['lock']);
} else {
	$lock = null;
}
$section = Project::SECTION; // This should be changed if were in the user wiki wwwlib, for example
$ref_id = $project->getProjectId(); // This should be changed if were in the user wiki wwwlib, for example

$wiki = new Wiki($section,$ref_id,$theme,$project);
$wiki->setAdmin();

if ($lock) {
	echo $wiki->lockPage($lock);
	if (isset($_REQUEST['return_to']) && $_REQUEST['return_to']=='page') {
		GFUrl::redirect(GFUrl::getUrl()->projectURL($project,'','wiki','', array('pagename'=>$wiki->getPage()->getPageName(),'feedback'=>Language::getSessText('Wiki.LockedPage'))));
	} else {
		GFUrl::redirect(GFUrl::getUrl()->projectURL($project,'','wiki','', array('action'=>'WikiPageBrowse','feedback'=>Language::getSessText('Wiki.LockedPage'))));
	}
} else {
	$theme->header($params);
	echo 'ERROR - no page specified';

	$params = array(
		'project' => $project,
		'action' => isset($action) ? $action : '',
		'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : ''),
		'title' => 'Wiki Admin'
		);
	$theme->footer();
}

?>
