<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

// This code generates a SOAP API for handling Project

require_once('core/Project.php');
require_once('core/ProjectPeer.php');
require_once('Validator.php');

/* ******************************************************************** */
/*                                 DATA TYPES                           */
/* ******************************************************************** */
$server->wsdl->addComplexType(
	'ProjectTemplate',
	'complexType',
	'struct',
	'sequence',
	'',
	array(
		'template_project_id' => array('name'=>'template_project_id', 'type' => 'xsd:int'),
		'project_name' => array('name'=>'project_name', 'type' => 'xsd:string'),
		'description' => array('name'=>'description', 'type' => 'xsd:string')
	)
);


$server->wsdl->addComplexType(
	'ArrayOfProjectTemplate',
	'complexType',
	'array',
	'',
	'SOAP-ENC:Array',
	array(),
	array(array('ref' => 'SOAP-ENC:arrayType', 'wsdl:arrayType' => 'tns:ProjectTemplate[]')),
	'tns:ProjectTemplate'
);

/* ******************************************************************** */
/*                                 METHODS                              */
/* ******************************************************************** */

$server->register(
	'getProjectTemplates',
	array(
		'sessionHash'	=> 'xsd:string'
	), 
	array('getProjectTemplates' => 'tns:ArrayOfProjectTemplate'),
	$uri, 
	$uri.'#getProjectTemplates',
	'rpc',
	'encoded'
);


/**
 * SOAP method to retrieve the list of ProjectTemplates
 */
function getProjectTemplates($sessionHash) {
	$ip = $_SERVER['REMOTE_ADDR'];
	Session::getSession()->setup($ip, $sessionHash);

	$c = new Criteria();
	$c->add(ProjectPeer::IS_TEMPLATE, true);
	
	$objs = ProjectPeer::doSelect($c);
	$res = array();
	foreach ($objs as $obj) {
		$res[] = ProjectTemplateToSOAP($obj);
	}
	return $res;
}


function ProjectTemplateToSOAP(&$obj) {
	$ret = array();
	$ret['template_project_id'] = $obj->getProjectId();
	$ret['project_name'] = $obj->getProjectName();
	$ret['description'] = $obj->getDescription();
	return $ret;
}
?>
