<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

// This code generates a SOAP API for handling User

require_once('core/User.php');
require_once('core/UserPeer.php');
require_once('Validator.php');

/* ******************************************************************** */
/*                                 DATA TYPES                           */
/* ******************************************************************** */
$server->wsdl->addComplexType(
	'User',
	'complexType',
	'struct',
	'sequence',
	'',
	array(
		'user_id' => array('name'=>'user_id', 'type' => 'xsd:int'),
		'unix_name' => array('name'=>'unix_name', 'type' => 'xsd:string'),
		'email' => array('name'=>'email', 'type' => 'xsd:string'),
		'status' => array('name'=>'status', 'type' => 'xsd:int'),
		'create_date' => array('name'=>'create_date', 'type' => 'xsd:string'),
		'timezone' => array('name'=>'timezone', 'type' => 'xsd:string'),
		'date_format' => array('name'=>'date_format', 'type' => 'xsd:string'),
		'address' => array('name'=>'address', 'type' => 'xsd:string'),
		'address2' => array('name'=>'address2', 'type' => 'xsd:string'),
		'phone' => array('name'=>'phone', 'type' => 'xsd:string'),
		'fax' => array('name'=>'fax', 'type' => 'xsd:string'),
		'title' => array('name'=>'title', 'type' => 'xsd:string'),
		'firstname' => array('name'=>'firstname', 'type' => 'xsd:string'),
		'lastname' => array('name'=>'lastname', 'type' => 'xsd:string'),
		'country_code' => array('name'=>'country_code', 'type' => 'xsd:string'),
		'language_id' => array('name'=>'language_id', 'type' => 'xsd:int'),
		'theme_id' => array('name'=>'theme_id', 'type' => 'xsd:int'),
		'external_id' => array('name'=>'external_id', 'type' => 'xsd:string'),
		'last_login' => array('name'=>'last_login', 'type' => 'xsd:string'),
		'user_text1' => array('name'=>'user_text1', 'type' => 'xsd:string'),
		'user_text2' => array('name'=>'user_text2', 'type' => 'xsd:string'),
		'user_text3' => array('name'=>'user_text3', 'type' => 'xsd:string'),
		'user_text4' => array('name'=>'user_text4', 'type' => 'xsd:string'),
		'user_text5' => array('name'=>'user_text5', 'type' => 'xsd:string'),
		'user_text6' => array('name'=>'user_text6', 'type' => 'xsd:string'),
		'is_group'=>array('name'=>'is_group', 'type'=>'xsd:boolean'),
		//'password_change_date' => array('name'=>'password_change_date', 'type' => 'xsd:string')
	)
);


$server->wsdl->addComplexType(
	'ArrayOfUser',
	'complexType',
	'array',
	'',
	'SOAP-ENC:Array',
	array(),
	array(array('ref' => 'SOAP-ENC:arrayType', 'wsdl:arrayType' => 'tns:User[]')),
	'tns:User'
);

/* ******************************************************************** */
/*                                 METHODS                              */
/* ******************************************************************** */

/*
$server->register(
	'getUsers',
	array(
		'sessionHash'	=> 'xsd:string',
		'user_id' => 'xsd:int',
		'unix_name' => 'xsd:string',
		'email' => 'xsd:string',
		'status' => 'xsd:int',
		'password_md5' => 'xsd:string',
		'password_crypt' => 'xsd:string',
		'create_date' => 'xsd:string',
		'confirm_hash' => 'xsd:string',
		'email_new' => 'xsd:string',
		'timezone' => 'xsd:string',
		'date_format' => 'xsd:string',
		'address' => 'xsd:string',
		'address2' => 'xsd:string',
		'phone' => 'xsd:string',
		'fax' => 'xsd:string',
		'title' => 'xsd:string',
		'firstname' => 'xsd:string',
		'lastname' => 'xsd:string',
		'country_code' => 'xsd:string',
		'language_id' => 'xsd:int',
		'theme_id' => 'xsd:int',
		'external_id' => 'xsd:string',
		'last_login' => 'xsd:string',
		'user_text1' => 'xsd:string',
		'user_text2' => 'xsd:string',
		'user_text3' => 'xsd:string',
		'user_text4' => 'xsd:string',
		'user_text5' => 'xsd:string',
		'user_text6' => 'xsd:string',
		'is_group' => 'xsd:boolean',
		'password_change_date' => 'xsd:string',
	), 
	array('getUsers' => 'tns:ArrayOfUser'),
	$uri, 
	$uri.'#getUsers',
	'rpc',
	'encoded'
);


/**
 * SOAP method to retrieve a list of User
 * @param	$user_id	Filter by user_id
 * @param	$unix_name	Filter by unix_name
 * @param	$email	Filter by email
 * @param	$status	Filter by status
 * @param	$password_md5	Filter by password_md5
 * @param	$password_crypt	Filter by password_crypt
 * @param	$create_date	Filter by create_date
 * @param	$confirm_hash	Filter by confirm_hash
 * @param	$email_new	Filter by email_new
 * @param	$timezone	Filter by timezone
 * @param	$date_format	Filter by date_format
 * @param	$address	Filter by address
 * @param	$address2	Filter by address2
 * @param	$phone	Filter by phone
 * @param	$fax	Filter by fax
 * @param	$title	Filter by title
 * @param	$firstname	Filter by firstname
 * @param	$lastname	Filter by lastname
 * @param	$country_code	Filter by country_code
 * @param	$language_id	Filter by language_id
 * @param	$theme_id	Filter by theme_id
 * @param	$external_id	Filter by external_id
 * @param	$last_login	Filter by last_login
 * @param	$user_text1	Filter by user_text1
 * @param	$user_text2	Filter by user_text2
 * @param	$user_text3	Filter by user_text3
 * @param	$user_text4	Filter by user_text4
 * @param	$user_text5	Filter by user_text5
 * @param	$user_text6	Filter by user_text6
 * @param	$is_group	Filter by is_group
 * @param	$password_change_date	Filter by password_change_date
 * /
function getUsers($sessionHash, $user_id, $unix_name, $email, $status, $password_md5, $password_crypt, $create_date, $confirm_hash, $email_new, $timezone, $date_format, $address, $address2, $phone, $fax, $title, $firstname, $lastname, $country_code, $language_id, $theme_id, $external_id, $last_login, $user_text1, $user_text2, $user_text3, $user_text4, $user_text5, $user_text6, $is_group, $password_change_date) {
	$ip = $_SERVER['REMOTE_ADDR'];
	Session::getSession()->setup($ip, $sessionHash);

	$c = new Criteria();
	
	if (!is_null($user_id)) {
		$c->add(UserPeer::USER_ID, $user_id);
	}
	if (!is_null($unix_name)) {
		$c->add(UserPeer::UNIX_NAME, $unix_name);
	}
	if (!is_null($email)) {
		$c->add(UserPeer::EMAIL, $email);
	}
	if (!is_null($status)) {
		$c->add(UserPeer::STATUS, $status);
	}
	if (!is_null($password_md5)) {
		$c->add(UserPeer::PASSWORD_MD5, $password_md5);
	}
	if (!is_null($password_crypt)) {
		$c->add(UserPeer::PASSWORD_CRYPT, $password_crypt);
	}
	if (!is_null($create_date)) {
		$c->add(UserPeer::CREATE_DATE, $create_date);
	}
	if (!is_null($confirm_hash)) {
		$c->add(UserPeer::CONFIRM_HASH, $confirm_hash);
	}
	if (!is_null($email_new)) {
		$c->add(UserPeer::EMAIL_NEW, $email_new);
	}
	if (!is_null($timezone)) {
		$c->add(UserPeer::TIMEZONE, $timezone);
	}
	if (!is_null($date_format)) {
		$c->add(UserPeer::DATE_FORMAT, $date_format);
	}
	if (!is_null($address)) {
		$c->add(UserPeer::ADDRESS, $address);
	}
	if (!is_null($address2)) {
		$c->add(UserPeer::ADDRESS2, $address2);
	}
	if (!is_null($phone)) {
		$c->add(UserPeer::PHONE, $phone);
	}
	if (!is_null($fax)) {
		$c->add(UserPeer::FAX, $fax);
	}
	if (!is_null($title)) {
		$c->add(UserPeer::TITLE, $title);
	}
	if (!is_null($firstname)) {
		$c->add(UserPeer::FIRSTNAME, $firstname);
	}
	if (!is_null($lastname)) {
		$c->add(UserPeer::LASTNAME, $lastname);
	}
	if (!is_null($country_code)) {
		$c->add(UserPeer::CCODE, $country_code);
	}
	if (!is_null($language_id)) {
		$c->add(UserPeer::LANGUAGE_ID, $language_id);
	}
	if (!is_null($theme_id)) {
		$c->add(UserPeer::THEME_ID, $theme_id);
	}
	if (!is_null($external_id)) {
		$c->add(UserPeer::EXTERNAL_ID, $external_id);
	}
	if (!is_null($last_login)) {
		$c->add(UserPeer::LAST_LOGIN, $last_login);
	}
	if (!is_null($user_text1)) {
		$c->add(UserPeer::USER_TEXT1, $user_text1);
	}
	if (!is_null($user_text2)) {
		$c->add(UserPeer::USER_TEXT2, $user_text2);
	}
	if (!is_null($user_text3)) {
		$c->add(UserPeer::USER_TEXT3, $user_text3);
	}
	if (!is_null($user_text4)) {
		$c->add(UserPeer::USER_TEXT4, $user_text4);
	}
	if (!is_null($user_text5)) {
		$c->add(UserPeer::USER_TEXT5, $user_text5);
	}
	if (!is_null($user_text6)) {
		$c->add(UserPeer::USER_TEXT6, $user_text6);
	}
	if (!is_null($is_group)) {
		$c->add(UserPeer::IS_GROUP, $is_group);
	}
	if (!is_null($password_change_date)) {
		$c->add(UserPeer::PASSWORD_CHANGE_DATE, $password_change_date);
	}
	
	$objs = UserPeer::doSelect($c);
	$res = array();
	foreach ($objs as $obj) {
		if ($obj->userCanRead()) {
			$res[] = UserToSOAP($obj);
		}
	}
	
	return $res;
	
}
*/

$server->register(
	'getUserArray',
	array(
		'sessionHash'	=> 'xsd:string',
		'user_ids' => 'tns:ArrayOfInt',
	), 
	array('getUser' => 'tns:ArrayOfUser'),
	$uri, 
	$uri.'#getUser',
	'rpc',
	'encoded'
);

/**
 * SOAP method to retrieve an array of User
 * @param	$user_id	Retrieve the User array identified by the array of user_id
 */
function getUserArray($sessionHash, $user_idArr) {
	$ip = $_SERVER['REMOTE_ADDR'];
	Session::getSession()->setup($ip, $sessionHash);

	$ret = array();

	$crit=new Criteria();
        $crit->add(UserPeer::USER_ID,$user_idArr,Criteria::IN);
	$objs = UserPeer::doSelect($crit);
	foreach ($objs as $obj) {
		$ret[] = UserToSOAP($obj);
	}
	return $ret;
}

$server->register(
	'getUser',
	array(
		'sessionHash'	=> 'xsd:string',
		'user_id' => 'xsd:int',
	), 
	array('getUser' => 'tns:User'),
	$uri, 
	$uri.'#getUser',
	'rpc',
	'encoded'
);


$server->register(
	'getUserArrayByUnixName',
	array(
		'sessionHash'	=> 'xsd:string',
		'unix_names' => 'tns:ArrayOfString',
	), 
	array('getUserArrayByUnixName' => 'tns:ArrayOfUser'),
	$uri, 
	$uri.'#getUserArrayByUnixName',
	'rpc',
	'encoded'
);

/**
 * SOAP method to retrieve an array of User
 * @param	$user_id	Retrieve the User array identified by the array of user_id
 */
function getUserArrayByUnixName($sessionHash, $unix_nameArr) {
	$ip = $_SERVER['REMOTE_ADDR'];
	Session::getSession()->setup($ip, $sessionHash);

	$ret = array();

	$crit=new Criteria();
        $crit->add(UserPeer::UNIX_NAME,$unix_nameArr,Criteria::IN);
	$objs = UserPeer::doSelect($crit);
	foreach ($objs as $obj) {
		$ret[] = UserToSOAP($obj);
	}
	return $ret;
}


/**
 * SOAP method to retrieve a single User
 * @param	$user_id	Retrieve the User identified by this user_id
 */
function getUser($sessionHash, $user_id) {
	try {
		$ip = $_SERVER['REMOTE_ADDR'];
		Session::getSession()->setup($ip, $sessionHash);
	
		$obj = UserPeer::retrieveByPK($user_id);
		if (is_null($obj)) {
			return null;
		}
		return UserToSOAP($obj);
	} catch (Exception $e) {
		return new soap_fault('', 'getUser', $e->getMessage(), $e->getMessage());
	}
}


$server->register(
	'getUserByUnixName',
	array(
		'sessionHash'	=> 'xsd:string',
		'unix_name' => 'xsd:string',
	), 
	array('getUserByUnixName' => 'tns:User'),
	$uri, 
	$uri.'#getUserByUnixName',
	'rpc',
	'encoded'
);

/**
 * SOAP method to retrieve a single User
 * @param	$user_id	Retrieve the User identified by this unix_name
 */
function getUserByUnixName($sessionHash, $unix_name) {
	try {
		$ip = $_SERVER['REMOTE_ADDR'];
		Session::getSession()->setup($ip, $sessionHash);
	
		$obj = UserPeer::retrieveByUnixName($unix_name);
		if (is_null($obj)) {
			return null;
		}
		return UserToSOAP($obj);
	} catch (Exception $e) {
		return new soap_fault('', 'getUserByUnixName', $e->getMessage(), $e->getMessage());
	}
}


$server->register(
	'deleteUser',
	array(
		'sessionHash'	=> 'xsd:string',
		'user_id' => 'xsd:int',
	), 
	array('deleteUser' => 'xsd:int'),
	$uri, 
	$uri.'#deleteUser',
	'rpc',
	'encoded'
);

/**
 * SOAP method to delete a single User
 * @param	$user_id	Delete the User identified by this user_id
 */
function deleteUser($sessionHash, $user_id) {
	try {
		$ip = $_SERVER['REMOTE_ADDR'];
		Session::getSession()->setup($ip, $sessionHash);
	
		$obj = UserPeer::retrieveByPK($user_id);
		if (is_null($obj)) {
			return new soap_fault('', 'deleteUser','Permission Denied - Cannot Delete This Record','Permission Denied - Cannot View This Record');
		}
		try {
			$obj->delete();
			return 1;
		} catch (Exception $e) {
			return new soap_fault('', 'deleteUser','Permission Denied - Cannot Delete This Record: ' . $e->getMessage(),$e->getMessage());
		}
	} catch (Exception $e) {
		return new soap_fault('', 'deleteUser', $e->getMessage(), $e->getMessage());
	}
}


/*
$server->register(
	'updateUser',
	array(
		'sessionHash'	=> 'xsd:string',
		'user_id' => 'xsd:int',
		'unix_name' => 'xsd:string',
		'email' => 'xsd:string',
		'status' => 'xsd:int',
		'password_md5' => 'xsd:string',
		'password_crypt' => 'xsd:string',
		'create_date' => 'xsd:string',
		'confirm_hash' => 'xsd:string',
		'email_new' => 'xsd:string',
		'timezone' => 'xsd:string',
		'date_format' => 'xsd:string',
		'address' => 'xsd:string',
		'address2' => 'xsd:string',
		'phone' => 'xsd:string',
		'fax' => 'xsd:string',
		'title' => 'xsd:string',
		'firstname' => 'xsd:string',
		'lastname' => 'xsd:string',
		'country_code' => 'xsd:string',
		'language_id' => 'xsd:int',
		'theme_id' => 'xsd:int',
		'external_id' => 'xsd:string',
		'last_login' => 'xsd:string',
		'user_text1' => 'xsd:string',
		'user_text2' => 'xsd:string',
		'user_text3' => 'xsd:string',
		'user_text4' => 'xsd:string',
		'user_text5' => 'xsd:string',
		'user_text6' => 'xsd:string',
		'is_group' => 'xsd:boolean',
		'password_change_date' => 'xsd:string',
	), 
	array('updateUser' => 'xsd:int'),
	$uri, 
	$uri.'#updateUser',
	'rpc',
	'encoded'
);

/**
 * SOAP method to update User
 * @param	$user_id	 User to update
 * @param	$unix_name
 * @param	$email
 * @param	$status
 * @param	$password_md5
 * @param	$password_crypt
 * @param	$create_date
 * @param	$confirm_hash
 * @param	$email_new
 * @param	$timezone
 * @param	$date_format
 * @param	$address
 * @param	$address2
 * @param	$phone
 * @param	$fax
 * @param	$title
 * @param	$firstname
 * @param	$lastname
 * @param	$country_code
 * @param	$language_id
 * @param	$theme_id
 * @param	$external_id
 * @param	$last_login
 * @param	$user_text1
 * @param	$user_text2
 * @param	$user_text3
 * @param	$user_text4
 * @param	$user_text5
 * @param	$user_text6
 * @param	$is_group
 * @param	$password_change_date
 * /
function updateUser($sessionHash, $user_id, $unix_name, $email, $status, $password_md5, $password_crypt, $create_date, $confirm_hash, $email_new, $timezone, $date_format, $address, $address2, $phone, $fax, $title, $firstname, $lastname, $country_code, $language_id, $theme_id, $external_id, $last_login, $user_text1, $user_text2, $user_text3, $user_text4, $user_text5, $user_text6, $is_group, $password_change_date) {
	$ip = $_SERVER['REMOTE_ADDR'];
	Session::getSession()->setup($ip, $sessionHash);

	$obj = UserPeer::retrieveByPK($user_id);
	if (is_null($obj)) {
		return new soap_fault('', 'updateUser', 'Couldn\'t update User: invalid user_id '.$user_id);
	}
	
	if (!is_null($unix_name)) {
		$obj->setUnixName( Validator::sanitizeString($unix_name) );
	}
	if (!is_null($email)) {
		$obj->setEmail( Validator::sanitizeString($email) );
	}
	if (!is_null($status)) {
		$obj->setStatus( Validator::sanitizeInt($status) );
	}
	if (!is_null($password_md5)) {
		$obj->setPasswordMd5( Validator::sanitizeString($password_md5) );
	}
	if (!is_null($password_crypt)) {
		$obj->setPasswordCrypt( Validator::sanitizeString($password_crypt) );
	}
	if (!is_null($create_date)) {
		$obj->setCreateDate( Validator::sanitizeDate($create_date) );
	}
	if (!is_null($confirm_hash)) {
		$obj->setConfirmHash( Validator::sanitizeString($confirm_hash) );
	}
	if (!is_null($email_new)) {
		$obj->setEmailNew( Validator::sanitizeString($email_new) );
	}
	if (!is_null($timezone)) {
		$obj->setTimezone( Validator::sanitizeString($timezone) );
	}
	if (!is_null($date_format)) {
		$obj->setDateFormat( Validator::sanitizeString($date_format) );
	}
	if (!is_null($address)) {
		$obj->setAddress( Validator::sanitizeString($address) );
	}
	if (!is_null($address2)) {
		$obj->setAddress2( Validator::sanitizeString($address2) );
	}
	if (!is_null($phone)) {
		$obj->setPhone( Validator::sanitizeString($phone) );
	}
	if (!is_null($fax)) {
		$obj->setFax( Validator::sanitizeString($fax) );
	}
	if (!is_null($title)) {
		$obj->setTitle( Validator::sanitizeString($title) );
	}
	if (!is_null($firstname)) {
		$obj->setFirstname( Validator::sanitizeString($firstname) );
	}
	if (!is_null($lastname)) {
		$obj->setLastname( Validator::sanitizeString($lastname) );
	}
	if (!is_null($country_code)) {
		$obj->setCcode( Validator::sanitizeString($country_code) );
	}
	if (!is_null($language_id)) {
		$obj->setLanguageId( Validator::sanitizeInt($language_id) );
	}
	if (!is_null($theme_id)) {
		$obj->setThemeId( Validator::sanitizeInt($theme_id) );
	}
	if (!is_null($external_id)) {
		$obj->setExternalId( Validator::sanitizeString($external_id) );
	}
	if (!is_null($last_login)) {
		$obj->setLastLogin( Validator::sanitizeDate($last_login) );
	}
	if (!is_null($user_text1)) {
		$obj->setUserText1( Validator::sanitizeString($user_text1) );
	}
	if (!is_null($user_text2)) {
		$obj->setUserText2( Validator::sanitizeString($user_text2) );
	}
	if (!is_null($user_text3)) {
		$obj->setUserText3( Validator::sanitizeString($user_text3) );
	}
	if (!is_null($user_text4)) {
		$obj->setUserText4( Validator::sanitizeString($user_text4) );
	}
	if (!is_null($user_text5)) {
		$obj->setUserText5( Validator::sanitizeString($user_text5) );
	}
	if (!is_null($user_text6)) {
		$obj->setUserText6( Validator::sanitizeString($user_text6) );
	}
	if (!is_null($is_group)) {
		$obj->setIsGroup( Validator::sanitizeBool($is_group) );
	}
	if (!is_null($password_change_date)) {
		$obj->setPasswordChangeDate( Validator::sanitizeDate($password_change_date) );
	}
	
	try {
		$obj->save();
	} catch (Exception $e) {
		return new soap_fault('', 'updateUser','Permission Denied - Cannot update This Record',$e->getMessage());
	}
	return 1;
}

*/

$server->register(
	'addUser',
	array(
		'sessionHash'	=> 'xsd:string',
		'unix_name' => 'xsd:string',
		'email' => 'xsd:string',
		'password' => 'xsd:string',
		'timezone' => 'xsd:string',
		'date_format' => 'xsd:string',
		'address' => 'xsd:string',
		'address2' => 'xsd:string',
		'phone' => 'xsd:string',
		'fax' => 'xsd:string',
		'title' => 'xsd:string',
		'firstname' => 'xsd:string',
		'lastname' => 'xsd:string',
		'country_code' => 'xsd:string',
		'language_id' => 'xsd:int',
		'theme_id' => 'xsd:int',
		'user_text1' => 'xsd:string',
		'user_text2' => 'xsd:string',
		'user_text3' => 'xsd:string',
		'user_text4' => 'xsd:string',
		'user_text5' => 'xsd:string',
		'user_text6' => 'xsd:string',
		'is_group' => 'xsd:boolean'
	), 
	array('addUser' => 'xsd:int'),
	$uri, 
	$uri.'#getUsers',
	'rpc',
	'encoded'
);


/**
 * SOAP method to add a User
 * @param	$unix_name
 * @param	$email
 * @param	$status
 * @param	$password
 * @param	$timezone
 * @param	$date_format
 * @param	$address
 * @param	$address2
 * @param	$phone
 * @param	$fax
 * @param	$title
 * @param	$firstname
 * @param	$lastname
 * @param	$country_code
 * @param	$language_id
 * @param	$theme_id
 * @param	$user_text1
 * @param	$user_text2
 * @param	$user_text3
 * @param	$user_text4
 * @param	$user_text5
 * @param	$user_text6
 * @param	$is_group
 *
 * @return	int the assigned user_id
 */
function addUser($sessionHash, $unix_name, $email, $password, $timezone, $date_format, $address, $address2, $phone, $fax, $title, $firstname, $lastname, $country_code, $language_id, $theme_id, $user_text1, $user_text2, $user_text3, $user_text4, $user_text5, $user_text6, $is_group) {
	$ip = $_SERVER['REMOTE_ADDR'];
	Session::getSession()->setup($ip, $sessionHash);

	$obj = new User();

	$obj->setUnixName( Validator::sanitizeString($unix_name) );
	$obj->setEmail( Validator::sanitizeString($email) );
	$obj->setPassword( $password );		// Password must not be sanitized
	$obj->setTimezone( Validator::sanitizeString($timezone) );
	$obj->setDateFormat( Validator::sanitizeString($date_format) );
	$obj->setAddress( Validator::sanitizeString($address) );
	$obj->setAddress2( Validator::sanitizeString($address2) );
	$obj->setPhone( Validator::sanitizeString($phone) );
	$obj->setFax( Validator::sanitizeString($fax) );
	$obj->setTitle( Validator::sanitizeString($title) );
	$obj->setFirstname( Validator::sanitizeString($firstname) );
	$obj->setLastname( Validator::sanitizeString($lastname) );
	$obj->setCcode( Validator::sanitizeString($country_code) );
	$obj->setLanguageId( Validator::sanitizeInt($language_id) );
	$obj->setThemeId( Validator::sanitizeInt($theme_id) );
	$obj->setUserText1( Validator::sanitizeString($user_text1) );
	$obj->setUserText2( Validator::sanitizeString($user_text2) );
	$obj->setUserText3( Validator::sanitizeString($user_text3) );
	$obj->setUserText4( Validator::sanitizeString($user_text4) );
	$obj->setUserText5( Validator::sanitizeString($user_text5) );
	$obj->setUserText6( Validator::sanitizeString($user_text6) );
	//$obj->setIsGroup( Validator::sanitizeBool($is_group) );
	//$obj->setPasswordChangeDate( Validator::sanitizeDate($password_change_date) );
	try {
		$obj->save();
		return $obj->getUserId();
	} catch (Exception $e) {
		return new soap_fault('', 'addUser','Permission Denied - Cannot add This Record: ' . $e->getMessage(), $e->getMessage());
	}
}

$server->register(
	'getUserProjects',
	array(
		'sessionHash'	=> 'xsd:string',
		'unix_name' => 'xsd:string',
	), 
	array('getUserProjects' => 'tns:ArrayOfProject'),
	$uri, 
	$uri.'#getUserProjects',
	'rpc',
	'encoded'
);

/**
 * SOAP method to retrieve a user's projects
 * @param	$unix_name	Retrieve the Projects of the User identified by this unix_name
 */
function getUserProjects($sessionHash, $unix_name) {
	try {
		$ip = $_SERVER['REMOTE_ADDR'];
		Session::getSession()->setup($ip, $sessionHash);
	
		$obj = UserPeer::retrieveByUnixName($unix_name);
		if (is_null($obj)) {
			return null;
		}
		$projects = $obj->getAllProjects();
		$res = array();
		foreach ($projects as $prj) {
			if ($prj->userCanRead()) {
				$res[] = ProjectToSOAP($prj);
			}
		}
		return $res;
	} catch (Exception $e) {
		return new soap_fault('', 'getUserProjects', $e->getMessage(), $e->getMessage());
	}
}

$server->register(
	'addUserGroup',
	array(
		'sessionHash'	=> 'xsd:string',
		'group_name' => 'xsd:string',
		'group_unix_name' => 'xsd:string',
	), 
	array('addUserGroup' => 'xsd:int'),
	$uri, 
	$uri.'#addUserGroup',
	'rpc',
	'encoded'
);

/**
 * SOAP method to create a user group
 */
function addUserGroup($sessionHash, $group_name, $group_unix_name) {
	try {
		$ip = $_SERVER['REMOTE_ADDR'];
		Session::getSession()->setup($ip, $sessionHash);
		
		User::createUserGroup($group_name, $group_unix_name);
		return 1;
	} catch (Exception $e) {
		return new soap_fault('', 'deleteUser', $e->getMessage(), $e->getMessage());
	}
}

/**
 * SOAP method the get an array of users ids for a given group
 */

$server->register(
	'getGroupUsers',
	array(
		'sessionHash'=>'xsd:string',
		'group_id'=>'xsd:int'
	),
	array('getGroupUsers' =>'tns:ArrayOfInt'),
	$uri,
	$uri.'#getGroupUsers',
	'rpc',
	'encoded'
);
function getGroupUsers($sessionHash, $group_id){
	$ip = $_SERVER['REMOTE_ADDR'];
	$session = Session::getSession();
	$session->setup($ip, $sessionHash);

	if(!$session->isSiteAdmin()){
		return new soap_fault('', 'getGroupUsers', 'Permission Denied','Only site admin can perform this action');
	}
	
	try{
		$c = new Criteria();
		$c->add(UsergroupUserPeer::USERGROUP_ID, $group_id);
		$users = UsergroupUserPeer::doSelect($c);
	} catch (Exception $e){
		return new soap_fault('','getGroupUsers', $e->getMessage(), $e->getMessage());
	}
	foreach ($users as $user){
		$ret[] = $user->getMemberUserId();
	}
	return $ret;
}

$server->register(
	'addGroupUser',
	array(
		'sessionHash'=>'xsd:string',
		'group_id'=>'xsd:int',
		'user_ids'=>'tns:ArrayOfInt'
	),
	array('addGroupUser' =>'tns:ArrayOfInt'),
	$uri,
	$uri.'#addGroupUser',
	'rpc',
	'encoded'
);

function addGroupUser($sessionHash, $group_id, $user_ids){
	$ip = $_SERVER['REMOTE_ADDR'];
	$session = Session::getSession();
	$session->setup($ip, $sessionHash);
	if(!$session->isSiteAdmin()){
		return new soap_fault('','addGroupUser', 'Permission Denied');
	}
	
	//Sanitize
	$group_id = Validator::SanitizeInt($group_id);
	foreach($user_ids as $user_id){
		$user_id = Validator::SanitizeInt($user_id);
	}
	try{
		$group = UserPeer::retrieveByPk($group_id);
	} catch (Exception $e) {
		return new soap_fault('','addGroupUsers',$e->getMessage());
	}
	if(is_null($group) || !$group->getIsGroup()){
		return new soap_fault('','addGroupUsers', 'Invalid group id');
	}
	$ret = array();
	$flag = 0;
	foreach($user_ids as $user_id){
		$ug = new UsergroupUser();
		$ug->setMemberUserId($user_id);
		$ug->setUsergroupId($group_id);
		if(is_null($ug->save())){
			$ret[] = $user_id;
		}
	}

	return $ret;

}

$server->register(
	'deleteGroupUser',
	array(
		'sessionHash'=>'xsd:string',
		'group_id'=>'xsd:int',
		'user_ids'=>'tns:ArrayOfInt'
	),
	array('deleteGroupUser' =>'xsd:int'),
	$uri,
	$uri.'#deleteGroupUser',
	'rpc',
	'encoded'
);

function deleteGroupUser($sessionHash, $group_id, $user_ids){
	$ip = $_SERVER['REMOTE_ADDR'];
	$session = Session::getSession();
	$session->setup($ip, $sessionHash);
	if(!$session->isSiteAdmin()){
		return new soap_fault('','addGroupUser', 'Permission Denied');
	}
	
	//Sanitize
	$group_id = Validator::SanitizeInt($group_id);
	foreach($user_ids as $user_id){
		$user_id = Validator::SanitizeInt($user_id);
	}
	try{
		$group = UserPeer::retrieveByPk($group_id);
	} catch (Exception $e) {
		return new soap_fault('',__FUNCTION__,$e->getMessage());
	}
	if(is_null($group) || !$group->getIsGroup()){
		return new soap_fault('',__FUNCTION__, 'Invalid group id');
	}
	try{
		$group = UserPeer::retrieveByPk($group_id);
	} catch (Exception $e) {
		return new soap_fault('',__FUNCTION__,$e->getMessage());
	}
	if(is_null($group) || !$group->getIsGroup()){
		return new soap_fault('',__FUNCTION__, 'Invalid group id');
	}
	foreach($user_ids as $user_id){
		try{
		$c = new Criteria();
		$c->add(UsergroupUserPeer::MEMBER_USER_ID, $user_id);
		$c->add(UsergroupUserPeer::USERGROUP_ID, $group_id);
		$ug = UsergroupUserPeer::doSelectOne($c);
		if(!is_null($ug)){
			$ug->delete();
		}
		}catch(InvalidDataException $e){
			return new soap_fault('',__FUNCTION__,$e->getErrors());
		}

		return 1;
			
	}
}

$server->register(
	'activateUser',
	array(
		'sessionHash'=>'xsd:string',
		'user_id'=>'xsd:int',
	),
	array('activateUser' =>'xsd:int'),
	$uri,
	$uri.'#activateUser',
	'rpc',
	'encoded'
);

function activateUser($sessionHash, $user_id){
	$ip = $_SERVER['REMOTE_ADDR'];
	$session = Session::getSession();
	$session->setup($ip, $sessionHash);
	if(!$session->isSiteAdmin()){
		return new soap_fault('',__FUNCTION__, 'Permission Denied');
	}
	//Sanitize
	$user_id = Validator::SanitizeInt($user_id);
	$user = UserPeer::retrieveByPk($user_id);
	if(is_null($user)){
		return new soap_fault('',__FUNCTION__,'Invalid user id');
	}
	$user->activate();
	
	return 1;
}


function UserToSOAP(&$obj) {
	$ret = array();
	$ret['user_id'] = $obj->getUserId();
	$ret['unix_name'] = $obj->getUnixName();
	$ret['email'] = $obj->getEmail();
	$ret['status'] = $obj->getStatus();
	$ret['password_md5'] = $obj->getPasswordMd5();
	$ret['password_crypt'] = $obj->getPasswordCrypt();
	$ret['create_date'] = $obj->getCreateDate();
	$ret['confirm_hash'] = $obj->getConfirmHash();
	$ret['email_new'] = $obj->getEmailNew();
	$ret['timezone'] = $obj->getTimezone();
	$ret['date_format'] = $obj->getDateFormat();
	$ret['address'] = $obj->getAddress();
	$ret['address2'] = $obj->getAddress2();
	$ret['phone'] = $obj->getPhone();
	$ret['fax'] = $obj->getFax();
	$ret['title'] = $obj->getTitle();
	$ret['firstname'] = $obj->getFirstname();
	$ret['lastname'] = $obj->getLastname();
	$ret['country_code'] = $obj->getCcode();
	$ret['language_id'] = $obj->getLanguageId();
	$ret['theme_id'] = $obj->getThemeId();
	$ret['external_id'] = $obj->getExternalId();
	$ret['last_login'] = $obj->getLastLogin();
	$ret['user_text1'] = $obj->getUserText1();
	$ret['user_text2'] = $obj->getUserText2();
	$ret['user_text3'] = $obj->getUserText3();
	$ret['user_text4'] = $obj->getUserText4();
	$ret['user_text5'] = $obj->getUserText5();
	$ret['user_text6'] = $obj->getUserText6();
	$ret['is_group'] = $obj->getIsGroup();
	//$ret['password_change_date'] = $obj->getPasswordChangeDate();
	return $ret;
}
?>
