var jst;
var jst_open = false;
var text_options = [];
$(document).ready(function() {

	var frm = $('form.use-jst')[0];

	jst = $( "#jst-panel" ).dialog({
		autoOpen: false,
		height: 'auto',
		closeOnEscape: true,
		title: 'JST',
		show: 'drop',
		open: resetSearch,
		hide: 'fade',
		resizable: false,
		modal: true,
		width: 500
	});

	$( "#jst-panel" ).siblings('.ui-dialog-titlebar').hide();

	text_options = gatherTextOptions(frm);

	$( "#jst-panel .jst-text" ).autocomplete({
		delay: 50,
		focus: function(event, ui) { dontUpdateTextBox(event); },
		response: function(event, ui) { addTextOptionsToResults(text_options, $( "#jst-panel .jst-text").val(), ui.content); },
		select: function(event, ui) { setValue(frm, ui.item); resetSearch(); dontUpdateTextBox(event); },
		source: gatherJSTValues(frm)
    });
});

$( document ).on( 'keydown', function( ev ) {
	const tab = 9;
	const esc = 27;
    if (ev.keyCode == esc) {
    	if (jst_open) {
    		if ($( "#jst-panel .jst-text" ).val() != '') {
    			resetSearch();
    		} else {
	    		jst.dialog('close');
	    		jst_open = false;
    		}
    	} else {
    		jst.dialog('open');
    		jst_open = true;
    	}
	    ev.preventDefault();
    }
});

function addTextOptionsToResults(text_options, search_text, results) {
	for(i = 0; i < text_options.length; i++) {
		results.push(getOption(text_options[i], search_text));
	};
}

function dontUpdateTextBox(event) {
	event.preventDefault(); 
	event.stopPropagation();
}

function setValue(formElement, selectedItem) {

	var pieces = selectedItem.value.split(": ");
	if (pieces.length > 0) {
		// First chunk is the control name
		var control_name = pieces.shift();
		// The rest of the pieces form the selected value
		var value = pieces.join(": ");

		// Go find the control
		$('select', formElement).each(function(index, elem) {
			if (control_name == getControlName(elem)) {
				for(i=0;i<elem.options.length;i++) {
					// Select the matching option, de-select all others
					// for, e.g., assignee multi-selects to work as expected
					elem.options[i].selected = (elem.options[i].text == value);
				}
				return true;
			}
		});
		$('input:text', formElement).each(function(index, elem) {
			if (getControlName(elem) == control_name) {
				$(elem).val(value);
				return true;
			}
		});
		// TODO Option buttons, checkboxes
	}
	return false;
}

function resetSearch() {
	$('.jst-text').val('');
}

function gatherJSTValues(formElement) {
	var ret = [];
	$('select', formElement).not('.tabbertab *').each(function(index, elem) {
		var control_name = getControlName(elem);
		for(i=0;i<elem.options.length;i++) {
			ret.push(getOption(control_name, elem.options[i].text.trim()));
		}
	});

	return ret;
}

function gatherTextOptions(formElement) {
	var ret = [];
	$('input:text', formElement).not('.tabbertab *').each(function(index, elem) {
		ret.push(getControlName(elem));
	});

	return ret;
}

function getControlName(elem) {
	var ret = $(elem).attr('title');
	// Certain debugging/development plugins can create crazy-long attribute lists 
	// INSIDE the title attribute.  This messes up our logic, so ignore any title
	// that is longer than 50 chars (sanity check)
	if (ret == undefined || ret == '' || ret.length > 50) {
		//ret = $(elem).attr('name');
		
		// TODO For now, we're cheating to get field titles
		// The real solution is to add data- attributes to our extra fields
		// so we can be smarter about client-side handling.
		ret = $(elem).siblings('strong:first').text();
		if (ret.endsWith(":")) {
			ret = ret.substring(0, ret.length - 1);
		}
	}
	return ret.trim();
}

function getOption(control_name, opt_text) {

	var tmp_text = (opt_text.length < 30 ? opt_text : opt_text.substring(0, 26) + '...')
	return {
		label: "Set " + control_name + ' to "' + tmp_text + '"',
		value: control_name + ': ' + opt_text
	};
}

if (typeof String.prototype.endsWith !== 'function') {
    String.prototype.endsWith = function(suffix) {
        return this.indexOf(suffix, this.length - suffix.length) !== -1;
    };
}