<?php
require_once('core/User.php');
require_once('Validator.php');
require_once('exceptions/PermissionDeniedException.php');
require_once('core/Language.php');

if ($_SERVER['REQUEST_METHOD'] != 'POST') {
    throw new PermissionDeniedException();
}

$User = $session->getUser();

$errors = array();
$language = Language::getSessLang();

//
// TODO Validate the values passed by $_POST. Store the errors in $error like
// $errors["field_name"] = error_description
//
$password =  isset($_POST['password']) ? Validator::sanitizeString($_POST['password']) : '';
$is_confirmed = isset($_POST['is_confirmed']) ? true : false;

if (!$is_confirmed) {
    $errors[] = $language->getText('My.DisableAccountNotConfirmed');
}

$c = new Criteria();
$c->add(UserPeer::UNIX_NAME, $User->getUnixName());
$c->add(UserPeer::PASSWORD_MD5, md5($password));
$user = UserPeer::doSelectOne($c);

if (!is_object($user)) {
    $errors[] = $language->getText('My.DisableAccountBadPassword');
}

if (count($errors) == 0) {
    try {
        $user->delete();

        GFUrl::redirect($url->currentBaseURL('Logout'), array('feedback' => $language->getText('My.UserAccountDisabled', array($user->getUnixName()))));
    } catch (InvalidDataException $ex) {
        $errors = array_merge($errors, $ex->getErrors()); // attach object errors to validation errors
        $feedback = '* '.implode('<br />* ', $errors);
        include('DisableAccount.php');
    }
} else {
    $feedback = '* '.implode('<br />* ', $errors);
    include('DisableAccount.php');
}
?>
