<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id$
 * @author Tim Perdue tim@gforge.org
 * @date 2006-02-27
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

require_once('html/SiteTemplate.php');
require_once('Validator.php');
require_once('StringUtils.php');

$session = Session::getSession();
if ($session->isLoggedIn()) {
	// if user is already logged in, go to the logout page
	$url = GFUrl::getUrl();
	$url->redirect($url->baseUrl('Logout', '', '/account'));
}

$template = new SiteTemplate();
$params = array(
		'selectedtoptab' => 'my',
		'title' => Language::getSessText('Common.Login'),
		'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : ''),
	);
$template->header($params);

if (isset($_POST) && isset($_POST['username'])) {
	$username = Validator::sanitizeString($_POST['username']);
} else {
	$username = '';
}

if (isset($_REQUEST['redirect']) && !empty($_REQUEST['redirect'])){
	if (Validator::validateRedirect($_REQUEST['redirect'])) {
		$redirect = StringUtils::stripHtmlTags($_REQUEST['redirect']); 
	}else{
    throw new NotFoundException();
	}
}else{
	$redirect = '';
}

//sso begin
if (GFConf::get('system.useSSO')) {
	if (isset($_SERVER[GFConf::get('system.SSOServerVar')])) {
		$url = GFUrl::getUrl();
		$params = array();
		if (isset($redirect)) {
			$params['redirect'] = urlencode($redirect);
		}
		$url->redirect($url->baseUrl('LoginAction', '', '/account'), $params);
	} else {
		throw new Exception('Must login with SSO first');
	}
}
//sso end
?>

<form action="<?php echo GFUrl::getUrl()->currentBaseURL('LoginAction') ?>" method="POST" autocomplete="off">
<input type="hidden" name="redirect" value="<?php echo $redirect; ?>" />
	<table border="0" cellspacing="7">
	<?php if (isset($showTFAForm) && $showTFAForm) : ?>
		<tr>
			<td>Token</td>
			<td>
			<input type="hidden" name="evaltfa" value="1" />
			<input type="hidden" name="username" value="<?php echo $username; ?>" />
			<input type="hidden" name="password" value="<?php echo $password; ?>" />
			<input type="text" name="token" value="" />
			</td>
		</tr>
	<?php else : ?>
		<tr>
			<td>User name</td>
			<td><input type="text" name="username" value="<?php echo $username ?>" /></td>
		</tr>
		<tr>
			<td>Password</td>
			<td><input type="password" name="password" value="" autocomplete="off" /></td>
		</tr>
	<?php endif; ?>
	<tr>
		<td>&nbsp;</td>
		<td><?php echo HTMLWidget::button("submit", Language::getSessText('Common.Login') ,"submit","","")?></td>
	</tr>
	</table>
	<a href="<?php echo GFUrl::getUrl()->baseUrl('ResendConfirmation','','account'); ?>"><?php echo Language::getSessText('User.ResendConfirmation'); ?></a>&nbsp;|&nbsp;<a href="<?php echo GFUrl::getUrl()->baseUrl('LostPassword','','account'); ?>"><?php echo Language::getSessText('User.LostYourPasswordLink'); ?></a>
<?php if(!GFConf::get('system.usesLdap') || GFConf::get('ldap.dbLoginPrefered')){
	$register_link= '<a href="' . GFUrl::getUrl()->baseURL('UserAdd','','account') . '">' . $language->getText('Common.NewAccount') .'</a>';
	echo '&nbsp;|&nbsp' . $register_link;
	}
?>
</form>

<?php
$template->footer();
?>

<script type="text/javascript">
document.onkeypress = processKey;

function processKey(e){
	if (null == e)
		e = window.event;
	var keyCode;
	if(e.keyCode)
		keyCode = e.keyCode;
	else
		keyCode = e.which;
	if(keyCode == 13) {
		document.getElementById('__button1__').click();
		return false;
	}
}
</script>
