<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

$errors = array();

if (!isset($_POST['confirm_hash'])) {
	$errors[] = Language::getSessText('LostLogin.NeedConfirmHash');
} else {
	$c = new Criteria();
	$c->add(UserPeer::CONFIRM_HASH,$_POST['confirm_hash']);
	$user = UserPeer::doSelectOne($c);
	if(!is_object($user)) $errors[] = Language::getSessText('LostLogin.NeedConfirmHash');
}

$new_password = isset($_POST['new_password']) ? $_POST['new_password'] : '';
$new_password_conf = isset($_POST['new_password_conf']) ? $_POST['new_password_conf'] : '';

if ($new_password != $new_password_conf) $errors[] = Language::getSessText('User.PasswordsDontMatch');

if(count($errors) == 0) {
	$passresult = Validator::validatePassword($new_password);
	if (!$passresult[0]) {
		$errors = array_merge($errors,$passresult[1]);
	}
}

if(count($errors) == 0) {
	try {
		$confirm_hash = md5(strval(time()) . strval(rand())); // First, we need to create new confirm hash
		$user->setConfirmHash($confirm_hash);
		$user->setPassword($new_password);
		$user->save();
	} catch (Exception $e) {
		$errors = array_merge($errors, $e->getErrors());
	}		
}

if (count($errors) > 0) {
	$feedback = '* '.implode('<br />* ', $errors);		
	include('lostlogin.php');
} else {
	$feedback = Language::getSessText('LostLogin.PassUpdated');
	header("Location: /gf/account/?action=Login&feedback=".urlencode($feedback));
}

?>
