<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id$
 * @author Tim Perdue tim@gforge.org
 * @date 2006-02-27
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

//
// This code shows a form for User
//
require_once('core/UserPeer.php');
require_once('core/User.php');
require_once('core/CountryCode.php');
require_once('core/Language.php');
require_once('core/Theme.php');
require_once('html/HTMLWidget.php');
require_once('lib/timezones.php');

$session = Session::getSession();
$Lang = $session->getLanguage();

if ($session->isLoggedIn()) {
	// if user is already logged in, go to the logout page
	header('Location: /gf/account/?action=Logout');
}

//Check if we are using ldap
if (GFConf::get('system.usesLdap') && !GFConf::get('ldap.dbLoginPrefered')){
	throw new PermissionDeniedException();
}

require_once('html/SiteTemplate.php');
$theme = new SiteTemplate();

// for project invites
$hash = ((isset($_REQUEST['hash'])) ? htmlspecialchars($_REQUEST['hash']) : '');
if ($hash != '') {
  $title = $Lang->getText("Project.Invite.Accept.Title");
  $c = new Criteria();
  $c->add(SettingPeer::SECTION, 'project');
  $c->add(SettingPeer::SETTING_VALUE, $hash);
  $s = SettingPeer::doSelectOne($c);
  if (is_object($s)) {
    $arr = explode(':', $s->getSettingName());
    $invite = array('email' => $arr[1], 'role_id' => $arr[2],
      'project_id' => $s->getProjectId());
  } else {
    $invite = null;
  }
  if (!$invite) {
    $theme->header($params);
    echo "<h3>Invalid hash</h3>";
    $theme->footer($params);
    exit;  
  }
} else {
  $title = $Lang->getText("User.AddNewPageTitle");
}
 

$params = array(
	//	'project' => $Project,
		'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : ''),
    'keep_feedback_tags' => isset($keep_feedback_tags),
		'selectedtoptab' => 'my',
		'selectedbottomtab' => 'core',
		'pagename'	=> $title,
		'title' => $title
		);

$unix_name=((isset($_POST['unix_name'])) ? htmlspecialchars($_POST['unix_name']) : '' );
if ($invite != null) {
  $email = $invite['email'];
} else {
  $email=((isset($_POST['email'])) ? htmlspecialchars($_POST['email']) : '' );
}
$confirm_hash=((isset($_POST['confirm_hash'])) ? htmlspecialchars($_POST['confirm_hash']) : '' );
$email_new=((isset($_POST['email_new'])) ? htmlspecialchars($_POST['email_new']) : '' );
$timezone=(isset($_POST['timezone'])) ? htmlspecialchars($_POST['timezone']) : GFConf::get('system.defaultTimeZone');
$date_format=((isset($_POST['date_format'])) ? htmlspecialchars($_POST['date_format']) : '' );
$address=((isset($_POST['address'])) ? htmlspecialchars($_POST['address']) : '' );
$address2=((isset($_POST['address2'])) ? htmlspecialchars($_POST['address2']) : '' );
$phone=((isset($_POST['phone'])) ? htmlspecialchars($_POST['phone']) : '' );
$fax=((isset($_POST['fax'])) ? htmlspecialchars($_POST['fax']) : '' );
$title=((isset($_POST['title'])) ? htmlspecialchars($_POST['title']) : '' );
$firstname=((isset($_POST['firstname'])) ? htmlspecialchars($_POST['firstname']) : '' );
$lastname=((isset($_POST['lastname'])) ? htmlspecialchars($_POST['lastname']) : '' );
$ccode=((isset($_POST['ccode'])) ? htmlspecialchars($_POST['ccode']) : '' );
$language_id=((isset($_POST['language_id'])) ? htmlspecialchars($_POST['language_id']) : '' );
$theme_id=((isset($_POST['theme_id'])) ? htmlspecialchars($_POST['theme_id']) : GFConf::get('system.defaultThemeId') );
$selected_avatar = ((isset($_POST['selected_avatar'])) ? htmlspecialchars($_POST['selected_avatar']) : 3);

$avatar_url = "/themes/gforge5/images/avatar_default.png";

$cell=((isset($_POST['cell'])) ? htmlspecialchars($_POST['cell']) : '' );

require_once('forms/UserAdd-tpl.php');

?>
