<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code shows a form for editing UserUnix
//
require_once('core/UserUnixPeer.php');
require_once('core/UserUnix.php');
require_once('exceptions/PermissionDeniedException.php');

$session = Session::getSession();
$Lang = $session->getLanguage();

require_once('html/MyTemplate.php');
$theme = new MyTemplate();

if (!$session->isLoggedIn()) {
	throw new NotLoggedInException();
}
$User = $session->getUser();
$obj = $User;

$params = array(
		'user' => $User,
		'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : ''),
		'action' => isset($action) ? $action : '',
		'title' => $Lang->getText('UserUnix.EditPageTitle')
		);

$unix_shell_id = ( (isset($_POST) && isset($_POST['unix_shell_id'])) ? htmlspecialchars($_POST['unix_shell_id']) : $obj->getUnixShellId() );
$authorized_keys = ( (isset($_POST) && isset($_POST['authorized_keys'])) ? htmlspecialchars($_POST['authorized_keys']) : $obj->getAuthorizedKeys() );

include ('forms/UserUnixEdit-tpl.php');

?>