<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id$
 * @author Tim Perdue tim@gforge.org
 * @date 2006-02-27
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

$theme->header($params);
?>
<script type="text/javascript">

window.onload = function () {
	REDIPS.dialog.init();
}

function selectStockAvatar(id, avatar_url) {
	document.getElementById('imgavatar').src = avatar_url;
	document.getElementById('selected_avatar_2').checked = true;
	document.getElementById('avatar_id').value = id;
}

function showStockAvatarSelect() {
	$.ajax({
		url: "<?php echo GFUrl::getUrl()->currentBaseURL('StockAvatarSelect'); ?>",
	}).done(function (data) {
		var response = data || "No response text";
		REDIPS.dialog.show(650, 450, response, 'Close' ,'');
	});

	return;
}	

function setDefaultAvatar() {
	document.getElementById('imgavatar').src = '<?php echo '/themes/'.$theme->getName().'/images/avatar_default.png'; ?>';
	document.getElementById('selected_avatar_3').checked = true;
	document.getElementById('avatar_id').value = 0;
}

</script>
<p>
  <?php if ($hash != '') { ?>
	<strong><?php echo $Lang->getText('Project.Invite.Accept.Title'); ?></strong>
  <?php } else { ?>
	<strong><?php echo $Lang->getText('User.AddNewPageTitle'); ?></strong>
  <?php } ?>
</p>
<form action="<?php echo GFUrl::getUrl()->currentBaseURL('UserAddAction') ?>" method="POST" enctype="multipart/form-data" autocomplete="off">
	<table border="0">
		<tr>
			<td><strong><?php echo $Lang->getText('User.UnixNameName'); ?></strong><span class="required">*</span><br />
			<input type="text" name="unix_name" value="<?php echo $unix_name; ?>"  /></td>
		</tr>
		<tr>
			<td><strong><?php echo $Lang->getText('User.Password'); ?></strong><span class="required">*</span><br />
			<input type="password" name="password" maxlength="32" value=""  autocomplete="off" /></td>
		</tr>
		<tr>
			<td><strong><?php echo $Lang->getText('User.ConfirmPassword'); ?></strong><span class="required">*</span><br />
			<input type="password" name="password_confirm" maxlength="32" value=""  autocomplete="off" /></td>
		</tr>
		<tr>
			<td><strong><?php echo $Lang->getText('User.TitleName'); ?></strong><br />
			<input type="text" name="title" value="<?php echo $title; ?>"  size="5" /></td>
		</tr>
		<tr>
			<td><strong><?php echo $Lang->getText('User.FirstnameName'); ?></strong><span class="required">*</span><br />
			<input type="text" name="firstname" value="<?php echo $firstname; ?>"  /></td>
		</tr>
		<tr>
			<td><strong><?php echo $Lang->getText('User.LastnameName'); ?></strong><span class="required">*</span><br />
			<input type="text" name="lastname" value="<?php echo $lastname; ?>"  /></td>
		</tr>
		<tr>
			<td><strong><?php echo $Lang->getText('User.EmailName'); ?></strong><span class="required">*</span><br />
			<emph><?php echo $Lang->getText('User.EmailDescription', array(GFConf::get('system.hostName'))); ?></emph><br />
      <?php if ($hash != '') {  ?>
      <strong><?php echo $email; ?></strong>
      <?php } else { ?>
			<input type="text" name="email" value="<?php echo $email; ?>"  size="30" /></td>
      <?php } ?>
		</tr>
		<tr>
			<td>
				<table>
					<tr>
						<td>
							<img id="imgavatar" src="<?php echo $avatar_url; ?>" alt="avatar" />
						</td>
						<td valign="top">
							<table>
								<tr>
									<td>
										<input type="radio" id="selected_avatar_1" name="selected_avatar" value="1" <?php if($selected_avatar == 1) echo 'checked="checked"' ?> />
									</td>
									<td>
										<strong><?php echo Language::getSessText('User.AvatarUpload'); ?>:</strong><br />
										<input type="file" name="avatar" onclick="document.getElementById('selected_avatar_1').checked=true;"><br />
									</td>
								</tr>
								<tr>
									<td>
										<input type="radio" id="selected_avatar_2" name="selected_avatar" value="2" onclick="showStockAvatarSelect();" <?php if($selected_avatar == 2) echo 'checked="checked"' ?>/>
									</td>
									<td>
										<strong><a href="javascript:;" onclick="showStockAvatarSelect();">Select stock avatar</a></strong><br />
										<input type="hidden" id="avatar_id" name="avatar_id" value="" />
									</td>
								</tr>
								<tr>
									<td>
										<input type="radio" id="selected_avatar_3" name="selected_avatar" value="3" onclick="setDefaultAvatar();" <?php if($selected_avatar == 3) echo 'checked="checked"' ?>/>
									</td>
									<td>
										<strong>None (use default avatar)</strong><br />
									</td>
								</tr>							
							</table>
						</td>
					</tr>
				</table>
			</td>
		</tr>
		<tr>
			<td><strong><?php echo $Lang->getText('User.TimezoneName'); ?></strong><br />
			<?php echo HTMLWidget::selectBoxFromArrays($TZs,$TZs,'timezone',$timezone,false); ?></td>
		</tr>
		<input type="hidden" name="date_format" value="Y-M-D"/>
<!--		<tr>
			<td><strong><?php echo $Lang->getText('User.DateFormatName'); ?></strong><br />
			<input type="text" name="date_format" value="<?php echo $date_format; ?>"  /></td>
		</tr> -->
		<tr>
			<td><strong><?php echo $Lang->getText('User.AddressName'); ?></strong><br />
			<input type="text" name="address" value="<?php echo $address; ?>"  /></td>
		</tr>
		<tr>
			<td><strong><?php echo $Lang->getText('User.Address2Name'); ?></strong><br />
			<input type="text" name="address2" value="<?php echo $address2; ?>"  /></td>
		</tr>
		<tr>
			<td><strong><?php echo $Lang->getText('User.PhoneName'); ?></strong><br />
			<input type="text" name="phone" value="<?php echo $phone; ?>"  /></td>
		</tr>
		<tr>
			<td><strong><?php echo $Lang->getText('User.CellName'); ?></strong>
			<?php /*if (GFConf::get('system.useTFA')) : ?>
			<span class="required">*</span>
			<br />
			<emph><?php echo $Lang->getText('User.CellDescription'); ?></emph>
			<?php endif;*/ ?>
			<br />
			<input type="text" name="cell" value="<?php echo $cell; ?>"  /></td>
		</tr>
		<tr>
			<td><strong><?php echo $Lang->getText('User.FaxName'); ?></strong><br />
			<input type="text" name="fax" value="<?php echo $fax; ?>"  /></td>
		</tr>
		<tr>
			<td><strong><?php echo $Lang->getText('User.CountryCodeName'); ?></strong><span class="required">*</span><br />
			<?php
			$countries = CountryCodePeer::getOrderedCountryList();
			echo HTMLWidget::select('ccode',$countries,$ccode,'US',false);
			?>
			</td>
		</tr>
		<tr>
			<td><strong><?php echo $Lang->getText('User.LanguageIdName'); ?></strong><span class="required">*</span><br />
			<?php
			$languages = LanguagePeer::doSelect(new Criteria());
			echo HTMLWidget::select('language_id',$languages,$language_id,HTMLWidget::OPTION_NONE,false);
			?>
			</td>
		</tr>
		<tr>
			<td><strong><?php echo $Lang->getText('User.ThemeIdName'); ?></strong><span class="required">*</span><br />
			<?php
			$themes = ThemePeer::doSelect(new Criteria());
			echo HTMLWidget::select('theme_id',$themes,$theme_id,HTMLWidget::OPTION_NONE,false);
			?>
			</td>
		</tr>
<?php if (GFConf::get('system.useCaptcha') == true) { 
	require_once('securimage/captcha_block.php');
} ?>
<?php if (GFConf::get('system.userRegClickLicense')) { ?>
		<tr>
			<td>
<pre>
<?php echo file_get_contents(GFConf::get('system.etcDir').'/USER_LICENSE'); ?>
</pre>
	</p>
	<p>
	<input type="checkbox" name="iagree" value="t" />&nbsp;<?php echo $Lang->getText('License.IHaveReadAndAgree'); ?>
			</td>
		</tr>
<?php } ?>
		<tr>
			<td colspan="2">
				<?php echo HTMLWidget::button("submit","" .   $Lang->getText('UserAddForm.submit') . " ","submit","","")?>
				<?php echo HTMLWidget::button("button", $Lang->getText('Common.Cancel'), "", "", "javascript:history.go(-1);"); ?>
			</td>
		</tr>
	</table>
  <?php if ($hash != '') {// used when inviting to project" ?>
    <input type="hidden" name="hash" value="<?php echo $hash ?>">
  <?php } ?>  
</form>

<?php
$theme->footer($params);
?>
