<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id: User.php 326 2006-01-09 19:49:12Z danper $
 * @author Daniel A. Prez	daniel@gforgegroup.com
 * @date 2005-11-11
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

require_once('lib/core/UserPeer.php');
require_once('lib/core/User.php');
require_once('html/SiteTemplate.php');

$feedback = '';

if (isset($_POST['submit'])) {

	if (($_POST['loginname'])) {
		$loginname = $_POST['loginname'];
	} else {
		$loginname = null;
		$feedback .= Language::getSessText('LostPass.NotEmpty');
	}	
	
	if ($loginname) {
		$c = new Criteria();
		$c->add(UserPeer::UNIX_NAME,$loginname);
		$user = UserPeer::doSelectOne($c);
		if ((!$user) || (!is_object($user))) {
			$feedback .= Language::getSessText('LostPass.NotExists');
		} else {
			$confirm_hash = md5(Session::getSession()->getSessionHash() . strval(time()) . strval(rand())); // First, we need to create new confirm hash
			$user->setConfirmHash($confirm_hash);
			$user->save();
			if (GFConf::get('system.use_ssl')) {
				$http = 'https://';
			} else {
				$http = 'http://';
			}
			$url = $http . GFConf::get('system.serverName') . GFUrl::getUrl()->baseURL('lostlogin','','account',array('confirm_hash'=>$confirm_hash));
			$message = stripcslashes(Language::getSessText('LostPass.Message',array($url,GFConf::get('system.serverName'))));
			SystemUtils::sendMail(Language::getSessText('LostPass.Subject',array(GFConf::get('system.serverName'))),$message,$user->getEmail());
			$feedback .= Language::getSessText('LostPass.Notify');
		}
	}
}

$template = new SiteTemplate();
$params = array(
		'selectedtoptab'	=> 'my', 'feedback' => $feedback
	);
$template->header($params);


echo Language::getSessText('LostPass.Warn');
?>

<form action="<?php echo GFUrl::getUrl()->currentBaseURL('lostpw'); ?>" method="post">
<p>
<?php echo Language::getSessText('SiteAdmin.UserList.Login'); ?> :
<br />
<input type="text" name="loginname" />
<br />
<br />
<?php echo HTMLWidget::button("submit","" .   Language::getSessText('LostPass.SendHash') . " ","submit","","")?>
</p>
</form>

<?php

$template->footer(array());

?>