<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id$
 * @author Ruben Gutierrez ruben@gforgegroup.org
 * @date 2006-02-27
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

require_once('core/ProjectPeer.php');
require_once('session/Session.php');
require_once('core/Plugin.php');
require_once('plugin/GFPlugin.php');
require_once('core/RolePeer.php');
require_once('core/UserProject.php');
require_once('html/HTMLWidget.php');

$session = Session::getSession();
$Language = $session->getLanguage();

require_once('html/templates/SiteAdminTemplate.php');

$template = new SiteAdminTemplate();
$params = array(
		'title'	=> Language::getSessText('SiteAdmin.Licenses')
);
$template->header($params);

$maxusers=GFConf::get('system.licenseMaxUsers');
$maxmembers=GFConf::get('system.licenseMaxMembers');

echo '<p><strong>'.Language::getSessText('SiteAdmin.LicenseExpire').'</strong><br />';
echo (( GFConf::get('system.licenseExpire') ) ? date('Y-m-d',GFConf::get('system.licenseExpire')) : 'Never' );
echo '</p><p>';
if ($maxmembers) {
	$sql = 'SELECT count(*) AS count FROM "user" WHERE user_id IN (
				SELECT user_id FROM user_project NATURAL JOIN "user" WHERE "user".is_group=false
				UNION 
				SELECT member_user_id AS user_id FROM usergroup_user WHERE usergroup_id IN (
					SELECT user_id FROM user_project NATURAL JOIN "user" WHERE "user".is_group=true
				)
			)';
	$stmt=Propel::getConnection()->createStatement();
	$rs=$stmt->executeQuery($sql);
	$rs->next();
	$count=$rs->getInt('count');
	echo '<strong>'.Language::getSessText('SiteAdmin.LicenseMaxMembers').'</strong><br />';
	echo $count.' of '.$maxmembers.' licenses used.<br />';
	echo '<a href="'.GFUrl::getUrl()->currentBaseUrl('UserBrowse',array('project_members'=>'1')).'">View Users</a>';
} else {
	echo '<strong>'.Language::getSessText('SiteAdmin.LicenseMaxUsers').'</strong><br />';
	//max users
	$crit=new Criteria();
	$crit->add(UserPeer::STATUS,User::STATUS_DELETED,Criteria::NOT_EQUAL);
	$crit->add(UserPeer::IS_GROUP,false);
	$count = UserPeer::doCount($crit);
	echo $count.' of '.$maxusers.' licenses used.';
}
echo '</p>';
echo HTMLWidget::button("button",$Language->getText('Common.Back'),"cancel","","window.location='".GFUrl::getUrl()->currentBaseUrl('')."';");
$template->footer();
?>
