<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   
 * @author Marcelo Mottalli	<marcelo@gforgegroup.com>
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */


// Show no more pending users per page than specified here
$LIMIT = 50;

require_once('html/templates/SiteAdminTemplate.php');
require_once('lib/core/User.php');
require_once('lib/core/UserPeer.php');
require_once('lib/html/HTMLWidget.php');

$con = Propel::getConnection(UserPeer::DATABASE_NAME);

$Lang = Session::getSession()->getLanguage();

$template = new SiteAdminTemplate();
$params = array(
		'title'	=> $Lang->getText('SiteAdmin.UserApproval'),
		'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : ''
	);
$template->header($params);

// get pending users (don't confuse with "pending confirmation")
$c = new Criteria();
$c->add(UserPeer::STATUS, User::STATUS_PENDING_APPROVAL);
$c->setLimit($LIMIT);
$pending_users = UserPeer::doSelect($c);

$ids = array();

$theader = array();
$theader[] = Language::getSessText('SiteAdmin.UserApprove.FullName');
$theader[] = Language::getSessText('SiteAdmin.UserApprove.Details');
$theader[] = Language::getSessText('Common.Action');
echo $template->tableTop($theader);
if (count($pending_users) < 1) {
	echo $template->tableFullRow( Language::getSessText('SiteAdmin.UserApprove.None') );
} else {
	foreach ($pending_users as $pending_user) {
		require ('forms/UserApprove-tpl.php');
		$ids[] = $pending_user->getUserId();
	}
}
echo $template->tableBottom();

//list of user_id's of pending users
$user_list = implode($ids,',');

echo '<p>';
require_once ('forms/UserApproveAll-tpl.php');
echo '</p>';

$template->footer();

?>
