<?php

// Allow POST only
if ($_SERVER['REQUEST_METHOD'] != 'POST') {
	throw new PermissionDeniedException();
}

/**
 * Toggle setting that indicates whether project admins are allowed to create project templates.
 * Returns TRUE if changed to enabled, FALSE if changed to disabled
 *
 * @return boolean
 */
function toggleEnabled() {
	$conf_key = 'system.projAdminCanCreateTemplate';
	if (GFConf::get($conf_key, FALSE)) {
		GFConf::set($conf_key, FALSE);
		return FALSE;
	} else {
		GFConf::set($conf_key, TRUE);
		return TRUE;
	}
}

// language
$Language = Session::getSession()->getLanguage();

$response = array();

$enabled = toggleEnabled();
$response['next_action'] = $enabled ? $Language->getText('SiteAdmin.disallowPAdminTemplate') : $Language->getText('SiteAdmin.allowPAdminTemplate'); ;
$response['message'] = $enabled ? $Language->getText('SiteAdmin.allowPAdminTemplateSuccess') : $Language->getText('SiteAdmin.disallowPAdminTemplateSuccess');
$response['success'] = TRUE;

echo json_encode($response);