<?php

/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version $Id$
 * @author Daniel A. Prez	daniel@gforgegroup.com
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

require_once('lib/core/ProjectPeer.php');

set_time_limit(0);		// Project approving is a pretty expensive task

if (isset($_POST['projects']) && !empty($_POST['projects'])) {
	$project_ids = $_POST['projects'];
	$project_ids = explode(',', $project_ids);
	
	if (!is_array($project_ids)) {
		$feedback = Language::getSessText('SiteAdmin.ProjectApprove.NoProjects') . '<br />';
	} else {
		$feedback = '';
		try {
			foreach ($project_ids as $project_id) {
				$project = ProjectPeer::retrieveByPk($project_id);
				if (!is_object($project)) {
					continue;
				}
				$project_name = $project->getProjectName();

				if ($project->approve()) {
					$feedback .= Language::getSessText('SiteAdmin.ProjectApprove.Approved',array($project_name)) . '<br />';
				} else {
					$feedback .= Language::getSessText('SiteAdmin.ProjectApprove.NotApproved',array($project_name)) . '<br />';
				}
			}
		} catch (InvalidDataException $ex) {
			$feedback .= '* '.implode('<br />* ', $ex->getErrors());
		}
	}	
} else {
	$feedback = Language::getSessText('SiteAdmin.ProjectApprove.NoProjects') . '<br />';
}

GFUrl::redirect(GFUrl::getUrl()->currentBaseURL('approve-pending',array('feedback'=>$feedback)));

?>
