<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id$
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

//
// This code shows a form for Project
//
require_once('core/ProjectPeer.php');
require_once('core/Project.php');
require_once('plugin/ActionManager.php');
require_once('html/HTMLWidget.php');
require_once('html/TroveRenderer.php');
require_once('exceptions/NotLoggedInException.php');
require_once('lib/GFExportImport.php');
require_once('html/templates/SiteAdminTemplate.php');

$session = Session::getSession();
$Lang = $session->getLanguage();

$theme = new SiteAdminTemplate();

$params = array(
		'feedback' => isset($feedback) ? $feedback : '',
		'title' => $Lang->getText('ProjectTemplate.ImportPageName')
		);

$session = Session::getSession();

if (!$session->isLoggedIn()) {
	throw new NotLoggedInException();
}

$allowed = true;
if (!$session->isSiteAdmin()) {
	throw new PermissionDeniedException();
}

$theme->header($params);
?>

<form action="<?php echo GFUrl::getUrl()->currentBaseURL('ProjectTemplateImportAction') ?>" method="POST" enctype="multipart/form-data"/>
<table border="0">
	<tr>
		<td>
			<b><?php echo $Lang->getText('ProjectTemplate.LegacyXMLTemplate');?><b><br/>
			<input name="template" size="30" type="file" /></td>
	</tr>
	<tr>
		<td align="center">
			<?php echo HTMLWidget::button("submit","" .   $Lang->getText('Common.Submit') . " ","submit","","")?>
		</td>
	</tr>
</table>
</form>
<br/>
<?php
$theme->footer($params);

?>