<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
require_once('core/SiteAdminPeer.php');

$session = Session::getSession();
$Lang = $session->getLanguage();

require_once('lib/html/templates/SiteAdminTemplate.php');
$theme = new SiteAdminTemplate();

//$Project = GFUrl::getUrl()->getProject();
$params = array(
	//	'project' => $Project,
	//	'SiteTemplate' => $SiteTemplate,
		'action' => isset($action) ? $action : '',
		'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : ''),
		'title' => $Lang->getText('SiteAdmin.EditAdmin')
		);
$theme->header($params);


// Retrieve the objects array
$con = Propel::getConnection(SiteAdminPeer::DATABASE_NAME);
$sql = "select distinct sa.user_id, u.unix_name, u.firstname,u.lastname from \"user\" u, site_admin sa where u.user_id = sa.user_id";
$stmt = $con->createStatement();
$arr = $stmt->executeQuery($sql, ResultSet::FETCHMODE_ASSOC);

$theader = array();

$theader[] = $Lang->getText('User.UserIdName');
$theader[] = $Lang->getText('User.UnixNameName');
$theader[] = $Lang->getText('SiteAdmin.Search.UserName');
$theader[] = $Lang->getText('Delete');

echo $theme->tableTop($theader);

if (count($arr) < 1) {
	echo $theme->tableRow(array('<span class="nonefound">'.$Lang->getText('SiteAdmin.NoneFound').'</span>'));
} else {
	while ($arr->next()) {
		$trow = array();
		$trow[]=$arr->getInt('user_id');
		$trow[]=$arr->getString('unix_name');
		$trow[]=$arr->getString('firstname') . ' ' . $arr->getString('lastname');
		if ($arr->getInt('user_id') != Session::getSession()->getUser()->getUserId()) {
			$trow[]='<a href="'. GFUrl::getUrl()->currentBaseUrl('SiteAdminDelete').'&amp;user_id='.$arr->getInt('user_id') . '">'. $Lang->getText('Delete') .'</a>';
		} else {
			$trow[] = '-';
		}
		

		echo $theme->tableRow($trow, array(), false);
	}
}

//echo $theme->tableBottom(array('<a href="'. GFUrl::getUrl()->currentBaseUrl('SiteAdminAdd').'">'. $Lang->getText('SiteAdmin.AddNew') .'</a>'));
$button_array = array();
$button_array[] = '<a href="'. GFUrl::getUrl()->currentBaseUrl('SiteAdminAdd').'">'. $Lang->getText('SiteAdmin.AddNew') .'</a>';
$button_array[] = '<a href="'. GFUrl::getUrl()->currentBaseUrl('').'">'. $Lang->getText('Common.Back') .'</a>';
echo $theme->tableBottom($button_array,array(true, true));

$theme->footer($params);

?>