<?php

// Allow POST only
if ($_SERVER['REQUEST_METHOD'] != 'POST') {
	throw new PermissionDeniedException();
}

// language
$Language = Session::getSession()->getLanguage();

$trove_ids = $_POST['ids'];
array_walk(&$trove_ids, function($value){
	Validator::sanitizeInt($value);
});
$projects_count = TroveCategoryPeer::getProjectLinkCountsAsArray($trove_ids);

$warnings = array();
foreach ($trove_ids as $trove_id) {
	if (array_key_exists($trove_id, $projects_count) && $projects_count[$trove_id]['project_links_count'] > 0) {
		$warnings[] = $Language->getText('TroveDelete.Warning.ProjectCount', array($projects_count[$trove_id]['category_name'], $projects_count[$trove_id]['project_links_count']))." "
			.$Language->getText('TroveDelete.Warning.Leaf');
	}
}
$response = array(
	'warnings' => $warnings
);

echo json_encode($response);