<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code shows a form for editing User
//
require_once('core/UserPeer.php');
require_once('core/User.php');
require_once('exceptions/PermissionDeniedException.php');
require_once('lib/html/HTMLWidget.php');
require_once('lib/timezones.php');

$session = Session::getSession();
$Lang = $session->getLanguage();

require_once('html/templates/SiteAdminTemplate.php');
$theme = new SiteAdminTemplate();

//$Project = GFUrl::getUrl()->getProject();
$User = UserPeer::retrieveByPk($_REQUEST['user_id']);

if (!is_object($User)) {
	throw new PermissionDeniedException();
}
$obj = $User;

$params = array(
	//	'project' => $Project,
	//	'SiteTemplate' => $SiteTemplate,
		'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : ''),
		'action' => isset($action) ? $action : '',
		'title' => $Lang->getText('User.EditPageTitle')
		);

$user_id=$obj->getUserId();
$unix_name = ( (isset($_POST) && isset($_POST['unix_name'])) ? htmlspecialchars($_POST['unix_name']) : $obj->getUnixName() );
$email = ( (isset($_POST) && isset($_POST['email'])) ? htmlspecialchars($_POST['email']) : $obj->getEmail() );
$status = ( (isset($_POST) && isset($_POST['status'])) ? htmlspecialchars($_POST['status']) : $obj->getStatus() );
$password_md5 = ( (isset($_POST) && isset($_POST['password_md5'])) ? htmlspecialchars($_POST['password_md5']) : $obj->getPasswordMd5() );
$password_crypt = ( (isset($_POST) && isset($_POST['password_crypt'])) ? htmlspecialchars($_POST['password_crypt']) : $obj->getPasswordCrypt() );
$create_date = ( (isset($_POST) && isset($_POST['create_date'])) ? htmlspecialchars($_POST['create_date']) : $obj->getCreateDate() );
$confirm_hash = ( (isset($_POST) && isset($_POST['confirm_hash'])) ? htmlspecialchars($_POST['confirm_hash']) : $obj->getConfirmHash() );
$email_new = ( (isset($_POST) && isset($_POST['email_new'])) ? htmlspecialchars($_POST['email_new']) : $obj->getEmailNew() );
$timezone = ( (isset($_POST) && isset($_POST['timezone'])) ? htmlspecialchars($_POST['timezone']) : $obj->getTimezone() );
$date_format = ( (isset($_POST) && isset($_POST['date_format'])) ? htmlspecialchars($_POST['date_format']) : $obj->getDateFormat() );
$address = ( (isset($_POST) && isset($_POST['address'])) ? htmlspecialchars($_POST['address']) : $obj->getAddress() );
$address2 = ( (isset($_POST) && isset($_POST['address2'])) ? htmlspecialchars($_POST['address2']) : $obj->getAddress2() );
$phone = ( (isset($_POST) && isset($_POST['phone'])) ? htmlspecialchars($_POST['phone']) : $obj->getPhone() );
$fax = ( (isset($_POST) && isset($_POST['fax'])) ? htmlspecialchars($_POST['fax']) : $obj->getFax() );
$title = ( (isset($_POST) && isset($_POST['title'])) ? htmlspecialchars($_POST['title']) : $obj->getTitle() );
$firstname = ( (isset($_POST) && isset($_POST['firstname'])) ? htmlspecialchars($_POST['firstname']) : $obj->getFirstname() );
$lastname = ( (isset($_POST) && isset($_POST['lastname'])) ? htmlspecialchars($_POST['lastname']) : $obj->getLastname() );
$ccode = ( (isset($_POST) && isset($_POST['ccode'])) ? htmlspecialchars($_POST['ccode']) : $obj->getCcode() );
$language_id = ( (isset($_POST) && isset($_POST['language_id'])) ? htmlspecialchars($_POST['language_id']) : $obj->getLanguageId() );
$theme_id = ( (isset($_POST) && isset($_POST['theme_id'])) ? htmlspecialchars($_POST['theme_id']) : $obj->getThemeId() );

if (GFConf::varExists('system.enableUdfEdit') 
      && (GFConf::get('system.enableUdfEdit') == 'users' || GFConf::get('system.enableUdfEdit') == 'on')) {
  $udf1 = ( (isset($_POST) && isset($_POST['udf1'])) ? htmlspecialchars($_POST['udf1']) : $obj->getUserText1() );
  $udf2 = ( (isset($_POST) && isset($_POST['udf2'])) ? htmlspecialchars($_POST['udf2']) : $obj->getUserText2() );
  $udf3 = ( (isset($_POST) && isset($_POST['udf3'])) ? htmlspecialchars($_POST['udf3']) : $obj->getUserText3() );
  $udf4 = ( (isset($_POST) && isset($_POST['udf4'])) ? htmlspecialchars($_POST['udf4']) : $obj->getUserText4() );
  $udf5 = ( (isset($_POST) && isset($_POST['udf5'])) ? htmlspecialchars($_POST['udf5']) : $obj->getUserText5() );
  $udf6 = ( (isset($_POST) && isset($_POST['udf6'])) ? htmlspecialchars($_POST['udf6']) : $obj->getUserText6() );
}

$can_unlock = $obj->isLocked() && $obj->getLoginAttempts() != -1;
$unlock = ( (isset($_POST) && isset($_POST['unlock']) ? htmlspecialchars($_POST['unlock']) : false ));

include ('forms/UserEdit-tpl.php');

?>
