<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code creates a new Usergroup and saves it to the 
// database
//
require_once('core/User.php');
require_once('Validator.php');
require_once('exceptions/InvalidDataException.php');
require_once('exceptions/PermissionDeniedException.php');
require_once('core/Language.php');

if ($_SERVER['REQUEST_METHOD'] != 'POST') {
	throw new PermissionDeniedException();
}
if (!Session::getSession()->isSiteAdmin()) {
	throw new PermissionDeniedException();
}

$User = new User();
$errors=array();

$Lang = Language::getSessLang();

$unix_name = Validator::sanitizeString($_POST['unix_name']);
$group_name = Validator::sanitizeString($_POST['firstname']);

try {
	$Group = User::createUserGroup($group_name, $unix_name);
  if (GFConf::varExists('system.enableUdfEdit') 
      && (GFConf::get('system.enableUdfEdit') == 'groups' || GFConf::get('system.enableUdfEdit') == 'on')) {

    $Group->setUserText1(Validator::sanitizeString($_POST['udf1']));
    $Group->setUserText2(Validator::sanitizeString($_POST['udf2']));
    $Group->setUserText3(Validator::sanitizeString($_POST['udf3']));
    $Group->setUserText4(Validator::sanitizeString($_POST['udf4']));
    $Group->setUserText5(Validator::sanitizeString($_POST['udf5']));
    $Group->setUserText6(Validator::sanitizeString($_POST['udf6']));
    $Group->save();
  }

	GFUrl::redirect(GFUrl::getUrl()->currentBaseURL('UsergroupBrowse'), array('feedback' => $Lang->getText('Usergroup.AddFeedback')));
} catch (InvalidDataException $ex) {
	$errors = array_merge($errors, $ex->getErrors());	       // attach object errors to validation errors
	$feedback = '* '.implode('<br />* ', $errors);
	include('UsergroupAdd.php');
}
?>
