<?php

/**
 * Copyright (c) 2005-2013 GForge, LLC
 *
 * @version $Id$
 * @author Rick Button	rickbutton@gforgegroup.com
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

require_once('core/User.php');
require_once('core/UserProjectPeer.php');
require_once('Validator.php');
require_once('exceptions/PermissionDeniedException.php');
require_once('core/Language.php');
if (!Session::getSession()->isSiteAdmin()) {
	throw new PermissionDeniedException();
}

if (array_key_exists('group_id',$_REQUEST)) {
	$group_id = Validator::sanitizeInt($_REQUEST['group_id']);
} else {
	$group_id = null;
}

$Group = UserPeer::retrieveByPk($group_id);

if (!is_object($Group) ) {
	throw new PermissionDeniedException();
}

$Lang = Language::getSessLang();

if (GFConf::varExists('system.enableUdfEdit') 
    && (GFConf::get('system.enableUdfEdit') == 'groups' || GFConf::get('system.enableUdfEdit') == 'on')) {
  $Group->setUserText1(Validator::sanitizeString($_POST['udf1']));
  $Group->setUserText2(Validator::sanitizeString($_POST['udf2']));
  $Group->setUserText3(Validator::sanitizeString($_POST['udf3']));
  $Group->setUserText4(Validator::sanitizeString($_POST['udf4']));
  $Group->setUserText5(Validator::sanitizeString($_POST['udf5']));
  $Group->setUserText6(Validator::sanitizeString($_POST['udf6']));
}
$Group->save();
$feedback='Changes Saved';

GFUrl::redirect(GFUrl::getUrl()->baseURL('UsergroupEdit','','admin',array('feedback'=>$feedback,'id'=>$group_id)));


?>
