<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code creates a new UsergroupUser and saves it to the 
// database
//
require_once('core/UsergroupUser.php');
require_once('core/UsergroupUserPeer.php');
require_once('exceptions/PermissionDeniedException.php');
require_once('core/Language.php');

$Lang = Language::getSessLang();

$group_id = Validator::sanitizeInt($_POST['id']);
$remove_id = Validator::sanitizeInt($_POST['remove_id']);

if (isset($_POST['sure'])) {
	$Group = UserPeer::retrieveByPk($group_id);
	if (!is_object($Group) || !Session::getSession()->isSiteAdmin()) {
		throw new PermissionDeniedException();
	}
	if ($Group->getIsGroup() != true) {
		throw new PermissionDeniedException();
	}
	$crit=new Criteria();
	$crit->add(UsergroupUserPeer::USERGROUP_ID,$group_id);
	$crit->add(UsergroupUserPeer::MEMBER_USER_ID,$remove_id);
	$UsergroupUser = UsergroupUserPeer::doSelect($crit);
	if (count($UsergroupUser) == 1) {
		$crit = new Criteria();
		$user = UserPeer::retrieveByPk($remove_id);
		$projects = $user->getAllProjectIds();
		$UsergroupUser[0]->delete();
		GFDaemon::notify('DAEMON_USERGROUP_DELETE', serialize($projects));
	} else {
		GFUrl::redirect($url->currentBaseURL('UsergroupEdit'), array('id' => $group_id, 'feedback' => $Lang->getText('UsergroupUserDeleteForm.MemberNotExists'),'id'=>$Group->getId()));
	}

	GFUrl::redirect($url->currentBaseURL('UsergroupEdit'), array('id' => $group_id, 'feedback' => $Lang->getText('UsergroupUser.DeleteFeedback'),'id'=>$Group->getId()));
} else {
	GFUrl::redirect($url->currentBaseURL('UsergroupEdit'), array('id' => $group_id, 'feedback' => $Lang->getText('UsergroupUserDeleteForm.DidntConfirm')));
}

?>
