<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   
 * @author Daniel A. Perez	daniel@gforgegroup.com
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

require_once('html/templates/SiteAdminTemplate.php');
require_once('lib/core/ProjectPeer.php');
require_once('lib/core/User.php');
require_once('lib/core/UserPeer.php');
require_once('lib/html/HTMLWidget.php');
require_once('lib/core/AuditTrailPeer.php');

$con = Propel::getConnection(UserPeer::DATABASE_NAME);

$Lang = Session::getSession()->getLanguage();

$template = new SiteAdminTemplate();
$params = array(
		'title'	=> $Lang->getText('SiteAdmin.ProjectApproval'),
		'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : ''
	);
$template->header($params);

// get pending projects
$c = new Criteria();
$c->add(ProjectPeer::STATUS,Project::STATUS_PENDING);
$pending_projects = ProjectPeer::doSelect($c);


$ids = array();

$theader = array();
$theader[] = Language::getSessText('Project.ListNameTitle');
$theader[] = Language::getSessText('Project.ListPurposeTitle');
$theader[] = Language::getSessText('Common.Action');
echo $template->tableTop($theader);
if (count($pending_projects) < 1) {
	echo $template->tableFullRow( Language::getSessText('SiteAdmin.ProjectApprove.None') );
} else {
	foreach ($pending_projects as $pending_project) {
		require ('forms/ProjectApprove-tpl.php');
		$ids[] = $pending_project->getProjectId();
	}
}
echo $template->tableBottom();

//list of project_id's of pending projects
$project_list = implode($ids,',');

echo '<p>';
require_once ('forms/ProjectApproveAll-tpl.php');
echo '</p>';

$template->footer();

?>
