<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id$
 * @author Ruben Gutierrez	ruben@gforgegroup.com
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

require_once('lib/graphics/GraphicPie.php');

if (!Session::getSession()->isSiteAdmin()) {
	throw new PermissionDeniedException();
}

$session = Session::getSession();
$Lang = $session->getLanguage();

if (!$session->isSiteAdmin()) {
	$sql = "SELECT pr.project_name, du.bytes_used as kbytes FROM project pr, disk_usage du WHERE 1=2";
} else {
	$sql = "SELECT pr.project_name, (du.bytes_used/1024) as kbytes FROM project pr, disk_usage du WHERE
			pr.project_id=du.project_id AND check_date = (SELECT MAX(check_date) FROM disk_usage) ORDER BY du.bytes_used DESC";
}

$gp = new GraphicPie($Lang->getText('SiteAdmin.DiskUsagePerProject'), 450, 250);
$gp->setSQL($sql);
$gp->setSQLFields('project_name', 'kbytes');
$gp->setLegendFormat('$legend = StringUtils::trimString($key, 20). \': \'.sprintf("%01.2f", ($val/1024)). \' '.$Lang->getText('Common.MB').'\';', true);

if (ob_get_level()) ob_end_clean();
$gp->showPie();
