<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @author Daniel A. Perez	daniel@gforgegroup.com
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

require_once('html/templates/SiteAdminTemplate.php');
require_once('lib/core/ProjectPeer.php');
require_once('lib/core/UserPeer.php');
require_once('lib/core/User.php');
require_once('lib/core/RolePeer.php');
require_once('lib/core/Role.php');
require_once('lib/core/UserPeer.php');

if(isset($_REQUEST['feedback'])) $feedback = $_REQUEST['feedback'];

$template = new SiteAdminTemplate();
$params = array(
		'title'	=> 'Index',
		'feedback' => isset($feedback) ? $feedback : '',
		'extra_css' => array(
			"/themes/gforge5/gf-dialogs.css"
		),
		'extra_js' => array(
			"/js/gf-dialogs.js"
		)
	);
$tabbertabsetcookie='siteadmin';
$template->header($params);


$alpha_array = array('A','B','C','D','E','F','G','H','I','J','K','L','M','N','O','P','Q','R','S','T','U','V','W','X','Y','Z','0','1','2','3','4','5','6','7','8','9');
$con = Propel::getConnection(UserPeer::DATABASE_NAME);

$u = Session::getSession()->getUser();
$versionFilename = "/opt/gforge/VERSION";
if (file_exists($versionFilename)) {
  $version = str_replace(array("\r", "\n"), '', file_get_contents($versionFilename));
} else {
  $version = false;
}
$host = GFConf::get('system.hostName');
$email = $u->getEmail();
$checkUrl = "https://gforge.com/gf/?action=Version&v=$version&host=$host&email=$email";
$isDefault = ActionManager::notify('CHECK_DEFAULT_LICENSE');
if ($version) {
?>

<script type="text/javascript">
  function setCookie(c_name,value,exdays) {
    var exdate=new Date();
    exdate.setDate(exdate.getDate() + exdays);
    var c_value=escape(value) + ((exdays==null) ? "" : "; expires="+exdate.toUTCString());
    document.cookie=c_name + "=" + c_value;
  }
  function getCookie(c_name) {
    var c_value = document.cookie;
    var c_start = c_value.indexOf(" " + c_name + "=");
    if (c_start == -1) {
      c_start = c_value.indexOf(c_name + "=");
    }
    if (c_start == -1) {
      c_value = null;
    }
    else {
      c_start = c_value.indexOf("=", c_start) + 1;
      var c_end = c_value.indexOf(";", c_start);
      if (c_end == -1)
      {
        c_end = c_value.length;
      }
      c_value = unescape(c_value.substring(c_start,c_end));
    }
    return c_value;
  }
  function compare(a, b) {
    if (a === b) {
      return 0;
    }
    var a_components = a.split(".");
    var b_components = b.split(".");
    var len = Math.min(a_components.length, b_components.length);

    for (var i = 0; i < len; i++) {
      if (parseInt(a_components[i]) > parseInt(b_components[i])) {
        return 1;
      }

      if (parseInt(a_components[i]) < parseInt(b_components[i])) {
        return -1;
      }
    }

    if (a_components.length > b_components.length) {
      return 1;
    }

    if (a_components.length < b_components.length) {
      return -1;
    }

    return 0;
  }
  function askCheck() {
    $("#version-notice").addClass("infobox");
    $("#version-notice").html("You haven't checked for a new GForge version in a while. Do you want to check it now? " +
      "<a href='#' onclick='checkVersion();'>Check for latest version</a><a style='float:right' href='#' onclick='hideVersionBox();'>Hide</a>");
  }
  
  function checkVersion() {
    $("#version-notice").removeClass("infobox");
    $("#version-notice").html("");
    $.ajax({
      url: "<?php echo $checkUrl; ?>",
        success: function(data) {
          var c = compare(data, "<?php echo $version ?>");

          $("#version-notice").addClass("infobox");
          if (c == 1) {
            data = data.replace(/^\s+|\s+$/g, '');
            $("#version-notice").html("The latest version is " + data + ". Go to " + 
              "<a href='http://gforgegroup.com'>gforgegroup.com</a> to download the upgrade. <a style='float: right' href='#' onclick='hideVersionBox();'>Hide</a>");
          } else {
            $("#version-notice").html("Your instance of GForge is upgraded to the latest version" +
              "<a style='float:right' href='#' onclick='hideVersionBox();'>Hide</a>");
          }
          setCookie("version-check", true, 7);
        }
    });

  }
  function hideVersionBox() {
    $("#version-notice").html('');
    $("#version-notice").removeClass('infobox');
    setCookie('version-hide', true);
  }

  $(document).ready(function() {
    var check = getCookie("version-check");
    var hide = getCookie("version-hide");
    isDefault = <?php echo $isDefault ? "true;\n" : "false;\n" ?>
    if (isDefault) {
      if (hide != 'true') {
        checkVersion();
      }
    } else {
      if (hide != 'true') {
        askCheck();
      }
    }
	
	$('.allow-projadmin-create-template-toggle').click(function(){
		GFDialogs.do_ajax_call({
			start_text: $(this).text(),
			action_url: '<?php echo GFUrl::getUrl()->currentBaseUrl('ProjAdminCreateTemplateToggleAction'); ?>',
			action_data: {},
			success_handler: function(response) {
				$('.allow-projadmin-create-template-toggle').text(response.next_action);
			}
		});
	});
	
  });
    </script>
<?php } ?>
<div class="" id="version-notice"></div>
<table width="100%" border="0" width="90%"><tr><td valign="top">

<div class="tabber">

<div class="tabbertab" title="<?php echo Language::getSessText('SiteAdmin.UserMaint'); ?>" id="userstab">
<p>
<strong><?php echo Language::getSessText('SiteAdmin.UserMaint'); ?></strong>
</p>
	<a href="<?php echo GFUrl::getUrl()->currentBaseURL('UserBrowse');?>"> <?php echo Language::getSessText('SiteAdmin.DisplayFullUser'); ?></a>&nbsp;&nbsp;</p>
	<p><?php
	echo Language::getSessText('SiteAdmin.DisplayUserBeginningWith').' ';
	for ($i=0; $i < count($alpha_array); $i++) {
		echo '<a href="'.GFUrl::getUrl()->currentBaseURL('UserBrowse',array('user_name_search'=>$alpha_array[$i])).'">'.$alpha_array[$i].'</a>|';
	}
?>
	<br />
<?php require_once('forms/UserSearch-tpl.php'); ?>
	</p>
<?php if (GFConf::get('system.approveUsers')) : ?>
    <p><a href="<?php echo GFUrl::getUrl()->currentBaseURL('PendingUserApproval');?>"> <?php echo Language::getSessText('SiteAdmin.NewUserApproval'); ?></a>&nbsp;&nbsp;</p>
<?php endif; ?>    

</div>

<div class="tabbertab" title="<?php echo Language::getSessText('SiteAdmin.ProjectMaint'); ?>" id="projectstab">
<p>
<strong><?php echo Language::getSessText('SiteAdmin.ProjectMaint'); ?></strong>
</p>

	<p><a href="<?php echo GFUrl::getUrl()->currentBaseURL('ProjectBrowse&is_template=on');?>"> <?php echo Language::getSessText('SiteAdmin.DisplayFullProject'); ?></a>&nbsp;&nbsp;</p>
	<p>
	<?php
	echo Language::getSessText('SiteAdmin.DisplayProjectBeginningWith').' ';
	for ($i=0; $i < count($alpha_array); $i++) {
		echo '<a href="'.GFUrl::getUrl()->currentBaseURL('ProjectBrowse',array('project_name_search'=>$alpha_array[$i])).'">'.$alpha_array[$i].'</a>|';
	}
?>
	<p>
<?php require_once('forms/ProjectSearch-tpl.php'); ?>
	</p>

<?php
	// get pending projects
	$c = new Criteria();
	$c->add(ProjectPeer::STATUS,Project::STATUS_PENDING);
	$pending_projects = ProjectPeer::doSelect($c);
	if (sizeof($pending_projects) > 0) {
?>
	<p><a href="<?php echo GFUrl::getUrl()->currentBaseURL('approve-pending')?>"><?php echo Language::getSessText('SiteAdmin.NewApproval') . ' (' . sizeof($pending_projects) . ')'; ?></a></p>
<?php
	}
?>
	<br>
	<?php echo HTMLWidget::button("button", Language::getSessText('Project.AddNew'),"","","window.location='". GFUrl::getUrl()->baseUrl('ProjectAdd', '', 'register', array('redirect' => $_SERVER['REQUEST_URI'])) ."';"); ?>
</div>

<div class="tabbertab" title="<?php echo Language::getSessText('Usergroup.Groups') ?>" id="groupstab">
<p>
<strong><?php echo Language::getSessText('Usergroup.Groups'); ?></strong>
</p>

	<p><a href="/gf/admin/?action=UsergroupBrowse"><?php echo Language::getSessText('Usergroup.ManageGroups'); ?></a></p>
	<p><a href="<?php echo GFUrl::getUrl()->baseURL('SiteAdminBrowse','','admin');?>"><?php echo Language::getSessText('SiteAdmin.EditAdmin'); ?></a></p>	
	<p><a href="#" class="allow-projadmin-create-template-toggle">
		<?php echo GFConf::get('system.projAdminCanCreateTemplate', FALSE) ? 
				Language::getSessText('SiteAdmin.disallowPAdminTemplate') : 
				Language::getSessText('SiteAdmin.allowPAdminTemplate'); 
		?>
	</a></p>

</div>

<div class="tabbertab" title="<?php echo Language::getSessText('SiteAdmin.SiteUtilities') ?>" id="utilitiestab">
<p>
<strong><?php echo Language::getSessText('SiteAdmin.SiteUtilities'); ?></strong>
</p>

	<p><a href="<?php echo GFUrl::getUrl()->baseURL('EditFrontPage','','admin');?>"><?php echo Language::getSessText('SiteAdmin.EditFrontPage'); ?></a></p>
	<p><a href="<?php echo GFUrl::getUrl()->baseURL('DeleteFrontPage','','admin');?>"><?php echo Language::getSessText('SiteAdmin.DeleteFrontPage'); ?></a></p>
	<p><a href="<?php echo GFUrl::getUrl()->baseURL('SiteNotification','','admin');?>"><?php echo Language::getSessText('SiteAdmin.SiteNotification'); ?></a></p>
	<p><a href="<?php echo GFUrl::getUrl()->currentBaseURL('ProjectImport')?>"><?php echo Language::getSessText('ProjectTemplate.ImportPageName'); ?></a></p>
	<p><a href="<?php echo GFUrl::getUrl()->currentBaseURL('ProjectImportTpl')?>"><?php echo Language::getSessText('ProjectTemplate.ImportPageNameLegacy'); ?></a></p>	
  <?php if (GFConf::get('system.troveEnabled') != 0) { ?>
	<p><a href="<?php echo GFUrl::getUrl()->baseURL('DisplayTroveMap','','admin');?>"><?php echo Language::getSessText('SiteAdmin.DisplayTroveMap'); ?></a></p>
  <?php } ?>

</div>

<div class="tabbertab" title="<?php echo Language::getSessText('SiteAdmin.PluginAdmin'); ?>" id="plugins">
<p>
<strong><?php echo Language::getSessText('SiteAdmin.PluginAdmin'); ?></strong>
</p>
<?php
//hook for site admin plugins elements
$resultset = ActionManager::notify('SITE_ADMIN_INDEX');

foreach ($resultset as $result) { 
	$plugin_section = $result->getResult();	   			 
 
	echo '<p><strong>'.$plugin_section['title'].'</strong></p>';	
	foreach ($plugin_section['elements'] as $elements) {				
		echo '<p>'.$elements.'</p>';
	}		
	echo '';
 
} 
?>
<p><strong><?php echo Language::getSessText('SiteAdmin.Tracker') ?></strong></p>

	<p><a href="<?php echo GFUrl::getUrl()->baseURL('TrackerTimeCodeBrowse','tracker','admin');?>"><?php echo Language::getSessText('SiteAdmin.TrackerTimeCode'); ?></a></p>
	<?php 
		if (GFConf::get('tracker.enableWorkflowScripts')) {
	?>
	<p><a href="<?php echo GFUrl::getUrl()->baseURL('TrackerTransitionScriptBrowse','tracker','admin');?>"><?php echo Language::getSessText('Tracker.GlobalWorkflowScripts'); ?></a></p>
	<?php 
		}
	?>

<p><strong><?php echo Language::getSessText('SiteAdmin.Scm') ?></strong></p>

	<p><a href="<?php echo GFUrl::getUrl()->currentBaseUrl('ScmCommitFilterBrowse');?>"><?php echo Language::getSessText('SiteAdmin.ScmCommitFilters'); ?></a></p>

<?php if (GFConf::get('system.splitScmServers')) : ?>

	<p><a href="<?php echo GFUrl::getUrl()->baseURL('ScmServerBrowse','scm','admin');?>"><?php echo Language::getSessText('SiteAdmin.ScmServerEdit'); ?></a></p>

<?php endif; ?>

<p><strong><?php echo Language::getSessText('SiteAdmin.Forum') ?></strong></p>
	<p><a href="<?php echo GFUrl::getUrl()->baseURL('LastPostsBrowse','forum','admin');?>"><?php echo Language::getSessText('SiteAdmin.ForumLastPosts');?></a></p>
</div>


<div class="tabbertab" title="<?php echo Language::getSessText('SiteAdmin.SiteStats') ?>" id="statstab">
<p>
<strong><?php echo Language::getSessText('SiteAdmin.SiteStats'); ?></strong>
</p>

	<p><a href="<?php echo GFUrl::getUrl()->baseURL('License','','admin');?>"><?php echo Language::getSessText('SiteAdmin.Licenses'); ?></a></p>
	<p><a href="/gf/admin/?action=Stats"><?php echo Language::getSessText('SiteAdmin.ViewStats'); ?></a></p>
	<p><a href="/gf/admin/?action=AdminReports"><?php echo Language::getSessText('SiteAdmin.AdminReports'); ?></a></p>
	<p><a href="<?php echo GFUrl::getUrl()->baseURL('DiskUsage','','admin');?>"><?php echo Language::getSessText('SiteAdmin.DiskUsage'); ?></a></p>

</div>

</div>

</td>
<td valign="top" width="10%">
<?php
echo $template->infoTableTop(Language::getSessText('SiteHome.SupportDocs'));
echo '<center><img src="http://gforgegroup.com/as-support-ad57.png?h='.GFConf::get('system.hostName').'" width="250" height="175" alt="" /></center>';
echo '<p>
<a target="_blank" href="http://gforge.org/frs/monitor.php?filemodule_id=70&group_id=152&start=1">Monitor Updates at GForge.org</a><br />
<a target="_blank" href="http://gforge.org/forum/?group_id=152">GForge AS Forums<br />
<a target="_blank" href="http://gforge.org/tracker/?group_id=152">GForge AS Bug and Feature Trackers<br />
</p>';
echo $template->infoTableBottom();
?>
</td>
</tr>
</table>
<?php
$template->footer();
?>
