<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version $Id$
 * @author Federico Tarantini	federico@gforgegroup.com 
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
require_once('html/templates/ProjectAdminTemplate.php');
require_once('wwwlib/search/commonsearch.php');
require_once('exceptions/LoginException.php');


$session = Session::getSession();
$Lang = $session->getLanguage();

$template = new ProjectAdminTemplate();

if(!$session->isLoggedIn()){
	throw new PermissionDeniedException();
}

if (isset($_GET['prj'])) { 
	$project = ProjectPeer::retrieveByUnixName($_GET['prj']);
} else {
	$project = null;
}

if((!is_object($project) || !$project->userIsAdmin()) && isset($_GET['prj'])){
	throw new PermissionDeniedException();
}

echo popupHeader($template, 'Find Users');
$val = (isset($_REQUEST['search'])) ? $_REQUEST['search'] : '';
$vals = explode('_',$val);
$params = array();
$params['words'] = (isset($_REQUEST['words'])) ? Validator::sanitizeString($_REQUEST['words']) : '';
$params['section'] = (isset($vals[0])) ? $vals[0] : '';
$params['sub_section'] = 'addUserSearch';
$params['ref_id'] = (isset($vals[1])) ? $vals[1] : '';
$params['template'] = $template;
if (isset($_REQUEST['formname'])) {
	$params['formname'] = Validator::sanitizeString($_REQUEST['formname']);
}
if (isset($_REQUEST['groups'])) {
	$params['groups'] = $_REQUEST['groups'];
}

require_once('wwwlib/admin/popups/forms/findusers-tpl.php');
echo getSearchResults($params);

echo popupFooter();

?>
