<?php
/**
 * Copyright (c) 2005-2012 GForge LLC
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//require_once('plugins/docman/lib/FastJSON.php');
require_once('core/UserPeer.php');

$session = Session::getSession();

if (!$session->isLoggedIn()) {
	error_log("UnixNames, session not logged in, returning 401");
	header('HTTP/1.1 401');
	exit;
}

$user = $session->getUser();

if (!is_object($user)) {
	error_log("UnixNames, session has no user, returning 401");
	header('HTTP/1.1 401');
	exit;
}
 
$itemtype	= isset($_GET['type']) ? $_GET['type'] : 'social';
$item_id	= isset($_GET['id']) ? $_GET['id'] : 0;
//error_log("MentionList type = $itemtype, id = $item_id");

switch($itemtype) {
	// Some special-case core data types
	case 'social':
		echo json_encode(
			UnixNames(UserPeer::getSocialGraphFor($user))
		);
		break;

	case 'project':
		echo json_encode(
			UnixNames(ProjectPeer::getProjectMembersFor($item_id))
		);
		break;

	// All plugins
	default:
		$params = array(
			'type' => $itemtype,
			'id' => $item_id
		);

		$prs = ActionManager::notify('MENTION_LIST', $params);

		$ret = array();
		if ($prs->count()) {
			$ret = UnixNames($prs->current()->getResult());
		}

		echo json_encode($ret);
		break;
}

function UnixNames($users) {
	$ret = array();

	foreach ($users as $user) {
		if ($user->isActive()) {
			$ret[] = '@' . $user->getUnixName();
		}
	}

	return $ret;
}
?>