<?php
/**
 * Copyright (c) 2005-2012 GForge LLC
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
require_once('plugins/docman/lib/FastJSON.php');

$session = Session::getSession();

if (!$session->isLoggedIn()) {
	error_log("UserSetPreferenceAjax, session not logged in, returning 401");
	header('HTTP/1.1 401');
	exit;
}

$user = $session->getUser();

if (!is_object($user)) {
	error_log("UserSetPreferenceAjax, session has no user, returning 401");
	header('HTTP/1.1 401');
	exit;
}
 
$preference_name = isset($_GET['preference_name']) ? $_GET['preference_name'] : '';
$preference_value = isset($_GET['preference_value']) ? $_GET['preference_value'] : '';

if ($preference_name != '') {
	try {
		$user->setPreference($preference_name, $preference_value);
	} catch(Exception $e) {
		error_log("UserSetPreferenceAjax, exception thrown setting $preference_name, returning 401: ".$e->getMessage());
		header('HTTP/1.1 401');
		exit;
	}
	
	header('HTTP/1.1 200');
	exit;

} else {
	error_log("UserSetPreferenceAjax, preference_name is empty, returning 401");
	header('HTTP/1.1 401');
}

?>