<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id$
 * @author mtutty mtutty@gforgegroup.com
 * @date 2012-08-28
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
?>
<!-- RMT only include files and wrapper markup for the window. 
     Don't include anything specific to a tab -->

<div class="tab-container">
    <ul>
		<div class="logo-container">
			<a href="http://gforgegroup.com/" target="_blank">
				<img class="logo" src="<?php echo $theme->getGFASLogoGrey() ?>" title="Powered By GForge&reg; Collaborative Development Environment <?php echo $theme->getVersionString() ?>" />
			</a>
		</div>
    </ul>
</div>

<!-- Content templates for client-side rendering -->
<!-- Even though they're enclosed in script tags, they're content.  We put them here instead of in a js file -->

<script id="tabTemplate" type="text/x-jquery-tmpl">
    <li><a href='${href}' title='${title_full}'>${title}</a> <span class='ui-icon ui-icon-close'>Remove Tab</span></li>
</script>

<script id="panelTemplate" type="text/x-jquery-tmpl">
    <div id="${id}"></div>
</script>


<!--
Each user present in the chat.
Params:
  user_id:		database or other unique identifier for the user
  unix_name:	user-friendly identifier for the user
  avatar:		URL to a picture representing the user
-->
<script id="userListItemTemplate" type="text/x-jquery-tmpl">
	<li class="userlist-${thread_id} user-${user_id} hot-hover" style="display: none;" data-bind-id="${unix_name}">
		<div class="avatar">
			<a href="/gf/user/${unix_name}" target="_new" title="User profile for ${unix_name}">
				<img src="${avatar}" />
			</a>
		</div>
		<div class="userblock">${unix_name}</div>
	</a></li>
</script>

<!--
The link at the top, to retrieve earlier messages.
Params: none for now.
-->
<script id="chatScrollbackTemplate" type="text/x-jquery-tmpl">
	<div class="line scrollback" style="display:none;" data-message-id="${message_id}">
		<div class="message-body">
			<div class="container">
				<a href="javascript:;" onclick="scrollBack(this);" title="<?php echo $params['scrollback.title'] ?>"><?php echo $params['scrollback.title'] ?></a>
			</div>
		</div>
	</div>
</script>

<!--
A placeholder left behind, when a message is deleted.  This looks better when removing,
especially when it's the only item under a date delimiter
Params: none for now.
-->
<script id="chatMessageDeletedTemplate" type="text/x-jquery-tmpl">
	<div class="line scrollback" style="display:none;">
		<div class="message-body">
			<div class="container">
				This message was deleted
			</div>
		</div>
	</div>
</script>

<!--
The link at the top, to retrieve earlier messages.
Params: none for now.
-->
<script id="chatNoMoreScrollbackTemplate" type="text/x-jquery-tmpl">
	<div class="line scrollback" style="display:none;">
		<div class="message-body">
			<div class="container">
				<a href="javascript:;" onclick="alert('Sorry, chief.');" title="<?php echo $params['scrollback.none.title'] ?>"><?php echo $params['scrollback.none.title'] ?></a>
			</div>
		</div>
	</div>
</script>

<!--
Each row in the chat.
Params:
  dateString:	Pre-formatted date/time string
  unix_name:	(optional) username of the message author
  msg_type:		(optional) additional style name for the message
  msg:			Content of the message.  Can include raw markup.  Appended without client-side escaping.
-->
<script id="chatMessageTemplate" type="text/x-jquery-tmpl">
	<div class="line ${msg_type}" data-message-id="${message_id}">
		<div class="message-header">
			<div class="unixname"><strong><a href="/gf/user/${unix_name}" target="_new" title="User profile for ${unix_name}">${unix_name}</a></strong></div>
			<div class="delete-button hot-hover" data-message-id="${message_id}"><img src="<?php echo $theme->getImgRoot(); ?>/chat/delete_off.png" /></div>
			<div class="timestamp"><strong>${dateString}</strong></div>
			<div style="clear: both;"></div>
		</div>
		
		<div class="message-body">
			<div class="container">
				<div class="avatar">
                    {{if unix_name != '' }}
					<a href="/gf/user/${unix_name}" target="_new" title="User profile for ${unix_name}">
                    {{/if}}
						<img src="${avatar}" />
					{{if unix_name != '' }}
                    </a>
                    {{/if}}
				</div>
				<div class="content">
					{{if msg_type.indexOf('multiline') >= 0 }}
					<span style="float: right;">
                      <a href="javascript:;"  class="toolbar-item open-multiline">
                         <img class="hot-hover toolbar-item" src="/themes/gforge5/images/chat/new_window.png" title="Open in New Window" />
                       </a>
                    </span><br /><br />
					{{/if}}
					{{html msg}}
				</div>
			</div>
		</div>
	</div>
</script>

<!--
A separator row with no content, to show the change of hour or day in the chat.
Params:
  dateString:	Pre-formatted date/time string
-->
<script id="chatDateDelimiterTemplate" type="text/x-jquery-tmpl">
	<div class="line">
		<div class="label">${dateString}</div>
		<hr />
	</div>
</script>

<!--
A link extracted from chat messages, shown in a list for ease of access.
Params:
  url	:	URL of the link
  title	:	title to be displayed.
-->
<script id="chatLinkTemplate" type="text/x-jquery-tmpl">
	<li class="hot-hover" style="display: none;">
		<a href="${url}" title="${title}" target="_new">${title}</a>
	</li>
</script>

<!--
A link to a related thread, shown in a list for ease of access.
Params:
  thread_id	:	unique identifier for the referenced thread
  title		:	title to be displayed.
-->
<script id="chatThreadTemplate" type="text/x-jquery-tmpl">
	<li class="hot-hover" style="display: none;">
		<a href="javascript:;" onclick="discuss(this);" title="${title_full}" data-thread-id="${thread_id}" >${title}</a>
	</li>
</script>

<!--
Display for a chat message that play(ed) a sound
Params:
  url	:	URL of the link
  title	:	title to be displayed.
-->
<script id="chatActionSoundTemplate" type="text/x-jquery-tmpl">
	<div>
		<span class="chat-action" data-sound-path="${url}">[${title}]</span>
	</div>
</script>

<!--
Template for embedded sound playing
Params:
  url	:	URL of the sound
-->
<script id="chatPlaySoundTemplate" type="text/x-jquery-tmpl">
	<embed id="chatsound_" autostart="true" hidden="true" src="${url}" />
</script>

<!--
Each emoticon item in the popup list
Params:
  text		:	text shortcut for the emoticon
  title		:	title to be displayed.
  emoticon	:	html markup for the rendered emoticon
-->
<script id="chatActionEmoticonTemplate" type="text/x-jquery-tmpl">
	<a class="emoticon-button hot-hover" data-emoticon="${text}" title="${title}">{{html emoticon}}</a>
</script>

<!-- END Content templates for client-side rendering -->

<div id="emoticon-list" class="dropdown-menu">
	<ul class="inline">
		<li></li>
	</ul>
</div>

<div id="chat-tips" class="" style="display: none;">
	<ul class="chat-tips-list">
		<li><em><strong>@mention: </strong></em>You can invite or get a user's attention with the <em>@mentions</em>. Simply enter @username where "username" is the user's user name (e.g: "@gforgeamdin please attend this chat.")</li>
		<li><em><strong>Autolink trackers: </strong></em>You can autolink tracker items by entering the tracker item id in the following format: <em>[#tracker-item-id]</em> (e.g. [#2355]) or by just copying/pasting the regular tracker item url.</li>
		<?php if ($can_drag_drop) { ?>
		<li><em><strong>Upload files: </strong></em>You can upload files to this chat by simply drag and drop into the window. When the file has finished uploading, a chat message with the file details and the poster is created automatically.</li>
		<?php } else { ?>
		<li><em><strong>Upload files: </strong></em>You can upload files to this chat by clicking on the file upload to open the file upload widget and then adding files. When a file has finished uploading, a chat message with the file details and the poster is created automatically.</li>
		<?php } ?>
		<li><em><strong>Project activity: </strong></em>You can enable/disable project activity on this chat. When enabled, project events will be automatically posted to this chat.</li>
		<li><em><strong>Custom sounds: </strong></em>You can create a special folder named "Sounds" in docman (document manager) on the project this chat belongs to. Sound files uploaded to that folder will be available to be played in this chat.</li>
		<?php if ($safe_browsing) { ?>
		<li><em><strong>Safe Browsing API: </strong></em>Google's Safe Browsing API is active, all external urls posted to this chat will be passed through the API to catch viruses and phishing.</li>
		<?php } else { ?>
		<li><em><strong>Safe Browsing API: </strong></em>Google's Safe Browsing API is not active, You can activate this feature by configuring a Safe Browsing API key for GForge (system.safeBrowsingKey). Visit <a href="https://developers.google.com/safe-browsing/">https://developers.google.com/safe-browsing</a> to read about it and get your key.</li>
		<?php } ?>
	</ul>
</div>

<script type="text/javascript">
	function setUploadWidgetParameter(thread_id) {
		FileUploadWidgetSetParameter('ref_id', thread_id);
	}
	
	$(document).ready(function() {
		var upload_url = '<?php echo GFUrl::getURL()->baseURL('', '', 'upload', array('section' => 'forumthread')); ?>';
		FileUploadWidgetInit('widget_container', 'fileupload', upload_url, 'ref_id');

		setTimeout(function() {
			var recentTabId = 'recent-chat-tab';
			var recentTabSelector = '#'+recentTabId;

            var tabs = $('.tab-container').tabs();

            var newTab = $.tmpl( 'tab', { href : recentTabSelector, title : "<?php echo $params['recent.tab'] ?>", title_full : "<?php echo $params['recent.tab'] ?>" });
            tabs.find('ul').append(newTab);

            var newTabIndex = tabs.find('.ui-tabs-nav li').length - 1;

            var newPanel = $.tmpl( 'tab.panel', { id : recentTabId });
            tabs.append(newPanel);

            $(tabs).tabs( 'refresh' );

			updateContent(recentTabSelector, '/gf/chat/?action=RecentChats');
		}, 100);
	});
</script>
