<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id$
 * @author mtutty mtutty@gforgegroup.com
 * @date 2012-08-28
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
?>
<div class="chatpanel">
	<div class="chat-area"></div>
	<div class="right-container">
		<div class="userlist-container" style="height: 100%;">
			<ul>
				<li><a href="#user-tab-<?php echo $params['thread_id'] ?>" class="icon-link" title="People"><img src="/images/person_gray.png" /> (<span class="usercount"></span>)</a></li>
				<li><a href="#link-tab-<?php echo $params['thread_id'] ?>" class="icon-link" title="Related Links"><img src="/images/link_16.png" /> (<span class="linkcount"></span>)</a></li>
				<li><a href="#thread-tab-<?php echo $params['thread_id'] ?>" class="icon-link" title="Other Threads"><img src="/images/chat_icon_24.png" /> (<span class="threadcount"></span>)</a></li>
				<?php if ( is_object($forum->getProject()) && ( $session->isSiteAdmin() || $forum->getProject()->userIsAdmin() ) ) { ?>
				<li id="roles-link-<?php echo $params['thread_id'] ?>"><a href="#roles-tab-<?php echo $params['thread_id'] ?>" class="icon-link"  title="Role Settings" onclick="getRoleSettings(<?php echo $params['thread_id'] ?>);"><img src="/images/roles_icon_24.png" /> (<span class="rolescount"></span>)</a></li>
				<?php } ?>
			</ul>
			<div id="user-tab-<?php echo $params['thread_id'] ?>" class="userlist tabpage">
				<h3>Who's Here?</h3>
				<ul></ul>
			</div>
			<div id="link-tab-<?php echo $params['thread_id'] ?>" class="linklist tabpage">
				<h3>Mentioned Links</h3>
				<ul></ul>
			</div>
			<div id="thread-tab-<?php echo $params['thread_id'] ?>" class="threadlist tabpage">
				<h3>Related Chat Threads</h3>
				<ul></ul>
			</div>
			<?php if ( is_object($forum->getProject()) && ( $session->isSiteAdmin() || $forum->getProject()->userIsAdmin() ) ) { ?>
			<div id="roles-tab-<?php echo $params['thread_id'] ?>" class="roleslist tabpage">
				<h3>Role Settings</h3>
				<ul></ul>
			</div>
			<?php } ?>
		</div>
	</div>

    <div class="send-message-area">
		<form action="">
			<fieldset>
				<div class="tools-container">
					<?php if ($params['writable'] == 'Y') { ?>
						<a class="toolbar-item emoticon-list" href="javascript:;" title="Insert an emoticon" data-vertical-offset="-24" data-horizontal-offset="22" data-dropdown="#emoticon-list"><img class="hot-hover" src="<?php echo $theme->getImgRoot(); ?>/chat/emoticons.png" /></a>&nbsp;
						<a class="toolbar-item sound-list" href="javascript:;" title="Play a sound" data-vertical-offset="-24" data-horizontal-offset="22" data-dropdown="#sound-list-<?php echo $params['thread_id'] ?>"><img class="hot-hover" src="<?php echo $theme->getImgRoot(); ?>/chat/notes.png" /></a>&nbsp;
					<?php } // if ?>
					<a class="toolbar-item activity-toggle" href="javascript:;" title="Show project activity" data-activity-setting="<?php echo $params['activity_setting'] ?>" ><img class="hot-hover" src="<?php echo $theme->getImgRoot(); ?>/chat/<?php echo $params['activity_icon'] ?>" /></a>&nbsp;
					<a class="toolbar-item sound-toggle" href="javascript:;" data-thread-id="<?php echo $params['thread_id'] ?>" title="Turn sounds on/off" data-sound-setting="<?php echo $params['sound_setting'] ?>" ><img class="hot-hover" src="<?php echo $theme->getImgRoot(); ?>/chat/<?php echo $params['sound_icon'] ?>" /></a>&nbsp;
					<?php if ($params['writable'] == 'Y') { ?>
						<a class="toolbar-item upload-toggle" href="javascript:;" title="Show uploads" id="#upload-toggle-<?php echo $params['thread_id'] ?>"><img class="hot-hover" src="<?php echo $theme->getImgRoot(); ?>/chat/chatupload.png" /></a>&nbsp;
					<?php } // if ?>
					<a class="toolbar-item help-toggle" href="javascript:;" title="Show chat tips"><img class="hot-hover" style="height: 16px; width: 14px;" src="<?php echo $theme->getImgRoot(); ?>/chat/help.png" /></a>&nbsp;
				</div>
				<legend><?php echo $Lang->getText('Discuss.AddMessage') ?></legend>
				<textarea <?php if ($params['writable'] != 'Y') echo 'readonly="readonly"'; ?> id="message-body-<?php echo $params['thread_id'] ?>" name='chat-body' class="sendie auto-complete" data-autocomplete-src="/gf/ajax/?action=MentionList&type=social"></textarea>
				<input type="button" id="chat-send-<?php echo $params['thread_id'] ?>" name="chatsend" class="chat-send" value="<?php echo $Lang->getText('Common.Submit') ?>" />
                <input type="hidden" name="baseUrl" class="baseUrl" value="<?php echo $params['base_url'] ?>" />
                <input type="hidden" name="whoami" class="whoami" value="<?php echo $params['whoami'] ?>" />
                <input type="hidden" name="threadId" class="threadId" value="<?php echo $params['thread_id'] ?>" />
                <input type="hidden" name="lastMessageDate" class="lastMessageDate" value="" />
			</fieldset>
		</form>
    </div>
<?php if ($params['writable'] == 'Y') { ?>
	<div id="sound-list-<?php echo $params['thread_id'] ?>" class="dropdown-menu">
		<ul>
			<?php foreach ($params['sounds'] as $key => $sound) { ?>
				<li>
					<a class="block-list-item small-padding" href="javascript:;" data-sound-path="<?php echo $sound ?>" title="<?php echo $key ?>">
						<img class="small-icon" src="<?php echo $theme->getImgRoot(); ?>/chat/notes.png" />
						<?php echo $key ?></a>
				</li>
			<?php } // foreach ?>
		</ul>
	</div>
<?php } // if ?>
</div>