<?php
/**
 * Copyright (c) 2005-2014 GForge, LLC
 *
 * @version $Id$
 * @author Mario A. Papayannis	mpapayannis@gforgegroup.com
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
require_once('html/templates/PopupTemplate.php');
require_once('wwwlib/search/commonsearch.php');
require_once('exceptions/LoginException.php');


$session = Session::getSession();
$Lang = $session->getLanguage();
$theme = new PopupTemplate();

$params = array();
$params['title'] = 'GForge Discussions';

echo $theme->popupHeader($params);

if(!$session->isLoggedIn()){
	throw new PermissionDeniedException();
}

if (!isset($_GET['message_id'])) {
	throw new InvalidDataException();
}

$message_id = Validator::sanitizeInt($_GET['message_id']);
$message = ForumMessagePeer::retrieveByPk($message_id);

if (!is_object($message)) {
	throw new InvalidDataException();
}

include('wwwlib/chat/popups/forms/ViewMultilineMessage-tpl.php');

echo $theme->popupFooter();
?>
