<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id$
 * @author Tim Perdue tim@gforge.org
 * @date 2006-02-27
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

require_once('html/SiteTemplate.php');
require_once('lib/core/FilesystemPeer.php');
require_once('plugins/news/lib/News.php');
require_once('lib/LinkRenderer.php');

$session = Session::getSession();
$user = $session->getUser();

$template = new SiteTemplate();
$params = array(
		'selectedtoptab'	=> 'home',
		'title' => ''
	);
$template->header($params);

$url = GFUrl::getUrl();

$c = new Criteria();
$c->add(FilesystemPeer::SECTION,'frontpage'); // TODO -> this section name should be stored somewhere as a constant
$front_page = FilesystemPeer::doSelectOne($c);
$lang = Language::getSessLang();
?>
<table cellpadding="0" cellspacing="0" class='mainTable'>
	<tr>
		<td width="70%" valign="top">
<?php
$bol_default_frontpage = true;
if (is_object($front_page)) {
	$bol_default_frontpage = false;
	echo '<div class="frontpage">';
	echo $front_page->getFileData(false);
	echo '</div>';
} else {
	//default home page
	require_once('home/homeContent-tpl.php');
}
?>
<?php

	if ($session->isLoggedIn() && $user->isSiteAdmin()) {
		echo '<br />&nbsp;';
		echo '<div align="center"><p>';
		echo HTMLWidget::button("button", Language::getSessText('SiteAdmin.EditFrontPage'),"","","window.location='". GFUrl::getUrl()->baseUrl('EditFrontPage', '', 'admin')."'");
		echo '</p></div>';
	}

$theader=array(Language::getSessText('Project.News'));
$value = "";

$c = new Criteria();
$c->setLimit(5);
$c->add(NewsPeer::IS_APPROVED,true);
$c->addDescendingOrderByColumn(NewsPeer::POST_DATE);
// Only retrieve projects with enabled blog (news) plugin
$c->addJoin(NewsPeer::PROJECT_ID, ProjectPeer::PROJECT_ID);
$c->addJoin(ProjectPeer::PROJECT_ID, ProjectPluginPeer::PROJECT_ID);
$c->addJoin(ProjectPluginPeer::PLUGIN_ID, PluginPeer::PLUGIN_ID);
$c->add(PluginPeer::PLUGIN_NAME, NewsPlugin::SECTION);
$posts = NewsPeer::doSelectJoinProject($c);

ob_start();	
require("plugins/news/wwwlib/forms/NewsSiteSummary-tpl.php");
$value = ob_get_clean();

echo $value;
?>

		</td>
<?php
if (!$bol_default_frontpage) {
?>
		<td>&nbsp;</td>
		<td valign="top" width="30%">
<?php
echo $template->infoTableTop($lang->getText('SiteHome.Activity'));
?>
<center>
<img src="/gf/graphs/?action=Activity" width="230" height="150" border="0" alt="Activity" />
</center>
<?php

echo $template->infoTableMiddle(Language::getSessText('HomePage.RecentlyRegProjects'));
//recently registered projects
$c = new Criteria();
$c->add(ProjectPeer::IS_PUBLIC, 1);
$c->add(ProjectPeer::STATUS, 1);
$c->addDescendingOrderByColumn(ProjectPeer::CREATE_DATE);
$c->setLimit(10);
$arr = ProjectPeer::doSelect($c);
if(!count($arr)) {
	echo Language::getSessText('HomePage.NoStatsAvailable');
} else {
	foreach($arr as $item) {							//todo link
		echo '<strong>('.$item->getCreateDate('Y-m-d').')</strong> <a href="'.$url->projectURL($item->getUnixName()).'">'.$item->getProjectName().'</a><br />';
	}
}
		
//top downloads
echo $template->infoTableMiddle(Language::getSessText('HomePage.TopDownloads'));

$con = Propel::getConnection(FilesystemPeer::DATABASE_NAME);
$stmt = $con->createStatement();
$sql = "select SUM(download_count) as downloads, project.project_name as project_name, project.project_id as project_id, project.unix_name as unix_name 
		from filesystem 
		left join frs_release on (filesystem.ref_id=frs_release.frs_release_id)
		left join frs_package on (frs_release.frs_package_id=frs_package.frs_package_id)
		left join project on (frs_package.project_id=project.project_id)
	where filesystem.section = 'frsrelease' and project.is_public=true 
	group by project.project_name, project.unix_name, project.project_id order by downloads desc limit 10";
$rs = $stmt->executeQuery($sql, ResultSet::FETCHMODE_ASSOC);
if(!isset($rs)) {
	echo Language::getSessText('HomePage.NoStatsAvailable');
} else {
	while($rs->next()) {
		echo '('.number_format($rs->getInt('downloads')).') <a href="'.$url->projectURL($rs->getString('unix_name')).'">'.$rs->getString('project_name').'</a><br />';
	}
}

$params['template'] = $template;
$prs = ActionManager::notify('BUILD_FRONTPAGE_ELEMENTS',$params);
foreach ($prs as $pr) {
	echo	$pr->getResult();
}

//browse by topic box
echo $template->infoTableMiddle(Language::getSessText('HomePage.BrowseTopic'));

$con = Propel::getConnection(FilesystemPeer::DATABASE_NAME);
$stmt = $con->createStatement();

$sql="select * from trove_category tc natural join trove_link_count where tc.parent_trove_category_id=".GFConf::get('system.troveTopic')." AND section='project'";
$rs = $stmt->executeQuery($sql, ResultSet::FETCHMODE_ASSOC);
if(!isset($rs)) {
	echo Language::getSessText('Project.NoneFound');
} else {
	while($rs->next()) {
		echo '<a href="/gf/project/?action=ProjectTroveBrowse&_trove_category_id='.$rs->getInt('trove_category_id').'">'.$rs->getString('category_name').' ('.$rs->getInt('link_count').')</a><br />';
	}
}

//Support and docs box
echo $template->infoTableMiddle($lang->getText('SiteHome.SupportDocs'));
echo '<a href="/gf/project/support/">Local Support Project</a>';
echo '<p><a href="http://gforge.org/projects/as-help">GForge Help Forum &amp; Docs</a><br />';
echo '<a href="https://gforge.com/gf/project/office-addin/">Office Add-in Project</a><br />';
echo '<a href="https://gforge.com/gf/project/soapsdk/">SOAP SDK Project</a><br />';
echo '</p><strong>Commercial Plugins</strong><p>';
echo '<a href="https://gforge.com/gf/project/eclipse/">Eclipse Project</a><br />';
echo '<a href="https://gforge.com/gf/project/msproject/">MS Project Plugin</a><br />';
echo '<a href="https://gforge.com/gf/project/vsplugin/">Visual Studio Plugin</a><br />';
echo '</p>';

echo $template->infoTableBottom();
?>
		</td>
<?php
}
?>
	</tr>
</table>
<?php
$template->footer();
?>
