<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id$
 * @author Ruben Gutierrez	ruben@gforgegroup.com
 * @date 2006-03-13
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

require_once('plugins/tracker/lib/Tracker.php');
require_once('lib/graphics/GraphicPie.php');

$session = Session::getSession();
$Lang = $session->getLanguage();
$user = $session->getUser();

// get all my projects from the DB
$projectsObj = $user->getAllProjects();

//a list of all ids of projects this user is a member of
$allids=$user->getAllProjectIds();
if (count($allids) > 0) {
	$allids=implode(',',$user->getAllProjectIds());
} else {
	$allids=0;
}

$Priorities = Tracker::getPriorities();

if (!isset($_GET['project_id']) || $_GET['project_id'] == 0) {
	$sqlaux = "AND p.project_id IN ($allids)";

} else {
	$sqlaux = "AND p.project_id = '".Validator::sanitizeInt($_GET['project_id'])."'";
}

// Check if we want to filter only the user's items
$onlymine = (isset($_GET['onlymine']) && $_GET['onlymine'] == 1) ? true : false;

// If there's a valid project_id, we'll filter by project all the queries
if (!$onlymine) {
	$sqlmine = '';
} else {
	$sqlmine = "AND (ti.submitted_by = ".$user->getUserId()." OR
	ti.tracker_item_id IN (SELECT tracker_item_id FROM tracker_item_assignee
	WHERE assignee=".$user->getUserId()."))";
}

$sql = "SELECT ti.priority, COUNT(*) AS count FROM tracker t, project p, tracker_item ti
	WHERE ti.tracker_id = t.tracker_id AND t.project_id = p.project_id
	$sqlaux
	$sqlmine
	AND ti.status_id=".Tracker::STATUS_OPEN." GROUP BY ti.priority ORDER BY count DESC";

$gp = new GraphicPie($Lang->getText('TrackerReporting.ByPriority'), 400, 250);
$gp->setSQL($sql);
$gp->setSQLFields('priority', 'count');
$gp->setAuxValue1($Priorities);
$gp->setLegendFormat('$legend = $this->auxvalue1[intval($key)]. \': \'.$val;');

if (ob_get_level()) ob_end_clean();
$gp->showPie();

