<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id$
 * @author Ruben Gutierrez	ruben@gforgegroup.com
 * @date 2006-03-13
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

require_once('plugins/tracker/lib/Tracker.php');
require_once("lib/graphics/GraphicPie.php");

$session = Session::getSession();
$Lang = $session->getLanguage();
$user = $session->getUser();

//a list of all ids of projects this user is a member of
$allids=$user->getAllProjectIds();
if (count($allids) > 0) {
	$allids=implode(',',$user->getAllProjectIds());
} else {
	$allids=0;
}

// Check if we want to filter only the user's items
$onlymine = (isset($_GET['onlymine']) && $_GET['onlymine'] == 1) ? true : false;

// If there's a valid project_id, we'll filter by project all the queries
if (!$onlymine) {
	$sqlmine = '';
} else {
	$sqlmine = "AND (ti.submitted_by = ".$user->getUserId()." OR
	ti.tracker_item_id IN (SELECT tracker_item_id FROM tracker_item_assignee
	WHERE assignee=".$user->getUserId()."))";
}

if (!isset($_GET['project_id']) || $_GET['project_id'] == 0) {
	$title = $Lang->getText('TrackerReporting.ByProject');
	$field_name = 'project_name';
	$sql = "select p.project_name, count(*) as count from tracker t, project p, tracker_item ti
	where ti.tracker_id = t.tracker_id and t.project_id = p.project_id
	and p.project_id IN ($allids)
	$sqlmine
	and ti.status_id=".Tracker::STATUS_OPEN." GROUP BY p.project_name order by count desc";
} else {
	$title = $Lang->getText('TrackerReporting.ByTracker');	
	$field_name = 'tracker_name';
	$sql = "SELECT t.tracker_name,
	COUNT(*) AS count FROM tracker t, project p, tracker_item ti
	WHERE ti.tracker_id = t.tracker_id AND t.project_id = p.project_id
	AND p.project_id = '".Validator::sanitizeInt($_GET['project_id'])."'
	$sqlmine
	AND ti.status_id=".Tracker::STATUS_OPEN." GROUP BY t.tracker_name ORDER BY count DESC";
}

$gp = new GraphicPie($title, 400, 250);
$gp->setSQL($sql);
$gp->setSQLFields($field_name, 'count');
$gp->setCenter(0.30);

if (ob_get_level()) ob_end_clean();
$gp->showPie();

