<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id$
 * @author Tim Perdue tim@gforge.org
 * @date 2006-02-27
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

$ids = $User->getAllProjectIds(false);
$projects = array();
foreach ($ids as $id) {
  $project = ProjectPeer::retrieveByPk($id);
  if ($project != NULL) {
	  $repo = SCMRepositoryFactory::getRepository($project);
	  if ($repo != NULL && $repo->getAccessType() == SCMRepository::ACCESS_TYPE_SSH) {
		  $projects[] = $project;
	  }
  }
}

?>
<p>
  <div class="infobox">
    <?php if (count($projects)  > 0) {
      echo $Lang->getText('MyUserSSHKeysEdit.Text') . "<br/><br/>";
      echo $Lang->getText('MyUserSSHKeysEdit.TextAccess') . "<ul>";
      foreach ($projects as $p) {
        echo "<li>" . $p->getProjectName() . "</li>";
      }
      echo "</ul>";
    } else {
      echo $Lang->getText("MyUserSSHKeysEdit.NoSSHProjects");
    } ?> 
  </div>
</p>
<?php if (count($projects) > 0) { ?>
<form action="<?php echo GFUrl::getUrl()->currentBaseURL('UserSSHKeysEditAction') ?>" method="POST">
	<table border="0">
		<tr>
			<td>
			<textarea name="authorized_keys" cols="80" rows="10"><?php echo $UserUnix->getAuthorizedKeys(); ?></textarea> <br />
			</td>
		</tr>
		<tr>
			<td>
				<strong><?php echo $Lang->getText('My.DisableAccountPassword'); ?></strong><br />
				<input type="password" name="password" value="" />
			</td>
		</tr>
		<tr>
			<td>
				<?php echo HTMLWidget::button("submit","" .   $Lang->getText('MyUserSSHKeysEdit.Submit') . " ","submit","","")?>
				<?php echo HTMLWidget::button("button","" .   $Lang->getText('Common.Back') . " ","cancel","","javascript:history.go(-1);")?>
			</td>
		</tr>
		<tr>
			<td align="center"></td>
		</tr>	</table>
</form>
<?php } else {
echo HTMLWidget::button("button","" .   $Lang->getText('Common.Back') . " ","cancel","","javascript:history.go(-1);");
} ?>
