<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id$
 * @author Tim Perdue tim@gforge.org
 * @date 2006-02-27
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

require_once('html/MyTemplate.php');
require_once('lib/core/FilesystemPeer.php');
require_once('lib/core/UserProjectPeer.php');
require_once('plugins/tracker/lib/TrackerMyQueuePeer.php');
require_once('core/ProjectJoinRequestPeer.php');
require_once('core/ProjectJoinRequest.php');

$session = Session::getSession();
if (!$session->isLoggedIn()) {
	throw new NotLoggedInException();
}
$User = $session->getUser();
$Lang = $session->getLanguage();

$template = new MyTemplate();
if(isset($_REQUEST['feedback'])) $feedback = $_REQUEST['feedback'];
$params = array(
	'title' => $Lang->getText('My.MyPage'),
	'selectedbottomtab' => 'my',
	'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : ''),
	'action' => isset($action) ? $action : '',
	'user' =>$User
	);
$tabbertabsetcookie='myindex';
$template->header($params);

// Get the list of queued tracker items
$MyQueuedItems = TrackerMyQueuePeer::getUserQueuedItems($User);

$tabbermyindex = isset($_GET['tabbermyindex']) ? $_GET['tabbermyindex'] : null;
$mytiassig_total = isset($_GET['_mytiassig_total']) ? $_GET['_mytiassig_total'] : null;
$mytiassig_page = isset($_GET['_mytiassig_page']) ? $_GET['_mytiassig_page'] : null;

?>
<script type="text/javascript">
var jsBlockLink = false;
var jsQueueTrackerItems = new Array();
var jsPreviousTrackerItemIds = new Array();
<?php
// Add Tracker Item Ids (in the format needed here) to the JavaScript code
foreach ($MyQueuedItems as $QueuedItem) {
	$priorities = $QueuedItem->getTrackerItem()->getTracker()->getPriorities();
	echo "jsPreviousTrackerItemIds.push(new Array('jsTrackerItemId_".$QueuedItem->getTrackerItemId()."','".addslashes($QueuedItem->getTrackerItem()->getSummary())."','".$priorities[$QueuedItem->getTrackerItem()->getPriority()]."','".StringUtils::generateTooltip(StringUtils::trimString($QueuedItem->getTrackerItem()->getDetails(),500))."', '".$QueuedItem->getTrackerItem()->getTrackerItemUrl()."', '".$template->getPriorityColor($QueuedItem->getTrackerItem()->getPriority())."'));\n";
}
?>
function getInternetExplorerVersion() {    
	var rv = -1; // Return value assumes failure.    
	if (navigator.appName == 'Microsoft Internet Explorer') {        
		var ua = navigator.userAgent;        
		var re = new RegExp("MSIE ([0-9]{1,}[\.0-9]{0,})");        
		if (re.exec(ua) != null)            
			rv = parseFloat(RegExp.$1);    
	}    
	return rv;
}

function doUnblockLink() { jsBlockLink = false; }
function doBlockLink() { jsBlockLink = true; }

function linkWatch(url) {
	if (jsBlockLink){ 
		jsBlockLink = false;
		return false;
	} else {
		return true;
	}
}

function addToQueue(element) {
	var jsBlockLink = true;

	var id = (element.id.split('_'))[1];	
	if ($("#" + id).length > 0) {
  	    alert('<?php echo $Lang->getText('TrackerMyQueue.AlreadyInQueue'); ?>');
	} else {
		if ($("#jsTrackerItemList").find(".moveHandle").length == 1) {
			var arr = $("#jsTrackerItemList").children(".moveHandle");
			if ($(arr[0]).attr('id') == '0') {
				$(arr[0]).remove();
			}
		}

		var myId = element.id.split('_');
		var myClass = (countItemsInList()  % 2) ? 'jsItemB' : 'jsItemA';
		var myPriority = FindObject('jsPriorityItemId_' + myId[1]);

		var str_row = 
			'<tr id="' + id +'" class="moveHandle" style="clear:both position:relative;">' +
				'<input name="queuedTrackerItems[]" type="hidden" value="'+myId[1]+'" />' +
				'<td class="'+myClass+' jsRBorder jsTrackerQueueColId">'+myId[1]+'<\/td>' +
				'<td class="'+myClass+' jsRBorder jsTrackerQueueColName">'+element.innerHTML+'<\/td>' +
		   		'<td class="'+myClass+' jsRBorder jsTrackerQueueColPriority" style="background-color: '+myPriority.bgColor+';">'+myPriority.innerHTML+'&nbsp;&nbsp;<\/td>' +
		   		'<td class="'+myClass+' jsTrackerQueueColRemove"><a href="javascript:void(0)" onClick="removeFromQueue(\''+id+'\')"><?php echo $Lang->getText('TrackerMyQueue.Remove'); ?><\/a><\/td>' +
			'</tr>';

		$('#jsTrackerItemList').append(str_row);
	}

	//we need to recreate the sortable to include this item
	$("#jsTrackerItemList").sortable();
}

function countItemsInList() {
	return $('#jsTrackerItemList').length;
}

function removeFromQueue(elementId) {
	var tiList = FindObject('jsTrackerItemList');
	$('#' + elementId).remove();

	if($("#jsTrackerItemList").find(".moveHandle").length == 0) {
		//No more items in list

		var str_row =
			'<tr id="0" class="moveHandle" style="clear:both position:relative;">' +
			'<td class="jsItemA jsRBorder jsTrackerQueueColId" colspan="4"><?php echo $Lang->getText('TrackerMyQueue.DragItemsHere'); ?><\/td>' +
			'</tr>';

		$('#jsTrackerItemList').append(str_row);
	}
}

function doPreviouslyQueued() {
	var queueDiv = FindObject("jsTrackerQueue"); // Queue Container
	var itemList =  FindObject("jsTrackerItemList");
	
	for(i=0;i<jsPreviousTrackerItemIds.length;i++) {
		//For each entry in the saved queue, create and append the proper element
		var myClass = (i % 2) ? 'jsItemB' : 'jsItemA';
		var myId = jsPreviousTrackerItemIds[i][0].split('_');
		var summary = jsPreviousTrackerItemIds[i][1];
		var priority = jsPreviousTrackerItemIds[i][2];
		//For some reason we need to escape the single quote even after using StringUtils::generateTooltip previously
		var tooltip = jsPreviousTrackerItemIds[i][3].replace('\'', '\\\'');
		var url = jsPreviousTrackerItemIds[i][4];
		var priorityColor = jsPreviousTrackerItemIds[i][5];
		var link = '<a onclick="return linkWatch(this.href);" '+ 'onmouseout="tooltipexit();"' + 'onmouseover="tooltip(\''+tooltip+'\');doUnblockLink();" ' + 'href="'+url+'">'+summary+'<\/a>' ;

		var elementId = myId[1];

		var str_row = 
			'<tr id="' + elementId +'" class="moveHandle" style="clear:both position:relative;">' +
				'<input name="queuedTrackerItems[]" type="hidden" value="'+myId[1]+'" />' +
				'<td class="'+myClass+' jsRBorder jsTrackerQueueColId">'+myId[1]+'<\/td>' +
				'<td class="'+myClass+' jsRBorder jsTrackerQueueColName">'+link+'<\/td>' +
	   		'<td class="'+myClass+' jsRBorder jsTrackerQueueColPriority" style="background-color: '+priorityColor+';">'+priority+'&nbsp;&nbsp;<\/td>' +
	   		'<td class="'+myClass+' jsTrackerQueueColRemove"><a href="javascript:void(0)" onClick="removeFromQueue(\''+elementId+'\')"><?php echo $Lang->getText('TrackerMyQueue.Remove'); ?><\/a><\/td>' +
			'</tr>';

		$('#jsTrackerItemList').append(str_row);
	}

	if($("#jsTrackerItemList").find(".moveHandle").length == 0) {
		try {
			var str_row =
				'<tr id="0" class="moveHandle" style="clear:both position:relative;">' +
				'<td class="'+myClass+' jsRBorder jsTrackerQueueColId" colspan="4"><?php echo $Lang->getText('TrackerMyQueue.DragItemsHere'); ?><\/td>' +
				'</tr>';

			$('#jsTrackerItemList').append(str_row);

		} catch(err) {
		}
	}

}
</script>
<form action="<?php echo GFUrl::getUrl()->currentBaseURL('MyQueueUpdateAction', array('tabbermyindex'=>$tabbermyindex, '_mytiassig_total'=>$mytiassig_total, '_mytiassig_page'=>$mytiassig_page)) ?>" method="POST">
<p>
<h3><?php echo $Lang->getText('TrackerMyQueue.MyQueue'); ?></h3>
</p>
<div class="tabber">
<?php echo '<div class="tabbertab'. ((isset($_GET['selectedtab']) && $_GET['selectedtab']=='myqueue') ? ' tabbertabdefault' : '') .'" title="'. $Lang->getText('TrackerMyQueue.MyQueue') . '" id="myqueuetab">'; ?>
<div id="jsTrackerQueue" class="trackerQueue">
		<table cellspacing="0" cellpadding="0" border="0" class="jsTrackerQueueTable" id="trackerQueueTable">
			<thead>
				<tr>
				<td class="jsTrackerQueueTitle jsRBorder jsTrackerQueueColId"><?php echo $Lang->getText('Common.Id');?></td>
				<td class="jsTrackerQueueTitle jsRBorder jsTrackerQueueColName"><?php echo $Lang->getText('TrackerItem.SummaryName'); ?></td>
				<td class="jsTrackerQueueTitle jsRBorder jsTrackerQueueColPriority"><?php echo $Lang->getText('TrackerItem.PriorityName'); ?></td>
				<td class="jsTrackerQueueTitle jsTrackerQueueColRemove"><a href="javascript:void(0);" onclick="fixedPopup('<?php echo GFUrl::getUrl()->currentBaseURL('MyQueuePopup') ?>', 625, 180);" /><img src="/images/plus.gif" alt="" border="0" /></a></td>
			</tr>
			</thead>
			<tbody id="jsTrackerItemList">
			</tbody>		
		</table>
	<div id="jsSeparator" style="height:16px;"></div>
</div>
<div class="jsTrackerQueueSave" align="right"><?php echo HTMLWidget::button("submit","" .   $Lang->getText('TrackerMyQueue.SaveQueue') . " ","updateQueue","","")?></div>
</div>
</form>

<?php

// get the user projects to display in a tab
$user_projects = $User->getAllProjects();
echo '<div class="tabbertab'. ((isset($_GET['selectedtab']) && $_GET['selectedtab']=='otherpending') ? ' tabbertabdefault' : '') .'" title="'. $Lang->getText('My.Pending') . '" id="otherpendingtab">'; 

$theader = array();
$theader[] = $Lang->getText('Project.Project');
$theader[] = $Lang->getText('My.Pending');
echo $template->tableTop($theader);
$nopending=true;


if (count($user_projects) > 0){
	$user_projects_ids = array();
	foreach ($user_projects as $user_project) {
		$user_projects_ids[] = $user_project->getProjectId();
	}
	// Retrieve the objects array
	$crit = new Criteria();
	$crit->add(ProjectJoinRequestPeer::PROJECT_ID, $user_projects_ids, Criteria::IN);
	$crit->setDistinct();
	$crit->addSelectColumn(ProjectJoinRequestPeer::PROJECT_ID);
	$rs = ProjectJoinRequestPeer::doSelectRS($crit);
	while ($rs->next()) {
		$join_req_id = $rs->getInt(1);
		$cols = array();
		foreach($user_projects as $project) {
			if($project->getProjectId()==$join_req_id && $project->userIsAdmin()) {
				$cols[] = '<a href="' . GFUrl::getUrl()->projectURL($project) . '" >' .  $project->getProjectName() . '</a>';
				$cols[] = '<a href="' . GFUrl::getUrl()->projectURL($project,'ProjectJoinRequestBrowse','','admin'). '" >'.$Lang->getText('ProjectJoinRequest.PendingRequests').'</a>';
				echo $template->tableRow($cols);
				$nopending=false;
				break;
			}
		}
	}
	
	if (Session::getSession()->isSiteAdmin()) {
		$crit = new Criteria();
		$crit->add(ProjectPeer::STATUS, Project::STATUS_PENDING);
		$pending_projects = ProjectPeer::doSelect($crit);
		foreach ($pending_projects as $pending_project) {
			$cols = array();
			$cols[] = $pending_project->getProjectName();
			$cols[] = '<a href="/gf/admin/?action=approve-pending">'.$Lang->getText('Project.PendingProjectApproval').'</a>';
			echo $template->tableRow($cols);
			$nopending = false;
		}
	}

	$pending_docs_projects = DocmanFilePeer::doSelectProjectsWithPendingDocs($user_projects_ids);
	
	foreach ($pending_docs_projects as $project_id) {
		foreach($user_projects as $project) {
			if($project->getProjectId()==$project_id && $project->usesPlugin('docman') && $project->getPermission()->check(DocmanPlugin::SECTION,0,DocmanPlugin::ADMIN)) {
				$cols = array();
				$cols[] = '<a href="' . GFUrl::getUrl()->projectURL($project) . '" >' .  $project->getProjectName() . '</a>';
				$cols[] = '<a href="' . GFUrl::getUrl()->projectURL($project,'','docman','admin'). '" >'.$Lang->getText('DocmanFolder.PendingDocs').'</a>';
				echo $template->tableRow($cols);
				$nopending=false;
				break;
			}
		}
	}

	$pending_forum_projects = ForumMessagePeer::doSelectProjectsWithPendingForumMessages($user_projects_ids);

	foreach ($pending_forum_projects as $project_id) {
		foreach($user_projects as $project) {
			if($project->getProjectId()==$project_id && 
				$project->usesPlugin('forum') && 
				$project->getPermission()->check(ForumPlugin::SECTION,0,ForumPlugin::ADMIN)){
						$cols = array();
						$cols[] = '<a href="' . GFUrl::getUrl()->projectURL($project) . '" >' .  $project->getProjectName() . '</a>';
						$cols[] = '<a href="' . GFUrl::getUrl()->projectURL($project,'','forum','admin'). '" >'.$Lang->getText('Forum.PendingMessages').'</a>';
						echo $template->tableRow($cols);
						$nopending=false;
					}
				
		}
	}

}

if($nopending) {
	echo $template->tableFullRow($Lang->getText('My.NoPendingItems'));
}

echo $template->tableBottom();

?>
</div>

</div>
<div class="tabber">
<?php 

$params['theme'] = $template;

// get the tabs that the plugins for the user display
$prs = ActionManager::notify('BUILD_MYPAGE_ELEMENTS',$params);
foreach ($prs as $pr) {
	echo $pr->getResult();
}


echo '<div class="tabbertab'. ((isset($_GET['selectedtab']) && $_GET['selectedtab']=='projects') ? ' tabbertabdefault' : '') .'" title="'. $Lang->getText('My.Projects') . '" id="projectstab">';
$theader = array();
$theader[] = $Lang->getText('My.MyProjects');
$theader[] = '&nbsp;';
echo $template->tableTop($theader);

if (count($user_projects) > 0){
	foreach ($user_projects as $user_project) {
		$cols = array();
		$project = $user_project;
		$cols[] = '<a href="' . GFUrl::getUrl()->projectURL($project) . '" >' .  $project->getProjectName() . '</a>';
		$cols[] = '<a href="' . GFUrl::getUrl()->currentBaseURL('UserProjectRemove', 
				array('project_id'=>$project->getProjectId())). '" >'.$Lang->getText('MyUserRemoveFromProject.Remove').'</a>';

		echo $template->tableRow($cols);
	}
	
} else { //The user have no projects.
	echo $template->tableFullRow($Lang->getText('My.NoProjects'));
}
echo $template->tableBottom();
echo '</div>';
?>
</div>
<script type="text/javascript">

doPreviouslyQueued();

//Enables the elements with the "jsTrackerItem" class to be draggable
$(".jsTrackerItems").draggable({
	helper: "clone",
	opacity: .75,
	refreshPositions: true,
	revert: "invalid",
	revertDuration: 300,
	scroll: true,
	start: function(event, ui) {
	},
	stop: function(event, ui) {
	},
});

//Sets the jsTrackerQueue object to be the drop zone
$('#jsTrackerQueue').droppable({
	accept: ".jsTrackerItems",
	drop: function(e, ui) { 
		var el = document.getElementById($(ui.draggable)[0].id);
		addToQueue(el);
		tooltipexit();
	},
	hoverClass: "jsTrackerQueueActive",
	over: function(e, ui) {
	}
});


//Sets the tracker items in the queue to be sortable elements
$("#jsTrackerItemList").sortable();

if(getInternetExplorerVersion() >= 8){
	//position:relative doesn't work right with ie8
	element=FindObject('jsTrackerQueue');
	element.style.position="";
}
</script>
<?php
$template->footer();
?>

