<?php

/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code lists News
//
require_once('lib/core/WallPost.php');
require_once('lib/core/WallPostPeer.php');
require_once('lib/core/WallPostComment.php');
require_once('lib/core/WallPostCommentPeer.php');
require_once('html/MyTemplate.php');

$session = Session::getSession();
$user = $session->getUser();
$Lang = $session->getLanguage();

if (!($session->isLoggedIn())) {
    throw new PermissionDeniedException();
}

$filter = isset($_REQUEST['filter']) ? intval($_REQUEST['filter']) : WallPostPeer::POST_FILTER_TYPE_BY_OR_TO_USER;
$year = isset($_REQUEST['year']) ? intval($_REQUEST['year']) : "0";
$month = isset($_REQUEST['month']) ? intval($_REQUEST['month']) : "0";

//Variables from the add-post form - used when returning from WallPostAddAction with errors
$comment = isset($_REQUEST['comment']) ? Validator::sanitizeString($_REQUEST['comment']) : "";
$section = isset($_REQUEST['section']) ? Validator::sanitizeString($_REQUEST['section']) : "";
$ref_id = isset($_REQUEST['ref_id']) ? Validator::sanitizeInt($_REQUEST['ref_id']) : "";
$unix_name = isset($_REQUEST['unix_name']) ? Validator::sanitizeString($_REQUEST['unix_name']) : "";

$theme = new MyTemplate();

$params = array(
    'user' => $user,
    'selectedbottomtab' => 'messagewall',
    'action' => isset($action) ? $action : '',
    'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : ''),
    'title' => $Lang->getText("Tabs.MyMessageWall")
);
$theme->header($params);

$crit = WallPostPeer::CreateUserCriteria($user->getUserId(), $filter, $year, $month);

$total = WallPostPeer::doCount($crit);

$paginator = new Paginator('messagewall', 10, $total, WallPostPeer::POST_DATE, array());
$paginator->addPageClauses($crit);
$arr = WallPostPeer::doSelect($crit);

//Get archives data (month/year)
$arr_archives = WallPostPeer::GetArchiveList($user->getUserId());

//Display posts
require_once("forms/MessageWallPostBrowse-tpl.php");

echo $paginator->getPaginator();

$theme->footer($params);
