<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id$
 * @author Julian Yerfino jyerfino@gforgegroup.com
 * @date
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

require_once('html/MyTemplate.php');
require_once('lib/core/FilesystemPeer.php');
//require_once('lib/core/UserProjectPeer.php');
require_once('lib/html/HTMLWidget.php');
require_once('lib/core/MyReport.php');
require_once('lib/core/MyReportPeer.php');
require_once('lib/core/MyReportProject.php');
require_once('lib/core/MyReportProjectPeer.php');

$session=Session::getSession();
if (!$session->isLoggedIn()) {
	throw new NotLoggedInException();
}
$Lang = $session->getLanguage();
$template = new MyTemplate();
$user = Session::getSession()->getUser();

if(isset($_REQUEST['feedback'])) $feedback = StringUtils::stripHTMLTags($_REQUEST['feedback']);
if(isset($_REQUEST['report_id'])) {
	$report_id = Validator::sanitizeInt($_REQUEST['report_id']);
	// Fetch report data
	if($report_id != 0) {
		$report = MyReportPeer::retrieveByPK($report_id);
		if(!is_object($report)) {
			$is_new = true;
			$report_id = 0;
		}
		else {
			$is_new = false;
			if($report->getUserId() != $user->getUserId()) {
				$parms = array ('feedback'=>$Lang->getText('Report.NotOwner'));
				GFUrl::getUrl()->redirect(GFUrl::getUrl()->currentBaseURL(''), $parms);
				exit();
			}
		}
	}
	else {
		$is_new = true;
	}
}
else {
	$is_new = true;
	$report_id = 0;
}


$params = array(
	'title' => $is_new ? Language::getSessText('Report.AddNew'):Language::getSessText('Report.Edit'),
	'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : ''),
	'action' => isset($action) ? $action : '',
	'selectedbottomtab' => 'myreports',
	'user' => $user
	);
$template->header($params);

$params['theme'] = $template;

echo '<p><div class="infobox">' . $Lang->getText('Report.Step1Description') . '</div></p><br>';

$projects = $user->getAllProjects();
$projects_arr = array();

foreach($projects as $project)
{
	$projects_arr[$project->getProjectId()] = $project->getProjectName();
}

$projects_selected = array();

if(!$is_new) {
	// Fetch selected projects from the report
	$crit = new Criteria();
	$crit->add(MyReportProjectPeer::MY_REPORT_ID, $report_id);
	$crit->addSelectColumn(MyReportProjectPeer::PROJECT_ID);
	$rs = MyReportProjectPeer::doSelectRS($crit);

	while($rs->next())
	{
		$projects_selected[] = $rs->getInt(1);
	}
}

include('forms/ReportEditStep1-tpl.php');

$template->footer();
?>
