<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id$
 * @author Julian Yerfino jyerfino@gforgegroup.com
 * @date
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
require_once('html/MyTemplate.php');
require_once('lib/core/FilesystemPeer.php');
require_once('lib/core/MyReport.php');
require_once('lib/core/MyReportPeer.php');
//require_once('lib/core/UserProjectPeer.php');
require_once('lib/html/HTMLWidget.php');
require_once('lib/core/MyReport.php');
require_once('lib/core/MyReportPeer.php');
require_once('lib/core/MyReportUser.php');
require_once('lib/core/MyReportUserPeer.php');
require_once('lib/core/MyReportFieldFilter.php');
require_once('lib/core/MyReportFieldDisplay.php');
require_once('lib/core/MyReportFieldFilterPeer.php');
require_once('lib/core/MyReportFieldDisplayPeer.php');
require_once('lib/core/MyReportTracker.php');
require_once('lib/core/MyReportTrackerPeer.php');
require_once('lib/core/MyReportFieldValue.php');
require_once('lib/core/MyReportFieldValuePeer.php');

$session=Session::getSession();
if (!$session->isLoggedIn()) {
	throw new NotLoggedInException();
}
$Lang = $session->getLanguage();


$template = new MyTemplate();

$user = Session::getSession()->getUser();

if(isset($_REQUEST['feedback'])) $feedback = StringUtils::stripHTMLTags($_REQUEST['feedback']);
if(isset($_REQUEST['report_id'])) {
	$report_id = Validator::sanitizeInt($_REQUEST['report_id']);
	// Fetch report data
	if($report_id != 0) {
		$report = MyReportPeer::retrieveByPK($report_id);
		if(!is_object($report)) {
			$is_new = true;
			$report_id = 0;
		}
		else {
			$is_new = false;
			if($report->getUserId() != $user->getUserId()) {
				$parms = array ('feedback'=>$Lang->getText('Report.NotOwner'));
				GFUrl::getUrl()->redirect(GFUrl::getUrl()->currentBaseURL(''), $parms);
				exit();
			}
		}
	}
	else {
		$is_new = true;
	}
}
else {
	$is_new = true;
	$report_id = 0;
}

if(!isset($_REQUEST['projects_selected']) || !is_array($_REQUEST['projects_selected']) || count($_REQUEST['projects_selected'])==0) {
	$_REQUEST['feedback'] = $Lang->getText('Report.ErrorNoProjectsSelected');
	include('ReportEditStep1.php');
	exit();
}
if(!isset($_REQUEST['trackers_selected']) || !is_array($_REQUEST['trackers_selected']) || count($_REQUEST['trackers_selected'])==0) {
	$_REQUEST['feedback'] = $Lang->getText('Report.ErrorNoTrackersSelected');
	include('ReportEditStep2.php');
	exit();
}
if(!isset($_REQUEST['extrafields_filter']) || !is_array($_REQUEST['extrafields_filter']) || count($_REQUEST['extrafields_filter'])==0) {
	$_REQUEST['extrafields_filter'] = array();
	/*$_REQUEST['feedback'] = $Lang->getText('Report.ErrorNoExtraFieldsSelected');
	include('ReportEditStep3.php');
	exit();*/
}
if(!isset($_REQUEST['extrafields_display']) || !is_array($_REQUEST['extrafields_display']) || count($_REQUEST['extrafields_display'])==0) {
	$_REQUEST['feedback'] = $Lang->getText('Report.ErrorNoExtraFieldsSelected');
	include('ReportEditStep3.php');
	exit();
}
$params = array(
	'title' => $is_new ? Language::getSessText('Report.AddNew'):Language::getSessText('Report.Edit'),
	'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : ''),
	'action' => isset($action) ? $action : '',
	'selectedbottomtab' => 'myreports',
	'user' => $user
	);
$template->header($params);

echo '<p><div class="infobox">' . $Lang->getText('Report.Step4Description') . '</div></p><br>';
$params['theme'] = $template;

$projects_selected = array();
$trackers_selected = array();
$extrafields_filter = array();
$extrafields_values = array();
$assignees_common = array();
// Build the list of selected projects, and from each project retrieve all trackers
// whose name matches one of the selected tracker names. From the trackers, extract the extra fields
// that appear in all trackers, and from there the elements that appear in all of each extra fields.

foreach($_REQUEST['projects_selected'] as $ps) {
	$ps = Validator::sanitizeInt($ps);
	$project = ProjectPeer::retrieveByPK($ps);
	if(is_object($project) && $project->userCanRead())
	{
		$projects_selected[$ps] = $project;
		$projectTrackers = $project->getTrackers();
		foreach($projectTrackers as $pt) {
			if ($pt->userCanRead()) {
				//Fetch the assignees for later use
				foreach($_REQUEST['trackers_selected'] as $ts) {
					if($ts==$pt->getTrackerName()) {
						$trackers_selected[] = $pt;
						$techs = $pt->getTechnicians();
						$tech_tmp = array();
						foreach($techs as $tech) {
							$assignees_common[$tech->getUserId()] = $tech->getFirstName() . ' ' . $tech->getLastName();
						}
						
						/*if(!isset($assignees_common)) {
							$assignees_common = $tech_tmp;
						}
						else {
							//First line ANDs the values together, the second one ORs them
							$assignees_common = array_intersect($assignees_common, $tech_tmp);
						}*/
						
						$efs = $pt->getTrackerExtraFields();
						foreach($efs as $ef)
						{
							$tmp_values = array();
							foreach($_REQUEST['extrafields_filter'] as $efs) {
								$efs = Validator::sanitizeString($efs);
								if($ef->getFieldName() == $efs) {

									$field_type = $ef->getFieldType();
									if ($field_type == TrackerExtraField::TYPE_MEMBERS){
										//None value
										$tmp_values['100']=$Lang->getText('Options.None');
										foreach($ef->getTrackerExtraFieldElements() as $efe){
											$tmp_values[$efe->getElementId()] = $efe->getElementName();
										}
									} else {
										
										foreach($ef->getTrackerExtraFieldElements() as $efe)
										{
										$tmp_values[$efe->getElementName()] = $efe->getElementName();
										}
									}
										
									if(!isset($extrafields_values[$efs])) {
										$extrafields_values[$efs] = array('type' => $ef->getFieldType(), 'values' => $tmp_values);
									}
									else {
										//First line ANDs the values together, the second one ORs them
										//$extrafields_values[$efs]['values'] = array_intersect($extrafields_values[$efs]['values'], $tmp_values);
										$extrafields_values[$efs]['values'] = array_merge($extrafields_values[$efs]['values'], $tmp_values);
									}
									break;
								}
							}
						}
						break;		
					}
				}
			}
		}
	}
}

// Add the tracker fixed fields values
foreach($_REQUEST['extrafields_filter'] as $efs) {
	$efs = Validator::sanitizeString($efs);
	
	switch($efs) {
		case TrackerItemPeer::SUMMARY:
			$extrafields_values[TrackerItemPeer::SUMMARY] = array('displayName' => Language::getSessText('TrackerItem.SummaryName'), 'type' => MyReport::FIELDTYPE_SUMMARY, 'values' => array());
			break;
		case TrackerItemPeer::DETAILS:		
			$extrafields_values[TrackerItemPeer::DETAILS] = array('displayName' => Language::getSessText('TrackerItem.DetailsName'), 'type' => MyReport::FIELDTYPE_DETAILS, 'values' => array());
			break;
		case TrackerItemPeer::PRIORITY:
			$extrafields_values[TrackerItemPeer::PRIORITY] = array('displayName' => Language::getSessText('TrackerItem.PriorityName'), 'type' => MyReport::FIELDTYPE_PRIORITY, 'values' => Tracker::getPriorities());
			break;
		case TrackerItemAssigneePeer::TABLE_NAME:
			$extrafields_values[TrackerItemAssigneePeer::TABLE_NAME] = array('displayName' => Language::getSessText('TrackerItem.AssignedTo'), 'type' => MyReport::FIELDTYPE_ASSIGNEES, 'values' => $assignees_common);
			break;
		default:
			break;
	}
}


// Add the row ordering selector
$extrafields_display = array();
foreach($_REQUEST['extrafields_display'] as $efs) {
	$efsname = $efs = Validator::sanitizeString($efs);
	switch($efs) {
		case TrackerItemPeer::SUMMARY:
			$efsname = Language::getSessText('TrackerItem.SummaryName');
			break;
		case TrackerItemPeer::DETAILS:
			$efsname = Language::getSessText('TrackerItem.DetailsName');
			break;
		case TrackerItemPeer::PRIORITY:
			$efsname = Language::getSessText('TrackerItem.PriorityName');
			break;
		case TrackerItemAssigneePeer::TABLE_NAME:
			$efsname = Language::getSessText('TrackerItem.AssignedTo');
			break;
		case TrackerItemPeer::OPEN_DATE:
			$efsname = Language::getSessText('TrackerItem.OpenDateName');
			break;
		case TrackerItemPeer::CLOSE_DATE:
			$efsname = Language::getSessText('TrackerItem.CloseDateName');
			break;
		case TrackerItemPeer::LAST_MODIFIED_DATE:
			$efsname = Language::getSessText('TrackerItem.LastModifiedDateName');
			break;
		case TrackerPeer::TRACKER_NAME:
			$efsname = Language::getSessText('Tracker.TabString');
			break;
		case ProjectPeer::PROJECT_NAME:
			$efsname = Language::getSessText('Common.Project');
			break;
		default:
			break;
	}
	$extrafields_display[$efs] = $efsname;
}

$rowSortColumn = '';
$rowSortOrder = true;
$extrafields_values_selected = array();

if(!$is_new) {
	
	$report_name = $report->getReportName();
	if($report->getOpenDateStart(null) > 50000) {
		$open_date_start = $report->getOpenDateStart('M d Y');
	}
	else {
		$open_date_start = '';
	}
	
	if($report->getOpenDateEnd(null) > 50000) {
		$open_date_end = $report->getOpenDateEnd('M d Y');
	}
	else {
		$open_date_end = '';
	}
	
	if($report->getCloseDateStart(null) > 50000) {
		$close_date_start = $report->getCloseDateStart('M d Y');
	}
	else {
		$close_date_start = '';
	}
	
	if($report->getCloseDateEnd(null) > 50000) {
		$close_date_end = $report->getCloseDateEnd('M d Y');
	}
	else {
		$close_date_end = '';
	}
	
	// Get Users we share with
	$crit = new Criteria();
	$crit->addJoin(UserPeer::USER_ID, MyReportUserPeer::USER_ID);
	$crit->add(MyReportUserPeer::MY_REPORT_ID, $report_id);
	/*$crit->addSelectColumn(UserPeer::USER_ID);
	$crit->addSelectColumn(UserPeer::FIRSTNAME);
	$crit->addSelectColumn(UserPeer::LASTNAME);*/
	$crit->addSelectColumn(UserPeer::UNIX_NAME);
	$rs = UserPeer::doSelectRS($crit);
	$users_selected = '';
	if ($rs->next()) {
		$users_selected = $rs->getString(1);
	}
	$users_list = array();
	while ($rs->next()){
		$users_selected .= ','.$rs->getString(1);
	}
	
	// Is Report shared?
	$report_shared = $report->getIsShared();
	
	// Fetch selected values for extra fields from the report
	foreach ( $extrafields_values as $efs => $data)
	{
		$crit = new Criteria();
		$crit->addJoin(MyReportFieldValuePeer::MY_REPORT_FIELD_FILTER_ID, MyReportFieldFilterPeer::MY_REPORT_FIELD_FILTER_ID );
		$crit->add(MyReportFieldFilterPeer::MY_REPORT_ID, $report_id);
		$crit->add(MyReportFieldFilterPeer::FIELD_NAME, $efs);
		if(!isset($extrafields_values_selected[$efs])) {
			$extrafields_values_selected[$efs] = array();
		}
		switch($data['type'])
		{	
			case MyReport::FIELDTYPE_ASSIGNEES:
			case MyReport::FIELDTYPE_PRIORITY:
			case TrackerExtraField::TYPE_SELECT:
				// Multiselect field
			case TrackerExtraField::TYPE_MEMBERS:
				// Type Members
			case TrackerExtraField::TYPE_CHECKBOX:
				// Checkbox
			case TrackerExtraField::TYPE_RADIO:
				// Radio
			case TrackerExtraField::TYPE_MULTISELECT:
				// Multiselect
			case TrackerExtraField::TYPE_STATUS:
				// Status field
			case TrackerExtraField::TYPE_RELEASE:
				$fvs = MyReportFieldValuePeer::doSelect($crit);
				if(is_array($fvs)) {
				foreach($fvs as $fv) {
					$extrafields_values_selected[$efs][]=$fv->getFieldValue();
				}
				}
				else {
					$extrafields_values_selected[$efs] = array();
				}
				break;
				
			case MyReport::FIELDTYPE_DETAILS:
			case MyReport::FIELDTYPE_SUMMARY:	
			case TrackerExtraField::TYPE_TEXT:
				// Text box
			case TrackerExtraField::TYPE_TEXTAREA:
				// Text Area
				$fv = MyReportFieldValuePeer::doSelectOne($crit);
				if(is_object($fv)) {
					$extrafields_values_selected[$efs]=$fv->getFieldValue();
				}
				else {
					$extrafields_values_selected[$efs]='';
				}
				break;

			case TrackerExtraField::TYPE_DATE:
			case TrackerExtraField::TYPE_SERIAL:
			case TrackerExtraField::TYPE_NUMERIC:			
				$fv = MyReportFieldValuePeer::doSelectOne($crit);
				if(is_object($fv)) {
					$extrafields_values_selected[$efs] = array('min' => $fv->getFieldRangeStart(), 'max' => $fv->getFieldRangeEnd());
				}
				else {
					$extrafields_values_selected[$efs] = array('min' => '', 'max' => '');
				}
				break;
				
			
							
				
			default:
				break;
		}
	}
	
	$crit = new Criteria();
	$crit->add(MyReportFieldDisplayPeer::MY_REPORT_ID, $report_id);
	$crit->addDescendingOrderByColumn(MyReportFieldDisplayPeer::ORDER_PRIORITY);
	$crit->addAscendingOrderByColumn(MyReportFieldDisplayPeer::COLUMN_ORDER);	// Just in case there no ordering made, use the left most column
	$sortCol = MyReportFieldDisplayPeer::doSelectOne($crit);
	if(is_object($sortCol)) {
		$rowSortColumn = $sortCol->getFieldName();
		$rowSortOrder = $sortCol->getOrderAsc();
	}
}
else {
	
	$report_name = $open_date_start = $open_date_end = $close_date_start = $close_date_end = '';
	$users_selected = '';
	$users_list = array();
	$report_shared = false;
	
	foreach ( $extrafields_values as $efs => $data)
	{
		switch($data['type'])
		{
			case MyReport::FIELDTYPE_ASSIGNEES:
			case MyReport::FIELDTYPE_PRIORITY:
			case TrackerExtraField::TYPE_SELECT:
				// Multiselect field
			case TrackerExtraField::TYPE_MEMBERS:
			   // Members field
			case TrackerExtraField::TYPE_CHECKBOX:
				// Checkbox
			case TrackerExtraField::TYPE_RADIO:
				// Radio
			case TrackerExtraField::TYPE_MULTISELECT:
				// Multiselect
			case TrackerExtraField::TYPE_STATUS:
				// Status field
			case TrackerExtraField::TYPE_RELEASE:
				$extrafields_values_selected[$efs] = array();
				break;
				
			case MyReport::FIELDTYPE_DETAILS:
			case MyReport::FIELDTYPE_SUMMARY:		
			case TrackerExtraField::TYPE_TEXT:
				// Text box
			case TrackerExtraField::TYPE_TEXTAREA:
				// Text Area
				$extrafields_values_selected[$efs]='';
				break;

			case TrackerExtraField::TYPE_DATE:
			case TrackerExtraField::TYPE_SERIAL:
			case TrackerExtraField::TYPE_NUMERIC:
				$extrafields_values_selected[$efs] = array('min' => '', 'max' => '');
				break;
				
			default:
				break;
		}
	}
}

include('forms/ReportEditStep4-tpl.php');

$template->footer();
?>
