<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id$
 * @author Marcelo Mottalli	<marcelo@gforgegroup.com>
 * @date 2006-03-13
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */


require_once('html/ProjectTemplate.php');
require_once('external/fckeditor/fckeditor.php');
require_once('lib/Validator.php');
$project = GFUrl::getUrl()->getProject();
$project_name = $project->getUnixName();
if (!$project->userIsAdmin()) {
	// Only project admins can change member information
	throw new PermissionDeniedException();
}

$feedback = 'No change';
$errors = array();

if (isset($_POST['submit'])) {
	//$contents = stripslashes($_POST['content']);
	$contents = $_POST['content'];
	$contents = Validator::sanitizeHtml($contents);
	try {
		$project->getHomepage()->setFileDataFromString($contents);
		$feedback = Language::getSessText('ProjectAdmin.HomepageUpdated');
		GFUrl::redirect(GFUrl::getUrl()->currentBaseURL('EditHomepage',array('feedback'=>$feedback)));
	} catch (InvalidDataException $ex){
		$errors = array_merge($errors, $ex->getErrors());
		$feedback = '* '.implode('<br />* ', $errors);
		GFUrl::redirect(GFUrl::getUrl()->currentBaseURL('',array('feedback'=>$feedback)));
	}
}
?>