<?php
require_once('core/Project.php');
require_once('session/Session.php');
require_once('lib/html/UploadHandler.php');


$session =  Session::getSession();
/** @var Project $project */
$project = GFUrl::getUrl()->getProject();
$Lang = $session->getLanguage();

require_once('html/templates/ProjectAdminTemplate.php');
$template = new ProjectAdminTemplate();
$params = array(
	'selectedbottomtab' => 'sendmassemail',
	'project'=>$project,
	'title'=>$Lang->getText('ProjectAdmin.MassEmail.Title'),
	'enableUploads'=>true,
	'feedback'=> isset($_REQUEST['feedback']) ? Validator::sanitizeString($_REQUEST['feedback'], false) : (isset($feedback) ? Validator::sanitizeString($feedback, false) : null)
);
$selected = isset($_REQUEST['receivers']) ? Validator::sanitizeString($_REQUEST['receivers'], false) : "1";
$tabbertabsetcookie='massEmail';
$template->header($params);
?>
<?php
echo '<h3>'. $Lang->getText('ProjectAdmin.MassEmail.Title') .'</h3>';


echo '<div class="tabber">';

?>
<script type="text/javascript">
		$(document).ready(
			function() {
			$("[name='receivers']").change(function(){
				selected = $("[name='receivers']:checked").val();
				if (selected == "1") {
					$('#receiversGroupOption').hide();
					$('#receiversIndividualOption').hide();
				} else if (selected == "2") {
					$('#receiversGroupOption').show();
					$('#receiversIndividualOption').hide();
				} else if (selected == "3") {
					$('#receiversGroupOption').hide();
					$('#receiversIndividualOption').show();
				}
			});

			$(".subjectLink").click(function () {
				tmpl = null;
				var url = '<?php echo GFUrl::getUrl()->currentBaseURL('GetProjectNotificationDetails')?>';
				var notification_id = $(this).attr('id').split('_');
				notification_id = notification_id[1];

				$.ajax({
					url: url,
					type: "GET",
					dataType: "json",
					data: {'notification_id' : notification_id },
					success: function(notificationDetails) {
						var tmpl = new EJS({element: 'notification_details_template'});

						$("#notification_details").html(tmpl.render(notificationDetails));
						$("#notification_details").dialog({
							title: '<?php echo $Lang->getText('ProjectAdmin.MassEmail.ProjectNotificationDetailsTitle') ?>',
							resizable: false,
							height: 500,
							width: 600,
							modal: true,
							buttons: {
								"<?php echo $Lang->getText('Common.Close') ?>": function()  {
									$( this).dialog( "close" );
									tmpl.out();
								}
							}
						});
					}
				});
			});

		});


</script>
<div id="notification_details" style="display:none;"></div>
<?php
include("forms/ProjectNotificationDetailsDialog.php");

$uploadHandler = new UploadHandler();
$file_upload_form_hash = $uploadHandler->getUploadHash();

$title = $Lang->getText('ProjectAdmin.MassEmail.Compose');
echo '<div class="tabbertab'. ((isset($_GET['selectedtab']) && $_GET['selectedtab']=='sendmassemail') ?
		' tabbertabdefault' : '') .'" title="'. $title. '" id="sendmassemail">';

echo '<form action="'. GFUrl::getUrl()->currentBaseURL('SendProjectEmailAction') .'" method="post" enctype="multipart/form-data" name="SendProjectEmail">';

	echo '<span id="mainControls">';
	echo '<div id="receiversDiv">';
	echo '<input type="radio" name="receivers" value="1" ' . ($selected == "1" ? ' checked="checked"' : '') .'/>' .
		$Lang->getText('ProjectAdmin.MassEmail.SendToAll');
	echo '<input type="radio" name="receivers" value="2" ' . ($selected == "2" ? ' checked="checked"' : '') . '/>' .
		$Lang->getText('ProjectAdmin.MassEmail.SendToRoleGroup');
	echo '<input type="radio" name="receivers" value="3" ' . ($selected == "3" ? ' checked="checked"' : '') .'/> ' .
		$Lang->getText('ProjectAdmin.MassEmail.SendToIndividual');
	echo '</div>';
	echo '<br />';

	echo '<table>';

	#echo '<span id="receiversGroupOption" ' ;
		echo '<tr id="receiversGroupOption" ' . (($selected != 2) ? ' style="display:none" >' : '>');
		echo '<td>Role</td>';
		/** @var Role[] $roles */
		$roles = $project->getRoles();
		$nonEmptyRoles = array();
		foreach ($roles as $role) {
			if ($role->getUserProjectRoles()) {
				$nonEmptyRoles[] = $role;
			}
		}
		$sel = isset($_POST['role_id']) ? $_POST['role_id'] : array();
		/**foreach ($roles as $role) {
			$sel[] = $role->getRoleId();
		}*/
		echo '<td>'.HTMLWidget::multiselect('role_id[]',$nonEmptyRoles,$sel, 0, false).'</td>';
		//echo '<td>' . HTMLWidget::multiselect('role_id[]',$roles,$sel,0, true, 'None',false, fa lse,
		//	null,10,false,null,0).'</td>';

		/** @var User[] $groups */
		$groups = $project->getMemberGroups();
		$sel = isset($_POST['group_id']) ? $_POST['group_id'] : array();
		/*
		foreach ($groups as $group) {
			$sel[] = $group->getUserId();
		}*/
		if (count($groups)) {
			echo '<td> Groups </td>';
			echo '<td>'.HTMLWidget::multiselect('group_id[]', $groups, $sel, 0,false).'</td>';
		}
		echo '</tr>';
	#echo '</span>';
	$members = $project->getMembers();
	$membersArr = array();
	foreach ($members as $member) {
		$membersArr[] = $member->getUnixName();
	}


	echo '<tr id="receiversIndividualOption" '.  (($selected != 3) ? ' style="display:none" >' : '>');
	echo '<td>'. $Lang->getText('ProjectAdmin.MassEmail.To') . '</td>';
	echo '<td colspan="2">'. HTMLWidget::inputTextWithAutoComplete('usernames', $membersArr, array('name'=>'usernames',
		'value'=>(isset($_POST['usernames']) ? $_POST['usernames'] : ''), 'size'=>95)) .'</td>';
	echo '</tr>';

	echo '<tr id="Subject">';
	echo '<td>' . $Lang->getText('ProjectAdmin.MassEmail.Subject') . '</td>';
	echo '<td colspan="3"><input name="subject" size="95" value="' . (isset($_POST['subject']) ? $_POST['subject'] : '') .'" /></td>';
	echo '</tr>';

	echo '<tr id="Message">';
	echo '<td>' . $Lang->getText('ProjectAdmin.MassEmail.Message') .'</td>';
	echo '<td colspan="3"><textarea name="message" rows="15" cols="80">'. (isset($_POST['message']) ? $_POST['message'] : '') .'</textarea></td>';
	echo '</tr>';

	echo '</table>';

	echo '<div class="upload_widget"></div>';
	echo $uploadHandler->getJavascriptSetup();

?>
	<table>
	<tr>
		<td colspan="2">

			<?php echo HTMLWidget::button("submit", $Lang->getText('Common.Send'), "submit", "", "")?>
		</td>
	</tr>
	</table>
<?php




echo '</form>';
echo '</div>';
$ref_id = $project->getId();
$section = Project::SECTION;

$title = $Lang->getText('ProjectAdmin.MassEmail.History');
echo '<div class="tabbertab'.((isset($_GET['selectedtab']) && $_GET['selectedtab']=='activenotifications') ?
		' tabbertabdefault' : '').'" title="' . $title .'" id="activenotifications">';


echo '<div>';
$status_filter = isset($_POST['status_filter']) ? $_POST['status_filter'] : 'all';
echo '<form action="'. GFUrl::getUrl()->currentBaseUrl('EmailMembers') . '" method="post" name="StatusFilter" >';
echo '<table><tbody>';
echo '<tr>';
echo '<td><strong>'.$Lang->getText('ProjectAdmin.MassEmail.Filter') . '</strong></td>';
echo '<td>';
echo '<select name="status_filter" >';
echo '<option value="all" '. ($status_filter == 'all' ? ' selected="selected" ' : '') . '>' .
	$Lang->getText('ProjectAdmin.MassEmail.FilterAll') . '</option>';
echo '<option value="pending" '. ($status_filter == 'pending' ? ' selected="selected" ' : '') . '>' .
	$Lang->getText('ProjectAdmin.MassEmail.FilterPending') . '</option>';
echo '<option value="sent" '. ($status_filter == 'sent' ? ' selected="selected" ' : '') . '>' .
	$Lang->getText('ProjectAdmin.MassEmail.FilterSent') . '</option>';
echo '<option value="failed" '. ($status_filter == 'failed' ? ' selected="selected" ' : '') . '>' .
	$Lang->getText('ProjectAdmin.MassEmail.FilterFailed') . '</option>';
echo '</select></td>';
$text = $Lang->getText('ProjectAdmin.MassEmail.ApplyFilter');
echo '<td>' .HTMLWidget::button("submit",$text,'filter_button','filter_button') .'</td></tr></tbody>';
echo '</table>';
echo '</form>';

if ($status_filter == 'all') {
	$sqlExtraClause = '';
} else if ($status_filter == 'pending') {
	$sqlExtraClause = ' AND notification_id IN (SELECT notification_id FROM notification_queue)';
} else if ($status_filter == 'sent') {
	$sqlExtraClause = ' AND notification_id NOT IN (SELECT notification_id FROM notification_queue UNION SELECT
	notification_id FROM failed_notification)';
} else if ($status_filter == 'failed') {
	$sqlExtraClause = ' AND notification_id NOT IN (SELECT notification_id FROM notification_queue)
	 AND notification_id IN (SELECT notification_id FROM failed_notification)';
}
$con = Propel::getConnection();
$stmt = $con->createStatement();
$sql = "SELECT count(*) FROM notification
WHERE ref_id = $ref_id and section = '$section' " . $sqlExtraClause;

$rs = $stmt->executeQuery($sql, ResultSet::FETCHMODE_NUM);
$rs->next();
$total = $rs->getInt(1);

$columns = array (
	'send_date' => $Lang->getText('ProjectAdmin.MassEmail.SendDate'),
	'by' => $Lang->getText('ProjectAdmin.MassEmail.By'),
	'subject' => $Lang->getText('ProjectAdmin.MassEmail.Subject'),
	'body' => $Lang->getText('ProjectAdmin.MassEmail.Message'),
	'status' => $Lang->getText('ProjectAdmin.MassEmail.Status'),

);
$paginator = new Paginator('active_notif', -1, $total, 'notification_id',$columns);
$theaders = $paginator->getSortableTableHeaders($theme);
echo $theme->tableTop($theaders);


if ($total > 0) {
	$sql = "SELECT notification.*, \"user\".*,
	(SELECT count(*) FROM notification_queue WHERE notification_id = notification.notification_id)::integer  AS active_notifications,
	(SELECT COUNT(*) FROM failed_notification)::integer AS failed_notifications FROM notification
	LEFT JOIN \"user\" ON notification.user_id = \"user\".user_id
	WHERE ref_id = $ref_id and section = '$section'  " . $sqlExtraClause . ' '. $paginator->getSQL();

	$stmt = $con->createStatement();
	/** @var ResultSet $rs */
	$rs = $stmt->executeQuery($sql, ResultSet::FETCHMODE_ASSOC);
	while ($rs->next()) {
		$trow = array();
		$trow[] = $rs->getTimestamp('send_date');
		$user = UserPeer::retrieveByPk($rs->getInt('user_id'));
		if ($user) {
			$trow[] = $user->getName();
		} else {
			//Should never happen
			$trow[] = 'undefined';
		}
		$trow[] = '<a class="subjectLink" id="href_' . $rs->getInt('notification_id') .'" href="javascript:void(0)">' . $rs->getString('subject') .'</a>';
		$trow[] = StringUtils::HTMLFromPlainString(substr($rs->getString('body'),0,77) . " ...");
		$active_notifications = $rs->getInt('active_notifications');
		$failed_notifications = $rs->getInt('failed_notifications');
		if ($active_notifications > 0 ) {
			$trow[] = "Active, $active_notifications notifications left";
		} else if ($failed_notifications > 0) {
			$trow[] = "Sent, $failed_notifications notifications failed";
		} else {
			$trow[] = "Sent";
		}

		echo $theme->tableRow($trow);
	}

} else {
	echo $theme->tableFullRow($Lang->getText('ProjectAdmin.MassEmail.NoPendingNotifications'));
}

echo $theme->tableBottom();

if(isset($paginator) && is_object($paginator)) {
	echo '<div class="paginator">' . $paginator->getPaginator() . '</div><br />';
}
echo '</div>';
echo '</div>';

$template->footer($params);
