<?php

$session = Session::getSession();
/** @var Project $project */
$project = GFUrl::getUrl()->getProject();

try {
	if (!$project->userIsAdmin()) {
		throw new Exception('HTTP/1.1: 403 Forbidden');
	}

	if (!isset($_GET['notification_id'])) {
		throw new Exception('HTTP/1.1: 400 Bad Request');
	}
	$notification_id = Validator::sanitizeInt($_GET['notification_id']);



	$sql = "SELECT notification.notification_id as notification_id, notification.subject as subject, notification.body as body,notification.user_id as sender,
 	\"user\".unix_name as unix_name, \"user\".firstname as firstname, \"user\".lastname as lastname
	FROM notification LEFT JOIN sent_notification ON notification.notification_id = sent_notification.notification_id
	LEFT JOIN \"user\" ON \"user\".user_id = sent_notification.user_id
	WHERE notification.notification_id = $notification_id ";
	$con = Propel::getConnection();

	$stmt = $con->createStatement();
	/** @var ResultSet $rs */
	$rs = $stmt->executeQuery($sql, ResultSet::FETCHMODE_ASSOC);


	if (!$rs->getRecordCount()) {
		throw new Exception('HTTP/1.1 404 Not Found');
	}

	$rs->next();
	$notification_id = $rs->getInt('notification_id');
	$sender = UserPeer::retrieveByPk($rs->getInt('sender'));
	$from = htmlentities('<'.$sender->getUnixName() .'> ' . $sender->getFirstname() . ' ' . $sender->getLastName());
	$subject = htmlentities($rs->getString('subject'));
	$body = StringUtils::HTMLFromPlainString($rs->getString('body'));
	$to[] = '<strong>&lt' . $rs->getString('unix_name') .'&gt</strong> ' . htmlentities($rs->getString('firstname') . ' ' . $rs->getString('lastname'));

	//Get Attachments
	$attachments = '';
	$c = new Criteria();
	$c->add(FilesystemPeer::SECTION, Notification::SECTION);
	$c->add(FilesystemPeer::REF_ID, $notification_id);
	/** @var Filesystem[] $fs */
	$fs = FilesystemPeer::doSelect($c);
	foreach ($fs as $file) {
		$attachments[] = '<a href="' . GFUrl::getUrl()->downloadUrl(Notification::SECTION, $notification_id,$file->getFilesystemId(),$file->getFileNameSafe()) .'">' .
			$file->getFileName() .'</a>';
	}

	while ($rs->next()) {
		$to[] = '<strong>&lt' . $rs->getString('unix_name') .'&gt</strong> ' . htmlentities($rs->getString('firstname') . ' ' . $rs->getString('lastname'));
		//$to[] = htmlentities('<' . $rs->getString('unix_name') .'> ' . $rs->getString('firstname') . ' ' . $rs->getString('lastname'));
	}

	$return = array(
		'from' => $from,
		'to' => implode(', ', $to),
		'subject' => 'This is my test email',
		'body' => $body,
		'notification_id' => $notification_id,
		'attachments' => implode(', ',$attachments)
	);
	echo json_encode($return);
} catch (Exception $e) {
	header($e->getMessage());
}