<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id$
 * @author Federico Tarantini federico@gforgegroup.com
 * @date 2006-12-01
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

require_once('Validator.php');

$url = GFUrl::getUrl();
$project = $url->getProject();

if (!$project->userIsAdmin()) {
        throw new PermissionDeniedException();
}

// Set the parent project
if (isset($_GET['id']) && !empty($_GET['id'])) {
	$parent_project = ProjectPeer::retrieveByPk( Validator::sanitizeInt($_GET['id']) );
	if (is_object($parent_project)) {
		$project->setParentProject($parent_project);
		$project->save();
		$feedback = Language::getSessText('ProjectAdmin.ParentProjectSetOk');
	} else {
		$feedback = Language::getSessText('ProjectAdmin.ParentProjectSetNotOk');
	}

}

// Remove the parent project
if (isset($_GET['do']) && $_GET['do'] == 'remove') {
	$project->removeParentProject();
	$project->save();
	$feedback = Language::getSessText('ProjectAdmin.ParentProjectRemoved');
}

GFUrl::redirect($url->currentBaseUrl('', array('feedback' => $feedback)));
?>
