<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code edits a Project and saves it to the 
// database
//
require_once('core/Project.php');
require_once('Validator.php');
require_once('exceptions/PermissionDeniedException.php');
require_once('core/Language.php');

if ($_SERVER['REQUEST_METHOD'] != 'POST') {
	throw new PermissionDeniedException();
}

$Project = ProjectPeer::retrieveByPk($_POST['id']);
if (!is_object($Project) || !$Project->userCanUpdate()) {
	throw new PermissionDeniedException();
}

$Lang = Language::getSessLang();


$errors = array();

$Project->setHomepageUrl( Validator::sanitizeString($_POST['homepage_url']) );
$Project->setProjectName( Validator::sanitizeString($_POST['project_name']) );
//$Project->setRegisterLicenseOther( Validator::sanitizeString($_POST['register_license_other']) );
try { 
	$Project->save();
	$feedback = $Lang->getText('Project.EditFeedback');
	GFUrl::redirect(GFUrl::getUrl()->currentBaseURL('ProjectBrowse'), array('feedback' => $feedback));
} catch (InvalidDataException $ex) {
	$errors = array_merge($errors, $ex->getErrors());
	$feedback = '* '.implode('<br />* ', $errors);
	include('ProjectEdit.php');
}

?>