<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code lists ProjectJoinRequest
//
require_once('core/ProjectJoinRequestPeer.php');
require_once('core/ProjectJoinRequest.php');
require_once('lib/html/HTMLWidget.php');


$session = Session::getSession();
$Lang = $session->getLanguage();

require_once('html/templates/ProjectAdminTemplate.php');
$theme = new ProjectAdminTemplate();

$Project = GFUrl::getUrl()->getProject();

$params = array(
		'project' => $Project,
		'action' => isset($action) ? $action : '',
		'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : ''),
		'title' => $Lang->getText('ProjectJoinRequest.BrowsePageTitle')
		);
$theme->header($params);

// Retrieve the objects array
$crit = new Criteria();
$crit->add(ProjectJoinRequestPeer::PROJECT_ID, $Project->getProjectId());
$arr = ProjectJoinRequestPeer::doSelect($crit);


$theader = array();

$theader[] = $Lang->getText('ProjectJoinRequest.UserIdName');
$theader[] = $Lang->getText('ProjectJoinRequest.CommentsName');
$theader[] = $Lang->getText('ProjectJoinRequest.Action');

echo $theme->tableTop($theader);

if (count($arr) < 1) {
	echo $theme->tableFullRow('<span class="nonefound">'.$Lang->getText('ProjectJoinRequest.NoneFound').'</span>');
} else {
$c = new Criteria();
$c->add(RolePeer::PROJECT_ID,$Project->getProjectId());
$roles = RolePeer::doSelect($c);


	foreach ($arr as $item) {
		$trow = array();
		$trow[] = $item->getUser()->getUserLink();
		$trow[] = $item->getComments();
		$trow[] ='<form action="'.GFUrl::getUrl()->currentBaseURL('ProjectJoinRequestEditAction').'" method="POST">'. 
			HTMLWidget::multiselect('role_id[]',$roles,array(null),HTMLWidget::OPTION_NONE,false,null,false) . 
			'<input type="hidden" name="user_id" value="' . $item->getUser()->getUserId() . '" />' . 
			'&nbsp; '.HTMLWidget::button("submit","Accept","accept","","").' &nbsp;' . 
			HTMLWidget::button("submit","Reject","reject","","") .
			'</form>';
		echo $theme->tableRow($trow, array(), false);
	}
}

echo $theme->tableBottom(array());

$theme->footer($params);

?>
