<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This script updates the project-level setting for a burn-down chart
// to be shown on the Summary page for the project.
//
// error_log('SetBurndownAction enter: '.implode(',', $_POST));

require_once('core/SettingPeer.php');
require_once('exceptions/PermissionDeniedException.php');

$project = GFUrl::getUrl()->getProject();
// error_log("SBA, project is {$project->getProjectName()}");

if (!$project->userIsAdmin()) {
	// Only project admins can change member information
    // error_log("SBA, user is not an admin, permissions denied");
	throw new PermissionDeniedException();
}

$Lang = Language::getSessLang();

$bd_index = Validator::sanitizeInt($_REQUEST['bd_index']);
$query_id = Validator::sanitizeInt($_REQUEST['query_id']);
// error_log("SBA, setting burndown option for index $bd_index to $query_id");

if ($bd_index > 0 && $query_id > 0) {
    $setting_name = "burndown-{$bd_index}-query";
    $setting_value = "query_id={$query_id}";
    // error_log("SBA, SaveSetting $setting_name = $setting_value");
    SettingPeer::SaveSetting(Project::SECTION, $project->getProjectId(), $setting_name, $setting_value, $project->getProjectId());
}

$url = GFUrl::getURL()->projectURL($project);
// error_log("SBA, redirecting to $url");
GFUrl::redirect($url);
