<?php
require_once('core/TroveLink.php');
require_once('html/TroveRenderer.php');
require_once('html/HTMLWidget.php');

$Project = GFUrl::getUrl()->getProject();
$session = Session::getSession();
$Lang = $session->getLanguage();

require_once('html/templates/ProjectAdminTemplate.php');
$theme = new ProjectAdminTemplate();

$params = array(
		'project' => $Project,
		'feedback' => isset($feedback) ? $feedback : '',
		'selectedtoptab' => 'projects',
		'selectedbottomtab'	=> 'project_admin',
		'pagename'	=> $Lang->getText('Trove.AddNewPageName'),
		'title' => $Lang->getText('Trove.AddNewPageTitle')
		);


$theme->header($params);
?>
<p><h3><?php echo $Lang->getText('Project.TroveCategorization'); ?></h3></p>
<form method="post" action="<?php echo GFUrl::getUrl()->currentBaseUrl('TroveEditAction') ?>">
<?php
$troveRenderer = new TroveRenderer();
$troveRenderer->setSection(Project::SECTION);
$troveRenderer->setRefId($Project->getPrimaryKey());
echo $troveRenderer->renderChosenJavascript();
echo $troveRenderer->showTroveForm();
//echo $troveRenderer->renderTroveControl(TroveRenderer::TROVE_SPOKEN_LANGUAGE);
?>
<?php echo HTMLWidget::button("submit","" .   $Lang->getText('Common.Submit')  . " ","submit","","")?>
</form>

<?php
$theme->footer($params);
?>
