<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code shows a form for editing News
//
require_once('lib/core/WallPost.php');
require_once('lib/core/WallPostPeer.php');
require_once('lib/core/WallPostComment.php');
require_once('lib/core/WallPostCommentPeer.php');
require_once('exceptions/PermissionDeniedException.php');
require_once('lib/html/ProjectTemplate.php');

$session = Session::getSession();
$Lang = $session->getLanguage();

$user = $session->getUser();

if (!is_object($user)) {
  header("HTTP/1.0 401 Unauthorized");
  echo "You don't have permission to post comments.";
  exit;
}

$errors = array();

$theme = new ProjectTemplate();

$str_comment = isset($_REQUEST['comment']) ? Validator::sanitizeString($_REQUEST['comment']) : "";
$id = isset($_REQUEST['id']) ? Validator::sanitizeInt($_REQUEST['id']) : 0;

$comment = new WallPostComment();

$comment->setComment($str_comment);
$comment->setWallPostId($id);
$comment->setPostDate(time());
$comment->setPostedBy($user->getUserId());

if (!$comment->userCanCreate()) {
	echo "You don't have permission to post comments."; exit;
}

try {
	$comment->save();
} catch (InvalidDataException $ex) {
	$errors = array_merge($errors, $ex->getErrors());		
}

if (sizeof($errors) > 1) {
	echo implode(';',$errors);
} else {
	echo "OK";
}
?>
