<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id$
 * @author Julian Yerfino	jyerfino@gforgegroup.com	
 * @date 2008-01-04
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

require_once('lib/html/HTMLWidget.php');
require_once('html/templates/ProjectReportingTemplate.php');
require_once('lib/core/DiskUsage.php');
require_once('lib/core/DiskUsagePeer.php');

$session = Session::getSession();
$Project = GFUrl::getUrl()->getProject();
$project_id = $Project->getProjectId();
$Lang = $session->getLanguage();

$theme = new ProjectReportingTemplate();

$begin=((isset($_REQUEST['start_date']) && strlen($_REQUEST['start_date']) > 5) ? $_REQUEST['start_date'] : 0 );
$end=((isset($_REQUEST['end_date']) && strlen($_REQUEST['end_date']) > 5) ? $_REQUEST['end_date'] : 0 );

if ($begin=='0') {
	$begin = (time()-(30*86400));
} else {
	$begin = strtotime($begin);
}
if ($end=='0') {
	$end = time();
} else {
	$end = strtotime($end)+86399;
}
if ($begin > $end) {
	$endtmp=$end;
	$end=$begin;
	$begin=$endtmp;
}

$params = array(
		'project' => $Project,
		'feedback' => (isset($feedback) ? $feedback : ''),
		'title' => $Lang->getText('ScmDiskUsageReport.Title')
	);
$theme->header($params);

$subprojects=((isset($_REQUEST['subprojects'])) ? Validator::sanitizeInt($_REQUEST['subprojects']) : 0 );

?>

<script language="javascript" type="text/javascript" src="/datetimepicker.js">
</script>
<form action="<?php echo $_SERVER['REQUEST_URI']; ?>" method="post">
<table border="0" cellspacing="0" cellpadding="3" bgcolor="#E0E0E0">
<tr>
	<td><input id="startdate" name="start_date" value="<?php echo date('M d Y',$begin); ?>" size="11" maxlength="11" /><a href="javascript:NewCal('startdate','MMMddyyyy')"><img src="/themes/gforge5/images/cal.gif" width="16" height="16" border="0" alt="Pick a date"/></a></td>
	<td><input id="enddate" name="end_date" value="<?php echo date('M d Y',$end); ?>" size="11" maxlength="11" /><a href="javascript:NewCal('enddate','MMMddyyyy')"><img src="/themes/gforge5/images/cal.gif" width="16" height="16" border="0" alt="Pick a date"/></a></td>
</tr>
<tr>
	<td><input type="checkbox" name="subprojects" value="1"<?php echo ($subprojects == 1) ? ' checked' : '';?>/><strong><?php echo $Lang->getText('ProjectReporting.IncludeSubprojects') ?></strong></td>
	<td align='right' valign="middle" rowspan="2"><?php echo HTMLWidget::button("submit","" .   $Lang->getText('Common.Submit')  . " ","submit","","")?></td>
</tr>
</table>
</form>
<?php
$imgquerystring = '&start_date='.date('Y-m-d', $begin);
$imgquerystring .= '&end_date='.date('Y-m-d', $end);
$imgquerystring .= '&subprojects='.$subprojects;

echo '<img src="/gf/project/'.$Project->getUnixName().'/graphs/?action=DiskUsage'.$imgquerystring.'" height="250" width="400" alt="" />';

echo '<br />';
echo '<br />';

?>
