<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id$
 * @author Ruben Gutierrez ruben@gforgegroup.org
 * @date 2006-02-27
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

require_once('core/ProjectPeer.php');
require_once('session/Session.php');
require_once('core/Plugin.php');
require_once('plugin/GFPlugin.php');
require_once('core/RolePeer.php');
require_once('core/UserProject.php');
require_once('html/HTMLWidget.php');

$session = Session::getSession();
$project = GFUrl::getUrl()->getProject();
$project_id = $project->getProjectId();
$Language = $session->getLanguage();

if (!isset($feedback)) {
	$feedback = '';
}

require_once('html/templates/ProjectReportingTemplate.php');
$template = new ProjectReportingTemplate();
$params = array(
		'project' => $project,
		'feedback' => $feedback,
		'title' => Language::getSessText('ProjectReporting.Stats')
	);
$template->header($params);
$year=((isset($_REQUEST['year'])) ? $_REQUEST['year'] : 0 );
$month=((isset($_REQUEST['month'])) ? $_REQUEST['month'] : 0 );
$subprojects=((isset($_REQUEST['subprojects'])) ? Validator::sanitizeInt($_REQUEST['subprojects']) : 0 );

list($cyear, $cmonth) = explode('-', date('Y-m'));

if ($year=='0') {
	$year = $cyear;
} else {
	$year = intval($year);
}

if ($month=='0') {
	$month = $cmonth;
} else {
	$month = intval($month);
}


$years = array();
for ($i=2000;$i<($cyear+1);$i++) {
	$years[$i] = $i;
}

$months = array();
for ($i=1;$i<13;$i++) {
	$months[$i] = $Language->getText('Common.Months.'.$i);
}

$requeststring = '&amp;year='.$year.'&amp;month='.$month.'&amp;project_id='.$project_id.'&amp;subprojects='.$subprojects;
?>
<br />
<form action="<?php echo $_SERVER['REQUEST_URI']; ?>" method="post">
<table border="0" cellspacing="0" cellpadding="3" bgcolor="#E0E0E0">
<tr>
	<td><strong><?php echo $Language->getText('Common.Year') ?></strong></td>
	<td><strong><?php echo $Language->getText('Common.Month') ?></strong></td>
	<td></td>
</tr>
<tr>
	<td><?php echo HTMLWidget::selectBoxFromAssoc($years, 'year', $year, false, false) ?></td>
	<td><?php echo HTMLWidget::selectBoxFromAssoc($months, 'month', $month, false, false) ?></td>
	<td valign="top"><?php echo HTMLWidget::button("submit", $Language->getText('Common.Submit'), "submit"); ?></td>
</tr>
<tr>
	<td colspan="3">
		<strong><?php echo $Language->getText('ProjectReporting.IncludeSubprojects') ?></strong> 
		<input type="checkbox" name="subprojects" value="1"<?php echo ($subprojects == 1) ? ' checked' : '';?>/>
	</td>
</tr>
</table>
</form>
<br />
<img src="/gf/stats/?action=PageViewsGraph<?php echo $requeststring ?>" width="400" height="250" alt="" />
<?php
$template->footer();
?>
