<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version $Id$
 * @author Daniel A. Prez	daniel@gforgegroup.com
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */


require_once('wwwlib/search/commonsearch.php');
require_once('html/SiteTemplate.php');
require_once('plugins/projectrating/lib/html/RatingWidget.php');

$template = new SiteTemplate();
if (array_key_exists('type',$_REQUEST)) {
	switch ($_REQUEST['type']) {
		case 'user' : {
			$tab = 'user';
			break;
		}
		case 'project' : {
			$tab = 'project';
		}
	}
} else {
	$tab = 'home';
}
$params = array(
	'selectedtoptab'	=> $tab,
	'title'=>'Search',
	'extra_head' => RatingWidget::getExtraHeaders(),
	);

$val = $_REQUEST['search'];
$vals = explode('_',$val);

$params['words'] = Validator::sanitizeString(($_REQUEST['words']), false);
$params['section'] = Validator::sanitizeString($vals[0], false);
$params['ref_id'] = Validator::sanitizeInt($vals[1]);
$params['template'] = $template;
if (array_key_exists('project_id',$_REQUEST)) {
	$params['project_id'] = Validator::sanitizeInt($_REQUEST['project_id']);
}
	
	
$template->header($params);

switch ($vals[0]) {
	case 'project' : {
		require_once('wwwlib/project/forms/ProjectSearch-tpl.php');
		break;
	}
	case 'user' : {
		require_once('wwwlib/user/forms/UserSearch-tpl.php');
		break;		
	}
					
}

echo getSearchResults($params);



?>


<?php

$template->footer();
?>
