<?php
require_once('core/TagEntryPeer.php');
require_once('core/TagEntry.php');
require_once('lib/html/ProjectTemplate.php');
require_once('plugins/userblog/lib/UserBlog.php');
require_once('Validator.php');


$Lang = Language::getSessLang();

if(isset($_GET['ref_id']) && isset($_GET['ref_id']) && isset($_GET['tagname']) && isset($_GET['return_to'])){
	$ref_id = Validator::sanitizeInt($_GET['ref_id']);
	$section = Validator::sanitizeString($_GET['section']);
	$return_to = $_GET['return_to'];

	$return_to = preg_replace("/&feedback=.*$/", "", $return_to);
	$tagname = Validator::sanitizeString($_GET['tagname']);
} else {
	throw new InvalidDataException(array('Invalid section or ref_id'));
}

if(!TagEntryPeer::userCanUpdate($section,$ref_id)){
	throw new PermissionDeniedException();
}
$tag = TagEntryPeer::findTag($section, $ref_id, $tagname);

if(is_null($tag) || !is_object($tag)){
	throw new InvalidDataException(array('Invalid Tag'));
} else {
	$tag->delete();
}

if ($section == Pastebin::SECTION) {
	header( 'Location: ' . $return_to ) ;
} else {
	GFUrl::redirect($return_to, array('id'=>$ref_id,'feedback' => $Lang->getText('Tag.DeleteFeedback')));
}

?>
